Ext.define('mpm.BpcInterface', {extend:'BpcCommon.BpcInterface', config:{moduleConfigurationComponents:['mpmConfigMain'], requiredModules:['flextable', 'documents'], widgets:[]}});
Ext.define('mpm.Module', {singleton:true, dictionary:function(colCfg) {
  colCfg = colCfg === void 0 ? {} : colCfg;
  var translation = undefined;
  var $jscomp$destructuring$var0 = colCfg;
  var dictionary = $jscomp$destructuring$var0.dictionary;
  if (dictionary) {
    var $jscomp$destructuring$var1 = dictionary || {};
    var dictionaryId = $jscomp$destructuring$var1.dictionaryId;
    var dic = mpm.Support.getDictionary(dictionaryId);
    if (dic.length) {
      translation = dic;
    }
  }
  return function(v, m, r) {
    var item = (translation || []).filter(function(i) {
      return i.key === v;
    });
    return item.length ? item[0].value : v;
  };
}, wimRenderer:function(column) {
  var map = column.wimLabels || {};
  return function(v, meta, r) {
    var icon = mpm.packages.wim.WIMStatusColumn.statusIconHtml(v);
    var text = map[String(v).toLowerCase()] || v;
    if (meta && !(r && !('STATUS' in r.data))) {
      return '\x3cspan data-qtip\x3d"' + Ext.String.htmlEncode(Ext.String.htmlEncode(text)) + '"\x3e' + icon + '\x3c/span\x3e';
    } else {
      return icon + ' ' + Ext.String.htmlEncode(text);
    }
  };
}, newRequest:function(url, params, data, method, timeout, type) {
  params = params === void 0 ? {} : params;
  data = data === void 0 ? null : data;
  method = method === void 0 ? 'GET' : method;
  timeout = timeout === void 0 ? 30000 : timeout;
  type = type === void 0 ? 'application/json' : type;
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request({url:url, params:params, timeout:timeout, method:method, jsonData:data, headers:{'Content-Type':'application/json'}, success:function(response) {
      resolve(response.responseText ? Ext.decode(response.responseText, true) : {});
    }, failure:function(response) {
      reject(response);
    }});
  });
}});
Ext.define('mpm.StaticData', {singleton:true, transaktionsgrund:[{'key':'E01', 'value':'E01 - Einzug/Auszug (Umzug)'}, {'key':'E02', 'value':'E02 - Einzug/Neuanlage'}, {'key':'E03', 'value':'E03 - Wechsel'}, {'key':'ZD2', 'value':'ZD2 - Lieferbeginn und Abmeldung aus der Ersatzversorgung'}], period:[{'key':'1', 'value':'1 Monat'}, {'key':'3', 'value':'3 Monate'}, {'key':'6', 'value':'6 Monate'}, {'key':'12', 'value':'12 Monate'}], netznutzungsvertrag:[{'key':'Z08', 'value':'Z08 - Direkter Vertrag zwischen Kunden und VNB'}, 
{'key':'Z09', 'value':'Z09 - Vertrag zwischen Lieferanten und VNB'}], zahlernetznutzung:[{'key':'Z10', 'value':'Z10 - Kunde'}, {'key':'Z11', 'value':'Z11 - Lieferant'}], gruppenzuordnung:[{'key':'Z15', 'value':'Z15 - Haushaltskunde gem. EnWG'}, {'key':'Z18', 'value':'Z18 - Kein Haushaltskunde gem. EnWG'}], netznutzungsabrechnungsvariante:[{'key':'Z14', 'value':'Z14 - Arbeitspreis/Grundpreis'}, {'key':'Z15', 'value':'Z15 - Arbeitspreis/Leistungspreis'}], netznutzungsabrechnungsgrundlage:[{'key':'Z12', 
'value':'Z12 - Lieferschein'}, {'key':'Z13', 'value':'Z13 - Abweichend vertraglich mit Anschlussnutzer vereinbarte Grundlage'}], prognosegrundlage:[{'key':'ZC0', 'value':'ZC0 - Prognose auf Basis von Werten'}, {'key':'ZA6', 'value':'ZA6 - Prognose auf Basis von Profilen'}], zaehlverfahren:[{'key':'E02', 'value':'E02 - SLP/SEP'}, {'key':'E14', 'value':'E14 - TLP/TEP'}], lastprofilzuordnung:[{'key':'E01', 'value':'E01 - synthetisches Verfahren'}, {'key':'Z10', 'value':'Z10 - analytisches Verfahren'}], 
lastprofilauswahl:[{'key':'Z02', 'value':'Z02 - Standardlastprofil'}, {'key':'Z03', 'value':'Z03 - tagesparameterabhängiges Lastprofil'}, {'key':'Z12', 'value':'Z12 - Lastprofil'}], kundengruppenzuordnung:[{'key':'Z15', 'value':'Z15 - Haushaltskunde gem. EnWG'}, {'key':'Z18', 'value':'Z18 - Kein Haushaltskunde gem. EnWG'}], gasqualitaet:[{'key':'Y04', 'value':'Y04 - H-Gas'}, {'key':'Y05', 'value':'Y05 - L-Gas'}], tagesparameter:[{'key':'265', 'value':'265 - Veranschlagte Jahresmenge Gesamt / Jahresverbrauchsprognose für spezifische Arbeit für tagesparameterabhängige Lieferstelle'}, 
{'key':'Z08', 'value':'Z08 - Angepasste elektrische Arbeit nach Anhang D der VDN-Richtlinie "Lastprofile für unterbrechbare Verbrauchseinrichtungen""'}], druckebene:[{'key':'Y01', 'value':'Y01 - Hochdruck'}, {'key':'Y02', 'value':'Y02 - Mitteldruck'}, {'key':'Y03', 'value':'Y03 - Niederdruck'}], fallgruppenzuordnung:[{'key':'GABi-RLMNEV', 'value':'GABi-RLMNEV - Normierungsersatzverfahren - Exit (nur für GABi)'}, {'key':'GABi-RLMmT', 'value':'GABi-RLMmT - RLM-Kunde in Tagesregime - Exit (nur für GABi)'}, 
{'key':'GABi-RLMoT', 'value':'GABi-RLMoT - RLM-Kunde im Stundenregime - Exit (nur für GABi)'}], profilcode:[{'key':'G0', 'value':'G0 - Gewerbe allgemein'}, {'key':'G1', 'value':'G1 - Gewerbe werktags 8-18 Uhr'}, {'key':'G2', 'value':'G2 - Gewerbe mit starkem bis überwiegendem Verbrauch in den Abendstunden'}, {'key':'G3', 'value':'G3 - Gewerbe durchlaufend'}, {'key':'G4', 'value':'G4 - Laden/Friseur'}, {'key':'G5', 'value':'G5 - Bäckerei mit Backstube'}, {'key':'G6', 'value':'G6 - Wochenendbetrieb'}, 
{'key':'G7', 'value':'G7 - Mobilfunksendestation'}, {'key':'H0', 'value':'H0 - Haushalt'}, {'key':'L0', 'value':'L0 - Landwirtschaftsbetriebe allgemein'}, {'key':'L1', 'value':'L1 - Landwirtschaftsbetriebe mit Milchwirtschaft/Nebenerwerbs-Tierzucht'}, {'key':'L2', 'value':'L2 - Übrige Landwirtschaftsbetriebe'}, {'key':'HK3', 'value':'HK3 - Kochgaslastprofil'}, {'key':'D13', 'value':'D13 - Einfamilienhaushalt o - Deutschland, bundesweit'}, {'key':'D14', 'value':'D14 - Einfamilienhaushalt + - Deutschland, bundesweit'}, 
{'key':'D23', 'value':'D23 - Mehrfamilienhaushalt o - Deutschland, bundesweit'}, {'key':'D24', 'value':'D24 - Mehrfamilienhaushalt + - Deutschland, bundesweit'}, {'key':'M13', 'value':'M13 - Einfamilienhaushalt o - Bremen'}, {'key':'M14', 'value':'M14 - Einfamilienhaushalt + - Bremen'}, {'key':'M23', 'value':'M23 - Mehrfamilienhaushalt o - Bremen'}, {'key':'M24', 'value':'M24 - Mehrfamilienhaushalt + - Bremen'}, {'key':'H13', 'value':'H13 - Einfamilienhaushalt o - Hamburg'}, {'key':'A13', 'value':'A13 - Einfamilienhaushalt o - Saaland'}, 
{'key':'H14', 'value':'H14 - Einfamilienhaushalt + - Hamburg'}, {'key':'A14', 'value':'A14 - Einfamilienhaushalt + - Saaland'}, {'key':'H23', 'value':'H23 - Mehrfamilienhaushalt o - Hamburg'}, {'key':'A23', 'value':'A23 - Mehrfamilienhaushalt o - Saaland'}, {'key':'H24', 'value':'H24 - Mehrfamilienhaushalt + - Hamburg'}, {'key':'A24', 'value':'A24 - Mehrfamilienhaushalt + - Saaland'}, {'key':'B13', 'value':'B13 - Einfamilienhaushalt o - Berlin'}, {'key':'F13', 'value':'F13 - Einfamilienhaushalt o - Hessen'}, 
{'key':'I13', 'value':'I13 - Einfamilienhaushalt o - Niedersachsen'}, {'key':'N13', 'value':'N13 - Einfamilienhaushalt o - Nordrhein-Westfalen'}, {'key':'B14', 'value':'B14 - Einfamilienhaushalt + - Berlin'}, {'key':'F14', 'value':'F14 - Einfamilienhaushalt + - Hessen'}, {'key':'I14', 'value':'I14 - Einfamilienhaushalt + - Niedersachsen'}, {'key':'N14', 'value':'N14 - Einfamilienhaushalt + - Nordrhein-Westfalen'}, {'key':'B23', 'value':'B23 - Mehrfamilienhaushalt o - Berlin'}, {'key':'F23', 'value':'F23 - Mehrfamilienhaushalt o - Hessen'}, 
{'key':'I23', 'value':'I23 - Mehrfamilienhaushalt o - Niedersachsen'}, {'key':'N23', 'value':'N23 - Mehrfamilienhaushalt o - Nordrhein-Westfalen'}, {'key':'B24', 'value':'B24 - Mehrfamilienhaushalt + - Berlin'}, {'key':'F24', 'value':'F24 - Mehrfamilienhaushalt + - Hessen'}, {'key':'I24', 'value':'I24 - Mehrfamilienhaushalt + - Niedersachsen'}, {'key':'N24', 'value':'N24 - Mehrfamilienhaushalt + - Nordrhein-Westfalen'}, {'key':'W13', 'value':'W13 - Einfamilienhaushalt o - Baden-Württemberg'}, {'key':'P13', 
'value':'P13 - Einfamilienhaushalt o - Rheinland-Pfalz'}, {'key':'L13', 'value':'L13 - Einfamilienhaushalt o - Schleswig-Holstein'}, {'key':'S13', 'value':'S13 - Einfamilienhaushalt o - Sachsen'}, {'key':'W14', 'value':'W14 - Einfamilienhaushalt + - Baden-Württemberg'}, {'key':'P14', 'value':'P14 - Einfamilienhaushalt + - Rheinland-Pfalz'}, {'key':'L14', 'value':'L14 - Einfamilienhaushalt + - Schleswig-Holstein'}, {'key':'S14', 'value':'S14 - Einfamilienhaushalt + - Sachsen'}, {'key':'W23', 'value':'W23 - Mehrfamilienhaushalt o - Baden-Württemberg'}, 
{'key':'P23', 'value':'P23 - Mehrfamilienhaushalt o - Rheinland-Pfalz'}, {'key':'L23', 'value':'L23 - Mehrfamilienhaushalt o - Schleswig-Holstein'}, {'key':'S23', 'value':'S23 - Mehrfamilienhaushalt o - Sachsen'}, {'key':'W24', 'value':'W24 - Mehrfamilienhaushalt + - Baden-Württemberg'}, {'key':'P24', 'value':'P24 - Mehrfamilienhaushalt + - Rheinland-Pfalz'}, {'key':'L24', 'value':'L24 - Mehrfamilienhaushalt + - Schleswig-Holstein'}, {'key':'S24', 'value':'S24 - Mehrfamilienhaushalt + - Sachsen'}, 
{'key':'R13', 'value':'R13 - Einfamilienhaushalt o - Brandenburg'}, {'key':'G13', 'value':'G13 - Einfamilienhaushalt o - Bayern'}, {'key':'V13', 'value':'V13 - Einfamilienhaushalt o - Mecklenburg-Vorpommern'}, {'key':'C13', 'value':'C13 - Einfamilienhaushalt o - Sachsen-Anhalt'}, {'key':'T13', 'value':'T13 - Einfamilienhaushalt o - Thüringen'}, {'key':'R14', 'value':'R14 - Einfamilienhaushalt + - Brandenburg'}, {'key':'G14', 'value':'G14 - Einfamilienhaushalt + - Bayern'}, {'key':'V14', 'value':'V14 - Einfamilienhaushalt + - Mecklenburg-Vorpommern'}, 
{'key':'C14', 'value':'C14 - Einfamilienhaushalt + - Sachsen-Anhalt'}, {'key':'T14', 'value':'T14 - Einfamilienhaushalt + - Thüringen'}, {'key':'R23', 'value':'R23 - Mehrfamilienhaushalt o - Brandenburg'}, {'key':'G23', 'value':'G23 - Mehrfamilienhaushalt o - Bayern'}, {'key':'V23', 'value':'V23 - Mehrfamilienhaushalt o - Mecklenburg-Vorpommern'}, {'key':'C23', 'value':'C23 - Mehrfamilienhaushalt o - Sachsen-Anhalt'}, {'key':'T23', 'value':'T23 - Mehrfamilienhaushalt o - Thüringen'}, {'key':'R24', 
'value':'R24 - Mehrfamilienhaushalt + - Brandenburg'}, {'key':'G24', 'value':'G24 - Mehrfamilienhaushalt + - Bayern'}, {'key':'V24', 'value':'V24 - Mehrfamilienhaushalt + - Mecklenburg-Vorpommern'}, {'key':'C24', 'value':'C24 - Mehrfamilienhaushalt + - Sachsen-Anhalt'}, {'key':'T24', 'value':'T24 - Mehrfamilienhaushalt + - Thüringen'}, {'key':'KO1', 'value':'KO1 - Gebietskörpersch.,Org. o. Erwerbszw. \x26 öff.Einr. --'}, {'key':'KO2', 'value':'KO2 - Gebietskörpersch.,Org. o. Erwerbszw. \x26 öff.Einr. -'}, 
{'key':'KO3', 'value':'KO3 - Gebietskörpersch.,Org. o. Erwerbszw. \x26 öff.Einr. o'}, {'key':'KO4', 'value':'KO4 - Gebietskörpersch.,Org. o. Erwerbszw. \x26 öff.Einr. +'}, {'key':'KO5', 'value':'KO5 - Gebietskörpersch.,Org. o. Erwerbszw. \x26 öff.Einr. ++'}, {'key':'HA1', 'value':'HA1 - Einzelhandel, Großhandel --'}, {'key':'HA2', 'value':'HA2 - Einzelhandel, Großhandel - '}, {'key':'HA3', 'value':'HA3 - Einzelhandel, Großhandel o'}, {'key':'HA4', 'value':'HA4 - Einzelhandel, Großhandel +'}, {'key':'HA5', 
'value':'HA5 - Einzelhandel, Großhandel ++'}, {'key':'MK1', 'value':'MK1 - Metall, KFZ --'}, {'key':'MK2', 'value':'MK2 - Metall, KFZ -'}, {'key':'MK3', 'value':'MK3 - Metall, KFZ o'}, {'key':'MK4', 'value':'MK4 - Metall, KFZ +'}, {'key':'MK5', 'value':'MK5 - Metall, KFZ ++'}, {'key':'BD1', 'value':'BD1 - sonst.betr. Dienstleistungen --'}, {'key':'BD2', 'value':'BD2 - sonst.betr. Dienstleistungen -'}, {'key':'BD3', 'value':'BD3 - sonst.betr. Dienstleistungen o'}, {'key':'BD4', 'value':'BD4 - sonst.betr. Dienstleistungen +'}, 
{'key':'BD5', 'value':'BD5 - sonst.betr. Dienstleistungen ++'}, {'key':'GA1', 'value':'GA1 - Gaststätten --'}, {'key':'GA2', 'value':'GA2 - Gaststätten -'}, {'key':'GA3', 'value':'GA3 - Gaststätten +'}, {'key':'GA4', 'value':'GA4 - Gaststätten +'}, {'key':'GA5', 'value':'GA5 - Gaststätten ++'}, {'key':'BH1', 'value':'BH1 - Beherbung --'}, {'key':'BH2', 'value':'BH2 - Beherbung -'}, {'key':'BH3', 'value':'BH3 - Beherbung o'}, {'key':'BH4', 'value':'BH4 - Beherbung +'}, {'key':'BH5', 'value':'BH5 - Beherbung ++'}, 
{'key':'BA1', 'value':'BA1 - Bäckereien --'}, {'key':'BA2', 'value':'BA2 - Bäckereien -'}, {'key':'BA3', 'value':'BA3 - Bäckereien o'}, {'key':'BA4', 'value':'BA4 - Bäckereien +'}, {'key':'BA5', 'value':'BA5 - Bäckereien ++'}, {'key':'WA1', 'value':'WA1 - Wäschereien --'}, {'key':'WA2', 'value':'WA2 - Wäschereien -'}, {'key':'WA3', 'value':'WA3 - Wäschereien o'}, {'key':'WA4', 'value':'WA4 - Wäschereien +'}, {'key':'WA5', 'value':'WA5 - Wäschereien ++'}, {'key':'GB1', 'value':'GB1 - Gartenbau --'}, 
{'key':'GB2', 'value':'GB2 - Gartenbau -'}, {'key':'GB3', 'value':'GB3 - Gartenbau o'}, {'key':'GB4', 'value':'GB4 - Gartenbau +'}, {'key':'GB5', 'value':'GB5 - Gartenbau ++'}, {'key':'PD1', 'value':'PD1 - Papier und Druck --'}, {'key':'PD2', 'value':'PD2 - Papier und Druck -'}, {'key':'PD3', 'value':'PD3 - Papier und Druck o'}, {'key':'PD4', 'value':'PD4 - Papier und Druck +'}, {'key':'PD5', 'value':'PD5 - Papier und Druck ++'}, {'key':'MF1', 'value':'MF1 - haushaltsähnliche Gewerbebetriebe --'}, 
{'key':'MF2', 'value':'MF2 - haushaltsähnliche Gewerbebetriebe -'}, {'key':'MF3', 'value':'MF3 - haushaltsähnliche Gewerbebetriebe o'}, {'key':'MF4', 'value':'MF4 - haushaltsähnliche Gewerbebetriebe +'}, {'key':'MF5', 'value':'MF5 - haushaltsähnliche Gewerbebetriebe ++'}, {'key':'HD3', 'value':'HD3 - Summenlastprofil Gewerbe,Handel, Dienstleistung o'}, {'key':'HD4', 'value':'HD4 - Summenlastprofil Gewerbe,Handel, Dienstleistung +'}], status:[{'key':'220', 'value':'Abgelesener Wert (wahrer Wert, abrechnungsrelevant)'}, 
{'key':'67', 'value':'Ersatzwert - geschätzt, veranschlagt (abrechnungsrelevant)'}], colors:{'aliceblue':'#f0f8ff', 'antiquewhite':'#faebd7', 'aqua':'#00ffff', 'aquamarine':'#7fffd4', 'azure':'#f0ffff', 'beige':'#f5f5dc', 'bisque':'#ffe4c4', 'black':'#000000', 'blanchedalmond':'#ffebcd', 'blue':'#0000ff', 'blueviolet':'#8a2be2', 'brown':'#a52a2a', 'burlywood':'#deb887', 'cadetblue':'#5f9ea0', 'chartreuse':'#7fff00', 'chocolate':'#d2691e', 'coral':'#ff7f50', 'cornflowerblue':'#6495ed', 'cornsilk':'#fff8dc', 
'crimson':'#dc143c', 'cyan':'#00ffff', 'darkblue':'#00008b', 'darkcyan':'#008b8b', 'darkgoldenrod':'#b8860b', 'darkgray':'#a9a9a9', 'darkgreen':'#006400', 'darkkhaki':'#bdb76b', 'darkmagenta':'#8b008b', 'darkolivegreen':'#556b2f', 'darkorange':'#ff8c00', 'darkorchid':'#9932cc', 'darkred':'#8b0000', 'darksalmon':'#e9967a', 'darkseagreen':'#8fbc8f', 'darkslateblue':'#483d8b', 'darkslategray':'#2f4f4f', 'darkturquoise':'#00ced1', 'darkviolet':'#9400d3', 'deeppink':'#ff1493', 'deepskyblue':'#00bfff', 
'dimgray':'#696969', 'dodgerblue':'#1e90ff', 'firebrick':'#b22222', 'floralwhite':'#fffaf0', 'forestgreen':'#228b22', 'fuchsia':'#ff00ff', 'gainsboro':'#dcdcdc', 'ghostwhite':'#f8f8ff', 'gold':'#ffd700', 'goldenrod':'#daa520', 'gray':'#808080', 'green':'#008000', 'greenyellow':'#adff2f', 'honeydew':'#f0fff0', 'hotpink':'#ff69b4', 'indianred ':'#cd5c5c', 'indigo':'#4b0082', 'ivory':'#fffff0', 'khaki':'#f0e68c', 'lavender':'#e6e6fa', 'lavenderblush':'#fff0f5', 'lawngreen':'#7cfc00', 'lemonchiffon':'#fffacd', 
'lightblue':'#add8e6', 'lightcoral':'#f08080', 'lightcyan':'#e0ffff', 'lightgoldenrodyellow':'#fafad2', 'lightgrey':'#d3d3d3', 'lightgreen':'#90ee90', 'lightpink':'#ffb6c1', 'lightsalmon':'#ffa07a', 'lightseagreen':'#20b2aa', 'lightskyblue':'#87cefa', 'lightslategray':'#778899', 'lightsteelblue':'#b0c4de', 'lightyellow':'#ffffe0', 'lime':'#00ff00', 'limegreen':'#32cd32', 'linen':'#faf0e6', 'magenta':'#ff00ff', 'maroon':'#800000', 'mediumaquamarine':'#66cdaa', 'mediumblue':'#0000cd', 'mediumorchid':'#ba55d3', 
'mediumpurple':'#9370d8', 'mediumseagreen':'#3cb371', 'mediumslateblue':'#7b68ee', 'mediumspringgreen':'#00fa9a', 'mediumturquoise':'#48d1cc', 'mediumvioletred':'#c71585', 'midnightblue':'#191970', 'mintcream':'#f5fffa', 'mistyrose':'#ffe4e1', 'moccasin':'#ffe4b5', 'navajowhite':'#ffdead', 'navy':'#000080', 'oldlace':'#fdf5e6', 'olive':'#808000', 'olivedrab':'#6b8e23', 'orange':'#ffa500', 'orangered':'#ff4500', 'orchid':'#da70d6', 'palegoldenrod':'#eee8aa', 'palegreen':'#98fb98', 'paleturquoise':'#afeeee', 
'palevioletred':'#d87093', 'papayawhip':'#ffefd5', 'peachpuff':'#ffdab9', 'peru':'#cd853f', 'pink':'#ffc0cb', 'plum':'#dda0dd', 'powderblue':'#b0e0e6', 'purple':'#800080', 'rebeccapurple':'#663399', 'red':'#ff0000', 'rosybrown':'#bc8f8f', 'royalblue':'#4169e1', 'saddlebrown':'#8b4513', 'salmon':'#fa8072', 'sandybrown':'#f4a460', 'seagreen':'#2e8b57', 'seashell':'#fff5ee', 'sienna':'#a0522d', 'silver':'#c0c0c0', 'skyblue':'#87ceeb', 'slateblue':'#6a5acd', 'slategray':'#708090', 'snow':'#fffafa', 'springgreen':'#00ff7f', 
'steelblue':'#4682b4', 'tan':'#d2b48c', 'teal':'#008080', 'thistle':'#d8bfd8', 'tomato':'#ff6347', 'turquoise':'#40e0d0', 'violet':'#ee82ee', 'wheat':'#f5deb3', 'white':'#ffffff', 'whitesmoke':'#f5f5f5', 'yellow':'#ffff00', 'yellowgreen':'#9acd32'}, meldepunkttyp:[{'key':'malo', 'value':'MaLo - Marktlokation'}, {'key':'melo', 'value':'MeLo - Messlokation'}], einheit:[{'key':'Z16', 'value':'Z16 - kWh/K (Kilowatt-Stunde / Kelvin)'}, {'key':'KWH', 'value':'KWH - Kilowattstunde'}], entnahmespannung:[{'key':'E03', 
'value':'E03 - Höchstspannung'}, {'key':'E04', 'value':'E04 - Hochspannung'}, {'key':'E05', 'value':'E05 - Mittelspannung'}, {'key':'E06', 'value':'E06 - Niederspannung'}, {'key':'E07', 'value':'E07 - Hös/HS Umspannung'}, {'key':'E08', 'value':'E08 - HS/MS Umspannung'}, {'key':'E09', 'value':'E09 - MS/NS Umspannung'}], spannungsbemessung:[{'key':'E03', 'value':'E03 - Höchstspannung'}, {'key':'E04', 'value':'E04 - Hochspannung'}, {'key':'E05', 'value':'E05 - Mittelspannung'}, {'key':'E06', 'value':'E06 - Niederspannung'}], 
messtechnischeeinordnung:[{'key':'Z52', 'value':'Z52 - iMS'}, {'key':'Z53', 'value':'Z53 - kME/mME'}, {'key':'Z68', 'value':'Z68 - keine Messung'}], wahlrecht:[{'key':'Z54', 'value':'Z54 - Wahlrecht durch LF gegeben'}, {'key':'Z55', 'value':'Z55 - Wahlrecht durch LF nicht gegeben'}], messwertuebermittlungsfallmalo:[{'key':'Z59', 'value':'Z59 - Konfiguration für MÜ-A'}, {'key':'Z40', 'value':'Z40 - Konfiguration für MÜ-B'}, {'key':'Z41', 'value':'Z41 - Konfiguration für MÜ-C'}, {'key':'Z42', 'value':'Z42 - Konfiguration für MÜ-D'}, 
{'key':'Z43', 'value':'Z43 - Konfiguration für MÜ-E'}], SENDERSTNUMQUALIFIERCODE:[{'key':'FC', 'value':'Steuernummer'}, {'key':'VA', 'value':'UStId.Nummer'}]});
Ext.define('mpm.util.TR', {singleton:true, getDefaultTranslations:function() {
  return BpcCommon && BpcCommon.lang && BpcCommon.lang.Current ? BpcCommon.lang.Current : {};
}, getModuleLanguageKeys:function() {
  var languageStartKey = (mpm.Support.getModuleNameFromClassName() || '').toUpperCase() + '_';
  return Object.keys(this.getDefaultTranslations()).filter(function(i) {
    return i.startsWith(languageStartKey);
  }).map(function(k) {
    return {key:k};
  });
}, trCache:{}, translations:{missing:{}}, getMissingTranslations:function() {
  return this.translations.missing;
}, getTranslation:function(key, otherModuleString) {
  var starter = (mpm.Support.getModuleNameFromClassName() || '').toUpperCase();
  if (Ext.isDefined(otherModuleString)) {
    starter = otherModuleString.toUpperCase();
  }
  starter += '_';
  if (!Ext.String.startsWith(key, starter)) {
    key = starter + key;
  }
  key = key.toUpperCase();
  if (this.trCache[key]) {
    return this.trCache[key];
  }
  var translation = BpcCommon.Api.getTranslation(key);
  if (key === translation) {
    this.translations.missing[key] = translation;
  }
  if (!this.trCache[key]) {
    this.trCache[key] = translation;
  }
  return translation;
}});
Ext.define('mpm.Support', {singleton:true, requires:['mpm.util.TR'], icons:{settings:'fa-cogs', messageViewer:{html:'fa-browser', tree:'fa-tree', text:'fa-file-code'}}, keys:{settings:{}, icons:{belegdaten:'fa-receipt', copy:'fa-copy', remove:'fa-times', save:'fa-save', edit:'fa-edit', add:'fa-plus'}}, constructor:function() {
  Ext.Loader.loadScript({url:'bpc-fe-mpm/resources/mpm.css', onLoad:function() {
  }, onError:function(error) {
  }});
}, getModuleNameFromClassName:function() {
  var classNameParts = this.$className.split('.');
  return classNameParts[0];
}, getSpanForIconCls:function(iconCls, color, size) {
  return BpcCommon.util.Icons.getSpanForIconCls(iconCls, color, size);
}, getBpcIconCls:function(fontAwesomeName) {
  return BpcCommon.util.Icons.getBpcIconCls(fontAwesomeName);
}, icon:function(v) {
  return this.getBpcIconCls(v);
}, getFlextableIdForTablePrefix:function(tablePrefix) {
  var instanceStore = BpcCommon.Api.getModuleInstances('flextable');
  if (instanceStore) {
    tablePrefix = tablePrefix.trim();
    var records = instanceStore.getData().getRange() || [];
    records = records.map(function(r) {
      return r.get('moduleId');
    }).filter(function(moduleId) {
      var ftprefix = BpcCommon.Api.getSetting(moduleId, 'tablePrefix') || '';
      return tablePrefix.toLowerCase().trim() === ftprefix.toLowerCase().trim();
    });
    if (records.length) {
      if (records.length > 1) {
        if (this.notify) {
          this.notify('More than one monitor to jump found', 'w');
        }
      }
      return records[0];
    }
  }
}, getFlexTablePathForModuleId:function(moduleId) {
  return 'cxf/bpc-flextable/' + moduleId + '/data';
}, getWorkflowUrl:function(mpmModuleId, prefix, noSlash) {
  prefix = prefix === void 0 ? '' : prefix;
  noSlash = noSlash === void 0 ? false : noSlash;
  var url = noSlash ? '' : '/';
  var proxyPath = this.getProxyUrl(mpmModuleId) || '-1';
  var basePath = BpcCommon.Api.getSetting(mpmModuleId, 'basePath') || '-1';
  var packageListener = BpcCommon.Api.getSetting(mpmModuleId, prefix + 'DataListener') || '-1';
  return url + [proxyPath, basePath, packageListener].join('/');
}, getProxyUrl:function(mpmModuleId) {
  var proxyId = BpcCommon.Api.getSetting(mpmModuleId, 'proxy_id') || '-1';
  return BpcCommon.Api.getBackendUrl(proxyId);
}, download:function(r, moduleId, dataUrl, process) {
  var url = this.getProxyUrl(moduleId) + dataUrl;
  url += '?' + Ext.Object.toQueryString({childId:r.get('CHILDID'), processId:r.get('PROCESSID'), prefix:process.prefix, download:true});
  window.open(url, '_blank');
}, TR:function(k) {
  return mpm.util.TR.getTranslation(k);
}, staticRenderer:function(key) {
  return function(value) {
    var data = mpm.StaticData[key] || [];
    var match = data.filter(function(item) {
      return item.key === value;
    });
    return match.length ? match[0].value : value;
  };
}, aliases:{gpkenb:'gpkeNb', gpkelf:'gpkeLf', routing:'routing', irm:'invoice', invoic:'invoice', invoice:'invoice'}, capitalizeFirstLetter:function(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}, getResponseObject:function(responseObj) {
  responseObj = responseObj || {};
  if ('responseText' in responseObj && responseObj.responseText) {
    return Ext.decode(responseObj.responseText, true);
  } else if ('responseJson' in responseObj && responseObj.responseJson) {
    return responseObj.responseJson;
  }
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}, colorCodeImage:function(v) {
  if (Ext.isEmpty(v)) {
    return '\x3cspan style\x3d"text-decoration: none; display: inline-block; vertical-align: top; margin: 2px 2px 1px 2px; ' + 'border-radius: 7px; box-shadow: 0px 0px 3px 0px #d0d0d0; height: 12px; width: 12px; ' + '"\x3e\x26nbsp;\x3c/span\x3e';
  }
  var c = [parseInt(v.substring(0, 2), 16), parseInt(v.substring(2, 4), 16), parseInt(v.substring(4, 6), 16)];
  var min = '', max = '';
  for (var i = 0; i < 3; i++) {
    min += Ext.String.leftPad(Math.max(c[i] - 48, 0).toString(16), 2, '0');
    max += Ext.String.leftPad(Math.min(c[i] + 16, 255).toString(16), 2, '0');
  }
  return '\x3cspan style\x3d"text-decoration: none; display: inline-block; vertical-align: top; margin: 1px 2px 0px 2px; ' + 'border-radius: 7px; box-shadow: 0px 0px 3px 0px #d0d0d0; height: 14px; width: 14px; ' + 'background: #' + v + '; ' + 'background: linear-gradient(to top right, #' + min + ', #' + max + '); ' + '"\x3e\x26nbsp;\x3c/span\x3e';
}, objectToHtmlTable:function(obj, width, keyWidth) {
  width = width === void 0 ? 200 : width;
  obj = obj || {};
  var html = '\x3ctable style\x3d"width: ' + width + 'px;"\x3e';
  html += this.objToTableRow(obj, keyWidth);
  return html + '\x3c/table\x3e';
}, objToTableRow:function(obj, keyWidth) {
  obj = obj === void 0 ? {} : obj;
  var html = '';
  Object.keys(obj).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd\x3e' + k + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 150px;"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html;
}, arrayToHtmlTable:function(array) {
  var $jscomp$this = this;
  array = array === void 0 ? [] : array;
  var html = '\x3ctable style\x3d"width: 200px;"\x3e';
  html += array.map(function(item) {
    return $jscomp$this.objToTableRow(item);
  }).join('');
  return html + '\x3c/table\x3e';
}, getAjaxPromise:function(requestOptions) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(requestOptions).then(function(success) {
      resolve(success);
    }, function(error) {
      reject(error);
    });
  });
}, request:function(url, params, mpmModuleId) {
  var requestOptions = {url:url, headers:{'Content-Type':'multipart/form-data'}, params:params || {}};
  if (!(url.startsWith('http') || url.startsWith('cxf'))) {
    delete requestOptions.headers;
  }
  return mpm.Support.getAjaxPromise({url:url, params:params});
}, styling:{tableview:{'background-color':'#DEDEE4'}}, dicItemFormatter:function(item, moduleId) {
  moduleId = moduleId || this.getFirstMpmInstance();
  var formatString = BpcCommon.Api.getSetting(moduleId, 'dictionaryDisplayVariant');
  return Ext.String.format(formatString, item.key, item.value);
}, dicToDisplayData:function(data, moduleId, hideKey) {
  var $jscomp$this = this;
  hideKey = hideKey === void 0 ? false : hideKey;
  return data.map(function(i) {
    return {key:i.key, value:hideKey ? i.value : $jscomp$this.dicItemFormatter(i, moduleId) || '-1', item:i};
  });
}, xTypeMap:{textarea:'mpmTextarea', textArea:'mpmTextarea', date:'mpmDatefield', text:'mpmTextfield', localCombo:'mpmSettingCombo', settingCombo:'mpmSettingCombo', staticCombo:'mpmStaticDataCombo', remoteCombo:'mpmPostCombo', checkbox:'mpmCheckbox', cb:'mpmCheckbox', box:'mpmCheckbox', dic:'mpmDictionaryCombo', mpmDictionaryCombo:'mpmDictionaryCombo', dictionary:'mpmDictionaryCombo', multi:'fieldcontainer', fieldgrid:'mpmFieldGrid', button:'mpmButton', btn:'mpmButton'}, createFields:function(fieldDefinitions, 
matchWithFields, extraParams, task) {
  if (matchWithFields) {
    fieldDefinitions = fieldDefinitions.map(function(k) {
      if (task.isConfig.meta.fields[k]) {
        var additionalFieldsInfo = task.isConfig.meta.fields[k] || {};
        if (!Ext.isEmpty(additionalFieldsInfo)) {
          task.notify('FIELD MATCHED WITH META:' + k, 'd');
          return Ext.apply({}, additionalFieldsInfo, {key:k});
        }
      }
      return k;
    });
  }
  return fieldDefinitions.map(function(fd) {
    var fieldToCreate = undefined, field = undefined;
    if (Ext.isString(fd)) {
      fieldToCreate = {key:fd};
    }
    if (fd.xtype) {
      return fd;
    }
    fieldToCreate = Ext.apply({}, fieldToCreate, fd);
    var type = fieldToCreate.type || 'text';
    fieldToCreate.xtype = mpm.Support.xTypeMap[type];
    if (type === 'multi') {
      var simpleItems = fieldToCreate.items || [];
      delete fieldToCreate.items;
      if (fieldToCreate.label) {
        fieldToCreate.fieldLabel = mpm.Support.TR('DTO_' + fieldToCreate.label);
        delete fieldToCreate.label;
      }
      simpleItems = simpleItems.map(function(item) {
        item.xtype = mpm.Support.xTypeMap[item.type || 'text'];
        var fieldDefinition = {name:item.key, dto:task.dto || {}, task:task};
        if (!item.width) {
          item.width = 130;
        }
        if (extraParams && Ext.isObject(extraParams)) {
          fieldDefinition = Ext.apply(fieldDefinition, extraParams);
        }
        var multiField = Ext.create(Ext.apply({}, fieldDefinition, item));
        multiField.setFieldLabel('');
        task.fields[item.key] = multiField;
        return multiField;
      });
      fieldToCreate.layout = {type:'hbox', align:'stretch'};
      field = Ext.create(Ext.apply({}, fieldToCreate, {items:simpleItems}));
    } else {
      var fieldDefinition = {name:fieldToCreate.key, dto:task.dto || {}, task:task};
      if (extraParams && Ext.isObject(extraParams)) {
        fieldDefinition = Ext.apply(fieldDefinition, extraParams);
      }
      field = Ext.create(Ext.apply({}, fieldDefinition, fieldToCreate));
    }
    task.fields[field.name] = field;
    return field;
  });
}, getModuleInstances:function(moduleName) {
  return BpcCommon.Api.getModuleInstances(moduleName);
}, getModuleIdBySettingValue:function(settingName, targetModule, settingValue) {
  settingName = settingName === void 0 ? 'inubit_dbTablePrefix' : settingName;
  targetModule = targetModule === void 0 ? 'monitor' : targetModule;
  settingValue = settingValue === void 0 ? '' : settingValue;
  var monitorStore = this.getModuleInstances(targetModule);
  if (monitorStore) {
    var records = monitorStore.getData().getRange() || [];
    records = records.map(function(r) {
      return r.get('moduleId');
    }).filter(function(moduleId) {
      var monitorPrefix = BpcCommon.Api.getSetting(moduleId, settingName) || '';
      return monitorPrefix.trim().toLowerCase() === settingValue.toLowerCase();
    });
    if (records.length) {
      if (records.length > 1) {
      }
      return records[0];
    }
  }
}, getFirstMpmInstance:function() {
  var $jscomp$destructuring$var2 = $jscomp.makeIterator(this.getModuleInstances('mpm').getData().getRange());
  var mpmInstance = $jscomp$destructuring$var2.next().value;
  if (mpmInstance) {
    return mpmInstance.get('moduleId');
  }
}, getDictionary:function(dictionaryId, mpmModuleId) {
  dictionaryId = dictionaryId === void 0 ? '' : dictionaryId;
  var values = BpcCommon.Api.getSetting(mpmModuleId || this.getFirstMpmInstance(), 'dictionary') || {};
  return values[dictionaryId] || [];
}, getFakeTask:function(dto, moduleId, key) {
  return {createFields:mpm.Support.createFields, mpmModuleId:moduleId, translationDebug:[], isFieldDefinedAsHidden:function() {
    return false;
  }, notify:function() {
  }, getBranch:function() {
  }, toggleSend:function(valid, c) {
  }, validateCmp:function(c) {
    var valid = true;
    if (c && c.isComponent) {
      var validations = c.query('[allowBlank\x3dfalse]').filter(function(f) {
        return true;
      }).map(function(f) {
        var isValid = f.validate();
        if (!isValid) {
          Ext.log({dump:f, msg:'not valid'});
        }
        return isValid;
      });
      valid = validations.indexOf(false) === -1;
    }
    return valid;
  }, validateAndToggle:function(c) {
  }, getDictionary:function(dictionaryId) {
    return mpm.Support.getDictionary(dictionaryId, this.mpmModuleId);
  }, fields:{}, dto:dto[key] || {}, isConfig:{meta:{}}};
}, updateFields:function(meta, fieldsDefinitions, sourceKey, targetKey, targetValue, matchValue, task) {
  matchValue = matchValue === void 0 ? true : matchValue;
  var $jscomp$destructuring$var3 = meta || {};
  var fields = $jscomp$destructuring$var3.fields;
  if (Ext.isObject(fields)) {
    var doMatch = matchValue !== null;
    var matchValues = [matchValue, String(matchValue)];
    Object.keys(fields).filter(function(k) {
      return doMatch ? matchValues.indexOf(fields[k][sourceKey]) !== -1 : Ext.isDefined(fields[k][sourceKey]);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          if (!doMatch) {
            targetValue = fields[key][sourceKey];
          }
          fd[targetKey] = targetValue;
          if (task) {
            task.notify('FIELD MODIFIED VIA META: ' + key + ' - SET: ' + targetKey + ' TO:' + targetValue + ' - FROM: ' + sourceKey, 'd');
          }
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldsWithDataFromMeta:function(meta, items, task) {
  items = this.updateFields(meta, items, 'allowBlank', 'allowBlank', false, null, task);
  items = this.updateFields(meta, items, 'required', 'allowBlank', false, true, task);
  items = this.updateFields(meta, items, 'hidden', 'hidden', true, true, task);
  items = this.updateFields(meta, items, 'readOnly', 'readOnly', true, true, task);
  items = this.updateFieldDefinitionsWithMatchExact(meta, items);
  items = this.updateFieldDefinitionsWithParams(meta, items);
  items = this.updateFieldDefinitionsWithType(meta, items);
  items = this.updateFieldDefinitionsWithActionName(meta, items, task);
  items = this.updateFieldDefinitionsWithStoreData(meta, items, task);
  items = this.updateFieldDefinitionsWithSubmitFields(meta, items, task);
  return this.updateFieldDefinitionsWithLabel(meta, items);
}, updateFieldDefinitionsWithMatchExact:function(meta, fieldsDefinitions) {
  var $jscomp$destructuring$var4 = meta || {};
  var fields = $jscomp$destructuring$var4.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].matchExact);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.matchExact = fields[key].matchExact;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, getKontaktDatenFields:function(obj, task) {
  var data = obj || {};
  var items = data.contactchannel || [];
  var icons = BpcCommon.Api.getSetting('mpm', 'contactIcons') || {};
  return [{xtype:'mpmTextfield', readOnly:true, task:task, fieldLabel:'Kontakt', skipValue:true, hardCodedValue:data.name || ''}].concat(items.map(function(item) {
    return {xtype:'mpmTextfield', skipValue:true, readOnly:true, task:task, iconCls:item.code ? icons[item.code] : 'fa-exclamation-triangle', useAsTriggerIcon:true, fieldLabel:item.type || '-1', hardCodedValue:item.contact};
  }));
}, updateFieldDefinitionsWithParams:function(meta, fieldsDefinitions) {
  var $jscomp$destructuring$var5 = meta || {};
  var fields = $jscomp$destructuring$var5.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].params);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.params = fields[key].params;
          fd.isId = Ext.isDefined(fields[key].isId) ? fields[key].isId : false;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldDefinitionsWithType:function(meta, fieldsDefinitions) {
  var $jscomp$destructuring$var6 = meta || {};
  var fields = $jscomp$destructuring$var6.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].type);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.type = fields[key].type;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldDefinitionsWithSubmitFields:function(meta, fieldsDefinitions, task) {
  var $jscomp$destructuring$var7 = meta || {};
  var fields = $jscomp$destructuring$var7.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].submitFields);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.submitFields = fields[key].submitFields;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldDefinitionsWithActionName:function(meta, fieldsDefinitions, task) {
  var $jscomp$destructuring$var8 = meta || {};
  var fields = $jscomp$destructuring$var8.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].actionName);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.actionName = fields[key].actionName;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldDefinitionsWithStoreData:function(meta, fieldsDefinitions, task) {
  var $jscomp$destructuring$var9 = meta || {};
  var fields = $jscomp$destructuring$var9.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].storeData);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.storeData = fields[key].storeData;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}, updateFieldDefinitionsWithLabel:function(meta, fieldsDefinitions) {
  var $jscomp$destructuring$var10 = meta || {};
  var fields = $jscomp$destructuring$var10.fields;
  if (Ext.isObject(fields)) {
    Ext.Object.getKeys(fields).filter(function(k) {
      return Ext.isDefined(fields[k].label);
    }).map(function(key) {
      fieldsDefinitions = fieldsDefinitions.map(function(fd) {
        if (fd.key === key) {
          fd.fieldLabel = fields[key].label;
        }
        return fd;
      });
    });
  }
  return fieldsDefinitions;
}});
Ext.define('mpm.task', {singleton:true, logs:[], init:function(dtoGlobalObject) {
  var dto = {};
  try {
    this.logs = [];
    if (dtoGlobalObject) {
      this.addLog('Task Init via scoped Object');
      dto = dtoGlobalObject;
    } else if (window.globalObject) {
      this.addLog('Task Init via globalObject', 'w');
      dto = window.globalObject;
    } else {
      this.addLog('Task Init data missing', 'w');
    }
    if (dto) {
      var taskData = dto.root ? dto.root : {};
      if (taskData.meta && taskData.meta.taskId) {
        var taskId = Ext.isObject(taskData.meta.taskId) ? Object.keys(taskData.meta.taskId)[0] : taskData.meta.taskId;
        var cls = this.getClassReference(taskId);
        if (cls) {
          this.addLog('Task class found: taskId -\x3e ' + taskData.meta.taskId);
          this.createTask(cls, dto);
          return;
        } else {
          if (taskData.meta.readOnly || taskData.meta.layout) {
            this.addLog('Task class not found: Fallback due to readOnly set or layout defined in meta.');
            this.createTask(this.getClassReference('mpmCustomTask'), dto);
            return;
          }
        }
      } else if (taskData.meta && taskData.meta.readOnly) {
        this.addLog('Task class not found: Fallback due to readOnly true in meta -\x3e Generic Infotask');
        this.createTask(this.getClassReference('mpmCustomTask'), dto);
        return;
      }
    }
    this.addLog('No task class found', 'w');
    this.addLog('Task DTO does not follow conventions', 'w');
    this.addLog('Please consult MPM documentation online', 'w');
    this.addLog('DTO will be reset.', 'i');
    this.addLog('You might want to check the RAW DTO under Info -\x3e Tab: DTO RAW', 'i');
    this.createErrorTask(dto);
  } catch (e) {
    this.addLog('ERROR DURING INIT, PLEASE CHECK YOU DTO OBJECT.', 'e');
    this.createLogEntryFromError(e);
    this.addLog('DTO will be reset.', 'i');
    this.addLog('You might want to check the RAW DTO under Info -\x3e Tab: DTO RAW', 'i');
    this.createErrorTask(dto);
  }
}, addLog:function(logEntry, level) {
  level = level === void 0 ? 'i' : level;
  this.logs.push(Ext.isString(logEntry) ? {msg:logEntry, time:new Date(), level:level} : logEntry);
}, getClassReference:function(taskId) {
  return Ext.ClassManager.getByAlias('widget.' + taskId);
}, createLogEntryFromError:function(e) {
  var logEntry = {msg:'', time:new Date(), level:'e'};
  if (e.name) {
    logEntry.msg += e.name + ' ';
  }
  if (e.message) {
    logEntry.msg += e.message;
  }
  this.addLog(logEntry);
}, createErrorTask:function(dto) {
  try {
    this.createTask(Ext.ClassManager.getByAlias('widget.mpmGenericError'), {root:{data:{}, meta:{}}, rawDto:dto || {msg:'no dto'}});
  } catch (e) {
  }
}, createTask:function(cls, data) {
  data = data === void 0 ? {} : data;
  try {
    cls.init(data, this.logs);
  } catch (e) {
    this.createLogEntryFromError(e);
    this.addLog('Oups, you probably found a Bug.', 'w');
    this.addLog('Please file a ticket.');
    this.createErrorTask();
  }
}});
Ext.define('mpm.mixins.Component', {getSetting:function(key, defaultValue) {
  return this.doGetSetting(this.moduleId, defaultValue);
}, getGlobalSetting:function(key, defaultValue) {
  return this.doGetSetting('mpm', key) || defaultValue;
}, doGetSetting:function(id, key) {
  return BpcCommon.Api.getSetting(id, key);
}, TR:function(key) {
  return mpm.Support.TR(key);
}, faIcon:function(icon) {
  return mpm.Support.icon(icon);
}, newLocalStore:function(data) {
  data = data === void 0 ? [] : data;
  return mpm.util.Store.newLocalStore(data);
}, getSettingModel:function(key) {
  return BpcCommon.Api.getSetting(this.moduleId, key, true);
}, getGlobalSettingModel:function(key) {
  return BpcCommon.Api.getSetting('collaboration', key, true);
}});
Ext.define('mpm.components.Container', {extend:'Ext.container.Container', alias:'widget.mpmContainer', mixins:['mpm.mixins.Component'], layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  this.style = 'background-color:' + mpm.Support.styling.tableview['background-color'] + '!important;border:0px!important';
  this.callParent(arguments);
}});
Ext.define('mpm.components.Panel', {extend:'Ext.panel.Panel', alias:'widget.mpmPanel', mixins:['mpm.mixins.Component'], style:'background-color:#DEDEE4!important;border:0px!important', scrollable:true, renderTpl:['\x3ctpl if\x3d"headingText"\x3e', '\x3cdiv id\x3d"{id}-headingEl" data-ref\x3d"headingEl" role\x3d"heading"', ' class\x3d"', Ext.baseCSSPrefix, 'hidden-clip" style\x3d"height:0"\x3e', '{headingText}', '\x3c/div\x3e', '\x3c/tpl\x3e', '\x3ctpl if\x3d"hasTabGuard"\x3e{% this.renderTabGuard(out, values, \'before\'); %}\x3c/tpl\x3e', 
'\x3cdiv id\x3d"{id}-bodyWrap" data-ref\x3d"bodyWrap" class\x3d"{baseCls}-bodyWrap"', '\x3ctpl if\x3d"bodyWrapAriaAttributes"\x3e', '\x3ctpl foreach\x3d"bodyWrapAriaAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', '\x3ctpl else\x3e', ' role\x3d"presentation"', '\x3c/tpl\x3e', '\x3e', '{% this.renderDockedItems(out,values,0); %}', '\x3cdiv id\x3d"{id}-body" style\x3d"background-color:#DEDEE4;" data-ref\x3d"body" class\x3d"{baseCls}-body\x3ctpl if\x3d"bodyCls"\x3e {bodyCls}\x3c/tpl\x3e', ' {baseCls}-body-{ui}\x3ctpl if\x3d"uiCls"\x3e', 
'\x3ctpl for\x3d"uiCls"\x3e {parent.baseCls}-body-{parent.ui}-{.}\x3c/tpl\x3e', '\x3c/tpl\x3e{childElCls}"', '\x3ctpl if\x3d"bodyAriaAttributes"\x3e', '\x3ctpl foreach\x3d"bodyAriaAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', '\x3ctpl else\x3e', ' role\x3d"presentation"', '\x3c/tpl\x3e', '\x3ctpl if\x3d"bodyStyle"\x3e style\x3d"{bodyStyle}"\x3c/tpl\x3e\x3e', '{%this.renderContainer(out,values);%}', '\x3c/div\x3e', '{% this.renderDockedItems(out,values,1); %}', '\x3c/div\x3e', '\x3ctpl if\x3d"hasTabGuard"\x3e{% this.renderTabGuard(out, values, \'after\'); %}\x3c/tpl\x3e'], 
layout:'mpmForm', padding:'4 2 4 5'});
Ext.define('mpm.components.container.Container', {extend:'mpm.components.Container', alias:'widget.mpmAnswerContainerRow', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'mpmPanel', flex:1, padding:'5 5 5 5', layout:{type:'vbox', align:'stretch'}}, allowBlank:false, confirmPanel:undefined, rejectPanel:undefined, conditionalFields:undefined, conditionalFieldPanel:undefined, confirmText:'Zustimmung', getMpmStyle:function() {
  return 'background-color:' + mpm.Support.styling.tableview['background-color'] + '!important;border:0px!important';
}, initComponent:function() {
  var $jscomp$this = this;
  var answerPanel = this, hideAccept = false, hideReject = false;
  if (this.rejectPanel) {
    this.rejectPanel.selectionHolder = this;
    hideReject = this.rejectPanel.hideEmpty && this.rejectPanel.hidden;
  }
  if (this.confirmPanel) {
    this.confirmPanel.selectionHolder = this;
    hideAccept = this.confirmPanel.hideEmpty && this.confirmPanel.hidden;
  }
  this.items = [{title:'Antwort', iconCls:mpm.Support.icon('fa-reply'), items:[{xtype:'fieldcontainer', style:this.getMpmStyle(), name:'antwort', itemId:'answerCategory', getValue:function() {
    var me = this;
    var radios = me.query('radiofield');
    var selectedArray = radios.filter(function(f) {
      return f.getValue();
    });
    return selectedArray.length ? selectedArray[0].inputValue : undefined;
  }, setValue:function() {
  }, defaultType:'radiofield', defaults:{flex:1, skipValue:true, name:'antwortSelect', task:this.task, holder:answerPanel, listeners:{change:function(field, newValue, oldValue, eOpts) {
    if (newValue === true) {
      var catWrapper = field.up('#selectPanel').down('#responseCategory');
      catWrapper.removeAll(false);
      var reject = field.inputValue === 'reject';
      $jscomp$this.rejectPanel.resetFields();
      $jscomp$this.confirmPanel.resetFields();
      $jscomp$this.resetConditionalFields();
      catWrapper.add(reject ? $jscomp$this.rejectPanel : $jscomp$this.confirmPanel);
      field.task.handleAcceptReject(reject);
      field.task.validateAndToggle();
    }
  }}}, layout:'mpmForm', items:[{boxLabel:this.confirmText, inputValue:'confirm', value:true, hidden:hideAccept}, {boxLabel:'Ablehnung', inputValue:'reject', hidden:hideReject || !this.rejectPanel}]}]}, {title:'Antwortkategorie', iconCls:mpm.Support.icon('fa-check-double'), itemId:'responseCategory', getValue:function() {
    var me = this;
    var radios = me.query('[name]');
    var selectedArray = radios.filter(function(f) {
      var value = f.getValue();
      if (f.mpmValidation && f.mpmValidation.length) {
        value = value || '';
        value = f.mpmValidation.length.indexOf(value.length) !== -1;
      }
      return value;
    });
    return selectedArray.length ? selectedArray[0].inputValue ? selectedArray[0].inputValue : selectedArray[0].getValue() : undefined;
  }, name:'antwortkategorie', flex:2, items:[this.confirmPanel]}];
  if (this.conditionalFields) {
    this.conditionalFieldPanel = Ext.create({xtype:'mpmPanel', flex:2, title:'Sonstige Angaben', items:this.conditionalFields});
    this.items.push(this.conditionalFieldPanel);
  }
  var rejectFields = this.rejectPanel ? this.rejectPanel.query('field') : [];
  var confirmFields = this.confirmPanel ? this.confirmPanel.query('field') : [];
  rejectFields.concat(confirmFields).map(function(f) {
    f.on('change', $jscomp$this.onFieldChanged.bind($jscomp$this));
  });
  this.callParent(arguments);
}, addStaticMpmFields:function(items) {
  items = items === void 0 ? [] : items;
  this.add({xtype:'mpmPanel', flex:2, title:'Sonstige Angaben', items:items});
}, onFieldChanged:function(f, newVal, oldVal) {
  Ext.log({dump:f, msg:'changed radio / combo field'});
  if (!newVal && oldVal) {
    Ext.log({dump:f, msg:'old selected changed radio / combo field'});
    return;
  }
  this.resetConditionalFields();
  if (f.requiredFields) {
    this.handleRequiredFields(f.requiredFields, newVal);
  }
  if (f.skipFields) {
    this.handleSkipFields(f.skipFields, newVal);
  }
  if (f.optionalFields) {
    this.handleOptionalFields(f.optionalFields, newVal);
  }
}, conditionalFieldCache:{}, handleRequiredFields:function(requiredFileNames, required) {
  var $jscomp$this = this;
  Ext.log({dump:requiredFileNames, msg:'requiredFields'});
  if (!required) {
    requiredFileNames = undefined;
  }
  if (requiredFileNames) {
    requiredFileNames.map(function(name) {
      var f = $jscomp$this.task.taskFormWrapper.down('[name\x3d' + name + ']');
      if (f.readOnly) {
        f = $jscomp$this.down('[name\x3d' + name + ']');
      }
      if (f) {
        if (!$jscomp$this.conditionalFieldCache[name]) {
          $jscomp$this.conditionalFieldCache[name] = f;
        }
        f.allowBlank = !required;
        f.setVisible(required);
        if (f.xtype === 'fieldcontainer') {
          f.query('field').map(function(f) {
            return f.setVisible(true);
          });
        }
        if (required && !f.changelistenerAdded) {
          f.on('change', $jscomp$this.task.validateAndToggle.bind($jscomp$this.task));
          f.changelistenerAdded = true;
        }
      }
    });
  } else {
    Object.keys(this.conditionalFieldCache).map(function(name) {
      var initConfig = $jscomp$this.conditionalFieldCache[name].getInitialConfig();
      $jscomp$this.conditionalFieldCache[name].setVisible(!initConfig.hidden);
      $jscomp$this.conditionalFieldCache[name].allowBlank = !initConfig.allowBlank;
      $jscomp$this.conditionalFieldCache[name].validate();
    });
  }
  this.task.validateAndToggle();
}, handleSkipFields:function(requiredFileNames, required) {
  var $jscomp$this = this;
  Ext.log({dump:requiredFileNames, msg:'skippedFields'});
  if (requiredFileNames) {
    requiredFileNames.map(function(name) {
      var f = $jscomp$this.task.taskFormWrapper.down('[name\x3d' + name + ']');
      if (f) {
        if (!$jscomp$this.conditionalFieldCache[name]) {
          $jscomp$this.conditionalFieldCache[name] = f;
        }
        f.allowBlank = true;
        if (required && !f.changelistenerAdded) {
          f.on('change', $jscomp$this.task.validateAndToggle.bind($jscomp$this.task));
          f.changelistenerAdded = true;
        }
      }
    });
  }
  Ext.log({dump:this.conditionalFieldCache, msg:'fieldCache'});
  this.task.validateAndToggle();
}, handleOptionalFields:function(requiredFileNames, required) {
  var $jscomp$this = this;
  Ext.log({dump:requiredFileNames, msg:'optionalFields'});
  if (requiredFileNames) {
    requiredFileNames.map(function(name) {
      var f = $jscomp$this.task.taskFormWrapper.down('[name\x3d' + name + ']');
      if (f) {
        f.setVisible(true);
        if (!$jscomp$this.conditionalFieldCache[name]) {
          $jscomp$this.conditionalFieldCache[name] = f;
        }
        f.allowBlank = true;
        if (f.xtype === 'fieldcontainer') {
          f.query('field').map(function(f) {
            return f.setVisible(true);
          });
        }
        if (required && !f.changelistenerAdded) {
          f.on('change', $jscomp$this.task.validateAndToggle.bind($jscomp$this.task));
          f.changelistenerAdded = true;
        }
      }
    });
  } else {
  }
  this.task.validateAndToggle();
}, resetConditionalFields:function() {
  if (this.conditionalFieldPanel) {
    var container = this.conditionalFieldPanel.query('fieldcontainer');
    var fields = this.conditionalFieldPanel.query('field');
    container.concat(fields).map(function(f) {
      f.allowBlank = true;
      f.setVisible(false);
      f.reset();
    });
  }
}, validate:function() {
  var $jscomp$this = this;
  var cmps = ['responseCategory', 'answerCategory'];
  var defined = cmps.map(function(name) {
    var cmp = $jscomp$this.down('#' + name);
    var value = cmp ? cmp.getValue() : undefined;
    return !!Ext.isDefined(value);
  }).filter(function(item) {
    return item === true;
  });
  return cmps.length === defined.length;
}});
Ext.define('mpm.components.Editor', {extend:'Ext.panel.Panel', alias:'widget.mpmEditor', layout:'fit', editor:undefined, value:undefined, readOnly:true, isBase64:false, editorLanguage:'json', copyEnabled:false, initComponent:function() {
  var $jscomp$this = this;
  this.editorId = Ext.id();
  var wrapper = Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + this.editorId + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
  this.items = [wrapper];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this), resize:this.onResize.bind(this)};
  if (this.copyEnabled) {
    this.tools = [{iconCls:mpm.Support.icon('fa-copy'), tooltip:mpm.Support.TR('COPY'), handler:function(event, toolEl, panelHeader) {
      if (mpm.Support.copyToClipBoard($jscomp$this.getValue(), $jscomp$this)) {
        BpcCommon.Api.showNotification(mpm.Support.TR('GENERIC_COPY_SUCCESS'));
      }
    }}];
  }
  this.callParent(arguments);
}, initEditor:function() {
  if (!window.ace) {
    return;
  }
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.editor.getSession().setMode('ace/mode/' + this.editorLanguage);
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, onResize:function() {
  if (this.editor) {
    this.editor.resize();
  }
}, getValue:function() {
  if (this.editor) {
    var value = this.editor.getValue();
    if (this.editorLanguage === 'edifact') {
      return value.split('\n').join('').trim();
    }
    return value;
  }
}, setValue:function(value) {
  value = value === void 0 ? '' : value;
  if (this.editor) {
    if (this.isBase64) {
      try {
        value = atob(value);
        if (this.editorLanguage === 'edifact') {
          value = value.split("'").join("'\n");
        } else if (this.editorLanguage === 'xml') {
          value = this.prettyXml(value);
        }
      } catch (e) {
        value = 'Fehler beim Dekodieren';
      }
    }
    this.editor.setValue((value || '').trim(), -1);
  }
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}, prettyXml:function(xml, tab, nl) {
  tab = tab === void 0 ? '\t' : tab;
  nl = nl === void 0 ? '\n' : nl;
  var formatted = '', indent = '';
  var nodes = xml.slice(1, -1).split(/>\s*</);
  if (nodes[0][0] === '?') {
    formatted += '\x3c' + nodes.shift() + '\x3e' + nl;
  }
  for (var i = 0; i < nodes.length; i++) {
    var node = nodes[i];
    if (node[0] === '/') {
      indent = indent.slice(tab.length);
    }
    formatted += indent + '\x3c' + node + '\x3e' + nl;
    if (node[0] !== '/' && node[node.length - 1] !== '/' && node.indexOf('\x3c/') === -1) {
      indent += tab;
    }
  }
  return formatted;
}});
Ext.define('mpm.components.FieldSet', {extend:'Ext.form.FieldSet', alias:'widget.mpmFieldSet', layout:'mpmForm', padding:'4 2 4 5', bodyPadding:1, scrollable:true, initComponent:function() {
  this.style = 'background-color:' + mpm.Support.styling.tableview['background-color'] + '!important;border:0px!important';
  this.callParent(arguments);
}});
Ext.define('mpm.layout.container.Form', {extend:'Ext.layout.container.Form', alias:'layout.mpmForm', type:'form', beforeBodyTpl:'\x3cdiv id\x3d"{ownerId}-formWrap" data-ref\x3d"formWrap" style\x3d"border-spacing: 3px;" class\x3d"{formWrapCls}"' + '\x3ctpl if\x3d"itemSpacing"\x3e style\x3d"border-spacing:{itemSpacing}px"\x3c/tpl\x3e\x3e' + '\x3cdiv class\x3d"{formColGroupCls}"\x3e' + '\x3cdiv id\x3d"{ownerId}-labelColumn" data-ref\x3d"labelColumn" class\x3d"{formColumnCls} {formLabelColumnCls}"' + 
'\x3ctpl if\x3d"labelWidth"\x3e style\x3d"width:{labelWidth}"\x3c/tpl\x3e\x3e' + '\x3c/div\x3e' + '\x3cdiv class\x3d"{formColumnCls}"\x3e\x3c/div\x3e' + '\x3c/div\x3e'});
Ext.define('mpm.components.LoadingPanel', {extend:'Ext.panel.Panel', alias:'widget.mpmLoadingPanel', layout:'fit', initComponent:function() {
  this.messagePanel = Ext.create({xtype:'container', width:'400', height:'150', html:''});
  this.setMessage();
  this.items = [{xtype:'container', layout:'center', items:[this.messagePanel]}];
  this.callParent(arguments);
}, setMessage:function(message, icon, color, size) {
  message = message || mpm.Support.TR('LOADING');
  icon = icon || 'fa-sync';
  color = color || '#000';
  size = size || 40;
  var html = '\x3cdiv style\x3d"display: flex; flex-direction: column; justify-content: center; justify-items: center; align-items: center; padding: 30px;"\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + BpcCommon.util.Icons.getSpanForIconCls(mpm.Support.icon(icon), color, size) + '\x3c/div\x3e' + '\x3cdiv style\x3d"padding: 10px;"\x3e' + message + '\x3c/div\x3e' + '\x3c/div\x3e';
  this.messagePanel.update(html);
}});
Ext.define('mpm.tasks.components.MessageViewer', {extend:'Ext.panel.Panel', alias:'widget.taskMessageViewer', layout:'card', supportedDisplayTypes:['Html', 'Text', 'Tree'], padding:'5 5 5 5', ref:undefined, dataUrl:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = mpm.Support.TR('MESSAGE');
  this.iconCls = mpm.Support.icon('fa-sticky-note');
  this.notificationField = Ext.create({xtype:'container', margin:'0 0 0 5'});
  this.cmps = this.supportedDisplayTypes.map(function(suffix) {
    return Ext.create({xtype:'mpmMessageViewer' + suffix, task:$jscomp$this.task, viewType:suffix, mpmModuleId:$jscomp$this.mpmModuleId, process:$jscomp$this.process, viewer:$jscomp$this});
  });
  this.tbar = this.cmps.map(function(cmp) {
    return {text:mpm.Support.TR('VIEWER_TYPE' + cmp.viewType), iconCls:mpm.Support.icon(mpm.Support.icons.messageViewer[cmp.viewType.toLowerCase()]), view:cmp, ui:'primary', handler:function(b) {
      $jscomp$this.showPanel(b.view);
    }};
  }).concat([this.notificationField, {xtype:'tbfill'}, {xtype:'button', iconCls:mpm.Support.icon('fa-download'), text:mpm.Support.TR('DOWNLOAD'), scope:this, ui:'secondary', handler:function() {
    mpm.Support.download($jscomp$this.record, $jscomp$this.mpmModuleId, $jscomp$this.dataUrl, $jscomp$this.process);
  }}]);
  this.callParent(arguments);
  if (Ext.isDefined(this.ref)) {
    this.setLoadReference(this.ref);
  }
  this.showPanel(this.cmps[0]);
}, showPanel:function(cmp) {
  if (Ext.isDefined(cmp.referenceId)) {
    cmp.loadData();
  }
  this.getLayout().setActiveItem(cmp);
}, setLoadReference:function(id) {
  this.cmps.map(function(c) {
    return c.setLoadReference(id);
  });
}});
Ext.define('mpm.components.MpmGrid', {extend:'Ext.grid.Panel', alias:'widget.mpmGrid', mixins:['mpm.mixins.Component'], task:undefined, name:'data', deviceType:'Zaehleinrichtungsdaten', windowTitle:'Zaehleinrichtungsdaten', windowIconCls:undefined, selModel:'cellmodel', barPosition:'tbar', allowBlank:true, validate:function() {
  return this.allowBlank ? true : this.store.getCount() > 0;
}, getValue:function(json) {
  json = json === void 0 ? false : json;
  var xmlDoc = document.implementation.createDocument(null, null, null);
  var wrapper = xmlDoc.createElement('Geraete');
  wrapper.setAttribute('type', 'relation');
  var jsonDataItems = [];
  this.store.each(function(r) {
    var row = xmlDoc.createElement('row');
    Object.keys(r.data).map(function(k) {
      if (k !== 'id') {
        var element = xmlDoc.createElement(k);
        element.append(r.get(k) || '');
        row.appendChild(element);
      }
    });
    if (json) {
      var item$0 = r.getData();
      if (item$0.id) {
        delete item$0.id;
      }
      jsonDataItems.push(item$0);
    }
    wrapper.appendChild(row);
  });
  var wrapper0 = xmlDoc.createElement('data');
  wrapper0.append(wrapper);
  xmlDoc.appendChild(wrapper0);
  return json ? jsonDataItems : (new XMLSerializer()).serializeToString(xmlDoc);
}, _data:undefined, _columns:[], openEditWindow:function(edit, r) {
  var fieldArray = this.getFieldArray(), record = undefined;
  if (edit) {
    if (r) {
      record = r;
    } else {
      var records = this.getSelection();
      if (records.length) {
        var active = records[0];
        r = active;
        fieldArray = fieldArray.map(function(fieldDef) {
          fieldDef.value = active.get(fieldDef.name);
          return fieldDef;
        });
      }
    }
  }
  var windowConfig = {xtype:'mpmWindow', title:mpm.Support.capitalizeFirstLetter(this.windowTitle.toLowerCase()), targetGrid:this, record:record, fields:fieldArray};
  if (this.windowIconCls) {
    windowConfig.iconCls = mpm.Support.icon(this.windowIconCls);
  }
  Ext.create(windowConfig).show();
}, getFieldArray:function() {
  var $jscomp$this = this;
  var g = this;
  var dataIndexes = this.getColumns().filter(function(c) {
    return Ext.isDefined(c.dataIndex) && c.dataIndex !== null;
  }).map(function(c) {
    return {dataIndex:c.dataIndex, type:c.editorType, settingName:c.settingName, command:c.command, mpmType:c.mpmType, text:c.text, params:c.params, field:c.field, values:c.values || []};
  });
  return dataIndexes.map(function(item) {
    var xtype = item.type ? item.type === 'static' ? 'mpmStaticDataCombo' : 'mpmPostCombo' : item.mpmType ? item.mpmType : 'textfield';
    if (item.type === 'values') {
      xtype = 'combo';
    }
    var fieldLabel = Ext.isDefined(item.text) && Ext.isDefined(item.mpmType) ? item.text : mpm.Support.TR('COL_' + item.dataIndex);
    var fieldCfg = {xtype:xtype, name:item.dataIndex, fieldLabel:$jscomp$this.tryTranslate(fieldLabel)};
    if (item.type === 'setting') {
      fieldCfg.dataKey = item.settingName;
      fieldCfg.xtype = 'mpmSettingCombo';
      fieldCfg.task = $jscomp$this.task;
      fieldCfg.moduleId = $jscomp$this.task.mpmModuleId;
      fieldCfg.fieldLabel = mpm.Support.capitalizeFirstLetter(item.dataIndex);
      fieldCfg.name = item.dataIndex;
    }
    if (item.type === 'static') {
      fieldCfg.dataKey = item.dataIndex;
    }
    if (item.type === 'static') {
      fieldCfg.customLabel = mpm.Support.TR('COL_' + item.dataIndex);
    }
    if (item.type === 'remote') {
      var params = {};
      if (item.params) {
        params = item.params;
      } else {
        params = {command:item.command || ''};
      }
      fieldCfg.params = params;
    }
    if (item.type === 'remote') {
      fieldCfg.task = g.task;
    }
    if (item.type === 'values') {
      fieldCfg.store = mpm.util.Store.newLocalStore(item.values);
      fieldCfg.valueField = 'key';
      fieldCfg.displayField = 'value';
      fieldCfg.queryMode = 'local';
    }
    return fieldCfg;
  });
}, onDataChanged:function(s) {
  if (this.allowBlank === false) {
    this.task.validateAndToggle();
  }
}, iconCls:mpm.Support.icon('database'), style:'border:0px!important;', readOnly:false, initComponent:function() {
  var $jscomp$this = this;
  this.viewConfig = {emptyText:this.TR('MPM_NO_DATA_FOUND'), style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';'};
  this.padding = '0 0 0 0';
  var storeData = this._data || this.task.dto[this.name] || [];
  if (!Ext.isDefined(this.title) || this.title === null) {
    var tr = this.TR(this.name);
    if (tr.toLowerCase().startsWith('mpm_')) {
      tr = mpm.Support.capitalizeFirstLetter(this.name);
    }
    this.title = tr;
  }
  this.store = Ext.create('Ext.data.Store', {data:storeData, listeners:{datachanged:this.onDataChanged.bind(this)}});
  this.createButton = Ext.create({text:'Hinzufügen', xtype:'button', ui:'primary', iconCls:mpm.Support.icon('fa-plus-circle'), handler:function() {
    $jscomp$this.openEditWindow();
  }});
  this.editButton = Ext.create({xtype:'button', ui:'secondary', text:'Bearbeiten', disabled:true, iconCls:mpm.Support.icon('fa-wrench'), scope:this, handler:function(b) {
    this.openEditWindow(true);
  }});
  this.removeButton = Ext.create({xtype:'button', ui:'secondary', text:'Entfernen', disabled:true, iconCls:mpm.Support.icon(mpm.Support.keys.icons.remove)});
  this.removeAllButton = Ext.create({xtype:'button', ui:'secondary', text:'Alle Entfernen', disabled:true, iconCls:mpm.Support.icon(mpm.Support.keys.icons.remove)});
  if (this.readOnly === false) {
    this[this.barPosition] = [this.createButton, this.editButton, this.removeButton, {xtype:'tbfill'}, this.removeAllButton];
    this.plugins = {cellediting:{clicksToEdit:1}};
  } else {
    if (storeData.length === 0) {
      this.disabled = true;
      this.tabConfig = {tooltip:this.TR('NO_DATA'), style:{pointerEvents:'all'}};
    }
  }
  this.listeners = {select:function(grid, record) {
  }.bind(this), selectionchange:function(grid, selectedRecords) {
    this.editButton.setDisabled(selectedRecords.length === 0);
    this.removeButton.setDisabled(selectedRecords.length === 0);
  }.bind(this)};
  var columns = this._columns.length ? this._columns : [{dataIndex:'Zaehlernummer', flex:1, editor:{completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}}}];
  if (this.readOnly === false) {
    columns = columns.concat([{xtype:'actioncolumn', width:90, items:[{iconCls:this.faIcon('fa-copy'), tooltip:this.TR('CLONE'), handler:function(grid, rowIndex, colIndex) {
      this.cloneItem(grid.getStore().getAt(rowIndex));
    }.bind(this)}, {iconCls:this.faIcon('fa-wrench'), tooltip:this.TR('EDIT'), handler:function(grid, rowIndex, colIndex, item, e, r) {
      this.openEditWindow(true, r);
    }.bind(this)}, {iconCls:this.faIcon(mpm.Support.keys.icons.remove), tooltip:this.TR('DELETE'), handler:function(grid, rowIndex, colIndex) {
      var rec = grid.getStore().removeAt(rowIndex);
    }}]}]);
  }
  this.columns = columns.map(function(i) {
    if (Ext.isString(i)) {
      i = {dataIndex:i, mpmType:'mpmTextfield'};
    }
    if (!i.text) {
      i.text = i.dataIndex ? $jscomp$this.TR('COL_' + i.dataIndex) : $jscomp$this.TR('COL_ACTIONS');
    }
    if (!i.width) {
      i.flex = 1;
    }
    if (i.text && i.text.toLowerCase().startsWith('mpm_col_')) {
      i.text = $jscomp$this.tryTranslate(i.text);
    }
    if (i.editorType === 'static') {
      i.renderer = mpm.Support.staticRenderer(i.dataIndex);
    }
    if (i.field && i.field.type === 'dic') {
      i.renderer = $jscomp$this.createFieldRendererDIC(i.field.dataKey);
    }
    if (Ext.isDefined(i.editor)) {
    } else {
      if (i.xtype !== 'actioncolumn') {
        i.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
      } else {
        if (i.flex) {
          delete i.flex;
        }
      }
    }
    return i;
  });
  this.callParent(arguments);
}, tryTranslate:function(text) {
  text = text === void 0 ? '' : text;
  text = text.toLowerCase();
  text = text.replace('mpm_col_', '');
  return mpm.Support.capitalizeFirstLetter(text);
}, createFieldRendererDIC:function(key) {
  var array = mpm.Support.getDictionary(key);
  return function(value, m, r) {
    var match = array.filter(function(item) {
      return item.key === value;
    });
    var renderValue = match.length ? mpm.Support.dicItemFormatter(match[0]) : value;
    this.addTooltipToMeta(m, renderValue);
    return renderValue;
  };
}, addTooltipToMeta:function(m, tooltip) {
  if (m) {
    m.tdAttr = 'data-qtip\x3d"' + Ext.String.htmlEncode(tooltip) + '"';
  }
}, cloneItem:function(rec) {
  var dataIndexes = this.getColumns().filter(function(c) {
    return Ext.isDefined(c.dataIndex) && c.dataIndex !== null;
  }).map(function(c) {
    return c.dataIndex;
  });
  var newItem = {};
  dataIndexes.map(function(dataIndex) {
    newItem[dataIndex] = rec.get(dataIndex);
  });
  this.store.add(newItem);
}});
Ext.define('mpm.Splitter', {extend:'Ext.resizer.Splitter', alias:'widget.mpmSplitter', style:'background-color:rgb(56 60 56 / 76%)', height:3});
Ext.define('mpm.components.TreePanel', {extend:'Ext.tree.Panel', alias:'widget.mpmTreepanel', margin:'5 5 5 5', rootVisible:true, infoButton:undefined, pathButton:undefined, initComponent:function() {
  this.listeners = {itemexpand:function(node, eOpts) {
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
  }, itemcollapse:function(node, eOpts) {
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
  }, select:function(treeModel, node) {
    var $jscomp$this = this;
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
    var pathString = node.getPath();
    var recordIds = pathString.split('/');
    var namedPath = recordIds.map(function(name) {
      if (name === 'root') {
        return name;
      } else {
        var r = $jscomp$this.store.getById(name);
        if (r) {
          return r.get('text');
        }
        return name;
      }
    });
    this.pathButton.setText(namedPath.join('/'));
    this.infoButton.setText(node.get('text'));
  }.bind(this)};
  this.callParent(arguments);
  this.expandAll();
}, columns:[{xtype:'treecolumn', text:'Baum', dataIndex:'text', flex:4}, {text:'Color', dataIndex:'text', width:40, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '', bgColor;
  if (textValue.toLowerCase() === 'root') {
    bgColor = '#FFF';
  } else {
    var getFirstSegment = function(rec) {
      if (rec.parentNode) {
        var text = rec.parentNode.get('text');
        if (text.startsWith('S_') || text.toLowerCase() === 'root' || text.toLowerCase() === 'message') {
          return rec.parentNode;
        } else {
          return getFirstSegment(rec.parentNode);
        }
      }
      return rec;
    };
    if (!textValue.startsWith('S_')) {
      var firstSegmentRecord = getFirstSegment(rec);
      textValue = firstSegmentRecord.get('text');
    }
    if (textValue.startsWith('S_')) {
      var cleantext = textValue.replace('S_', '').trim();
      var isHeader = ['UNB', 'UNZ'].indexOf(cleantext) !== -1;
      var isMessage = ['UNH', 'UNT'].indexOf(cleantext) !== -1;
      bgColor = isHeader ? 'darkblue' : isMessage ? 'lightblue' : 'lightcyan';
    } else {
      if (textValue.toLowerCase().startsWith('root')) {
        bgColor = '#FFF';
      }
      if (textValue.toLowerCase().startsWith('message')) {
        bgColor = 'lightcyan';
      }
      if (val === 'Message' && textValue === 'Root') {
        bgColor = 'lightgreen';
      } else {
        if (val.startsWith('G_') && textValue.toLowerCase().startsWith('message')) {
          bgColor = 'lightcyan';
        } else {
          bgColor = 'red';
          Ext.log({dump:textValue, msg:'textValue'});
          Ext.log({dump:val, msg:'value'});
        }
      }
    }
  }
  meta.tdAttr = 'bgcolor\x3d"' + bgColor + '"';
  return '';
}}, {text:'Item', dataIndex:'text', flex:1, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[0] : textValue;
}}, {text:'Value', dataIndex:'text', flex:2, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[1] : '';
}}]});
Ext.define('mpm.components.Validations', {extend:'Ext.grid.Panel', alias:'widget.mpmValidationsGrid', iconCls:mpm.Support.icon('fa-eye'), dto:undefined, task:undefined, style:'border:0px!important;', initComponent:function() {
  this.viewConfig = {emptyText:'No Validations in DTO or format not met', style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';'};
  var storeData = this.transformValidations();
  this.store = mpm.util.Store.newLocalStore(storeData);
  this.columns = [{xtype:'mpmValidationCheckcolumn', dataIndex:'cbValue', width:40, disabled:true}, {dataIndex:'name', flex:1, renderer:function(val) {
    return mpm.Support.capitalizeFirstLetter(val || '');
  }}, {hidden:true, dataIndex:'text'}];
  this.callParent(arguments);
}, transformValidations:function() {
  if (this.dto.validaton === null) {
    return [];
  }
  var validation = JSON.parse(JSON.stringify(this.dto.validation));
  return validation.map(function(item) {
    item.rawValue = item.value;
    item.cbValue = item.value;
    var trueValue = ['true', false, 'false', true];
    if (trueValue.indexOf(item.value) === -1) {
      item.cbValue = false;
    }
    return item;
  }) || [];
}});
Ext.define('mpm.components.Window', {extend:'Ext.window.Window', alias:'widget.mpmWindow', style:'background-color:#DEDEE4!important;', fields:undefined, targetGrid:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.layout = 'fit';
  this.width = document.body.clientWidth * 0.5;
  this.height = document.body.clientHeight * 0.5;
  this.items = [{xtype:'mpmPanel', autoScroll:true, defaults:{dto:{}}, items:this.fields || []}];
  this.callParent(arguments);
  var fieldDefinitions = this.fields || [];
  if (fieldDefinitions.length > 0 && Ext.isDefined(this.record)) {
    this.query('[name]').map(function(f) {
      var value = $jscomp$this.record.get(f.name);
      if (value) {
        f.setValue(value);
      }
    });
  }
}, getStoreData:function() {
  var storeData = {};
  this.query('[name]').map(function(f) {
    storeData[f.name] = f.getValue();
  });
  return storeData;
}, bbar:[{xtype:'tbfill'}, {text:'Fenster schließen', ui:'secondary', iconCls:mpm.Support.icon(mpm.Support.keys.icons.remove), handler:function(b) {
  var win = b.up('window');
  win.close();
}}, {text:'Werte übernehmen', ui:'primary', iconCls:mpm.Support.icon('fa-check'), handler:function(b) {
  var win = b.up('window');
  var storeData = win.getStoreData();
  if (Ext.isDefined(win.record)) {
    Object.keys(storeData).map(function(name) {
      win.record.set(name, storeData[name]);
    });
  } else {
    win.targetGrid.getStore().add(storeData);
  }
  win.close();
}}]});
Ext.define('mpm.tasks.components.column.ValidationCheck', {extend:'Ext.grid.column.Check', alias:'widget.mpmValidationCheckcolumn', defaultRenderer:function(value, cellValues) {
  var me = this, cls = me.checkboxCls, tip = '';
  var showBox = [true, false, 'true', 'false'].indexOf(cellValues.record.get('value')) !== -1;
  if (me.invert) {
    value = !value;
  }
  if (me.disabled) {
    cellValues.tdCls += ' ' + me.disabledCls;
  }
  if (value) {
    cls += ' ' + me.checkboxCheckedCls;
    tip = me.checkedTooltip;
  } else {
    tip = me.tooltip;
  }
  if (tip) {
    cellValues.tdAttr += ' data-qtip\x3d"' + Ext.htmlEncode(tip) + '"';
  }
  if (me.useAriaElements) {
    cellValues.tdAttr += ' aria-describedby\x3d"' + me.id + '-cell-description' + (!value ? '-not' : '') + '-selected"';
  }
  me.updateHeaderState();
  if (showBox === false) {
    cls = '';
  }
  return '\x3cspan class\x3d"' + cls + '" role\x3d"' + me.checkboxAriaRole + '"' + (!me.ariaStaticRoles[me.checkboxAriaRole] ? ' tabIndex\x3d"0"' : '') + '\x3e\x3c/span\x3e';
}});
Ext.define('mpm.components.mixins.Fields', {setValueDeferred:false, handleReadOnlyEmptyText:function() {
  if (this.readOnly) {
    this.setEmptyText('');
  }
}, enableCopyAndPasteOnDblClick:function() {
  this.on('afterrender', this.onAfterRender.bind(this));
}, onAfterRender:function(c) {
  var $jscomp$this = this;
  this.getEl().on('dblclick', function() {
    var v = $jscomp$this.getValue();
    if (v) {
      if (mpm.Support.copyToClipBoard(v, $jscomp$this)) {
        BpcCommon.Api.showNotification(v + ' ' + mpm.Support.TR('HAS_BEEN_COPIED'));
      }
    }
  });
}, validateValueLength:function(val) {
  var valid = true;
  val = String(val);
  if (this.matchExact) {
    var matchValues = [];
    if (Ext.isString(this.matchExact)) {
      matchValues = this.matchExact.split(',');
      matchValues = matchValues.map(function(s) {
        if (Ext.isString(s)) {
          return parseInt(s);
        }
      });
    } else {
      if (Ext.isNumber(this.matchExact)) {
        matchValues = [this.matchExact];
      }
    }
    valid = matchValues.indexOf(val.length) !== -1;
  }
  return valid;
}, additionalTooltipInfo:{}, addTooltip:function() {
  var isRemote = this.getXType() === 'mpmPostCombo';
  var tooltip = {DTO:this.name, XType:this.getXType(), Remote:isRemote, LabelKey:this.trLabelKey};
  if (this._initValue) {
    tooltip.InitValue = this._initValue;
    tooltip.CalcValue = this._translatedValue;
    tooltip.Dictionary = this._dictionary;
  }
  tooltip = Ext.apply(tooltip, this.additionalTooltipInfo);
  var tooltipHidden = false;
  var isAdmin = this.task && this.task.mpmModuleId ? BpcCommon.Api.hasUserAnyRole(BpcCommon.Api.getSetting(this.task.mpmModuleId, 'mpmDebugRole')) : false;
  if (!isAdmin) {
    tooltip = {};
    if (this.task) {
      var tooltips = BpcCommon.Api.getSetting(this.task.mpmModuleId, 'tooltips') || {};
      var key = this.name || '';
      var value = '';
      if (tooltips[key.toUpperCase()]) {
        value = tooltips[key.toUpperCase()];
        tooltip = {Info:value};
      } else {
        tooltipHidden = true;
      }
    } else {
      tooltipHidden = true;
    }
  }
  var tooltipHtml = mpm.Support.objectToHtmlTable(tooltip);
  if (isRemote && isAdmin) {
    tooltipHtml += '\x3cbr\x3ePARAMETERS:\x3cbr/\x3e' + mpm.Support.objectToHtmlTable(this.store.getProxy().getExtraParams() || {});
  }
  if (this.formatInfo && this.formatInfo.length) {
    tooltipHtml += '\x3cbr\x3eHINWEISE:\x3cbr/\x3e' + mpm.Support.objectToHtmlTable({FORMAT:this.formatInfo});
  }
  this._tooltip = !tooltipHidden ? Ext.create('Ext.tip.ToolTip', {target:this.id, hidden:tooltipHidden, html:tooltipHtml}) : undefined;
}, emptyText:' - ', fieldStyle:'background-color:#f7f7ec;', applyReadOnlyStyle:function() {
  if (this.readOnly) {
    this.setFieldStyle({backgroundColor:'#f7f7ec7d'});
  }
}, listeners:{afterrender:function(field) {
  field.addTooltip();
  if (field.icon) {
    field.setFieldLabelWithIconCls(field.fieldLabel, field.icon);
  }
}, beforerender:function(field) {
  if (field.task) {
    var hidden = field.task.isFieldDefinedAsHidden(field.name);
    if (hidden) {
      field.setVisible(!hidden);
    }
  }
}}, notify:function(txt, params, level) {
  params = params === void 0 ? {} : params;
  level = level === void 0 ? 'i' : level;
  params.level = level;
  this.task.notify(txt, level, Ext.apply({}, params));
}, trLabelKey:'-1', initFieldLabel:function(labelLegacy) {
  var translationDefinition = {set:'hard', key:'', value:'', fieldName:undefined, notes:'', sliceLabelPrefix:this.sliceLabelPrefix, editable:false};
  if (this.fieldLabel) {
    Ext.log('fieldLabel set by config: ' + this.fieldLabel + ' for ' + this.name);
    translationDefinition.value = this.fieldLabel;
    translationDefinition.notes += this.name;
  } else {
    var keys = BpcCommon.Api.getSetting('mpm', 'customLanguageKeys');
    if (keys && keys[this.name]) {
      this.fieldLabel = keys[this.name]['de'];
      translationDefinition.notes = 'hard de value picked';
      translationDefinition.set = 'customLanguageKeys';
    } else {
      translationDefinition.set = 'generated';
      var dtoField = labelLegacy || this.name, label = dtoField || '';
      if (this.sliceLabelPrefix) {
        label = label.replace(this.sliceLabelPrefix, '');
        translationDefinition.notes = 'sliced';
      }
      var trKey = label.toUpperCase();
      var translated = mpm.Support.TR('DTO_' + trKey);
      if (translated === 'MPM_DTO_' + trKey) {
        translationDefinition.notes += ' - untranslated';
        translationDefinition.editable = true;
        translationDefinition.key = translated;
        label = label.trim();
        label = label.toLowerCase();
        label = mpm.Support.capitalizeFirstLetter(label);
      } else {
        translationDefinition.notes += ' - translated';
        label = translated;
        this.trLabelKey = 'MPM_DTO_' + trKey;
      }
      this.fieldLabel = mpm.Support.capitalizeFirstLetter(label);
    }
  }
  if (this.task) {
    this.task.translationDebug.push(translationDefinition);
  }
}, iconOnly:undefined, setFieldLabelWithIconCls:function(label, icon) {
  label = label || '';
  var me = this, separator = me.labelSeparator, labelEl = me.labelEl, errorWrapEl = me.errorWrapEl, sideLabel = me.labelAlign !== 'top', noLabelCls = me.noLabelCls, errorWrapUnderSideLabelCls = me.errorWrapUnderSideLabelCls;
  label = mpm.Support.getSpanForIconCls(mpm.Support.icon(icon), '#000') + '\x26nbsp;' + (this.iconOnly ? '' : label);
  me.fieldLabel = label;
  if (me.rendered) {
    if (Ext.isEmpty(label) && me.hideEmptyLabel) {
      me.addCls(noLabelCls);
      if (sideLabel && errorWrapEl) {
        errorWrapEl.removeCls(errorWrapUnderSideLabelCls);
      }
    } else {
      if (separator) {
        label = me.trimLabelSeparator() + separator;
      }
      me.labelTextEl.dom.innerHTML = label;
      me.removeCls(noLabelCls);
      if (sideLabel && errorWrapEl) {
        errorWrapEl.addCls(errorWrapUnderSideLabelCls);
      }
    }
    me.updateLayout();
  }
}, _initValue:undefined, _dictionary:undefined, _translatedValue:undefined, translateValue:function(value, matchingKeyInSettings) {
  this._initValue = value;
  this._dictionary = matchingKeyInSettings + ' - InstanceId: ' + this.task.mpmModuleId;
  var data = BpcCommon.Api.getSetting(this.task.mpmModuleId, matchingKeyInSettings) || [];
  var match = data.filter(function(obj) {
    return obj.key === value;
  });
  this._translatedValue = match.length ? match[0].value : value;
  return this._translatedValue;
}});
Ext.define('mpm.tasks.components.combo.DictionaryCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.mpmDictionaryCombo'], mixins:['mpm.components.mixins.Fields'], emptyText:mpm.Support.TR('PLEASE_CHOOSE'), valueField:'key', displayField:'value', queryMode:'local', fieldLabel:undefined, dataKey:undefined, name:undefined, dto:undefined, task:undefined, hideKey:false, initComponent:function() {
  this.initFieldLabel();
  this.additionalTooltipInfo = {dataKeySetByName:false};
  if (!Ext.isDefined(this.dataKey)) {
    this.dataKey = this.name;
    this.additionalTooltipInfo.dataKeySetByName = true;
  }
  this.additionalTooltipInfo.dataKey = this.dataKey;
  var value = this.dto ? this.dto[this.name] : undefined;
  this.setValueDeferred = Ext.isDefined(value);
  this.deferredValue = value;
  var data = this.dictionaryItemFromWorkflow() || mpm.Support.getDictionary(this.dataKey) || [];
  var mpmModuleId = this.task ? this.task.mpmModuleId : undefined;
  this.store = mpm.util.Store.newLocalStore(mpm.Support.dicToDisplayData(data, mpmModuleId, this.hideKey));
  this.callParent(arguments);
  this.handleReadOnlyEmptyText();
  this.applyReadOnlyStyle();
}, dictionaryItemFromWorkflow:function() {
  var $jscomp$destructuring$var11 = (this.task || {}).isConfig || {};
  var meta = $jscomp$destructuring$var11.meta;
  var $jscomp$destructuring$var12 = meta || {};
  var dictionary = $jscomp$destructuring$var12.dictionary;
  if (dictionary && !Array.isArray(dictionary)) {
    return dictionary[this.dataKey];
  }
}});
Ext.define('mpm.tasks.components.combo.PostRequestCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.mpmPostCombo'], mixins:['mpm.components.mixins.Fields'], emptyText:mpm.Support.TR('PLEASE_CHOOSE'), valueField:'ID', displayField:'NAME', pageSize:50, minChars:1, params:undefined, task:undefined, isId:false, forceIdLoading:false, matchExact:undefined, value:undefined, initComponent:function() {
  var $jscomp$this = this;
  var dtoField = this.name, label = dtoField || '';
  if (this.sliceLabelPrefix) {
    label = label.replace(this.sliceLabelPrefix, '');
  }
  label = label.trim();
  label = label.toLowerCase();
  this.initFieldLabel(label);
  var dtoValue = this.dto[dtoField];
  if (!Ext.isDefined(this.value)) {
    this.value = dtoValue;
  }
  var loadSingleId = this.isId !== true;
  var meta = this.task.isConfig.meta || {};
  var url = mpm.Support.getWorkflowUrl(this.task.mpmModuleId, meta.process ? meta.process["package"] : this.task.tabPrefix ? this.task.tabPrefix : 'mpmCatchAll');
  this.notify('URL SET FOR FIELD: ' + (this.name || ' -1') + ' -\x3e ' + url, undefined, 'd');
  var autoLoad = this.hidden ? false : loadSingleId;
  if (!autoLoad) {
    this.notify('STORE AUTOLOAD FOR FIELD: ' + (this.name || ' -1') + ' -\x3e ' + autoLoad, undefined, 'd');
  }
  this.store = Ext.create('Ext.data.Store', {proxy:{actionMethods:{create:'POST', read:'POST', update:'POST', destroy:'POST'}, type:'ajax', url:url, reader:{type:'json', rootProperty:'data'}, extraParams:this.params || {}}, _component:this, listeners:{load:function(store, records, successful, operation, eOpts) {
    if (successful) {
    } else {
      $jscomp$this.setRawValue($jscomp$this.value);
      $jscomp$this.notify('Fehler beim Laden der Combo: ' + $jscomp$this.name, undefined, 'e');
    }
  }}, autoLoad:autoLoad});
  this.listeners = {select:function(c, r) {
    c.task.validateAndToggle();
  }};
  this.callParent(arguments);
  this.handleReadOnlyEmptyText();
  if (!loadSingleId || this.forceIdLoading) {
    this.addParam('id', dtoValue);
    this.store.load({scope:this, callback:function(records, operation, success) {
      this.removeParam('id');
      if (success) {
        Ext.defer(function() {
          this.task.validateAndToggle();
        }.bind(this), 200);
      }
    }});
  }
  this.enableCopyAndPasteOnDblClick();
  this.applyReadOnlyStyle();
}, validator:function(val) {
  return this.validateValueLength(val);
}, addParam:function(key, value) {
  var p = this.store.getProxy().getExtraParams() || {};
  p[key] = value;
  this.store.getProxy().setExtraParams(p);
}, removeParam:function(key) {
  try {
    var p = this.store.getProxy().getExtraParams() || {};
    if (p[key]) {
      delete p[key];
    }
    this.store.getProxy().setExtraParams(p);
  } catch (e) {
  }
}});
Ext.define('mpm.tasks.components.combo.SettingCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.mpmSettingCombo'], mixins:['mpm.components.mixins.Fields'], emptyText:mpm.Support.TR('PLEASE_CHOOSE'), valueField:'key', displayField:'value', queryMode:'local', dataKey:undefined, dto:{}, moduleId:'mpm', name:undefined, initComponent:function() {
  if (!Ext.isDefined(this.dataKey)) {
    this.dataKey = this.name;
  }
  this.initFieldLabel();
  this.store = mpm.util.Store.newLocalStore(BpcCommon.Api.getSetting(this.task.mpmModuleId, this.dataKey) || []);
  this.value = this.dto[this.name];
  this.callParent(arguments);
  this.handleReadOnlyEmptyText();
  this.applyReadOnlyStyle();
}});
Ext.define('mpm.tasks.components.combo.StaticDataCombo', {extend:'Ext.form.field.ComboBox', alias:['widget.mpmStaticDataCombo'], mixins:['mpm.components.mixins.Fields'], emptyText:mpm.Support.TR('PLEASE_CHOOSE'), valueField:'key', displayField:'value', queryMode:'local', fieldLabel:undefined, dataKey:undefined, customName:undefined, customLabel:undefined, name:undefined, storeData:undefined, initComponent:function() {
  this.initFieldLabel();
  if (!Ext.isDefined(this.dataKey)) {
    this.dataKey = this.name;
  }
  this.value = this.dto[this.name];
  var storeData = this.dataKey && mpm.StaticData[this.dataKey] ? mpm.StaticData[this.dataKey] : [];
  this.store = mpm.util.Store.newLocalStore(this.storeData || storeData);
  this.callParent(arguments);
  this.handleReadOnlyEmptyText();
  this.applyReadOnlyStyle();
}});
Ext.define('mpm.components.field.button', {extend:'Ext.button.Button', alias:'widget.mpmButton', initComponent:function() {
  this.handler = this.onButtonClick.bind(this);
  this.text = this.fieldLabel || '-1';
  this.callParent(arguments);
}, onButtonClick:function() {
  var $jscomp$this = this;
  if (this.task) {
    var url = mpm.Support.getWorkflowUrl(this.task.mpmModuleId, this.task.getItemFromMetaProcess(this.task.isConfig, 'package'));
    var params = {};
    if (this.actionName) {
      params.action = this.actionName;
    }
    var pid = this.task.getItemFromMetaProcess(this.task.isConfig, 'processId');
    if (pid) {
      params.processId = pid;
    }
    params.usecase = this.task.getUseCase() || '-1';
    params.taskId = (this.task.taskMeta || {}).taskId || '-1';
    if (this.submitFields && Ext.isArray(this.submitFields)) {
      this.submitFields.map(function(key) {
        var f = $jscomp$this.task.wrapper.query('[name\x3d' + key + ']');
        return {key:key, value:f.length ? f[0].getValue() : '-1'};
      }).map(function(obj) {
        params[obj.key] = obj.value;
      });
    }
    url = url + '?' + Ext.Object.toQueryString(params);
    if (this.actionName.startsWith('download')) {
      window.open(url, '_blank');
    } else {
      Ext.Ajax.request({url:url, success:function(response) {
        var json = mpm.Support.getResponseObject(response);
        if (json) {
          var o = {html:json.message || '-1', title:json.success ? 'Aktion erfolgreich' : 'Fehler', iconCls:mpm.Support.icon(json.success ? 'fa-check' : 'fa-exclamation-circle')};
          $jscomp$this.showNotification(o);
        } else {
          Ext.toast('ANSWER_UNEXPECTED');
        }
      }, failure:function(response) {
        Ext.toast('error');
      }});
    }
  }
}, showNotification:function(obj) {
  obj = obj === void 0 ? {} : obj;
  obj.anchor = this.task.getInteractionTaskWindow();
  Ext.toast(obj);
}, validate:function() {
  return true;
}});
Ext.define('mpm.components.field.checkbox', {extend:'Ext.form.field.Checkbox', alias:['widget.mpmCheckbox'], mixins:['mpm.components.mixins.Fields'], name:undefined, fieldLabel:undefined, initComponent:function() {
  this.initFieldLabel();
  this.value = this.dto[this.name];
  this.callParent(arguments);
  if (this.noLabel) {
    this.setFieldLabel('');
  }
}, validate:function() {
  if (this.allowBlank === false) {
    this.getValue();
  }
  return this.allowBlank === false ? this.getValue() === true : true;
}});
Ext.define('mpm.components.field.date', {extend:'Ext.form.field.Date', alias:'widget.mpmDatefield', format:'d.m.Y', altFormats:'c|C|time', mixins:['mpm.components.mixins.Fields'], name:undefined, fieldLabel:undefined, initComponent:function() {
  this.initFieldLabel();
  var dtoSourceValue = this.dto[this.name];
  this.additionalTooltipInfo = {rawValue:dtoSourceValue || '', isISO:this.isIsoDate(dtoSourceValue)};
  this.value = dtoSourceValue;
  this.callParent(arguments);
  this.applyReadOnlyStyle();
}, isIsoDate:function(val) {
  try {
    return Ext.isDate(Ext.Date.parse(val, 'c'));
  } catch (e) {
    return false;
  }
}});
Ext.define('mpm.components.field.text', {extend:'Ext.form.field.Text', alias:'widget.mpmTextfield', mixins:['mpm.components.mixins.Fields'], name:undefined, sliceLabelPrefix:undefined, dto:{}, trMatch:undefined, matchExact:undefined, hardCodedValue:undefined, useAsTriggerIcon:undefined, customFieldValidations:[], formatInfo:'', validator:function(val) {
  var lengthValidation = this.validateValueLength(val);
  var customValidation = this.customFieldValidations.length <= 0;
  if (this.customFieldValidations.length) {
    var customValidationResults = this.customFieldValidations.map(function(regExStr) {
      var r = new RegExp(regExStr);
      return r.test(val || '');
    });
    customValidation = customValidationResults.length === 1 ? customValidationResults[0] : customValidationResults.indexOf(true) !== -1;
  }
  return lengthValidation && customValidation;
}, initComponent:function() {
  var $jscomp$this = this;
  this.initFieldLabel();
  this.value = this.hardCodedValue ? this.hardCodedValue : this.applyValueFromDto();
  this.triggers = {};
  if (this.formatInfo && this.formatInfo.length) {
    this.emptyText = this.formatInfo;
  }
  this.callParent(arguments);
  this.on('change', this.onFieldValueChange.bind(this));
  if (!this.readOnly) {
    this.setTriggers({reset:{cls:this.determineTriggerIconCls(), hidden:(this.getValue() || '').length === 0, handler:function() {
      $jscomp$this.setValue(undefined);
    }}});
  }
  this.enableCopyAndPasteOnDblClick();
  this.applyReadOnlyStyle();
}, determineTriggerIconCls:function() {
  return mpm.Support.icon(this.useAsTriggerIcon ? this.iconCls : 'times');
}, applyValueFromDto:function() {
  return this.trMatch ? this.translateValue(this.dto[this.name], this.trMatch) : this.dto[this.name];
}, onFieldValueChange:function(field, newVal) {
  var t = this.getTrigger('reset');
  if (t) {
    t.setVisible(newVal && newVal.length > 0);
  }
}});
Ext.define('mpm.components.field.textarea', {extend:'Ext.form.field.TextArea', alias:'widget.mpmTextarea', mixins:['mpm.components.mixins.Fields'], name:undefined, sliceLabelPrefix:undefined, dto:undefined, initComponent:function() {
  this.initFieldLabel();
  this.value = this.dto[this.name];
  this.callParent(arguments);
  this.enableCopyAndPasteOnDblClick();
  this.applyReadOnlyStyle();
}});
Ext.define('mpm.components.fieldcontainer.AnswerPanel', {extend:'Ext.form.FieldContainer', alias:'widget.mpmAnswerPanel', defaultType:'radiofield', layout:'vbox', _values:[], _name:undefined, task:undefined, selectionHolder:undefined, hideEmpty:undefined, initComponent:function() {
  this.items = this._values.map(function(i) {
    return i;
  });
  if (this.hideEmpty && this.items.length === 0) {
    this.hidden = true;
  }
  this.defaults = {flex:1, skipValue:true, task:this.task, name:this._name, listeners:{change:function(field, newValue, oldValue, eOpts) {
    field.task.validateAndToggle();
  }}};
  this.callParent(arguments);
}, resetFields:function() {
  if (this.selectionHolder) {
    this.selectionHolder.resetConditionalFields();
  }
  this.query(this.defaultType).map(function(f, index) {
    var value = f.hardCodedValue ? f.hardCodedValue : f.mpmValidation ? '' : false;
    f.setValue(value);
  });
}});
Ext.define('mpm.tasks.components.messageView.Base', {extend:'Ext.panel.Panel', layout:'fit', padding:'10 10 10 10', header:false, getParams:function() {
  return Ext.applyIf({data:'file', format:this.type, referenz:this.referenceId}, this.process);
}, loaded:false, initComponent:function() {
  this.loadingPanel = Ext.create({xtype:'mpmLoadingPanel'});
  this.loadingPanel.setMessage('MPM Message viewer', 'fa-file');
  this.items = [this.loadingPanel];
  this.callParent(arguments);
}, loadData:function() {
  var $jscomp$this = this;
  if (this.loaded === false) {
    this.loadingPanel.setMessage(mpm.Support.TR('LOADING'), 'fa-sync');
    return this.fetchData().then(function(json) {
      if (json && json.success) {
        $jscomp$this.loaded = true;
        $jscomp$this.handleResponse(json);
      } else {
        $jscomp$this.showError(json);
      }
    }, function(error) {
      $jscomp$this.showError({msg:'ERROR OCCURED WHILE TRYING TO LOAD THE MESSAGE DATA'});
    });
  }
}, fetchData:function() {
  return mpm.Support.request(mpm.Support.getWorkflowUrl(this.mpmModuleId, this.process["package"]), this.getParams(), this.mpmModuleId).then(function(r) {
    return Ext.decode(r.responseText, true);
  }, function(error) {
    return error;
  });
}, showError:function(json) {
  json = json === void 0 ? {error:'called without json'} : json;
  this.removeAll();
  var jsonString = JSON.stringify(json, undefined, 4);
  this.add({xtype:'textarea', fieldLabel:'ERROR', value:jsonString});
  BpcCommon.Api.showNotification('MPM_ERROR_OCCURED: ' + jsonString);
}, handleResponse:function(json) {
  Ext.log({dump:json, msg:'PLEASE IMPLEMENT IN YOUR CUSTOM VIEWER'});
}, setLoadReference:function(id) {
  this.referenceId = id;
}});
Ext.define('mpm.tasks.components.messageView.HTML', {extend:'mpm.tasks.components.messageView.Base', alias:'widget.mpmMessageViewerHtml', layout:'fit', type:'html', scrollable:'y', handleResponse:function(json) {
  json = json === void 0 ? {} : json;
  this.removeAll();
  var html = json.data ? json.data : '';
  this.add({xtype:'container', html:html});
}});
Ext.define('mpm.tasks.components.messageView.Text', {extend:'mpm.tasks.components.messageView.Base', alias:'widget.mpmMessageViewerText', layout:'fit', type:'text', handleResponse:function(json) {
  var $jscomp$this = this;
  this.removeAll();
  var $jscomp$destructuring$var13 = json || {};
  var data = $jscomp$destructuring$var13.data;
  var $jscomp$destructuring$var14 = data;
  var REFFILE = $jscomp$destructuring$var14.REFFILE;
  var $jscomp$destructuring$var15 = REFFILE || {};
  var DATA = $jscomp$destructuring$var15.DATA;
  var html = DATA || '';
  var ediViewer = Ext.create({xtype:'container', padding:'10 10 10 10', scrollable:'y'});
  var expandBtn = {iconCls:mpm.Support.icon('fa-columns'), base64:html, textView:this, mode:'raw', text:'Tabellenansicht', tooltip:'Nachricht in Tabelle darstellen', handler:function(btn) {
    var beauify = btn.mode === 'raw';
    btn.mode = beauify ? 'beautify' : 'raw';
    btn.setIconCls(mpm.Support.icon(beauify ? 'fa-file-code' : 'fa-columns'));
    btn.setTooltip(beauify ? 'Nachricht als Text darstellen' : 'Nachricht in Tabelle darstellen');
    ediViewer.update(btn.textView.base64ToEdi(btn.base64, beauify));
  }};
  var messageParser = {componentSeparator:':', elementSeparator:'+', decimelSeparator:'.', releaseIndicator:'?', spaceIndicator:' ', segmentTerminator:"'"};
  var displayFields = [];
  this.add({xtype:'panel', layout:'fit', header:false, tbar:[expandBtn, {iconCls:mpm.Support.icon('fa-copy'), text:'Nachricht kopieren', task:this.task, rawData:html, scope:this, handler:function(b) {
    if (mpm.Support.copyToClipBoard($jscomp$this.base64ToEdi(b.rawData, false, true).replace(/'/g, "'\r\n"), b)) {
      BpcCommon.Api.showNotification(mpm.Support.TR('MESSAGE_COPIED_TO_CLIPBOARD'));
    }
  }}, {xtype:'tbfill'}].concat(displayFields), items:[ediViewer]});
  if (html.length) {
    ediViewer.update(this.base64ToEdi(html));
  }
}, base64ToEdi:function(base64, beautify, asText) {
  var s = atob(base64);
  var lines = s.split("'").filter(function(line) {
    return line.trim().length;
  });
  var UNH = lines.filter(function(s) {
    return s.startsWith('UNH');
  });
  if (UNH.length) {
    var lineReverse = (UNH[0] || '').split('+').reverse();
    if (lineReverse.length) {
      var messsageMeta = lineReverse[0].split(':').map(function(s, index) {
        return {value:s, index:index};
      });
      this.viewer.notificationField.update('Nachrichtentyp:  ' + messsageMeta.map(function(o) {
        return o.value;
      }).join(' : '));
    }
  }
  if (asText) {
    return lines.join("'");
  }
  var helper = lines.map(function(line) {
    return line.split('+');
  });
  var elemCountMax = 0;
  helper.map(function(array) {
    if (array.length > elemCountMax) {
      elemCountMax = array.length;
    }
  });
  var lengths = {};
  helper.map(function(array) {
    array.map(function(string, index) {
      var strIndex = '' + index;
      if (Ext.isDefined(lengths[strIndex])) {
        if (string.length > lengths[strIndex]) {
          lengths[strIndex] = string.length;
        }
      } else {
        lengths[strIndex] = string.length === 0 ? 5 : string.length;
      }
    });
  });
  var html = '';
  if (beautify) {
    var header = '';
    for (var i = 0; i < elemCountMax; i++) {
      header += i + (elemCountMax - 1 > i ? '+' : '');
    }
    var spacer = '';
    for (var i = 0; i < elemCountMax; i++) {
      spacer += elemCountMax - 1 > i ? '+' : '';
    }
    lines = [header].concat([spacer]).concat(lines);
  }
  lines.map(function(line, index) {
    var isHeader = ['UNB', 'UNZ'].indexOf(line.split('+')[0]) !== -1;
    var isMessage = ['UNH', 'UNT'].indexOf(line.split('+')[0]) !== -1;
    html += '\x3cspan style\x3d"width: 30px;display: inline-block; color: #444;"\x3e' + (beautify ? index <= 1 ? '' : index - 1 : index + 1) + '\x3c/span\x3e' + '\x3cspan style\x3d"width: 30px;display: inline-block; background-color: ' + (isHeader ? 'darkblue' : isMessage ? 'lightblue' : beautify ? index <= 1 ? 'white' : 'lightcyan' : 'lightcyan') + ';"\x3e\x26nbsp;\x3c/span\x3e' + '\x3cspan style\x3d"width: 10px;display: inline-block;"\x3e\x26nbsp;\x3c/span\x3e';
    if (beautify) {
      var elemsPerLine = line.split('+');
      if (elemCountMax !== elemsPerLine.length) {
        var items = elemCountMax - elemsPerLine.length;
        for (var i = 0; i < items; i++) {
          elemsPerLine.push('');
        }
      }
      elemsPerLine.map(function(elem, index) {
        html += '\x3cspan style\x3d"text-align:center; width:' + lengths[index] * (lengths[index] > 30 ? 3 : 10) + 'px;display: inline-block;background-color: ' + (index & 1 ? '#888' : '#999') + '"\x3e' + (elem.length === 0 ? '\x26nbsp;' : elem) + '\x3c/span\x3e';
      });
      html += '\x3cbr/\x3e';
    } else {
      html += '\x3cspan\x3e' + line + "\x3c/span\x3e'\x3cbr/\x3e";
    }
  });
  return html;
}});
Ext.define('mpm.tasks.components.messageView.Tree', {extend:'mpm.tasks.components.messageView.Base', alias:'widget.mpmMessageViewerTree', type:'tree', handleResponse:function(json) {
  this.removeAll();
  var $jscomp$destructuring$var16 = json || {};
  var data = $jscomp$destructuring$var16.data;
  var $jscomp$destructuring$var17 = data;
  var EDITREE = $jscomp$destructuring$var17.EDITREE;
  var ERRORS = $jscomp$destructuring$var17.ERRORS;
  var $jscomp$destructuring$var18 = EDITREE || {};
  var DATA = $jscomp$destructuring$var18.DATA;
  var errorData = (ERRORS || {}).DATA || [];
  var errorType = (ERRORS || {}).ERRORTYPE || ' - ';
  var store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:DATA || []}});
  var path = Ext.create({xtype:'button'});
  var info = Ext.create({xtype:'button'});
  var treepanel = Ext.create({pathButton:path, infoButton:info, xtype:'mpmTreepanel', store:store});
  var expandBtn = Ext.create({xtype:'button', iconCls:mpm.Support.icon('chevron-square-right'), mode:'expand', treepanel:treepanel, handler:function(btn) {
    if (btn.mode === 'expand') {
      btn.treepanel.collapseAll();
      btn.mode = 'collapse';
      btn.setIconCls(mpm.Support.icon('chevron-square-up'));
    } else {
      btn.treepanel.expandAll();
      btn.mode = 'expand';
      btn.setIconCls(mpm.Support.icon('chevron-square-right'));
    }
  }});
  var panel = Ext.create({xtype:'panel', tbar:[expandBtn, {iconCls:mpm.Support.icon('fa-code-branch')}, path, {xtype:'tbfill'}, info], layout:'fit', flex:3, items:[treepanel]});
  var errorGrid = Ext.create({xtype:'grid', margin:'5 5 5 5', store:mpm.util.Store.newLocalStore(errorData), title:'Fehler: ' + errorType, viewConfig:{emptyText:'keine Fehler'}, header:false, _treePanel:treepanel, listeners:{rowclick:function(tableView, record) {
    var pathString = record.get('xpath');
    var pathParts = pathString.split('/');
    pathParts = pathParts.filter(function(str) {
      return str.length;
    });
    var pathObjects = pathParts.map(function(name) {
      var nodeNum = undefined, identifier = undefined;
      if (name.endsWith(']')) {
        var elems = name.split('[');
        identifier = elems[0].trim();
        nodeNum = elems[1].replace(']', '').trim();
      } else {
        identifier = name;
      }
      return {raw:name, identifier:identifier, identifierLowercase:identifier.toLowerCase(), nodeNum:nodeNum, record:undefined};
    });
    var grid = tableView.up('grid');
    var targetStore = grid._treePanel.store;
    var pathRecords = pathObjects.map(function(item) {
      if (item.identifier) {
        targetStore.each(function(rec) {
          var text = rec.get('text');
          text = text.toLowerCase();
          if (text === item.identifierLowercase) {
            item.record = rec;
          }
        });
      }
      return item;
    });
    if (pathRecords[pathRecords.length - 1] && pathRecords[pathRecords.length - 1].record) {
      grid._treePanel.getSelectionModel().select(pathRecords[pathRecords.length - 1].record);
    }
  }.bind(this)}, columns:[{dataIndex:'pseudoId', text:'ID', width:40}, {dataIndex:'qualifier', text:'Qualifier', width:60}, {dataIndex:'msg', flex:1, text:'Message'}, {dataIndex:'xpath', hidden:true}], flex:2});
  var error = Ext.create({xtype:'button', iconCls:mpm.Support.icon('fa-warning')});
  this.add({xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[panel, Ext.create({xtype:'panel', tbar:[error], layout:'fit', flex:2, items:[errorGrid]})]});
  path.setText('Keine Auswahl');
  var storeCount = errorGrid.getStore().getCount();
  error.setText((storeCount === 0 ? 'Keine' : storeCount) + ' Fehler');
  error.setIconCls(mpm.Support.getBpcIconCls(storeCount === 0 ? 'fa-check-square' : 'fa-warning'));
}});
Ext.define('mpm.move.TreeErrorPanel', {extend:'Ext.panel.Panel', alias:'widget.mpmTreeErrorPanel', type:'tree', handleResponse:function(json) {
  this.removeAll();
  var html = item && item.EDITREE && item.EDITREE.DATA ? item.EDITREE.DATA : [];
  var childItem = item;
  var store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:html}});
  var path = Ext.create({xtype:'button'});
  var info = Ext.create({xtype:'button'});
  var treepanel = Ext.create({pathButton:path, infoButton:info, xtype:'mpmTreepanel', store:store});
  var expandBtn = Ext.create({xtype:'button', iconCls:mpm.Support.icon('chevron-square-right'), mode:'expand', treepanel:treepanel, handler:function(btn) {
    if (btn.mode === 'expand') {
      btn.treepanel.collapseAll();
      btn.mode = 'collapse';
      btn.setIconCls(mpm.Support.icon('chevron-square-up'));
    } else {
      btn.treepanel.expandAll();
      btn.mode = 'expand';
      btn.setIconCls(mpm.Support.icon('chevron-square-right'));
    }
  }});
  var panel = Ext.create({xtype:'panel', tbar:[expandBtn, {iconCls:mpm.Support.icon('fa-code-branch')}, path, {xtype:'tbfill'}, info], layout:'fit', flex:3, items:[treepanel]});
  var errorGrid = Ext.create({xtype:'grid', margin:'5 5 5 5', store:mpm.util.Store.newLocalStore(childItem && childItem.ERRORS && childItem.ERRORS.DATA ? childItem.ERRORS.DATA : []), title:'Fehler: ' + (childItem && childItem.ERRORS && childItem.ERRORS.ERRORTYPE ? childItem.ERRORS.ERRORTYPE : ' - '), viewConfig:{emptyText:'keine Fehler'}, header:false, _treePanel:treepanel, listeners:{rowclick:function(tableView, record) {
    var pathString = record.get('xpath');
    var pathParts = pathString.split('/');
    pathParts = pathParts.filter(function(str) {
      return str.length;
    });
    var pathObjects = pathParts.map(function(name) {
      var nodeNum = undefined, identifier = undefined;
      if (name.endsWith(']')) {
        var elems = name.split('[');
        identifier = elems[0].trim();
        nodeNum = elems[1].replace(']', '').trim();
      } else {
        identifier = name;
      }
      return {raw:name, identifier:identifier, identifierLowercase:identifier.toLowerCase(), nodeNum:nodeNum, record:undefined};
    });
    var grid = tableView.up('grid');
    var targetStore = grid._treePanel.store;
    var pathRecords = pathObjects.map(function(item) {
      if (item.identifier) {
        targetStore.each(function(rec) {
          var text = rec.get('text');
          text = text.toLowerCase();
          if (text === item.identifierLowercase) {
            item.record = rec;
          }
        });
      }
      return item;
    });
    if (pathRecords[pathRecords.length - 1] && pathRecords[pathRecords.length - 1].record) {
      grid._treePanel.getSelectionModel().select(pathRecords[pathRecords.length - 1].record);
    }
  }.bind(this)}, columns:[{dataIndex:'pseudoId', text:'ID', width:40}, {dataIndex:'qualifier', text:'Qualifier', width:60}, {dataIndex:'msg', flex:1, text:'Message'}, {dataIndex:'xpath', hidden:true}], flex:2});
  var error = Ext.create({xtype:'button', iconCls:mpm.Support.icon('fa-warning')});
  this.add({xtype:'container', layout:{type:'hbox', align:'stretch'}, items:[panel, Ext.create({xtype:'panel', tbar:[error], layout:'fit', flex:2, items:[errorGrid]})]});
  path.setText('Keine Auswahl');
  var storeCount = errorGrid.getStore().getCount();
  error.setText((storeCount === 0 ? 'Keine' : storeCount) + ' Fehler');
  error.setIconCls(mpm.Support.getBpcIconCls(storeCount === 0 ? 'fa-check-square' : 'fa-warning'));
}});
Ext.define('mpm.components.mixins.ActionButtons', {actionButtons:undefined, showActionButtons:function(visible) {
  visible = visible === void 0 ? true : visible;
  if (this.actionButtons) {
    this.actionButtons.map(function(b) {
      if (b && !b.destroyed) {
        b.setVisible(visible);
      }
    });
  }
}, setActionButtonsDisabled:function(disabled) {
  if (this.actionButtons) {
    this.actionButtons.map(function(b) {
      if (b && !b.destroyed) {
        b.setDisabled(disabled);
      }
    });
  }
}});
Ext.define('mpm.components.moduleConfigurationComponents.InstanceEditor', {extend:'Ext.container.Container', alias:'widget.mpmAdminMain', layout:'fit', padding:'5 5 5 5', moduleId:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.rootTabpanel = Ext.create({xtype:'tabpanel', items:[]});
  var defaults = {moduleId:this.moduleId};
  var settings = Ext.create(Ext.apply({xtype:'mpmJsonSettings'}, defaults));
  this.rootTabpanel.add(settings);
  this.rootTabpanel.add({xtype:'mpmTranslations'});
  var dictionary = BpcCommon.Api.getSetting(this.moduleId, 'dictionary');
  if (dictionary && Ext.isObject(dictionary)) {
    var grids = Object.keys(dictionary).map(function(itemName) {
      var storedata = JSON.stringify(dictionary[itemName]);
      storedata = JSON.parse(storedata);
      return {xtype:'grid', columns:[{dataIndex:'key'}, {dataIndex:'value'}].map(function(i) {
        i.flex = 1;
        return i;
      }), title:itemName + ' - ' + storedata.length, store:storedata, dictionaryKey:itemName};
    });
    var item = Ext.create({xtype:'panel', scrollable:true, title:'Dictionary' + ' - ' + grids.length, iconCls:mpm.Support.icon('fa-spell-check'), layout:{type:'vbox', align:'stretch'}, dockedItems:[{xtype:'toolbar', dock:'top', overflowHandler:'menu', items:grids.map(function(g) {
      return {text:g.title};
    })}], items:grids, bbar:[{text:'Werte einspielen', handler:function(b) {
      Ext.create('Ext.window.Window', {title:'JsonString to Dictionary Converter', height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.4, layout:'fit', bbar:[{xtype:'tbfill'}, {text:'Auswahl übernehmen', targetBtn:b, handler:function(submitBtn) {
        var jsonArrayObjString = submitBtn.up('window').down('textarea').getValue();
        jsonArrayObjString = jsonArrayObjString.replaceAll("'", '"');
        var jsonArray = JSON.parse(jsonArrayObjString);
        var data = jsonArray.map(function(array) {
          return {key:array[0] || '-1', value:array[1] || '-1'};
        });
        var itemToApply = {key:submitBtn.up('window').down('textfield').getValue(), value:data};
        Ext.log({dump:itemToApply, msg:'itemToApply'});
        $jscomp$this.addToDictionary(itemToApply);
      }}], items:[{xtype:'container', scrollable:true, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'textfield', fieldLabel:'Dictionary Name'}, {xtype:'textarea', flex:1, fieldLabel:'JSON', grow:true}]}]}).show();
    }}, {xtype:'tbfill'}, {text:'Speichern'}]});
    this.rootTabpanel.add(item);
  }
  this.items = [this.rootTabpanel];
  this.rootTabpanel.setActiveTab(0);
  this.callParent(arguments);
}, addToDictionary:function(oToAdd) {
  var setting = BpcCommon.Api.getSetting(this.moduleId, 'dictionary', true);
  var obj = setting.get('value') || {};
  if (oToAdd.key in obj) {
  } else {
    obj[oToAdd.key] = oToAdd.value;
  }
  setting.save();
}});
Ext.define('mpm.components.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.mpmConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-database'));
  this.setTitle(mpm.Support.TR('MPM_ADMIN'));
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var webtsmCacheMain = Ext.create({xtype:'mpmAdminMain', moduleId:record.get('moduleId')});
  this.settingsWrapper.add(webtsmCacheMain);
}});
Ext.define('mpm.components.moduleConfigurationComponents.Settings', {extend:'Ext.panel.Panel', alias:'widget.mpmJsonSettings', title:'Settings Editor', layout:{type:'vbox', align:'stretch'}, autoScroll:true, moduleId:undefined, settingKeys:['counter_status_quality', 'identifikationslogik'], initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = mpm.Support.icon(mpm.Support.keys.icons.edit);
  this.items = this.settingKeys.map(function(settingName) {
    return $jscomp$this.getEditorForSettingName(settingName);
  });
  this.callParent(arguments);
}, getEditorForSettingName:function(name) {
  var settingModel = BpcCommon.Api.getSetting(this.moduleId, name, true);
  var settingValue = BpcCommon.Api.getSetting(this.moduleId, name) || [];
  return {xtype:'fieldset', title:name, layout:'center', items:[{xtype:'grid', width:'80%', settingModel:settingModel, moduleId:this.moduleId, settingName:name, height:250, store:mpm.util.Store.newLocalStore(settingValue), plugins:{cellediting:{clicksToEdit:1}}, selModel:'cellmodel', columns:[{dataIndex:'key', text:mpm.Support.TR('KEY'), flex:1, editor:{completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}}}, {dataIndex:'value', text:mpm.Support.TR('VALUE'), flex:1, editor:{completeOnEnter:false, 
  field:{xtype:'textfield', allowBlank:false}}}, {xtype:'actioncolumn', width:90, items:[{iconCls:mpm.Support.getBpcIconCls(mpm.Support.keys.icons.copy), tooltip:mpm.Support.TR('CLONE'), handler:function(grid, rowIndex, colIndex) {
    var r = grid.getStore().getAt(rowIndex);
    grid.store.add({key:r.get('key'), value:r.get('value')});
  }.bind(this)}, {iconCls:mpm.Support.getBpcIconCls(mpm.Support.keys.icons.remove), tooltip:mpm.Support.TR('DELETE'), handler:function(grid, rowIndex, colIndex) {
    var rec = grid.getStore().removeAt(rowIndex);
  }}]}], bbar:[{iconCls:mpm.Support.getBpcIconCls(mpm.Support.keys.icons.add), text:mpm.Support.TR('ADD')}, {xtype:'tbfill'}, {text:mpm.Support.TR('SAVE'), iconCls:mpm.Support.getBpcIconCls(mpm.Support.keys.icons.save), handler:function(b) {
    var grid = b.up('grid');
    var settingValue = [];
    grid.store.each(function(r) {
      settingValue.push({key:r.get('key'), value:r.get('value')});
    });
    grid.settingModel.data.value = settingValue;
    grid.settingModel.save({failure:function(record, operation) {
      BpcCommon.Api.showNotification('Setting update error');
    }, success:function(record, operation) {
      BpcCommon.Api.showNotification('Setting updated successfully');
    }, callback:function(record, operation, success) {
      grid.store.removeAll();
      var storeData = BpcCommon.Api.getSetting(grid.moduleId, grid.settingName) || [];
      grid.store.add(storeData);
    }});
  }}]}]};
}});
Ext.define('mpm.components.moduleConfigurationComponents.TranslationsNew', {extend:'Ext.panel.Panel', alias:'widget.mpmTranslations', layout:'fit', title:'TR', initComponent:function() {
  var $jscomp$this = this;
  this.callParent(arguments);
  this.trGrid = this.add({xtype:'grid', store:mpm.util.Store.newLocalStore(), selModel:'cellmodel', plugins:{cellediting:{clicksToEdit:1}}, tbar:[{text:'Show Missing Translations', handler:function() {
    var map = mpm.util.TR.getMissingTranslations() || {};
    var data = Object.keys(map).map(function(key) {
      return {key:key, de:'', en:''};
    });
    $jscomp$this.trGrid.store.removeAll();
    $jscomp$this.trGrid.store.add(data);
  }}, {xtype:'tbfill'}, {text:'Export', iconCls:mpm.Support.icon('fa-file-export'), handler:function() {
    var exportData = [];
    $jscomp$this.trGrid.store.each(function(r) {
      var $jscomp$destructuring$var19 = r.getData();
      var key = $jscomp$destructuring$var19.key;
      var de = $jscomp$destructuring$var19.de;
      var en = $jscomp$destructuring$var19.en;
      exportData.push({key:key, de:de, en:en});
    });
    var items = [];
    var de_data = exportData.filter(function(item) {
      return (item.de || '').length > 0;
    }).map(function(item) {
      var $jscomp$destructuring$var20 = item;
      var key = $jscomp$destructuring$var20.key;
      var de = $jscomp$destructuring$var20.de;
      var value = de || '';
      return '"' + key + '" : "' + value + '"';
    });
    var en_data = exportData.filter(function(item) {
      return (item.en || '').length > 0;
    }).map(function(item) {
      var $jscomp$destructuring$var21 = item;
      var key = $jscomp$destructuring$var21.key;
      var en = $jscomp$destructuring$var21.en;
      var value = en || '';
      return '"' + key + '" : "' + value + '"';
    });
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:de_data.join(',\n')}]});
    items.push({title:'de', xtype:'panel', layout:'fit', items:[{xtype:'textarea', grow:true, fieldLabel:'MISSING', value:en_data.join(',\n')}]});
    mpm.util.Window.openWindow('MISSING_TRANSLATIONS', 'fa-info', document.body.clientWidth * 0.8, document.body.clientHeight * 0.7, 'tabpanel', {items:items});
  }}], columns:['key', 'de', 'en'].map(function(dataIndex) {
    var c = {dataIndex:dataIndex, text:dataIndex, flex:1};
    if (dataIndex !== 'key') {
      c.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
    }
    return c;
  })});
}});
Ext.define('mpm.components.plugin.BpcPluginMixin', {getValueFromPluginConfiguration:function(key, fromContext) {
  if (this.pluginConfiguration && Ext.isObject(this.pluginConfiguration)) {
    if (!fromContext) {
      var $jscomp$destructuring$var22 = this.pluginConfiguration;
      var configuration = $jscomp$destructuring$var22.configuration;
      configuration = configuration || {};
      if (key in configuration && configuration[key]) {
        return configuration[key];
      }
    } else if (fromContext) {
      var supportMap = {moduleId:'baseModuleId', instanceId:'moduleId'};
      if (supportMap.hasOwnProperty(key || '')) {
        key = supportMap[key];
      }
      var $jscomp$destructuring$var23 = this.pluginConfiguration;
      var context = $jscomp$destructuring$var23.context;
      context = context || {};
      if (key in context && context[key]) {
        return context[key];
      }
    }
  }
}, getProcessId:function() {
  try {
    this.record = this.getValueFromPluginConfiguration('record', true) || undefined;
    this.instanceId = this.getValueFromPluginConfiguration('instanceId', true) || undefined;
    this.processIdKey = BpcCommon.Api.getSetting(this.instanceId, 'column_id');
    return this.record.get(this.processIdKey);
  } catch (e) {
    return undefined;
  }
}, getWorkflowUrl:function(mpmModuleId, prefix) {
  return mpm.Support.getWorkflowUrl(mpmModuleId, prefix);
}, doFindComponentIn:function(upperCmp, searchCmp) {
  upperCmp = upperCmp === void 0 ? 'window' : upperCmp;
  searchCmp = searchCmp === void 0 ? 'monitorActionPanel' : searchCmp;
  var w = this.up(upperCmp);
  if (w) {
    return w.down(searchCmp);
  }
}, getActionButtonCfg:function(text, iconCls, tooltip, actionMethod, actionCfg) {
  var $jscomp$this = this;
  actionCfg = actionCfg === void 0 ? {} : actionCfg;
  return {xtype:'button', iconCls:mpm.Support.icon(iconCls), text:mpm.Support.TR(text), action:actionCfg, hidden:true, tooltip:mpm.Support.TR(tooltip), handler:actionMethod ? actionMethod : function(b) {
    if ($jscomp$this.executeAction) {
      $jscomp$this.executeAction(b);
    }
  }};
}, addActionsToMonitor:function(actionButtons, targetCmp) {
  if (targetCmp) {
    return actionButtons.map(function(btnCfg) {
      return targetCmp.add(btnCfg);
    });
  }
  return [];
}, isMonitor:function() {
  var baseModuleId = this.getValueFromPluginConfiguration('moduleId', true);
  return baseModuleId && baseModuleId === 'monitor';
}, tryMakePluginActiveInTabpanel:function() {
  var $jscomp$this = this;
  Ext.defer(function() {
    var t = $jscomp$this.up('tabpanel');
    if (t) {
      t.setActiveTab($jscomp$this);
    }
  }, 300);
}});
Ext.define('mpm.components.plugin.EdiTestResult', {extend:'Ext.panel.Panel', alias:'widget.mpmEditTestResult', mixins:['mpm.components.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', moduleId:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = mpm.Support.TR('EDI_TEST');
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls('fa-check');
  this.listeners = {added:function(c, owner) {
    var types = owner.getXTypes();
    types = types.split('/').map(function(t) {
      return t.toLowerCase();
    });
    if (types.indexOf('tabpanel') !== -1) {
      Ext.defer(function() {
        owner.setActiveTab(c);
      }, 200);
      return;
    }
  }};
  this.callParent(arguments);
  var hookCmp = this.getValueFromPluginConfiguration('hook', true);
  if (hookCmp && hookCmp.ownerCt) {
    var w = hookCmp.ownerCt.up('window');
    if (!w) {
      this.setVisible(false);
    } else {
      var monitorId = this.getValueFromPluginConfiguration('instanceId', true);
      if (monitorId) {
        var mode = this.getValueFromPluginConfiguration('method') || 'loadTestResults';
        var proxyId = BpcCommon.Api.getSetting(monitorId, 'inubit_proxyId');
        var baseUrl = BpcCommon.Api.getSetting(monitorId, 'inubit_baseUrl');
        this.baseUrl = BpcCommon.Api.getBackendUrl(proxyId) + baseUrl + 'PMEDI';
        var r = this.getValueFromPluginConfiguration('record', true);
        var idKey = BpcCommon.Api.getSetting(monitorId, 'column_id') || '';
        var pid = r.get(idKey) || '-1';
        var method = mode;
        this.method = method;
        this.isRule = this.method === 'loadTestRule';
        this.pid = pid;
        mpm.Module.newRequest(this.baseUrl, {pid:pid, method:method}).then(function(json) {
          var $jscomp$destructuring$var24 = json;
          var data = $jscomp$destructuring$var24.data;
          $jscomp$this.add($jscomp$this.getUI(data || {}));
        });
      }
    }
  }
}, getFieldsFromList:function(array, data, width) {
  var $jscomp$this = this;
  array = array === void 0 ? [] : array;
  return array.map(function(name) {
    var cfg = {value:data[name], fieldLabel:mpm.Support.capitalizeFirstLetter(name), labelAlign:'top'};
    if (width) {
      cfg.width = width;
    }
    if (name === 'expectedResult') {
      cfg.xtype = 'combo';
      cfg.queryMode = 'local';
      cfg.displayField = 'key';
      cfg.valueField = 'key';
      cfg.store = Ext.create('Ext.data.Store', {data:[{key:'', isRule:true}, {key:'OK', isRule:true}, {key:'APERAK'}, {key:'negCONTRL'}, {key:'technicalError'}, {key:'NOTOK', isRule:true}].map(function(c) {
        c.value = c.key.toLowerCase();
        return c;
      }).filter(function(i) {
        if ($jscomp$this.isRule) {
          return i.isRule;
        }
        return i.key !== 'NOTOK';
      })});
    } else if (name === 'activ') {
      cfg.xtype = 'checkbox';
      cfg.inputValue = 'Y';
    } else if (name === 'expectedErrorcount') {
      cfg.xtype = 'numberfield';
    }
    cfg.itemId = name;
    return cfg;
  });
}, getUI:function(data) {
  var $jscomp$this = this;
  data = data === void 0 ? {} : data;
  var fieldsLeft = ['pruefidentifikator', 'editype', 'activ', 'resultStatus'];
  var fieldsRight = ['expectedResult', 'expectedErrorcount', 'ticket', 'proofset'];
  var ruleFields = ['pid', 'editype', 'ticket', 'activ', 'proofset', 'version', 'description', 'ediBase64', 'expectedResult', 'resultXmlBase64'];
  if (this.method === 'loadTestRule') {
    fieldsLeft = fieldsLeft.filter(function(i) {
      return ruleFields.indexOf(i) !== -1;
    });
    fieldsLeft.push('version');
    fieldsRight = fieldsRight.filter(function(i) {
      return ruleFields.indexOf(i) !== -1;
    });
  }
  var topConfig = {xtype:'container', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'container', layout:{type:'vbox', align:'stretch'}, defaults:{xtype:'textfield'}}, items:[{items:this.getFieldsFromList(fieldsLeft, data, 150)}, {items:this.getFieldsFromList(fieldsRight, data)}].concat(this.isRule ? [] : [{xtype:'container', flex:1, layout:{type:'hbox', align:'stretch'}, items:[this.getGrid(data.currentErrorText, 'Fehlertexte aktuell'), this.getGrid(data.expectedErrorText, 'Fehlertexte erwartet')]}])};
  if (this.method === 'loadTestResults') {
    topConfig.flex = 1;
  }
  var topContainer = Ext.create(topConfig);
  var mainpanel = Ext.create({xtype:'container', region:'center', layout:{type:'vbox', align:'stretch'}, items:[topContainer, {xtype:'toolbar', padding:'2 2 2 2', items:[{text:'Neu', action:'create', iconCls:mpm.Support.icon('fa-plus'), ui:'primary', handler:function(b) {
    return $jscomp$this.submitEdiTest(b);
  }}, {text:'Speichern', action:'update', iconCls:mpm.Support.icon('fa-save'), ui:'primary', handler:function(b) {
    return $jscomp$this.submitEdiTest(b);
  }}, {xtype:'textfield', fieldLabel:'resultStatus', hidden:this.isRule, value:data.resultStatus}, {xtype:'textfield', fieldLabel:'proofset', hidden:this.isRule, value:data.proofset}, {xtype:'textfield', fieldLabel:'Beschreibung', itemId:'description', flex:1, value:data.description}]}, {xtype:'container', flex:2, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'container', flex:1, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'mpmEditor', flex:2, title:'EDIFACT', itemId:'ediBase64', 
  value:data.ediBase64, isBase64:true, readOnly:false, editorLanguage:'edifact', copyEnabled:true}, {xtype:'mpmEditor', flex:1, title:'Partnerinfos', itemId:'partnerinfos', value:data.partnerinfos, editorLanguage:'xml', readOnly:false, copyEnabled:true, hidden:this.isRule}]}, {xtype:'container', flex:1, layout:{type:'vbox', align:'stretch'}, items:[{xtype:'mpmEditor', title:'Erwartetes Ergebnis', flex:1, value:data.expectedResultXmlBase64, isBase64:true, editorLanguage:'xml', readOnly:true, copyEnabled:true, 
  hidden:this.isRule}, {xtype:'mpmEditor', flex:1, title:'Ergebnis', value:data.resultXmlBase64, itemId:'resultXmlBase64', isBase64:true, editorLanguage:'xml', readOnly:true, copyEnabled:true}]}]}]});
  return {xtype:'container', layout:'border', items:[mainpanel, {xtype:'panel', hidden:this.isRule, region:'east', collapsed:true, collapsible:true, title:'Aperak Status: ' + data.aperakResultStatus || '', layout:'fit', width:400, items:[{xtype:'mpmEditor', flex:1, value:data.aperakResultXmlBase64, isBase64:true, editorLanguage:'xml', readOnly:true, copyEnabled:true}]}]};
}, getGrid:function(data, title) {
  data = data === void 0 ? [] : data;
  title = title + ' (' + data.length + ')';
  return {xtype:'grid', flex:1, store:mpm.util.Store.newLocalStore(data), title:title, columns:[{dataIndex:'segName', width:120, renderer:function(v, m, r) {
    var color = r.get('changeColorSeg') || '';
    if (color.length > 0) {
      m.tdStyle = 'background-color:' + color + ';';
    }
    v = v || '';
    m.tdAttr = 'data-qtip\x3d"' + Ext.String.htmlEncode(v) + '"';
    return v;
  }}, {dataIndex:'errorText', flex:1, cellWrap:true, renderer:function(v, m, r) {
    var color = r.get('changeColor') || '';
    if (color.length > 0) {
      m.tdStyle = 'background-color:' + color + ';';
    }
    v = v || '';
    m.tdAttr = 'data-qtip\x3d"' + Ext.String.htmlEncode(v) + '"';
    return v;
  }}]};
}, handleResponse:function(r) {
  var json = r.responseText ? Ext.decode(r.responseText, true) : {};
  if (json && json.success) {
    var w = this.up('window');
    if (w) {
      w.close();
    }
  }
}, submitEdiTest:function(btn) {
  var $jscomp$this = this;
  var pid = this.pid;
  var action = btn.action;
  var formData = new FormData();
  var submitFields = ['ediBase64', 'expectedResult', 'description', 'expectedErrorcount', 'ticket', 'proofset', 'pruefidentifikator', 'editype', 'activ', 'resultStatus', 'partnerinfos'];
  if (this.method === 'loadTestRule') {
    submitFields = ['editype', 'ticket', 'activ', 'proofset', 'version', 'description', 'ediBase64', 'expectedResult', 'resultXmlBase64'];
  }
  submitFields.map(function(itemId) {
    formData.append(itemId, $jscomp$this.down('#' + itemId).getValue());
  });
  formData.append('portalUser', BpcCommon.Api.getUserName());
  var method = this.method;
  Ext.Ajax.request({url:this.baseUrl, params:{pid:pid, action:action, method:method}, rawData:formData, headers:{'Content-Type':'multipart/form-data'}, success:function(response) {
    $jscomp$this.handleResponse(response);
  }, failure:function(response) {
  }});
}});
Ext.define('mpm.components.plugin.ediTestResultPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM EDI Test Plugin', COMPONENT_XTYPE:'mpmEditTestResult', PLUGIN_ID:'mpm-edi-test-result'}});
Ext.define('mpm.components.plugin.InvoiceViewer', {extend:'Ext.panel.Panel', alias:'widget.mpmInvoiceViewerPlugin', mixins:['mpm.components.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', moduleId:undefined, record:undefined, initComponent:function() {
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls('fa-file-invoice-dollar');
  this.method = this.getValueFromPluginConfiguration('method') || 'loadInvoice';
  var id = this.getProcessId();
  this.title = mpm.Support.TR('IRM_TITLE' + (this.method || '').trim().replace('load', '').trim());
  this.listeners = {activate:function(c) {
    if (c.invoiceWrapper) {
      var t = c.invoiceWrapper.getActiveTab();
      if (t && t.showActionButtons) {
        t.showActionButtons(true);
      }
    }
  }, deactivate:function(c) {
    if (c.invoiceWrapper) {
      var t = c.invoiceWrapper.getActiveTab();
      if (t && t.showActionButtons) {
        t.showActionButtons(false);
      }
    }
  }};
  this.callParent(arguments);
  var hookCmp = this.getValueFromPluginConfiguration('hook', true);
  if (hookCmp && hookCmp.ownerCt) {
    var w = hookCmp.ownerCt.up('window');
    if (!w) {
      this.setVisible(false);
    } else {
      this.loadData(id);
      this.tryMakePluginActiveInTabpanel();
    }
  }
}, createActionButtons:function() {
  var monitorActionPanel = this.doFindComponentIn();
  var buttons = [this.getActionButtonCfg('INVOICE_ACCEPT', 'fa-file-invoice', 'INVOICE_ACCEPT', this.pluginActionHandler.bind(this), {mode:'accept'}), this.getActionButtonCfg('INVOICE_REJECT', 'fa-times', 'INVOICE_REJECT', this.pluginActionHandler.bind(this), {mode:'reject'})];
  return this.addActionsToMonitor(buttons, monitorActionPanel);
}, actionButtonsCreated:false, invoiceType:undefined, sparte:undefined, isUiPartHidden:function(obj) {
  return Ext.isObject(obj) ? Ext.Object.isEmpty(obj) : true;
}, createUI:function(dto) {
  dto = dto === void 0 ? {} : dto;
  try {
    dto = dto || {};
    var $jscomp$destructuring$var25 = dto;
    var RECHNUNG = $jscomp$destructuring$var25.RECHNUNG;
    var $jscomp$destructuring$var26 = RECHNUNG || {};
    var REFUSIALREASON = $jscomp$destructuring$var26.REFUSIALREASON;
    if (RECHNUNG && Array.isArray(REFUSIALREASON)) {
      dto.RECHNUNG.REFUSIALREASON = REFUSIALREASON.map(function(i) {
        return i.REFUSIALREASONQUALIFIER || ' - 1';
      });
    } else {
      dto.RECHNUNG = {};
      dto.RECHNUNG.REFUSIALREASON = [];
    }
    this.removeAll();
    var actionButtons = [];
    if (!this.actionButtonsCreated && this.isMonitor() && this.method === 'loadInvoice') {
      this.actionButtonsCreated = true;
      actionButtons = this.createActionButtons();
    }
    var invoiceViewer = Ext.create(Ext.apply({xtype:'mpmInvoiceUi', hidden:this.method !== 'loadInvoice'}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'RECHNUNG'), readOnly:true, bpcPlugin:true, actionButtons:actionButtons, listeners:{activate:function(c) {
      c.showActionButtons();
    }, deactivate:function(c) {
      c.showActionButtons(false);
    }}}));
    var $jscomp$destructuring$var27 = dto || {};
    var RECHNUNG_ORIGINAL = $jscomp$destructuring$var27.RECHNUNG_ORIGINAL;
    var RECHNUNG_STORNO = $jscomp$destructuring$var27.RECHNUNG_STORNO;
    var COMDISDATEN = $jscomp$destructuring$var27.COMDISDATEN;
    var LIEFERSCHEINDATEN = $jscomp$destructuring$var27.LIEFERSCHEINDATEN;
    var LSCOMDISDATEN = $jscomp$destructuring$var27.LSCOMDISDATEN;
    var invoiceViewerOriginal = Ext.create(Ext.apply({xtype:'mpmInvoiceUi', hidden:this.isUiPartHidden(RECHNUNG_ORIGINAL)}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'RECHNUNG_ORIGINAL'), readOnly:true, bpcPlugin:true}));
    invoiceViewerOriginal.setTitle('Rechnung (Original)');
    var invoiceViewerStorno = Ext.create(Ext.apply({xtype:'mpmInvoiceUi', hidden:this.isUiPartHidden(RECHNUNG_STORNO)}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'RECHNUNG_STORNO'), readOnly:true, bpcPlugin:true}));
    invoiceViewerStorno.setTitle('Rechnung (Storno)');
    var remadvViewer = Ext.create(Ext.apply({xtype:'mpmRemadvUi', hidden:this.method.toLowerCase() !== 'loadremadv'}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'REMADV'), readOnly:true, bpcPlugin:true}));
    var invoiceComdis = Ext.create(Ext.apply({xtype:'mpmComdisUi', mode:'invoice', hidden:this.isUiPartHidden(COMDISDATEN)}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'COMDISDATEN'), readOnly:true, bpcPlugin:true}));
    var ls = Ext.create(Ext.apply({xtype:'mpmLieferscheinUi', hidden:this.isUiPartHidden(LIEFERSCHEINDATEN)}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'LIEFERSCHEINDATEN'), readOnly:true, bpcPlugin:true}));
    var lsComdis = Ext.create(Ext.apply({xtype:'mpmComdisUi', mode:'delivery', hidden:this.isUiPartHidden(LSCOMDISDATEN)}, {task:mpm.Support.getFakeTask(dto, this.moduleId, 'LSCOMDISDATEN'), readOnly:true, bpcPlugin:true}));
    var visiblePanels = [invoiceViewer, invoiceViewerOriginal, invoiceViewerStorno, remadvViewer, invoiceComdis, ls, lsComdis].filter(function(p) {
      return !p.isHidden();
    });
    if (!invoiceViewer.isHidden()) {
      this.invoiceMain = invoiceViewer;
    }
    this.invoiceWrapper = Ext.create({xtype:'tabpanel', items:visiblePanels});
    this.invoiceWrapper.query('[setValueDeferred\x3dtrue]').map(function(f) {
      f.setValue(f.deferredValue);
    });
    if (visiblePanels.length > 1) {
      this.invoiceWrapper.setActiveTab(visiblePanels[0]);
    }
  } catch (e) {
    this.invoiceWrapper = Ext.create({xtype:'container', html:'ERROR - FILE A BUG PLEASE'});
  }
  this.add(this.invoiceWrapper);
}, pluginActionHandler:function(b) {
  var $jscomp$this = this;
  var $jscomp$destructuring$var28 = b.action || {};
  var mode = $jscomp$destructuring$var28.mode;
  var sendButton = Ext.create({text:'Senden', xtype:'button', ui:'primary', iconCls:mpm.Support.icon('fa-check'), handler:function(b) {
    $jscomp$this.invoiceMain.setActionButtonsDisabled(true);
    var win = b.up('window');
    var map = decisionPanel.getFieldsAsMap();
    map.processId = $jscomp$this.getProcessId();
    map.action = 'submitInvoice';
    map.portalUser = BpcCommon.Api.getUserName();
    $jscomp$this.setLoading('Invoice Auswahl wird versandt');
    var url = mpm.Support.getWorkflowUrl($jscomp$this.moduleId, 'invoice');
    Ext.Ajax.request({method:'POST', url:url + '?' + Ext.Object.toQueryString(map), jsonData:map, success:function(response) {
      var json = mpm.Support.getResponseObject(response);
      if (win) {
        win.close();
      }
      var o = {html:'JSON NOT FOUND.', title:'Fehler', width:250, iconCls:mpm.Support.icon('fa-exclamation-circle')};
      if (json) {
        o.html = json.message || '-1';
        o.title = json.success ? 'Aktion erfolgreich' : 'Fehler';
        o.iconCls = mpm.Support.icon(json.success ? 'fa-check' : 'fa-exclamation-circle');
        if (json.success) {
          $jscomp$this.refreshPluginContent();
        }
      }
      $jscomp$this.showNotification(o);
    }, failure:function(response) {
      $jscomp$this.showNotification({html:response.status || 'SOMETHING WENT WRONG.', title:'Fehler', width:250, iconCls:mpm.Support.icon('fa-exclamation-circle')});
    }});
  }});
  var decisionPanel = this.invoiceMain.createDecisionComponent(mode, this.sparte, this.invoiceType, sendButton);
  Ext.create({xtype:'window', modal:true, style:'background-color:#DEDEE4!important;', title:'Zahlungsavis: ' + mode || '-1', layout:'fit', width:document.body.clientWidth * 0.5, padding:'10 10 10 10', items:[decisionPanel], bbar:[{xtype:'tbfill'}, {text:'Fenster schließen', ui:'secondary', iconCls:mpm.Support.icon(mpm.Support.keys.icons.remove), handler:function(b) {
    var win = b.up('window');
    if (win) {
      win.close();
    }
  }}, sendButton]}).show();
  if (mode === 'accept') {
    sendButton.handler(sendButton);
  }
}, refreshPluginContent:function() {
  var $jscomp$this = this;
  this.setLoading('Invoice wurde erfolgreich aktualisiert.');
  this.loadData(this.getProcessId()).then(function() {
    $jscomp$this.setLoading(false);
  });
}, showNotification:function(obj) {
  obj.anchor = this.invoiceWrapper;
  Ext.toast(obj);
}, loadData:function(id) {
  var $jscomp$this = this;
  var dto = {};
  return mpm.Support.getAjaxPromise({url:this.getWorkflowUrl(this.moduleId, 'invoice'), params:{method:this.method, processId:id}}).then(function(r) {
    var json = Ext.decode(r.responseText, true);
    var $jscomp$destructuring$var29 = json;
    var data = $jscomp$destructuring$var29.data;
    var meta = $jscomp$destructuring$var29.meta;
    dto = data;
    $jscomp$this.sparte = (meta || {}).sparte;
  })["catch"](function(e) {
    dto = {};
  })["finally"](function() {
    var $jscomp$destructuring$var30 = (dto || {}).RECHNUNG || {};
    var RECHNUNGSTYPCODE = $jscomp$destructuring$var30.RECHNUNGSTYPCODE;
    $jscomp$this.invoiceType = RECHNUNGSTYPCODE;
    $jscomp$this.createUI(dto);
    return true;
  });
}});
Ext.define('mpm.components.plugin.invoiceViewerPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM Invoice Viewer Plugin', COMPONENT_XTYPE:'mpmInvoiceViewerPlugin', PLUGIN_ID:'mpm-invoice-viewer-plugin'}});
Ext.define('mpm.plugins.columnWidget', {extend:'Ext.Widget', alias:['widget.mpmColumnWidget'], element:{reference:'element', style:'cursor: pointer;\n' + '    overflow: hidden;\n' + '    text-overflow: ellipsis; ', listeners:{click:'onModuleJump'}}, defaultBindProperty:'value', showIcon:true, showValue:true, renderValue:undefined, separator:undefined, rendererFn:undefined, tpl:'', displayText:'', constructor:function(config) {
  this.callParent([config]);
  this.tpl = this.createTemplate();
}, createTemplate:function() {
  this.tpl = "\x3ctpl for\x3d\"valueArray\"\x3e\x3ctpl if\x3d'.'\x3e\x3ca data-value\x3d'{.:htmlEncode2}'\x3e";
  if (this.showIcon) {
    this.tpl += '\x3cspan class\x3d"' + this.iconCls + '" aria-hidden\x3d"true"\x3e \x3c/span\x3e';
  }
  this.tpl += this.showValue ? ' {.:htmlEncode2}' : this.displayText || '';
  this.tpl += '\x3c/a\x3e \x3c/tpl\x3e\x3c/tpl\x3e';
  return new Ext.XTemplate(this.tpl);
}, updateContent:function(value) {
  var displayHtml;
  if (Ext.isArray(value)) {
    displayHtml = value;
  } else if (Ext.isString(value)) {
    displayHtml = this.separator ? value.split(this.separator).map(Ext.String.trim) : [value];
  } else {
    displayHtml = [value];
  }
  this.element.setHtml(this.tpl.apply({valueArray:displayHtml}));
}, onModuleJump:function(event, domEl) {
  BpcCommon.Api.showModule(this.targetModuleId, false, this.targetJumpParams);
}});
Ext.define('mpm.plugins.jumpColumn', {extend:'Ext.grid.column.Widget', alias:'widget.mpmJumpColumn', mixins:['mpm.components.plugin.BpcPluginMixin'], width:100, prefix:undefined, valueIdKey:undefined, items:[{xtype:'bpcTextField', readOnly:true}], targetIdColumn:undefined, initComponent:function() {
  this.widget = {xtype:'mpmColumnWidget', iconCls:mpm.Support.icon('fa-external-link'), showIcon:true};
  this.text = this.getValueFromPluginConfiguration('title') || 'MPM Jump';
  this.valueIdKey = this.getValueFromPluginConfiguration('idColumn') || 'FACHPROCESSID';
  this.compareReferenceKey = this.getValueFromPluginConfiguration('settingCompareColumn') || 'FACHPROZESS_PREFIX';
  this.targetIdColumn = this.getValueFromPluginConfiguration('targetIdColumn');
  this.moduleMatchConfiguration = this.getValueFromPluginConfiguration('valueInstanceMap') || {};
  this.callParent(arguments);
}, getJumpParams:function(moduleId, value) {
  var columnId = this.targetIdColumn || BpcCommon.Api.getSetting(moduleId, 'column_id');
  if (columnId) {
    return {storeState:{filters:[{property:columnId, value:value}]}};
  }
  return {};
}, onWidgetAttach:function(col, widget, rec) {
  if (widget) {
    var value = rec.get(this.valueIdKey);
    var tablePrefix = rec.get(this.compareReferenceKey);
    var canJump = this.isValidValue(value) && this.isValidValue(tablePrefix);
    if (canJump) {
      var moduleId = mpm.Support.getModuleIdBySettingValue(undefined, undefined, tablePrefix);
      moduleId = this.moduleMatchConfiguration[tablePrefix] || moduleId;
      if (moduleId) {
        widget.updateContent(canJump ? value : '');
        widget.targetModuleId = moduleId;
        widget.targetJumpParams = this.getJumpParams(moduleId, value);
      }
    }
  }
}, isValidValue:function(value) {
  return Ext.isDefined(value) && value != null;
}});
Ext.define('mpm.plugins.jumpColumnPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM Jump Column', COMPONENT_XTYPE:'mpmJumpColumn', PLUGIN_ID:'mpmJumpColumn'}});
Ext.define('mpm.components.plugin.mailViewer', {extend:'Ext.panel.Panel', alias:'widget.mpmMailViewerPlugin', mixins:['mpm.components.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', moduleId:undefined, record:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  this.pid = this.getProcessId();
  this.title = mpm.Support.TR('MPM_MAIL_PLUGIN_TITLE');
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls('fa-envelope');
  this.bbar = [{text:'Reload', hidden:!BpcCommon.Api.hasUserAnyRole(BpcCommon.Api.getSetting(this.moduleId, 'mpmDebugRole')), handler:function(b) {
    $jscomp$this.loadData($jscomp$this.pid);
  }}];
  this.callParent(arguments);
  var hookCmp = this.getValueFromPluginConfiguration('hook', true);
  if (hookCmp && hookCmp.ownerCt) {
    var w = hookCmp.ownerCt.up('window');
    if (!w) {
      this.setVisible(false);
    } else {
      this.loadData(this.pid);
    }
  }
}, createUI:function(dto) {
  dto = dto === void 0 ? {} : dto;
  this.add({xtype:'mpmMailView', header:false, protocolData:dto});
}, loadData:function(id) {
  var $jscomp$this = this;
  var dto = {};
  if (!Ext.isDefined(id) || id && id.length === 0) {
    this.removeAll();
    this.add({xtype:'container', html:'no id found'});
    return;
  }
  var url = this.getWorkflowUrl(this.moduleId, 'routing');
  mpm.Support.getAjaxPromise({url:url, params:{processId:id, method:'mail'}}).then(function(r) {
    var json = Ext.decode(r.responseText, true);
    if (json && json.ENVELOPEXML) {
      dto = json.ENVELOPEXML || {};
    } else {
      BpcCommon.Api.showNotification('NO MAIL DATA FOUND');
    }
  })["catch"](function(e) {
    BpcCommon.Api.showNotification('ERROR FETCHING MAIL DATA');
    dto = {};
  })["finally"](function() {
    if (Ext.Object.isEmpty(dto)) {
      $jscomp$this.setDisabled(true);
      $jscomp$this.setVisible(false);
      if ($jscomp$this.tab) {
        $jscomp$this.tab.hide();
      }
    } else {
      $jscomp$this.createUI(dto);
    }
  });
}});
Ext.define('mpm.components.plugin.mailViewerPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM Mail Viewer Plugin', COMPONENT_XTYPE:'mpmMailViewerPlugin', PLUGIN_ID:'mpm-mail-viewer-plugin'}});
Ext.define('mpm.components.plugin.messageViewerAction', {extend:'Ext.panel.Panel', alias:'widget.mpmMessageViewerActionPlugin', mixins:['mpm.components.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', moduleId:undefined, record:undefined, firstSuccessLoad:false, sourceCmp:undefined, autoOpenTypes:[], onSourceGridStoreLoad:function(store, records, success, operation) {
  var $jscomp$this = this;
  if (success && records.length && this.firstSuccessLoad === false) {
    try {
      this.process.processId = this.sourceCmp.flexContext.processId;
    } catch (e) {
      Ext.toast('Fehler im Plugin - mpmMessageViewerActionPlugin');
    }
    if (this.autoOpenTypes.length) {
      records.filter(function(r) {
        var type = r.get('TYPE') || '';
        type = type.trim().toLowerCase();
        return $jscomp$this.autoOpenTypes.indexOf(type) !== -1;
      }).map(function(r) {
        $jscomp$this.addToComponent($jscomp$this.sourceCmp, r.get('CHILDID'), r);
      });
    }
  }
}, getPluginAction:function(grid) {
  var me = this;
  if (grid && grid.store) {
    this.sourceCmp = grid;
    grid.store.on('load', this.onSourceGridStoreLoad.bind(this));
  }
  return {iconCls:mpm.Support.getBpcIconCls('fa-file'), tooltip:mpm.Support.TR('SHOW_MESSAGE'), isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    var type = record.get('TYPE');
    if (type) {
      item.tooltip = mpm.Support.TR('SHOW_MESSAGE') + ': ' + mpm.Support.capitalizeFirstLetter(type);
    }
    return !record.get('TYPE');
  }, handler:function(grid, rowIndex, colIndex) {
    var rec = grid.getStore().getAt(rowIndex);
    var type = rec.get('TYPE');
    if (type) {
      me.process.processId = grid.up('grid').flexContext.processId;
      me.addToComponent(grid, rec.get('CHILDID'), rec, true);
    }
  }};
}, addToComponent:function(baseComponent, logEntryNum, r, openAsWindow) {
  openAsWindow = openAsWindow === void 0 ? false : openAsWindow;
  var w = baseComponent.up('window');
  var inWindow = Ext.isDefined(w);
  var t = baseComponent.up('tabpanel');
  var isMail = (r.get('TYPE') || '').toLowerCase().trim() === 'mail';
  var p;
  if (!isMail) {
    p = this.getMessageViewerCmp(true, logEntryNum, Ext.isDefined(t));
  } else {
    var $jscomp$destructuring$var31 = baseComponent || {};
    var moduleId = $jscomp$destructuring$var31.moduleId;
    p = Ext.create({xtype:'panel', layout:'fit', iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-envelope'), listeners:{afterrender:function(p) {
      flextable.file.getFile(r, moduleId).then(function(data) {
        var $jscomp$destructuring$var32 = data;
        var fileSource = $jscomp$destructuring$var32.fileSource;
        if (fileSource.startsWith('\x3c')) {
          data.meta.mime = 'text/x-bpc-mpm+xml';
        }
        var wrapper = flextable.file.getViewer(moduleId, data);
        p.add(wrapper);
      });
    }}});
  }
  var title = mpm.Support.capitalizeFirstLetter(r.get('TYPE'));
  p.setTitle(title);
  p.record = r;
  if (inWindow && Ext.isDefined(t)) {
    var matches = t.query('taskMessageViewer[childLogId\x3d' + logEntryNum + ']');
    if (matches.length === 1) {
      p = matches[0];
    } else {
      t.add(p);
    }
    t.setActiveTab(p);
  } else {
    if (openAsWindow) {
      Ext.create('Ext.window.Window', {title:title, iconCls:mpm.Support.getBpcIconCls('fa-file'), height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.6, layout:'fit', items:[p]}).show();
    }
  }
}, initComponent:function() {
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  this.process = this.getValueFromPluginConfiguration('process') || {prefix:undefined, 'package':undefined};
  this.instanceId = this.getValueFromPluginConfiguration('instanceId', true) || undefined;
  this.title = this.getValueFromPluginConfiguration('title') || mpm.Support.TR('MPM_MESSAGE_PLUGIN_TITLE');
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls('fa-file');
  var packageIdInternal = mpm.Support.aliases[this.process["package"]];
  this.basePath = BpcCommon.Api.getSetting(this.moduleId, 'basePath');
  this.dataUrl = this.basePath + '/' + BpcCommon.Api.getSetting(this.moduleId, packageIdInternal + 'DataListener');
  var types = BpcCommon.Api.getSetting(this.moduleId, 'messageviewer_types') || [];
  this.autoOpenTypes = types.map(function(t) {
    return t.trim().toLowerCase();
  });
  this.callParent(arguments);
}, getMessageViewerCmp:function(closable, reference, header) {
  closable = closable === void 0 ? false : closable;
  var o = {xtype:'taskMessageViewer', childLogId:String(reference), mpmModuleId:this.moduleId, dataUrl:this.dataUrl, process:this.process, ref:reference, closable:closable};
  if (!header) {
    o.header = false;
  }
  return Ext.create(o);
}});
Ext.define('mpm.components.plugin.messageViewerActionPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM Message Viewer Action Plugin', COMPONENT_XTYPE:'mpmMessageViewerActionPlugin', PLUGIN_ID:'mpm-message-viewer-action-plugin'}});
Ext.define('mpm.plugins.rendererColumn', {extend:'Ext.grid.column.Column', alias:'widget.mpmRendererColumn', mixins:['mpm.components.plugin.BpcPluginMixin'], width:100, prefix:undefined, processId:undefined, items:[{xtype:'bpcTextField', readOnly:true}], initComponent:function() {
  var $jscomp$this = this;
  this.text = this.getValueFromPluginConfiguration('title') || 'MPM Renderer';
  this.dataIndex = this.getValueFromPluginConfiguration('dataIndex') || 'CA_STATUS';
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  var map = BpcCommon.Api.getSetting(instanceId, 'column_customRenderer') || {};
  var iconCount = this.getValueFromPluginConfiguration('iconCount');
  if (iconCount && !Ext.isNumber(iconCount)) {
    iconCount = Number(iconCount);
  }
  if (iconCount) {
    this.width = iconCount * 35;
  }
  this.lowerCaseRendererMap = {};
  this.lowerCaseRendererKeys = Object.keys(map).map(function(k) {
    var lcRendererName = k.toLowerCase();
    $jscomp$this.lowerCaseRendererMap[lcRendererName] = map[k] || {iconOnly:true, valueMap:{}};
    return lcRendererName;
  });
  this.renderer = this.dynamicColumnRenderer.bind(this);
  this.callParent(arguments);
}, dynamicColumnRenderer:function(v, m, r, rowInd, colInd, store, view) {
  var $jscomp$this = this;
  v = v || '';
  var stringArray = v.toLowerCase().split('_');
  var toolTip = [];
  if (stringArray.length % 2 === 0) {
    var rendererArray = [];
    stringArray.map(function(v, index, array) {
      if ((index + 1) % 2 === 0) {
        rendererArray.push({key:array[index - 1], value:v});
      }
    });
    rendererArray = rendererArray.map(function(obj) {
      if ($jscomp$this.lowerCaseRendererMap[obj.key]) {
        var rendererConfig = $jscomp$this.lowerCaseRendererMap[obj.key];
        var $jscomp$destructuring$var33 = rendererConfig;
        var valueMap = $jscomp$destructuring$var33.valueMap;
        valueMap = valueMap || {};
        if (valueMap[obj.value]) {
          var tt = {};
          tt[obj.key] = obj.value;
          toolTip.push(tt);
          return mpm.Support.getSpanForIconCls(valueMap[obj.value]['iconCls'], valueMap[obj.value]['color']);
        }
        return '-1';
      } else {
        return '-1';
      }
    });
    m.tdAttr = "data-qtip\x3d'" + mpm.Support.arrayToHtmlTable(toolTip) + "'";
    return rendererArray.join('\x26nbsp;');
  } else {
    return v;
  }
}});
Ext.define('mpm.plugins.rendererColumnPlugin', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'MPM Renderer Column', COMPONENT_XTYPE:'mpmRendererColumn', PLUGIN_ID:'mpmRendererColumn'}});
Ext.define('mpm.tasks.Wrapper', {extend:'mpm.components.Panel', alias:'widget.tasksMainWrapper', layout:{type:'vbox', align:'stretch'}, items:[], task:undefined, msg:undefined, infoTooltip:undefined, meta:{}, setTaskDescription:function() {
  var desc = this.meta && this.meta.description ? this.meta.description : this.TR('DESCRIPTION_NOT_SET');
  this.descriptionField.setText(desc);
}, setBranch:function(branch) {
  branch = branch === void 0 ? '' : branch;
  var map = BpcCommon.Api.getSetting('mpm', 'branches');
  this.branchField.setVisible(true);
  var icon = map[branch] || 'fa-exclamation-circle';
  this.branchField.setIconCls(mpm.Support.icon(icon));
  var tooltip = branch.length ? mpm.Support.capitalizeFirstLetter(branch) : 'No branch set';
  tooltip = this.TR('BRANCH') + ': ' + tooltip;
  this.branchField.setTooltip(tooltip);
}, applyModuleJump:function(moduleId, cfg, processId) {
  cfg = cfg === void 0 ? {} : cfg;
  if (moduleId) {
    this.jumpButton.setText(BpcCommon.Api.getSetting(moduleId, 'module_name') + ' ' + this.TR('OPEN'));
    this.jumpButton.setDisabled(false);
    this.jumpButton.setVisible(true);
    if (Ext.Object.isEmpty(cfg)) {
      this.jumpButton.setTooltip('NO PROCESS ID SET.');
    }
    this.jumpButton.jumpParams = cfg;
    this.jumpButton.targetModuleId = moduleId;
    if (processId && processId.length) {
      this.jumpButton.setTooltip('Prozess: ' + processId);
    }
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.task.translationDebug = [];
  this.descriptionField = Ext.create({xtype:'button', overCls:'', focusable:false, iconCls:this.faIcon('fa-info-square'), text:this.msg || 'NO_MESSAGE_SET', handleMouseEvents:false, skipValue:true, iconAlign:'left', textAlign:'left', flex:1});
  this.branchField = Ext.create({xtype:'button', overCls:'', focusable:false, hidden:true, iconCls:this.faIcon('fa-info-square'), handleMouseEvents:false, skipValue:true, iconAlign:'left', textAlign:'left'});
  this.headerFields = Ext.create({xtype:'button', overCls:'', text:'Kopfdaten', iconCls:this.faIcon('fa-ban'), skipValue:true, handler:function(b) {
    if ($jscomp$this.task.taskMainHeader) {
      var visible = $jscomp$this.task.taskMainHeader.isVisible();
      b.setIconCls(mpm.Support.icon(visible ? 'fa-circle' : 'fa-ban'));
      $jscomp$this.task.taskMainHeader.setVisible(!visible);
    }
  }});
  this.jumpButton = Ext.create({xtype:'button', targetModuleId:undefined, jumpParams:undefined, handler:function(b) {
    BpcCommon.Api.showModule(b.targetModuleId, false, b.jumpParams || {});
  }, hidden:true, iconCls:this.faIcon('fa-external-link'), skipValue:true});
  var dockedItems = [this.descriptionField, this.jumpButton, this.headerFields, this.branchField];
  if (this.task.taskBtns) {
    dockedItems = dockedItems.concat(this.task.taskBtns);
  }
  this.taskDebugInfoButton = Ext.create({iconCls:this.faIcon('fa-info'), tooltip:this.infoTooltip || 'Task and ProcessInfo', task:this.task, wrapper:this, disabled:!this.canDebug(), xtype:'button', infoCreated:false, lastCard:undefined, setMode:function(mode) {
    mode = mode === void 0 ? 'w' : mode;
    if (this.wrapper.canDebug()) {
      this.setStyle({backgroundColor:'orange'});
    }
  }, handler:function(b) {
    if ($jscomp$this.canDebug()) {
      if (b.infoCreated === false) {
        b.task.createTaskInfoComponent();
        b.infoCreated = true;
        b.lastCard = 'taskInfoComponent';
      }
      b.task.swapComponents('taskInfoComponent');
    }
  }});
  dockedItems.push(this.taskDebugInfoButton);
  this.topToolbar = Ext.create({xtype:'toolbar', style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';', padding:'2 2 2 2', items:dockedItems});
  this.dockedItems = [this.topToolbar];
  this.callParent(arguments);
}, setInfoButtonMode:function(mode) {
  this.taskDebugInfoButton.setMode(mode);
}, canDebug:function() {
  return BpcCommon.Api.hasUserAnyRole(BpcCommon.Api.getSetting(this.task.mpmModuleId, 'mpmDebugRole'));
}});
Ext.define('mpm.tasks.Task', {extend:'Ext.Base', requires:['mpm.tasks.Wrapper', 'mpm.tasks.components.MessageViewer'], isConfig:undefined, errorTask:false, interactionWindowId:'autoload-win', interactionWindow:undefined, interactionModuleId:undefined, interactionPanel:undefined, interactionPanelId:'interactionTaskFormPanel', mpmModuleId:undefined, submitValue:undefined, _rawDto:undefined, _meta:undefined, _hiddenFields:[], 'package':undefined, wrapper:undefined, taskFormWrapper:undefined, taskInfoComponent:undefined, 
translationDebug:[], taskNotificationStore:undefined, dictionaryValues:undefined, formatDictionaryEntry:function(item, moduleId) {
  item = item === void 0 ? {} : item;
  return mpm.Support.dicItemFormatter(item, moduleId);
}, setValue:function(value) {
  this.submitValue = value;
  var submitBtn = this.interactionWindow.down('#submitBtn');
  submitBtn.setDisabled(!Ext.isDefined(this.submitValue));
}, setDeferredValues:function() {
  this.taskFormWrapper.query('[setValueDeferred\x3dtrue]').map(function(f) {
    f.setValue(f.deferredValue);
  });
}, addModuleJump:function() {
  var targetModuleId = this.getModuleJumpId();
  if (targetModuleId) {
    this.applyModuleJump(targetModuleId);
  }
}, getModuleJumpId:function() {
  var prefix = this.getItemFromMetaProcess(this.isConfig, 'prefix');
  if (prefix) {
    return mpm.Support.getModuleIdBySettingValue(undefined, undefined, prefix);
  }
}, taskBranch:undefined, getConfirmValues:function(dic) {
  var $jscomp$this = this;
  dic = dic === void 0 ? [] : dic;
  var taskBranch = this.taskBranch || '';
  return dic.filter(function(i) {
    return i.flag === 'accept' && i.branch === taskBranch;
  }).map(function(i) {
    return $jscomp$this.dicItemToSelectElem(i);
  });
}, getRejectValues:function(dic) {
  var $jscomp$this = this;
  dic = dic === void 0 ? [] : dic;
  var taskBranch = this.taskBranch || '';
  return dic.filter(function(i) {
    return i.flag === 'reject' && i.branch === taskBranch;
  }).map(function(i) {
    return $jscomp$this.dicItemToSelectElem(i);
  });
}, dicItemToSelectElem:function(item, name) {
  item = item === void 0 ? {} : item;
  name = name === void 0 ? 'antwortkategorie' : name;
  return {boxLabel:this.formatDictionaryEntry(item), name:name, inputValue:item.key};
}, getBranch:function() {
  this.notify('FETCHING BRANCH', 'd');
  if (this.isConfig.meta.sparte || this.isConfig.meta.branch) {
    var branch = (this.isConfig.meta.sparte || this.isConfig.meta.branch || '').trim();
    var validBranches = ['strom', 'gas'];
    if (branch.length === 0) {
      this.notify('SPARTE (meta.sparte) NOT SET', 'w');
    }
    if (validBranches.indexOf(branch) === -1) {
      this.notify('SPARTE (meta.sparte) ' + branch + ' NOT VALID', 'w');
    } else {
      this.notify('BRANCH FOUND: ' + branch);
    }
    branch = branch.length ? branch : undefined;
    this.taskBranch = branch;
    this.applyBranch(branch);
    return branch;
  } else {
    this.notify('BRANCH (meta.sparte) KEY NOT DEFINED', 'w');
  }
}, dictionarySource:'', getWfDictionary:function(fallbackId) {
  fallbackId = fallbackId === void 0 ? '' : fallbackId;
  this.notify('GETTING DICTIONARY FROM WF DATA - DTO', 'd');
  var $jscomp$destructuring$var34 = this.isConfig || {};
  var meta = $jscomp$destructuring$var34.meta;
  var $jscomp$destructuring$var35 = meta || {};
  var dictionary = $jscomp$destructuring$var35.dictionary;
  if (dictionary) {
    this.notify('DICTIONARY KEY FOUND', 'd');
    if (Ext.isArray(dictionary)) {
      this.notify('DICTIONARY FORMAT CORRECT', 'd');
      this.dictionarySource = 'Workflow';
      this.dictionaryValues = dictionary;
      return dictionary;
    } else {
      this.notify('DICTIONARY FORMAT NOT CORRECT - SHOULD BE AN ARRAY OF OBJECTS []', 'd');
    }
  }
  this.notify('NO DICTIONARY FOUND. TRYING FALLBACK', 'd');
  if (!fallbackId || !fallbackId.length) {
    this.notify('USING XTYPE AS DICTIONARY ID FALLBACK', 'd');
    fallbackId = fallbackId || this.xtype || '';
  }
  if (fallbackId && fallbackId.length) {
    this.notify('USING FALLBACK-ID: ' + fallbackId, 'd');
    dictionary = this.getDictionary(fallbackId) || [];
    this.dictionarySource = 'MPM-Module';
    this.dictionaryValues = dictionary;
    return dictionary;
  }
  this.notify('NO DICTIONARY FOUND. SORRY', 'd');
  return undefined;
}, applyModuleJump:function(moduleId, cfg) {
  if (this.taskFormWrapper) {
    var columnId = BpcCommon.Api.getSetting(moduleId, 'column_id');
    this.notify('COLUMN ID IN TARGETMONITOR: ' + columnId, 'd');
    var processId = this.getItemFromMetaProcess(this.isConfig, 'processId');
    processId = processId || this.getItemFromMetaProcess(this.isConfig, 'processid');
    if (processId) {
      processId = processId || '';
      if (processId.length === 0) {
        this.notify('PROCESS ID KEY SET, VALUE EMPTY', 'w');
      } else {
        this.notify('PROCESS ID FOUND IN DTO: USED AS JUMP PARAM: ' + processId, 'd');
      }
    } else {
      this.notify('NO PROCESS ID SET, JUMP MIGHT NOT FULLY WORK (SET IF POSSIBLE : DTO -\x3e meta -\x3e process -\x3e processId)', 'w');
    }
    var jumpParams = processId ? {storeState:{filters:[{property:columnId, value:processId}]}} : {};
    this.taskFormWrapper.applyModuleJump(moduleId, jumpParams, processId);
  } else {
    this.notify('MODULE JUMP NOT SET - WRAPPER NOT DEFINED', 'w');
  }
}, applyBranch:function(branch) {
  if (this.taskFormWrapper) {
    this.taskFormWrapper.setBranch(branch);
  } else {
    this.notify('TASK BRANCH NOT SET - WRAPPER (taskFormWrapper) NOT DEFINED', 'w');
  }
}, hideHeaderPanel:function() {
  if (this.taskMainHeader) {
    this.taskMainHeader.setVisible(!this.taskMainHeader.isVisible());
  }
}, getInteractionTaskWindow:function() {
  if (!this.interactionWindow) {
    var array = Ext.ComponentQuery.query('#' + this.interactionWindowId);
    if (array.length > 0 && array[0]) {
      this.interactionWindow = array[0];
      var panel = this.interactionWindow.down(this.interactionPanelId);
      if (panel) {
        this.interactionPanel = panel;
        this.interactionModuleId = panel.moduleId;
      }
    } else {
      var array = Ext.ComponentQuery.query('#' + this.interactionPanelId);
      if (array.length) {
        this.interactionWindow = array[0];
        this.interactionPanel = this.interactionWindow;
        this.interactionModuleId = this.interactionWindow.moduleId;
        return this.interactionWindow;
      } else {
        this.createDummyWindow();
      }
    }
  }
  return this.interactionWindow;
}, createDummyWindow:function() {
  this.interactionWindow = Ext.create({xtype:'window', layout:'fit', width:document.body.clientWidth * 0.8, height:document.body.clientHeight * 0.8, items:[]});
  this.interactionWindow.show();
  this.interactionModuleId = undefined;
}, setWindowIcon:function(faCls) {
  this.interactionWindow.setIconCls(mpm.Support.icon(faCls));
}, addTaskToWindow:function(btns, size) {
  var win = this.getInteractionTaskWindow();
  if (win) {
    size = size || this.viewMode || 'l';
    if (size === 'xl') {
      this.notify('WINDOW SIZE CHANGE TO: ' + size, 'd');
      this.interactionWindow.setWidth(document.body.clientWidth * 0.95);
      this.interactionWindow.setHeight(document.body.clientHeight * 0.95);
      this.interactionWindow.center();
    }
    if (!this.interactionPanel) {
      this.interactionPanel = this.interactionWindow;
    }
    if (this.interactionPanel) {
      this.interactionPanel.removeAll();
      this.interactionPanel.setLayout('fit');
      this.interactionPanel.setScrollable(false);
      this.interactionPanel.setStyle({backgroundColor:'#DEDEE4'});
      this.interactionPanel.add(this.wrapper);
      btns = btns || this.getTaskActionButtonsCfgs();
      if (btns && btns.length) {
        this.interactionPanel.addDocked({xtype:'toolbar', dock:'bottom', style:'background-color:' + mpm.Support.styling.tableview['background-color'] + '!important;', defaults:{task:this}, items:[{xtype:'tbfill'}].concat(btns || []).concat([{xtype:'tbfill'}])});
      }
    }
  }
  this.setWindowIcon('fa-tasks');
  this.addModuleJump();
}, closeInteractionWindow:function() {
  if (this.interactionWindow) {
    var window$1 = this.interactionWindow.up('window');
    if (window$1) {
      window$1.close();
    } else {
      this.interactionWindow.close();
    }
  }
}, getTaskInfoGridCfg:function() {
  var $jscomp$this = this;
  this.taskNotificationStore.sort('time', 'ASC');
  var logLevel = {warn:{c:'orange', icon:'exclamation-triangle'}, info:{c:'black', icon:'exclamation-circle'}, debug:{c:'black', icon:'info-circle'}, error:{c:'red', icon:'exclamation-square'}};
  return {xtype:'grid', title:'Notifications', iconCls:mpm.Support.icon('fa-flag'), dockedItems:[{xtype:'toolbar', dock:'top', padding:'3 3 3 3', items:Object.keys(logLevel).map(function(level) {
    return {xtype:'button', ui:'secondary', margin:'1 1 1 1', style:'border: 1px solid ' + logLevel[level].c + ';', text:level.toUpperCase(), level:level, handler:function(b) {
      $jscomp$this.taskNotificationStore.clearFilter();
      var filter = new Ext.util.Filter({property:'level', value:level});
      $jscomp$this.taskNotificationStore.addFilter([filter]);
    }};
  }).concat([{xtype:'button', ui:'secondary', margin:'1 1 1 1', style:'border: 1px solid black;', text:'RESET', handler:function(b) {
    $jscomp$this.taskNotificationStore.clearFilter();
  }}])}], columns:[{dataIndex:'time', xtype:'datecolumn', text:'TIME', format:'d.m.Y H:i:s.u', width:200}, {dataIndex:'level', text:'', width:40, renderer:function(v) {
    var m = logLevel;
    return m[v] ? mpm.Support.getSpanForIconCls(mpm.Support.icon(m[v].icon), m[v].c) : '';
  }}, {dataIndex:'level', text:'LEVEL', renderer:function(v) {
    return v && v.length ? v.toUpperCase() : 'INFO';
  }}, {dataIndex:'msg', text:'MESSAGE', flex:1}], store:this.taskNotificationStore};
}, getMessageViewerCmp:function(closable, reference) {
  return Ext.create({xtype:'taskMessageViewer', mpmModuleId:this.mpmModuleId, task:this, dataUrl:this.dataUrl, process:this.isConfig.meta.process, ref:reference, closable:Ext.isDefined(closable) ? closable : false});
}, applyMpmInstanceId:function(config) {
  config = config === void 0 ? {} : config;
  var moduleId;
  if (Ext.isObject(config) && config.meta && Ext.isObject(config.meta) && config.meta.moduleId) {
    moduleId = config.meta.moduleId;
  } else {
    moduleId = mpm.Support.getFirstMpmInstance();
  }
  this.mpmModuleId = moduleId;
}, request:function(url, params) {
  return mpm.Support.request(url, params, this.mpmModuleId);
}, getSubmitUrl:function(formId, interactionModuleId) {
  formId = formId || (dataIS || {}).form || '';
  if (formId.length === 0) {
    if (this.interactionPanel) {
      var $jscomp$destructuring$var36 = this.interactionPanel;
      var form = $jscomp$destructuring$var36.form;
      var formName = $jscomp$destructuring$var36.formName;
      formId = form || formName || '';
      if (formId.length !== 0) {
        return 'cxf/bpc-interaction/tasks/task/submit/' + formId + '?instanceId\x3d' + interactionModuleId + '\x26amp;userName\x3dbpcadmin';
      }
    }
    console.log('please report to mpm maintainer if you read this', this);
    var $jscomp$destructuring$var37 = $jscomp.makeIterator(Object.keys(dataIS).filter(function(k) {
      return (k || '').endsWith('_form');
    }));
    var key = $jscomp$destructuring$var37.next().value;
    if (key) {
      formId = dataIS[key];
    }
  }
  return 'cxf/bpc-interaction/tasks/task/submit/' + formId + '?instanceId\x3d' + interactionModuleId + '\x26amp;userName\x3dbpcadmin';
}, getFieldDataAsObject:function() {
  var fields = this.submitAnswersOnly ? this.wrapper.down('mpmAnswerContainerRow').query('[name]') : this.wrapper.query('[name]');
  Ext.log({dump:fields, msg:'fields'});
  var map = {};
  fields = fields.filter(function(f) {
    var addFieldToDTO = false;
    addFieldToDTO = !f.hasOwnProperty('skipValue');
    return addFieldToDTO;
  });
  Ext.log({dump:fields, msg:'filtered fields'});
  fields.map(function(f) {
    var $jscomp$destructuring$var38 = f || {};
    var xtype = $jscomp$destructuring$var38.xtype;
    var name = $jscomp$destructuring$var38.name;
    var value = f.getValue();
    map[name] = Ext.isDate(value) ? Ext.Date.format(value, f.mpmSubmitFormat || 'd.m.Y') : value;
    if (xtype && xtype === 'mpmGrid') {
      map[name + 'Array'] = f.getValue(true);
    }
  });
  Ext.log({dump:map, msg:'(form) data obj'});
  return map;
}, submitAnswersOnly:false, createFormObjectFromValue:function(data) {
  var formData = new FormData();
  var obj = this.getFieldDataAsObject();
  Ext.iterate(obj, function(k, v) {
    formData.append(k, v);
  });
  formData.append('submitter', data);
  formData.append('submitId', data);
  formData.append('hiddenSubmitIS', data);
  return formData;
}, submit:function(btn) {
  var $jscomp$this = this;
  var value = btn._initValue ? btn._initValue : this.submitValue;
  interaction.Support.submitViaExtJs('POST', this.getSubmitUrl(undefined, this.interactionModuleId), this.createFormObjectFromValue(value)).then(function(r) {
    $jscomp$this.closeInteractionWindow();
  }, function(r) {
    $jscomp$this.notify('ERROR:' + r.status, 'e');
    Ext.toast({html:mpm.Support.TR('SUBMIT_ERROR') + ' ' + 'Status: ' + r.status, width:200, anchor:$jscomp$this.wrapper});
  });
}, show:function() {
  Ext.log('DEPRECATED: Show called');
}, notify:function(msg, level) {
  level = level === void 0 ? 'i' : level;
  var levels = {i:'info', d:'debug', e:'error', w:'warn'};
  var logEntry = {};
  if (msg && Ext.isString(msg)) {
    logEntry.msg = msg;
    logEntry.level = levels[level] || level || 'info';
    logEntry.time = new Date();
  } else {
    logEntry = msg || {};
    if (logEntry.level && levels[logEntry.level]) {
      logEntry.level = levels[logEntry.level];
    }
  }
  this.taskNotificationStore.add(logEntry);
  if (level === 'w') {
    try {
      if (this.taskFormWrapper && this.taskFormWrapper.setInfoButtonMode) {
        this.taskFormWrapper.setInfoButtonMode();
      }
    } catch (e) {
    }
  }
}, swapComponents:function(componentName) {
  var cardLayout = this.wrapper.getLayout();
  cardLayout.setActiveItem(this[componentName]);
  var showInfo = componentName === 'taskInfoComponent';
  this.showFormButton.setVisible(showInfo);
  if (!this.errorTask) {
    this.dryRunButton.setVisible(!showInfo);
  }
}, createTaskInfoComponent:function() {
  this.taskInfoComponent = Ext.create({xtype:'mpmTaskInfo', flex:1, task:this});
}, add:function(cmp) {
  if (this.taskFormWrapper) {
    return this.taskFormWrapper.add(cmp);
  } else {
    this.notify('Wrapper not defined');
  }
}, getDictionary:function(dictionaryId) {
  dictionaryId = dictionaryId === void 0 ? '' : dictionaryId;
  this.notify('FETCHING DICTIONARY: ' + dictionaryId);
  var dictionary = mpm.Support.getDictionary(dictionaryId, this.mpmModuleId);
  this.notify('DICTIONARY ' + dictionary && dictionary.length ? 'FOUND' : 'NOT FOUND');
  return dictionary;
}, createWrapper:function(cfg) {
  cfg = cfg === void 0 ? {} : cfg;
  this.taskNotificationStore = mpm.util.Store.newLocalStore();
  cfg.msg = '';
  this.taskFormWrapper = Ext.create(Ext.apply({}, {xtype:'tasksMainWrapper', task:this}, cfg));
  return this.taskFormWrapper;
}, setWrapper:function(cfg) {
  var taskForm = this.createWrapper(cfg);
  var container = Ext.create({xtype:'container', layout:'card'});
  container.add(taskForm);
  this.wrapper = container;
  taskForm.setTaskDescription();
}, createTabPanel:function(customTabConfigs, customComponents) {
  customTabConfigs = customTabConfigs === void 0 ? [] : customTabConfigs;
  customComponents = customComponents === void 0 ? [] : customComponents;
  var tabpanel = Ext.create({xtype:'tabpanel', tabBar:{style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';', defaults:{overCls:''}}, flex:2});
  if (customTabConfigs && customTabConfigs.length) {
    customTabConfigs.map(function(cfg) {
      return tabpanel.add(cfg);
    });
  }
  if (customComponents.length) {
    customComponents.map(function(c) {
      return tabpanel.add(c);
    });
  }
  this._tabPanel = tabpanel;
  return tabpanel;
}, createAndShowDTOPreview:function(data) {
  data = data || this.getFieldDataAsObject();
  Ext.create('Ext.window.Window', {title:'DTO Preview', iconCls:mpm.Support.icon('info'), height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.7, layout:'fit', style:'background-color:#DEDEE4!important;', items:[{xtype:'mpmPanel', layout:{type:'vbox', align:'stretch'}, items:[{xtype:'mpmPanel', items:[{xtype:'displayfield', value:'DTO sent to interaction (task) backend'}, {xtype:'displayfield', value:'Inside the interaction backend, some of these data values are might getting transformed due to implicit XSLT logic.'}]}, 
  {flex:1, xtype:'mpmEditor', title:'DTO', iconCls:mpm.Support.icon('fa-receipt'), copyEnabled:true, editorLanguage:'json', readOnly:true, value:JSON.stringify(data, undefined, 4)}]}], bbar:[{xtype:'tbfill'}, {text:mpm.Support.TR('close'), ui:'primary', iconAlign:'top', scale:'large', iconCls:mpm.Support.icon('fa-times'), handler:function(b) {
    b.up('window').close();
  }}]}).show();
}, createDryRunButton:function() {
  var $jscomp$this = this;
  return Ext.create({xtype:'button', text:'DRY RUN', hidden:!BpcCommon.Api.hasUserAnyRole(BpcCommon.Api.getSetting(this.mpmModuleId, 'mpmDebugRole')), tooltip:mpm.Support.TR('DTO_PREVIEW'), key:'dry-run', iconCls:mpm.Support.icon('fa-play'), _submitValue:'dry-run', ui:'secondary', handler:function() {
    $jscomp$this.createAndShowDTOPreview();
  }});
}, getTaskActionButtonsCfgs:function(btnDefinitions, beforeButtons) {
  var $jscomp$this = this;
  btnDefinitions = btnDefinitions === void 0 ? [] : btnDefinitions;
  beforeButtons = beforeButtons === void 0 ? [] : beforeButtons;
  var btns = beforeButtons;
  var definedButtons = btnDefinitions.map(function(btnDef) {
    btnDef.text = btnDef.text || btnDef.label;
    var btnCfg = {text:btnDef.text ? btnDef.text : mpm.Support.TR(btnDef.key), key:btnDef.key, isSubmit:['SEND'].indexOf(btnDef.value) !== -1, _initValue:btnDef.value, _submitValue:btnDef.value, ui:'primary', handler:function(b) {
      b.task.submit(b);
    }};
    if (btnDef.iconKey) {
      btnCfg.iconCls = mpm.Support.icon(btnDef.iconKey);
    }
    if (!Ext.isDefined(btnCfg._initValue)) {
      btnCfg.itemId = 'submitBtn';
    }
    if (!Ext.isDefined(btnCfg._initValue)) {
      btnCfg.disabled = true;
    }
    return btnCfg;
  });
  btns = btns.concat(definedButtons);
  this.dryRunButton = this.createDryRunButton();
  this.showFormButton = Ext.create({xtype:'button', ui:'secondary', text:'SHOW FORM', iconCls:mpm.Support.icon('fa-tasks'), tooltip:'Go back to the form', hidden:true, handler:function() {
    $jscomp$this.swapComponents('taskFormWrapper');
  }});
  btns.push(this.dryRunButton);
  btns.push(this.showFormButton);
  return btns.concat([{xtype:'tbfill'}, {text:mpm.Support.TR('TASK_CLOSE_WINDOW'), iconCls:mpm.Support.icon('times-circle'), ui:'secondary', handler:function() {
    $jscomp$this.closeInteractionWindow();
  }}]).map(function(b) {
    b.margin = '0 5 0 5';
    return b;
  });
}, getButtonsFromTaskDefinition:function(meta) {
  var btns = meta.buttons || [];
  btns = this.parseToArray(btns);
  var buttons = btns.map(function(btn) {
    var btnX = btn || {};
    if (btnX.value === '' || btnX.value === 'null' || btnX.value === null) {
      btnX.value = undefined;
    }
    if (btnX.icon) {
      btnX.iconKey = btnX.icon;
    }
    delete btnX.icon;
    if (btnX.langKey) {
      btnX.key = btnX.langKey;
    }
    delete btnX.langKey;
    return btnX;
  });
  Ext.log({dump:buttons, msg:'buttons from config'});
  if (buttons.length === 0) {
    buttons.push({value:'SEND', text:'Senden (generic)', icon:'fa-bug'});
  }
  return buttons;
}, getBelegdatenWrapperCfg:function() {
  return {xtype:'mpmPanel', title:'Belegdaten', iconCls:mpm.Support.icon(mpm.Support.keys.icons.belegdaten), layout:{type:'vbox', align:'stretch'}, items:[{xtype:'mpmPanel', header:false, items:[{xtype:'mpmDictionaryCombo', name:'lieferrichtung', fieldLabel:'Lieferrichtung', readOnly:true, dto:this.dto, task:this}]}]};
}, getPositionsGrid:function(data) {
  return {xtype:'grid', task:this, flex:1, style:'border:0px!important;', store:mpm.util.Store.newLocalStore(data), columns:[{dataIndex:'posnr', width:100}, {dataIndex:'periodeBeginn'}, {dataIndex:'periodeEnde'}].map(function(c) {
    if (!c.hasOwnProperty('width')) {
      c.flex = 1;
    }
    c.text = mpm.Support.TR('COL_' + c.dataIndex.toUpperCase());
    return c;
  })};
}, getItemFromMetaProcess:function(config, prop) {
  config = config === void 0 ? {} : config;
  var meta = config.meta || {};
  var process = meta.process || {};
  return process[prop] ? process[prop] : undefined;
}, noHeader:false, taskMeta:undefined, viewMode:undefined, taskMainHeader:undefined, initConfigurableTask:function(config, readOnly, implicitHeader, useBaseHeader) {
  readOnly = readOnly === void 0 ? false : readOnly;
  implicitHeader = implicitHeader === void 0 ? true : implicitHeader;
  useBaseHeader = useBaseHeader === void 0 ? false : useBaseHeader;
  this.getInteractionTaskWindow();
  this.applyMpmInstanceId(config);
  this.isConfig = config;
  this.dto = config.dto || {};
  var meta = config.meta || {};
  this.taskMeta = meta;
  this.viewMode = meta.viewMode && ['l', 'xl'].indexOf((meta.viewMode || '').toLowerCase()) !== -1 ? meta.viewMode : 'l';
  if (useBaseHeader) {
    readOnly = true;
  }
  this.setWrapper({task:this, msg:'', meta:meta}, {readOnly:readOnly});
  if ((implicitHeader || useBaseHeader) && !this.noHeader) {
    var headerXType = this.taskBaseHeader ? this.taskBaseHeader : this.tabPrefix + 'HeaderSimple';
    if (useBaseHeader) {
      headerXType = 'mpmBaseHeader';
    }
    this.taskMainHeader = this.add({xtype:headerXType, readOnly:readOnly, dto:this.dto, task:this});
  }
  this.addLogsToStore(config);
  if (meta.taskNote) {
    this.handleTaskNotification(meta.taskNote);
  }
}, handleTaskNotification:function(objOrStr) {
  objOrStr = Ext.isString(objOrStr) ? {note:objOrStr} : objOrStr || {note:null, position:null, key:null};
  return this.add({xtype:'mpmContainer', layout:'center', items:[{xtype:'container', width:'60%', style:{backgroundColor:'orange', textAlign:'center'}, html:objOrStr.note || '-1'}]});
}, addLogsToStore:function(config) {
  var $jscomp$this = this;
  if (config.logs) {
    config.logs.map(function(i) {
      $jscomp$this.notify(i);
    });
  }
}, parseToArray:function(objectOrArray) {
  if (Ext.isObject(objectOrArray)) {
    return [objectOrArray];
  }
  if (Ext.isArray(objectOrArray)) {
    return objectOrArray;
  }
  return [];
}, parseToArrayWithScope:function(key, view) {
  if (view.dto[key]) {
    var data = view.dto[key];
    if (Ext.isObject(data)) {
      return [data];
    }
    if (Ext.isArray(data)) {
      return data;
    }
  }
}, isFieldDefinedAsHidden:function(dtoKey) {
  var $jscomp$destructuring$var39 = this.isConfig.meta;
  var meta = $jscomp$destructuring$var39.meta;
  var $jscomp$destructuring$var40 = meta || {};
  var fields = $jscomp$destructuring$var40.fields;
  return ((fields || {})[dtoKey] || {}).hidden;
}});
Ext.define('mpm.tasks.MpmTask', {extend:'mpm.tasks.Task', requires:['mpm.tasks.Task'], fields:{}, branches:{}, log:function(str) {
  console.log(str);
}, handleTaskSpecificFields:function() {
  var $jscomp$this = this;
  var branches = Object.keys(this.branches);
  this.log('Defined Branches: ' + branches.join(', '));
  branches.filter(function(branch) {
    return branch !== $jscomp$this.taskBranch;
  }).map(function(branch) {
    $jscomp$this.log('Hiding fields for: ' + branch);
    var fieldsToHide = $jscomp$this.branches[branch] || [];
    $jscomp$this.hideFieldsByName(fieldsToHide);
  });
}, getGridWithSimpleDataIndexes:function(name, dataIndexes, readOnly, icon) {
  var $jscomp$this = this;
  name = name === void 0 ? '' : name;
  dataIndexes = dataIndexes === void 0 ? [] : dataIndexes;
  readOnly = readOnly === void 0 ? true : readOnly;
  icon = icon === void 0 ? 'database' : icon;
  return Ext.create({xtype:'mpmGrid', readOnly:readOnly, name:name, iconCls:mpm.Support.icon(icon), flex:1, task:this, padding:'5 5 5 5', _columns:dataIndexes.map(function(dataIndex) {
    var hidden = false;
    if (dataIndex.indexOf('_') !== -1) {
      var parts = dataIndex.split('_');
      dataIndex = parts[0];
      hidden = $jscomp$this.taskBranch !== parts[1];
    }
    if (dataIndex.indexOf(':') !== -1) {
      return {hidden:hidden, dataIndex:dataIndex.split(':')[0], field:{type:'dic', dataKey:dataIndex.split(':')[0]}};
    }
    return {dataIndex:dataIndex, hidden:hidden};
  })});
}, createBaseTabs:function(tabs, readOnly) {
  var $jscomp$this = this;
  tabs = tabs === void 0 ? ['nbGlobalBelegdaten', 'nbGlobalMarktlokation', 'meldepunkte', 'geraete', 'obis', 'endkunde', 'lieferanschrift', 'ablesekarte', 'marktpartner'] : tabs;
  readOnly = readOnly === void 0 ? false : readOnly;
  var tabpanel = this.createTabPanel(tabs.map(function(t) {
    var customTitle = undefined;
    if (Ext.isObject(t)) {
      customTitle = t.title;
      t = t.name;
    }
    var component = $jscomp$this.getContentTab(t, readOnly);
    if (customTitle) {
      component.setTitle(customTitle);
    }
    return component;
  }));
  tabpanel.setActiveTab(0);
  tabpanel.setFlex(1);
  this.add(tabpanel);
}, handleCustomFields:function() {
  this.notify('TASK IMPLEMENTS CUSTOM_FIELDS', 'd');
  if (this.dto) {
    var items = Object.keys(this.dto).filter(function(name) {
      name = name || '';
      return name.startsWith('custom_');
    }).map(function(customFieldKey) {
      return {key:customFieldKey};
    });
    if (items.length) {
      this.notify('TASK HAS CUSTOM_FIELDS ' + items.length + ' : ' + items.map(function(item) {
        return item.key;
      }).join(', '), 'i');
      this.add({xtype:'mpmPanel', items:this.createFields(this.updateHeaderFields(items))});
    }
  }
}, updateHeaderFields:function(items) {
  return mpm.Support.updateFieldsWithDataFromMeta(this.isConfig.meta, items, this);
}, setFieldsRequired:function(arrayWithNames, required) {
  var $jscomp$this = this;
  arrayWithNames = arrayWithNames === void 0 ? [] : arrayWithNames;
  if (!Ext.isDefined(required)) {
    required = true;
  }
  if (arrayWithNames.length) {
    arrayWithNames.map(function(name) {
      var field = $jscomp$this.wrapper.down('[name\x3d' + name + ']');
      if (field) {
        field.allowBlank = !required;
        if (!required) {
          field.clearInvalid();
        }
        $jscomp$this.notify('FIELD SET REQUIRED: ' + field.name + ' -\x3e ' + String(required));
      } else {
        $jscomp$this.notify('FIELD SPECIFIED AS REQUIRED - NOT FOUND: ' + name, 'w');
      }
    });
  }
}, hideFieldsByName:function(arrayWithNames) {
  var $jscomp$this = this;
  arrayWithNames = arrayWithNames === void 0 ? [] : arrayWithNames;
  if (arrayWithNames.length) {
    arrayWithNames.map(function(name) {
      var field = $jscomp$this.wrapper.down('[name\x3d' + name + ']');
      if (field) {
        $jscomp$this.hideField(field);
      } else {
        $jscomp$this.notify('FIELD SPECIFIED AS HIDDEN - NOT FOUND: ' + name, 'w');
      }
    });
  }
}, setEmptyTextByName:function(name, text, customValidations) {
  text = text === void 0 ? '' : text;
  customValidations = customValidations === void 0 ? [] : customValidations;
  var field = this.wrapper.down('[name\x3d' + name + ']');
  if (field) {
    field.setEmptyText(text);
    field.formatInfo = text;
    field.customFieldValidations = customValidations;
  } else {
  }
}, hideField:function(f) {
  f.allowBlank = true;
  f.skipValue = true;
  f.hide();
  this.notify('FIELD HIDDEN: ' + f.name);
}, getBaseObject:function() {
  return {dto:this.dto, task:this};
}, getGenericPanel:function(title, itemsLeft, itemsRight) {
  title = title === void 0 ? '' : title;
  itemsLeft = itemsLeft === void 0 ? [] : itemsLeft;
  itemsRight = itemsRight === void 0 ? [] : itemsRight;
  return Ext.apply({xtype:'mpmGenericDataPanel', title:title, itemsLeft:itemsLeft, itemsRight:itemsRight}, this.getBaseObject());
}, inheritableStatics:{init:function(data, logs) {
  logs = logs === void 0 ? [] : logs;
  var dto = data && data.root && data.root.data ? data.root.data : {};
  if (dto && Ext.isObject(dto.Geraete)) {
    Object.keys(dto.Geraete).map(function(k) {
      dto[k] = Ext.isObject(dto.Geraete[k]) ? [dto.Geraete[k]] : Ext.isArray(dto.Geraete[k]) ? dto.Geraete[k] : [];
    });
  }
  return new this({data:data, task:data.root && data.root.meta ? data.root.meta : {name:'', description:''}, dto:dto, meta:data.root.meta || {}, logs:logs});
}}, addValidation:function() {
  var $jscomp$this = this;
  this.validateAndToggle();
  for (var key in this.fields) {
    this.fields[key].on('change', function(c, newVal, oldVal) {
      $jscomp$this.validateAndToggle();
    });
  }
}, validateAndToggle:function() {
  this.toggleSend(this.validateFields());
}, validateFields:function() {
  var fields = this.wrapper.query('[allowBlank\x3dfalse]');
  var validations = fields.map(function(f) {
    var isValid = f.validate();
    if (!isValid) {
      console.log('field not valid', f);
    }
    return isValid;
  });
  return validations.indexOf(false) === -1;
}, toggleSend:function(valid) {
  var btn = this.interactionWindow.down('[isSubmit\x3dtrue]');
  if (btn) {
    btn.setDisabled(!valid);
  }
}, createFields:function(fieldDefinitions, matchWithFields, extraParams) {
  return mpm.Support.createFields(fieldDefinitions, matchWithFields, extraParams, this);
}, getUseCase:function() {
  var config = this.isConfig || {};
  var $jscomp$destructuring$var41 = config;
  var meta = $jscomp$destructuring$var41.meta;
  var $jscomp$destructuring$var42 = meta || {};
  var usecase = $jscomp$destructuring$var42.usecase;
  return usecase;
}, getItemFromMetaProcess:function(config, prop) {
  config = config === void 0 ? {} : config;
  var meta = config.meta || {};
  var process = meta.process || {};
  return process[prop] ? process[prop] : undefined;
}, idValue:undefined, flexTableModuleId:undefined, addFlextableHistoryGrid:function(idValue, prefix) {
  this.idValue = idValue;
  if (prefix) {
    var models = BpcCommon.Api.getModuleInstances('flextable').getData().getRange();
    var ids = models.map(function(m) {
      return m.get('moduleId');
    });
    ids = ids.map(function(id) {
      return {moduleId:id, tablePrefix:BpcCommon.Api.getSetting(id, 'tablePrefix')};
    });
    var matches = ids.filter(function(item) {
      return item.tablePrefix === prefix;
    });
    if (matches.length) {
      this.flexTableModuleId = matches[0].moduleId;
    }
  } else {
    this.flexTableModuleId = BpcCommon.Api.getSetting(this.mpmModuleId, 'routingFlextableId');
  }
  if (this.flexTableModuleId) {
    this.flextable = Ext.create({xtype:'flextableMain', isBpcModule:false, moduleId:this.flexTableModuleId, showToolbars:false, idKey:Ext.isDefined(this.idValue) ? false : undefined, onTableCreated:this.onTableCreated.bind(this)});
  } else {
    this.flextable = Ext.create({xtype:'panel', html:'Flextable Routing Id ist nicht gesetzt. Bitte konfigurieren.'});
  }
  this.flextable.setTitle(mpm.Support.TR('Verarbeitungshistorie'));
  this.flextable.setIconCls(mpm.Support.icon('fa-history'));
  return this.addToTabPanel(this.flextable);
}, addToTabPanel:function(cmp) {
  this._tabPanel.add(cmp);
}, onTableCreated:function() {
  if (Ext.isDefined(this.idValue)) {
    this.flextable.grid.changeExtraParams({id:this.idValue});
    this.flextable.grid.flexContext = {processId:this.idValue};
  }
  var sortColumn = BpcCommon.Api.getSetting(this.flexTableModuleId, 'idColumnDetailSub');
  this.flextable.grid.store.on('load', function(s, records, success, operation) {
    if (sortColumn && sortColumn.length) {
      s.sort(sortColumn);
    }
  }.bind(this));
  this.flextable.load();
}, getLieferanschft:function(readOnly) {
  var $jscomp$this = this;
  readOnly = readOnly === void 0 ? false : readOnly;
  return {xtype:'mpmGenericDataPanel', title:'Lieferanschrift', mpmKey:'lieferanschrift', iconCls:mpm.Support.icon('user'), itemsLeft:[{key:'lieferanschriftStrasse'}, {key:'lieferanschriftHausnummer'}, {key:'lieferanschriftPLZ'}, {key:'lieferanschriftOrt'}, {key:'lieferanschriftOrtsteil'}, {key:'lieferanschriftLand', type:'dic', dataKey:'Land'}].map(function(i) {
    i.sliceLabelPrefix = 'lieferanschrift';
    i.readOnly = readOnly;
    return i;
  }), itemsRight:[{key:'lieferanschriftHinweis', type:'textarea'}].map(function(i) {
    i.sliceLabelPrefix = 'lieferanschrift';
    i.readOnly = readOnly;
    return i;
  }).concat([{xtype:'button', hidden:readOnly, iconCls:mpm.Support.icon('copy'), text:'Werte aus Reiter Endkunde übernehmen', handler:function(btn) {
    var panel = $jscomp$this.wrapper.down('mpmGenericDataPanel[mpmKey\x3dendkunde]');
    if (panel) {
      var values = {};
      panel.query('field').map(function(f) {
        values[f.name.replace('letztverbraucher', '')] = f.getValue();
      });
      btn.up('mpmGenericDataPanel').query('field').map(function(f) {
        Object.keys(values).map(function(name) {
          if (f.name.endsWith(name)) {
            f.setValue(values[name]);
          }
        });
      });
    }
  }}]), dto:this.dto, task:this};
}, getAblesekarte:function(readOnly) {
  var $jscomp$this = this;
  readOnly = readOnly === void 0 ? false : readOnly;
  return {xtype:'mpmGenericDataPanel', title:'Ablesekarte', iconCls:mpm.Support.icon('user'), itemsLeft:[{key:'ablesekarteKundenTyp', type:'dic', dataKey:'kundentyp', listeners:{change:function(c, newVal, oldVal) {
    if (newVal) {
      ['ablesekarteVorname', 'ablesekarteTitel'].map(function(name) {
        $jscomp$this.wrapper.down('[name\x3d' + name + ']').setVisible(newVal === 'Z01');
      });
    }
    $jscomp$this.validateAndToggle();
  }}}, {key:'ablesekarteName', allowBlank:false}, {key:'ablesekarteVorname'}, {key:'ablesekarteTitel'}, {key:'ablesekarteZusaetzlicheNamensangabe'}, {key:'ablesekarteKundennummerAltlieferant'}].map(function(i) {
    i.sliceLabelPrefix = 'ablesekarte';
    if (readOnly) {
      i.allowBlank = true;
      i.readOnly = readOnly;
    }
    return i;
  }), itemsRight:[{key:'ablesekarteHinweis'}, {key:'ablesekarteStrasse', allowBlank:false}, {key:'ablesekarteHausnummer', allowBlank:false}, {key:'ablesekartePLZ', allowBlank:false}, {key:'ablesekarteOrt', allowBlank:false}, {key:'ablesekarteOrtsteil'}, {key:'ablesekarteLand', allowBlank:false, type:'dic', dataKey:'Land'}].map(function(i) {
    i.sliceLabelPrefix = 'ablesekarte';
    if (readOnly) {
      i.allowBlank = true;
      i.readOnly = readOnly;
    }
    return i;
  }).concat([{xtype:'button', iconCls:mpm.Support.icon('copy'), text:'Werte aus Reiter Endkunde übernehmen', hidden:readOnly, handler:function(btn) {
    var panel = $jscomp$this.wrapper.down('mpmGenericDataPanel[mpmKey\x3dendkunde]');
    if (panel) {
      var values = {};
      panel.query('field').map(function(f) {
        values[f.name.replace('letztverbraucher', '')] = f.getValue();
      });
      btn.up('mpmGenericDataPanel').query('field').map(function(f) {
        Object.keys(values).map(function(name) {
          if (f.name.endsWith(name)) {
            f.setValue(values[name]);
          }
        });
      });
    }
  }}]), dto:this.dto, task:this};
}, createAndAddTabpanel:function(config) {
  config = config === void 0 ? [] : config;
  var t = this.createTabPanel(config);
  t.setActiveTab(0);
  t.setFlex(1);
  this.add(t);
}, handleAcceptReject:function(reject) {
}, getReadOnlyFromFields:function(readOnly, name) {
  if (this.taskMeta) {
    var $jscomp$destructuring$var43 = this.taskMeta;
    var fields = $jscomp$destructuring$var43.fields;
    fields = fields || {};
    var field = fields[name];
    field = field || {};
    if (field.readOnly) {
      readOnly = field.readOnly;
    }
  }
  return readOnly;
}, getContentTab:function(tabName, readOnly) {
  readOnly = readOnly === void 0 ? false : readOnly;
  if (tabName === 'endkunde') {
    return Ext.apply({}, this.getKundendaten(undefined, readOnly), this.getBaseObject());
  }
  if (tabName === 'ablesekarte') {
    return Ext.apply({}, this.getAblesekarte(readOnly), this.getBaseObject());
  }
  if (tabName === 'lieferanschrift') {
    return Ext.apply({}, this.getLieferanschft(readOnly), this.getBaseObject());
  }
  if (tabName === 'zaehlernummern') {
    return Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('COUNTER_IDS'), iconCls:mpm.Support.icon('database'), name:'zaehleinrichtungsdaten', flex:1, task:this, readOnly:this.getReadOnlyFromFields(readOnly, 'zaehleinrichtungsdaten'), padding:'5 5 5 5', _columns:[{dataIndex:'zaehlernummer'}]});
  }
  if (tabName === 'meldepunkte') {
    return Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('MELDEPUNKTE'), iconCls:mpm.Support.icon('database'), name:'messlokationen', flex:1, task:this, readOnly:this.getReadOnlyFromFields(readOnly, 'messlokationen'), padding:'5 5 5 5', _columns:['messlokation', {dataIndex:'abrechnungmessstellenbetriebnna'}, {dataIndex:'spannungsebene', hidden:this.taskBranch !== 'strom'}, {dataIndex:'gasqualitaet', hidden:this.taskBranch !== 'gas'}].filter(function(col) {
      return !col.hidden;
    })});
  }
  if (tabName === 'marktpartner') {
    return Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('MARKTPARTNER'), iconCls:mpm.Support.icon('database'), name:'marktpartner', flex:1, task:this, readOnly:this.getReadOnlyFromFields(readOnly, 'marktpartner'), padding:'5 5 5 5', _columns:[{dataIndex:'mpid', text:'Marktpartner-ID'}, {dataIndex:'rolle', text:'Rolle'}, {dataIndex:'name'}, {dataIndex:'meldepunkt'}]});
  }
  if (tabName === 'obis') {
    return Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('OBIS'), iconCls:mpm.Support.icon('database'), name:'obisdaten', flex:1, task:this, readOnly:this.getReadOnlyFromFields(readOnly, 'obisdaten'), padding:'5 5 5 5', _columns:[{dataIndex:'meldepunkt'}, {dataIndex:'kennzahl'}, {dataIndex:'schwachlastfaehig', hidden:this.taskBranch !== 'strom'}, {dataIndex:'kennzeichnungZaehlwerk'}, {dataIndex:'zaehlernummer'}, {dataIndex:'vorkommastellen'}, {dataIndex:'nachkommastellen'}, 
    {dataIndex:'verwendungszwecke', hidden:this.taskBranch !== 'strom'}, {dataIndex:'verbrauchsart', hidden:this.taskBranch !== 'strom'}, {dataIndex:'unterbrechbarkeit', hidden:this.taskBranch !== 'strom'}, {dataIndex:'waermenutzung', hidden:this.taskBranch !== 'strom'}, {dataIndex:'konzessionsabgabeCode'}, {dataIndex:'konzessionsabgabeWert'}, {dataIndex:'konzessionsabgabeGebuehrenkategorie'}, {dataIndex:'steuerinformation', hidden:this.taskBranch !== 'strom'}].filter(function(col) {
      return !col.hidden;
    })});
  }
  if (tabName === 'geraete') {
    return Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('GERAETE'), iconCls:mpm.Support.icon('database'), name:'geraete', flex:1, task:this, readOnly:this.getReadOnlyFromFields(readOnly, 'geraete'), padding:'5 5 5 5', _columns:[{dataIndex:'messlokation'}, {dataIndex:'geraetenummer'}, {dataIndex:'zaehlernummer'}, {dataIndex:'zaehlertyp', field:{type:'dic', dataKey:'zaehlertyp'}}, {dataIndex:'zaehlerGroesse'}, {dataIndex:'tarifanzahl', hidden:this.taskBranch !== 'strom', field:{type:'dic', 
    dataKey:'tarifanzahl'}}, {dataIndex:'energierichtung', hidden:this.taskBranch !== 'strom', field:{type:'dic', dataKey:'energierichtung'}}, {dataIndex:'fernschaltung', hidden:this.taskBranch !== 'strom', field:{type:'dic', dataKey:'fernschaltung'}}, {dataIndex:'messwerterfassung', field:{type:'dic', dataKey:'messwerterfassung'}}, {dataIndex:'referenzSmartmetergateway'}, {dataIndex:'wandlerTyp', hidden:this.taskBranch !== 'strom'}, {dataIndex:'wandlerFaktor', hidden:this.taskBranch !== 'strom', 
    field:{type:'dic', dataKey:'wandlerfaktor'}}, {dataIndex:'mengenumwerterTyp', hidden:this.taskBranch !== 'gas'}, {dataIndex:'kommunikationseinrichtungTyp', field:{type:'dic', dataKey:'wandlerfaktor'}}, {dataIndex:'technischeSteuereinrichtungTyp'}].filter(function(col) {
      return !col.hidden;
    })});
  }
  if (tabName === 'nbGlobalBelegdaten') {
    return this.getGenericPanel('Belegdaten', [{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung'}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAnmeldung'}, {key:'transaktionsgrundergaenzung'}, {key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date'}, {key:'bilanzierungsbeginn', type:'date'}, {key:'bilanzierungsende', type:'date'}, {key:'bilanzkreis'}, {key:'bilanzierungsgebiet'}, {key:'regelzone'}, {key:'marktgebiet'}].map(function(i) {
      i.readOnly = readOnly;
      return i;
    }), [{key:'identifikationslogik', type:'settingCombo', hidden:true}, {key:'startAbrechnungsjahr', type:'date'}, {key:'netznutzungsabrechnungsintervall', type:'dic', dataKey:'netznutzungsabrechnungsintervall'}, {key:'netznutzungsabrechnung', formatInfo:'MMDD || MMWW-MMWW', customFieldValidations:['^\\d{4}$', '^\\d{4}-\\d{4}$']}, {key:'naechstenetznutzungsabrechnung', formatInfo:'CCYY', customFieldValidations:['^\\d{4}$']}, {key:'netznutzungsvertrag', type:'dic', dataKey:'netznutzungsvertrag'}, 
    {key:'netznutzungszahler', type:'dic', dataKey:'netznutzungszahler'}, {key:'netznutzungsabrechnungsvariante', type:'dic', dataKey:'netznutzungsabrechnungsvariante'}, {key:'netznutzungsabrechnungsgrundlage', type:'dic', dataKey:'netznutzungsabrechnungsgrundlage'}, {key:'singulaergenutztebetriebsmittelnna', type:'dic', dataKey:'singulaergenutztebetriebsmittelnna', hidden:this.taskBranch !== 'strom'}, {key:'abrechnungsintervallLF', type:'dic', dataKey:'period'}, {key:'gemeinderabatt'}, {key:'turnusableseintervall', 
    type:'dic', dataKey:'turnusableseintervall', hidden:this.taskBranch !== 'strom'}, {key:'geplanteTurnusablesung', formatInfo:'MMDD || MMWW-MMWW', customFieldValidations:['^\\d{4}$', '^\\d{4}-\\d{4}$'], hidden:this.taskBranch !== 'strom'}].map(function(i) {
      i.readOnly = readOnly;
      return i;
    }));
  }
  if (tabName === 'nbGlobalMarktlokation') {
    return this.getGenericPanel('Marktlokation', [{key:'spannungsebene', type:'dic', dataKey:'spannungsebenemessung'}, {key:'druckebene', type:'dic'}, {key:'fallgruppenzuordnung', type:'dic', dataKey:'fallgruppenzuordnung'}, {key:'gruppenzuordnung', type:'dic', dataKey:'gruppenzuordnung'}, {key:'aggregationsverantwortung', type:'dic', dataKey:'aggregationsverantwortungLF'}, {key:'messtechnischeeinordnung', type:'dic', dataKey:'messtechnischeeinordnung'}, {key:'prognosegrundlage', type:'dic', dataKey:'prognosegrundlage'}, 
    {key:'prognosegrundlageDetails', type:'dic', dataKey:'prognosegrundlageDetails'}, {key:'prognosegrundlageWahlrecht', type:'dic', dataKey:'prognosegrundlageWahlrecht'}, {key:'TUMKundenwert'}, {key:'veranschlagtejahresmenge'}, {key:'verbrauchsaufteilung'}].map(function(i) {
      i.readOnly = readOnly;
      return i;
    }), [{key:'arbeitleistungtagesparameterabhmaloType', hidden:this.taskBranch !== 'strom'}, {key:'arbeitleistungtagesparameterabhmaloMenge', hidden:this.taskBranch !== 'strom'}, {key:'arbeitleistungtagesparameterabhmaloEinheit', hidden:this.taskBranch !== 'strom'}, {key:'lastprofilklassentyp', type:'dic', dataKey:'lastprofilklassentyp'}, {key:'lastprofilverfahren', type:'dic', dataKey:'lastprofilZuordnung'}, {key:'lastprofilcode'}, {key:'lastprofilverantwortungCode'}, {key:'lastprofilschar'}, {key:'lastprofiltemperaturmessstelleCode'}, 
    {key:'lastprofiltemperaturmessstelleID'}, {key:'lastprofiltemperaturmessstelleDienstanbieter'}, {key:'lastprofiltemperaturmessstelleVerantwortungCode'}, {key:'zeitreihentyp', type:'dic', dataKey:'zeitreihentyp'}, {key:'zeitreihentypTLP', type:'dic', dataKey:'zeitreihentypTLP'}].map(function(i) {
      i.readOnly = readOnly;
      return i;
    }));
  }
}, getKundendaten:function(filterObj, readOnly) {
  var $jscomp$this = this;
  readOnly = readOnly === void 0 ? false : readOnly;
  filterObj = filterObj || {remove:[]};
  return {xtype:'mpmGenericDataPanel', mpmKey:'endkunde', title:mpm.Support.TR('END_CUSTOMER'), iconCls:mpm.Support.icon('user'), itemsLeft:[{key:'letztverbraucherKundenTyp', type:'dic', dataKey:'kundentyp', listeners:{change:function(c, newVal, oldVal) {
    if (newVal) {
      ['letztverbraucherVorname', 'letztverbraucherTitel'].map(function(name) {
        $jscomp$this.wrapper.down('[name\x3d' + name + ']').setVisible(newVal === 'Z01');
      });
    }
  }}}, {key:'letztverbraucherName'}, {key:'letztverbraucherVorname'}, {key:'letztverbraucherTitel'}, {key:'letztverbraucherZusaetzlicheNamensangabe'}, {key:'letztverbraucherKundennummerAltlieferant'}, {key:'letztverbraucherKundennummer'}].filter(function(i) {
    return filterObj.remove.indexOf(i.key) === -1;
  }).map(function(i) {
    i.sliceLabelPrefix = 'letztverbraucher';
    if (readOnly) {
      i.readOnly = true;
    }
    return i;
  }), itemsRight:[{key:'letztverbraucherStrasse'}, {key:'letztverbraucherHausnummer'}, {key:'letztverbraucherPLZ'}, {key:'letztverbraucherOrt'}, {key:'letztverbraucherOrtsteil'}, {key:'letztverbraucherLand', type:'dic', dataKey:'Land'}].filter(function(i) {
    return filterObj.remove.indexOf(i.key) === -1;
  }).map(function(i) {
    i.sliceLabelPrefix = 'letztverbraucher';
    if (readOnly) {
      i.readOnly = true;
    }
    return i;
  })};
}});
Ext.define('mpm.packages.ErrorTask', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], alias:['widget.mpmGenericError'], errorTask:true, constructor:function(config) {
  this.getInteractionTaskWindow();
  this.isConfig = config;
  this.dto = config.dto;
  this.setWrapper({task:this, msg:'', meta:config.meta});
  this.addLogsToStore(config);
  this.add({xtype:'container', flex:1, layout:'center', items:[{xtype:'container', width:'80%', layout:'fit', items:[this.getTaskInfoGridCfg()]}]});
  this.addTaskToWindow();
  this.dryRunButton.setVisible(false);
  this.callParent(arguments);
  this.setWindowIcon('fa-exclamation-triangle');
}});
Ext.define('mpm.tasks.TaskInfo', {extend:'mpm.components.Panel', alias:'widget.mpmTaskInfo', layout:{type:'vbox', align:'stretch'}, scrollable:'y', initComponent:function() {
  var $jscomp$this = this;
  var hasRoot, dataInRoot, metaInRoot, metaTaskIdSet, metaDescriptionSet, metaNameSet, sparteSet;
  var dtoFromInubit;
  if (this.task) {
    var $jscomp$destructuring$var44 = this.task;
    var isConfig = $jscomp$destructuring$var44.isConfig;
    var $jscomp$destructuring$var45 = isConfig || {};
    var data = $jscomp$destructuring$var45.data;
    dtoFromInubit = data;
    hasRoot = (data || {}).hasOwnProperty('root');
    if (hasRoot) {
      var $jscomp$destructuring$var46 = data;
      var root = $jscomp$destructuring$var46.root;
      dataInRoot = root.data && typeof root.data === 'object';
      metaInRoot = root.meta && typeof root.meta === 'object';
      if (metaInRoot) {
        var $jscomp$destructuring$var47 = root.meta;
        var taskId = $jscomp$destructuring$var47.taskId;
        var description = $jscomp$destructuring$var47.description;
        var name = $jscomp$destructuring$var47.name;
        var sparte = $jscomp$destructuring$var47.sparte;
        metaTaskIdSet = (taskId || '').length > 0;
        metaDescriptionSet = (description || '').length > 0;
        metaNameSet = (name || '').length > 0;
        sparteSet = (sparte || '').length > 0;
      }
    }
  }
  var def = {labelWidth:20, xtype:'checkbox', readOnly:true};
  var dtoClone = JSON.parse(JSON.stringify(dtoFromInubit)), storeData = [];
  var textFieldDefaults = {xtype:'textfield', labelWidth:120, readOnly:true, fieldStyle:'background-color:#f7f7ec;'};
  this.checkContainer = Ext.create({xtype:'mpmFieldSet', title:'Task Analyser', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'mpmContainer', padding:'5 5 5 5', flex:1, layout:'mpmForm'}, items:[{defaults:def, items:[{boxLabel:'root (Object)', boxLabelAttrTpl:'data-qtip\x3d"root property in DTO defined"', value:hasRoot}, {boxLabel:'data in Root (Object)', value:dataInRoot}, {boxLabel:'meta in Root (Object)', value:metaInRoot}]}, {defaults:def, items:[{boxLabel:'taskId ', value:metaTaskIdSet}, 
  {boxLabel:'name', value:metaNameSet}, {boxLabel:'description', value:metaDescriptionSet}]}, {defaults:def, items:[{boxLabel:this.TR('BRANCH'), value:sparteSet}]}, {defaults:textFieldDefaults, flex:2, items:['processId', 'prefix', 'package'].map(function(name) {
    var value;
    try {
      var root$2 = dtoClone.root || {};
      var meta = root$2.meta || {};
      var process = meta.process || {};
      value = Ext.Object.isEmpty(process) ? 'meta.process not set' : process[name] || name + ' not set';
    } catch (e) {
      value = 'Error: properly set?';
    }
    return {fieldLabel:$jscomp$this.TR(name), value:value, emptyText:$jscomp$this.TR('EMPTY')};
  })}, {defaults:textFieldDefaults, flex:2, items:['types'].map(function(name) {
    var value;
    try {
      if (dtoClone.root.meta.messageViewer) {
        value = dtoClone.root.meta.messageViewer[name];
      } else {
        value = 'messageViewer not set';
      }
    } catch (e) {
      value = ' ! ';
    }
    return {fieldLabel:$jscomp$this.TR(name), value:value, emptyText:$jscomp$this.TR('EMPTY')};
  }).concat([{fieldLabel:this.TR('TASKID'), value:dtoClone.root.meta.taskId}, {fieldLabel:this.TR('BRANCH'), value:sparteSet ? dtoClone.root.meta.sparte : '-1'}])}]});
  if (dataInRoot) {
    storeData = Object.keys(dtoClone.root.data).map(function(key) {
      var value = dtoClone.root.data[key];
      var getType = function(val) {
        if (Ext.isDefined(val)) {
          if (Ext.isString(val)) {
            return 'String';
          } else if (Ext.isNumber(val)) {
            return 'Number';
          } else if (Ext.isObject(val)) {
            return 'Object';
          } else if (Ext.isArray(val)) {
            return 'Array';
          } else if (Ext.isBoolean(val)) {
            return 'Boolean';
          } else {
            return 'Something Else' + val;
          }
        }
        return 'Not defined' + val;
      };
      return {key:key, initValue:value, initType:getType(value)};
    });
  }
  this.tabPanel = Ext.create({xtype:'tabpanel', tabBar:{style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';', defaults:{overCls:''}}, flex:1});
  this.definitionsGrid = Ext.create({xtype:'grid', scrollable:'y', title:'DTO Analyser', viewConfig:{emptyText:this.TR('NO_DATA_FOUND'), enableTextSelection:true}, iconCls:this.faIcon('analytics'), columns:[{dataIndex:'key', width:200}, {dataIndex:'key', text:'Label (auto)', width:200, renderer:function(v) {
    v = v || '';
    return v.length ? mpm.Support.capitalizeFirstLetter(v) : v;
  }}, {dataIndex:'initValue', width:300}, {dataIndex:'initType', width:120}, {dataIndex:'initType', text:'Details', flex:1, renderer:function(v, m, r) {
    if (v && v.toLowerCase() === 'array') {
      var arr = r.get('initValue');
      if (arr && Ext.isArray(arr)) {
        return 'Elements: ' + arr.length;
      } else {
        return 'No Array';
      }
    }
    return '';
  }}].map(function(c) {
    if (!c.width) {
      c.flex = 1;
    }
    if (!c.text) {
      c.text = $jscomp$this.TR(c.dataIndex.toUpperCase());
    }
    return c;
  }), store:this.newLocalStore(storeData)});
  this.translationDebugGrid = Ext.create({xtype:'grid', scrollable:'y', title:'Translation Debugger', viewConfig:{emptyText:this.TR('NO_DATA_FOUND'), enableTextSelection:true}, plugins:{cellediting:{clicksToEdit:1}}, iconCls:this.faIcon('analytics'), columns:[{dataIndex:'set', width:200}, {dataIndex:'key', width:300}, {dataIndex:'value', editor:{completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}}}, {dataIndex:'fieldName'}, {dataIndex:'notes'}, {dataIndex:'sliceLabelPrefix'}].map(function(c) {
    if (!c.width) {
      c.flex = 1;
    }
    c.text = $jscomp$this.TR(c.dataIndex.toUpperCase());
    return c;
  }), store:this.newLocalStore(this.task.translationDebug), bbar:[{text:'DL to console', handler:function(b) {
    var cfg = {};
    b.up('grid').getStore().each(function(r) {
      if (r.get('editable')) {
        var k = r.get('key');
        if (k in cfg) {
        } else {
          cfg[r.get('key')] = r.get('value');
        }
      }
    });
    Ext.log({dump:cfg, msg:'translationsToApply'});
  }}]});
  this.tabPanel.add(this.definitionsGrid);
  this.tabPanel.add(this.getRawDTOTab(dtoClone));
  if (this.task.loadedPages && this.task.loadedPages.length) {
    this.task.loadedPages.map(function(page) {
      $jscomp$this.tabPanel.add($jscomp$this.getRawDTOTab(page.data, page.method));
    });
  }
  this.tabPanel.add(this.translationDebugGrid);
  this.tabPanel.add(this.task.getTaskInfoGridCfg());
  var docStoreData = this.task.dictionaryValues || [];
  var dicColumns = docStoreData.length ? Object.keys(docStoreData[0]).map(function(key) {
    return {dataIndex:key, text:key.toUpperCase(), flex:1};
  }) : [];
  var btn = Ext.create({xtype:'button', text:docStoreData.length + ' Entries', iconCls:this.faIcon('fa-database')});
  this.tabPanel.add({title:'Dictionary Data', iconCls:this.faIcon('fa-book'), xtype:'grid', viewConfig:{emptyText:'NO DATA'}, columns:dicColumns, store:this.newLocalStore(docStoreData), bbar:[btn, {xtype:'button', text:'Source ' + this.task.dictionarySource}, {xtype:'tbfill'}]});
  this.tabPanel.setActiveTab(this.definitionsGrid);
  this.items = [this.checkContainer, {xtype:'mpmSplitter'}, {xtype:'container', layout:'fit', flex:1, items:[this.tabPanel]}];
  this.callParent(arguments);
}, getRawDTOTab:function(dto, method) {
  return {title:method ? 'DTO ' + method : 'DTO RAW', iconCls:this.faIcon('file-alt'), xtype:'mpmEditor', value:JSON.stringify(dto, undefined, 4)};
}});
Ext.define('mpm.packages.generic.DataPanel', {extend:'mpm.components.Panel', alias:'widget.mpmGenericDataPanel', layout:{type:'hbox', align:'stretch'}, itemsLeft:undefined, itemsRight:undefined, title:mpm.Support.TR('DEFAULT_TAB_TITLE'), scrollable:true, iconCls:undefined, flexLeft:1, flexRight:1, initComponent:function() {
  var $jscomp$this = this;
  if (this.iconCls === null || !Ext.isDefined(this.iconCls)) {
    this.iconCls = mpm.Support.icon('fa-file');
  }
  this.defaults = {xtype:'mpmFieldSet', flex:1};
  var itemsLeft = this.itemsLeft || [], itemsRight = this.itemsRight || [];
  var headerLeft = itemsLeft.map(function(i) {
    return i;
  }), headerRight = itemsRight.map(function(i) {
    i.labelWidth = 200;
    return i;
  });
  this.items = [{flex:this.flexLeft, items:this.createFields(this.customizeFields(headerLeft))}, {flex:this.flexRight, items:this.createFields(this.customizeFields(headerRight))}];
  this.tabConfig = {listeners:{mouseover:function(t) {
    if ($jscomp$this.isTabActive()) {
      return;
    }
    $jscomp$this.hideOtherTooltips();
    if (!$jscomp$this.panelTip) {
      $jscomp$this.panelTip = Ext.create('Ext.tip.ToolTip', {target:t.getEl(), html:'', showDelay:0, listeners:{beforeshow:function(t) {
        if ($jscomp$this.isTabActive()) {
          return false;
        }
        var ttObj = {};
        $jscomp$this.getTooltipData().map(function(obj) {
          var k = (obj.tr || '').trim().length > 0 ? obj.tr : obj.key || '';
          ttObj[k] = obj.value || '';
        });
        t.update(mpm.Support.objectToHtmlTable(ttObj, 400, 180));
      }}, autoHide:false});
    }
    $jscomp$this.panelTip.show();
  }, mouseout:function(t) {
    if ($jscomp$this.panelTip) {
      $jscomp$this.panelTip.hide();
    }
  }}};
  this.callParent(arguments);
}, isTabActive:function(t) {
  var tp = this.up('tabpanel');
  if (tp) {
    var active = tp.getActiveTab();
    return active && active.id === this.id;
  }
  return false;
}, hideOtherTooltips:function() {
  var tp = this.up('tabpanel');
  if (tp) {
    tp.query('mpmGenericDataPanel').map(function(p) {
      if (p && p.panelTip && p.panelTip.isVisible()) {
        p.panelTip.hide();
      }
    });
  }
}, createFields:function(fields) {
  return this.task.createFields(fields, undefined, undefined, this.task);
}, customizeFields:function(items) {
  return mpm.Support.updateFieldsWithDataFromMeta(this.task.isConfig.meta, items, this.task);
}, getTooltipData:function() {
  return this.query('field').filter(function(f) {
    return !f.hidden;
  }).map(function(f) {
    return {key:f.key, tr:f.getFieldLabel() || '', value:f.getValue() || ''};
  });
}});
Ext.define('mpm.packages.generic.GlobalGpkeHeader', {extend:'mpm.components.Container', alias:'widget.mpmBaseHeader', layout:{type:'hbox', align:'stretch'}, padding:'0 0 0 0', readOnly:false, handleInlineFieldsDefinitions:function(i) {
  i = i === void 0 ? {} : i;
  if (this.task.taskFieldDefinitions) {
    var hardCodedTaskDefinitions = this.task.taskFieldDefinitions || {};
    if (hardCodedTaskDefinitions[i.key]) {
      var $jscomp$destructuring$var48 = hardCodedTaskDefinitions[i.key] || {};
      var type = $jscomp$destructuring$var48.type;
      var params = $jscomp$destructuring$var48.params;
      var forceIdLoading = $jscomp$destructuring$var48.forceIdLoading;
      var hidden = $jscomp$destructuring$var48.hidden;
      if (type) {
        i.type = type;
      }
      if (forceIdLoading) {
        i.forceIdLoading = forceIdLoading;
      }
      if (hidden) {
        i.hidden = hidden;
      }
      if (params) {
        i.params = Ext.apply({}, params, i.params || {});
      }
    }
  }
  return i;
}, initComponent:function() {
  var $jscomp$this = this;
  this.defaults = {xtype:'mpmFieldSet', flex:1};
  var headerLeft = [{key:'kategorie', type:'dic', dataKey:'kategorie', readOnly:true}, {key:'sender', type:'remoteCombo', valueField:'mpid', displayField:'partnername', params:{field:'sender'}}, {key:'empfaenger', valueField:'mpid', type:'remoteCombo', displayField:'partnername', params:{field:'empfaenger'}}, {key:'ansprechpartner', type:'remoteCombo', valueField:'ID', displayField:'NAME', params:{field:'ansprechpartner'}}, {key:'meldepunkt', type:'remoteCombo', params:{field:'meldepunkt'}}, {key:'messlokation', 
  type:'remoteCombo', params:{field:'messlokation'}}, {key:'marktlokation', type:'remoteCombo', params:{field:'marktlokation'}}].map(function(i) {
    if (!i.hasOwnProperty('readOnly')) {
      i.readOnly = $jscomp$this.readOnly;
    }
    i = $jscomp$this.handleInlineFieldsDefinitions(i);
    return i;
  });
  var headerRight = [{key:'nachrichtendatum', type:'date', format:'d.m.Y H:i:s'}, {key:'vorgangsnummer'}, {key:'refVorgangsnummer'}, {key:'fristtermin', type:'date', readOnly:true}, {type:'date', key:'gueltigkeitbeginn', readOnly:true}].map(function(i) {
    if (!i.hasOwnProperty('readOnly')) {
      i.readOnly = $jscomp$this.readOnly;
    }
    i = $jscomp$this.handleInlineFieldsDefinitions(i);
    i.labelWidth = 200;
    return i;
  });
  var items = [{items:this.task.createFields(this.updateHeaderFields(headerLeft)), itemId:'headerLeft', title:'Allgemein', scrollable:true}];
  var k1 = 'MARKTPARTNER_ANSPRECHPARTNER'.toLowerCase(), k2 = 'MANDANT_ANSPRECHPARTNER'.toLowerCase();
  if (this.dto[k1]) {
    items.push({items:mpm.Support.getKontaktDatenFields(this.dto[k1], this.task), title:'Ansprechpartner (MP)'});
  }
  if (this.dto[k2]) {
    items.push({items:mpm.Support.getKontaktDatenFields(this.dto[k2], this.task), title:'Ansprechpartner'});
  }
  items.push({items:this.task.createFields(this.updateHeaderFields(headerRight)), itemId:'headerRight', title:'Nachricht', scrollable:true});
  this.items = items;
  this.callParent(arguments);
}, hideFieldsByDtoName:function(names) {
  var $jscomp$this = this;
  names = names === void 0 ? [] : names;
  names.map(function(name) {
    var field = $jscomp$this.down('[name\x3d' + name + ']');
    if (field) {
      return field;
    } else {
      $jscomp$this.task.notify('FIELD SPECIFIED AS HIDDEN - NOT FOUND: ' + name, 'w');
      return undefined;
    }
  }).filter(function(field) {
    return typeof field !== 'undefined';
  }).map(function(f) {
    return f.task.hideField(f);
  });
}, addValidationsGrid:function() {
  var validationGrid = Ext.create({xtype:'mpmValidationsGrid', header:false, dto:this.dto, task:this.task});
  this.task.validationGrid = validationGrid;
  this.add({items:[validationGrid], layout:'fit', title:'Prüfungen / Hinweise'});
}, updateHeaderFields:function(items) {
  return mpm.Support.updateFieldsWithDataFromMeta(this.task.isConfig.meta, items, this.task);
}});
Ext.define('mpm.packages.generic.InfoTask', {extend:'mpm.components.Panel', alias:'widget.genericInfoTask', layout:{type:'vbox', align:'stretch'}, dto:undefined, task:undefined, meta:undefined, taskLayout:undefined, header:false, initComponent:function() {
  var items;
  if (this.taskLayout && Ext.isObject(this.taskLayout)) {
    this.taskLayout = [this.taskLayout];
  }
  if (this.taskLayout && Ext.isArray(this.taskLayout)) {
    items = this.parseTaskLayout(this.taskLayout);
  } else {
    var fieldDefinitions = Object.keys(this.dto).map(function(k) {
      return {labelWidth:250, key:k};
    });
    items = {xtype:'mpmFieldSet', title:'Formular', items:this.task.createFields(fieldDefinitions, this.matchWithMetaFields)};
  }
  this.items = items;
  this.callParent(arguments);
}, parseTaskLayout:function(layout) {
  var $jscomp$this = this;
  layout = layout || [];
  return layout.map(function(row, i) {
    if (Ext.isString(row) && row.trim() === 'header') {
      return {xtype:'mpmBaseHeader', flex:1, task:$jscomp$this.task, dto:$jscomp$this.dto};
    }
    var rowTitle = row.title, rowHeader = [null, undefined, ''].indexOf(rowTitle) === -1;
    if (row.items && Ext.isArray(row.items)) {
      return {xtype:'mpmPanel', title:rowTitle || 'row' + ' ' + i, flex:1, layout:{type:'hbox', align:'stretch'}, header:rowHeader, iconCls:row.icon ? mpm.Support.icon(row.icon) : null, items:row.items.map(function(col, cid) {
        var columnTitle = col.title, header = [null, undefined, ''].indexOf(columnTitle) === -1;
        return Ext.apply({}, col, {xtype:'mpmPanel', iconCls:col.icon ? mpm.Support.icon(col.icon) : null, flex:1, title:columnTitle || 'col' + ' ' + cid, header:header, items:$jscomp$this.task.createFields(col.keys || [], true, {readOnly:true, labelWidth:150})});
      })};
    } else {
      return Ext.apply({}, row, {xtype:'mpmPanel', title:rowTitle || 'row' + ' ' + i, iconCls:row.icon ? mpm.Support.icon(row.icon) : null, flex:1, header:rowHeader, items:$jscomp$this.task.createFields(row.keys || [], true, {readOnly:true, labelWidth:150})});
    }
  });
}});
Ext.define('mpm.packages.generic.messages', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], alias:['widget.mpmMessageTask'], constructor:function(config) {
  this.getInteractionTaskWindow();
  this.applyMpmInstanceId(config);
  this.isConfig = config;
  this.dto = config.dto;
  this.isReadOnlyTask = true;
  this.setWrapper({task:this, msg:'', meta:config.meta});
  this.add({xtype:'genericInfoTask', collapsible:true, dto:this.dto, task:this, meta:config.meta, taskLayout:config.meta.layout ? config.meta.layout : undefined});
  this.process = config.meta.process || {};
  this.add(this.createTabPanel());
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.addFlextableHistoryGrid(this.process.processId, this.process.prefix);
}, validateFields:function() {
  var fields = this.wrapper.query('[allowBlank\x3dfalse]');
  var validations = fields.map(function(f) {
    return f.validate();
  });
  return validations.indexOf(false) === -1;
}});
Ext.define('gpke.packages.generic.customTask', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], alias:['widget.mpmCustomTask'], constructor:function(config) {
  var packageName = this.getItemFromMetaProcess(config, 'package') || '';
  var isGpkeNb = packageName.toLowerCase() === 'gpkenb';
  this.initConfigurableTask(config, false, false, isGpkeNb);
  this.add({xtype:'genericInfoTask', matchWithMetaFields:true, padding:'10 10 10 10', flex:1, dto:this.dto, task:this, meta:config.meta, taskLayout:config.meta.layout ? config.meta.layout : undefined});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('mpm.packages.generic.MasterData', {extend:'mpm.tasks.MpmTask', alias:['widget.gpkeSdae'], hiddenFieldDefaults:{gas:['bilanzierungsgebiet', 'regelzone', 'marktlokation', 'spannungsebene', 'spannungsebene', 'verbrauchsaufteilung', 'zeitreihentyp', 'messtechnischeeinordnung', 'aggregationsverantwortung', 'prognosegrundlageWahlrecht', 'netznutzungsabrechnungsgrundlage', 'singulaergenutztebetriebsmittelnna'], strom:['marktgebiet', 'startAbrechnungsjahr', 'marktlokation', 'druckebene', 'TUMKundenwert', 
'fallgruppenzuordnung']}, taskUseCase:undefined, constructor:function(config) {
  var readOnly = true;
  this.initConfigurableTask(config, readOnly, false, true);
  var branch = this.getBranch();
  this.taskUseCase = this.getUseCase() || '-1';
  if (this.dto.validation && Ext.isArray(this.dto.validation)) {
    this.wrapper.down('mpmBaseHeader').addValidationsGrid();
    this.validationGrid.store.add({name:this.taskUseCase, cbValue:true, value:true});
  }
  this.wrapper.down('#headerRight').add({xtype:'mpmTextfield', name:'gueltigkeitbeginn', readOnly:readOnly, dto:this.dto, task:this});
  this.createBaseTabs(undefined, readOnly);
  var infoTab = this._tabPanel.insert(0, {xtype:'mpmGenericDataPanel', title:'Information', itemsLeft:[{key:'changeData', readOnly:readOnly}], dto:this.dto, task:this});
  this._tabPanel.setActiveTab(infoTab);
  this.hideFieldsByName(this.hiddenFieldDefaults[branch] || []);
  this.applyTaskSubmitDictionary();
  var confirmValues = this.getConfirmValues();
  var rejectValues = this.getRejectValues();
  if (confirmValues.length === 0) {
    this.notify('NO ACCEPT VALUES.', 'w');
  }
  if (rejectValues.length === 0) {
    this.notify('NO REJECT VALUES FOUND.', 'w');
  }
  this.handleCustomFields();
  var task = this;
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', hideEmpty:true, task:task, defaultType:'radiofield', _values:confirmValues, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', defaultType:'radiofield', _name:'reject', hideEmpty:true, task:task, _values:rejectValues})});
  this.submitAnswersOnly = true;
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}, customRejectCodes:[], customAcceptCodes:[], submitDictionary:[], applyTaskSubmitDictionary:function() {
  var meta = this.taskMeta || {};
  var $jscomp$destructuring$var49 = meta;
  var submit = $jscomp$destructuring$var49.submit;
  var $jscomp$destructuring$var50 = submit || {};
  var reject = $jscomp$destructuring$var50.reject;
  var accept = $jscomp$destructuring$var50.accept;
  var dictionary = $jscomp$destructuring$var50.dictionary;
  this.customRejectCodes = reject || [];
  this.customAcceptCodes = accept || [];
  var dictionaryKey = dictionary || 'gpkeSdae';
  this.notify('USING DICTIONARY ID: ' + dictionaryKey + ' USECASE: ' + this.taskUseCase);
  this.submitDictionary = this.getWfDictionary(dictionaryKey) || [];
}, getConfirmValues:function() {
  var $jscomp$this = this;
  return this.submitDictionary.filter(function(i) {
    if (i.usecase) {
      return i.usecase.indexOf($jscomp$this.taskUseCase) !== -1;
    }
    return true;
  }).filter(function(i) {
    return i.flag === 'accept' && i.branch === $jscomp$this.taskBranch;
  }).map(function(i) {
    return {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key};
  }).filter(function(i) {
    if ($jscomp$this.customAcceptCodes.length) {
      return $jscomp$this.customAcceptCodes.indexOf(i.inputValue) !== -1;
    }
    return true;
  });
}, getRejectValues:function() {
  var $jscomp$this = this;
  return this.submitDictionary.filter(function(i) {
    if (i.usecase) {
      return i.usecase.indexOf($jscomp$this.taskUseCase) !== -1;
    }
    return true;
  }).filter(function(i) {
    return i.flag === 'reject' && i.branch === $jscomp$this.taskBranch;
  }).map(function(i) {
    return {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key};
  }).filter(function(i) {
    if ($jscomp$this.customRejectCodes.length) {
      return $jscomp$this.customRejectCodes.indexOf(i.inputValue) !== -1;
    }
    return true;
  });
}});
Ext.define('mpm.packages.generic.mailView', {extend:'mpm.components.Panel', alias:'widget.mpmMailView', layout:'fit', protocolData:undefined, initComponent:function() {
  var $jscomp$this = this;
  this.title = mpm.Support.TR('MAIL');
  this.iconCls = mpm.Support.icon('fa-envelope');
  this.callParent(arguments);
  if (Ext.Object.isEmpty(this.protocolData)) {
    this.html = 'NO DATA FOUND - ENVELOPEXML EMPTY';
  } else {
    this.add({xtype:'mpmPanel', header:false, items:Object.keys(this.protocolData).map(function(name) {
      var field = {xtype:'textfield'};
      if (name.trim().toLowerCase() === 'bodytext') {
        field.xtype = 'textarea';
        field.grow = true;
      }
      field.fieldLabel = mpm.Support.TR('MAIL_' + name);
      field.value = $jscomp$this.protocolData[name];
      field.name = name;
      return field;
    })});
  }
}});
Ext.define('mpm.packages.generic.measurementsGrid', {extend:'mpm.components.Panel', alias:'widget.mpmMeasurementsGrid', mixins:['mpm.mixins.Component'], layout:'fit', protocolData:undefined, moduleId:undefined, initComponent:function() {
  this.title = this.TR('MPM_MEASUREMENT_VALUES_PLUGIN_TITLE');
  this.iconCls = this.faIcon('fa-analytics');
  if (!this.moduleId) {
    this.moduleId = mpm.Support.getFirstMpmInstance();
  }
  this.callParent(arguments);
  if (this.protocolData && Ext.isObject(this.protocolData) && Ext.Object.isEmpty(this.protocolData)) {
    this.html = this.TR('NO_DATA');
  } else {
    var $jscomp$destructuring$var51 = this.protocolData;
    var positions = $jscomp$destructuring$var51.positions;
    this.add({xtype:'grid', store:mpm.util.Store.newLocalStore(positions), viewConfig:{enableTextSelection:true, emptyText:this.TR('NO_DATA')}, header:false, columns:this.createColumns(positions)});
  }
}, createColumns:function(positions) {
  var $jscomp$this = this;
  positions = positions === void 0 ? [] : positions;
  return (BpcCommon.Api.getSetting(this.moduleId, 'measurementColumns') || []).map(function(colDef) {
    var $jscomp$destructuring$var52 = colDef;
    var dataIndex = $jscomp$destructuring$var52.dataIndex;
    var renderer = $jscomp$destructuring$var52.renderer;
    var width = $jscomp$destructuring$var52.width;
    var align = $jscomp$destructuring$var52.align;
    var dictionary = $jscomp$destructuring$var52.dictionary;
    if (renderer && $jscomp$this.getRenderer(renderer)) {
      renderer = renderer && $jscomp$this.getRenderer(renderer) ? $jscomp$this.getRenderer(renderer) : false;
      width = 150;
    } else if (dictionary) {
      renderer = $jscomp$this.getRenderer(undefined, dictionary);
    }
    var column = {dataIndex:dataIndex, renderer:renderer};
    column.text = $jscomp$this.TR('COL_' + dataIndex);
    if (positions.length) {
      column.hidden = !positions.map(function(obj) {
        return obj[dataIndex] || '';
      }).filter(function(value) {
        return value && value.length;
      }).length;
    }
    if (align) {
      column.align = align;
    }
    if (width) {
      column.width = width;
    } else {
      column.flex = 1;
    }
    return column;
  });
}, getRenderer:function(rendererName, dictionaryKey) {
  var $jscomp$this = this;
  var renderer = {date_dmyhis:function(v, m, r) {
    return $jscomp$this.parseAndDisplayDate(v, 'd.m.Y H:i:s');
  }};
  if (rendererName && !rendererName.startsWith('dictionary')) {
    return renderer[rendererName] ? renderer[rendererName] : undefined;
  } else {
    return function(v, m, r) {
      var renderedValue = $jscomp$this.getValueFromDictionary(dictionaryKey, v);
      if (Ext.isArray(v)) {
        renderedValue = v.map(function(obj) {
          if (Ext.isString(obj)) {
            return $jscomp$this.getValueFromDictionary(dictionaryKey, obj);
          } else {
            return 'String expected';
          }
        });
        renderedValue = renderedValue.join(', ');
        v = JSON.stringify(v);
      }
      m.tdAttr = "data-qtip\x3d'" + mpm.Support.objectToHtmlTable({original:v, rendered:renderedValue}) + "'";
      return renderedValue || v || '';
    };
  }
}, parseAndDisplayDate:function(v, format) {
  format = format === void 0 ? 'd.m.Y' : format;
  var init = v;
  try {
    v = Ext.Date.format(Ext.Date.parse(v, 'c'), format);
  } catch (e) {
  }
  return v || init;
}, getValueFromDictionary:function(dictionary, value) {
  value = value === void 0 ? '' : value;
  value = Ext.isString(value) ? value : String(value);
  var translations = mpm.Support.getDictionary(dictionary);
  var match = translations.filter(function(item) {
    return item.key === value;
  });
  return match.length ? mpm.Support.dicItemFormatter(match[0], this.moduleId) : value;
}});
Ext.define('gpke.lf', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], tabPrefix:'gpkeLf', taskBaseHeader:'mpmBaseHeader', branches:{strom:['bilanzierungsgebiet', 'geplanteTurnusablesung', 'regelzone', 'spannungsebene', 'spannungsebene', 'verbrauchsaufteilung', 'zeitreihentyp', 'messtechnischeeinordnung', 'aggregationsverantwortung', 'prognosegrundlageWahlrecht', 'netznutzungsabrechnungsgrundlage', 'singulaergenutztebetriebsmittelnna'], gas:['marktgebiet', 'startAbrechnungsjahr', 'druckebene', 
'TUMKundenwert', 'fallgruppenzuordnung']}, kuendigungsterminFormat:undefined, getBaseTabs:function(readOnly) {
  return [this.getBelegdatenTab(readOnly), this.getMaloTab(readOnly), this.getMeloGrid(readOnly), this.getDeviceGrid(readOnly), this.getObisMalo(readOnly), this.getObisMelo(readOnly), this.getContentTab('endkunde', readOnly), this.getContentTab('lieferanschrift', readOnly), this.getContentTab('ablesekarte', readOnly), this.getMarktpartner(readOnly)];
}, handleBaseTabs:function(tabs) {
  tabs = tabs === void 0 ? [] : tabs;
  var tabpanel = this.createTabPanel(tabs);
  tabpanel.setActiveTab(0);
  tabpanel.setFlex(2);
  this.add(tabpanel);
}, getObisMalo:function() {
  return this.getGridWithSimpleDataIndexes('obisdatenMalo', ['kennzahl', 'schwachlastfaehig:dic', 'verwendungszwecke:dic', 'verbrauchsart:dic_strom', 'unterbrechbarkeit:dic_strom', 'waermenutzung:dic_strom', 'konzessionsabgabeCode:dic', 'konzessionsabgabeWert', 'konzessionsabgabeGebuehrenkategorie', 'steuerinformation:dic']);
}, getObisMelo:function() {
  return this.getGridWithSimpleDataIndexes('obisdatenMelo', ['referenztyp:dic', 'referenznummer', 'messlokation', 'konfigurationsid', 'kennzahl', 'wertegranularitaet:dic', 'zaehlzeit_strom', 'zaehlzeitregister_strom', 'vorkommastellen', 'nachkommastellen', 'kennzeichnungZaehlwerk', 'schwachlastfaehig:dic_strom']);
}, getMarktpartner:function() {
  return this.getGridWithSimpleDataIndexes('marktpartner', ['meldepunkt', 'rolle:dic', 'name', 'mpid', 'artleistungserbringung:dic']);
}, getMaloTab:function(readOnly) {
  return {xtype:'mpmGenericDataPanel', title:'Marktlokationsdaten', itemsLeft:[{key:'spannungsebene', type:'dic', dataKey:'spannungsebenemessung'}, {key:'druckebene'}, {key:'fallgruppenzuordnung', type:'dic', dataKey:'fallgruppenzuordnung'}, {key:'gruppenzuordnung', type:'dic', dataKey:'gruppenzuordnung'}, {key:'aggregationsverantwortung', type:'dic', dataKey:'aggregationsverantwortungLF'}, {key:'messtechnischeeinordnung', type:'dic', dataKey:'messtechnischeeinordnung'}, {key:'prognosegrundlage', 
  type:'dic', dataKey:'prognosegrundlage'}, {key:'prognosegrundlageDetails', type:'dic', dataKey:'prognosegrundlageDetails'}, {key:'prognosegrundlageWahlrecht', type:'dic', dataKey:'prognosegrundlageWahlrecht'}, {key:'TUMKundenwert'}, {key:'veranschlagtejahresmenge'}, {key:'verbrauchsaufteilung'}].map(function(e) {
    if (readOnly) {
      e.readOnly = readOnly;
    }
    return e;
  }), itemsRight:[{key:'arbeitleistungtagesparameterabhmaloType', type:'dic'}, {key:'arbeitleistungtagesparameterabhmaloMenge'}, {key:'arbeitleistungtagesparameterabhmaloEinheit', type:'dic'}, {key:'lastprofilklassentyp', type:'dic', dataKey:'lastprofilklassentyp'}, {key:'lastprofilverfahren', type:'dic', dataKey:'lastprofilZuordnung'}, {key:'lastprofilcode', type:'dic'}, {key:'lastprofilverantwortungCode', type:'dic'}, {key:'lastprofilschar'}, {key:'lastprofiltemperaturmessstelleCode', type:'dic'}, 
  {key:'lastprofiltemperaturmessstelleID'}, {key:'lastprofiltemperaturmessstelleDienstanbieter', type:'dic'}, {key:'lastprofiltemperaturmessstelleVerantwortungCode', type:'dic'}, {key:'zeitreihentyp', type:'dic', dataKey:'zeitreihentyp'}, {key:'zeitreihentypTLP', type:'dic', dataKey:'zeitreihentypTLP'}].map(function(e) {
    if (readOnly) {
      e.readOnly = readOnly;
    }
    return e;
  }), dto:this.dto, task:this};
}, getBelegdatenTab:function(readOnly) {
  return {xtype:'mpmGenericDataPanel', title:'Belegdaten', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic'}, {key:'transaktionsgrundergaenzung', type:'dic', dataKey:'transaktionsgrund'}, {key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date'}, {key:'bilanzierungsbeginn', type:'date'}, {key:'bilanzierungsende', type:'date'}, {key:'bilanzkreis'}, {key:'bilanzierungsgebiet'}, {key:'regelzone'}, {key:'marktgebiet'}].map(function(e) {
    if (readOnly) {
      e.readOnly = readOnly;
    }
    return e;
  }), itemsRight:[{key:'startAbrechnungsjahr'}, {key:'netznutzungsabrechnungsintervall', type:'dic', dataKey:'netznutzungsabrechnungsintervall'}, {key:'netznutzungsabrechnung'}, {key:'naechstenetznutzungsabrechnung'}, {key:'netznutzungsvertrag', type:'dic', dataKey:'netznutzungsvertrag'}, {key:'netznutzungszahler', type:'dic', dataKey:'netznutzungszahler'}, {key:'netznutzungsabrechnungsvariante', type:'dic', dataKey:'netznutzungsabrechnungsvariante'}, {key:'singulaergenutztebetriebsmittelnna', type:'dic', 
  dataKey:'singulaergenutztebetriebsmittelnna'}, {key:'abrechnungsintervallLF', type:'dic', dataKey:'period'}, {key:'gemeinderabatt'}, {key:'geplanteTurnusablesung'}].map(function(e) {
    if (readOnly) {
      e.readOnly = readOnly;
    }
    return e;
  }), dto:this.dto, task:this};
}, getDeviceGrid:function(readOnly) {
  return Ext.create({xtype:'mpmGrid', iconCls:mpm.Support.icon('database'), name:'geraete', readOnly:readOnly, flex:1, task:this, padding:'5 5 5 5', _columns:[{dataIndex:'geraetetyp'}, {dataIndex:'messlokation'}, {dataIndex:'zaehlernummer'}, {dataIndex:'zaehlertyp', field:{type:'dic', dataKey:'geraetezaehlertyp'}}, {dataIndex:'referenzGeratenummer'}, {dataIndex:'referenzSmartmeter'}, {dataIndex:'referenzMalo'}, {dataIndex:'tarifanzahl', field:{type:'dic', dataKey:'tarifanzahl'}, hidden:this.taskBranch !== 
  'strom'}, {dataIndex:'energierichtung', hidden:this.taskBranch !== 'strom', field:{type:'dic', dataKey:'energierichtung'}}, {dataIndex:'fernschaltung', hidden:this.taskBranch !== 'strom', field:{type:'dic', dataKey:'fernschaltung'}}, {dataIndex:'messwerterfassung', field:{type:'dic', dataKey:'messwerterfassung'}}, {dataIndex:'wandlerFaktor', field:{type:'dic', dataKey:'wandlerfaktor'}}, {dataIndex:'zaehlerGroesse', hidden:this.taskBranch !== 'gas'}]});
}, getMeloGrid:function(readOnly) {
  return Ext.create({xtype:'mpmGrid', iconCls:mpm.Support.icon('database'), name:'messlokationen', readOnly:readOnly, flex:1, task:this, padding:'5 5 5 5', _columns:[{dataIndex:'messlokation'}, {dataIndex:'msb'}, {dataIndex:'msbartleistungserbringung', field:{type:'dic', dataKey:'artleistungserbringung'}}, {dataIndex:'abrechnungmessstellenbetriebnna', field:{type:'dic', dataKey:'abrechnungmessstellenbetriebnna'}, hidden:this.taskBranch !== 'strom'}, {dataIndex:'spannungsebene', hidden:this.taskBranch !== 
  'strom', field:{type:'dic', dataKey:'spannungsebenemessung'}}, {dataIndex:'gasqualitaet', hidden:this.taskBranch !== 'gas'}]});
}, lfFields:{antwortFreitext:function(dto, task) {
  return Ext.create({xtype:'mpmTextarea', name:'antwortFreitext', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), dto:dto, task:task});
}, vorjahresverbrauch:function(dto, task) {
  return Ext.create({xtype:'mpmTextfield', name:'vorjahresverbrauch', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), dto:dto, task:task, hidden:true});
}, gueltigkeitbeginn:function(dto, task) {
  return Ext.create({xtype:'mpmDatefield', name:'gueltigkeitbeginn', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), label:'Nächstes Kündigungsdatum', dto:dto, task:task, hidden:true});
}, fc_vertragsende:function(dto, task) {
  return Ext.create({xtype:'fieldcontainer', layout:{type:'hbox', align:'stretch'}, name:'fc_vertragsende', skipValue:true, hidden:true, dto:task.dto, task:task, reset:function() {
    this.query('field').map(function(f) {
      f.setValue(undefined);
      f.reset();
    });
  }, validate:function() {
    if (this.allowBlank === false) {
      var definedValues = this.query('field').map(function(f) {
        var v = f.getValue();
        return Ext.isDefined(v) && v !== false && v !== null;
      });
      return definedValues.filter(function(i) {
        return i === true;
      }).length === 2;
    }
    return true;
  }, fieldLabel:'Vertragsende', items:[{xtype:'radio', boxLabel:'Kunde', name:'dateScopeSelector', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), inputValue:'k', width:80, listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    if (newVal) {
      fc.down('datefield').name = 'bestaetigtesVertragsende' + f.boxLabel;
    }
    fc.task.validateAndToggle();
  }}}, {xtype:'radio', boxLabel:'Lieferant', name:'dateScopeSelector', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), inputValue:'l', width:80, listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    if (newVal) {
      fc.down('datefield').name = 'bestaetigtesVertragsende' + f.boxLabel;
    }
    fc.task.validateAndToggle();
  }}}, {xtype:'datefield', width:120, format:'d.m.Y', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), fieldStyle:'background-color:#f7f7ec;', listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    fc.task.validateAndToggle();
  }}}]});
}, fc_kuendigungstermin:function(dto, task) {
  return Ext.create({xtype:'fieldcontainer', layout:{type:'hbox', align:'stretch'}, name:'fc_kuendigungstermin', skipValue:true, hidden:true, dto:task.dto, task:task, reset:function() {
    this.query('field').map(function(f) {
      f.setValue(undefined);
      f.reset();
    });
  }, validate:function() {
    if (this.allowBlank === false) {
      var definedValues = this.query('field').map(function(f) {
        var v = f.getValue();
        return Ext.isDefined(v) && v !== false && v !== null;
      });
      return definedValues.filter(function(i) {
        return i === true;
      }).length === 2;
    }
    return true;
  }, fieldLabel:'Kündigungstermin', items:[{xtype:'combobox', name:'formatKuendigungstermin', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), valueField:'key', displayField:'value', fieldStyle:'background-color:#f7f7ec;', store:mpm.util.Store.newLocalStore([{key:'CCYYMMDD', value:'CCYYMMDD'}, {key:'MMDD', value:'MMDD'}]), width:120, listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    fc.task.validateAndToggle();
  }}}, {xtype:'datefield', width:120, name:'kuendigungstermin', fieldStyle:'background-color:#f7f7ec;', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), format:task.kuendigungsterminFormat ? task.kuendigungsterminFormat : 'd.m.Y', listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    fc.task.validateAndToggle();
  }}}]});
}, fc_kuendigungsfrist:function(dto, task) {
  return Ext.create({xtype:'fieldcontainer', layout:{type:'hbox', align:'stretch'}, name:'fc_kuendigungsfrist', skipValue:true, hidden:true, dto:task.dto, task:task, reset:function() {
    this.query('field').map(function(f) {
      f.setValue(undefined);
      f.reset();
    });
  }, validate:function() {
    if (this.allowBlank === false) {
      var definedValues = this.query('field').map(function(f) {
        var v = f.getValue();
        return Ext.isDefined(v) && v !== false && v !== null;
      });
      return definedValues.filter(function(i) {
        return i === true;
      }).length === 3;
    }
    return true;
  }, fieldLabel:'Kündigungsfrist', items:[{xtype:'numberfield', width:80, name:'kuendigungsfristWert', fieldStyle:'background-color:#f7f7ec;', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip)}, {xtype:'combobox', width:120, fieldStyle:'background-color:#f7f7ec;', name:'kuendigungsfristEinheit', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), valueField:'key', displayField:'value', store:mpm.util.Store.newLocalStore([{key:'T', value:'Tage'}, {key:'W', value:'Wochen'}, {key:'M', 
  value:'Monate'}]), listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    fc.task.validateAndToggle();
  }}}, {xtype:'combobox', width:120, fieldStyle:'background-color:#f7f7ec;', name:'kuendigungsfristReferenz', readOnly:!!(Ext.isDefined(task) && task.isReadOnlyTaskWip), valueField:'key', displayField:'value', store:mpm.util.Store.newLocalStore([{key:'M', value:'Monatsende'}, {key:'Q', value:'Quartalsende'}, {key:'H', value:'Halbjahresende'}, {key:'J', value:'Jahresende'}, {key:'T', value:'Termin'}, {key:'R', value:'Rollierend'}]), listeners:{change:function(f, newVal, oldVal) {
    var fc = f.up('fieldcontainer');
    var fields = fc.task.wrapper.query('[name\x3dfc_kuendigungstermin]');
    var field = fields[0];
    field.setVisible(newVal && newVal === 'T');
    field.allowBlank = newVal && newVal !== 'T';
    field.query('field').map(function(f) {
      return f.setVisible(newVal && newVal === 'T');
    });
    fc.task.validateAndToggle();
  }}}]});
}}});
Ext.define('gpkelf.lf.mpmMeldepunktIdentifikation', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.mpmMeldepunktIdentifikation'], constructor:function(config) {
  var $jscomp$this = this;
  var packageName = this.getItemFromMetaProcess(config, 'package') || '';
  var isGpkeNb = packageName.toLowerCase() === 'gpkenb';
  this.taskFieldDefinitions = {sender:{forceIdLoading:true}, empfaenger:{forceIdLoading:true}, messlokation:{type:'text', hidden:true}, meldepunkt:{type:'text', hidden:true}, marktlokation:{type:'text'}, ansprechpartner:{type:'text'}};
  this.initConfigurableTask(config, true);
  var readOnly = true;
  this.wrapper.down('#headerLeft').add({xtype:'mpmTextfield', name:'pruefidentifikator', fieldLabel:'Prüfiddentifikator', readOnly:true, dto:this.dto, task:this});
  var belegdaten = {xtype:'mpmGenericDataPanel', title:'Belegdaten', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAnmeldung', readOnly:true}, {key:'lieferbeginn', type:'date', readOnly:true}, {key:'lieferende', type:'date', readOnly:true}], itemsRight:[{key:'identifikationslogik', type:'settingCombo', readOnly:true}, {key:'zusaetzlicheInformation', type:'textarea', readOnly:true}], dto:this.dto, 
  task:this};
  var g = Ext.create({xtype:'mpmGrid', barPosition:'bbar', title:mpm.Support.TR('COUNTER_IDS'), iconCls:mpm.Support.icon('database'), name:'zaehleinrichtungsdaten', readOnly:readOnly, flex:1, task:this, padding:'5 5 5 5', _columns:[{dataIndex:'zaehlernummer'}]});
  var messlokationen = Ext.create({xtype:'mpmGrid', iconCls:mpm.Support.icon('database'), name:'messlokationen', readOnly:readOnly, flex:1, task:this, padding:'5 5 5 5', _columns:[{dataIndex:'messlokation'}]});
  var tabpanel = this.createTabPanel([belegdaten, messlokationen, g, this.getContentTab('endkunde', readOnly), this.getContentTab('lieferanschrift', readOnly)]);
  tabpanel.setActiveTab(0);
  tabpanel.setFlex(2);
  var extras = this.isConfig.meta.extra || [];
  var showMeldepunktSuche = Ext.isArray(extras) ? extras.filter(function(i) {
    return i.name === 'meldepunktesuche';
  }).length > 0 : false;
  if (showMeldepunktSuche) {
    var meldepunktSuche = Ext.create({xtype:'mpmMeldepunktSuche', moduleId:this.mpmModuleId, task:this, dto:this.dto});
    tabpanel.add(meldepunktSuche);
    tabpanel.setActiveTab(meldepunktSuche);
  }
  this.notify('Meldepunktsuche: ' + (showMeldepunktSuche ? 'aktiviert' : 'nicht konfiguriert'), 'd');
  this.add(tabpanel);
  var branch = this.getBranch();
  var isAnmeldung;
  if (isGpkeNb) {
    isAnmeldung = this.dto.pruefidentifikator && this.dto.pruefidentifikator === '11001';
    if (!isAnmeldung) {
      branch = '';
      this.notify('BRANCH RESET TO EMPTY STRING - DUE TO PID 11001', 'd');
    }
  }
  var dicKey = isGpkeNb ? 'mpmMeldepunktIdentifikationNb' : 'mpmMeldepunktIdentifikation';
  var dictionary = this.getWfDictionary(dicKey) || [];
  var rejectValues = dictionary.filter(function(i) {
    return i.flag === 'reject' && i.branch === branch;
  }).map(function(i) {
    var elem = {boxLabel:$jscomp$this.formatDictionaryEntry(i), name:'antwortkategorie', inputValue:i.key};
    if (isGpkeNb) {
      if (['A16', 'A17', 'A03', 'A04'].indexOf(i.key) !== -1) {
        if (!isAnmeldung) {
          elem.hidden = true;
        }
      }
    }
    return elem;
  });
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'mpmTextfield', values:[{name:'antwortkategorie', fieldLabel:'Meldepunkt', padding:'5 5 5 5', width:400, mpmValidation:{length:[11, 33]}}]}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'checkbox', values:rejectValues}}};
  var task = this;
  this.add({xtype:'mpmAnswerContainerRow', confirmText:'Übernahme', allowBlank:false, flex:1, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:task, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', layout:'mpmForm', defaultType:definition.answer.reject.valuesType, _name:'reject', task:task, _values:definition.answer.reject.values})});
  var answerRow = this.wrapper.down('mpmAnswerContainerRow');
  answerRow.addStaticMpmFields([{xtype:'mpmTextarea', name:'antwortFreitext', dto:this.dto, task:this.task}]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)), config.meta && config.meta.viewMode ? config.meta.viewMode : 'l');
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
  var submitValues = this.isConfig.meta.submitValues || {};
  var meldePunktValue = Ext.isObject(submitValues) ? submitValues.Meldepunkt ? submitValues.Meldepunkt : undefined : undefined;
  this.notify('Vordefinierten Meldepunkt: ' + (meldePunktValue ? meldePunktValue : 'nicht gesetzt'), 'd');
  if (meldePunktValue) {
    var matches = this.wrapper.query('textfield[fieldLabel\x3dMeldepunkt]');
    matches = matches.filter(function(field) {
      return field.name === 'antwortkategorie';
    });
    if (matches.length === 1) {
      matches[0].setValue(meldePunktValue);
    }
  }
}});
Ext.define('gpkelf.lf.stammdatenanfrage', {extend:'gpke.lf', requires:['gpke.lf'], alias:'widget.gpkeLfStammdatenAenderungVersenden', constructor:function(config) {
  this.initConfigurableTask(config);
  this.getBranch();
  var belegdaten = {xtype:'mpmGenericDataPanel', title:'Belegdaten', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung'}, {key:'netznutzungsvertrag', type:'dic', dataKey:'netznutzungsvertrag'}, {key:'zahlernetznutzung', type:'dic', dataKey:'netznutzungszahler'}, {key:'gemeinderabatt'}, {key:'temperatormessstelle'}, {key:'id'}, {key:'dienstanbieter'}], itemsRight:[{key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date', readOnly:true}, {key:'aenderungZum', type:'date'}, 
  {key:'geplanteTurnusablesung'}, {key:'erstmaligeTurnusablesung'}, {key:'abrechnungsintervallLF', type:'dic', dataKey:'turnusintervall'}, {key:'startAbrechnungsjahr'}, {key:'bilanzierungsbeginn'}, {key:'bilanzierungsgebiet'}, {key:'bilanzkreis'}, {key:'regelzone'}], dto:this.dto, task:this};
  var zaehlpunktDaten = {xtype:'mpmGenericDataPanel', title:'Zählpunktdaten', itemsLeft:[{key:'lastprofilzuordnung', type:'dic', dataKey:'lastprofilzuordnung'}, {key:'lastprofilTyp', type:'dic', dataKey:'lastprofilauswahl'}, {key:'profilcode', type:'dic', dataKey:'lastprofilauswahl'}, {key:'profilcode', type:'dic', dataKey:'profilcode'}, {key:'zaehlverfahren', type:'dic', dataKey:'zaehlverfahren'}, {key:'spannungsebene_zaehlpunkt', type:'dic', dataKey:'entnahmespannung'}, {key:'spannungsebene_messung', 
  dataKey:'spannungsbemessung', type:'dic'}, {key:'gruppenzuordnung', type:'dic', dataKey:'kundengruppenzuordnung'}, {key:'verbrauchsaufteilung', type:'dic', dataKey:'verbrauchsaufteilung'}, {key:'profilchar', type:'dic', dataKey:'profilcode'}], itemsRight:[{key:'tagesparameter', type:'dic', dataKey:'tagesparameter'}, {key:'menge'}, {key:'einheit', type:'dic', dataKey:'einheit'}, {key:'veranschlagteJahresmenge'}, {key:'bishergemessenemaximalleistung'}, {key:'verlustfaktor_trafo'}, {key:'zeitreihentyp', 
  type:'dic', dataKey:'zeitreihentyp'}], dto:this.dto, task:this};
  this.handleBaseTabs([belegdaten, zaehlpunktDaten, this.getContentTab('endkunde')]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.abmeldeAnfrage', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAbmeldeanfrage'], constructor:function(config) {
  this.initConfigurableTask(config);
  var branch = this.getBranch() || '';
  var belegdaten = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dictionary', dataKey:'transaktionsgrundAbmeldungsanfrage'}, {key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date'}, {key:'dritterMarktbeteiligter'}], itemsRight:[], dto:this.dto, task:this};
  this.handleBaseTabs([belegdaten, this.getContentTab('endkunde')]);
  branch = branch.trim();
  var values = this.getWfDictionary('antwortCodesAbmeldeanfrage') || [];
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:values.filter(function(i) {
    return i.flag === 'accept' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key + ' - ' + i.value, inputValue:i.key, name:'antwortkategorie'};
  })}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:branch === 'strom' ? 'radiofield' : 'checkbox', values:values.filter(function(i) {
    return i.flag === 'reject' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key + ' - ' + i.value, inputValue:i.key, name:'reject'};
  })}}};
  var task = this;
  this.add({xtype:'mpmSplitter'});
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:task, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:task, _values:definition.answer.reject.values})});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.abmeldung', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAbmeldung'], constructor:function(config) {
  this.initConfigurableTask(config);
  var belegdaten = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dictionary', dataKey:'transaktionsgrundAbmeldungLf', allowBlank:false, listeners:{select:function(combo, record, eOpts) {
    var matches = ['ZG9', 'ZH1', 'ZH2'];
    var beginVisible = matches.indexOf(record.get('key')) === -1;
    var fields = ['lieferbeginn', 'lieferende'].map(function(name) {
      return combo.up('panel').down('[name\x3d' + name + ']');
    }).map(function(f, i) {
      f.setVisible(i === 0 ? !beginVisible : beginVisible);
      f.setDisabled(i === 0 ? beginVisible : !beginVisible);
    });
  }, change:function(c, newVal, oldVal) {
    var matches = ['ZG9', 'ZH1', 'ZH2'];
    var beginVisible = matches.indexOf(newVal) === -1;
    var fields = ['lieferbeginn', 'lieferende'].map(function(name) {
      return c.up('panel').down('[name\x3d' + name + ']');
    }).map(function(f, i) {
      f.setVisible(i === 0 ? !beginVisible : beginVisible);
      f.setDisabled(i === 0 ? beginVisible : !beginVisible);
    });
  }}}, {key:'lieferbeginn', allowBlank:false, type:'date'}, {key:'lieferende', allowBlank:false, type:'date'}], itemsRight:[{key:'zusaetzlicheInformation', type:'textarea'}], dto:this.dto, task:this};
  this.handleBaseTabs([belegdaten]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.anmeldung', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAnmeldung'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var branch = this.getBranch();
  this.hideFieldsByName(['refVorgangsnummer', 'messlokation', 'marktlokation']);
  var belegdaten = {xtype:'mpmGenericDataPanel', title:'Belegdaten', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic', allowBlank:false, dataKey:'transaktionsgrundAnmeldung'}, {key:'transaktionsgrundergaenzung', type:'dic', allowBlank:true, dataKey:'transaktionsgrundAnmeldungZ17'}, {key:'lieferbeginn', type:'date', allowBlank:false}, {key:'lieferende', type:'date', allowBlank:true, listeners:{change:function(c, newVal, oldVal) {
    var valueSet = Ext.isDefined(newVal) && newVal !== null;
    var f = $jscomp$this.wrapper.down('[name\x3dtransaktionsgrundergaenzung]');
    f.allowBlank = !valueSet;
    f.setVisible(valueSet);
    $jscomp$this.validateAndToggle();
  }}}, {key:'bilanzkreis', allowBlank:false}], itemsRight:[{key:'identifikationslogik', allowBlank:false, type:'settingCombo', listeners:{change:function(c, newVal, oldVal) {
    $jscomp$this.wrapper.down('[name\x3dmeldepunkt]').allowBlank = newVal !== 'Z12';
    $jscomp$this.wrapper.down('[name\x3dmeldepunkt]').validate();
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftStrasse]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftStrasse]').validate();
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftHausnummer]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftHausnummer]').validate();
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftPLZ]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftPLZ]').validate();
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftOrt]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dlieferanschriftOrt]').validate();
    $jscomp$this.validateAndToggle();
  }}}, {key:'abrechnungsintervallLF', allowBlank:false, type:'dic', dataKey:'period'}, {key:'netznutzungsvertrag', type:'dic', dataKey:'netznutzungsvertrag', allowBlank:false, listeners:{change:function(c, newVal, oldVal) {
    if (newVal === 'Z09') {
      $jscomp$this.wrapper.down('[name\x3dzahlernetznutzung]').setValue('Z11');
    }
    $jscomp$this.validateAndToggle();
  }}}, {key:'zahlernetznutzung', type:'dic', dataKey:'netznutzungszahler', allowBlank:false}, {key:'gemeinderabatt', allowBlank:false}, {key:'gruppenzuordnung', type:'dic', dataKey:'kundengruppenzuordnung', allowBlank:false}, {key:'grundlageEnfg', type:'dic', dataKey:'grundlageEnfg', allowBlank:branch !== 'strom'}]};
  this.add({xtype:'mpmSplitter'});
  this.handleBaseTabs([Ext.apply(belegdaten, this.getBaseObject())].concat(['endkunde', 'lieferanschrift', 'ablesekarte'].map(function(t) {
    return $jscomp$this.getContentTab(t);
  })).concat([Ext.apply({}, {xtype:'mpmGenericDataPanel', title:mpm.Support.TR('DTO_zusaetzlicheInformation'), iconCls:mpm.Support.icon('info'), itemsLeft:[{key:'zusaetzlicheInformation', type:'textarea'}]}, this.getBaseObject()), this.getContentTab('zaehlernummern')]));
  var ablesekarte = ['ablesekarteName', 'ablesekarteOrt', 'ablesekartePLZ', 'ablesekarteStrasse', 'ablesekarteLand', 'ablesekarteHausnummer'];
  var endkunde = ['letztverbraucherName', 'letztverbraucherKundenTyp', 'letztverbraucherHausnummer', 'letztverbraucherLand', 'letztverbraucherStrasse', 'letztverbraucherPLZ', 'letztverbraucherOrt'];
  var fields = ablesekarte.concat(endkunde);
  fields.map(function(name) {
    $jscomp$this.wrapper.down('[name\x3d' + name + ']').allowBlank = false;
  });
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.bda.BrennwertZustandszahl', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfBdaBrennwertZustandszahl'], constructor:function(config) {
  this.initConfigurableTask(config);
  var belegdaten = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', readOnly:true}, {key:'verarbeitungStart', type:'date', allowBlank:false}, {key:'verarbeitungEnde', type:'date', allowBlank:false}], itemsRight:[], dto:this.dto, task:this};
  this.handleBaseTabs([belegdaten]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.addValidation();
}});
Ext.define('gpkelf.lf.bda.MessdatenZaehlerstandVersand', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfBdaMessdatenZaehlerstandVersand'], constructor:function(config) {
  this.initConfigurableTask(config);
  var belegdaten = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'obis', type:'text'}, {key:'leistungsbeschreibung', type:'mpmDictionaryCombo', allowBlank:false}, {key:'verarbeitungStart', type:'date', mpmSubmitFormat:'c', allowBlank:false}, {key:'verarbeitungEnde', type:'date', mpmSubmitFormat:'c', allowBlank:false}], itemsRight:[], dto:this.dto, task:this};
  this.handleBaseTabs([belegdaten]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.meldepunktSuche', {extend:'Ext.panel.Panel', alias:'widget.mpmMeldepunktSuche', layout:{type:'vbox', align:'stretch'}, moduleId:undefined, loadDirectly:false, getDefaultFromDto:function(filterKey) {
  var dtoPrefix = 'letztverbraucher';
  var keyInDto = dtoPrefix + filterKey;
  if (this.dto && this.dto[keyInDto] && Ext.isString(this.dto[keyInDto]) && this.dto[keyInDto].length) {
    this.loadDirectly = true;
    return this.dto[keyInDto];
  }
}, initComponent:function() {
  var $jscomp$this = this;
  this.panel = Ext.create({xtype:'mpmPanel', header:false, layout:{type:'hbox', align:'stretch'}, flex:1, items:[{xtype:'mpmPanel', header:false, flex:1, items:['Marktlokation', 'Messlokation', 'Zaehlernummer', 'suchdatum'].map(function(name) {
    var label = name === 'Zaehlernummer' ? 'Zählernummer' : name, xtype = 'textfield';
    if (name === 'suchdatum') {
      label = 'Datum';
      xtype = 'datefield';
    }
    var field = {xtype:xtype, fieldLabel:label, filterParamKey:name, emptyText:' - ', fieldStyle:'background-color:#f7f7ec;', triggers:{bar:{cls:BpcCommon.util.Icons.getBpcIconCls('fa-times'), handler:function(f) {
      f.setValue(undefined);
      $jscomp$this.changeFilters();
    }}}};
    var defaultValue;
    if (name === 'suchdatum') {
      defaultValue = ($jscomp$this.dto || {})[name];
      field = Ext.apply(field, {format:'d.m.Y', altFormats:'c|C|time|Y-m-d H:i:s'});
    } else {
      defaultValue = $jscomp$this.getDefaultFromDto(name);
    }
    if (defaultValue) {
      field.value = defaultValue;
    }
    return field;
  })}, {xtype:'mpmPanel', header:false, flex:1, items:['Kundennummer', 'Vertragsnummer', 'Vorname', 'Nachname', 'Titel'].map(function(name) {
    var field = {xtype:'textfield', fieldLabel:name, filterParamKey:name, emptyText:' - ', fieldStyle:'background-color:#f7f7ec;', triggers:{bar:{cls:BpcCommon.util.Icons.getBpcIconCls('fa-times'), handler:function(f) {
      f.setValue(undefined);
      $jscomp$this.changeFilters();
    }}}};
    var defaultValue = $jscomp$this.getDefaultFromDto(name);
    if (defaultValue) {
      field.value = defaultValue;
    }
    return field;
  })}, {xtype:'mpmPanel', header:false, flex:1, items:['Strasse', 'Hausnummer', 'Postleitzahl', 'Stadt', 'Land'].map(function(name) {
    var label = name === 'Strasse' ? 'Straße' : name;
    var field = {xtype:name === 'Land' ? 'mpmDictionaryCombo' : 'textfield', dataKey:name, fieldLabel:label, filterParamKey:name, emptyText:' - ', fieldStyle:'background-color:#f7f7ec;', triggers:{bar:{cls:BpcCommon.util.Icons.getBpcIconCls('fa-times'), handler:function(f) {
      f.setValue(undefined);
      $jscomp$this.changeFilters();
    }}}};
    var defaultValue = $jscomp$this.getDefaultFromDto(name);
    if (defaultValue) {
      field.value = defaultValue;
    }
    return field;
  })}]});
  this.checkButton = Ext.create({xtype:'button', text:'Meldepunkt übernehmen', iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-plus'), itemId:'checkbutton', scale:'medium', disabled:true, _valueField:'meldepunkt', handler:function(b) {
    var models = $jscomp$this.grid.getSelection();
    if (models.length) {
      var matches = $jscomp$this.task.wrapper.query('textfield[fieldLabel\x3dMeldepunkt]');
      matches = matches.filter(function(field) {
        return field.name === 'antwortkategorie';
      });
      if (matches.length === 1) {
        matches[0].setValue(models[0].get(b._valueField));
      }
    }
  }});
  this.store = Ext.create('Ext.data.Store', {proxy:{type:'ajax', url:mpm.Support.getWorkflowUrl(this.moduleId, this.task.getItemFromMetaProcess(this.task.isConfig, 'package'), true), reader:{type:'json', rootProperty:'data', totalProperty:'total'}, extraParams:{method:'search', context:'meldepunkt'}, listeners:{exception:function() {
    $jscomp$this.setEmptyText('Fehler bei der Abfrage');
  }}}, listeners:{load:function(s, r, successful) {
    if (successful) {
      $jscomp$this.setEmptyText('Keine Meldepunkte');
      var totalButton = $jscomp$this.down('#totalCountButton');
      if (totalButton) {
        totalButton.setText(s.getTotalCount() + ' Meldepunkte');
      }
    }
  }}, autoLoad:false});
  this.title = 'Meldepunktsuche';
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls('fa-search');
  this.grid = Ext.create({xtype:'grid', header:false, store:this.store, layout:'fit', flex:1, listeners:{selectionchange:function(selmodel, selection) {
    $jscomp$this.checkButton.setDisabled(!(selection.length > 0));
  }}, columns:[{text:'Marktlokation', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Marktlokation'] ? value['Marktlokation'] : '';
  }}, {text:'Messlokation', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Messlokation'] ? value['Messlokation'] : '';
  }}, {text:'Zählernummer', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Zaehlernummer'] ? value['Zaehlernummer'] : '';
  }}, {text:'Kundennummer', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Kundennummer'] ? value['Kundennummer'] : '';
  }}, {text:'Vertragsnummer', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Vertragsnummer'] ? value['Vertragsnummer'] : '';
  }}, {text:'Vorname', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Vorname'] ? value['Vorname'] : '';
  }}, {text:'Nachname', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Nachname'] ? value['Nachname'] : '';
  }}, {text:'Titel', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Titel'] ? value['Titel'] : '';
  }}, {text:'Straße', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Strasse'] ? value['Strasse'] : '';
  }}, {text:'Hausnummer', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Hausnummer'] ? value['Hausnummer'] : '';
  }}, {text:'Postleitzahl', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Postleitzahl'] ? value['Postleitzahl'] : '';
  }}, {text:'Stadt', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Stadt'] ? value['Stadt'] : '';
  }}, {text:'Land', dataIndex:'data', flex:2, renderer:function(value) {
    value = value || {};
    return value['Land'] ? value['Land'] : '';
  }}].map(function(c) {
    c.sortable = false;
    c.menuDisabled = true;
    return c;
  }), tbar:[{xtype:'button', text:'Suchen', iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-search'), handler:function() {
    $jscomp$this.changeFilters();
  }}, this.checkButton, {xtype:'tbfill'}, {xtype:'button', itemId:'totalCountButton', text:'', iconCls:BpcCommon.util.Icons.getBpcIconCls('fa-database')}]});
  this.items = [this.panel, this.grid];
  this.callParent(arguments);
  if (this.loadDirectly) {
    this.changeFilters();
  } else {
    this.store.load();
  }
}, setEmptyText:function(text) {
  var view = this.grid.down('tableview');
  view.setEmptyText(text);
  view.refresh();
}, getFilterValues:function() {
  var filters = {};
  this.query('textfield[filterParamKey]').map(function(field) {
    var value = field.getValue();
    filters[field.filterParamKey] = Ext.isDate(value) ? value.toISOString() : value;
  });
  return filters;
}, changeFilters:function() {
  var s = this.grid.store;
  var p = s.getProxy().getExtraParams() || {};
  var filters = this.getFilterValues();
  var filterString = '';
  Ext.iterate(filters, function(key, value) {
    filterString += key + '\x3d' + value + ',';
  });
  p.filter = filterString;
  s.getProxy().setExtraParams(p);
  s.load();
}});
Ext.define('gpkelf.lf.gpkeLfAbmeldungVomNb', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAbmeldungVomNb'], constructor:function(config) {
  this.initConfigurableTask(config);
  var readOnly = true;
  var belegdaten = {xtype:'mpmGenericDataPanel', title:'Belegdaten', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAbmeldungLf'}, {key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date'}, {key:'bilanzierungsbeginn', type:'date'}, {key:'bilanzierungsende', type:'date'}, {key:'bemerkungen'}], itemsRight:[], dto:this.dto, task:this};
  var marktPartner = Ext.create({xtype:'mpmGrid', iconCls:mpm.Support.icon('database'), name:'marktpartner', readOnly:readOnly, flex:1, task:this, padding:'5 5 5 5', _columns:[{dataIndex:'meldepunkt'}, {dataIndex:'rolle'}, {dataIndex:'name'}, {dataIndex:'mpid'}]});
  this.handleBaseTabs([belegdaten, this.getContentTab('endkunde', readOnly), marktPartner]);
  var values = this.getWfDictionary() || [];
  var confirmValues = [], rejectValues = [];
  var branch = this.getBranch() || '';
  branch = branch.trim();
  var antwortFreitext = Ext.create({xtype:'mpmTextarea', name:'antwortFreitext', dto:this.dto});
  if (values) {
    confirmValues = values.filter(function(i) {
      return i.flag === 'accept' && i.branch === branch;
    }).map(function(i) {
      return {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key, optionalFields:['antwortFreitext']};
    });
    rejectValues = values.filter(function(i) {
      return i.flag === 'reject' && i.branch === branch;
    }).map(function(i) {
      var elem = {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key};
      if (i.key === 'E14') {
        elem.requiredFields = ['antwortFreitext'];
      } else {
        elem.optionalFields = ['antwortFreitext'];
      }
      return elem;
    });
  }
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:confirmValues}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:rejectValues}}};
  var task = this;
  this.add({xtype:'mpmSplitter'});
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:task, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:task, _values:definition.answer.reject.values}), conditionalFields:[antwortFreitext]});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.gpkeLfAntwortAufAnmeldung', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAntwortAufAnmeldung'], constructor:function(config) {
  var $jscomp$this = this;
  var readOnly = true;
  this.taskFieldDefinitions = {sender:{forceIdLoading:true}, empfaenger:{forceIdLoading:true}, messlokation:{type:'text', hidden:true}, meldepunkt:{type:'text', hidden:true}, ansprechpartner:{type:'text'}};
  this.initConfigurableTask(config, readOnly);
  this.getBranch();
  this.handleBaseTabs(this.getBaseTabs(readOnly));
  this.handleTaskSpecificFields();
  this.hideFieldsByName(['zeitreihentypTLP', 'ablesekarteKundennummerAltlieferant']);
  var topRow = Ext.create(this.getAnswerRowWrapperCfg());
  var bottomRow = Ext.create(this.getAnswerRowWrapperCfg());
  var answerState = {xtype:'mpmContainer', itemId:'answerState', layout:{type:'vbox', align:'stretch'}, items:[topRow, bottomRow]};
  if (this.dto.antwortstatus) {
    var values = this.getWfDictionary() || [];
    var label = ' ? ';
    var match = values.filter(function(i) {
      return i.key === $jscomp$this.dto.antwortstatus;
    });
    if (match.length) {
      label = match[0].flag === 'reject' ? 'Ablehnung' : 'Zustimmung';
    }
    var fieldBase = this.getBaseObject();
    fieldBase.labelWidth = 220;
    topRow.add([{xtype:'mpmDictionaryCombo', fieldLabel:label, dataKey:'gpkeLfAntwortAufAnmeldung', flex:1, name:'antwortstatus', readOnly:readOnly}, {xtype:'mpmTextfield', flex:1, name:'antwortFreitext', readOnly:readOnly}].map(function(item) {
      return Ext.apply(item, fieldBase);
    }));
    if (['Z35', 'A50'].indexOf(this.dto.antwortstatus) !== -1) {
      bottomRow.add([{xtype:'mpmDictionaryCombo', dataKey:'ablehnungsgrundDrittermarktPartner', flex:2, name:'ablehnungsgrundDritterMarktbeteiligter', readOnly:label.toLowerCase() === 'ablehnung'}, {xtype:'mpmTextfield', name:'dritterMarktbeteiligter', flex:1, readOnly:label.toLowerCase() === 'ablehnung'}].map(function(item) {
        return Ext.apply(item, fieldBase);
      }));
    }
    if (['ZC5', 'A11'].indexOf(this.dto.antwortstatus) !== -1) {
      bottomRow.add([{xtype:'mpmTextfield', name:'lieferbeginnDatumBearbeitung'}, {xtype:'mpmTextfield', name:'datumNaechsteBearbeitung'}].map(function(item) {
        return Ext.apply(item, fieldBase);
      }));
    }
  }
  this.add(answerState);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}, getAnswerRowWrapperCfg:function() {
  return {xtype:'mpmContainer', layout:{type:'hbox', align:'stretch'}, flex:1, items:[]};
}});
Ext.define('gpkelf.lf.gpkeLfAntwortSdanfEingehend', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfAntwortSdanfEingehend'], constructor:function(config) {
  this.initConfigurableTask(config);
  var readOnly = true;
  this.getBranch();
  this.handleBaseTabs([this.getBelegdatenTab(readOnly), this.getMaloTab(readOnly), this.getMeloGrid(readOnly), this.getDeviceGrid(readOnly), this.getObisMalo(readOnly), this.getObisMelo(readOnly), this.getMarktpartner(readOnly)]);
  this.handleTaskSpecificFields();
  var dictionaryValues = this.getWfDictionary() || [];
  var confirmValues = this.getConfirmValues(dictionaryValues), rejectValues = this.getRejectValues(dictionaryValues);
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:confirmValues}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:rejectValues}}};
  this.add({xtype:'mpmSplitter'});
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:this, confirmPanel:confirmValues.length === 0 ? undefined : Ext.create({xtype:'mpmAnswerPanel', task:this, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:rejectValues.length === 0 ? undefined : Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:this, _values:definition.answer.reject.values})});
  this.submitAnswersOnly = true;
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.gpkeLfSdaeEingehend', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfSdaeEingehend'], constructor:function(config) {
  var readOnly = true;
  this.taskFieldDefinitions = {sender:{forceIdLoading:true}, empfaenger:{forceIdLoading:true}, messlokation:{type:'text', hidden:true}, meldepunkt:{type:'text'}, marktlokation:{type:'text', hidden:true}, ansprechpartner:{type:'text'}, refVorgangsnummer:{type:'text', hidden:true}};
  this.initConfigurableTask(config, readOnly);
  this.getBranch();
  var information = {xtype:'mpmGenericDataPanel', title:'Information', itemsLeft:[{key:'changeData', type:'textarea', readOnly:true}], dto:this.dto, task:this};
  this.handleBaseTabs([information].concat(this.getBaseTabs(readOnly)));
  this.handleTaskSpecificFields();
  this.hideFieldsByName(['zeitreihentypTLP', 'transaktionsgrundergaenzung', 'letztverbraucherKundennummerAltlieferant', 'ablesekarteKundennummerAltlieferant']);
  var dictionaryValues = this.getWfDictionary() || [];
  var confirmValues = this.getConfirmValues(dictionaryValues), rejectValues = this.getRejectValues(dictionaryValues);
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:confirmValues}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:rejectValues}}};
  this.add({xtype:'mpmSplitter'});
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:this, confirmPanel:confirmValues.length === 0 ? undefined : Ext.create({xtype:'mpmAnswerPanel', task:this, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:rejectValues.length === 0 ? undefined : Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:this, _values:definition.answer.reject.values})});
  this.submitAnswersOnly = true;
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpkelf.lf.kuendigung', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfKuendigung'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var base = this.getBaseObject();
  var names = ['sender', 'empfaenger'];
  names.map(function(name) {
    $jscomp$this.wrapper.down('[name\x3d' + name + ']').allowBlank = false;
  });
  var belegdatanNew = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'identifikationslogik', type:'settingCombo', listeners:{change:function(c, newVal, oldVal) {
    $jscomp$this.wrapper.down('[name\x3dmeldepunkt]').allowBlank = newVal !== 'Z12';
    $jscomp$this.wrapper.down('[name\x3dmeldepunkt]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherStrasse]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherStrasse]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherName]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherName]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherKundenTyp]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherKundenTyp]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherHausnummer]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherHausnummer]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherPLZ]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherPLZ]').validate();
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherOrt]').allowBlank = newVal !== 'Z13';
    $jscomp$this.wrapper.down('[name\x3dletztverbraucherOrt]').validate();
    $jscomp$this.validateAndToggle();
  }}}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAnmeldung', readOnly:true}, {key:'naechstmoeglicherTermin', type:'cb'}, {key:'lieferende', type:'date', allowBlank:false}], itemsRight:[{key:'zusaetzlicheInformation', type:'textarea'}], dto:this.dto, task:this};
  var kundendaten = Ext.apply({}, this.getKundendaten({remove:['letztverbraucherKundennummer']}), base);
  this.handleBaseTabs([belegdatanNew, kundendaten, this.getContentTab('zaehlernummern')]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.lf.kuendigung.eingehend', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfKuendigungEingehend'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var branch = this.getBranch() || '';
  var belegdatanNew = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAnmeldung', readOnly:true}, {key:'identifikationslogik', type:'dic', dataKey:'identifikationslogik'}, {key:'naechstmoeglicherTermin', type:'cb'}, {key:'lieferende', type:'date'}], itemsRight:[{key:'zusaetzlicheInformation', type:'textarea'}], dto:this.dto, task:this};
  this.handleBaseTabs([belegdatanNew, this.getContentTab('endkunde'), this.getContentTab('zaehlernummern')]);
  var selectionFields = (this.getWfDictionary() || []).filter(function(i) {
    return i.branch === branch;
  }).map(function(i) {
    var f = {};
    f.boxLabel = mpm.Support.dicItemFormatter(i, $jscomp$this.mpmModuleId);
    f.name = i.flag === 'confirm' ? 'antwortkategorie' : 'reject';
    f.requiredFields = i.requiredFields || [];
    f.optionalFields = i.optionalFields || [];
    f.inputValue = i.key;
    f._flag = i.flag;
    return f;
  });
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:selectionFields.filter(function(i) {
    return i.name === 'antwortkategorie';
  }).filter(function(i) {
    if (branch === 'strom') {
      return true;
    } else {
      if (i.inputValue === 'Z01') {
        if ($jscomp$this.dto.naechstmoeglicherTermin === true || $jscomp$this.dto.naechstmoeglicherTermin === 'true') {
          return true;
        } else {
          return false;
        }
      } else {
        return true;
      }
    }
  })}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:selectionFields.filter(function(i) {
    return i.name === 'reject';
  }).filter(function(i) {
    if (branch === 'strom') {
      return true;
    } else {
      if (i.inputValue === 'Z12') {
        if ($jscomp$this.dto.naechstmoeglicherTermin === false || $jscomp$this.dto.naechstmoeglicherTermin === 'false') {
          return true;
        } else {
          return false;
        }
      } else {
        return true;
      }
    }
  })}}};
  var task = this;
  this.add({xtype:'mpmSplitter'});
  this.add({xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:task, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:task, _values:definition.answer.reject.values}), conditionalFields:[this.lfFields.antwortFreitext(this.dto), 
  this.lfFields.vorjahresverbrauch(this.dto), this.lfFields.gueltigkeitbeginn(this.dto), this.lfFields.fc_kuendigungsfrist(this.dto, this), this.lfFields.fc_kuendigungstermin(this.dto, this), this.lfFields.fc_vertragsende(this.dto, this)]});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.lf.kuendigung.eingehendAntwort', {extend:'gpke.lf', requires:['gpke.lf'], alias:['widget.gpkeLfKuendigungEingehendAntwort'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var belegdatanNew = {xtype:'mpmGenericDataPanel', itemsLeft:[{key:'lieferrichtung', type:'dic', dataKey:'lieferrichtung', readOnly:true}, {key:'transaktionsgrund', type:'dic', dataKey:'transaktionsgrundAnmeldung', readOnly:true}, {key:'identifikationslogik', type:'settingCombo', allowBlank:false}, {key:'naechstmoeglicherTermin', type:'cb'}, {key:'lieferende', type:'date', readOnly:true}], itemsRight:[{key:'zusaetzlicheInformation', type:'textarea'}], dto:this.dto, task:this};
  this.handleBaseTabs([belegdatanNew, this.getContentTab('endkunde'), this.getContentTab('zaehlernummern')]);
  this.add({xtype:'mpmSplitter'});
  this.isReadOnlyTaskWip = true;
  var formatKuendigungsterminValue = this.dto['formatKuendigungstermin'] || '';
  formatKuendigungsterminValue = formatKuendigungsterminValue.trim();
  if (formatKuendigungsterminValue === 'MMDD') {
    this.kuendigungsterminFormat = 'd.m.';
    this.dto.kuendigungstermin = (this.dto.kuendigungstermin || '') + '2000';
    this.notify('DTO MODIFICATION - kuendigungstermin - (year) 2000 added to string');
  }
  this.add({xtype:'mpmGenericDataPanel', itemsLeft:[{key:'antwortkategorie', type:'dic', dataKey:'gpkeLfAntwortAufKuendigung', listeners:{change:function(f, newVal) {
    if (newVal) {
      var r = f.getSelection();
      var item$3 = r.get('item') || {};
      var $jscomp$destructuring$var53 = item$3;
      var optionalFields = $jscomp$destructuring$var53.optionalFields;
      var requiredFields = $jscomp$destructuring$var53.requiredFields;
      optionalFields = optionalFields || [];
      requiredFields = requiredFields || [];
      optionalFields.concat(requiredFields).map(function(name) {
        var f = $jscomp$this.wrapper.down('[name\x3d' + name + ']');
        f.setVisible(true);
        if (name === 'fc_vertragsende') {
          var k = $jscomp$this.dto.bestaetigtesVertragsendeKunde || '';
          var l = $jscomp$this.dto.bestaetigtesVertragsendeLieferant || '';
          if (k.length) {
            f.down('radio[inputValue\x3dk]').setValue(true);
            f.down('datefield').setValue(k);
          } else {
            f.down('radio[inputValue\x3dl]').setValue(true);
            f.down('datefield').setValue(l);
          }
        }
      });
      var fieldNames = ['formatKuendigungstermin', 'kuendigungstermin', 'kuendigungsfristWert', 'kuendigungsfristEinheit', 'kuendigungsfristReferenz'];
      fieldNames.map(function(name) {
        var f = $jscomp$this.wrapper.down('[name\x3d' + name + ']');
        var v = $jscomp$this.dto[name] || '';
        try {
          if (name === 'kuendigungstermin' && v.length > 0) {
            v = Ext.Date.parse(v, 'd.m.Y');
          }
        } catch (e) {
          $jscomp$this.notify('ERROR WHILE CONVERTING : kuendigungstermin to Date', 'e');
        }
        if (f) {
          f.setValue(v);
        }
      });
    }
  }}}, this.lfFields.vorjahresverbrauch(this.dto, this), this.lfFields.gueltigkeitbeginn(this.dto, this), this.lfFields.fc_vertragsende(this.dto, this), this.lfFields.fc_kuendigungstermin(this.dto, this), this.lfFields.fc_kuendigungsfrist(this.dto, this)], itemsRight:[this.lfFields.antwortFreitext(this.dto, this)], dto:this.dto, task:this});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}, validateAndToggle:function() {
}});
Ext.define('gpke.nb', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], tabPrefix:'gpkeNb', taskBaseHeader:'mpmBaseHeader', branches:{strom:['bilanzierungsgebiet', 'regelzone', 'marktlokation', 'spannungsebene', 'spannungsebene', 'verbrauchsaufteilung', 'zeitreihentyp', 'messtechnischeeinordnung', 'aggregationsverantwortung', 'prognosegrundlageWahlrecht', 'netznutzungsabrechnungsgrundlage', 'singulaergenutztebetriebsmittelnna'], gas:['marktgebiet', 'startAbrechnungsjahr', 'marktlokation', 
'druckebene', 'TUMKundenwert', 'fallgruppenzuordnung']}, getAnswerContainer:function(definition) {
  var me = this;
  return {xtype:'mpmAnswerContainerRow', allowBlank:false, flex:1, itemId:'selectPanel', task:me, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:me, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', defaultType:definition.answer.reject.valuesType, _name:'reject', task:me, _values:definition.answer.reject.values})};
}});
Ext.define('gpke.nb.Abmeldung', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbAbmeldung'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  this.createAndAddTabpanel([this.getGenericPanel('Belegdaten', [{key:'transaktionsgrund', type:'dic'}, {key:'lieferrichtung', type:'dic'}, {key:'uebermittlungzaehlerstand', type:'checkbox'}, {key:'marktpartnerMsbId', valueField:'mpid', type:'remoteCombo', displayField:'partnername', isId:true, params:{role:'NB', field:'marktpartner', noConnections:'true', onlyName:'true'}}].map(function(i) {
    i.readOnly = true;
    return i;
  }), [{key:'lieferbeginn', type:'date'}, {key:'lieferende', type:'date'}].map(function(i) {
    i.readOnly = true;
    return i;
  }))].concat(['endkunde'].map(function(t) {
    return $jscomp$this.getContentTab(t, true);
  })));
  this.hideFieldsByName(['letztverbraucherKundennummerAltlieferant']);
  var transaktionsGrund = this.dto.transaktionsgrund || '';
  var reasons = ['ZG9', 'ZH1', 'ZH2'];
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:[{boxLabel:'E15 - Zustimmung (ohne Korrekturen)', name:'antwortkategorie', inputValue:'E15', optionalFields:reasons.indexOf(transaktionsGrund) !== -1 ? [] : ['bilanzierungsende']}, {boxLabel:'Z01 - Zustimmung mit Terminänderung', hidden:reasons.indexOf(transaktionsGrund) !== -1, name:'antwortkategorie', inputValue:'Z01', requiredFields:['lieferende'], optionalFields:['bilanzierungsende']}]}, 
  reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:[{boxLabel:'E14 - Sonstiges', requiredFields:['bemerkungen'], inputValue:'E14'}, {boxLabel:'E17 - Ablehnung wegen Fristüberschreitung', inputValue:'E17'}, {boxLabel:'Z08 - Ablehnung (Transaktion schon stattgefunden)', inputValue:'Z08'}, {boxLabel:'Z14 - Ablehnung (Doppelmeldung)', inputValue:'Z14'}]}}};
  this.handleCustomFields();
  var answerContainerConfig = this.getAnswerContainer(definition);
  var submitLieferEnde = Ext.create({xtype:'mpmDatefield', name:'lieferende', fieldLabel:'Lieferende', value:this.dto.lieferende, dto:this.dto, hidden:true});
  var bilanzierungsende = Ext.create({xtype:'mpmDatefield', name:'bilanzierungsende', fieldLabel:'Bilanzierungsende', value:this.dto.bilanzierungsende, dto:this.dto, hidden:true});
  var sonstigeBemerkungen = Ext.create({xtype:'mpmTextarea', name:'bemerkungen', dto:this.dto, hidden:true});
  answerContainerConfig.conditionalFields = [sonstigeBemerkungen, submitLieferEnde, bilanzierungsende];
  this.add(answerContainerConfig);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)), 'xl');
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.nb.AbmeldungStillegung', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbAbmeldungStilllegung'], constructor:function(config) {
  this.initConfigurableTask(config);
  this.createAndAddTabpanel([this.getGenericPanel('Daten', [{key:'lieferrichtung', type:'dic', readOnly:true}, {key:'transaktionsgrund', type:'dic', readOnly:true}, {key:'bilanzierungsende', type:'date'}, {key:'lieferende', type:'date'}], [{key:'zusaetzlicheInformation', type:'textarea'}])]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.nb.AntwortAbmeldungVomNbInfotask', {extend:'gpke.nb', requires:['gpke.nb'], constructor:function(config) {
  this.getInteractionTaskWindow();
  this.isConfig = config;
  this.dto = config.dto;
  this.isReadOnlyTask = true;
  var layout = [{items:[{keys:['senderId']}, {keys:['empfaengerId']}, {keys:['nachrichtendatum']}]}, {keys:['foobar']}, {keys:['foobarIo']}];
  this.setWrapper({task:this, msg:'', meta:config.meta});
  this.add({xtype:'genericInfoTask', flex:1, dto:this.dto, task:this, meta:config.meta, taskLayout:config.meta.layout ? config.meta.layout : layout});
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
}});
Ext.define('gpke.nb.BrennwertAnfrage', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbBrennwertAnfrage'], constructor:function(config) {
  this.initConfigurableTask(config);
  this.hideFieldsByName(['refVorgangsnummer']);
  var belegdaten = this.getBelegdatenWrapperCfg();
  belegdaten.items.push(this.getPositionsGrid(this.parseToArrayWithScope('position', this) || []));
  this.add(belegdaten);
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:[{boxLabel:'Zustimmung (Brennwerte senden)', value:true, name:'antwortkategorie', inputValue:'E15'}]}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:[{boxLabel:'Z15 keine Berechtigung', inputValue:'Z15'}]}}};
  this.handleCustomFields();
  this.add(this.getAnswerContainer(definition));
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.nb.LastgangAnfrage', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbLastgangAnfrage'], constructor:function(config) {
  this.initConfigurableTask(config);
  this.hideFieldsByName(['refVorgangsnummer']);
  var belegdaten = this.getBelegdatenWrapperCfg();
  belegdaten.items.push(this.getPositionsGrid(this.parseToArrayWithScope('position', this) || []));
  this.add(belegdaten);
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:[{boxLabel:'Zustimmung (Lastgänge senden)', value:true, name:'antwortkategorie', inputValue:'E15'}]}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:[{boxLabel:'Z21 - Ablehnung Daten nicht vorhanden', inputValue:'Z21', disabled:true}, {boxLabel:'Z15 - Keine Berechtigung', inputValue:'Z15', value:true}, {boxLabel:'Z68 - falscher Prozess', 
  inputValue:'Z68', disabled:true}, {boxLabel:'Z69 - Ablehnung es wurden Werte angefragt, die es auf der genannten Marktlokation, Messlokation oder Tranche nicht geben kann', inputValue:'Z69', disabled:true}, {boxLabel:'Z70 - Ablehnung die angefragten Werte sind nicht vorhanden', inputValue:'Z70', disabled:true}]}}};
  this.handleCustomFields();
  this.add(this.getAnswerContainer(definition));
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.nb.MesswertAnfrage', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbMesswertAnfrage'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  this.hideFieldsByName(['refVorgangsnummer']);
  var belegdaten = this.getBelegdatenWrapperCfg();
  var positions = this.parseToArrayWithScope('position', this) || [];
  belegdaten.items.push({xtype:'mpmContainer', flex:2, layout:{type:'hbox', align:'stretch'}, items:[this.getPositionsGrid(positions), {xtype:'mpmGrid', barPosition:'bbar', header:false, allowBlank:false, name:'positionen', flex:1, task:this, padding:'5 5 5 5', windowTitle:'Zähleinrichtungsdaten', windowIconCls:'fa-plus', _columns:[{dataIndex:'posnr', editorType:'values', values:positions.map(function(i) {
    i = i || {};
    var $jscomp$destructuring$var54 = i;
    var posnr = $jscomp$destructuring$var54.posnr;
    var periodeBeginn = $jscomp$destructuring$var54.periodeBeginn;
    var periodeEnde = $jscomp$destructuring$var54.periodeEnde;
    posnr = posnr || '-1';
    periodeBeginn = periodeBeginn || '-1';
    periodeEnde = periodeEnde || '-1';
    return {key:posnr, value:'Position: ' + posnr + ' (' + periodeBeginn + ' - ' + periodeEnde + ')'};
  }), text:'Position'}, {dataIndex:'messwert'}, {dataIndex:'zaehlernummer'}, {dataIndex:'obis', editorType:'remote', params:{field:'obis'}}, {dataIndex:'status', editorType:'setting', settingName:'counter_status_quality', renderer:function(v, m, r) {
    var matches = BpcCommon.Api.getSetting($jscomp$this.mpmModuleId, 'counter_status_quality') || [];
    matches = matches.filter(function(item) {
      return item.key === v;
    });
    return matches.length ? v + ' - ' + matches[0].value : v;
  }}]}]});
  this.add(belegdaten);
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:[{boxLabel:'Zustimmung (Messwerte senden)', value:true, name:'antwortkategorie', inputValue:'E15', requiredFields:['positionen']}]}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:[{boxLabel:'Z21 - Ablehnung Daten nicht vorhanden', inputValue:'Z21', disabled:true}, {boxLabel:'Z15 - Keine Berechtigung', inputValue:'Z15', value:true, skipFields:['positionen']}, 
  {boxLabel:'Z68 - falscher Prozess', inputValue:'Z68', disabled:true}, {boxLabel:'Z69 - Ablehnung es wurden Werte angefragt, die es auf der genannten Marktlokation, Messlokation oder Tranche nicht geben kann', inputValue:'Z69', disabled:true}, {boxLabel:'Z70 - Ablehnung die angefragten Werte sind nicht vorhanden', inputValue:'Z70', disabled:true}]}}};
  this.handleCustomFields();
  this.add(this.getAnswerContainer(definition));
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('gpke.nb.anmeldung', {extend:'gpke.nb', alias:['widget.gpkeNbAnmeldung'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var branch = this.getBranch();
  var usecase = this.getUseCase();
  var directConfirm = false;
  if (this.dto.validation && Ext.isArray(this.dto.validation)) {
    this.wrapper.down('mpmBaseHeader').addValidationsGrid();
    this.validationGrid.store.add({name:usecase || '-1', cbValue:true, value:true});
    if (usecase === 'otherSupplierAssigned') {
      directConfirm = true;
      this.validationGrid.store.add({name:'Es wird eine Informationsmeldung über eine bestehende Zuordnung an den anmeldenden LFN gesendet', cbValue:true, value:true});
      this.validationGrid.store.add({name:'Es wird eine Abmeldeanfrage an den aktuell zugeordneten LFA gesendet', cbValue:true, value:true});
    }
  }
  this.hideFieldsByName(['refVorgangsnummer', 'messlokation', 'marktlokation']);
  this.createBaseTabs();
  var requiredFields = ['lieferrichtung', 'transaktionsgrund', 'lieferbeginn'];
  if (this.dto.transaktionsgrundergaenzung) {
    requiredFields.push('lieferende');
  }
  this.setFieldsRequired(requiredFields);
  this.handleTaskSpecificFields();
  var dictionary = this.getWfDictionary() || [];
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:directConfirm ? 'mpmTextfield' : 'radiofield', values:directConfirm ? [{name:'foobar', readOnly:true, hardCodedValue:'Keine Auswahl nötig', fieldLabel:'Info', padding:'5 5 5 5'}] : dictionary.filter(function(i) {
    return i.flag === 'accept' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key, requiredFields:i.requiredFields || [], optionalFields:i.optionalFields || []};
  })}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:dictionary.filter(function(i) {
    return i.flag === 'reject' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key + ' ' + i.value, name:'antwortkategorie', inputValue:i.key, requiredFields:i.requiredFields || [], optionalFields:i.optionalFields || []};
  })}}};
  var task = this;
  this.handleCustomFields();
  this.add({xtype:'mpmAnswerContainerRow', maxHeight:200, confirmText:'Übernahme', allowBlank:false, itemId:'selectPanel', task:task, confirmPanel:Ext.create({xtype:'mpmAnswerPanel', task:task, directConfirm:directConfirm, defaultType:definition.answer.confirm.valuesType, _values:definition.answer.confirm.values, _name:'antwortkategorie'}), rejectPanel:Ext.create({xtype:'mpmAnswerPanel', layout:'mpmForm', defaultType:definition.answer.reject.valuesType, _name:'reject', task:task, _values:definition.answer.reject.values}), 
  conditionalFields:[{xtype:'mpmTextarea', name:'antwortFreitext'}, {xtype:'mpmTextarea', name:'ablehnungsgrundDritterMarktbeteiligter'}, {xtype:'mpmDatefield', name:'datumNaechsteBearbeitung'}, {xtype:'mpmDatefield', name:'datumLieferbeginnInBearbeitung'}, {xtype:'mpmDatefield', name:'abweichenderTermin'}].map(function(f) {
    return Ext.create(Ext.apply({}, f, {dto:$jscomp$this.dto, hidden:true}));
  })});
  this.prognosegrundlage = this.wrapper.down('[name\x3dprognosegrundlage]');
  this.prognosegrundlageDetails = this.wrapper.down('[name\x3dprognosegrundlageDetails]');
  this.lastprofiltemperaturmessstelleVerantwortungCode = this.wrapper.down('[name\x3dlastprofiltemperaturmessstelleVerantwortungCode]');
  this.lastprofiltemperaturmessstelleVerantwortungCode.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.prognosegrundlage.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.prognosegrundlageDetails.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)), 'xl');
  this.callParent(arguments);
  this.setDeferredValues();
  this.handleAcceptReject(false);
  this.addValidation();
}, handlePrognosefields:function(accept) {
  accept = accept === void 0 ? true : accept;
  this.setFieldsRequired(['startAbrechnungsjahr'], this.prognosegrundlage.getValue() === 'ZC0' && this.taskBranch === 'gas' && accept);
  this.setFieldsRequired(['fallgruppenzuordnung'], this.prognosegrundlage.getValue() === 'ZC0' && this.taskBranch === 'gas' && accept);
  this.setFieldsRequired(['veranschlagtejahresmenge', 'TUMKundenwert', 'lastprofilverfahren', 'lastprofilcode', 'lastprofilverantwortungsCode', 'lastprofiltemperaturmessstelleCode', 'lastprofiltemperaturmessstelleID', 'lastprofiltemperaturmessstelleVerantwortungCode'], this.prognosegrundlageDetails.getValue() === 'E02' && this.prognosegrundlage.getValue() === 'ZA6' && accept);
  this.setFieldsRequired(['lastprofiltemperaturmessstelleDienstanbieter'], this.lastprofiltemperaturmessstelleVerantwortungCode.getValue() === '293' && this.prognosegrundlageDetails.getValue() === 'E02' && this.prognosegrundlage.getValue() === 'ZA6' && accept);
}, handleAcceptReject:function(reject) {
  var uc = this.getUseCase();
  var requiredFields = ['antwortstatus', 'abrechnungsintervallLF', 'netznutzungsabrechnung', 'netznutzungsvertrag', 'naechstenetznutzungsabrechnung', 'netznutzungsabrechnungsintervall', 'prognosegrundlage', 'netznutzungsabrechnungsvariante', 'gruppenzuordnung', 'bilanzkreis', 'gemeinderabatt'];
  if (this.taskBranch === 'gas') {
    requiredFields.push('marktgebiet');
  }
  var required = reject === false;
  if (uc === 'otherSupplierAssigned' && reject === false) {
    required = false;
  }
  this.handlePrognosefields(required);
  this.setFieldsRequired(requiredFields, required);
}});
Ext.define('gpke.nb.gdaStammdaten', {extend:'gpke.nb', alias:['widget.gpkeNbGdaStammdaten'], constructor:function(config) {
  var $jscomp$this = this;
  this.initConfigurableTask(config);
  var branch = this.getBranch();
  this.createBaseTabs(['nbGlobalBelegdaten', 'nbGlobalMarktlokation', {name:'meldepunkte', title:'Messlokationen'}, 'geraete', 'obis', 'endkunde', 'lieferanschrift', 'marktpartner'], false);
  if (branch === 'strom') {
    this.hideFieldsByName(['marktgebiet', 'startAbrechnungsjahr', 'marktlokation', 'druckebene', 'TUMKundenwert', 'fallgruppenzuordnung']);
  } else if (branch === 'gas') {
    this.hideFieldsByName(['bilanzierungsgebiet', 'regelzone', 'marktlokation', 'spannungsebene', 'spannungsebene', 'verbrauchsaufteilung', 'zeitreihentyp', 'messtechnischeeinordnung', 'aggregationsverantwortung', 'prognosegrundlageWahlrecht', 'netznutzungsabrechnungsgrundlage', 'singulaergenutztebetriebsmittelnna']);
  }
  this.hideFieldsByName(['refVorgangsnummer', 'messlokation', 'marktlokation']);
  this.hideFieldsByName(['transaktionsgrund', 'transaktionsgrundergaenzung', 'lieferbeginn', 'lieferende', 'bilanzierungsbeginn', 'bilanzierungsende', 'bilanzkreis', 'naechstenetznutzungsabrechnung', 'abrechnungsintervallLF']);
  this.antwortFreitext = Ext.create({xtype:'mpmTextarea', name:'antwortFreitext', dto:this.dto, task:this});
  var dictionary = this.getWfDictionary('nbSubmitGdaStammdaten') || [];
  var definition = {answer:{confirm:{boxLabel:'Zustimmung', inputValue:'confirm', value:true, valuesType:'radiofield', values:dictionary.filter(function(i) {
    return i.flag === 'confirm' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key !== i.value ? i.key + ' ' + i.value : i.key, name:'antwortkategorie', inputValue:i.key, optionalFields:['antwortFreitext']};
  })}, reject:{boxLabel:'Ablehnung', inputValue:'reject', valuesType:'radiofield', values:dictionary.filter(function(i) {
    return i.flag === 'reject' && i.branch === branch;
  }).map(function(i) {
    return {boxLabel:i.key !== i.value ? i.key + ' ' + i.value : i.key, name:'antwortkategorie', inputValue:i.key, optionalFields:['antwortFreitext']};
  })}}};
  this.handleCustomFields();
  var answerContainerConfig = this.getAnswerContainer(definition);
  answerContainerConfig.conditionalFields = [this.antwortFreitext];
  delete answerContainerConfig.flex;
  this.add(answerContainerConfig);
  this.prognosegrundlage = this.wrapper.down('[name\x3dprognosegrundlage]');
  this.prognosegrundlageDetails = this.wrapper.down('[name\x3dprognosegrundlageDetails]');
  this.lastprofiltemperaturmessstelleVerantwortungCode = this.wrapper.down('[name\x3dlastprofiltemperaturmessstelleVerantwortungCode]');
  this.lastprofiltemperaturmessstelleVerantwortungCode.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.prognosegrundlage.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.prognosegrundlageDetails.on('change', function() {
    $jscomp$this.handlePrognosefields();
  });
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)), 'xl');
  this.callParent(arguments);
  this.setDeferredValues();
  this.handleAcceptReject(false);
  this.addValidation();
}, handlePrognosefields:function(accept) {
  accept = accept === void 0 ? true : accept;
  this.setFieldsRequired(['startAbrechnungsjahr'], this.prognosegrundlage.getValue() === 'ZC0' && this.taskBranch === 'gas' && accept);
  this.setFieldsRequired(['fallgruppenzuordnung'], this.prognosegrundlage.getValue() === 'ZC0' && this.taskBranch === 'gas' && accept);
  this.setFieldsRequired(['druckebene'], this.taskBranch === 'gas' && accept);
  this.setFieldsRequired(['prognosegrundlageDetails'], this.prognosegrundlage.getValue() === 'ZA6' && accept);
  var f = this.wrapper.down('veranschlagtejahresmenge');
  if (f) {
    f.setVisible(this.prognosegrundlage.getValue() === 'ZA6');
  }
  var f2 = this.wrapper.down('TUMKundenwert');
  if (f2) {
    f2.setVisible(this.taskBranch === 'gas' && this.prognosegrundlage.getValue() === 'ZA6');
  }
}, handleAcceptReject:function(reject) {
  this.antwortFreitext.setVisible(true);
  var requiredFields = ['antwortstatus', 'netznutzungsabrechnung', 'netznutzungsvertrag', 'netznutzungsabrechnungsintervall', 'prognosegrundlage', 'gruppenzuordnung', 'netznutzungsabrechnungsvariante', 'gemeinderabatt'];
  var required = reject === false;
  this.handlePrognosefields(required);
  this.setFieldsRequired(requiredFields, required);
}});
Ext.define('gpke.nb.LastgangVersenden', {extend:'gpke.nb', requires:['gpke.nb'], alias:['widget.gpkeNbLastgangAusgehend'], constructor:function(config) {
  this.initConfigurableTask(config);
  this.createAndAddTabpanel([this.getGenericPanel('Lastgang versenden', [{key:'anwendungsreferenz', type:'dic', readOnly:true}, {key:'messperiodeBeginn', type:'date'}, {key:'messperiodeEnde', type:'date'}])]);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.callParent(arguments);
  this.setDeferredValues();
  this.addValidation();
}});
Ext.define('mpm.packages.invoice.InvoiceDecisionPanel', {extend:'mpm.components.Container', alias:'widget.mpmInvoiceDecisions', task:undefined, selectedValue:undefined, dto:undefined, invoiceType:undefined, branch:undefined, initComponent:function() {
  var $jscomp$this = this;
  if (this.task) {
    this.dto = this.task.dto;
    this.mpmModuleId = this.task.mpmModuleId;
  }
  this.confirmCombo = Ext.create({xtype:'mpmDictionaryCombo', fieldLabel:'Entscheidung', width:300, hideKey:true, listeners:{change:function(c, newValue, oldValue) {
    $jscomp$this.rejectReasonCombo.setDisabled(newValue && newValue === 'accept');
    $jscomp$this.validateAndToggle();
  }}, task:this.task, allowBlank:false, dto:this.dto, name:'invoicePruefenZustimmung'});
  var dictionary = this.task.getDictionary('invoicePruefenReasons') || [];
  var invoiceType = this.invoiceType;
  var taskBranch = this.branch;
  var reasonStoreData = dictionary.filter(function(item) {
    var $jscomp$destructuring$var55 = item;
    var branch = $jscomp$destructuring$var55.branch;
    branch = branch || '';
    if (typeof branch === 'string') {
      return branch === taskBranch;
    } else {
      return branch.indexOf(taskBranch) !== -1;
    }
  }).filter(function(item) {
    var $jscomp$destructuring$var56 = item || [];
    var invoiceTypes = $jscomp$destructuring$var56.invoiceTypes;
    return invoiceTypes.indexOf(invoiceType) !== -1;
  });
  this.rejectReasonCombo = Ext.create({xtype:'combo', fieldLabel:'Ablehnungsgrund', store:mpm.util.Store.newLocalStore(mpm.Support.dicToDisplayData(reasonStoreData, this.mpmModuleId)), valueField:'key', displayField:'value', queryMode:'local', disabled:true, task:this.task, flex:1, dto:this.dto, name:'refuseReason', allowBlank:false, listeners:{change:function(c, newValue, oldValue) {
    var r = c.getSelection();
    var sourceItem = r.get('item') || {};
    var $jscomp$destructuring$var57 = sourceItem;
    var requiredFields = $jscomp$destructuring$var57.requiredFields;
    requiredFields = requiredFields || [];
    $jscomp$this.mandantoryComment.setDisabled(requiredFields.indexOf($jscomp$this.mandantoryComment.name) === -1);
    $jscomp$this.validateAndToggle(c);
  }}});
  this.mandantoryComment = Ext.create({xtype:'mpmTextfield', name:'sonstigerKommentar', dto:this.dto, flex:1, fieldLabel:'Kommentar', allowBlank:false, disabled:true, task:this.task, listeners:{change:function(c, newValue, oldValue) {
    $jscomp$this.validateAndToggle(c);
  }}});
  this.internalComment = Ext.create({xtype:'mpmTextfield', name:'internerKommentar', width:300, dto:this.dto, fieldLabel:'Kommentar (intern)'});
  this.flex = 7;
  this.defaults = {xtype:'mpmContainer', layout:{type:'hbox', align:'stretch'}};
  this.items = [{items:[this.confirmCombo, this.rejectReasonCombo]}, {items:[this.internalComment, this.mandantoryComment]}];
  this.callParent(arguments);
  if (this.selectedValue) {
    this.confirmCombo.setValue(this.selectedValue);
  }
}, validateAndToggle:function() {
  var valid = this.task.validateCmp(this);
  this.submitButton.setDisabled(!valid);
}, getFieldsAsMap:function() {
  var map = {};
  this.query('[name]').filter(function(f) {
    return !f.hasOwnProperty('skipValue');
  }).map(function(f) {
    var value = f.getValue();
    map[f.name] = Ext.isDate(value) ? Ext.Date.format(value, f.mpmSubmitFormat || 'd.m.Y') : value;
  });
  return map;
}});
Ext.define('invoice.header', {extend:'mpm.components.Container', alias:'widget.invoiceHeader', layout:{type:'hbox', align:'stretch'}, readOnly:false, minimize:function() {
  this.query('mpmFieldSet').map(function(f) {
    f.setCollapsed(!f.getCollapsed());
  });
}, getFieldHandlerFn:function(sliceLabel, readOnly) {
  return function(f) {
    f.sliceLabelPrefix = sliceLabel;
    f.readOnly = readOnly;
    return f;
  };
}, initComponent:function() {
  var landWidth = 35, plzWidth = 90, houseNumberWidth = 50;
  this.items = [{title:'Absender', items:this.createFields(this.createAbsenderFields(houseNumberWidth, plzWidth))}, {title:'Empfänger', items:this.createFields(this.createEmpfaengerFields(houseNumberWidth, plzWidth))}, {title:'MeldepunktInfos', items:this.createFields(this.createMeldepunktInfos(houseNumberWidth, plzWidth, landWidth))}, {title:'Rechnungsinfos', items:this.createFields(this.createRechnungsinfos())}].map(function(f) {
    f.xtype = 'mpmFieldSet';
    f.flex = 1;
    return f;
  });
  this.callParent(arguments);
}, createAbsenderFields:function(houseNumberWidth, plzWidth) {
  return [{key:'SENDERID', fieldLabel:'Absender'}, {key:'SENDERNAME', fieldLabel:'Name'}, {type:'multi', label:'STRASSE', items:[{key:'SENDERSTRASSE'}, {key:'SENDERHAUSNUMMER', width:houseNumberWidth}].map(this.getFieldHandlerFn('SENDER', this.readOnly))}, {type:'multi', label:'ORT', items:[{key:'SENDERPLZ', width:plzWidth}, {key:'SENDERORT'}].map(this.getFieldHandlerFn('SENDER', this.readOnly))}, {key:'SENDERLAND'}, {key:'SENDERSTEUERNUMMER', fieldLabel:this.task.dto.SENDERSTNUMQUALIFIERCODE === 
  'VA' ? 'USt. ID' : 'Steuernummer'}].map(this.getFieldHandlerFn('SENDER', this.readOnly));
}, createEmpfaengerFields:function(houseNumberWidth, plzWidth) {
  return [{key:'EMPFAENGERID'}, {key:'EMPFAENGERPARTNERNAME'}, {type:'multi', label:'STRASSE', items:[{key:'EMPFAENGERSTRASSE'}, {key:'EMPFAENGERHAUSNUMMER', width:houseNumberWidth}].map(this.getFieldHandlerFn('EMPFAENGER', this.readOnly))}, {type:'multi', label:'ORT', items:[{key:'EMPFAENGERPLZ', width:plzWidth}, {key:'EMPFAENGERORT'}].map(this.getFieldHandlerFn('EMPFAENGER', this.readOnly))}, {key:'EMPFAENGERLAND'}, {key:'EMPFAENGERSTEUERNUMMER', fieldLabel:this.task.dto.EMPFAENGERSTNUMQUALIFIERCODE === 
  'VA' ? 'USt. ID' : 'Steuernummer'}].map(this.getFieldHandlerFn('EMPFAENGER', this.readOnly));
}, createRechnungsinfos:function() {
  var hideStornoReNr = this.task.dto.STORNORECHNUNGSNUMMER && this.task.dto.STORNORECHNUNGSNUMMER.length === 0;
  return [{key:'STORNORECHNUNGSNUMMER', fieldLabel:'Storno-Rechnungsnummer', hidden:hideStornoReNr}, {key:'NACHRICHTENARTCODE', fieldLabel:'Rechnungsart', type:'dic'}, {key:'NACHRICHTENFUNKTIONCODE', fieldLabel:'Funktion', type:'dic'}, {key:'RECHNUNGSTYPCODE', fieldLabel:'Rechnungstyp', type:'dic'}, {key:'ACENUMMER', fieldLabel:'Referenz Lieferschein'}, {key:'BEARBEITUNGSDATUM', type:'date'}, {type:'multi', label:'PERIOD', items:[{key:'ABRECHNUNGSZEITRAUMANFANG', fieldLabel:'Rechnungsperiode (Beginn)', 
  type:'date'}, {key:'ABRECHNUNGSZEITRAUMENDE', fieldLabel:'Rechnungsperiode (Ende)', type:'date'}].map(this.getFieldHandlerFn('', this.readOnly))}].map(this.getFieldHandlerFn('', this.readOnly));
}, createMeldepunktInfos:function(houseNumberWidth, plzWidth, landWidth) {
  if (this.task.dto.STEUERSCHULD === 'RCH') {
    this.task.dto.STEUERSCHULD = true;
  }
  return [{key:'MELDEPUNKT'}, {type:'multi', label:'STRASSE', items:[{key:'LIEFERANSCHRIFTSTRASSE'}, {key:'LIEFERANSCHRIFTHAUSNUMMER', width:houseNumberWidth}].map(this.getFieldHandlerFn('LIEFERANSCHRIFT', this.readOnly))}, {type:'multi', label:'ORT', items:[{key:'LIEFERANSCHRIFTPLZ', width:plzWidth}, {key:'LIEFERANSCHRIFTORT'}].map(this.getFieldHandlerFn('LIEFERANSCHRIFT', this.readOnly))}, {key:'LIEFERANSCHRIFTLAND', width:landWidth}, {type:'multi', label:'ACCOUNTING', items:[{key:'BILANZIERUNGSANFANG', 
  type:'date'}, {key:'BILANZIERUNGSENDE', type:'date'}].map(this.getFieldHandlerFn('LIEFERANSCHRIFT', this.readOnly))}, {key:'STEUERSCHULD', boxLabel:'Steuerschuld bei Empfänger', noLabel:true, type:'checkbox'}].map(this.getFieldHandlerFn('LIEFERANSCHRIFT', this.readOnly));
}, createFields:function(fields) {
  return this.task.createFields(fields, undefined, undefined, this.task);
}});
Ext.define('mpm.components.Invoice', {extend:'mpm.components.Panel', alias:'widget.mpmInvoiceUi', mixins:['mpm.components.mixins.ActionButtons'], layout:{type:'vbox', align:'stretch'}, task:undefined, scrollable:true, readOnly:false, bpcPlugin:false, header:false, initComponent:function() {
  var $jscomp$this = this;
  this.title = this.TR('INVOICE');
  this.iconCls = this.faIcon('fa-file-invoice');
  this.items = [{xtype:'mpmPanel', header:false, padding:'3 3 3 3', layout:{type:'hbox', align:'stretch'}, items:mpm.Support.createFields([{key:'NACHRICHTENNUMMER', fieldLabel:'Rechnungsnummer'}, {key:'RECHNUNGSDATUM', type:'date'}, {key:'FAELLIGKEITSDATUM', type:'date', fieldLabel:'Fälligkeitsdatum'}, {key:'AUSFUEHRUNGSDATUM', fieldLabel:'Ausführungsdatum', type:'date'}].map(function(f) {
    f.readOnly = $jscomp$this.readOnly;
    f.labelWidth = 150;
    f.margin = '0 10 0 0';
    return f;
  }).concat({xtype:'toolbar', flex:1, items:[{xtype:'tbfill'}, {xtype:'button', text:mpm.Support.TR('HIDE_SHOW_HEADER'), handler:function(b) {
    var header = $jscomp$this.down('invoiceHeader');
    header.setVisible(!header.isVisible());
  }}]}), undefined, undefined, this.task, this)}, {xtype:'mpmPanel', header:false, padding:'3 3 3 3', hidden:!this.bpcPlugin, layout:{type:'hbox', align:'stretch'}, items:mpm.Support.createFields([{key:'STATUS'}, {key:'REFUSIALREASON', width:500, fieldLabel:'Ablehnungsgrund', type:'dic', dataKey:'invoicePruefenReasons'}, {key:'REFUSIALREASONTEXT', fieldLabel:'Ablehnungstext'}].map(function(f) {
    f.readOnly = $jscomp$this.readOnly;
    f.labelWidth = 150;
    f.margin = '0 10 0 0';
    return f;
  }), undefined, undefined, this.task, this)}, {xtype:'invoiceHeader', task:this.task, readOnly:this.readOnly}, {xtype:'mpmGrid', margin:'10 0 0 0', readOnly:true, title:'Positionen', name:'POSITIONEN', task:this.task, _columns:[{dataIndex:'ArtikelID'}, {dataIndex:'ArtikelTyp'}, {dataIndex:'FakturierteMenge', align:'right'}, {dataIndex:'FakturierteMengeMasseinheit'}, {dataIndex:'ErreichteMenge', align:'right'}, {dataIndex:'ErreichteMengeMasseinheit'}, {dataIndex:'RechnungsperiodeBeginn', text:'Rechnungsperiode (Beginn)'}, 
  {dataIndex:'RechnungsperiodeEnde', text:'Rechnungsperiode (Ende)'}, {dataIndex:'Ausfuehrungsdatum'}, {dataIndex:'PositionsbetragNetto', align:'right'}, {dataIndex:'RabattbetragNetto', align:'right'}, {dataIndex:'Preisangaben'}, {dataIndex:'PreisangabeMasseinheit'}, {dataIndex:'Steuersatz'}, {dataIndex:'Steuerkategorie'}, {dataIndex:'ZuAbschlaege', renderer:function(v) {
    if (Ext.isArray(v)) {
      return v.map(function(item) {
        return (item.typ || '-1') + ' ' + (item.code || '-1') + ' ' + (item.prozentsatz || ' -1');
      }).join('\x3cbr\x3e');
    }
    return '';
  }}]}, {xtype:'mpmPanel', margin:'10 0 0 0', layout:{type:'hbox', align:'stretch'}, padding:'0 0 0 0', items:[{xtype:'mpmGrid', readOnly:true, title:'Betrag', name:'ZWISCHENSUMMEN', task:this.task, flex:2, _columns:[{dataIndex:'zwSteuersatz', align:'right', menuDisabled:true, width:90}, {dataIndex:'zwSteuerkategorie', menuDisabled:true}, {dataIndex:'netto', align:'right', menuDisabled:true, width:130}, {dataIndex:'steuern', align:'right', menuDisabled:true, width:130}, {dataIndex:'bruttovorausbezahlt', 
  align:'right', menuDisabled:true}, {dataIndex:'steuernvorausbezahlt', align:'right', menuDisabled:true}]}, {xtype:'mpmPanel', header:false, flex:1}]}, {xtype:'mpmGenericDataPanel', flexRight:3, header:false, itemsLeft:[{key:'RECHNUNGSBETRAG', fieldStyle:'text-align: right;'}, {key:'VORAUSBEZAHLTERBETRAG', fieldStyle:'text-align: right;'}, {key:'FAELLIGERBETRAG', fieldStyle:'text-align: right;'}].map(function(f) {
    f.readOnly = true;
    f.width = 200;
    return f;
  }), itemsRight:[], dto:this.task.dto, task:this.task}];
  this.callParent(arguments);
}, createDecisionComponent:function(selectedValue, sparte, invoiceType, sendButton) {
  return Ext.create({xtype:'mpmInvoiceDecisions', task:this.task, branch:sparte, submitButton:sendButton, invoiceType:invoiceType, selectedValue:selectedValue});
}});
Ext.define('mpm.components.Lieferschein', {extend:'mpm.components.Container', alias:'widget.mpmLieferscheinUi', layout:{type:'vbox', align:'stretch'}, task:undefined, scrollable:true, initComponent:function() {
  this.title = this.TR('MPM_DELIVERYNOTE');
  this.iconCls = this.faIcon('fa-file-alt');
  var readOnly = true;
  var dto = this.task.dto || {};
  var $jscomp$destructuring$var58 = dto;
  var positionen = $jscomp$destructuring$var58.positionen;
  var positions = positionen || [];
  this.items = [{xtype:'container', flex:1, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'mpmFieldSet', title:'Absender', flex:1, items:this.createFields([{key:'SENDERID'}, {key:'SENDERNAME'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'Empfänger', items:this.createFields([{key:'EMPFAENGERID'}, {key:'EMPFAENGERPARTNERNAME'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'Meldepunktinfos', items:this.createFields([{key:'MELDEPUNKT'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'Lieferscheininfos', items:this.createFields([{key:'LIEFERSCHEINNUMMER'}, {key:'LIEFERSCHEINDATUM', type:'date'}, {key:'LSANTWORTNUMMER'}, {key:'LSANTWORT'}, {key:'LSANTWORTDETAILS'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}], task:this.task}, {xtype:'mpmSplitter'}, {xtype:'mpmMeasurementsGrid', header:false, flex:1, protocolData:{positions:positions}}];
  this.callParent(arguments);
}, getValueFromDictionary:function(dictionary, value) {
  value = value === void 0 ? '' : value;
  value = Ext.isString(value) ? value : String(value);
  var translations = mpm.Support.getDictionary(dictionary);
  var match = translations.filter(function(item) {
    return item.key === value;
  });
  return match.length ? mpm.Support.dicItemFormatter(match[0], this.task.mpmModuleId) : value;
}, parseAndDisplayDate:function(v) {
  var init = v;
  try {
    v = Ext.Date.format(Ext.Date.parse(v, 'c'), 'd.m.Y');
  } catch (e) {
  }
  return v || init;
}, createFields:function(fields) {
  return this.task.createFields(fields, undefined, undefined, this.task);
}});
Ext.define('mpm.components.comdisUi', {extend:'mpm.components.Container', alias:'widget.mpmComdisUi', layout:{type:'vbox', align:'stretch'}, task:undefined, scrollable:true, mode:'invoice', initComponent:function() {
  this.title = this.TR('COMDIS') + ' ' + this.TR(this.mode === 'invoice' ? 'INVOICE' : 'DELIVERYNOTE');
  this.iconCls = this.faIcon('fa-receipt');
  var readOnly = true;
  this.items = [{xtype:'container', flex:1, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'mpmFieldSet', title:'Absender', flex:1, layout:{type:'vbox', align:'stretch'}, items:this.createFields([{key:'CDTECHNICALSENDER', fieldLabel:'Absender'}, {key:'CDSENDERNAME', fieldLabel:'Name'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }).concat([mpm.util.Components.getHr(), {xtype:'mpmGrid', flex:1, task:this.task, header:false, name:'CONTACTCHANNEL', _columns:[{dataIndex:'CODE', text:' ', width:50, renderer:function(v) {
    var map = {EM:'fa-envelope-square', TE:'fa-phone-square-alt'};
    v = v || '';
    return mpm.Support.getSpanForIconCls(map[v] || 'fa-exclamation-triangle', '#000');
  }}, {dataIndex:'CONTACT', flex:1, text:'Kontakt'}], readOnly:readOnly}]))}, {xtype:'mpmFieldSet', title:'Empfänger', flex:1, layout:{type:'vbox', align:'stretch'}, items:this.createFields([{key:'CDEMPFAENGERID', fieldLabel:'Empfänger'}, {key:'CDEMPFAENGERPARTNERNAME', fieldLabel:'Name'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'COMDIS', items:this.createFields([{key:'CDNACHRICHTENNUMMER', fieldLabel:'Nachrichtennummer'}, {key:'CDNACHRICHTENDATUM', fieldLabel:'Nachrichtendatum', type:'date'}, {key:'CDREFCODE', fieldLabel:'Begründung', type:'dic', dataKey:'anpassungsgrund'}, {key:'CDREF', fieldLabel:'Referenz', type:'dic', dataKey:'anpassungsgrundSonstiges', hidden:this.mode !== 'invoice'}, {key:'CDREFFILE', fieldLabel:this.mode === 'invoice' ? 'Datenaustauschreferenz' : 'Erklärung', 
  type:'textarea'}, {key:'CDREFNR', fieldLabel:'Vorgangsnummer', hidden:this.mode !== 'invoice'}, {key:'CDREFIN', fieldLabel:'Empfangsbestätigung', hidden:this.mode !== 'invoice'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'Lieferschein', hidden:this.mode !== 'delivery', items:this.createFields([{key:'LIEFERSCHEINNUMMER', fieldLabel:'Nummer'}, {key:'LIEFERSCHEINDATUM', fieldLabel:'Datum', type:'date'}, {key:'LSANTWORTNUMMER', fieldLabel:'Antwortnummer'}, {key:'LSANTWORT', fieldLabel:'Antwort'}, {key:'LSANTWORTDETAILS', fieldLabel:'Antwortdetails', type:'dic', dataKey:'antwortdetails'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}, {xtype:'mpmFieldSet', flex:1, title:'Rechnung', hidden:this.mode !== 'invoice', items:this.createFields([{key:'NACHRICHTENNUMMER', fieldLabel:'Nummer'}, {key:'RECHNUNGSDATUM', fieldLabel:'Datum', type:'date'}, {key:'CSRECHNUNGSBETRAG', fieldLabel:'Betrag'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}], task:this.task}];
  this.callParent(arguments);
}, createFields:function(fields) {
  return this.task.createFields(fields, undefined, undefined, this.task);
}});
Ext.define('mpm.components.remadvUi', {extend:'mpm.components.Container', alias:'widget.mpmRemadvUi', layout:{type:'vbox', align:'stretch'}, task:undefined, scrollable:true, mode:'invoice', initComponent:function() {
  this.title = this.TR('REMADV');
  this.iconCls = this.faIcon('fa-receipt');
  var readOnly = true;
  this.items = [{xtype:'container', flex:1, layout:{type:'hbox', align:'stretch'}, items:[{xtype:'mpmFieldSet', title:'Allgemein', flex:1, layout:{type:'vbox', align:'stretch'}, items:this.createFields([{key:'UEBERWIESENERBETRAG', fieldLabel:'Überwiesender Betrag'}, {key:'ZAHLUNGSDATUM', type:'date'}, {key:'CONTACTNAME', fieldLabel:'Kontakt'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }).concat([mpm.util.Components.getHr(), {xtype:'mpmGrid', flex:1, task:this.task, header:false, name:'CONTACTCHANNEL', _columns:[{dataIndex:'CODE', text:' ', width:50, renderer:function(v) {
    var map = BpcCommon.Api.getSetting('mpm', 'contactIcons') || {EM:'fa-envelope-square', TE:'fa-phone-square-alt'};
    v = v || '';
    return mpm.Support.getSpanForIconCls(map[v] || 'fa-exclamation-triangle', '#000');
  }}, {dataIndex:'CONTACT', flex:1, text:'Kontakt'}], readOnly:true}]))}, {xtype:'mpmFieldSet', flex:1, title:'Prozess', layout:{type:'vbox', align:'stretch'}, items:this.createFields([{key:'PROCESSID'}, {key:'DIRECTION'}, {key:'SENDERID', fieldLabel:'Sender'}, {key:'EMPFAENGERID', fieldLabel:'Empfänger'}, {key:'TYPE', fieldLabel:'Typ'}].map(function(f) {
    f.sliceLabelPrefix = '';
    f.readOnly = readOnly;
    return f;
  }))}], task:this.task}];
  this.callParent(arguments);
}, createFields:function(fields) {
  return this.task.createFields(fields, undefined, undefined, this.task);
}});
Ext.define('mpm.packages.routing.Base', {extend:'mpm.tasks.MpmTask', requires:['mpm.tasks.MpmTask'], submitValue:undefined, constructor:function(config) {
  this.setRoutingWrapper(config);
  this.add(this.createTabPanel(this.getCustomTabConfigs(), this.getCustomComponents()));
  this.callParent(arguments);
  this.addTaskToWindow(this.getTaskActionButtonsCfgs(this.getButtonsFromTaskDefinition(config.meta)));
  this.addFlextableHistoryGrid(this.process.processId);
}, getCustomTabConfigs:function() {
  return [];
}, getCustomComponents:function() {
  return [];
}, createForm:function(data) {
  var store = mpm.util.Store.newLocalStore(data);
  return Ext.create({xtype:'grid', viewConfig:{emptyText:mpm.Support.TR('EMPTY_TEXT_GRID'), markDirty:false, style:'background-color:' + mpm.Support.styling.tableview['background-color'] + ';'}, store:store, title:mpm.Support.TR('ROUTING_TARGETSYSTEMS'), iconCls:mpm.Support.icon('fa-dot-circle'), columns:[{xtype:'checkcolumn', dataIndex:'selected', task:this, listeners:{checkchange:function(col, rowIndex, checked, rec) {
    if (checked) {
      col.task.setValue(rec.get('Submit'));
    }
    var checked = [];
    store.each(function(r) {
      if (r.get('selected')) {
        checked.push(r);
      }
    });
    checked.map(function(r) {
      if (r.get('Submit') !== rec.get('Submit')) {
        r.set('selected', false);
      }
    });
    if (!checked.length) {
      col.task.setValue(undefined);
    }
  }}}, {dataIndex:'Submit', hidden:true}, 'Package', 'Protocol', {dataIndex:'E-MailReceiver', renderer:this.renderer.ifStringNullAsEmpty}, 'Path', {dataIndex:'Data', flex:1}].map(function(colCfg) {
    if (typeof colCfg === 'string') {
      colCfg = {dataIndex:colCfg};
    }
    colCfg.text = mpm.Support.TR('COL_' + colCfg.dataIndex);
    return colCfg;
  })});
}, renderer:{ifStringNullAsEmpty:function(v) {
  v = v === void 0 ? '' : v;
  if (v === 'null') {
    return '';
  }
  return v;
}}, setRoutingWrapper:function(config) {
  this.isConfig = config;
  this.dto = config.dto;
  this.applyMpmInstanceId(config);
  this.setWrapper({task:this, msg:this.isConfig.taskMsgText, meta:config.meta});
  if (this.dto.processID) {
    this.notify('PROCESSID DEFINED IN DTO - CHANGE AND TALK TO YOUR DEV', 'w');
  }
  this.process = {processId:this.dto.processID, values:this.dto.values || {}, prefix:this.dto.prefix || 'MESSAGE_'};
  if (!this.isConfig.meta.process) {
    this.notify('meta.process WILL GET OVERWRITTEN', 'w');
    this.isConfig.meta.process = this.process;
  }
  var processPanel = this.createProcessPanel();
  this.taskMainHeader = processPanel;
  this.addModuleJump();
  this.add(processPanel);
}, createProcessPanel:function() {
  var $jscomp$this = this;
  var panel = Ext.create({xtype:'mpmPanel', flex:1, layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'mpmFieldSet', flex:1}, header:false, task:this});
  var items = BpcCommon.Api.getSetting('mpm', 'processData_panelFields').map(function(arrayWithDefinitions) {
    return {items:$jscomp$this.createFields(arrayWithDefinitions.map(function(f) {
      if (typeof f === 'string') {
        f = {key:f};
      }
      f.readOnly = true;
      return f;
    }))};
  });
  panel.add(items);
  this.getProcessData().then(function(row) {
    panel.query('field[name]').map(function(f) {
      if (row[f.name]) {
        f.setValue(row[f.name]);
      }
    });
  });
  return panel;
}, getProcessData:function() {
  return mpm.Support.getAjaxPromise({method:'GET', url:mpm.Support.getFlexTablePathForModuleId(mpm.Support.getFlextableIdForTablePrefix(this.process.prefix)), params:{id:this.process.processId, details:false}}).then(function(r) {
    var json = Ext.decode(r.responseText, true);
    if (json && json.count === 1) {
      return json.items[0];
    }
    return undefined;
  });
}});
Ext.define('mpm.packages.routing.MultipleRoutesTask', {extend:'mpm.packages.routing.Base', alias:['widget.routingMultipleRoutesTask'], requires:['mpm.packages.routing.Base'], submitValue:undefined, getCustomComponents:function() {
  return [this.createForm(this.process.values.routes.filter(function(r) {
    return r.IsRoute === true;
  }) || [])];
}});
Ext.define('mpm.packages.routing.NegCONTRLTask', {extend:'mpm.packages.routing.Base', alias:['widget.routingNegContrlOutTask'], requires:['mpm.packages.routing.Base']});
Ext.define('mpm.packages.routing.NoPartnerTask', {extend:'mpm.packages.routing.Base', alias:['widget.routingNoPartnerTask'], requires:['mpm.packages.routing.Base'], getCustomTabConfigs:function() {
  return [{xtype:'mpmMailView', protocolData:this.dto.protocolData || {}}];
}});
Ext.define('mpm.packages.routing.NoRouteTask', {extend:'mpm.packages.routing.Base', alias:['widget.routingNoRouteTask'], requires:['mpm.packages.routing.Base'], submitValue:undefined, getCustomComponents:function() {
  return [this.createForm(this.process.values.routes || [])];
}});
Ext.define('mpm.packages.wim.FormPopup', {extend:'Ext.util.Observable', addToStore:function(record) {
  this.store.add(this.record);
}, saveRecord:function(record) {
}, onClose:function() {
  if (this.window) {
    this.window.close();
  }
}, onCommit:function() {
  this.saveRecord(this.record);
  if (this.mode == 'create') {
    this.addToStore(this.record);
  }
  this.doCommit.apply(this, arguments);
}, doCommit:function() {
  if (this.window) {
    this.window.hide();
  }
  var v = ['commit', this].concat(Ext.toArray(arguments));
  this.fireEvent.apply(this, v);
  this.fireEvent('close');
}, newSimpleComboBox:function(config) {
  return new Ext.form.ComboBox(Ext.apply({}, config, {width:300, allowBlank:false, triggerAction:'all', forceSelection:true}));
}, newSimpleCheckBox:function(config) {
  return new Ext.form.Checkbox(Ext.apply({}, config, {width:300}));
}, createCommitCancelButtons:function() {
  this.commitButton = new Ext.Button({scale:'medium', width:120, text:'Übernehmen', handler:this.onCommit, scope:this});
  this.cancelButton = new Ext.Button({scale:'medium', width:120, text:'Abbrechen', handler:this.onClose, scope:this});
  this.buttons = new Ext.Panel({layout:{type:'hbox', align:'stretch', pack:'center', padding:'10'}, items:[{xtype:'container', flex:1, width:10}, this.commitButton, {xtype:'container', width:10}, this.cancelButton, {xtype:'container', flex:1, width:10}]});
}, createFormWindow:function(title, width, height) {
  this.window = new Ext.Window({title:title, resizable:false, modal:true, layout:{type:'vbox', align:'stretch'}, constrainHeader:true, width:width, height:height, items:[this.form, this.buttons]});
}});
Ext.define('mpm.packages.wim.StubCore', {requires:['mpm.packages.wim.FormPopup']});
(function() {
  Ext.ns('WIM');
  Ext.util.CSS.createStyleSheet('.wim-invalid-row { background: #ffaaaa; }' + '.wim-invalid-cell { background: #ffaaaa; }', 'bpc-fe-mpm-wim');
  WIM.configuration = {maxErrorLength:200, invalidRowClass:'wim-invalid-row', invalidCellClass:'wim-invalid-cell', noRowsInvalidText:'Eintrag erforderlich', noRowsText:'Keine Einträge'};
  WIM.iconCls = function(icon) {
    return 'x-fa ' + Ext.String.htmlEncode(icon);
  };
  WIM.iconClsHtml = function(icon, color) {
    if (!Ext.isEmpty(color)) {
      color = 'style\x3d"color:' + Ext.String.htmlEncode(color) + '"';
    }
    return '\x3cspan ' + color + ' class\x3d"' + WIM.iconCls(icon) + '"\x3e\x3c/span\x3e';
  };
  WIM.noRowsText = function(invalid) {
    return WIM.configuration[invalid ? 'noRowsInvalidText' : 'noRowsText'];
  };
  WIM.updateGridNoRowsText = function(g, invalid) {
    g.setEmptyText(WIM.noRowsText(invalid));
  };
  WIM.marktpartnerText = function(_) {
    if (!_) {
      return '';
    }
    var result = '';
    if (Ext.isEmpty(_.partnername)) {
      result = Ext.isEmpty(_.mpid) ? '' : 'unbekannt (' + _.mpid + ')';
    } else {
      if (Ext.isEmpty(_.mpid)) {
        result = _.partnername + ' (unbekannt)';
      } else {
        result = _.partnername + ' (' + _.mpid + ')';
      }
    }
    return result;
  };
  WIM.trueFunction = function() {
    return true;
  };
  WIM.falseFunction = function() {
    return false;
  };
  WIM.IDOf = function(_) {
    return _.ID;
  };
  WIM.StringSet = Ext.extend(Object, {constructor:function() {
    this.data = {};
    this._size = 0;
  }, size:function() {
    return this._size;
  }, contains:function(_) {
    return this.data[_] === true;
  }, toArray:function() {
    var result = [];
    for (var e in this.data) {
      if (this.data[e] === true) {
        result.push(e);
      }
    }
    return result;
  }, equals:function(other) {
    if (this._size !== other._size) {
      return false;
    }
    for (var e in this.data) {
      if (this.data[e] === true) {
        if (other.data[e] !== true) {
          return false;
        }
      }
    }
    return true;
  }});
  WIM.StringSet.fromArray = function(_) {
    var result = new WIM.StringSet();
    Ext.each(_, function(e) {
      if (result.data[e] !== true) {
        result.data[e] = true;
        result._size++;
      }
    }, this);
    return result;
  };
  WIM.XMLOutput = Ext.extend(Object, {constructor:function() {
    this.s = '';
    this._quote = '"';
  }, quote:function() {
    return this._quote;
  }, reset:function() {
    this.s = '';
  }, begin:function(name, type) {
    if (type == 'atom') {
      type = '';
    } else {
      type = ' type\x3d' + this._quote + Ext.String.htmlEncode(type) + this._quote;
    }
    this.s += '\x3c' + name + type + '\x3e';
  }, end:function(name) {
    this.s += '\x3c/' + name + '\x3e';
  }, text:function(value) {
    this.s += Ext.String.htmlEncode(Ext.valueFrom(value, ''));
  }, encodedText:function(value) {
    this.s += value;
  }, subXML:function(value) {
    this.s += value;
  }, atom:function(name, value) {
    this.s += '\x3c' + name + '\x3e' + Ext.String.htmlEncode(Ext.valueFrom(value, '')) + '\x3c/' + name + '\x3e';
  }, atomArray:function(name, value) {
    this.s += '\x3c' + name + " type\x3d'array'\x3e";
    if (Ext.isArray(value)) {
      Ext.each(value, function(v) {
        this.atom('item', v);
      }, this);
    }
    this.s += '\x3c/' + name + '\x3e';
  }, encodedAtom:function(name, value) {
    this.s += '\x3c' + name + '\x3e' + value + '\x3c/' + name + '\x3e';
  }, result:function() {
    return this.s;
  }});
  WIM.handleFailure = function(response, exception) {
    var s = 'Unbekannter Fehler';
    try {
      if (exception) {
        if (response.responseText === '' && exception.message == 'Syntax error') {
          s = 'Interner Fehler: Leere Antwort vom Server.';
        } else if (response.responseText === '') {
          s = 'Serverfehler: Leere Antwort vom Server.';
        } else if (response.responseText.substring(0, 1) != '{') {
          s = 'Serverfehler: ' + response.responseText;
        } else {
          s = 'Interner Fehler: ' + exception.message;
        }
      } else {
        s = 'Serverfehler.';
        if (!Ext.isEmpty(response.responseText)) {
          try {
            var d = Ext.decode(response.responseText);
            if (Ext.isObject(d) && d.message && d.message != 'OK') {
              s += ': ' + d.message;
            } else {
              s += ': ' + d;
            }
          } catch (e) {
            s += ':  ' + response.responseText;
          }
        } else {
          if (!Ext.isEmpty(response.statusText) && response.statusText != 'OK') {
            s += ': ' + response.statusText;
          }
        }
      }
    } catch (e$4) {
      Ext.log({level:'error', msg:'WIM.handleFailure - Error extracting the error message', dump:e$4, stack:true});
    }
    s = Ext.String.htmlEncode(s);
    var maxLength = WIM.configuration.maxErrorLength;
    if (s.length > maxLength) {
      s = s.substring(0, maxLength) + '\x26nbsp;...';
    }
    Ext.Msg.alert('Fehler', s);
  };
  WIM.tooltipText = function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.util.Format.nl2br(Ext.String.htmlEncode(Ext.String.htmlEncode(v)));
  };
  WIM.renderer = function(config) {
    config = config || {};
    return function(v, meta) {
      v = Ext.util.Format.htmlEncode(Ext.valueFrom(v, ''));
      if (config.tooltip) {
        meta.attr = "ext:qtip\x3d'" + WIM.tooltipText(v) + "'";
      }
      return "\x3cdiv style\x3d'white-space:nowrap'\x3e" + v + '\x3c/div\x3e';
    };
  };
  WIM.startOfToday = function() {
    return Ext.Date.clearTime(new Date());
  };
  WIM.startOfTomorrow = function() {
    return Ext.Date.clearTime(Ext.Date.add(new Date(), Ext.Date.DAY, 1));
  };
  WIM.endOfToday = function() {
    return Ext.Date.add(Ext.Date.clearTime(Ext.Date.add(new Date(), Ext.Date.DAY, 1)), Ext.Date.SECOND, -1);
  };
  WIM.startOfDay = function(d) {
    return Ext.Date.clearTime(d);
  };
  WIM.endOfDay = function(d) {
    return Ext.Date.add(Ext.Date.clearTime(Ext.Date.add(d, Ext.Date.DAY, 1)), Ext.Date.SECOND, -1);
  };
  WIM.arrayRenderer = function(s) {
    if (s !== '' && Ext.isEmpty(s)) {
      s = '\x3cbr/\x3e';
    }
    return function(v) {
      if (Ext.isEmpty(v)) {
        return '';
      }
      if (!Ext.isArray(v)) {
        return Ext.String.htmlEncode(v);
      }
      var result = '';
      Ext.each(v, function(w, index) {
        if (index !== 0) {
          result += s;
        }
        result += Ext.String.htmlEncode(w);
      }, this);
      return result;
    };
  };
  WIM.dateOrSpanDisplayValue = function(_) {
    if (Ext.isEmpty(_)) {
      return _;
    }
    var index = _.indexOf(' - ');
    return index >= 0 ? WIM.dateDisplayValue(_.substring(0, index)) + ' - ' + WIM.dateDisplayValue(_.substring(index + 3)) : WIM.dateDisplayValue(_);
  };
  WIM.dateDisplayValue = function(dateString) {
    if (Ext.isEmpty(dateString)) {
      return dateString;
    }
    var d = Ext.Date.parse(dateString, 'c');
    if (!d) {
      return dateString;
    }
    return dateString.length == 10 ? Ext.Date.format(d, 'd.m.Y') : Ext.Date.format(d, 'd.m.Y H:i');
  };
  WIM.dbDateDisplayValue = function(dateString) {
    if (Ext.isEmpty(dateString)) {
      return '';
    }
    var d = Ext.Date.parse(dateString.substring(0, 19), 'Y-m-d H:i:s');
    if (d) {
      dateString = Ext.Date.format(d, 'd.m.Y H:i:s');
    }
    return dateString;
  };
  WIM.activateFirstPossibleTab = function(tabPanel) {
    tabPanel.items.each(function(t, index) {
      if (!t.disabled) {
        tabPanel.setActiveTab(t);
        return false;
      }
      return true;
    }, this);
  };
  WIM.MaskServerCallback = Ext.extend(Object, {constructor:function(config) {
    this.callParent(arguments);
    this.component = config.component;
    this.callback = {noAction:config.noAction || Ext.emptyFn, starting:config.starting || Ext.emptyFn, success:config.success || Ext.emptyFn, failure:config.failure || Ext.emptyFn};
    this.scope = config.scope;
  }, noAction:function() {
    this.callback.noAction.apply(this.scope, arguments);
  }, success:function() {
    this.decreaseMask(this.component);
    this.callback.success.apply(this.scope, arguments);
  }, failure:function() {
    this.decreaseMask(this.component);
    this.callback.failure.apply(this.scope, arguments);
  }, increaseMask:function(component) {
    if (component) {
      if (component.maskCount === undefined) {
        component.maskCount = 1;
      } else {
        component.maskCount++;
      }
      if (component.rendered) {
        component.setLoading(true);
      } else {
        component.on('render', function() {
          if (component.maskCount > 0) {
            component.setLoading(true);
          }
        }, this);
      }
    }
  }, decreaseMask:function(component) {
    if (component) {
      if (component.maskCount !== undefined) {
        --component.maskCount;
        if (component.maskCount === 0 && component.rendered) {
          component.setLoading(false);
        }
      }
    }
  }, starting:function() {
    this.increaseMask(this.component);
    this.callback.starting.apply(this.scope, arguments);
  }});
  WIM.AjaxRequest = Ext.extend(Object, {constructor:function(config) {
    this.callParent(arguments);
    this.ajaxRequest = config.ajaxRequest;
    this.callback = config.callback;
  }, noAction:function() {
    this.callback.noAction();
  }, request:function() {
    var request = Ext.apply({timeout:120000, success:this.success, failure:this.failure, scope:this}, this.ajaxRequest);
    this.callback.starting();
    Ext.Ajax.request(request);
  }, success:function(response, options) {
    this.callback.success(response);
  }, failure:function(response) {
    this.callback.failure(response);
  }});
  WIM.newScrollableDisplayField = function(data) {
    return new Ext.form.field.Text(Ext.apply({}, data, {readOnly:true}));
  };
  Ext.define('WIM.SimpleModel', {extend:'Ext.data.Model', idProperty:'ID'});
  WIM.Process = Ext.extend(Object, {constructor:function(config) {
    this.prefix = Ext.valueFrom(config.prefix, '');
    this.processID = Ext.valueFrom(config.processID, '');
    this.own_mpid = Ext.valueFrom(config.own_mpid, '');
    this.own_mpidcode = Ext.valueFrom(config.own_mpidcode, '');
  }, makeCommand:function() {
    return '\x3cprocess\x3e\x3cprefix\x3e' + Ext.String.htmlEncode(this.prefix) + '\x3c/prefix\x3e\x3cprocessid\x3e' + Ext.String.htmlEncode(this.processID) + '\x3c/processid\x3e\x3cmandant\x3e\x3cown_mpid\x3e' + Ext.String.htmlEncode(this.own_mpid) + '\x3c/own_mpid\x3e\x3cown_mpidcode\x3e' + Ext.String.htmlEncode(this.own_mpidcode) + '\x3c/own_mpidcode\x3e\x3c/mandant\x3e\x3c/process\x3e';
  }});
  WIM.ProcessRequest = Ext.extend(Object, {constructor:function(config) {
    this.process = config.process;
    this.url = config.url;
    if (config.referenz !== undefined) {
      this.referenz = config.referenz;
    }
    this.scope = config.scope || this;
    if (config.makeCommand) {
      this.makeCommand = config.makeCommand;
    }
    if (config.requestSuccess) {
      this.requestSuccess = config.requestSuccess;
    }
    if (config.requestFailure) {
      this.requestFailure = config.requestFailure;
    }
  }, makeDefaultCommand:function() {
    return this.process.makeCommand();
  }, makeCommand:function() {
    return this.makeDefaultCommand();
  }, start:function(mask) {
    if (!this.request) {
      this.request = new WIM.AjaxRequest({ajaxRequest:{url:this.url, method:'POST', params:{command:'\x3cread\x3e' + this.makeCommand() + '\x3c/read\x3e'}}, callback:new WIM.MaskServerCallback({component:mask, scope:this, starting:Ext.emptyFn, noAction:Ext.emptyFn, success:this.success, failure:this.failure})});
    } else {
      this.request.ajaxRequest.params.command = '\x3cread\x3e' + this.makeCommand() + '\x3c/read\x3e';
    }
    this.request.request();
  }, failure:function() {
    this.requestFailure.apply(this.scope, arguments);
  }, success:function(response) {
    try {
      var d = Ext.decode(response.responseText);
      if (d.success === true || d.success === 'true') {
        this.requestSuccess.call(this.scope, d);
      } else {
        this.requestFailure.call(this.scope, response);
      }
    } catch (e) {
      try {
        this.requestFailure.call(this.scope, response, e);
      } catch (e2) {
        Ext.Msg.alert('Fehler', 'Unerwarteter Fehler: ' + Ext.valueFrom(e2.message, '[unbekannt]'));
      }
    }
  }, requestFailure:function() {
  }, requestSuccess:function() {
  }});
  WIM.ProcessView = Ext.extend(Object, {constructor:function(config) {
    this.process = config.process;
    this.wimContext = config.wimContext;
    this.isGERAustausch = !!config.isGERAustausch;
    this.hiddenFields = WIM.StringSet.fromArray(config.hiddenFields);
    this.root = new Ext.form.Panel({layout:{type:'hbox', align:'stretch'}, scrollable:true, bodyPadding:'10'});
  }, loadMeta:function(root) {
    var labelWidth = 80;
    var columnWidth = 300 + labelWidth;
    var ff = [Ext.create('Ext.form.field.Display', {name:'STATUS', fieldLabel:'Status', htmlEncode:false, width:columnWidth}), WIM.newScrollableDisplayField({name:'PROCESSID', fieldLabel:'Prozess-ID', width:columnWidth}), WIM.newScrollableDisplayField({name:'NAME', fieldLabel:'Prozess', width:columnWidth}), WIM.newScrollableDisplayField({name:'ZAEHLPUNKT', fieldLabel:'Zählpunkt', width:columnWidth})];
    this.root.add(new Ext.form.FieldContainer({padding:'0 0 0 0', fieldDefaults:{labelWidth:labelWidth}, width:columnWidth, items:ff}));
    labelWidth = 120;
    columnWidth = 250 + labelWidth;
    ff = [];
    if (!this.hiddenFields.contains('VORGANG')) {
      ff.push(this.vorgangField = WIM.newScrollableDisplayField({name:'VORGANG', fieldLabel:'Vorgang', width:columnWidth}));
    }
    this.marktpartnerField = WIM.newScrollableDisplayField({name:'MP_PARTNERNAME', fieldLabel:'Marktpartner', width:columnWidth});
    if (!this.hiddenFields.contains('MP')) {
      ff.push(this.marktpartnerField);
    }
    if (root.data.LOG.RICHTUNG !== undefined && !this.hiddenFields.contains('RICHTUNG')) {
      ff.push(WIM.newScrollableDisplayField({name:'RICHTUNG', fieldLabel:'Richtung', width:columnWidth}));
    }
    this.marktpartnerFieldSet = new Ext.form.FieldContainer({padding:'0 10 0 10', fieldDefaults:{labelWidth:labelWidth}, width:columnWidth, items:ff});
    this.root.add(this.marktpartnerFieldSet);
    columnWidth = 250 + labelWidth;
    ff = [WIM.newScrollableDisplayField({name:'TIMESTAMP', fieldLabel:'Zeitstempel', width:columnWidth})];
    if (root.data.LOG.DATUMUNPLAUSIBEL === 'ja') {
      ff.push(Ext.create('Ext.form.field.Display', {htmlEncode:false, name:'', fieldLabel:'Vorlauffrist', value:'\x3cspan style\x3d"color:red"\x3eNicht eingehalten.\x3c/span\x3e', width:columnWidth}));
    }
    if (root.data.LOG.TERMINUNPLAUSIBEL === 'korridor') {
      ff.push(Ext.create('Ext.form.field.Display', {htmlEncode:false, name:'', fieldLabel:'Termin', value:'\x3cspan style\x3d"color:red"\x3eRealisierungskorridor nicht eingehalten.\x3c/span\x3e', width:columnWidth}));
    }
    var fristWidth = 140;
    ff.push(new Ext.form.FieldContainer({fieldLabel:'Bearbeitung bis', layout:{type:'hbox'}, items:[WIM.newScrollableDisplayField({width:fristWidth, name:'OFFENEFRIST'}), new Ext.Container({width:5}), Ext.create('Ext.form.field.Display', {width:columnWidth - fristWidth - 5, name:'FRISTSTATUS', htmlEncode:false})]}));
    this.root.add(new Ext.form.FieldContainer({padding:'0 0 0 0', fieldDefaults:{labelWidth:labelWidth}, width:columnWidth, items:ff}));
  }, fixMarktpartnerVorgangFieldSet:function(root, displayedData) {
    if (this.isGERAustausch) {
      if (root.data.LOG.ROLLE == 'NB') {
        if (Ext.isEmpty(root.data.LOG.MP_MPID)) {
          if (Ext.isEmpty(root.data.LOG.MSBA_MPID)) {
            if (!Ext.isEmpty(root.data.LOG.MDL_MPID)) {
              this.marktpartnerField.setFieldLabel('Marktpartner (MDL)');
              displayedData.MP_MPID = displayedData.MDL_MPID;
              displayedData.MP_MPIDCODE = displayedData.MDL_MPIDCODE;
              displayedData.MP_PARTNERNAME = displayedData.MDL_PARTNERNAME;
              displayedData.MP_PARTNERID = displayedData.MDL_PARTNERID;
            }
          } else {
            this.marktpartnerField.setFieldLabel('Marktpartner MSB');
            displayedData.MP_MPID = displayedData.MSBA_MPID;
            displayedData.MP_MPIDCODE = displayedData.MSBA_MPIDCODE;
            displayedData.MP_PARTNERNAME = displayedData.MSBA_PARTNERNAME;
            displayedData.MP_PARTNERID = displayedData.MSBA_PARTNERID;
          }
        } else {
          if (Ext.isEmpty(root.data.LOG.MSBA_MPID)) {
            this.marktpartnerField.setFieldLabel('Marktpartner MSB(N)');
          } else {
            this.marktpartnerField.setFieldLabel('Marktpartner MSB(N)');
            var p = this.marktpartnerFieldSet;
            p.insert(p.items.indexOf(this.marktpartnerField) + 1, WIM.newScrollableDisplayField({name:'MSBA_PARTNERNAME', fieldLabel:'MP MSB(N)/MSBA', width:250}));
          }
        }
      }
    }
  }, load:function(root) {
    this.loadMeta(root);
    var dd = Ext.apply({}, root.data.LOG);
    var convertFields = {STATUS:this.wimContext.statusIconIMGRenderer(), TIMESTAMP:WIM.dbDateDisplayValue, LASTUPDATE:WIM.dbDateDisplayValue};
    Ext.Object.each(convertFields, function(name, f) {
      dd[name] = f.call(this, dd[name]);
    }, this);
    var fristen = Ext.clone(root.data.OFFENEFRISTEN);
    fristen.sort(function(a, b) {
      return a.DATUM < b.DATUM ? -1 : a.DATUM > b.DATUM ? 1 : 0;
    });
    dd.OFFENEFRIST = fristen.length > 0 ? WIM.dateDisplayValue(fristen[0].DATUM) : '';
    var friststatus = Ext.isEmpty(dd.FRISTSTATUS) ? '' : dd.FRISTSTATUS.replace(/^Frist_/, '');
    dd.FRISTSTATUS = Ext.isEmpty(friststatus) || friststatus === 'OK' ? '' : '\x3cspan style\x3d"color:red"\x3e' + Ext.String.htmlEncode(friststatus) + '\x3c/span\x3e';
    this.fixMarktpartnerVorgangFieldSet(root, dd);
    this.root.getForm().loadRecord(new Ext.data.Model(dd));
  }, setZaehlpunkt:function(_) {
    this.root.getForm().setValues({ZAEHLPUNKT:_});
  }});
  WIM.AbstractMessagePanel = Ext.extend(Object, {constructor:function(config) {
    this.wimContext = config.wimContext;
    this.process = config.process;
  }, requestData:function(maskComponent) {
    this.maskComponent = maskComponent;
    var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, requestSuccess:function(data) {
      data = data.data;
      if (!data.meta || !data.data.LOG || !data.data.LOG.PROCESSID) {
        Ext.Msg.alert('Fehler', 'Keine Daten zum Prozess (' + Ext.util.Format.htmlEncode(this.process.processID) + ') gefunden.');
        this.requestFailed();
      } else {
        this.loadMeta(data);
        this.load(data);
        if (this.tabs) {
          WIM.activateFirstPossibleTab(this.tabs);
        }
      }
    }, requestFailure:function() {
      WIM.handleFailure.apply(this, arguments);
      this.requestFailed();
    }});
    processRequest.start(this.maskComponent);
  }, loadMeta:function(root) {
  }, load:function(root) {
    if (this.processView) {
      this.processView.load(root);
    }
    if (this.historyView) {
      this.historyView.load(root);
    }
  }, requestFailed:function(value) {
    if (this.historyView) {
      this.historyView.requestFailed();
    }
  }});
  WIM.Latin1Regex = function() {
    var s = '';
    var i;
    for (i = 32; i < 127; i++) {
      s += String.fromCharCode(i);
    }
    for (i = 160; i <= 255; i++) {
      s += String.fromCharCode(i);
    }
    s = s.replace(/([\[\]\\\-])/g, '\\$1');
    s = '^[' + s + ']*$';
    return new RegExp(s);
  }();
  WIM.Latin1RegexError = 'Das Feld enthält ungültige Zeichen.';
  WIM.obisRegex = /((^\d[-]\d{1,2}:)((\d{1,2})\.(\d{1,2})\.(\d{1,2})$))/;
  WIM.obisRegexError = 'Das OBIS-Format wurde nicht eingehalten.';
  WIM.turnusRegex = new RegExp('^(((1[0-2]|0[1-9])(3[01]|[12][0-9]|0[1-9]))|(((1[0-2]|0[1-9])[0][1-4])((1[0-2]|0[1-9])[0][1-4])))$');
  WIM.turnusRegexError = 'Das Format für die geplante Turnusablesung wurde nicht eingehalten (MMDD oder MMWWMMWW)';
  WIM.erstmaligeturnusRegex = new RegExp('^(19|[2-9][0-9])[0-9]{2}$');
  WIM.erstmaligeturnusRegexError = 'Das Format für die erstmalige Turnusablesung wurde nicht eingehalten (CCYY)';
  WIM.positiveZahlMaskRegex = new RegExp('[0-9,]');
  WIM.positiveZahlRegex = new RegExp('^[1-9][0-9]*(,[0-9]+)?$');
  WIM.nichtnegativeZahlMaskRegex = new RegExp('[0-9,]');
  WIM.nichtnegativeZahlRegex = new RegExp('^(0|([1-9][0-9]*))(,[0-9]+)?$');
  WIM.ZahlField = Ext.extend(Ext.form.field.Text, {maskRe:WIM.positiveZahlMaskRegex, regex:WIM.positiveZahlRegex, regexText:'Ungültige Zahl', setValue:function(_) {
    _ = Ext.valueFrom(_, '');
    _ = String(_).replace('.', ',');
    Ext.form.field.Text.prototype.setValue.call(this, _);
  }, getValue:function() {
    return String(Ext.form.field.Text.prototype.getValue.call(this)).replace(',', '.');
  }});
  WIM.preisMaskRegex = new RegExp('[0-9,]');
  WIM.preisRegex = new RegExp('^([1-9][0-9]*|0),[0-9][0-9]$');
  WIM.PreisField = Ext.extend(WIM.ZahlField, {maskRe:WIM.preisMaskRegex, regex:WIM.preisRegex, regexText:'Ungültiger Preis'});
  WIM.preisOptionalMaskRegex = new RegExp('[0-9,]');
  WIM.preisOptionalRegex = new RegExp('^([1-9][0-9]*|0)(,[0-9][0-9])?$');
  WIM.PreisFieldOptional = Ext.extend(WIM.ZahlField, {maskRe:WIM.preisOptionalMaskRegex, regex:WIM.preisOptionalRegex, regexText:'Ungültiger Preis', getValue:function() {
    var v = String(Ext.form.field.Text.prototype.getValue.call(this));
    if (v === '') {
      return '';
    }
    if (v.indexOf(',') >= 0) {
      return v.replace(',', '.');
    } else {
      return v + '.00';
    }
  }});
  WIM.Component = Ext.extend(Ext.util.Observable, {constructor:function(config) {
    WIM.Component.superclass.constructor.call(this, {});
    this.noSubmit = config.noSubmit;
    if (config.canSave) {
      this.canSave = config.canSave;
    }
    if (config.canAccept) {
      this.canAccept = config.canAccept;
    }
    if (config.canReject) {
      this.canReject = config.canReject;
    }
  }, canAccept:function() {
    return true;
  }, canReject:function() {
    return true;
  }, canSave:function() {
    return true;
  }, hasSubmitValue:function() {
    if (this.field && this.field.destroyed) {
      return false;
    }
    return !this.noSubmit && !this.isDisabled() && !this.isHidden();
  }, isDisabled:WIM.falseFunction, isHidden:WIM.falseFunction, submitType:function() {
    return 'atom';
  }, copyValue:function() {
    return '';
  }, submitValue:function() {
    return '';
  }, load:function(_) {
  }, isMulti:function() {
    return false;
  }, addFields:function(into) {
  }, fieldsToArray:function() {
    var result = [];
    this.addFields(result);
    return result;
  }});
  WIM.NamedComponent = Ext.extend(WIM.Component, {constructor:function(config) {
    this.callParent(arguments);
    this.name = config.name;
  }});
  WIM.FixedComponent = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.value = config.value;
  }, setFixedValue:function(_) {
    this.value = _;
  }, submitValue:function() {
    return Ext.String.htmlEncode(this.value);
  }});
  WIM.TunnelComponent = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
  }, load:function(_) {
    this.value = Ext.valueFrom(_, '');
  }, submitValue:function() {
    return Ext.String.htmlEncode(this.value);
  }});
  WIM.SpaceComponent = Ext.extend(WIM.Component, {constructor:function(config) {
    config = Ext.apply({}, config, {height:10});
    WIM.SpaceComponent.superclass.constructor.call(this, config);
    this.field = new Ext.Component(config);
    this.noSubmit = true;
  }, addFields:function(into) {
    into.push(this.field);
  }});
  WIM.FieldComponent = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.field = config.field;
    this.initialValue = config.initialValue;
  }, setReadOnly:function(_) {
    this.field.setReadOnly(_);
  }, isReadOnly:function() {
    return this.field.readOnly;
  }, isDisabled:function() {
    return this.field.disabled;
  }, setDisabled:function(_) {
    this.field.setDisabled(_);
    this.field.validate();
    this.fireEvent('change', this);
  }, isHidden:function() {
    return this.field.hidden;
  }, setHidden:function(_) {
    this.field.setVisible(!_);
    this.fireEvent('change', this);
  }, canAccept:function() {
    return this.field.destroyed || this.field.disabled || this.field.hidden || this.field.isValid();
  }, load:function(value) {
    if (value === undefined) {
      value = this.initialValue;
    }
    this.field.setValue(value);
  }, copyValue:function() {
    return this.field.getValue();
  }, submitValue:function() {
    return Ext.String.htmlEncode(this.field.getValue());
  }, addFields:function(into) {
    into.push(this.field);
  }});
  WIM.findLabelEl = function(field) {
    var result;
    var el = field.getEl();
    if (el) {
      var wrapDiv = el.hasCls('x-form-item') ? el : el.up('div.x-form-item');
      if (wrapDiv) {
        result = wrapDiv.child('label');
      }
    }
    return result;
  };
  WIM.TextField = Ext.extend(WIM.FieldComponent, {statics:{diffConfig:{iconClasses:{diffBase:'x-fa', diffModified:'x-fa fa-star', diffBoth:'x-fa fa-wrench', diffSD:' x-fa fa-exclamation-circle', diffProcess:'x-fa fa-gear'}, iconColor:'#ffaa00'}}, constructor:function(config) {
    this.singleLine = true;
    this.diff = config.diff;
    this.noProcessValue = config.noProcessValue;
    this.noSDValue = config.noSDValue;
    if (config.validator != null) {
      this.validator = config.validator;
    }
    this.allowBlank = !(config.allowBlank === false);
    var fieldConfig = Ext.apply({}, config.fieldConfig || {}, {fieldLabel:config.fieldLabel, width:config.width, readOnly:config.readOnly});
    fieldConfig.allowBlank = this.allowBlank || config.readOnly;
    if (config.disabled !== undefined) {
      fieldConfig.disabled = config.disabled;
    }
    if (config.hidden !== undefined) {
      fieldConfig.hidden = config.hidden;
    }
    if (config.minLength !== undefined) {
      fieldConfig.minLength = config.minLength;
    }
    if (config.maxLength !== undefined) {
      fieldConfig.maxLength = config.maxLength;
    }
    fieldConfig.value = '';
    if (config.regex != null) {
      fieldConfig.regex = config.regex;
      fieldConfig.regexText = config.regexText;
    } else if (!config.noRegex) {
      fieldConfig.regex = WIM.Latin1Regex;
      fieldConfig.regexText = WIM.Latin1RegexError;
    }
    if (config.emptyText != null) {
      fieldConfig.emptyText = config.emptyText;
    }
    var fieldClass = config.fieldClass || Ext.form.field.Text;
    config = Ext.apply({}, config, {field:new fieldClass(fieldConfig)});
    WIM.TextField.superclass.constructor.call(this, config);
    this.field.on('afterrender', function() {
      this.addLabel();
    }, this);
    this.field.on('change', function(c) {
      if (this.diff) {
        this.updateLabel();
      }
      this.fireEvent('change', this);
    }, this);
    if (config.processValue !== undefined) {
      this.loadProcess(config.processValue);
    }
  }, setReadOnly:function(_) {
    this.field.setReadOnly(_);
    this.field.allowBlank = _ || this.allowBlank;
    this.field.validate();
  }, setAllowBlank:function(_) {
    if (this.allowBlank != _) {
      this.allowBlank = _;
      this.field.allowBlank = _ || this.field.readOnly;
      this.field.validate();
    }
  }, setLabel:function(_) {
    this.field.setFieldLabel(_);
  }, load:function(v) {
    if (v !== undefined && v !== null) {
      this.hasTaskValue = true;
      this.field.setValue(v);
    }
    this.updateLabel();
  }, noBackend:function() {
    this.noSDValue = true;
    this.updateLabel();
  }, loadSD:function(v, zpChanged) {
    this.sdValue = v;
    if (this.noProcessValue && (!this.hasTaskValue || zpChanged)) {
      this.field.setValue(v);
    }
    this.updateLabel();
  }, loadProcess:function(v) {
    this.processValue = v;
    this.field.setValue(v);
    this.updateLabel();
  }, equalValues:function(a, b) {
    return a === b;
  }, valueToString:function(_) {
    return _;
  }, takeValue:function(_) {
    this.field.setValue(_);
    this.fireEvent('change', this);
  }, takeValueNoChange:function(_) {
    this.field.setValue(_);
  }, giveValue:function() {
    return this.field.getValue();
  }, updateLabel:function() {
    if (!this.diff) {
      return;
    }
    if (!this.field.rendered || !this.icon) {
      return;
    }
    var v = this.giveValue();
    var isSDValue = this.equalValues(this.sdValue, v);
    var hasSDValue = this.sdValue != 'undefined';
    var isProcessValue = this.equalValues(this.processValue, v);
    var isSDProcessValue = this.equalValues(this.sdValue, this.processValue);
    var needsCustom = false;
    var effectiveNoSDValue = this.noSDValue || this.sdValue === undefined || this.sdValue === null;
    var effectiveNoProcessValue = this.noProcessValue || this.ignoreEmptyProcessValue && Ext.isEmpty(this.processValue);
    if (effectiveNoProcessValue) {
      if (effectiveNoSDValue) {
        this.hasDifferences = false;
      } else {
        this.hasDifferences = !isSDValue;
      }
    } else if (effectiveNoSDValue) {
      this.hasDifferences = !isProcessValue;
    } else {
      this.hasDifferences = !isSDValue || !isProcessValue;
    }
    var iconClasses = WIM.TextField.diffConfig.iconClasses;
    this.icon.removeCls(iconClasses.diffSD);
    this.icon.removeCls(iconClasses.diffProcess);
    this.icon.removeCls(iconClasses.diffBoth);
    this.icon.removeCls(iconClasses.diffModified);
    if (this.hasDifferences) {
      if (!this.tooltip) {
        this.tooltip = new Ext.QuickTip({});
        this.tooltip.register({title:'', text:'In diesem Feld gibt es Wertdifferenzen, Doppelklick zur ' + (this.isReadOnly() ? 'Ansicht' : 'Wertdefinition') + '.', enabled:true, target:this.icon});
      }
      if (effectiveNoProcessValue || effectiveNoSDValue) {
        this.icon.addCls(iconClasses.diffModified);
        needsCustom = true;
      } else {
        if (!isSDValue && !isProcessValue) {
          this.icon.addCls(iconClasses.diffBoth);
          needsCustom = true;
        } else if (isSDValue) {
          this.icon.addCls(iconClasses.diffProcess);
        } else if (!isSDValue && hasSDValue) {
          this.icon.addCls(iconClasses.diffProcess);
        } else {
          this.icon.addCls(iconClasses.diffSD);
        }
      }
    } else {
      if (this.tooltip) {
        this.tooltip.unregister(this.icon);
        delete this.tooltip;
      }
    }
    var differences = [];
    if (!effectiveNoProcessValue) {
      differences.push({differencesRawValue:this.processValue, value:this.valueToString(this.processValue), source:'Prozess'});
    }
    if (!effectiveNoSDValue) {
      differences.push({differencesRawValue:this.sdValue, value:this.valueToString(this.sdValue), source:'Stammdaten'});
    }
    if (needsCustom) {
      differences.push({differencesRawValue:v, value:this.valueToString(v), source:'derzeitiger Wert'});
    }
    var items = [];
    Ext.each(differences, function(d) {
      var displayValue = Ext.String.htmlEncode(d.value || '').replace(/\n/g, '\x3cbr/\x3e');
      if (Ext.isEmpty(displayValue)) {
        displayValue = '[leer]';
      }
      var checked = this.equalValues(d.differencesRawValue, v);
      if (this.isReadOnly()) {
        items.push(new Ext.form.field.Display({value:(checked ? '\x3cb\x3e' : '') + (d.source + (this.singleLine ? ': ' + displayValue : ':')) + (checked ? '\x3c/b\x3e' : ''), checked:checked}));
        if (!this.singleLine) {
          items.push(new Ext.form.field.Display({value:(checked ? '\x3cb\x3e' : '') + displayValue + (checked ? '\x3c/b\x3e' : '')}));
        }
        items.push(new Ext.Container({height:10}));
      } else {
        items.push(new Ext.form.Radio({boxLabel:d.source + (this.singleLine ? ': ' + displayValue : ':'), name:'differences', checked:checked, differencesRawValue:d.differencesRawValue}));
        if (!this.singleLine) {
          items.push(new Ext.form.field.Display({value:displayValue}));
        }
      }
    }, this);
    this.group = items;
    this.groupCount = items.length;
  }, addLabel:function() {
    if (!this.diff) {
      return;
    }
    var self = this;
    var labelEl = WIM.findLabelEl(this.field);
    if (labelEl) {
      this.icon = labelEl.createChild({tag:'span', cls:WIM.TextField.diffConfig.diffBase, style:'color: ' + WIM.TextField.diffConfig.iconColor + '; font-size: 20px; display: inline-block; margin: 3px 0px 0px 0px; padding: 0px; height: 24px; width: 24px'});
      labelEl.on('dblclick', function(e) {
        if (!this.hasDifferences) {
          return;
        }
        var group = this.group;
        var v = this.giveValue();
        Ext.each(group, function(r) {
          if (r.name === 'differences' && this.equalValues(r.differencesRawValue, v)) {
            r.setValue(true);
          }
        }, this);
        var buttons = [];
        if (this.isReadOnly()) {
          buttons.push({text:'Schließen', handler:function() {
            this.ownerCt.ownerCt.ownerCt.hide();
          }});
        } else {
          buttons.push({text:'Übernehmen', handler:function() {
            if (this.ownerCt.ownerCt.getForm().isValid()) {
              Ext.each(group, function(r) {
                if (r.name === 'differences' && r.getValue()) {
                  self.takeValue(r.differencesRawValue);
                  self.updateLabel();
                  return false;
                }
                return true;
              }, this);
              this.ownerCt.ownerCt.ownerCt.hide();
            }
          }});
          buttons.push({text:'Abbrechen', handler:function() {
            this.ownerCt.ownerCt.ownerCt.hide();
          }});
        }
        var win = new Ext.Window({layout:'auto', width:500, modal:true, title:'Wertunterschiede', items:[new Ext.FormPanel({waitMsgTarget:true, scrollable:true, frame:true, bodyPadding:'10 10 0 10', labelWidth:90, defaults:{anchor:'95%', allowBlank:false, msgTarget:'side'}, items:this.group, buttons:buttons})]});
        win.show();
      }, this);
    }
    this.updateLabel();
  }});
  WIM.MultiSelect = Ext.extend(WIM.FieldComponent, {constructor:function(config) {
    this.noProcessValue = config.noProcessValue;
    this.noSDValue = config.noSDValue;
    if (config.validator != null) {
      this.validator = config.validator;
    }
    this.allowBlank = !(config.allowBlank === false);
    var fieldConfig = Ext.apply({}, config.fieldConfig || {}, {fieldLabel:config.fieldLabel, width:config.width, readOnly:config.readOnly});
    fieldConfig.allowBlank = this.allowBlank || config.readOnly;
    if (config.disabled !== undefined) {
      fieldConfig.disabled = config.disabled;
    }
    if (config.hidden !== undefined) {
      fieldConfig.hidden = config.hidden;
    }
    if (config.minLength !== undefined) {
      fieldConfig.minLength = config.minLength;
    }
    if (config.maxLength !== undefined) {
      fieldConfig.maxLength = config.maxLength;
    }
    if (config.maxheight !== undefined) {
      fieldConfig.maxheight = config.maxheight;
    }
    if (config.store !== undefined) {
      fieldConfig.store = config.store;
    }
    if (config.queryMode !== undefined) {
      fieldConfig.queryMode = config.queryMode;
    }
    if (config.shrinkWrap !== undefined) {
      fieldConfig.shrinkWrap = config.shrinkWrap;
    }
    if (config.displayField !== undefined) {
      fieldConfig.displayField = config.displayField;
    }
    if (config.valueField !== undefined) {
      fieldConfig.valueField = config.valueField;
    }
    fieldConfig.value = config.value;
    if (config.regex != null) {
      fieldConfig.regex = config.regex;
      fieldConfig.regexText = config.regexText;
    } else if (!config.noRegex) {
      fieldConfig.regex = WIM.Latin1Regex;
      fieldConfig.regexText = WIM.Latin1RegexError;
    }
    if (config.emptyText != null) {
      fieldConfig.emptyText = config.emptyText;
    }
    var fieldClass = config.fieldClass || Ext.form.field.Tag;
    config = Ext.apply({}, config, {field:new fieldClass(fieldConfig)});
    WIM.MultiSelect.superclass.constructor.call(this, config);
    this.field.on('change', function(c) {
      this.fireEvent('change', this);
    }, this);
    if (config.processValue !== undefined) {
      this.loadProcess(config.processValue);
    }
  }, setReadOnly:function(_) {
    this.field.setReadOnly(_);
    this.field.allowBlank = _ || this.allowBlank;
    this.field.validate();
  }, setAllowBlank:function(_) {
    if (this.allowBlank != _) {
      this.allowBlank = _;
      this.field.allowBlank = _ || this.field.readOnly;
      this.field.validate();
    }
  }, setLabel:function(_) {
    this.field.setFieldLabel(_);
  }, load:function(v) {
    if (v !== undefined && v !== null) {
      this.hasTaskValue = true;
      this.field.setValue(v);
    }
  }, noBackend:function() {
    this.noSDValue = true;
  }, loadSD:function(v, zpChanged) {
    this.sdValue = v;
    if (this.noProcessValue && (!this.hasTaskValue || zpChanged)) {
      this.field.setValue(v);
    }
  }, loadProcess:function(v) {
    this.processValue = v;
    this.field.setValue(v);
  }, equalValues:function(a, b) {
    return a === b;
  }, valueToString:function(_) {
    return _;
  }, takeValue:function(_) {
    this.field.setValue(_);
    this.fireEvent('change', this);
  }, giveValue:function() {
    return this.field.getValue();
  }});
  WIM.TextArea = Ext.extend(WIM.FieldComponent, {constructor:function(config) {
    this.diff = config.diff;
    this.noProcessValue = config.noProcessValue;
    this.noSDValue = config.noSDValue;
    var fieldConfig = {fieldLabel:config.fieldLabel, width:config.width || 400, height:config.height || 100, readOnly:config.readOnly};
    if (config.allowBlank === false && !config.readOnly) {
      fieldConfig.allowBlank = false;
    }
    fieldConfig.value = '';
    fieldConfig.regex = WIM.Latin1Regex;
    fieldConfig.regexText = WIM.Latin1RegexError;
    fieldConfig.maxLength = 2560;
    config = Ext.apply({}, config, {field:new Ext.form.field.TextArea(fieldConfig)});
    WIM.TextArea.superclass.constructor.call(this, config);
    this.field.on('afterrender', function() {
      this.addLabel();
    }, this);
    this.field.on('change', function(c) {
      if (this.diff) {
        this.updateLabel();
      }
      this.fireEvent('change', this);
    }, this);
    if (config.processValue !== undefined) {
      this.loadProcess(config.processValue);
    }
  }, load:WIM.TextField.prototype.load, loadSD:WIM.TextField.prototype.loadSD, loadProcess:WIM.TextField.prototype.loadProcess, addLabel:WIM.TextField.prototype.addLabel, updateLabel:WIM.TextField.prototype.updateLabel, equalValues:WIM.TextField.prototype.equalValues, valueToString:WIM.TextField.prototype.valueToString, takeValue:WIM.TextField.prototype.takeValue, giveValue:WIM.TextField.prototype.giveValue, noBackend:WIM.TextField.prototype.noBackend, setAllowBlank:WIM.TextField.prototype.setAllowBlank});
  WIM.EditableListForm = Ext.extend(mpm.packages.wim.FormPopup, {constructor:function(config) {
    this.maxLength = config.maxLength;
    this.name = config.columnName;
    this.fieldName = config.fieldName || 'VALUE';
    WIM.EditableListForm.superclass.constructor.call(this, config);
  }, saveRecord:function(record) {
    this.record.set(this.fieldName, this.element.getValue());
  }, makeWindow:function(title) {
    this.element = new Ext.form.field.Text({fieldLabel:this.name, allowBlank:false, maxLength:this.maxLength, regex:WIM.Latin1Regex, regexText:WIM.Latin1RegexError});
    this.createCommitCancelButtons();
    this.form = new Ext.form.Panel({flex:1, bodyPadding:'10', items:[this.element]});
    this.form.on('validitychange', function(form, valid) {
      this.commitButton.setDisabled(!valid);
    }, this);
    this.createFormWindow(this.mode == 'create' ? 'Hinzufügen' : 'Bearbeiten', 400, 170);
  }, edit:function(store, record) {
    this.store = store;
    this.record = record;
    this.mode = 'edit';
    this.makeWindow('Bearbeiten');
    this.element.setValue(this.record.data[this.fieldName]);
    this.window.show();
  }, create:function(store, record) {
    this.store = store;
    this.record = record;
    this.mode = 'create';
    this.makeWindow('Erzeugen');
    this.window.show();
  }});
  WIM.EditableList = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.diff = config.diff;
    this.noSDValue = config.noSDValue;
    this.noProcessValue = config.noProcessValue;
    this.columnName = config.columnName;
    this.fieldName = config.fieldName || 'VALUE';
    this.readOnly = config.readOnly;
    this.maxLength = config.maxLength || 70;
    this.form = new WIM.EditableListForm({columnName:this.columnName, fieldName:this.fieldName, maxLength:this.maxLength});
    this.form.on('commit', function() {
      this.updateLabel();
      this.fireEvent('change', this);
    }, this);
    this.createButton = new Ext.Button({text:'Hinzufügen', handler:function() {
      var data = {};
      data[this.fieldName] = '';
      var r = new this.grid.store.model(data);
      this.form.create(this.store, r);
    }, scope:this});
    this.editButton = new Ext.Button({text:'Bearbeiten', disabled:true, handler:function() {
      this.form.edit(this.grid.store, this.grid.getSelectionModel().getSelection()[0]);
    }, scope:this});
    this.removeButton = new Ext.Button({text:'Entfernen', disabled:true, handler:function() {
      this.grid.store.remove(this.grid.getSelectionModel().getSelection()[0]);
      this.updateLabel();
      this.fireEvent('change', this);
    }, scope:this});
    this.store = new Ext.data.Store({fields:[this.fieldName]});
    this.forceRow = !!config.forceRow;
    var b = [];
    b.push(this.createButton);
    b.push(this.editButton);
    b.push(this.removeButton);
    Ext.each(b, function(s) {
      s.columnWidth = 1 / b.length;
    });
    var buttons = this.readOnly ? undefined : new Ext.Toolbar({height:30, items:b});
    this.grid = new Ext.grid.GridPanel({border:true, tbar:buttons, hideHeaders:!this.readOnly, store:this.store, width:config.width || 400, height:config.height || 120, viewConfig:{emptyText:WIM.noRowsText(!this.readOnly && this.forceRow), deferEmptyText:false}, reserveScrollOffset:false, selModel:{type:'rowmodel', mode:'SINGLE'}, autoExpandColumn:this.fieldName, columns:[{flex:1, resizable:false, itemId:this.fieldName, renderer:WIM.renderer(), text:this.columnName || config.fieldLabel, dataIndex:this.fieldName}]});
    if (!this.readOnly) {
      this.grid.on('rowdblclick', function(view, record) {
        this.form.edit(this.grid.store, record);
      }, this);
    }
    this.grid.getSelectionModel().on('selectionchange', function(view, nodes) {
      if (this.grid.getSelectionModel().getCount() === 0) {
        this.editButton.disable();
        this.removeButton.disable();
        this.fireEvent('clear', this);
      } else {
        this.editButton.enable();
        this.removeButton.enable();
        this.fireEvent('select', this);
      }
    }, this);
    this.root = Ext.create('Ext.form.FieldContainer', {fieldLabel:config.fieldLabel, items:[this.grid]});
    this.field = this.root;
    this.field.on('afterrender', function() {
      this.addLabel();
      this.updateLabel();
    }, this);
    if (config.processValue) {
      this.loadProcess(config.processValue);
    }
  }, isReadOnly:function() {
    return this.readOnly;
  }, addFields:function(into) {
    into.push(this.root);
  }, submitType:function() {
    return 'array';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    this.grid.store.each(function(a) {
      x.atom('v', a.data[this.fieldName]);
    }, this);
    return x.result();
  }, load:function(v) {
    if (v !== undefined && v !== null) {
      this.hasTaskValue = true;
      this.takeValue(v);
      this.updateLabel();
    }
  }, loadSD:function(v, zpChanged) {
    this.sdValue = v;
    if ((!this.hasTaskValue || zpChanged) && (!this.diff || this.noProcessValue)) {
      this.takeValue(v);
    }
    this.updateLabel();
  }, loadProcess:function(v) {
    this.processValue = v;
    this.takeValue(v);
    this.updateLabel();
  }, noBackend:WIM.TextField.prototype.noBackend, addLabel:WIM.TextField.prototype.addLabel, updateLabel:WIM.TextField.prototype.updateLabel, canAccept:function() {
    return this.readOnly || !this.forceRow || this.store.getCount() > 0;
  }, setForceRow:function(_) {
    if (this.forceRow != _) {
      this.forceRow = _;
      WIM.updateGridNoRowsText(this.grid, !this.readOnly && this.forceRow);
    }
  }, equalValues:function(a, b) {
    if (Ext.isEmpty(a)) {
      return Ext.isEmpty(b);
    }
    if (Ext.isEmpty(b)) {
      return false;
    }
    return WIM.StringSet.fromArray(a).equals(WIM.StringSet.fromArray(b));
  }, valueToString:function(vv) {
    var result = '';
    if (Ext.isArray(vv)) {
      Ext.each(vv, function(v, index) {
        if (index !== 0) {
          result += '\n';
        }
        result += v;
      }, this);
    }
    return result;
  }, takeValue:function(vv) {
    if (Ext.isArray(vv)) {
      this.grid.store.removeAll();
      Ext.each(vv, function(v) {
        var data = {};
        data[this.fieldName] = v;
        this.grid.store.add(new this.grid.store.model(data));
      }, this);
    }
  }, giveValue:function() {
    var result = [];
    this.grid.store.each(function(r) {
      result.push(r.data[this.fieldName]);
    }, this);
    return result;
  }});
  WIM.Checkbox = Ext.extend(WIM.FieldComponent, {constructor:function(config) {
    config = Ext.apply({}, config);
    WIM.Checkbox.superclass.constructor.call(this, Ext.apply({}, config, {field:new Ext.form.Checkbox(config)}));
    this.field.on('change', this.fieldChanged, this);
  }, isChecked:function() {
    return this.field.getValue();
  }, fieldChanged:function() {
    this.fireEvent('change', this);
  }});
  WIM.BasicChoice = Ext.extend(WIM.FieldComponent, {constructor:function(config) {
    config = Ext.apply({}, config);
    if (!config.field) {
      config = Ext.apply({}, config);
      config.field = new Ext.form.ComboBox(Ext.apply({}, config, {width:400, allowBlank:false, triggerAction:'all', mode:'remote', forceSelection:true, valueField:'ID', displayField:'NAME', matchFieldWidth:false, store:new Ext.data.Store({model:'WIM.SimpleModel', proxy:{type:'ajax', url:config.url, actionMethods:{read:'POST'}, reader:{type:'json', rootProperty:'data', messageProperty:'message'}, extraParams:{command:config.command}}})}));
    }
    this.callParent([config]);
    this.field.setDisplayedValue = function(_) {
      this.lastSelectionText = _;
      var v = this.value;
      Ext.form.Field.prototype.setValue.call(this, _);
      this.value = v;
      if (!this.rendered) {
        this.on('afterrender', function() {
          if (this.value === v) {
            this.lastSelectionText = _;
            Ext.form.Field.prototype.setValue.call(this, _);
            this.value = v;
          }
        }, this);
      }
    };
    this.field.on('select', this.fieldChanged, this);
    this.field.on('click', this.fieldChanged, this);
    this.field.on('change', this.fieldChanged, this);
    this.field.on('paste', this.fieldChanged, this);
    this.field.on('paste blur keyup', this.fieldChanged, this);
  }, setCommand:function(_) {
    this.field.store.getProxy().getExtraParams().command = _;
  }, load:function(_) {
    if (_ === undefined) {
      _ = this.initialValue;
    }
    WIM.BasicChoice.superclass.load.call(this, _);
  }, submitValue:function() {
    return Ext.String.htmlEncode(Ext.valueFrom(this.field.getValue(), ''));
  }, fieldChanged:function() {
    this.fireEvent('change', this);
  }});
  WIM.ZaehlpunktComponent = Ext.extend(WIM.BasicChoice, {constructor:function(config) {
    this.task = config.task;
    this.loadErrorSuppressed = config.loadErrorSuppressed;
    this.zaehlpunktMode = config.zaehlpunktMode || 'defaultMode';
    config = Ext.apply({}, config);
    config.url = (config.wimContext || this.task.wimContext).serverURL();
    config.forceSelection = this.zaehlpunktMode == 'defaultMode';
    config.width = 500;
    config.zplength = this.zaehlpunktMode == 'malo' ? 11 : 33;
    config.minLengthText = 'Die Zählpunktbezeichnung muss genau ' + config.zplength + ' Stellen lang sein';
    var commandKey = this.zaehlpunktMode == 'malo' ? 'meldepunkt' : 'zaehlpunkt';
    config.command = '\x3cread\x3e\x3c' + commandKey + 'e/\x3e\x3cmandant\x3e\x3cown_mpid\x3e' + config.process.own_mpid + '\x3c/own_mpid\x3e\x3cown_mpidcode\x3e' + config.process.own_mpidcode + '\x3c/own_mpidcode\x3e\x3c/mandant\x3e\x3c/read\x3e';
    config.paging = true;
    config.pageSize = 20;
    config.triggerAction = 'query';
    config.minChars = 0;
    WIM.ZaehlpunktComponent.superclass.constructor.call(this, config);
    this.data = {};
    this.lastValue = '';
    var f = this.field;
    this.processRequest = new WIM.ProcessRequest({url:config.url, process:config.process, scope:this, lastLoadedValue:undefined, makeCommand:function() {
      return '\x3c' + commandKey + '\x3e\x3cname\x3e' + Ext.String.htmlEncode(f.getValue()) + '\x3c/name\x3e\x3cdata/\x3e\x3cmandant\x3e\x3cown_mpid\x3e' + f.initialConfig.process.own_mpid + '\x3c/own_mpid\x3e\x3cown_mpidcode\x3e' + f.initialConfig.process.own_mpidcode + '\x3c/own_mpidcode\x3e\x3c/mandant\x3e\x3c/' + commandKey + '\x3e';
    }, requestSuccess:function(result) {
      this.data = result.data;
      var expect1, expect2;
      switch(this.zaehlpunktMode) {
        case 'defaultMode':
          expect1 = 'meldepunkt';
          expect2 = 'zaehlpunkt';
          break;
        case 'malo':
          expect1 = 'meldepunkt';
          break;
        default:
          expect1 = 'zaehlpunkt';
          break;
      }
      if (this.data[expect1] === undefined && this.data[expect2] === undefined) {
        if (!this.loadErrorSuppressed) {
          Ext.Msg.alert('Fehler', 'Fehler beim Abrufen der Meldepunktdaten.');
        }
        this.fireEvent('load', changed);
      } else {
        var changed;
        if (this.data[expect1] != undefined) {
          changed = this.lastLoadedValue != this.data[expect1] && this.lastLoadedValue != undefined;
          this.lastLoadedValue = this.data[expect1];
        } else {
          changed = this.lastLoadedValue != this.data[expect2] && this.lastLoadedValue != undefined;
          this.lastLoadedValue = this.data[expect2];
        }
        this.fireEvent('load', changed);
      }
    }, requestFailure:function() {
      WIM.handleFailure.apply(WIM, arguments);
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
      this.data = {};
      this.fireEvent('load');
    }});
    if (this.zaehlpunktMode != 'noload') {
      this.field.on('change', this.startRequest, this);
    }
  }, showSuppressedError:function(zaehlpunktInitial) {
    if (this.data.zaehlpunkt === undefined) {
      if (!Ext.isEmpty(zaehlpunktInitial)) {
        Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
      }
    }
  }, startRequest:function() {
    var v = this.field.getValue();
    if (v !== this.lastValue) {
      this.lastValue = v;
      if (!Ext.isEmpty(v)) {
        this.processRequest.start(this.maskComponent());
      }
    }
  }, maskComponent:function() {
    return this.task ? this.task.root : this.field;
  }, load:function(v) {
    this.callParent(arguments);
    if (!Ext.isEmpty(v) && this.zaehlpunktMode != 'noload') {
      this.processRequest.start(this.maskComponent());
    }
  }, setAllowBlank:function(_) {
    this.field.allowBlank = _;
    this.field.validate();
  }, noBackend:function() {
    this.fireEvent('noBackend');
  }});
  WIM.MarktpartnerDisplayField = Ext.extend(WIM.Component, {constructor:function(config) {
    this.callParent(arguments);
    this.name = config.name;
    this.role = config.role;
    this.field = new Ext.form.field.Text({readOnly:true, width:400});
    this.grundzustaendigkeit = !!config.grundzustaendigkeit;
    this.gzField = new Ext.form.field.Display({htmlEncode:true});
    this.outerField = new Ext.form.FieldContainer({layout:{type:'hbox'}, fieldLabel:config.fieldLabel, items:[this.field, new Ext.Container({width:5}), this.gzField]});
    if (!config.noSDValue && config.sdZaehlpunkt && this.role) {
      config.sdZaehlpunkt.on('load', function(zpChanged) {
        this.loadSD(config.sdZaehlpunkt.data[this.role], zpChanged);
      }, this);
      config.sdZaehlpunkt.on('noBackend', this.noBackend, this);
    }
  }, noBackend:function() {
  }, hide:function() {
    this.outerField.hide();
  }, setLabel:function(_) {
    this.outerField.setFieldLabel(_);
  }, addFields:function(into) {
    into.push(this.outerField);
  }, hasSubmitValue:WIM.falseFunction, setAllowBlank:function(_) {
  }, loadProcess:function(_) {
    var n = this.name.toUpperCase();
    var v = {mpid:Ext.valueFrom(_[n + '_MPID'], ''), mpidcode:Ext.valueFrom(_[n + '_MPIDCODE'], ''), partnerid:Ext.valueFrom(_[n + '_PARTNERID'], ''), partnername:Ext.valueFrom(_[n + '_PARTNERNAME'], ''), gz:Ext.valueFrom(_[n + '_GZ'], '')};
    this.setFieldValues(v);
  }, loadSD:function(_, zpChanged) {
    this.setFieldValues(_);
  }, setFieldValues:function(_) {
    if (!_) {
      _ = {};
    }
    this.field.setValue(WIM.marktpartnerText(_, ''));
    if (this.grundzustaendigkeit) {
      var gz = _.gz == 'JA' ? 'grundzuständig' : _.gz == 'NEIN' ? 'nicht grundzuständig' : Ext.valueFrom(_.gz, '');
      this.gzField.setValue(gz);
    }
  }});
  WIM.MarktpartnerComponent = Ext.extend(WIM.BasicChoice, {constructor:function(config) {
    var rollen = '';
    if (config.NB) {
      rollen += '\x3citem\x3eNB\x3c/item\x3e';
    }
    if (config.MSBGZ) {
      rollen += '\x3citem\x3eMSBGZ\x3c/item\x3e';
    }
    if (config.MSB) {
      rollen += '\x3citem\x3eMSB\x3c/item\x3e\x3citem\x3eMSBGZ\x3c/item\x3e';
    }
    if (config.MSBNoGZ) {
      rollen += '\x3citem\x3eMSB\x3c/item\x3e';
    }
    if (config.LF) {
      rollen += '\x3citem\x3eLF\x3c/item\x3e';
    }
    if (rollen !== '') {
      rollen = '\x3crollen\x3e' + rollen + '\x3c/rollen\x3e';
    }
    var command;
    if (config.selbst) {
      command = '\x3cread\x3e\x3cAbsender\x3e' + rollen + '\x3cnoConnections\x3etrue\x3c/noConnections\x3e\x3c/Absender\x3e\x3c/read\x3e';
    } else {
      command = '\x3cread\x3e\x3cMarktpartner\x3e' + rollen + '\x3cnoConnections\x3etrue\x3c/noConnections\x3e\x3c/Marktpartner\x3e\x3c/read\x3e';
    }
    this.allowBlank = !!config.allowBlank;
    this.role = config.role;
    this.singleLine = true;
    this.diff = config.diff;
    this.noSDValue = config.noSDValue;
    this.ignoreEmptyProcessValue = config.ignoreEmptyProcessValue;
    this.noProcessValue = config.noProcessValue;
    this.submitGrundzustaendigkeit = config.submitGrundzustaendigkeit;
    var storeConfig = {proxy:{type:'ajax', actionMethods:{read:'POST'}, url:config.url, extraParams:{command:command}, reader:{type:'json', rootProperty:'data', messageProperty:'message'}}, model:Ext.define(null, {extend:'Ext.data.Model', fields:['id', 'partnerid', 'partnername', 'mpid', 'mpidcode', 'gz', {name:'displayname', convert:function(v, r) {
      return WIM.marktpartnerText(r.data);
    }}]})};
    this.store = new Ext.data.Store(storeConfig);
    var emptyTextValue = Ext.valueFrom(config.emptyText, '');
    config.field = new Ext.form.ComboBox({width:config.width || 570, fieldLabel:config.fieldLabel, allowBlank:this.allowBlank, triggerAction:'query', mode:'remote', minChars:0, readOnly:config.readOnly, paging:true, pageSize:20, forceSelection:true, valueField:'id', displayField:'displayname', emptyText:emptyTextValue, store:this.store, hidden:!!config.hidden});
    if (config.canCheck) {
      this.checkbox = new Ext.form.Checkbox({scope:this, checked:true, handler:function() {
        config.canCheck(this);
      }});
      this.isChecked = function() {
        return this.checkbox.getValue();
      };
      this.outerField = new Ext.form.FieldContainer({padding:'0', layout:{type:'hbox'}, items:[this.checkbox, new Ext.Container({width:10}), config.field]});
    } else if (config.canDelete) {
      var b = new Ext.Button({text:'Entfernen', scope:this, handler:function() {
        this.outerField.ownerCt.remove(this.outerField);
        config.canDelete(this);
      }});
      this.outerField = new Ext.Container({layout:{type:'hbox'}, items:[config.field, new Ext.Container({width:5}), b]});
    } else if (config.grundzustaendigkeit) {
      this.gzCheckbox = new Ext.form.Checkbox({scope:this, readOnly:config.readOnly, disabled:config.readOnly, boxLabel:'grundzuständig', handler:this.gzCheckboxChanged});
      this.outerField = new Ext.form.FieldContainer({layout:{type:'hbox'}, fieldLabel:config.fieldLabel, items:[config.field, new Ext.Container({width:5}), this.gzCheckbox]});
    }
    if (config.sdZaehlpunkt && this.role) {
      config.sdZaehlpunkt.on('load', function(zpChanged) {
        this.loadSD(config.sdZaehlpunkt.data[this.role], zpChanged);
      }, this);
      config.sdZaehlpunkt.on('noBackend', this.noBackend, this);
    }
    WIM.MarktpartnerComponent.superclass.constructor.call(this, config);
    this.field.on('afterrender', function() {
      this.field.validate();
      this.addLabel();
    }, this);
  }, hide:function() {
    (this.outerField ? this.outerField : this.field).hide();
  }, setLabel:function(_) {
    (this.outerField ? this.outerField : this.field).setFieldLabel(_);
  }, isReadOnly:function() {
    return this.field.readOnly;
  }, setAllowBlank:function(_) {
    if (this.allowBlank !== _) {
      this.allowBlank = _;
      this.field.allowBlank = _;
      this.field.validate();
    }
  }, canAccept:function() {
    return this.field.disabled || this.field.hidden || this.allowBlank || this.value && !Ext.isEmpty(this.value.mpid);
  }, maskComponent:function() {
    return this.task ? this.task.root : this.field;
  }, noBackend:function() {
    this.noSDValue = true;
    this.updateLabel();
  }, addLabel:WIM.TextField.prototype.addLabel, updateLabel:WIM.TextField.prototype.updateLabel, equalValues:function(a, b) {
    var aempty = !a || Ext.isEmpty(a.id);
    var bempty = !b || Ext.isEmpty(b.id);
    if (aempty) {
      return bempty;
    }
    if (bempty) {
      return false;
    }
    return a.id === b.id && (!this.gzCheckbox || a.gz === b.gz);
  }, valueToString:function(_) {
    var result = WIM.marktpartnerText(_);
    if (result !== '' && _ && this.gzCheckbox) {
      result += ' ' + (_.gz == 'JA' ? 'grundzuständig' : 'nicht grundzuständig');
    }
    return result;
  }, valueToDisplayValue:function(_) {
    return WIM.marktpartnerText(_);
  }, takeGZ:function(_) {
    if (this.gzCheckbox) {
      this.gzCheckbox.setValue(_ && _.gz == 'JA');
    }
  }, isGZ:function() {
    return this.value && this.value.gz == 'JA';
  }, takeValue:function(_) {
    this.value = _;
    if (this.value) {
      if (Ext.isEmpty(this.value.id)) {
        this.field.setValue(undefined);
        this.takeGZ(undefined);
      } else {
        var r = this.field.store.getById(this.value.id);
        if (r) {
          this.field.setValue(this.value.id);
        } else {
          this.field.setValue(this.value.id);
          this.field.setDisplayedValue(this.valueToDisplayValue(this.value));
        }
        this.takeGZ(this.value);
      }
    } else {
      this.field.setValue(undefined);
      this.takeGZ(undefined);
    }
    this.updateLabel();
    this.fireEvent('change', this);
  }, giveValue:function(_) {
    return this.value;
  }, loadStoreException:function() {
    Ext.Msg.alert('Fehler', 'Fehler beim Abruf vom Server.');
  }, gzCheckboxChanged:function() {
    if (this.value) {
      this.value = Ext.apply({}, this.value);
      this.value.gz = this.gzCheckbox.getValue() ? 'JA' : 'NEIN';
      this.updateLabel();
      this.fireEvent('change', this);
    }
  }, fieldChanged:function() {
    var v = this.field.getValue();
    if (Ext.isEmpty(v)) {
      this.value = {id:'', partnerid:'', partnername:'', mpid:'', mpidcode:'', gz:''};
    } else {
      var r = this.store.getById(v);
      if (r) {
        this.value = {id:v, partnerid:r.data.partnerid, partnername:r.data.partnername, mpid:r.data.mpid, mpidcode:r.data.mpidcode, gz:r.data.gz};
      }
    }
    this.takeGZ(this.value);
    this.updateLabel();
    this.fireEvent('change', this);
    this.callParent(arguments);
  }, isMulti:WIM.trueFunction, loadSD:function(v, zpChanged) {
    if (v !== undefined && v !== null && !Ext.isEmpty(v.mpid)) {
      v = Ext.apply({}, v);
      if (Ext.isEmpty(v.id)) {
        v.id = v.partnerid + '_' + v.mpid + '_' + v.mpidcode;
      }
      this.sdValue = v;
    } else {
      this.sdValue = {id:'', partnerid:'', partnername:'', mpid:'', mpidcode:'', gz:''};
    }
    if (zpChanged || this.value === undefined || !this.value.id) {
      this.takeValue(this.sdValue);
    }
    this.updateLabel();
  }, loadProcess:function(v) {
    if (!Ext.isEmpty(v[(this.name + '_mpid').toUpperCase()])) {
      var value = {partnerid:Ext.valueFrom(v[(this.name + '_partnerid').toUpperCase()], ''), partnername:Ext.valueFrom(v[(this.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(v[(this.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(v[(this.name + '_mpidcode').toUpperCase()], ''), gz:Ext.valueFrom(v[(this.name + '_gz').toUpperCase()], '')};
      value.id = value.partnerid + '_' + value.mpid + '_' + value.mpidcode;
      this.processValue = value;
    } else {
      this.processValue = undefined;
    }
    this.takeValue(this.processValue);
    this.updateLabel();
  }, load:function(v) {
    var value = undefined;
    if (v[this.name + 'id'] !== undefined) {
      value = {id:Ext.valueFrom(v[this.name + 'id'], ''), partnerid:Ext.valueFrom(v[this.name + '_partnerid'], ''), partnername:Ext.valueFrom(v[this.name + '_partnername'], ''), mpid:Ext.valueFrom(v[this.name + '_mpid'], ''), mpidcode:Ext.valueFrom(v[this.name + '_mpidcode'], ''), gz:Ext.valueFrom(v[this.name + '_gz'], '')};
    }
    if (this.checkbox) {
      this.checkbox.setValue(v.checked === 'true');
    }
    if (value !== undefined) {
      if (!Ext.isEmpty(value.id) || !this.value) {
        this.takeValue(value);
      }
    }
    this.updateLabel();
  }, submitValue:function() {
    var v = this.value;
    if (!v) {
      v = {id:'', partnername:'', partnerid:'', mpid:'', mpidcode:'', gz:''};
    }
    var x = new WIM.XMLOutput();
    x.atom(this.name + 'id', v.id);
    x.atom(this.name + '_partnerid', v.partnerid);
    x.atom(this.name + '_partnername', v.partnername);
    x.atom(this.name + '_mpid', v.mpid);
    x.atom(this.name + '_mpidcode', v.mpidcode);
    if (this.gzCheckbox || this.submitGrundzustaendigkeit) {
      x.atom(this.name + '_gz', v.gz);
    }
    return x.result();
  }, addFields:function(into) {
    into.push(this.outerField ? this.outerField : this.field);
  }});
  WIM.QualifierChoice = Ext.extend(WIM.BasicChoice, {constructor:function(config) {
    this.allowBlank = !!config.allowBlank;
    this.readOnly = !!config.readOnly;
    this.singleLine = true;
    this.diff = config.diff;
    this.loaded = false;
    this.noSDValue = config.noSDValue;
    this.noProcessValue = config.noProcessValue;
    this.ignoreEmptyProcessValue = config.ignoreEmptyProcessValue;
    this.store = new Ext.data.Store({model:'WIM.QualifierModel', data:config.values || []});
    config.field = new Ext.form.ComboBox({width:config.overrideWidth ? config.overrideWidth : 400 - (config.canCheck ? 70 : 0), fieldLabel:config.fieldLabel, allowBlank:this.allowBlank || this.readOnly, readOnly:this.readOnly, triggerAction:'all', queryMode:'local', minChars:0, forceSelection:true, valueField:'key', displayField:config.qualifierOptions && config.qualifierOptions.noKey ? 'keytextnokey' : 'keytext', matchFieldWidth:false, store:this.store});
    WIM.QualifierChoice.superclass.constructor.call(this, config);
    this.field.on('afterrender', function() {
      this.field.validate();
      this.addLabel();
    }, this);
    if (config.processValue !== undefined) {
      this.loadProcess(config.processValue);
    }
  }, setDisabled:function(_) {
    this.field.allowBlank = _ || this.allowBlank;
    this.field.setDisabled(_);
    this.field.validate();
  }, setReadOnly:function(_) {
    this.field.setReadOnly(_);
    this.field.allowBlank = _ || this.allowBlank;
    this.field.validate();
  }, setAllowBlank:function(_) {
    if (this.allowBlank !== _) {
      this.allowBlank = _;
      this.field.allowBlank = _ || this.field.readOnly;
      this.field.validate();
    }
  }, canAccept:function() {
    return this.field.disabled || this.field.hidden || this.allowBlank || this.readOnly || !Ext.isEmpty(this.value);
  }, noBackend:function() {
    this.noSDValue = true;
    this.updateLabel();
  }, addLabel:WIM.TextField.prototype.addLabel, updateLabel:WIM.TextField.prototype.updateLabel, equalValues:WIM.TextField.prototype.equalValues, valueToString:function(_) {
    var r = this.field.store.getById(_);
    return r ? r.data.keytext : _;
  }, takeValue:function(_) {
    if (Ext.isEmpty(_)) {
      _ = '';
    }
    this.value = _;
    this.field.setValue(this.value);
    this.updateLabel();
    this.fireEvent('change', this);
  }, takeValueNoChange:function(_) {
    if (Ext.isEmpty(_)) {
      _ = '';
    }
    this.value = _;
    this.field.setValue(this.value);
    this.updateLabel();
  }, giveValue:function(_) {
    return this.value;
  }, fieldChanged:function() {
    this.value = this.field.getValue();
    this.updateLabel();
    this.fireEvent('change', this);
    this.callParent(arguments);
  }, load:function(v) {
    if (v !== undefined) {
      this.hasTaskValue = true;
      this.takeValue(v);
    }
    this.updateLabel();
  }, loadNoChange:function(v) {
    if (v !== undefined) {
      this.hasTaskValue = true;
      this.takeValueNoChange(v);
    }
    this.updateLabel();
  }, noBackend:function() {
    this.noSDValue = true;
    this.updateLabel();
  }, loadSD:function(v, zpChanged) {
    this.sdValue = v;
    if (this.noProcessValue && (!this.hasTaskValue || zpChanged)) {
      this.takeValue(v);
    }
    this.updateLabel();
  }, loadProcess:function(v) {
    this.processValue = v;
    this.takeValue(v);
    this.updateLabel();
  }, submitValue:function() {
    if (this.value === undefined || this.value === null) {
      return '';
    }
    return Ext.String.htmlEncode(this.value);
  }});
  WIM.AnsprechpartnerChoice = Ext.extend(WIM.BasicChoice, {constructor:function(config) {
    config = Ext.apply({}, config, {triggerAction:'query', matchFieldWidth:true, minChars:0, paging:true, pageSize:15, fields:['ID', 'NAME', 'MAIL']});
    WIM.AnsprechpartnerChoice.superclass.constructor.call(this, config);
    this.sender = config.sender;
    if (this.sender) {
      this.sender.on('change', this.senderChanged, this);
    }
    this.senderChanged();
    this.internalValue = {};
    this.field.on('select', this.updateInternalValue, this);
    this.field.on('change', this.updateInternalValue, this);
  }, loadSender:function(root) {
    var s = new WIM.XMLOutput();
    s.begin('read', 'tuple');
    s.begin('Ansprechpartner', 'tuple');
    s.atom('own_mpid', root.data.LOG.OWN_MPID);
    s.atom('own_mpidcode', root.data.LOG.OWN_MPIDCODE);
    s.end('Ansprechpartner');
    s.end('read');
    this.setCommand(s.result());
  }, senderChanged:function() {
    var s = new WIM.XMLOutput();
    s.begin('read', 'tuple');
    s.begin('Ansprechpartner', 'tuple');
    if (this.sender) {
      var v = this.sender.giveValue();
      delete this.sender.field.lastQuery;
      this.field.setValue('');
      s.atom('own_mpid', v ? v.mpid : '');
      s.atom('own_mpidcode', v ? v.mpidcode : '');
    }
    s.end('Ansprechpartner');
    s.end('read');
    this.setCommand(s.result());
  }, updateInternalValue:function() {
    if (Ext.isEmpty(this.field.getValue())) {
      this.setInternalValue({id:''});
    } else {
      var r = this.field.store.getById(this.field.getValue());
      if (r) {
        this.setInternalValue({id:this.field.getValue(), NAME:r.data.NAME, MAIL:r.data.MAIL});
      } else {
        this.setInternalValue({id:''});
      }
    }
  }, setInternalValue:function(_) {
    this.internalValue = _;
  }, canReject:WIM.FieldComponent.prototype.canAccept, loadProcess:function(root) {
    var a = root.data.LOG.ANSPRECHPARTNERINTERN;
    if (a) {
      this.setInternalValue({id:'$none', NAME:a.name, MAIL:a.mail, TELEFON:a.telefon, TELEFON2:a.telefon2, HANDY:a.handy, TELEFAX:a.telefax});
      this.field.setRawValue(a.name);
    }
  }, load:function(root) {
    if (root[this.name] !== undefined && root[this.name].length > 1) {
      this.setInternalValue({id:root[this.name + 'id'], NAME:root[this.name][0], MAIL:root[this.name][1][1]});
      if (root[this.name + 'id'] !== 'none' && this.field.getStore().getCount() > 0) {
        this.field.setValue(root[this.name + 'id']);
      }
      this.field.setRawValue(this.internalValue.NAME);
    } else {
      if (!this.internalValue || this.internalValue.id !== '$none') {
        this.setInternalValue({id:''});
      }
    }
  }, isMulti:function() {
    return true;
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    if (Ext.isEmpty(this.internalValue.id) || Ext.isEmpty(this.internalValue.NAME)) {
      x.atom(this.name, '');
    } else {
      x.atom(this.name + 'id', this.internalValue.id);
      var type = 'array';
      x.begin(this.name, type);
      x.begin('div', 'atom');
      x.text(this.internalValue.NAME);
      x.end('div');
      var address = function(name, key) {
        if (!Ext.isEmpty(this.internalValue[key])) {
          x.begin('div', type);
          x.begin('span', 'atom');
          x.text(name + ': ');
          x.end('span');
          x.begin('span', 'atom');
          x.text(this.internalValue[key]);
          x.end('span');
          x.end('div');
        }
      };
      address.call(this, 'Mail', 'MAIL');
      address.call(this, 'Telefon', 'TELEFON');
      address.call(this, 'Telefon 2', 'TELEFON2');
      address.call(this, 'Handy', 'HANDY');
      address.call(this, 'Telefax', 'TELEFAX');
      x.end(this.name);
    }
    return x.result();
  }});
  WIM.DateComponent = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.ignoreEmptyValue = config.ignoreEmptyValue;
    this.field = new Ext.form.DateField({value:'', fieldLabel:config.fieldLabel, allowBlank:config.allowBlank, disabled:config.disabled, afterSubTpl:Ext.isEmpty(config.hint) ? '' : '\x3cdiv style\x3d"white-space: nowrap;"\x3e' + Ext.String.htmlEncode(config.hint) + '\x3c/div\x3e'});
    if (config.minDate) {
      this.field.setMinValue(config.minDate);
    }
    if (config.maxDate) {
      this.field.setMaxValue(config.maxDate);
    }
    this.field.on('change', function() {
      this.fireEvent('change', this);
    }, this);
    this.field.on('select', function() {
      this.fireEvent('change', this);
    }, this);
  }, setLabel:function(_) {
    this.field.setFieldLabel(_);
  }, isDisabled:function() {
    return this.field.disabled;
  }, setDisabled:function(_) {
    this.field.setDisabled(_);
  }, isHidden:function() {
    return this.field.hidden;
  }, setHidden:function(_) {
    this.field.setVisible(!_);
    this.fireEvent('change', this);
  }, canAccept:function() {
    return this.field.disabled || this.field.isValid();
  }, load:function(_) {
    if (Ext.isEmpty(_)) {
      if (!this.ignoreEmptyValue) {
        this.field.setValue(null);
      }
    } else {
      var v = Ext.Date.parse(_, 'c');
      if (!v) {
        v = Ext.Date.parse(_, 'Y-m-d');
      }
      if (v) {
        v = Ext.Date.clearTime(v);
      }
      this.field.setValue(v);
    }
  }, submitValue:function() {
    var v = this.field.getValue();
    return Ext.isEmpty(v) ? '' : Ext.Date.format(v, 'Y-m-d');
  }, addFields:function(into) {
    into.push(this.field);
  }, setAllowBlank:function(_) {
    if (this.allowBlank != _) {
      this.allowBlank = _;
      this.field.allowBlank = _ || this.field.readOnly;
      this.field.validate();
    }
  }});
  WIM.DateTimeComponent = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.timeDisabled = false;
    this.allowBlank = config.allowBlank;
    this.field = new Ext.form.FieldContainer(Ext.apply({}, config, {fieldLabel:config.fieldLabel, layout:{type:'hbox'}, items:[this.dateField = new Ext.form.DateField({width:120, validateOnBlur:false, format:'d.m.Y', disabled:config.disabled, allowBlank:config.allowBlank, minValue:config.minDate ? WIM.startOfDay(config.minDate) : undefined, maxValue:config.maxDate ? WIM.endOfDay(config.maxDate) : undefined}), new Ext.Container({width:10}), this.timeField = new Ext.form.TimeField({width:90, validateOnBlur:false, 
    format:'H:i', disabled:config.disabled, allowBlank:config.allowBlank})]}));
    var changed = function() {
      this.fireEvent('change', this);
    };
    this.dateField.on('change', changed, this);
    this.timeField.on('change', changed, this);
  }, setTimeDisabled:function(_) {
    if (_ != this.timeDisabled) {
      this.timeDisabled = _;
      if (this.timeDisabled) {
        this.timeField.setValue('');
      }
      this.timeField.setDisabled(this.dateField.disabled || this.timeDisabled);
      this.timeField.allowBlank = this.allowBlank || this.timeDisabled;
      this.timeField.validate();
      this.fireEvent('change', this);
    }
  }, isDisabled:function() {
    return this.dateField.disabled;
  }, setDisabled:function(_) {
    this.dateField.setDisabled(_);
    this.timeField.setDisabled(this.timeDisabled || _);
  }, canAccept:function() {
    return this.dateField.disabled || this.dateField.isValid() && (this.timeDisabled || this.timeField.isValid());
  }, load:function(_) {
    if (Ext.isEmpty(_)) {
      this.dateField.setValue('');
      this.timeField.setValue('');
    } else {
      var set = false;
      var d;
      if (_.length == 10) {
        d = Ext.Date.parse(_, 'Y-m-d');
        if (d) {
          this.dateField.setValue(d);
          this.timeField.setValue('');
          set = true;
        }
      } else {
        d = Ext.Date.parse(_, 'c');
        if (d) {
          this.dateField.setValue(d);
          if (!this.timeDisabled) {
            d.setMilliseconds(0);
            d.setSeconds(0);
            this.timeField.setValue(d);
          }
          set = true;
        }
      }
      if (!set) {
        this.dateField.setValue('');
        this.timeField.setValue('');
      }
    }
  }, submitValue:function() {
    var d = this.dateField.getValue();
    if (this.timeDisabled) {
      return Ext.isEmpty(d) ? '' : Ext.Date.format(d, 'Y-m-d');
    } else {
      var t = this.timeField.getValue();
      if (Ext.isEmpty(d) || Ext.isEmpty(t)) {
        return '';
      }
      var ff = /(..):(..)(?::(..))?/.exec(t);
      if (!ff) {
        return '';
      }
      Ext.Date.clearTime(d);
      d.setHours(parseInt(ff[1], 10));
      d.setMinutes(parseInt(ff[2], 10));
      return Ext.Date.format(d, 'c');
    }
  }, addFields:function(into) {
    into.push(this.field);
  }});
  WIM.RadioGroup = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.textFunction = config.textFunction;
    this.buttons = new Ext.util.MixedCollection(false, function(a) {
      return a.value;
    });
    this.defaultValue = config.defaultValue;
    Ext.each(config.items, function(a) {
      this.buttons.add({value:a.value, field:new Ext.form.field.Radio({boxLabel:this.boxLabelFor(a), name:'group-' + this.name, inputValue:a.value, checked:this.defaultValue == a.value, disabled:!!a.disabled})});
    }, this);
    var b = [];
    this.buttons.each(function(a) {
      b.push(a.field);
    }, this);
    this.root = new Ext.form.RadioGroup({fieldLabel:config.fieldLabel, columns:config.columnCount || 3, disabled:config.disabled || false, items:b});
    this.root.on('change', function() {
      this.fireEvent('change', this);
    }, this);
  }, boxLabelFor:function(_) {
    return this.textFunction && _.boxLabel === undefined ? this.textFunction.call(_, _.value) : _.boxLabel;
  }, canAccept:function() {
    if (this.root.disabled) {
      return true;
    }
    var result = false;
    this.buttons.each(function(a) {
      if (a.field.getValue()) {
        if (!a.field.disabled) {
          result = true;
        }
        return false;
      }
      return true;
    }, this);
    return result;
  }, isDisabled:function() {
    return this.root.disabled;
  }, isValueDisabled:function(value) {
    return this.buttons.findIndexBy(function(a) {
      return a.value === value && a.field.disabled;
    }, this) !== -1;
  }, setValueDisabled:function(value, disabled) {
    this.buttons.each(function(a) {
      if (a.value === value) {
        a.field.setDisabled(disabled);
        return false;
      }
      return true;
    }, this);
  }, setDisabled:function(_) {
    this.root.setDisabled(_);
    this.fireEvent('change', this);
  }, addFields:function(into) {
    into.push(this.root);
  }, isChecked:function(_) {
    return this.buttons.findIndexBy(function(a) {
      return a.value === _ && a.field.getValue();
    }, this) !== -1;
  }, load:function(value) {
    var b = this.buttons.getByKey(value);
    if (!b) {
      b = this.buttons.getByKey(this.defaultValue);
    }
    if (b) {
      b.field.setValue(true);
      if (!b.field.rendered) {
        this.fireEvent('change', this);
      }
    }
  }, submitValue:function() {
    var result = this.defaultValue;
    this.buttons.each(function(a) {
      if (a.field.getValue()) {
        result = Ext.String.htmlEncode(a.value);
        return false;
      }
      return true;
    }, this);
    return result;
  }});
  WIM.Antwortstatus = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    config = Ext.apply({}, config, {name:'antwortstatus'});
    WIM.Antwortstatus.superclass.constructor.call(this, config);
    this.fieldLabel = config.fieldLabel || 'Antwortstatus';
    this.maxCount = 3;
    this.textFunction = config.textFunction;
    this.allDisabled = false;
    this.antwortstatus = new Ext.util.MixedCollection(false, function(a) {
      return a.key;
    });
    this.antwortstatus.addAll(config.items);
    this.antwortstatus.each(function(a, index) {
      a.field = new Ext.form.Checkbox({boxLabel:this.boxLabelFor(a), disabled:!!a.disabled, hideEmptyLabel:false});
      a.field.setBoxLabel = function(_) {
        if (!this.rendered || !this.wrap) {
          return;
        }
        var e = this.wrap.child('.x-form-cb-label');
        if (e) {
          e.update(_);
        }
      };
      if (index === 0) {
        a.field.fieldLabel = this.fieldLabel;
      }
      a.field.on('change', function() {
        if (a.field.getValue()) {
          this.antwortstatus.each(function(b) {
            if (a != b && (a.accept != b.accept || a.exclusive || b.exclusive)) {
              b.field.setValue(false);
            }
          }, this);
        }
        this.fireEvent('change', this);
      }, this);
    }, this);
  }, removeValues:function(vv) {
    var parent;
    Ext.each(vv, function(v) {
      for (var i = this.antwortstatus.getCount() - 1; i >= 0; --i) {
        var a = this.antwortstatus.getAt(i);
        if (a.key == v) {
          parent = a.field.ownerCt;
          this.antwortstatus.removeAt(i);
          parent.remove(a.field);
        }
      }
    }, this);
  }, boxLabelFor:function(_) {
    return this.textFunction && _.text === undefined ? this.textFunction.call(_, _.key) : _.text;
  }, updateLabels:function() {
    this.antwortstatus.each(function(b) {
      if (b.field) {
        b.field.setBoxLabel(this.boxLabelFor(b));
      }
    }, this);
  }, canAccept:function() {
    var result = undefined;
    var count = 0;
    this.antwortstatus.each(function(a) {
      if (a.field.getValue()) {
        if (a.accept) {
          count++;
          if (result === undefined) {
            result = true;
          }
        } else {
          result = false;
        }
      }
    }, this);
    if (count > this.maxCount) {
      result = false;
    }
    return !!result;
  }, isDisabled:function() {
    return this.allDisabled || this.antwortstatus.findIndexBy(function(a) {
      return !a.field.disabled;
    }, this) === -1;
  }, setValueDisabled:function(key, value, clearField) {
    var a = this.antwortstatus.getByKey(key);
    a.disabled = value;
    a.field.setDisabled(this.allDisabled || a.disabled);
    if (clearField) {
      a.field.setValue(false);
    }
  }, setDisabled:function(_) {
    this.allDisabled = _;
    this.antwortstatus.each(function(a) {
      a.field.setDisabled(this.allDisabled || a.disabled);
    }, this);
    this.fireEvent('change', this);
  }, isAnyChecked:function() {
    return this.antwortstatus.findIndexBy(function(a) {
      return a.field.getValue();
    }) !== -1;
  }, isChecked:function(key) {
    var a = this.antwortstatus.getByKey(key);
    return a && a.field.getValue();
  }, canReject:function() {
    var result = undefined;
    var count = 0;
    this.antwortstatus.each(function(a) {
      if (a.field.getValue()) {
        if (a.accept) {
          result = false;
        } else {
          count++;
          if (result === undefined) {
            result = true;
          }
        }
      }
    }, this);
    if (count > this.maxCount) {
      result = false;
    }
    return !!result;
  }, addFields:function(into) {
    this.antwortstatus.each(function(a) {
      into.push(a.field);
    }, this);
  }, clearAll:function() {
    this.antwortstatus.each(function(a) {
      a.field.setValue(false);
    });
  }, load:function(value) {
    if (Ext.isArray(value)) {
      Ext.each(value, function(a) {
        var s = this.antwortstatus.getByKey(a);
        if (s && s.field) {
          s.field.setValue(true);
        }
      }, this);
    }
  }, submitType:function() {
    return 'array';
  }, submitValue:function() {
    var s = new WIM.XMLOutput();
    this.antwortstatus.each(function(a) {
      if (a.field.getValue()) {
        s.atom('v', a.key);
      }
    }, this);
    return s.result();
  }});
  WIM.BasicGrid = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    if (config.submitValue) {
      this.submitValue = config.submitValue;
    }
    this.editContext = config.editContext;
    this.readOnly = config.readOnly;
    this.reorderGroup = config.reorderGroup;
    if (config.isRecordValid) {
      this.isRecordValid = config.isRecordValid;
    }
    this.forceRow = !!config.forceRow;
    this.createZeile = config.createZeile;
    this.columns = config.columns;
    this.loaded = false;
    var ff = [];
    var cc = [];
    Ext.each(this.columns, function(c) {
      ff.push(c.name);
      if (!c.internal) {
        var column = {dataIndex:c.name, header:c.header, width:Ext.valueFrom(c.width, 120), hidden:!!c.hidden, renderer:c.renderer || WIM.renderer()};
        if (c.editor) {
          column.editor = c.editor;
        }
        cc.push(column);
      }
    }, this);
    this.store = new Ext.data.Store({fields:ff});
    var grid, store = this.store;
    var gridConfig = {plugins:['cellediting'], border:true, title:config.title, store:this.store, scrollable:true, flex:config.withFieldContainer ? 1 : config.flex, enableColumnHide:config.columnhide || true, selModel:{type:'rowmodel', mode:'SINGLE'}, columns:cc, viewConfig:{emptyText:WIM.noRowsText(!this.readOnly && this.forceRow), deferEmptyText:false, getRowClass:this.getRowClassForView.bind(this)}};
    if (config.id) {
      gridConfig.id = config.id;
    }
    if (this.editContext && !this.readOnly) {
      this.createButton = new Ext.Button({text:'Hinzufügen', scope:this, handler:function() {
        this.editContext.create(this.grid);
      }});
      this.editButton = new Ext.Button({text:'Bearbeiten', disabled:true, scope:this, handler:function() {
        this.editContext.edit(this.grid, this.grid.getSelectionModel().getSelection()[0]);
      }});
      this.removeButton = new Ext.Button({text:'Entfernen', disabled:true, scope:this, handler:function() {
        this.editContext.remove(this.grid, this.grid.getSelectionModel().getSelection()[0]);
      }});
      this.up = new Ext.Button({text:'Hoch', disabled:true, scope:this, handler:function() {
        var r = this.grid.getSelectionModel().getSelection()[0];
        var i = r ? this.grid.getStore().indexOf(r) : -1;
        if (i !== -1 && i !== 0) {
          this.grid.store.remove(r);
          this.grid.store.insert(i - 1, r);
        }
      }});
      this.down = new Ext.Button({text:'Herunter', disabled:true, scope:this, handler:function() {
        var r = this.grid.getSelectionModel().getSelection()[0];
        var i = r ? this.grid.getStore().indexOf(r) : -1;
        if (i !== -1 && i !== this.grid.store.getCount()) {
          this.grid.store.remove(r);
          this.grid.store.insert(i + 1, r);
        }
      }});
      var items = [this.createButton, this.editButton, this.removeButton, ' ', this.up, this.down];
      Ext.each(config.tbarItems || [], function(n) {
        items.push(n);
      }, this);
      gridConfig.tbar = new Ext.Toolbar({items:items});
    }
    grid = this.grid = new Ext.grid.Panel(gridConfig);
    if (this.editContext && !this.readOnly) {
      this.grid.on('rowdblclick', function(view, record) {
        this.editContext.edit(this.grid, record);
      }, this);
      this.grid.getSelectionModel().on('selectionchange', function(view, nodes) {
        if (this.grid.getSelectionModel().hasSelection()) {
          this.editButton.enable();
          this.removeButton.enable();
          var r = this.grid.getSelectionModel().getSelection()[0];
          var index = this.grid.getStore().indexOf(r);
          if (this.reorderGroup) {
            var other;
            if (index === 0) {
              this.up.setDisabled(true);
            } else {
              other = this.grid.getStore().getAt(index - 1);
              this.up.setDisabled(other.get(this.reorderGroup) !== r.get(this.reorderGroup));
            }
            if (index + 1 == this.grid.getStore().getCount()) {
              this.down.setDisabled(true);
            } else {
              other = this.grid.getStore().getAt(index + 1);
              this.down.setDisabled(other.get(this.reorderGroup) !== r.get(this.reorderGroup));
            }
            this.editButton.enable();
            this.removeButton.enable();
          } else {
            this.up.setDisabled(index === 0);
            this.down.setDisabled(index + 1 == this.grid.getStore().getCount());
          }
        } else {
          this.editButton.disable();
          this.removeButton.disable();
          this.up.disable();
          this.down.disable();
        }
      }, this);
    }
    var fireChange = function() {
      this.fireEvent('change', this);
    };
    this.store.on('update', fireChange, this);
    this.store.on('add', fireChange, this);
    this.store.on('remove', fireChange, this);
    if (config.withFieldContainer) {
      this.root = Ext.create('Ext.form.FieldContainer', {width:config.width, height:config.height, fieldLabel:config.fieldLabel, layout:{type:'vbox', align:'stretch'}, items:[this.grid]});
    } else {
      this.root = this.grid;
    }
  }, setForceRow:function(_) {
    if (this.forceRow != _) {
      this.forceRow = _;
      WIM.updateGridNoRowsText(this.grid, !this.readOnly && this.forceRow);
    }
  }, refreshValid:function() {
    if (this.grid.rendered) {
      this.grid.view.refresh(false);
    }
    this.fireEvent('change', this);
  }, canAccept:function() {
    if (this.readOnly) {
      return true;
    }
    return this.store.getCount() === 0 ? !this.forceRow : this.store.findBy(function(r) {
      return !this.isRecordValid(r);
    }, this) === -1;
  }, getRowClassForView:function(record) {
    return this.readOnly || this.isRecordValid(record) ? '' : WIM.configuration.invalidRowClass;
  }, isRecordValid:WIM.trueFunction, addFields:function(into) {
    into.push(this.root);
  }, submitType:function() {
    return 'relation';
  }, setTitle:function(_) {
    this.grid.setTitle(_);
  }, getValue:function() {
    var result = [];
    this.grid.store.each(function(a) {
      result.push(Ext.apply({}, a.data));
    }, this);
    return result;
  }, submitValue:function() {
    var s = new WIM.XMLOutput();
    this.grid.store.each(function(a, index) {
      s.begin('position', 'tuple');
      if (this.createZeile) {
        s.atom('zeile', index + 1);
      }
      Ext.each(this.columns, function(c) {
        var v = a.data[c.name];
        v = Ext.isEmpty(v) ? '' : v;
        s.atom(c.name, v);
      }, this);
      s.end('position');
    }, this);
    return s.result();
  }, hasValue:function() {
    return this.loaded;
  }, noBackend:function() {
    this.loaded = true;
  }, loadInitial:function(pp, zpChanged) {
    if (!this.loaded || zpChanged) {
      this.grid.store.removeAll();
      Ext.each(pp, function(p) {
        var r = {};
        Ext.each(this.columns, function(f) {
          var v = p[f.name];
          if (v === undefined) {
            v = f.defaultValue;
          }
          r[f.name] = v;
        }, this);
        this.grid.store.add(new this.grid.store.model(r));
      }, this);
      this.fireEvent('change', this);
    }
  }, load:function(v) {
    if (Ext.isArray(v)) {
      this.grid.store.removeAll();
      this.loaded = true;
      Ext.each(v, function(a) {
        this.grid.store.add(new this.grid.store.model(Ext.apply({}, a)));
      }, this);
      this.fireEvent('change', this);
    }
  }, appendRows:function(v) {
    if (Ext.isArray(v)) {
      Ext.each(v, function(a) {
        this.grid.store.add(new this.grid.store.model(Ext.apply({}, a)));
      }, this);
      this.fireEvent('change', this);
    }
  }});
  WIM.StammdatenZPView = Ext.extend(Object, {constructor:function(config) {
    this.defaultKategorie = config.defaultKategorie;
    this.readOnly = config.readOnly;
    this.diff = config.diff;
    this.task = config.task;
    this.noProcessValue = config.noProcessValue;
    this.editableZaehlernummern = config.editableZaehlernummern;
    this.hiddenFields = WIM.StringSet.fromArray(config.hiddenFields || []);
    this.initialTask = !!config.initialTask;
    this.root = new Ext.form.Panel({title:'Meldepunktinformationen', fieldDefaults:{labelWidth:190}, bodyPadding:'10', scrollable:true, items:[]});
    this.components = [];
  }, loadSD:function(data, zpChanged) {
    var parent = data;
    if (data.references != null) {
      parent = data.references.filter(function(o) {
        return o.meldepunkttyp == 'malo';
      });
      if (parent != null) {
        parent = parent[0];
      }
    }
    if (this.hinweis) {
      this.hinweis.loadSD(data.hinweis, zpChanged);
    }
    if (this.zaehlernummern) {
      if (data.summary) {
        this.zaehlernummern.loadSD(data.summary.zaehlernummern, zpChanged);
      }
    }
    if (this.turnusablesung) {
      this.turnusablesung.loadSD(data.turnusablesung, zpChanged);
    }
    if (this.erstmaligeturnusablesung) {
      this.erstmaligeturnusablesung.loadSD(data.erstmaligeturnusablesung, zpChanged);
    }
    if (this.turnusintervall) {
      this.turnusintervall.loadSD(data.turnusintervall, zpChanged);
    }
    if (this.spannungsebeneentnahme) {
      this.spannungsebeneentnahme.loadSD(parent.spannungsebeneentnahme, zpChanged);
    }
    if (this.druckebeneentnahme) {
      this.druckebeneentnahme.loadSD(parent.druckebeneentnahme, zpChanged);
    }
    if (this.gasqualitaet) {
      this.gasqualitaet.loadSD(data.gasqualitaet, zpChanged);
    }
    if (this.spannungsebenemessung) {
      this.spannungsebenemessung.loadSD(data.spannungsebenemessung, zpChanged);
    }
  }, noBackend:function() {
    if (this.hinweis) {
      this.hinweis.noBackend();
    }
    if (this.zaehlernummern) {
      this.zaehlernummern.noBackend();
    }
    if (this.turnusablesung) {
      this.turnusablesung.noBackend();
    }
    if (this.turnusintervall) {
      this.turnusintervall.noBackend();
    }
    if (this.erstmaligeturnusablesung) {
      this.erstmaligeturnusablesung.noBackend();
    }
    if (this.spannungsebeneentnahme) {
      this.spannungsebeneentnahme.noBackend();
    }
    if (this.druckebeneentnahme) {
      this.druckebeneentnahme.noBackend();
    }
    if (this.gasqualitaet) {
      this.gasqualitaet.noBackend();
    }
    if (this.spannungsebenemessung) {
      this.spannungsebenemessung.noBackend();
    }
  }, setRestrictedByRole:function(_) {
    var hidden = {turnusablesung:false, turnusintervall:false, spannungsebeneentnahme:false, druckebeneentnahme:false, spannungsebenemessung:false};
    if (_ == 'MSB') {
      hidden.turnusablesung = true;
      hidden.erstmaligeturnusablesung = true;
      hidden.turnusintervall = true;
    } else if (_ == 'MDL') {
      hidden.spannungsebeneentnahme = true;
      hidden.druckebeneentnahme = true;
      hidden.spannungsebenemessung = true;
    }
    if (this.turnusablesung) {
      this.turnusablesung.setHidden(hidden.turnusablesung);
    }
    if (this.erstmaligeturnusablesung) {
      this.erstmaligeturnusablesung.setHidden(hidden.erstmaligeturnusablesung);
    }
    if (this.turnusintervall) {
      this.turnusintervall.setHidden(hidden.turnusintervall);
    }
    if (this.spannungsebeneentnahme) {
      this.spannungsebeneentnahme.setHidden(hidden.spannungsebeneentnahme);
    }
    if (this.druckebeneentnahme) {
      this.druckebeneentnahme.setHidden(hidden.druckebeneentnahme);
    }
    if (this.spannungsebenemessung) {
      this.spannungsebenemessung.setHidden(hidden.spannungsebenemessung);
    }
  }, setReadOnly:function(_) {
    if (this.hinweis) {
      this.hinweis.setReadOnly(_);
    }
    if (this.zaehlernummern) {
      this.zaehlernummern.setReadOnly(_);
    }
    if (this.turnusablesung) {
      this.turnusablesung.setReadOnly(_);
    }
    if (this.erstmaligeturnusablesung) {
      this.erstmaligeturnusablesung.setReadOnly(_);
    }
    if (this.turnusintervall) {
      this.turnusintervall.setReadOnly(_);
    }
    if (this.spannungsebeneentnahme) {
      this.spannungsebeneentnahme.setReadOnly(_);
    }
    if (this.druckebeneentnahme) {
      this.druckebeneentnahme.setReadOnly(_);
    }
    if (this.spannungsebenemessung) {
      this.spannungsebenemessung.setReadOnly(_);
    }
  }, setForceZaehlernummer:function(_) {
    if (this.zaehlernummern) {
      this.zaehlernummern.setForceRow(_);
    }
  }, load:function(root) {
    var kategorie = root.data.LOG.KATEGORIE;
    var gasquali = true;
    if (Ext.isEmpty(kategorie)) {
      kategorie = this.defaultKategorie;
      gasquali = false;
    }
    if (!Ext.isEmpty(this.task)) {
      if (this.task.kind == 'GED_SDAENDERUNG_AUS_OUT') {
        gasquali = true;
      }
    }
    if (root.data.LOG.MELDEPUNKT !== undefined && this.readOnly == true && !Ext.isEmpty(root.data.LOG.MELDEPUNKT)) {
      var meldepunkte = root.data.LOG.MELDEPUNKT.split(', ');
      this.components.push(this.marktlokationen = new WIM.EditableList({columnName:'Marktlokation', name:'marktlokationen', fieldLabel:'zugeh. Marktlokationen', readOnly:this.readOnly, noProcessValue:this.noProcessValue, diff:this.diff, forceRow:false, processValue:meldepunkte}));
    }
    if (!this.hiddenFields.contains('HINWEIS') && (kategorie == 'E03' || root.data.LOG.HINWEIS !== undefined) && kategorie == 'E01' && kategorie == 'E35') {
      this.components.push(this.hinweis = new WIM.TextArea({name:'hinweis', fieldLabel:'Hinweis', readOnly:this.readOnly, noProcessValue:this.noProcessValue, diff:this.diff, processValue:root.data.LOG.HINWEIS}));
    }
    if (!this.hiddenFields.contains('ZAEHLERNUMMERN')) {
      var obsolete = kategorie == 'E03' || kategorie == 'Z13';
      var anfrage = (kategorie == 'E01' || kategorie == 'Z14') && !this.editableZaehlernummern;
      if (!obsolete || !Ext.isEmpty(root.data.LOG.ZAEHLERNUMMERN)) {
        this.components.push(this.zaehlernummern = new WIM.EditableList({columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:anfrage ? 'Zählernummern (Anfrage)' : obsolete ? 'Zählernummern (obsolet)' : 'Zählernummern', readOnly:this.readOnly || anfrage, noProcessValue:this.noProcessValue, diff:this.diff, forceRow:true, processValue:root.data.LOG.ZAEHLERNUMMERN}));
      }
    }
    var noProcessValue = (kategorie === 'E27' || kategorie === 'Z14') && root.data.LOG.RICHTUNG == 'Eingang';
    if (kategorie === 'E27' || kategorie === 'Z14' || kategorie === 'E03') {
      this.components.push(this.spannungsebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebeneentnahme, name:'spannungsebeneentnahme', fieldLabel:'Spannungsebene MaLo', readOnly:this.readOnly, allowBlank:false, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.SPANNUNGSEBENEENTNAHME}));
      this.components.push(this.druckebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.druckebeneentnahme, name:'druckebeneentnahme', fieldLabel:'Druckebene MaLo', readOnly:this.readOnly, allowBlank:false, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.DRUCKEBENEENTNAHME}));
      this.components.push(this.gasqualitaet = new WIM.QualifierChoice({values:WIM.QQQ.SD.gasqualitaet, name:'gasqualitaet', fieldLabel:'Gasqualität', readOnly:this.readOnly, allowBlank:true, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.GASQUALITAET}));
      this.components.push(this.spannungsebenemessung = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebenemessung, name:'spannungsebenemessung', fieldLabel:'Spannungsebene MeLo', readOnly:this.readOnly, allowBlank:false, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.SPANNUNGSEBENEMESSUNG}));
      if (!gasquali) {
        this.gasqualitaet.setDisabled(true);
      }
      var changeebenen = function() {
        if (this.readOnly) {
          return;
        }
        var d = false;
        var g = false;
        var s = false;
        var m = false;
        var df = !Ext.isEmpty(this.druckebeneentnahme.submitValue());
        var sf = !Ext.isEmpty(this.spannungsebeneentnahme.submitValue());
        var mf = !Ext.isEmpty(this.spannungsebenemessung.submitValue());
        if (gasquali) {
          var gf = !Ext.isEmpty(this.gasqualitaet.submitValue());
          if (df || gf || sf || mf) {
            if (df || gf) {
              s = true;
              m = true;
            } else {
              if (sf || mf) {
                d = true;
              }
              g = true;
            }
          }
          this.gasqualitaet.setAllowBlank(g);
        } else {
          if (df || sf || mf) {
            if (df) {
              s = true;
              m = true;
            } else {
              if (sf || mf) {
                d = true;
              }
              g = true;
            }
          }
        }
        this.druckebeneentnahme.setAllowBlank(d);
        this.spannungsebeneentnahme.setAllowBlank(s);
        this.spannungsebenemessung.setAllowBlank(m);
      };
      this.druckebeneentnahme.on('change', changeebenen, this);
      if (gasquali) {
        this.gasqualitaet.on('change', changeebenen, this);
      }
      this.spannungsebeneentnahme.on('change', changeebenen, this);
      this.spannungsebenemessung.on('change', changeebenen, this);
      changeebenen.call(this);
    }
    if (kategorie === 'E01' && this.initialTask == false) {
      this.components.push(this.spannungsebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebeneentnahme, name:'spannungsebeneentnahme', fieldLabel:'Spannungsebene MaLo', readOnly:this.readOnly, allowBlank:true, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.SPANNUNGSEBENEENTNAHME}));
      this.components.push(this.druckebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.druckebeneentnahme, name:'druckebeneentnahme', fieldLabel:'Druckebene MaLo', readOnly:this.readOnly, allowBlank:true, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.DRUCKEBENEENTNAHME}));
      this.components.push(this.gasqualitaet = new WIM.QualifierChoice({values:WIM.QQQ.SD.gasqualitaet, name:'gasqualitaet', fieldLabel:'Gasqualität', readOnly:this.readOnly, allowBlank:true, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.GASQUALITAET}));
      this.components.push(this.spannungsebenemessung = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebenemessung, name:'spannungsebenemessung', fieldLabel:'Spannungsebene MeLo', readOnly:this.readOnly, allowBlank:true, diff:this.diff, noProcessValue:noProcessValue || this.noProcessValue, processValue:root.data.LOG.SPANNUNGSEBENEMESSUNG}));
    }
    if (kategorie === 'E27' || kategorie === 'Z14' || kategorie === undefined || kategorie == 'E03' || kategorie === 'E01' && this.initialTask == false) {
      this.components.push(new WIM.SpaceComponent({height:5}));
      this.components.push(this.turnusablesung = new WIM.TextField({maxLength:8, allowBlank:false, name:'turnusablesung', fieldLabel:'Geplante Turnusablesung MSB', emptyText:'MMDD oder MMWWMMWW', readOnly:this.readOnly, diff:this.diff, noProcessValue:!this.readOnly, regex:WIM.turnusRegex, regexText:WIM.turnusRegexError, validator:function(v) {
        if (v.length > 0) {
          if (v.length == 4) {
            if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0) {
              return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12) {
              return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) == 0) {
              return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) > 31) {
              return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
            }
          } else if (v.length >= 9) {
            if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) == 0) {
              return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) > 12) {
              return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) == 0) {
              return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
            } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) > 4 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) > 4) {
              return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
            }
          }
        }
        return true;
      }, processValue:root.data.LOG.TURNUSABLESUNG}));
      this.components.push(this.turnusintervall = new WIM.QualifierChoice({values:WIM.QQQ.SD.turnusintervall, name:'turnusintervall', fieldLabel:'Turnusintervall MSB', allowBlank:false, readOnly:this.readOnly, diff:this.diff, noProcessValue:!this.readOnly, processValue:root.data.LOG.TURNUSINTERVALL}));
    }
    if (kategorie === 'E01' && this.initialTask == false) {
      this.components.push(this.erstmaligeturnusablesung = new WIM.TextField({maxLength:8, allowBlank:false, name:'erstmaligeturnusablesung', fieldLabel:'Erstmalige bzw. nächste Turnusablesung', readOnly:this.readOnly, regex:WIM.erstmaligeturnusRegex, regexText:WIM.erstmaligeturnusRegexError, emptyText:'CCYY', diff:this.diff, noProcessValue:!this.readOnly, processValue:root.data.LOG.ERSTMALIGETURNUSABLESUNG}));
      this.turnusablesung.on('change', function(field, newvalue) {
        if (field.giveValue().length > 0 && field.giveValue() != '0000') {
          this.erstmaligeturnusablesung.setAllowBlank(false);
        }
        if (field.giveValue().length == 0) {
          this.erstmaligeturnusablesung.setAllowBlank(true);
        }
      }, this);
    }
    if (kategorie === 'E03') {
      this.components.push(this.erstmaligeturnusablesung = new WIM.TextField({maxLength:8, allowBlank:true, name:'erstmaligeturnusablesung', fieldLabel:'Erstmalige bzw. nächste Turnusablesung', readOnly:this.readOnly, diff:this.diff, noProcessValue:!this.readOnly, processValue:root.data.LOG.ERSTMALIGETURNUSABLESUNG}));
      this.turnusablesung.on('change', function(field, newvalue) {
        if (field.giveValue().length > 0 && field.giveValue() != '0000') {
          this.erstmaligeturnusablesung.setAllowBlank(false);
        }
        if (field.giveValue().length == 0) {
          this.erstmaligeturnusablesung.setAllowBlank(true);
        }
      }, this);
    }
    var items = [];
    Ext.each(this.components, function(c) {
      if (this.task) {
        this.task.addComponent(c);
      }
      c.addFields(items);
    }, this);
    this.root.add(items);
  }});
  WIM.ProcessTabView = Ext.extend(Object, {labelWidth:190, constructor:function(config) {
    this.hiddenFields = WIM.StringSet.fromArray(config.hiddenFields || []);
    this.root = new Ext.form.Panel({title:Ext.valueFrom(this.title, 'Prozessinformationen'), bodyPadding:10, scrollable:true, fieldDefaults:{labelWidth:190}});
  }, addProcessName:function(root, width) {
    width = width || 400 + this.labelWidth;
    if (!this.hiddenFields.contains('NAME')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Prozess', width:width, value:root.data.LOG.NAME}));
      this.addLargeSpace();
    }
  }, marktpartnerLogText:function(log, key) {
    return WIM.marktpartnerText({partnername:log[key + '_PARTNERNAME'], partnerid:log[key + '_PARTNERID'], mpid:log[key + '_MPID'], mpidcode:log[key + '_MPIDCODE']});
  }, ansprechpartnerText:function(v) {
    if (!v) {
      return '';
    }
    var iffull = function(name, w) {
      return w !== '' ? '\n' + name + ': ' + w : '';
    };
    return v.name + iffull('Mail', v.mail) + iffull('Telefon', v.telefon) + iffull('Telefon 2', v.telefon2) + iffull('Handy', v.handy) + iffull('Telefax', v.telefax);
  }, addProcessPartner:function(root, width) {
    width = width || 400 + this.labelWidth;
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Mandant', width:width, value:this.marktpartnerLogText(root.data.LOG, 'OWN')}));
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Partner', width:width, value:this.marktpartnerLogText(root.data.LOG, 'MP')}));
    this.addSmallSpace();
  }, addPartner:function(root, config, width) {
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:config.fieldLabel, width:width, value:this.marktpartnerLogText(root.data.LOG, config.prefix)}));
  }, addSmallSpace:function() {
    this.root.add({xtype:'container', height:10});
  }, addLargeSpace:function() {
    this.root.add({xtype:'container', height:20});
  }, addAnsprechpartner:function(root, width) {
    width = width || 400 + this.labelWidth;
    if (root.data.LOG.ANSPRECHPARTNERINTERN !== undefined && !this.hiddenFields.contains('ANSPRECHPARTNERINTERN')) {
      this.root.add(new Ext.form.field.TextArea({fieldLabel:'Ansprechpartner intern', readOnly:true, width:width, height:60, value:this.ansprechpartnerText(root.data.LOG.ANSPRECHPARTNERINTERN)}));
    }
    if (root.data.LOG.ANSPRECHPARTNEREXTERN !== undefined && !this.hiddenFields.contains('ANSPRECHPARTNEREXTERN')) {
      this.root.add(new Ext.form.field.TextArea({fieldLabel:'Ansprechpartner extern', readOnly:true, width:width, height:60, value:this.ansprechpartnerText(root.data.LOG.ANSPRECHPARTNEREXTERN)}));
    }
    if (root.data.LOG.ROLLE == 'NB' && (root.data.LOG.ANSPRECHPARTNERMSBA !== undefined && !this.hiddenFields.contains('ANSPRECHPARTNERMSBA'))) {
      this.root.add(new Ext.form.field.TextArea({fieldLabel:'Ansprechpartner extern (MSB Endablesewerte)', readOnly:true, width:width, height:60, value:this.ansprechpartnerText(root.data.LOG.ANSPRECHPARTNERMSBA)}));
    }
    if (root.data.LOG.ANSPRECHPARTNERMELDER !== undefined && !this.hiddenFields.contains('ANSPRECHPARTNERMELDER')) {
      this.root.add(new Ext.form.field.TextArea({fieldLabel:'Ansprechpartner Melder', readOnly:true, width:width, height:60, value:this.ansprechpartnerText(root.data.LOG.ANSPRECHPARTNERMELDER)}));
    }
  }});
  WIM.HistoryView = Ext.extend(Object, {constructor:function(config) {
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.mkoView = config.mkoView;
    this.root = new Ext.Panel({title:'Prozessschritte', layout:'fit'});
  }, load:function(root) {
    var fields = [];
    var columns = [];
    Ext.each(root.meta.CHILDLOG, function(e) {
      if (e.hidden === 'true' && e.hideable === 'false') {
        return;
      }
      var f = {name:e.dataIndex};
      if (e.type == 'date') {
        f.convert = WIM.dbDateDisplayValue;
      }
      var c = {dataIndex:e.dataIndex, header:e.header, cellWrap:true, width:Ext.Number.from(e.width, 100)};
      if (e.dataIndex == 'TEXT') {
        c.renderer = function(value, meta) {
          meta.attr += "style\x3d'white-space: normal'";
          return Ext.util.Format.nl2br(Ext.String.htmlEncode(value));
        };
      } else if (e.dataIndex == 'STATUS') {
        c.renderer = this.wimContext.statusIconIMGRenderer({withText:true});
        c.width = 140;
        c.cellWrap = false;
      } else {
        c.renderer = WIM.renderer();
      }
      fields.push(f);
      columns.push(c);
    }, this);
    if (this.mkoView) {
      columns.push({header:'', dataIndex:'', align:'center', scope:this, width:70, renderer:function(v, meta, r) {
        if (Ext.isEmpty(r.data.MESSAGEID)) {
          return '';
        }
        return '\x3cspan onclick\x3d"var v \x3d Ext.getCmp(\'' + this.mkoView.root.getId() + '\'); v.ownerCt.setActiveTab(v);"\x3e' + WIM.iconClsHtml('fa-search') + '\x3c/span\x3e';
      }});
    }
    var cc = Ext.clone(root.data.CHILDLOG);
    cc.sort(function(a, b) {
      var m = Ext.Number.parseInt(a.CHILDID), n = Ext.Number.parseInt(b.CHILDID);
      return m < n ? -1 : m === n ? 0 : 1;
    });
    this.grid = new Ext.grid.GridPanel({viewConfig:{emptyText:'Keine Einträge.', deferEmptyText:false}, border:false, enableHdMenu:false, store:new Ext.data.Store({model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'CHILDID', fields:fields}), data:cc}), columns:columns});
    this.root.add(this.grid);
  }, requestFailed:function() {
    this.root.add(new Ext.form.field.Display({value:"\x3cspan style\x3d'color:#f44'\x3eFehler beim Abruf.\x3c/span\x3e"}));
  }});
  WIM.ComponentList = Ext.extend(Object, {constructor:function(config) {
    this.callParent(arguments);
    this.nextListID = 0;
    this.maxLength = config.maxLength;
    this.minCount = config.minCount;
    this.maxCount = config.maxCount;
    if (config.newField) {
      this.newField = config.newField;
    }
    this.root = new Ext.form.FieldContainer({fieldLabel:config.fieldLabel});
    this.root.on('render', this.render, this);
    this.task = config.task;
    this.values = new Ext.util.MixedCollection(false, WIM.IDOf);
    this.addButton = new Ext.Button({text:'Hinzufügen', scope:this, handler:function() {
      this.addValue('');
      this.updateButtons();
    }});
    this.loadValue([]);
  }, render:function() {
    this.values.each(function(v) {
      this.root.add(v.outerField);
    }, this);
    this.root.add(this.addButton);
  }, updateButtons:function() {
    this.addButton.setDisabled(this.values.getCount() >= this.maxCount);
    var cannotRemove = this.values.getCount() <= this.minCount;
    this.values.each(function(v) {
      v.button.setDisabled(cannotRemove);
    }, this);
    if (this.minCount == this.maxCount) {
      this.root.setVisible(this.minCount > 0);
      this.addButton.hide();
      this.values.each(function(v) {
        v.button.hide();
      }, this);
    } else {
      this.root.show();
      this.addButton.show();
      this.values.each(function(v) {
        v.button.show();
      }, this);
    }
  }, setMinCount:function(_) {
    this.minCount = _;
    for (var i = this.values.getCount(); i < this.minCount; i++) {
      this.addValue('');
    }
    this.updateButtons();
  }, setMaxCount:function(_) {
    this.maxCount = _;
    for (var i = this.values.getCount() - 1; i >= this.maxCount; --i) {
      this.removeComponent(this.values.getAt(i));
    }
    this.updateButtons();
  }, removeComponent:function(_) {
    if (_.outerField.ownerCt) {
      _.outerField.ownerCt.remove(_.outerField);
    }
    this.values.remove(_);
    this.updateButtons();
  }, newField:function() {
    return new Ext.form.field.Text({width:300, regex:WIM.Latin1Regex, regexText:WIM.Latin1RegexError, maxLength:this.maxLength, allowBlank:false});
  }, addValue:function(_) {
    var f = this.newField();
    var b = new Ext.Button({text:'Entfernen', scope:this, handler:function() {
      this.removeComponent(data);
    }});
    var outerField = new Ext.Container({layout:'hbox', items:[f, new Ext.Component({width:5}), b]});
    var data = {field:f, button:b, outerField:outerField, ID:'ID' + this.nextListID};
    this.nextListID++;
    f.setValue(_);
    this.values.add(data);
    if (this.root.rendered) {
      this.root.insert(this.root.items.getCount() - 1, outerField);
    }
  }, loadValue:function(vv) {
    var i;
    for (i = this.values.getCount() - 1; i >= 0; --i) {
      this.removeComponent(this.values.getAt(i));
    }
    if (vv !== undefined) {
      Ext.each(vv, function(v) {
        this.addValue(v);
      }, this);
    }
    for (i = this.values.getCount(); i < this.minCount; i++) {
      this.addValue('');
    }
    this.updateButtons();
  }, value:function() {
    var result = [];
    this.values.each(function(v) {
      result.push(v.field.getValue());
    }, this);
    return result;
  }});
  WIM.newNBComponent = function(task, config) {
    config = config || {};
    return new WIM.MarktpartnerComponent(Ext.apply({}, config, {url:task.wimContext.serverURL(), diff:false, allowBlank:false, noProcessValue:true, name:'nb', role:'nb', NB:true, fieldLabel:'NB', sdZaehlpunkt:task.zaehlpunkt}));
  };
  WIM.newMSBComponent = function(task, config) {
    config = config || {};
    return new WIM.MarktpartnerComponent(Ext.apply({}, config, {url:task.wimContext.serverURL(), diff:true, noProcessValue:true, name:'msb', role:'msb', MSB:true, fieldLabel:'MSB', sdZaehlpunkt:task.zaehlpunkt}));
  };
  WIM.newLFComponent = function(task, config) {
    config = config || {};
    return new WIM.MarktpartnerComponent(Ext.apply({}, config, {url:task.wimContext.serverURL(), diff:true, noProcessValue:true, name:'lf', loadingText:'', role:'lf', LF:true, fieldLabel:'LF', sdZaehlpunkt:task.zaehlpunkt}));
  };
  WIM.newNBLFComponent = function(task, config) {
    config = config || {};
    return new WIM.MarktpartnerComponent(Ext.apply({}, config, {url:task.wimContext.serverURL(), diff:false, allowBlank:false, noProcessValue:true, name:'nblf', role:'nb', NB:true, LF:true, fieldLabel:'NB/LF', sdZaehlpunkt:task.zaehlpunkt}));
  };
  WIM.ZaehlpunktMarktpartnerList = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.roles = ['msb', 'lf'];
    var labelWidth = 50;
    this.root = new Ext.form.FieldContainer({border:false, fieldDefaults:{labelWidth:labelWidth}, labelWidth:140, fieldLabel:config.fieldLabel});
    this.task = config.task;
    var mpConfig = {url:this.task.wimContext.serverURL(), diff:true, noProcessValue:true, name:'mp', width:367 - 7 - labelWidth, sdZaehlpunkt:this.task.zaehlpunkt, canCheck:this.checkMarktpartner.bind(this)};
    this.roleComponents = {};
    Ext.each(this.roles, function(r) {
      var u = r.toUpperCase();
      var c = {};
      c[u] = true;
      this.roleComponents[r] = new WIM.MarktpartnerComponent(Ext.apply(c, mpConfig, {name:r, role:r, fieldLabel:u}));
      this.roleComponents[r].on('change', mpConfig.canCheck);
      this.root.add(this.roleComponents[r].outerField);
    }, this);
  }, submitType:function() {
    return 'tuple';
  }, load:function(data) {
    if (!data) {
      data = {};
    }
    Ext.Object.each(this.roleComponents, function(r, c) {
      c.load(data[r] || {});
    }, this);
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    Ext.Object.each(this.roleComponents, function(r, c) {
      x.begin(r, 'tuple');
      x.atom('checked', c.isChecked() ? 'true' : 'false');
      x.subXML(c.submitValue());
      x.end(r);
    }, this);
    return x.result();
  }, checkMarktpartner:function(_) {
    this.fireEvent('change', this);
  }, canAccept:function() {
    var hasOne = false;
    var result = true;
    Ext.Object.each(this.roleComponents, function(r, c) {
      if (c.isChecked()) {
        hasOne = true;
        if (!c.canAccept()) {
          result = false;
          return false;
        }
      }
      return true;
    }, this);
    return result && hasOne;
  }, addFields:function(into) {
    into.push(this.root);
  }});
  WIM.ProcessListView = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.chosenProcessID = '';
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.prefixes = config.prefixes;
    this.prefixName = config.prefixName;
    var fields = ['PREFIX', 'NAME', 'PROCESSID', 'VORGANG', 'MP_PARTNERNAME', {name:'DATUM', convert:function(v) {
      if (Ext.isEmpty(v)) {
        return '';
      }
      var d = Ext.Date.parse(v, 'c');
      return d ? Ext.Date.format(d, 'd.m.Y') : v;
    }}, 'ZAEHLPUNKT', 'TRANSAKTIONSGRUND', {name:'TIMESTAMP', convert:function(date) {
      if (Ext.isEmpty(date)) {
        return '';
      }
      return Ext.Date.parse(date.substring(0, 19), 'Y-m-d H:i:s');
    }}];
    var columns = [{header:'Prozess', dataIndex:'NAME', width:200, renderer:WIM.renderer()}, {header:'Prozess-ID', dataIndex:'PROCESSID', width:105, renderer:WIM.renderer()}, {header:'Vorgang', dataIndex:'VORGANG', width:200, renderer:WIM.renderer()}, {header:'Zählpunkt', dataIndex:'ZAEHLPUNKT', width:300, renderer:WIM.renderer()}, {header:'Termin', dataIndex:'DATUM', width:105, renderer:WIM.renderer()}, {header:'Transaktionsgrund', dataIndex:'TRANSAKTIONSGRUND', width:105, renderer:WIM.renderer()}, 
    {header:'Marktpartner', dataIndex:'MP_PARTNERNAME', width:200, renderer:WIM.renderer()}, {header:'Zeitstempel', dataIndex:'TIMESTAMP', renderer:function(v) {
      if (Ext.isEmpty(v)) {
        return '';
      }
      return Ext.String.htmlEncode(Ext.Date.format(v, 'd.m.Y H:i:s'));
    }, width:160}];
    this.root = new Ext.grid.GridPanel({selModel:{type:'checkboxmodel', mode:'SINGLE'}, title:'Stornierbare Prozesse', width:'auto', height:250, viewConfig:{emptyText:'Keine Prozesse.', deferEmptyText:true}, enableHdMenu:false, store:new Ext.data.Store({model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'PROCESSID', fields:fields}), sorters:[{property:'TIMESTAMP', direction:'DESC'}]}), columns:columns});
    this.root.getSelectionModel().on('selectionchange', function() {
      var r = this.root.getSelectionModel().getSelection()[0];
      this.chosenProcessID = r ? r.data.PROCESSID : '';
      this.chosenPrefix = r ? r.data.PREFIX : '';
      this.fireEvent('change', this);
    }, this);
  }, canAccept:function() {
    return !Ext.isEmpty(this.chosenProcessID);
  }, isMulti:WIM.trueFunction, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.atom(this.name, this.chosenProcessID);
    x.atom(this.prefixName, this.chosenPrefix);
    return x.result();
  }, load:function(root) {
    this.chosenProcessID = root[this.name];
    this.chosenPrefix = root[this.prefixName];
    if (this.loaded) {
      this.selectChosen();
    }
  }, selectChosen:function() {
    var r = this.root.store.getById(this.chosenProcessID);
    if (r) {
      this.root.getSelectionModel().select([r]);
    } else {
      this.root.getSelectionModel().clearSelections();
      this.chosenPrefix = '';
      this.chosenProcessID = '';
    }
  }, addFields:function(into) {
    into.push(this.root);
  }, requestLoad:function(root) {
    var prefixes = this.prefixes;
    this.request = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, makeCommand:function() {
      var result = '\x3cprocesses\x3e\x3cprefixes\x3e';
      Ext.each(prefixes, function(p) {
        result += '\x3citem\x3e' + Ext.String.htmlEncode(p) + '\x3c/item\x3e';
      }, this);
      result += '\x3c/prefixes\x3e\x3csimplefilters\x3e\x3cstatus\x3eOK\x3c/status\x3e\x3crichtung\x3eAusgang\x3c/richtung\x3e\x3cnichtstorniert\x3etrue\x3c/nichtstorniert\x3e\x3c/simplefilters\x3e\x3c/processes\x3e';
      return result;
    }, scope:this, requestSuccess:function(result) {
      this.loaded = true;
      this.loadProcesses(result.data);
    }, requestFailure:function() {
      this.loaded = true;
      WIM.handleFailure.apply(this, arguments);
    }});
    this.request.start(root);
  }, loadProcesses:function(d) {
    this.root.store.add(d.LOG);
    this.selectChosen();
  }});
  WIM.RemoteView = Ext.extend(Ext.util.Observable, {constructor:function(config) {
    this.callParent(arguments);
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.remoteConfig = config.remoteConfig;
    this.tabPanel = config.tabPanel;
  }, load:function(value, mask) {
    var remoteConfig = this.remoteConfig;
    var anfrageRequest = new WIM.ProcessRequest({process:this.process, scope:this, url:this.wimContext.serverURL(), makeCommand:function() {
      return '\x3cremoteprocess\x3e\x3cprefix\x3e' + Ext.String.htmlEncode(remoteConfig.prefix) + '\x3c/prefix\x3e\x3cfromField\x3e' + Ext.String.htmlEncode(remoteConfig.fromField) + '\x3c/fromField\x3e\x3cfromValue\x3e' + Ext.String.htmlEncode(value) + '\x3c/fromValue\x3e\x3c/remoteprocess\x3e';
    }, requestSuccess:function(root) {
      if (!root.data || !root.data.data || !root.data.data.LOG) {
        this.fireEvent('loaded', this);
        if (this.tabView.setError) {
          this.tabView.setError("\x3cspan style\x3d'font-weight: bold'\x3eProzess nicht gefunden.\x3c/span\x3e");
        }
      } else {
        this.fireEvent('loaded', this, root.data);
        if (this.tabPanel) {
          this.tabPanel.add(this.tabView.root);
        }
        this.tabView.load(root.data);
      }
    }, requestFailure:function() {
      WIM.handleFailure.apply(this, arguments);
      if (this.tabView.setError) {
        this.tabView.setError("\x3cspan style\x3d'color:red'\x3eFehler beim Abruf.\x3c/span\x3e");
      }
    }});
    anfrageRequest.start(mask);
  }});
  WIM.RemoteWechselView = Ext.extend(WIM.RemoteView, {constructor:function(config) {
    this.callParent(arguments);
    this.tabView = new WIM.WechselView(config.wechselConfig);
    this.root = this.tabView.root;
  }});
  WIM.RemoteUebernahmeView = Ext.extend(WIM.RemoteView, {constructor:function(config) {
    this.callParent(arguments);
    this.tabView = new WIM.GeraeteuebernahmeView(config.uebernahmeConfig);
  }});
  WIM.WechselView = Ext.extend(WIM.ProcessTabView, {setError:function(text) {
    this.root.add(Ext.create('Ext.form.field.Display', {width:600, htmlEncode:false, value:text}));
  }, load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    if (root.data.LOG.ROLLE !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Rolle', width:width, value:root.data.LOG.ROLLE}));
    }
    this.addProcessPartner(root, width);
    if (root.data.LOG.KATEGORIE !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Kategorie', width:width, value:WIM.QQQ.GED.kategorieQText(root.data.LOG.KATEGORIE)}));
    }
    if (root.data.LOG.LEISTUNG !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Leistung', width:width, value:WIM.QQQ.SD.leistungQText(root.data.LOG.LEISTUNG)}));
    }
    if (root.data.LOG.LIEFERRICHTUNG !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Lieferrichtung', width:width, value:WIM.QQQ.SD.lieferrichtungQText(root.data.LOG.LIEFERRICHTUNG)}));
    }
    if (root.data.LOG.TRANSAKTIONSGRUND !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Transaktionsgrund', width:width, value:WIM.QQQ.UTILMD.transaktionsgrundQTexts(root.data.LOG.TRANSAKTIONSGRUND)}));
    }
    var dateHint = root.data.LOG.KATEGORIE === 'E35' ? ' - 00:00 (Strom) bzw. 06:00 (Gas)' : '';
    var dateDisplayValueWithHint = function(v) {
      var w = WIM.dateDisplayValue(v);
      return Ext.isEmpty(w) ? '' : w + dateHint;
    };
    if (root.data.LOG.DATUMBEGINN !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (Beginn)', width:width, value:dateDisplayValueWithHint(root.data.LOG.DATUMBEGINN)}));
    }
    if (root.data.LOG.DATUM !== undefined && root.data.LOG.DATUMBEGINN !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (Ende)', width:width, value:dateDisplayValueWithHint(root.data.LOG.DATUM)}));
    }
    if (root.data.LOG.DATUM !== undefined && root.data.LOG.DATUMBEGINN == undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin', width:width, value:dateDisplayValueWithHint(root.data.LOG.DATUM)}));
    }
    if (!this.hiddenFields.contains('DATUMKORRIGIERT') && root.data.LOG.DATUMKORRIGIERT !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (korrigiert)', width:width, value:dateDisplayValueWithHint(root.data.LOG.DATUMKORRIGIERT)}));
    }
    if (!this.hiddenFields.contains('DATUMNAECHSTMOEGLICH') && root.data.LOG.DATUMNAECHSTMOEGLICH !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'zum nächstmöglichen Termin', width:width, value:root.data.LOG.DATUMNAECHSTMOEGLICH}));
    }
    if (root.data.LOG.BEAUFTRAGUNGBEENDIGUNG !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Beauftragung/Beendigung', width:width, value:WIM.QQQ.MSB.beauftragungbeendigungQTexts(root.data.LOG.BEAUFTRAGUNGBEENDIGUNG)}));
    }
    if (!this.hiddenFields.contains('ANTWORTSTATUS') && root.data.LOG.ANTWORTSTATUS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Antwortstatus', width:width, value:WIM.QQQ.UTILMD.antwortstatusQTexts(root.data.LOG.ANTWORTSTATUS)}));
    }
    if (!this.hiddenFields.contains('ABLEHNUNGSGRUND') && !Ext.isEmpty(root.data.LOG.ABLEHNUNGSGRUND)) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablehnungsgrund', width:width, value:WIM.QQQ.GED.antwortstammdatenQText(root.data.LOG.ABLEHNUNGSGRUND)}));
    }
    if (root.data.LOG.KATEGORIE == 'E35' && (!Ext.isEmpty(root.data.LOG.KUENDIGUNGSFRIST_CODE) || !Ext.isEmpty(root.data.LOG.KUENDIGUNGSFRIST_BEZUG))) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Code Kündigungsfrist', width:width, value:root.data.LOG.KUENDIGUNGSFRIST_CODE}));
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Bezug Kündigungsfrist', width:width, value:root.data.LOG.KUENDIGUNGSFRIST_BEZUG}));
    }
    if (root.data.LOG.WECHSELSTATUS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Wechselstatus', width:width, value:WIM.QQQ.MSB.wechselstatusQText(root.data.LOG.WECHSELSTATUS)}));
    }
    if (!this.hiddenFields.contains('WECHSELSTATUSANLASS') && root.data.LOG.WECHSELSTATUSANLASS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Wechselstatusanlass', width:width, value:WIM.QQQ.MSB.wechselstatusanlassQText(root.data.LOG.WECHSELSTATUSANLASS)}));
    }
    if (root.data.LOG.KATEGORIE == 'Z09') {
      this.addSmallSpace();
      var mp = new WIM.MarktpartnerZPView(root.data.LOG.LEISTUNG == 'Z09' ? {displayOnly:true, noLF:true, MSB:{name:'msbn', fieldLabel:'MSBN'}, noMDL:true} : root.data.LOG.LEISTUNG == 'Z10' ? {displayOnly:true, noLF:true, MSB:{name:'msbn', fieldLabel:'MSBN'}} : {displayOnly:true, noLF:true, noMSB:true});
      mp.load(root);
      this.root.add(mp.fieldsToArray());
    }
    if (root.data.LOG.BEMERKUNG !== undefined) {
      this.root.add(new Ext.form.field.TextArea({readOnly:true, fieldLabel:'Bemerkung', width:width, value:root.data.LOG.BEMERKUNG}));
    }
    if (!this.hiddenFields.contains('BEMERKUNGANTWORT') && root.data.LOG.BEMERKUNGANTWORT !== undefined) {
      this.root.add(new Ext.form.field.TextArea({readOnly:true, fieldLabel:'Bemerkung (Antwort)', width:width, value:root.data.LOG.BEMERKUNGANTWORT}));
    }
    if (!Ext.isEmpty(root.data.LOG.VORGANGWEITER)) {
      this.addSmallSpace();
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin Weiterverpflichtung', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUMWEITER)}));
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Antwort Weiterverpflichtung', width:width, value:WIM.QQQ.MSB.antwortweiterQText(root.data.LOG.ANTWORTSTATUSWEITER)}));
    }
    if (root.data.LOG.RICHTUNG == 'Eingang' && !this.hiddenFields.contains('VORGANGLF') && root.data.LOG.VORGANGLF !== undefined) {
      this.addSmallSpace();
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang (LF)', width:width, value:WIM.dateDisplayValue(root.data.LOG.VORGANGLF)}));
    }
    if (!Ext.isEmpty(root.data.LOG.STORNIERT)) {
      this.addSmallSpace();
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'storniert', width:width, value:root.data.LOG.STORNIERT}));
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang Storno', width:width, value:root.data.LOG.VORGANGSTORNO}));
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Antwortstatus Storno', width:width, value:WIM.QQQ.UTILMD.antwortstatusQTexts(root.data.LOG.ANTWORTSTORNO)}));
      this.root.add(new Ext.form.field.TextArea({readOnly:true, fieldLabel:'Bemerkung Storno', width:width, value:root.data.LOG.BEMERKUNGSTORNO}));
      this.root.add(new Ext.form.field.TextArea({readOnly:true, fieldLabel:'Bemerkung Storno (Antwort)', width:width, value:root.data.LOG.BEMERKUNGANTWORTSTORNO}));
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.GeraeteuebernahmeView = Ext.extend(WIM.ProcessTabView, {load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    this.addProcessPartner(root, width);
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUM)}));
    if (!this.hiddenFields.contains('LEISTUNG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Leistung', width:width, value:WIM.QQQ.GER.leistungbestellungQText(root.data.LOG.LEISTUNG)}));
    }
    if (!this.hiddenFields.contains('WAEHRUNG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Währung', width:width, value:root.data.LOG.WAEHRUNG}));
    }
    if (!this.hiddenFields.contains('BETRAG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Betrag (Angebot)', width:width, value:root.data.LOG.BETRAG.replace('.', ',')}));
    }
    if (!this.hiddenFields.contains('BETRAGBESTELLUNG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Betrag (Bestellung)', width:width, value:root.data.LOG.BETRAGBESTELLUNG.replace('.', ',')}));
    }
    if (!this.hiddenFields.contains('ANTWORTBESTELLUNG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Antwort Bestellung', width:width, value:WIM.QQQ.GER.antwortbestellungQText(root.data.LOG.ANTWORTBESTELLUNG)}));
    }
    this.addLargeSpace();
    if (!this.hiddenFields.contains('VORGANG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang (Anfrage)', width:width, value:root.data.LOG.VORGANG}));
    }
    if (!this.hiddenFields.contains('VORGANGQUOTES')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang (Angebot)', width:width, value:root.data.LOG.VORGANGQUOTES}));
    }
    if (!this.hiddenFields.contains('VORGANGORDERS')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang (Bestellung)', width:width, value:root.data.LOG.VORGANGORDERS}));
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.MarktpartnerZPView = Ext.extend(Object, {constructor:function(config) {
    this.displaySDOnly = config.displaySDOnly;
    config = Ext.apply({}, config, {MSB:{}, LF:{}, OWN:{}});
    this.MSBs = [];
    this.task = config.task;
    this.zaehlpunkt = this.task ? this.task.zaehlpunkt : undefined;
    if (config.NB) {
      if (config.displayOnly || config.NBDisplayOnly) {
        this.NB = new WIM.MarktpartnerDisplayField(Ext.apply({}, config.NB, {task:config.task, name:'nb', role:'nb', fieldLabel:'NB', noProcessValue:false, sdZaehlpunkt:this.zaehlpunkt}));
      } else {
        this.NB = WIM.newNBComponent(this.task, config.NB);
      }
    }
    if (config.MSB0) {
      if (config.displayOnly || config.MSB0DisplayOnly) {
        this.MSBs.push(new WIM.MarktpartnerDisplayField(Ext.apply({}, config.MSB0, {task:config.task, name:'msb', role:'msb', fieldLabel:'MSB', noProcessValue:false, sdZaehlpunkt:this.zaehlpunkt})));
      } else {
        this.MSBs.push(WIM.newMSBComponent(this.task, Ext.apply({}, config.MSB0, {noProcessValue:false})));
      }
    }
    if (!config.noMSB) {
      if (config.displayOnly || config.MSBDisplayOnly) {
        this.MSBs.push(new WIM.MarktpartnerDisplayField(Ext.apply({}, config.MSB, {task:config.task, name:'msb', role:'msb', fieldLabel:'MSB', noProcessValue:false, sdZaehlpunkt:this.zaehlpunkt})));
      } else {
        this.MSBs.push(WIM.newMSBComponent(this.task, Ext.apply({}, config.MSB, {noProcessValue:false})));
      }
    }
    if (!config.noLF) {
      if (config.displayOnly || config.LFDisplayOnly) {
        this.LF = new WIM.MarktpartnerDisplayField(Ext.apply({}, config.LF, {task:config.task, name:'lf', role:'lf', fieldLabel:'LF', noProcessValue:false, sdZaehlpunkt:this.zaehlpunkt}));
      } else {
        this.LF = WIM.newLFComponent(this.task, Ext.apply({}, config.LF, {noProcessValue:false}));
      }
    }
    if (config.OWN) {
      this.OWN = new WIM.MarktpartnerDisplayField(Ext.apply({}, config.OWN, {task:config.task, name:'own', role:'own', fieldLabel:'Mandant', noProcessValue:false, readOnly:true, hidden:true, sdZaehlpunkt:this.zaehlpunkt}));
      this.OWN.hide();
    }
    this.components = [];
    if (this.NB) {
      this.components.push(this.NB);
      this.components.push(new WIM.SpaceComponent({}));
    }
    Ext.each(this.MSBs, function(m) {
      this.components.push(m);
    }, this);
    if (this.MSBs.length > 0) {
      this.components.push(new WIM.SpaceComponent({}));
    }
    if (this.LF) {
      this.components.push(this.LF);
    }
    if (this.OWN) {
      this.components.push(this.OWN);
    }
    if (config.rooted) {
      var items = [];
      this.addFields(items);
      this.root = new Ext.form.Panel({title:'Marktpartner', scrollable:true, fieldDefaults:{labelWidth:120}, bodyPadding:'10', items:items});
    }
  }, noBackend:function() {
    if (this.displaySDOnly && this.root) {
      this.root.setDisabled(true);
    }
  }, setAllowBlankForMSBMDL:function(_) {
    Ext.each(this.MSBs, function(m) {
      m.setAllowBlank(_);
    }, this);
  }, setAllowBlankForLF:function(_) {
    if (this.LF) {
      this.LF.setAllowBlank(_);
    }
  }, setAllowBlankForAll:function(_) {
    if (this.NB) {
      this.NB.setAllowBlank(_);
    }
    this.setAllowBlankForMSBMDL(_);
    if (this.LF) {
      this.LF.setAllowBlank(_);
    }
  }, load:function(_) {
    _ = _.data.LOG;
    if (this.NB && !this.NB.noProcessValue) {
      this.NB.loadProcess(_);
    }
    Ext.each(this.MSBs, function(m) {
      if (!m.noProcessValue) {
        m.loadProcess(_);
      }
    }, this);
    if (this.LF && !this.LF.noProcessValue) {
      this.LF.loadProcess(_);
    }
    if (this.OWN && !this.OWN.noProcessValue) {
      this.OWN.loadProcess(_);
    }
  }, addComponentsToTask:function() {
    Ext.each(this.components, function(c) {
      this.task.addComponent(c);
    }, this);
  }, addFields:function(into) {
    Ext.each(this.components, function(c) {
      c.addFields(into);
    }, this);
  }, fieldsToArray:function() {
    var result = [];
    this.addFields(result);
    return result;
  }});
  WIM.MSAenderungView = Ext.extend(WIM.ProcessTabView, {load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    this.addProcessPartner(root, width);
    if (root.data.LOG.KATEGORIE !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Kategorie', width:width, value:WIM.QQQ.GED.kategorieQText(root.data.LOG.KATEGORIE)}));
    }
    if (root.data.LOG.DATUM !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUM)}));
    }
    this.root.add((new WIM.EditableList({maxLength:35, fieldLabel:'Auftrag OBIS-Kennzahlen', width:width, readOnly:true, processValue:root.data.LOG.OBISXML})).root);
    this.addLargeSpace();
    if (!this.hiddenFields.contains('ANTWORTSTATUS') && root.data.LOG.ANTWORTSTATUS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Antwortstatus', width:width, value:WIM.QQQ.GED.antwortumbauQText(root.data.LOG.ANTWORTSTATUS)}));
    }
    if (!this.hiddenFields.contains('DATUMKORRIGIERT') && root.data.LOG.DATUMKORRIGIERT !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (korrigiert)', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUMKORRIGIERT)}));
    }
    this.addLargeSpace();
    if (!this.hiddenFields.contains('DATUMVOLLZOGEN') && root.data.LOG.DATUMVOLLZOGEN !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (vollzogen)', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUMVOLLZOGEN)}));
    }
    if (!this.hiddenFields.contains('UMBAUSTATUS') && root.data.LOG.UMBAUSTATUS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Umbaustatus', width:width, value:WIM.QQQ.GED.umbaustatusQText(root.data.LOG.UMBAUSTATUS)}));
    }
    if (!this.hiddenFields.contains('UMBAUSTATUSANLASS') && root.data.LOG.UMBAUSTATUSANLASS !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Umbaustatusanlass', width:width, value:WIM.QQQ.GED.umbaustatusanlassQText(root.data.LOG.UMBAUSTATUSANLASS)}));
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.GeraeteAustauschView = Ext.extend(WIM.ProcessTabView, {load:function(root) {
    var isMDL = root.data.LOG.ROLLE == 'MDL';
    var isMSB = root.data.LOG.ROLLE == 'MSB';
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    this.addPartner(root, {fieldLabel:'Mandant', prefix:'OWN'}, width);
    if (isMDL || isMSB) {
      if (!this.hiddenFields.contains('MP')) {
        this.addPartner(root, {fieldLabel:'Partner (NB)', prefix:'MP'}, width);
      }
    } else {
      this.addPartner(root, {fieldLabel:'Partner MSB(N)', prefix:'MP'}, width);
      this.addPartner(root, {fieldLabel:'Partner MSB Endablesewerte', prefix:'MSBA'}, width);
    }
    this.addSmallSpace();
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Rolle', width:width, value:WIM.dateDisplayValue(root.data.LOG.ROLLE)}));
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin', width:width, value:WIM.dateDisplayValue(root.data.LOG.DATUM)}));
    if (!isMDL) {
      if (!this.hiddenFields.contains('SPANNUNGSEBENEMESSUNG')) {
        this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Spannungsebene Messung', width:width, value:WIM.QQQ.SD.spannungsebenemessungQText(root.data.LOG.SPANNUNGSEBENEMESSUNG)}));
      }
      this.addSmallSpace();
    }
    if (!this.hiddenFields.contains('VORGANG')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Vorgang', width:width, value:root.data.LOG.VORGANG}));
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.MeldepunkteContext = Ext.extend(Object, {constructor:function(config) {
    this.store = config.store;
    this.fields = config.fields || [];
  }, hasStore:function() {
    return !!this.store;
  }, toStringArray:function(lengthOfText) {
    var result = [];
    if (this.store) {
      this.store.each(function(r) {
        var v = r.data.meldepunkt;
        if (!Ext.isEmpty(v) && (!lengthOfText || v.length == lengthOfText)) {
          result.push(v);
        } else {
          v = r.data.zaehlpunkt;
          if (!Ext.isEmpty(v) && (!lengthOfText || v.length == lengthOfText)) {
            result.push(v);
          }
        }
      });
    } else {
      Ext.each(this.fields, function(f) {
        if (f) {
          var z = f.getValue();
          if (!Ext.isEmpty(z) && (!lengthOfText || z.length == lengthOfText)) {
            result.push(z);
          }
          return false;
        }
        return true;
      });
    }
    return result;
  }});
})();
Ext.define('mpm.packages.wim.AngebotForm', {extend:'mpm.packages.wim.FormPopup', requires:['mpm.packages.wim.StubCore'], saveRecord:function(r) {
  this.form.getForm().updateRecord(r);
  if (this.baujahrRadio.getValue()) {
    r.set('baujahr', this.jahr.getValue());
    r.set('verkehrsjahr', '');
  } else if (this.verkehrsjahrRadio.getValue()) {
    r.set('baujahr', '');
    r.set('verkehrsjahr', this.jahr.getValue());
  } else {
    r.set('baujahr', '');
    r.set('verkehrsjahr', '');
  }
  r.set('seriennummern', this.seriennummern.value());
  r.set('geraetenummern', this.geraetenummern.value());
  r.set('zaehleinrichtung', null);
  r.set('wandler', null);
  r.set('mengenumwerter', null);
  r.set('kommunikationseinrichtung', null);
  r.set('technischesteuereinrichtung', null);
  r.set('smartmetergateway', null);
  r.set('steuerbox', null);
  r.set('befestigungsart', '');
  if (this.geraet) {
    if (r.data.artikelnummer == WIM.Artikelnummer.zaehleinrichtung) {
      r.set('zaehleinrichtung', this.geraet.getValue());
    } else if (r.data.artikelnummer == WIM.Artikelnummer.wandler) {
      r.set('wandler', this.geraet.getValue());
    } else if (r.data.artikelnummer == WIM.Artikelnummer.mengenumwerter) {
      r.set('mengenumwerter', {typ:this.geraet.getValue()});
    } else if (r.data.artikelnummer == WIM.Artikelnummer.kommunikationseinrichtung) {
      r.set('kommunikationseinrichtung', {typ:this.geraet.getValue()});
    } else if (r.data.artikelnummer == WIM.Artikelnummer.technischesteuereinrichtung) {
      r.set('technischesteuereinrichtung', {typ:this.geraet.getValue()});
    } else if (r.data.artikelnummer == WIM.Artikelnummer.befestigungsart) {
      r.set('befestigungsart', this.geraet.getValue());
    } else if (r.data.artikelnummer == WIM.Artikelnummer.smartmetergateway) {
      r.set('smartmetergateway', {marktlokation:this.geraet.getValue()});
    } else if (r.data.artikelnummer == WIM.Artikelnummer.steuerbox) {
      r.set('steuerbox', {marktlokation:this.geraet.getValue()});
    }
  }
}, updateBlankAndVisible:function() {
  var nummer = this.artikelnummer.getValue();
  var impossible = this.leistung.getValue() === 'Z09';
  Ext.each([this.jahr, this.anzahl, this.betrag, this.preis], function(field) {
    field.allowBlank = impossible;
  }, this);
  var visible = nummer === WIM.Artikelnummer.zaehleinrichtung || nummer === WIM.Artikelnummer.wandler || nummer === WIM.Artikelnummer.mengenumwerter || nummer === WIM.Artikelnummer.smartmetergateway;
  this.eichjahr.setVisible(visible);
  this.eichjahr.allowBlank = impossible || !visible || nummer === WIM.Artikelnummer.wandler;
  this.eichjahr.isValid();
  visible = nummer === WIM.Artikelnummer.zaehleinrichtung;
  this.messwerterfassung.setVisible(visible);
  this.messwerterfassung.allowBlank = impossible || !visible;
  this.messwerterfassung.isValid();
  var formitem;
  if (nummer === WIM.Artikelnummer.zaehleinrichtung) {
    this.form.down('[name\x3dbefestigungsart]').allowBlank = impossible;
    this.form.down('[name\x3dfernschaltung]').allowBlank = impossible;
  } else if (nummer === WIM.Artikelnummer.wandler) {
    this.form.down('[name\x3dtyp]').allowBlank = impossible;
  } else if (nummer === WIM.Artikelnummer.technischesteuereinrichtung) {
    this.form.down('[name\x3dtechnische_steuereinrichtung]').allowBlank = impossible;
  } else if (nummer === WIM.Artikelnummer.kommunikationseinrichtung) {
    this.form.down('[name\x3dkommunikations_einrichtung]').allowBlank = impossible;
  }
  this.form.getForm().isValid();
}, makeWindow:function(title, config) {
  this.form = new Ext.form.Panel({bodyPadding:'10', scrollable:true, flex:1, fieldDefaults:{labelWidth:170}, items:[this.artikelnummer = new Ext.form.ComboBox({fieldLabel:'Artikelnummer', name:'artikelnummer', allowBlank:false, width:600, forceSelection:true, triggerAction:'all', store:[[WIM.Artikelnummer.zaehleinrichtung, 'Zähleinrichtung (' + WIM.Artikelnummer.zaehleinrichtung + ')'], [WIM.Artikelnummer.wandler, 'Wandler (' + WIM.Artikelnummer.wandler + ')'], [WIM.Artikelnummer.mengenumwerter, 
  'Mengenumwerter (' + WIM.Artikelnummer.mengenumwerter + ')'], [WIM.Artikelnummer.kommunikationseinrichtung, 'Kommunikationseinrichtung (' + WIM.Artikelnummer.kommunikationseinrichtung + ')'], [WIM.Artikelnummer.technischesteuereinrichtung, 'Techn. Steuereinrichtung (' + WIM.Artikelnummer.technischesteuereinrichtung + ')'], [WIM.Artikelnummer.befestigungsart, 'Befestigungseinrichtung (' + WIM.Artikelnummer.befestigungsart + ')'], [WIM.Artikelnummer.smartmetergateway, 'Smartmeter Gateway (' + WIM.Artikelnummer.smartmetergateway + 
  ')'], [WIM.Artikelnummer.steuerbox, 'Steuerbox (' + WIM.Artikelnummer.steuerbox + ')']]}), this.jahr = new Ext.form.field.Number({allowNegative:false, allowExponential:false, allowDecimals:false, minValue:1900, maxValue:2100, fieldLabel:'Jahr', allowBlank:false, name:'baujahr'}), new Ext.form.RadioGroup({hideEmptyLabel:false, allowBlank:false, items:[this.baujahrRadio = new Ext.form.Radio({name:'jahrradio', boxLabel:'Baujahr', checked:true}), this.verkehrsjahrRadio = new Ext.form.Radio({name:'jahrradio', 
  boxLabel:'Jahr des In-den-Verkehr-Bringens'})]}), this.eichjahr = new Ext.form.field.Number({allowNegative:false, allowExponential:false, allowDecimals:false, minValue:1900, maxValue:2100, fieldLabel:'Eichgültigkeit (Jahr)', name:'eichjahr'}), this.anzahl = new Ext.form.field.Number({maxLength:35, allowNegative:false, allowExponential:false, allowDecimals:false, fieldLabel:'Anzahl', allowBlank:false, name:'anzahl'}), this.preis = new WIM.PreisFieldOptional({maxLength:35, fieldLabel:'Preis', allowBlank:false, 
  name:'preis'}), this.betrag = new WIM.PreisFieldOptional({maxLength:35, fieldLabel:'Betrag', allowBlank:false, name:'betrag'}), (this.seriennummern = new WIM.ComponentList({fieldLabel:'Seriennnummer', maxLength:35, minCount:0, maxCount:3})).root, (this.geraetenummern = new WIM.ComponentList({fieldLabel:'Gerätenummer', maxLength:70, minCount:0, maxCount:3})).root, this.leistung = new Ext.form.ComboBox({fieldLabel:'Leistung', name:'leistung', matchFieldWidth:false, allowBlank:false, width:400, forceSelection:true, 
  triggerAction:'all', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.leistungbestellposition)}), this.eigentuemer = new Ext.form.field.Text({fieldLabel:'Eigentümer', name:'eigentuemer', allowBlank:true, width:600, maxLength:35}), this.messwerterfassung = mpm.packages.wim.GeraeteForm.newMesswerterfassung()]});
  this.anzahl.on('blur', this.calculateBetrag, this);
  this.preis.on('blur', this.calculateBetrag, this);
  this.leistung.on('change', this.updateBlankAndVisible, this);
  this.leistung.on('select', this.updateBlankAndVisible, this);
  this.form.on('validitychange', function(form, valid) {
    this.commitButton.setDisabled(!valid);
  }, this);
  var lastGeraet;
  var updateGeraet = function(config) {
    this.config = config || null;
    var newGeraet = this.artikelnummer.getValue();
    if (newGeraet !== lastGeraet) {
      this.updateGeraetFields(newGeraet, this.config);
      this.updateBlankAndVisible();
    }
  };
  this.updateBlankAndVisible();
  this.artikelnummer.on('select', updateGeraet, this);
  this.artikelnummer.on('change', updateGeraet, this);
  this.createCommitCancelButtons();
  this.createFormWindow(this.mode == 'create' ? 'Artikel hinzufügen' : 'Artikel bearbeiten', 650, 900);
}, calculateBetrag:function() {
  var a = this.anzahl.getValue();
  var v = parseFloat(this.preis.getValue());
  if (!isNaN(v) && a >= 0) {
    this.betrag.setValue((v * a).toFixed(2));
  }
}, updateGeraetFields:function(artikelnummer, config) {
  var f;
  var newCount = 1;
  this.config = config;
  if (artikelnummer == WIM.Artikelnummer.zaehleinrichtung) {
    f = mpm.packages.wim.GeraeteForm.newZaehleinrichtung(true);
  } else if (artikelnummer == WIM.Artikelnummer.wandler) {
    f = mpm.packages.wim.GeraeteForm.newWandler();
    newCount = 3;
  } else if (artikelnummer == WIM.Artikelnummer.mengenumwerter) {
    f = mpm.packages.wim.GeraeteForm.newMengenumwerter();
  } else if (artikelnummer == WIM.Artikelnummer.kommunikationseinrichtung) {
    f = mpm.packages.wim.GeraeteForm.newKommunikationseinrichtung();
  } else if (artikelnummer == WIM.Artikelnummer.technischesteuereinrichtung) {
    f = mpm.packages.wim.GeraeteForm.newTechnischesteuereinrichtung();
  } else if (artikelnummer == WIM.Artikelnummer.befestigungsart) {
    f = mpm.packages.wim.GeraeteForm.newBefestigungseinrichtung();
  }
  if (this.geraetFields) {
    Ext.each(this.geraetFields, function(f) {
      this.form.remove(f);
    }, this);
  }
  this.seriennummern.setMaxCount(newCount);
  this.geraetenummern.setMaxCount(newCount);
  if (f) {
    this.geraet = f;
    this.geraetFields = f.items ? f.items : [f];
  } else {
    this.geraetFields = [];
    this.geraet = undefined;
  }
  this.form.insert(this.form.items.getCount() - 1, this.geraetFields);
}, loadRecord:function() {
  var r = this.record;
  this.form.getForm().loadRecord(r);
  if (!Ext.isEmpty(r.data.baujahr)) {
    this.jahr.setValue(r.data.baujahr);
    this.baujahrRadio.setValue(true);
  } else if (!Ext.isEmpty(r.data.verkehrsjahr)) {
    this.jahr.setValue(r.data.verkehrsjahr);
    this.verkehrsjahrRadio.setValue(true);
  } else {
    this.jahr.setValue('');
    this.baujahrRadio.setValue(true);
  }
  this.seriennummern.loadValue(r.data.seriennummern);
  this.geraetenummern.loadValue(r.data.geraetenummern);
  this.updateGeraetFields(r.data.artikelnummer);
  if (this.geraet) {
    if (r.data.artikelnummer == WIM.Artikelnummer.zaehleinrichtung) {
      this.geraet.setValue(r.data.zaehleinrichtung);
    } else if (r.data.artikelnummer == WIM.Artikelnummer.wandler) {
      this.geraet.setValue(r.data.wandler);
    } else if (r.data.artikelnummer == WIM.Artikelnummer.mengenumwerter) {
      this.geraet.setValue(r.data.mengenumwerter ? r.data.mengenumwerter.typ : '');
    } else if (r.data.artikelnummer == WIM.Artikelnummer.kommunikationseinrichtung) {
      this.geraet.setValue(r.data.kommunikationseinrichtung ? r.data.kommunikationseinrichtung.typ : '');
    } else if (r.data.artikelnummer == WIM.Artikelnummer.technischesteuereinrichtung) {
      this.geraet.setValue(r.data.technischesteuereinrichtung ? r.data.technischesteuereinrichtung.typ : '');
    } else if (r.data.artikelnummer == WIM.Artikelnummer.befestigungsart) {
      this.geraet.setValue(r.data.befestigungsart ? r.data.befestigungsart : '');
    } else if (r.data.artikelnummer == WIM.Artikelnummer.smartmetergateway) {
      this.geraet.setValue(r.data.smartmetergateway ? r.data.smartmetergateway.marktlokation : '');
    } else if (r.data.artikelnummer == WIM.Artikelnummer.steuerbox) {
      this.geraet.setValue(r.data.steuerbox ? r.data.steuerbox.marktlokation : '');
    }
  }
  this.updateBlankAndVisible();
}, create:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'create';
  this.makeWindow('Erzeugen');
  this.loadRecord();
  this.window.show();
}, edit:function(record) {
  this.record = record;
  this.mode = 'edit';
  this.makeWindow('Bearbeiten');
  this.loadRecord();
  this.window.show();
}});
Ext.define('mpm.packages.wim.DetailPanel', {extend:'Ext.panel.Panel', alias:'widget.wimDetailPanel', scrollable:true, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var m = BpcCommon.Api.getActiveModuleId();
  var url, prefix, processIdKey;
  try {
    prefix = BpcCommon.Api.getSetting(m, 'inubit_dbTablePrefix');
    processIdKey = BpcCommon.Api.getSetting(m, 'column_id');
    url = BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(m, 'inubit_proxyId'));
  } catch (e) {
    Ext.log({level:'error', msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true});
  }
  if (window.WIM && url && this.record) {
    var wimContext = Ext.create('mpm.packages.wim.WIMContext', {baseURL:url});
    var map = {WIM_MKO_NACHRICHTEN_:'InterchangeMessagePanel', WIM_MSB_ANMELDUNGEN_:'MSBBeginnMessagePanel', WIM_MSB_ABMELDUNGEN_:'MSBEndeMessagePanel', WIM_MSB_KUENDIGUNGEN_:'MSBKuendigungMessagePanel', WIM_GER_AUSTAUSCH_:'GERAustauschMessagePanel', WIM_GER_WECHSEL_:'GERWechselMessagePanel', WIM_GER_UEBERNAHME_:'GERUebernahmeMessagePanel', WIM_GED_MSAENDERUNGEN_:'GEDMSAenderungMessagePanel', WIM_GED_MESSWERTE_:'GEDMesswerteMessagePanel', WIM_GED_LASTGANG_:'GEDLastgangMessagePanel', WIM_GED_SDAENDERUNGEN_:'GEDSDAenderungMessagePanel', 
    WIM_GED_SDANFRAGEN_:'GEDSDAnfrageMessagePanel', WIM_STM_MELDUNGEN_:'STMMeldungMessagePanel', WIM_STM_INFORMATIONEN_:'STMInformationMessagePanel', WIM_MDL_ANMELDUNGEN_:'MDLBeginnMessagePanel', WIM_MDL_ABMELDUNGEN_:'MDLEndeMessagePanel', WIM_MDL_KUENDIGUNGEN_:'MDLKuendigungMessagePanel', WIM_MDL_WECHSEL_:'MDLWechselMessagePanel', WIM_MSB_WECHSEL_:'MSBWechselMessagePanel'};
    var panelName = map[prefix.toUpperCase()];
    if (!panelName) {
      var prefix2 = Ext.valueFrom(this.record.data.PROCESSPREFIX, this.record.data.processprefix);
      if (!Ext.isEmpty(prefix2)) {
        prefix = String(prefix2).toUpperCase();
        panelName = map[prefix];
      }
    }
    var panelClass = WIM[panelName] || WIM.MessagePanel;
    this.messagePanel = Ext.create(panelClass, {wimContext:wimContext, process:Ext.create('WIM.Process', {prefix:prefix, processID:this.record.get(processIdKey)})});
    this.items = this.messagePanel.items;
    this.callParent(arguments);
  } else {
    this.callParent(arguments);
    this.showError('WIM-Detailansicht - anscheinend fehlende Berechtigungen oder Fehlkonfiguration. Bitte wenden Sie sich an den Administrator.');
  }
}, afterRender:function() {
  this.callParent(arguments);
  if (this.messagePanel) {
    this.messagePanel.requestData(this.up('window') || this);
  }
}, showError:function(message) {
  this.removeAll();
  this.add({padding:5, xtype:'displayfield', htmlEncode:true, value:message});
}});
Ext.define('mpm.packages.wim.GeraeteForm', {extend:'mpm.packages.wim.FormPopup', requires:['mpm.packages.wim.StubCore'], constructor:function(config) {
  this.callParent(arguments);
  this.meldepunkteContext = config.meldepunkteContext || new WIM.MeldepunkteContext({});
  this.zaehlernummern = config.zaehlernummern;
  this.smartmetergatewaynummern = config.smartmetergatewaynummern;
  this.canOnlyZaehlernummer = !!config.canOnlyZaehlernummer;
  this.taskdata = config.taskdata || null;
}, saveRecord:function(r) {
  r.set('art', this.art.getValue());
  r.set('refzaehleinrichtungen', this.refzaehleinrichtungen.value());
  r.set('refzaehleinrichtungenSmartmeter', this.refzaehleinrichtungenSmartmeter.value());
  r.set('geraetenummern', this.geraetenummern.value());
  if (this.geraet) {
    if (r.data.art == 'zaehleinrichtung') {
      var e = this.geraet.getValue();
      e.messwerterfassung = this.messwerterfassung.getValue();
      e.befestigungsart = this.befestigungsart.getValue();
      r.set('eigenschaften', e);
    } else if (r.data.art == 'wandler') {
      r.set('eigenschaften', this.geraet.getValue());
    } else if (r.data.art == 'mengenumwerter') {
      r.set('eigenschaften', {typ:this.geraet.getValue()});
    } else if (r.data.art == 'kommunikationseinrichtung') {
      r.set('eigenschaften', {typ:this.geraet.getValue()});
    } else if (r.data.art == 'technischesteuereinrichtung') {
      r.set('eigenschaften', {typ:this.geraet.getValue()});
    } else if (r.data.art == 'smartmetergateway') {
      r.set('eigenschaften', {marktlokation:this.geraet.getValue()});
    } else if (r.data.art == 'steuerbox') {
      r.set('eigenschaften', {marktlokation:this.geraet.getValue()});
    }
  }
}, addToStore:function(record) {
  var store = this.store;
  var order = ['zaehleinrichtung', 'wandler', 'mengenumwerter', 'kommunikationseinrichtung', 'technischesteuereinrichtung', 'smartmetergateway', 'steuerbox'];
  var art = record.data.art;
  var artIndex = order.indexOf(art);
  var inserted = false;
  store.each(function(r, index) {
    var i = order.indexOf(r.data.art);
    if (i > artIndex) {
      store.insert(index, record);
      inserted = true;
      return false;
    }
    return true;
  }, this);
  if (!inserted) {
    store.add(record);
  }
}, makeWindow:function(title) {
  var labelWidth = 170;
  this.form = new Ext.form.Panel({bodyPadding:'10', flex:1, fieldDefaults:{labelWidth:labelWidth}, scrollable:true, items:[this.art = new Ext.form.ComboBox({fieldLabel:'Art', readOnly:this.mode == 'edit', name:'art', allowBlank:false, width:400 + labelWidth, forceSelection:true, triggerAction:'all', store:[['zaehleinrichtung', 'Zähleinrichtung'], ['wandler', 'Wandler'], ['mengenumwerter', 'Mengenumwerter'], ['kommunikationseinrichtung', 'Kommunikationseinrichtung'], ['technischesteuereinrichtung', 
  'Techn. Steuereinrichtung'], ['smartmetergateway', 'Smartmeter Gateway'], ['steuerbox', 'Steuerbox']]}), (this.geraetenummern = new WIM.ComponentList({fieldLabel:'Gerätenummer', maxLength:70, minCount:0, maxCount:3})).root, (this.refzaehleinrichtungen = new WIM.ComponentList({newField:function() {
    return this.newSimpleComboBox({store:this.zaehlernummern});
  }.bind(this), fieldLabel:'zug. Zählernummer', minCount:0, maxCount:0})).root, (this.refzaehleinrichtungenSmartmeter = new WIM.ComponentList({newField:function() {
    return this.newSimpleComboBox({store:this.smartmetergatewaynummern});
  }.bind(this), fieldLabel:'Nr. des Smartmeter-Gateway', minCount:0, maxCount:0})).root]});
  this.form.on('validitychange', function(form, valid) {
    this.commitButton.setDisabled(!valid);
  }, this);
  var lastGeraet;
  var updateGeraet = function() {
    var newGeraet = this.art.getValue();
    if (newGeraet !== lastGeraet) {
      this.updateGeraetFields(newGeraet, this.taskdata);
      this.form.getForm().isValid();
    }
  };
  this.art.on('select', updateGeraet, this);
  this.art.on('change', updateGeraet, this);
  this.createCommitCancelButtons();
  this.createFormWindow(this.mode == 'create' ? 'Hinzufügen' : 'Bearbeiten', 650, 530);
}, updateGeraetFields:function(art, config) {
  var ff = [];
  this.config = config;
  delete this.messwerterfassung;
  delete this.befestigungsart;
  delete this.onlyZaehlernummer;
  if (this.canOnlyZaehlernummer) {
    this.onlyZaehlernummer = new Ext.form.Checkbox({boxLabel:'nur Zählernummer erfassen'});
    this.onlyZaehlernummer.on('change', function() {
      var checked = this.onlyZaehlernummer.getValue();
      Ext.each(this.geraetFields, function(f) {
        if (f !== this.onlyZaehlernummer) {
          if (f.setAllowBlank) {
            f.setAllowBlank(checked);
          }
          f.setDisabled(checked);
          if (checked) {
            f.setValue('');
          }
        }
      }, this);
    }, this);
  }
  var refCount = this.zaehlernummern.length === 0 ? 0 : 1;
  var refMaxCount = Math.min(9, this.zaehlernummern.length);
  var refCountSmartmeter = this.smartmetergatewaynummern.length === 0 ? 0 : 1;
  var refMaxCountSmartmeter = Math.min(9, this.smartmetergatewaynummern.length);
  if (art == 'zaehleinrichtung') {
    ff = [mpm.packages.wim.GeraeteForm.newZaehleinrichtung(false, this.refzaehleinrichtungenSmartmeter, this.meldepunkteContext), this.messwerterfassung = mpm.packages.wim.GeraeteForm.newMesswerterfassung(), this.befestigungsart = mpm.packages.wim.GeraeteForm.newBefestigungsart()];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.messwerterfassung.setAllowBlank(false);
    this.befestigungsart.setAllowBlank(false);
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(1);
    if (this.taskdata != null && this.taskdata.geraetedatenView != null) {
      if (this.taskdata.geraetedatenView.isNeuanlage) {
        this.geraetenummern.setMinCount(0);
        this.geraetenummern.setMaxCount(0);
      }
    }
    this.refzaehleinrichtungen.setMinCount(0);
    this.refzaehleinrichtungen.setMaxCount(0);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(1);
  } else if (art == 'wandler') {
    ff = [mpm.packages.wim.GeraeteForm.newWandler()];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(3);
    this.refzaehleinrichtungen.setMinCount(refCount);
    this.refzaehleinrichtungen.setMaxCount(refMaxCount);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(0);
  } else if (art == 'mengenumwerter') {
    ff = [mpm.packages.wim.GeraeteForm.newMengenumwerter()];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(3);
    this.refzaehleinrichtungen.setMinCount(refCount);
    this.refzaehleinrichtungen.setMaxCount(refMaxCount);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(0);
  } else if (art == 'kommunikationseinrichtung') {
    ff = [mpm.packages.wim.GeraeteForm.newKommunikationseinrichtung()];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(1);
    this.refzaehleinrichtungen.setMinCount(refCount);
    this.refzaehleinrichtungen.setMaxCount(refMaxCount);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(0);
  } else if (art == 'technischesteuereinrichtung') {
    ff = [mpm.packages.wim.GeraeteForm.newTechnischesteuereinrichtung()];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(1);
    this.refzaehleinrichtungen.setMinCount(refCount);
    this.refzaehleinrichtungen.setMaxCount(refMaxCount);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(0);
  } else if (art == 'smartmetergateway') {
    ff = [mpm.packages.wim.GeraeteForm.newSmartmetergateway(this.config, this.meldepunkteContext)];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(1);
    this.refzaehleinrichtungen.setMinCount(0);
    this.refzaehleinrichtungen.setMaxCount(0);
    this.refzaehleinrichtungenSmartmeter.setMinCount(0);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(0);
  } else if (art == 'steuerbox') {
    ff = [mpm.packages.wim.GeraeteForm.newSteuerbox(this.meldepunkteContext)];
    if (this.onlyZaehlernummer) {
      ff.push(this.onlyZaehlernummer);
    }
    this.geraetenummern.setMinCount(1);
    this.geraetenummern.setMaxCount(1);
    this.refzaehleinrichtungen.setMinCount(refCount);
    this.refzaehleinrichtungen.setMaxCount(refMaxCount);
    this.refzaehleinrichtungenSmartmeter.setMinCount(refCountSmartmeter);
    this.refzaehleinrichtungenSmartmeter.setMaxCount(refMaxCountSmartmeter);
  }
  if (this.geraetFields) {
    Ext.each(this.geraetFields, function(f) {
      this.form.remove(f);
    }, this);
  }
  if (ff) {
    this.geraet = ff[0];
    this.geraetFields = [];
    Ext.each(ff, function(f) {
      if (f.items) {
        this.geraetFields = this.geraetFields.concat(f.items);
      } else {
        this.geraetFields.push(f);
      }
    }, this);
  } else {
    this.geraetFields = [];
    this.geraet = undefined;
  }
  Ext.each(this.geraetFields, function(f) {
    this.form.insert(this.form.items.getCount(), f);
  }, this);
  var v;
  if (this.refzaehleinrichtungen.minCount > 0 && this.zaehlernummern.length == 1) {
    v = this.refzaehleinrichtungen.value();
    if (v.length === 0 || v.length == 1 && v[0] === '') {
      this.refzaehleinrichtungen.loadValue(this.zaehlernummern);
    }
  }
  if (this.record != undefined && this.record.data.refzaehleinrichtungenSmartmeter != undefined) {
    this.refzaehleinrichtungenSmartmeter.loadValue(this.record.data.refzaehleinrichtungenSmartmeter);
  } else if (this.refzaehleinrichtungenSmartmeter.maxCount > 0 && this.smartmetergatewaynummern.length == 1) {
    v = this.refzaehleinrichtungenSmartmeter.value();
    if (v.length === 0 || v.length == 1 && v[0] === '') {
      this.refzaehleinrichtungenSmartmeter.loadValue(this.smartmetergatewaynummern);
    }
  }
}, edit:function(record) {
  this.record = record;
  this.mode = 'edit';
  this.makeWindow('Bearbeiten');
  this.form.getForm().loadRecord(record);
  this.geraetenummern.loadValue(record.data.geraetenummern);
  this.refzaehleinrichtungen.loadValue(record.data.refzaehleinrichtungen);
  this.refzaehleinrichtungenSmartmeter.loadValue(record.data.refzaehleinrichtungenSmartmeter);
  this.updateGeraetFields(record.data.art, this.taskdata);
  if (this.geraet) {
    if (record.data.art == 'zaehleinrichtung') {
      this.geraet.setValue(record.data.eigenschaften);
      this.messwerterfassung.setValue(record.data.eigenschaften.messwerterfassung);
      this.befestigungsart.setValue(record.data.eigenschaften.befestigungsart);
    } else if (record.data.art == 'wandler') {
      this.geraet.setValue(record.data.eigenschaften);
    } else if (record.data.art == 'mengenumwerter') {
      this.geraet.setValue(record.data.eigenschaften.typ);
    }
    if (record.data.art == 'kommunikationseinrichtung') {
      this.geraet.setValue(record.data.eigenschaften.typ);
    }
    if (record.data.art == 'technischesteuereinrichtung') {
      this.geraet.setValue(record.data.eigenschaften.typ);
    }
    if (record.data.art == 'smartmetergateway') {
      this.geraet.setValue(record.data.eigenschaften.marktlokation);
    }
    if (record.data.art == 'steuerbox') {
      this.geraet.setValue(record.data.eigenschaften.marktlokation);
    }
  }
  this.window.show();
}, create:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'create';
  this.makeWindow('Erzeugen');
  this.window.show();
}, statics:{newComboBox:function(config) {
  var result = new Ext.form.ComboBox(Ext.apply({}, config, {width:400 + 170, allowBlank:false, triggerAction:'all', matchFieldWidth:false, forceSelection:true}));
  result.setAllowBlank = function(_) {
    this.allowBlank = _;
    this.validate();
  };
  return result;
}, newZaehleinrichtung:function(create_befestigung, refSmartmeter, meldepunkteContext) {
  if (!meldepunkteContext) {
    meldepunkteContext = new WIM.MeldepunkteContext({});
  }
  var groesse, tarif, richtung, befestigungsart, fernschaltung, messlokation;
  var gasGroesseRequired = true;
  var meldepunktNotrequired = !meldepunkteContext.hasStore();
  var zaehlpunkte = meldepunkteContext.toStringArray(33);
  if (create_befestigung) {
    return new WIM.MultiField({mainField:mpm.packages.wim.GeraeteForm.newComboBox({name:'typ', allowBlank:false, fieldLabel:'Zählertyp', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlertyp, {textFirst:true})}), updateEnabled:function() {
      if (this.disabled) {
        Ext.each(this.items, function(n) {
          n.setDisabled(true);
        }, this);
      } else {
        this.mainField.setDisabled(false);
        if (this.mainField.getValue() === 'IVA') {
          groesse.setAllowBlank(true);
          tarif.setAllowBlank(true);
          richtung.setAllowBlank(true);
          groesse.setDisabled(false);
          tarif.setDisabled(false);
          richtung.setDisabled(false);
          groesse.setVisible(true);
        } else {
          if (refSmartmeter) {
            refSmartmeter.setMinCount(0);
            refSmartmeter.setMaxCount(this.mainField.getValue() === 'MME' ? 1 : 0);
          }
          var gas = WIM.qualifierProperty(WIM.QQQ.GER.zaehlertyp, this.mainField.getValue(), 'gas');
          if (gas) {
            groesse.setAllowBlank(!gasGroesseRequired);
            tarif.setAllowBlank(true);
            richtung.setAllowBlank(true);
            groesse.setDisabled(!gasGroesseRequired);
            tarif.setDisabled(true);
            richtung.setDisabled(true);
            groesse.setVisible(true);
          } else {
            if (this.mainField.getValue() === 'EHZ' || this.mainField.getValue() === 'MME') {
              groesse.setAllowBlank(false);
              groesse.setVisible(true);
              groesse.setDisabled(false);
            } else {
              groesse.setAllowBlank(true);
              groesse.setVisible(false);
              groesse.setDisabled(true);
            }
            tarif.setAllowBlank(false);
            richtung.setAllowBlank(false);
            tarif.setDisabled(false);
            richtung.setDisabled(false);
          }
        }
        Ext.each(this.items, function(n) {
          n.validate();
        }, this);
      }
    }, otherFields:[groesse = mpm.packages.wim.GeraeteForm.newComboBox({name:'groesse', fieldLabel:'Zählergröße', allowBlank:true, disabled:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlergroesse, {textFirst:true})}), tarif = mpm.packages.wim.GeraeteForm.newComboBox({name:'tarif', fieldLabel:'Zählertarif', allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlertarif, {textFirst:true})}), befestigungsart = mpm.packages.wim.GeraeteForm.newBefestigungsart(), richtung = mpm.packages.wim.GeraeteForm.newComboBox({name:'richtung', 
    fieldLabel:'Zählerrichtung', allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlerrichtung, {textFirst:true})}), fernschaltung = mpm.packages.wim.GeraeteForm.newComboBox({name:'fernschaltung', fieldLabel:'Fernschaltung', allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.fernschaltung, {textFirst:true})}), messlokation = mpm.packages.wim.GeraeteForm.newComboBox({name:'messlokation', fieldLabel:'Messlokation', hidden:meldepunktNotrequired && zaehlpunkte.length === 
    0, allowBlank:meldepunktNotrequired, store:zaehlpunkte})]});
  } else {
    return new WIM.MultiField({mainField:mpm.packages.wim.GeraeteForm.newComboBox({name:'typ', allowBlank:false, fieldLabel:'Zählertyp', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlertyp, {textFirst:true})}), updateEnabled:function() {
      if (this.disabled) {
        Ext.each(this.items, function(n) {
          n.setDisabled(true);
        }, this);
      } else {
        this.mainField.setDisabled(false);
        if (this.mainField.getValue() === 'IVA') {
          groesse.setAllowBlank(true);
          tarif.setAllowBlank(true);
          richtung.setAllowBlank(true);
          fernschaltung.setAllowBlank(true);
          groesse.setDisabled(false);
          tarif.setDisabled(false);
          richtung.setDisabled(false);
          fernschaltung.setDisabled(false);
        } else {
          if (refSmartmeter) {
            refSmartmeter.setMinCount(0);
            refSmartmeter.setMaxCount(this.mainField.getValue() === 'MME' ? 1 : 0);
          }
          var gas = WIM.qualifierProperty(WIM.QQQ.GER.zaehlertyp, this.mainField.getValue(), 'gas');
          if (gas) {
            groesse.setAllowBlank(!gasGroesseRequired);
            tarif.setAllowBlank(true);
            richtung.setAllowBlank(true);
            fernschaltung.setAllowBlank(true);
            groesse.setDisabled(!gasGroesseRequired);
            tarif.setDisabled(true);
            richtung.setDisabled(true);
            fernschaltung.setDisabled(true);
          } else {
            if (this.mainField.getValue() === 'EHZ' || this.mainField.getValue() === 'MME') {
              groesse.setAllowBlank(false);
              groesse.setDisabled(false);
            } else {
              groesse.setAllowBlank(true);
              groesse.setDisabled(true);
            }
            tarif.setAllowBlank(false);
            richtung.setAllowBlank(false);
            fernschaltung.setAllowBlank(false);
            tarif.setDisabled(false);
            richtung.setDisabled(false);
            fernschaltung.setDisabled(false);
          }
        }
        Ext.each(this.items, function(n) {
          n.validate();
        }, this);
      }
    }, otherFields:[groesse = mpm.packages.wim.GeraeteForm.newComboBox({name:'groesse', fieldLabel:'Zählergröße', allowBlank:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlergroesse, {textFirst:true})}), tarif = mpm.packages.wim.GeraeteForm.newComboBox({name:'tarif', fieldLabel:'Zählertarif', allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlertarif, {textFirst:true})}), richtung = mpm.packages.wim.GeraeteForm.newComboBox({name:'richtung', fieldLabel:'Zählerrichtung', allowBlank:false, 
    store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.zaehlerrichtung, {textFirst:true})}), fernschaltung = mpm.packages.wim.GeraeteForm.newComboBox({name:'fernschaltung', fieldLabel:'Fernschaltung', allowBlank:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.fernschaltung, {textFirst:true})}), messlokation = mpm.packages.wim.GeraeteForm.newComboBox({name:'messlokation', fieldLabel:'Messlokation', hidden:meldepunktNotrequired && zaehlpunkte.length === 0, allowBlank:meldepunktNotrequired, store:zaehlpunkte})]});
  }
}, newWandler:function() {
  var typ;
  var konstante;
  return new WIM.MultiField({mainField:typ = mpm.packages.wim.GeraeteForm.newComboBox({name:'typ', allowBlank:false, fieldLabel:'Wandlertyp', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.wandlertyp, {textFirst:true, obsoleteFiltered:true})}), otherFields:[konstante = new WIM.ZahlField({maxLength:35, name:'konstante', fieldLabel:'Wandlerkonstante', allowBlank:false})], updateEnabled:function() {
    if (this.disabled) {
      Ext.each(this.items, function(n) {
        n.setDisabled(true);
      }, this);
    } else {
      var needsKonstante = WIM.qualifierProperty(WIM.QQQ.GER.wandlertyp, this.mainField.getValue(), 'konstante');
      konstante.allowBlank = !needsKonstante;
    }
    Ext.each(this.items, function(n) {
      n.validate();
    }, this);
  }});
}, newMengenumwerter:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Mengenumwertertyp', allowBlank:false, name:'mengenumwertertyp', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.mengenumwertertyp, {textFirst:true})});
}, newKommunikationseinrichtung:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Kommunikationseinrichtung', allowBlank:false, name:'kommunikations_einrichtung', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.kommtyp, {textFirst:true})});
}, newTechnischesteuereinrichtung:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Technische Steuereinrichtung', allowBlank:false, name:'technische_steuereinrichtung', store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.techtyp, {textFirst:true})});
}, newSmartmetergateway:function(config, meldepunkteContext) {
  if (!meldepunkteContext) {
    meldepunkteContext = new WIM.MeldepunkteContext({});
  }
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Marktlokation', allowBlank:!meldepunkteContext.hasStore(), hidden:true, disabled:true, name:'marktlokation', store:meldepunkteContext.toStringArray(11)});
}, newSteuerbox:function(meldepunkteContext) {
  if (!meldepunkteContext) {
    meldepunkteContext = new WIM.MeldepunkteContext({});
  }
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Marktlokation', allowBlank:!meldepunkteContext.hasStore(), hidden:false, disabled:false, name:'marktlokation', store:meldepunkteContext.toStringArray(11)});
}, newBefestigungseinrichtung:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Befestigungseinrichtung', allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.befestigungsart, {textFirst:true})});
}, newBefestigungsart:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Befestigungsart', name:'befestigungsart', allowBlank:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.befestigungsart, {textFirst:true})});
}, newMesswerterfassung:function() {
  return mpm.packages.wim.GeraeteForm.newComboBox({fieldLabel:'Messwerterfassung', name:'messwerterfassung', allowBlank:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.messwerterfassung, {textFirst:true})});
}}});
Ext.define('mpm.packages.wim.MeldepunkteForm', {extend:'mpm.packages.wim.FormPopup', requires:['mpm.packages.wim.StubCore'], constructor:function(config) {
  this.callParent(arguments);
  this.diff = true;
  this.components = [];
}, makeWindow:function(title) {
  var record = this.record;
  var labelWidth = 170;
  this.form = new Ext.form.Panel({scrollable:true, flex:1, bodyPadding:'10', fieldDefaults:{labelWidth:labelWidth}});
  this.noProcessValue = this.mode === 'create';
  this.components = [];
  this.components.push(this.meldepunkttyp = new WIM.QualifierChoice({values:WIM.QQQ.SD.meldepunkttyp, name:'meldepunkttyp', fieldLabel:'Meldepunkttyp', allowBlank:false, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.meldepunkttyp_process}));
  this.meldepunkttyp.on('change', function(field, newvalue) {
    var type = field.giveValue();
    if (type == 'pbmelo') {
      this.meldepunkt.field.setDisabled(true);
      this.meldepunkt.field.setVisible(false);
      this.zaehlpunkt.field.setDisabled(false);
      this.zaehlpunkt.field.setVisible(true);
      this.zaehlpunkt.setAllowBlank(false);
      this.meldepunkt.setAllowBlank(true);
      this.referenzMeldepunktMultiMalo.field.setDisabled(false);
      this.referenzMeldepunktMultiMalo.field.setVisible(true);
      this.referenzMeldepunktMultiMalo.setAllowBlank(true);
      this.referenzMeldepunktMultiMelo.field.setDisabled(true);
      this.referenzMeldepunktMultiMelo.field.setVisible(false);
      this.referenzMeldepunktMultiMelo.setAllowBlank(true);
      this.prognosegrundlage.field.setDisabled(true);
      this.prognosegrundlage.field.setVisible(false);
      this.prognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage.field.setDisabled(true);
      this.detailsprognosegrundlage.field.setVisible(false);
      this.detailsprognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage2.field.setDisabled(true);
      this.detailsprognosegrundlage2.field.setVisible(false);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.field.setDisabled(true);
      this.arbeitleistung.field.setVisible(false);
      this.arbeitleistungmenge.field.setDisabled(true);
      this.arbeitleistungmenge.field.setVisible(false);
      this.arbeitleistungeinheit.field.setDisabled(true);
      this.arbeitleistungeinheit.field.setVisible(false);
      this.veranschlagtejahresmenge.field.setDisabled(true);
      this.veranschlagtejahresmenge.field.setVisible(false);
      this.lieferrichtung.field.setDisabled(true);
      this.lieferrichtung.field.setVisible(false);
      this.messtechnischeeinordnung.field.setDisabled(true);
      this.messtechnischeeinordnung.field.setVisible(false);
      this.arterzeugendemarktlokation.field.setDisabled(true);
      this.arterzeugendemarktlokation.field.setVisible(false);
      this.betriebszustand.field.setDisabled(false);
      this.betriebszustand.field.setVisible(true);
      this.betriebszustand.setAllowBlank(false);
      this.spannungsebeneentnahme.field.setDisabled(true);
      this.spannungsebeneentnahme.field.setVisible(false);
      this.spannungsebenemessung.field.setDisabled(false);
      this.spannungsebenemessung.field.setVisible(true);
      this.druckebeneentnahme.field.setDisabled(true);
      this.druckebeneentnahme.field.setVisible(false);
      this.gasqualitaet.field.setDisabled(false);
      this.gasqualitaet.field.setVisible(true);
      this.turnusablesung.field.setDisabled(true);
      this.turnusablesung.field.setVisible(false);
      this.turnusintervall.field.setDisabled(true);
      this.turnusintervall.field.setVisible(false);
      this.turnusablesungnb.field.setDisabled(false);
      this.turnusablesungnb.field.setVisible(true);
      this.turnusintervallnb.field.setDisabled(false);
      this.turnusintervallnb.field.setVisible(true);
      this.abrechnungsintervalllf.field.setDisabled(true);
      this.abrechnungsintervalllf.field.setVisible(false);
      this.aufteilungsmenge.field.setDisabled(true);
      this.aufteilungsmenge.field.setVisible(false);
      this.aufteilungsmenge.setAllowBlank(true);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    } else if (type == 'melo') {
      this.meldepunkt.field.setDisabled(true);
      this.meldepunkt.field.setVisible(false);
      this.zaehlpunkt.field.setDisabled(false);
      this.zaehlpunkt.field.setVisible(true);
      this.zaehlpunkt.setAllowBlank(false);
      this.meldepunkt.setAllowBlank(true);
      this.referenzMeldepunktMultiMalo.field.setDisabled(false);
      this.referenzMeldepunktMultiMalo.field.setVisible(true);
      this.referenzMeldepunktMultiMalo.setAllowBlank(true);
      this.referenzMeldepunktMultiMelo.field.setDisabled(true);
      this.referenzMeldepunktMultiMelo.field.setVisible(false);
      this.referenzMeldepunktMultiMelo.setAllowBlank(true);
      this.prognosegrundlage.field.setDisabled(true);
      this.prognosegrundlage.field.setVisible(false);
      this.prognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage.field.setDisabled(true);
      this.detailsprognosegrundlage.field.setVisible(false);
      this.detailsprognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage2.field.setDisabled(true);
      this.detailsprognosegrundlage2.field.setVisible(false);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.field.setDisabled(true);
      this.arbeitleistung.field.setVisible(false);
      this.arbeitleistungmenge.field.setDisabled(true);
      this.arbeitleistungmenge.field.setVisible(false);
      this.arbeitleistungeinheit.field.setDisabled(true);
      this.arbeitleistungeinheit.field.setVisible(false);
      this.veranschlagtejahresmenge.field.setDisabled(true);
      this.veranschlagtejahresmenge.field.setVisible(false);
      this.lieferrichtung.field.setDisabled(true);
      this.lieferrichtung.field.setVisible(false);
      this.messtechnischeeinordnung.field.setDisabled(true);
      this.messtechnischeeinordnung.field.setVisible(false);
      this.arterzeugendemarktlokation.field.setDisabled(true);
      this.arterzeugendemarktlokation.field.setVisible(false);
      this.betriebszustand.field.setDisabled(false);
      this.betriebszustand.field.setVisible(true);
      this.betriebszustand.setAllowBlank(true);
      this.spannungsebeneentnahme.field.setDisabled(true);
      this.spannungsebeneentnahme.field.setVisible(false);
      this.spannungsebenemessung.field.setDisabled(false);
      this.spannungsebenemessung.field.setVisible(true);
      this.druckebeneentnahme.field.setDisabled(true);
      this.druckebeneentnahme.field.setVisible(false);
      this.gasqualitaet.field.setDisabled(false);
      this.gasqualitaet.field.setVisible(true);
      this.turnusablesung.field.setDisabled(true);
      this.turnusablesung.field.setVisible(false);
      this.turnusintervall.field.setDisabled(true);
      this.turnusintervall.field.setVisible(false);
      this.turnusablesungnb.field.setDisabled(false);
      this.turnusablesungnb.field.setVisible(true);
      this.turnusintervallnb.field.setDisabled(false);
      this.turnusintervallnb.field.setVisible(true);
      this.abrechnungsintervalllf.field.setDisabled(true);
      this.abrechnungsintervalllf.field.setVisible(false);
      this.aufteilungsmenge.field.setDisabled(true);
      this.aufteilungsmenge.field.setVisible(false);
      this.aufteilungsmenge.setAllowBlank(true);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    } else if (type == 'tranche') {
      this.meldepunkt.field.setDisabled(false);
      this.meldepunkt.field.setVisible(true);
      this.zaehlpunkt.field.setDisabled(true);
      this.zaehlpunkt.field.setVisible(false);
      this.zaehlpunkt.setAllowBlank(true);
      this.meldepunkt.setAllowBlank(false);
      this.aufteilungsmenge.field.setDisabled(false);
      this.aufteilungsmenge.field.setVisible(true);
      this.aufteilungsmenge.setAllowBlank(false);
      this.referenzMeldepunktMultiMalo.field.setDisabled(false);
      this.referenzMeldepunktMultiMalo.field.setVisible(true);
      this.referenzMeldepunktMultiMalo.setAllowBlank(false);
      this.referenzMeldepunktMultiMelo.field.setDisabled(true);
      this.referenzMeldepunktMultiMelo.field.setVisible(false);
      this.referenzMeldepunktMultiMelo.setAllowBlank(true);
      this.prognosegrundlage.field.setDisabled(true);
      this.prognosegrundlage.field.setVisible(false);
      this.prognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage.field.setDisabled(true);
      this.detailsprognosegrundlage.field.setVisible(false);
      this.detailsprognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage2.field.setDisabled(true);
      this.detailsprognosegrundlage2.field.setVisible(false);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.field.setDisabled(true);
      this.arbeitleistung.field.setVisible(false);
      this.arbeitleistungmenge.field.setDisabled(true);
      this.arbeitleistungmenge.field.setVisible(false);
      this.arbeitleistungeinheit.field.setDisabled(true);
      this.arbeitleistungeinheit.field.setVisible(false);
      this.veranschlagtejahresmenge.field.setDisabled(true);
      this.veranschlagtejahresmenge.field.setVisible(false);
      this.lieferrichtung.field.setDisabled(true);
      this.lieferrichtung.field.setVisible(false);
      this.messtechnischeeinordnung.field.setDisabled(true);
      this.messtechnischeeinordnung.field.setVisible(false);
      this.arterzeugendemarktlokation.field.setDisabled(true);
      this.arterzeugendemarktlokation.field.setVisible(false);
      this.betriebszustand.field.setDisabled(true);
      this.betriebszustand.field.setVisible(false);
      this.betriebszustand.setAllowBlank(true);
      this.spannungsebeneentnahme.field.setDisabled(true);
      this.spannungsebeneentnahme.field.setVisible(false);
      this.spannungsebenemessung.field.setDisabled(true);
      this.spannungsebenemessung.field.setVisible(false);
      this.druckebeneentnahme.field.setDisabled(true);
      this.druckebeneentnahme.field.setVisible(false);
      this.gasqualitaet.field.setDisabled(true);
      this.gasqualitaet.field.setVisible(false);
      this.turnusablesung.field.setDisabled(true);
      this.turnusablesung.field.setVisible(false);
      this.turnusintervall.field.setDisabled(true);
      this.turnusintervall.field.setVisible(false);
      this.turnusablesungnb.field.setDisabled(true);
      this.turnusablesungnb.field.setVisible(false);
      this.turnusintervallnb.field.setDisabled(true);
      this.turnusintervallnb.field.setVisible(false);
      this.abrechnungsintervalllf.field.setDisabled(true);
      this.abrechnungsintervalllf.field.setVisible(false);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    } else if (type == 'malo') {
      this.meldepunkt.field.setDisabled(false);
      this.meldepunkt.field.setVisible(true);
      this.zaehlpunkt.field.setDisabled(true);
      this.zaehlpunkt.field.setVisible(false);
      this.zaehlpunkt.setAllowBlank(true);
      this.meldepunkt.setAllowBlank(false);
      this.referenzMeldepunktMultiMalo.field.setDisabled(true);
      this.referenzMeldepunktMultiMalo.field.setVisible(false);
      this.referenzMeldepunktMultiMalo.setAllowBlank(true);
      this.referenzMeldepunktMultiMelo.field.setDisabled(true);
      this.referenzMeldepunktMultiMelo.field.setVisible(false);
      this.referenzMeldepunktMultiMelo.setAllowBlank(true);
      this.prognosegrundlage.field.setDisabled(false);
      this.prognosegrundlage.field.setVisible(true);
      this.prognosegrundlage.setAllowBlank(false);
      this.detailsprognosegrundlage.field.setDisabled(false);
      this.detailsprognosegrundlage.field.setVisible(true);
      this.arbeitleistung.field.setDisabled(false);
      this.arbeitleistung.field.setVisible(true);
      this.arbeitleistungmenge.field.setDisabled(false);
      this.arbeitleistungmenge.field.setVisible(true);
      this.arbeitleistungeinheit.field.setDisabled(false);
      this.arbeitleistungeinheit.field.setVisible(true);
      this.veranschlagtejahresmenge.field.setDisabled(false);
      this.veranschlagtejahresmenge.field.setVisible(true);
      this.lieferrichtung.field.setDisabled(false);
      this.lieferrichtung.field.setVisible(true);
      this.messtechnischeeinordnung.field.setDisabled(false);
      this.messtechnischeeinordnung.field.setVisible(true);
      this.arterzeugendemarktlokation.field.setDisabled(false);
      this.arterzeugendemarktlokation.field.setVisible(true);
      this.betriebszustand.field.setDisabled(true);
      this.betriebszustand.field.setVisible(false);
      this.betriebszustand.setAllowBlank(true);
      this.aufteilungsmenge.field.setDisabled(true);
      this.aufteilungsmenge.field.setVisible(false);
      this.aufteilungsmenge.setAllowBlank(true);
      this.spannungsebeneentnahme.field.setDisabled(false);
      this.spannungsebeneentnahme.field.setVisible(true);
      this.spannungsebenemessung.field.setDisabled(true);
      this.spannungsebenemessung.field.setVisible(false);
      this.druckebeneentnahme.field.setDisabled(false);
      this.druckebeneentnahme.field.setVisible(true);
      this.gasqualitaet.field.setDisabled(true);
      this.gasqualitaet.field.setVisible(false);
      this.turnusablesung.field.setDisabled(false);
      this.turnusablesung.field.setVisible(true);
      this.turnusintervall.field.setDisabled(false);
      this.turnusintervall.field.setVisible(true);
      this.turnusablesungnb.field.setDisabled(true);
      this.turnusablesungnb.field.setVisible(false);
      this.turnusintervallnb.field.setDisabled(true);
      this.turnusintervallnb.field.setVisible(false);
      this.abrechnungsintervalllf.field.setDisabled(false);
      this.abrechnungsintervalllf.field.setVisible(true);
      this.normiertesProfil.field.setDisabled(false);
      this.normiertesProfil.field.setVisible(true);
      this.normiertesProfilVerfahren.field.setDisabled(false);
      this.normiertesProfilVerfahren.field.setVisible(true);
      this.normiertesProfilCode.field.setDisabled(false);
      this.normiertesProfilCode.field.setVisible(true);
      this.profilschar.field.setDisabled(false);
      this.profilschar.field.setVisible(true);
      this.profilscharVerfahren.field.setDisabled(false);
      this.profilscharVerfahren.field.setVisible(true);
      this.profilscharCode.field.setDisabled(false);
      this.profilscharCode.field.setVisible(true);
      this.klimazone.field.setDisabled(false);
      this.klimazone.field.setVisible(true);
      this.dienstanbieter.field.setDisabled(false);
      this.dienstanbieter.field.setVisible(true);
      this.klimazoneid.field.setDisabled(false);
      this.klimazoneid.field.setVisible(true);
      this.referenzprofilCode.field.setDisabled(false);
      this.referenzprofilCode.field.setVisible(true);
    }
  }, this);
  this.components.push(this.meldepunkt = new WIM.TextField({maxLength:11, minLength:11, width:300 + labelWidth, allowBlank:false, name:'meldepunkt', fieldLabel:'Marktlokations-ID', diff:false, noProcessValue:this.noProcessValue, processValue:''}));
  this.components.push(this.zaehlpunkt = new WIM.TextField({maxLength:33, minLength:33, width:300 + labelWidth, allowBlank:false, name:'zaehlpunkt', fieldLabel:'Messlokations-ID', diff:false, noProcessValue:this.noProcessValue, processValue:''}));
  this.zaehlpunkt.on('change', function(field) {
    this.meldepunkt.setAllowBlank(field.giveValue().length > 0);
  }, this);
  this.meldepunkt.on('change', function(field) {
    this.zaehlpunkt.setAllowBlank(field.giveValue().length > 0);
  }, this);
  var malos = [];
  this.store.each(function(r) {
    if (r.data.meldepunkt.toString().length != 0) {
      malos.push(r.copy());
    }
  });
  var newmalostore = new Ext.data.Store({model:this.store.model});
  newmalostore.add(malos);
  var melos = [];
  this.store.each(function(r) {
    if (r.data.zaehlpunkt.toString().length != 0) {
      melos.push(r.copy());
    }
  });
  var newmelostore = new Ext.data.Store({model:this.store.model});
  newmelostore.add(melos);
  this.components.push(this.referenzMeldepunktMultiMalo = new WIM.MultiSelect({queryMode:'local', name:'referenzMeldepunktMultiMalo', fieldLabel:'Referenz MaLo', width:250, maxheight:100, shrinkWrap:2, hidden:true, allowBlank:true, value:record.data.referenzmalomelo != undefined && record.data.referenzmalomelo != '' ? record.data.referenzmalomelo : newmalostore.getAt(0) == undefined ? '' : newmalostore.getAt(0).data.meldepunkt, store:newmalostore, valueField:'meldepunkt', displayField:'meldepunkt'}));
  this.components.push(this.referenzMeldepunktMultiMelo = new WIM.MultiSelect({queryMode:'local', name:'referenzMeldepunktMultiMelo', fieldLabel:'Referenz MeLo', width:250, maxheight:100, shrinkWrap:2, hidden:true, allowBlank:true, value:record.data.referenzmalomelo != undefined && record.data.referenzmalomelo != '' ? record.data.referenzmalomelo : newmelostore.getAt(0) == undefined ? '' : newmelostore.getAt(0).data.zaehlpunkt, store:newmelostore, valueField:'zaehlpunkt', displayField:'zaehlpunkt'}));
  this.components.push(this.prognosegrundlage = new WIM.QualifierChoice({values:WIM.QQQ.SD.prognosegrundlage, name:'prognosegrundlage', fieldLabel:'Prognosegrundlage', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:false, noProcessValue:this.noProcessValue, processValue:record.data.prognosegrundlage_process}));
  this.prognosegrundlage.on('change', function(field) {
    var value = field.giveValue();
    if (value == 'ZA6') {
      this.detailsprognosegrundlage.field.setDisabled(false);
      this.detailsprognosegrundlage.field.setVisible(true);
      this.detailsprognosegrundlage.setAllowBlank(false);
      this.normiertesProfil.field.setDisabled(false);
      this.normiertesProfil.field.setVisible(true);
      this.normiertesProfilVerfahren.field.setDisabled(false);
      this.normiertesProfilVerfahren.field.setVisible(true);
      this.normiertesProfilCode.field.setDisabled(false);
      this.normiertesProfilCode.field.setVisible(true);
      this.profilschar.field.setDisabled(false);
      this.profilschar.field.setVisible(true);
      this.profilscharVerfahren.field.setDisabled(false);
      this.profilscharVerfahren.field.setVisible(true);
      this.profilscharCode.field.setDisabled(false);
      this.profilscharCode.field.setVisible(true);
      this.klimazone.field.setDisabled(false);
      this.klimazone.field.setVisible(true);
      this.dienstanbieter.field.setDisabled(false);
      this.dienstanbieter.field.setVisible(true);
      this.klimazoneid.field.setDisabled(false);
      this.klimazoneid.field.setVisible(true);
      this.referenzprofilCode.field.setDisabled(false);
      this.referenzprofilCode.field.setVisible(true);
    } else if (value == 'ZC0') {
      this.detailsprognosegrundlage.field.setDisabled(true);
      this.detailsprognosegrundlage.field.setVisible(false);
      this.detailsprognosegrundlage.setAllowBlank(true);
      this.detailsprognosegrundlage2.field.setDisabled(true);
      this.detailsprognosegrundlage2.field.setVisible(false);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    }
  }, this);
  this.components.push(this.detailsprognosegrundlage = new WIM.QualifierChoice({values:WIM.QQQ.SD.detailsprognosegrundlage, name:'detailsprognosegrundlage', fieldLabel:'Details Prognosegrundlage', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:true, hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.detailsprognosegrundlage_process}));
  this.detailsprognosegrundlage.on('change', function(field) {
    var value = field.giveValue();
    if (value == 'E02') {
      this.detailsprognosegrundlage2.field.setDisabled(false);
      this.detailsprognosegrundlage2.field.setVisible(true);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.setAllowBlank(true);
      this.arbeitleistungmenge.setAllowBlank(true);
      this.arbeitleistungeinheit.setAllowBlank(true);
      this.veranschlagtejahresmenge.setAllowBlank(false);
      this.normiertesProfil.field.setDisabled(false);
      this.normiertesProfil.field.setVisible(true);
      this.normiertesProfilVerfahren.field.setDisabled(false);
      this.normiertesProfilVerfahren.field.setVisible(true);
      this.normiertesProfilCode.field.setDisabled(false);
      this.normiertesProfilCode.field.setVisible(true);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    } else if (value == 'E14') {
      this.detailsprognosegrundlage2.field.setDisabled(false);
      this.detailsprognosegrundlage2.field.setVisible(true);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.setAllowBlank(false);
      this.arbeitleistungmenge.setAllowBlank(false);
      this.arbeitleistungeinheit.setAllowBlank(false);
      this.veranschlagtejahresmenge.setAllowBlank(true);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(false);
      this.profilschar.field.setVisible(true);
      this.profilscharVerfahren.field.setDisabled(false);
      this.profilscharVerfahren.field.setVisible(true);
      this.profilscharCode.field.setDisabled(false);
      this.profilscharCode.field.setVisible(true);
      this.klimazone.field.setDisabled(false);
      this.klimazone.field.setVisible(true);
      this.dienstanbieter.field.setDisabled(false);
      this.dienstanbieter.field.setVisible(true);
      this.klimazoneid.field.setDisabled(false);
      this.klimazoneid.field.setVisible(true);
      this.referenzprofilCode.field.setDisabled(true);
      this.referenzprofilCode.field.setVisible(false);
    } else if (value == 'Z36') {
      this.detailsprognosegrundlage2.field.setDisabled(true);
      this.detailsprognosegrundlage2.field.setVisible(false);
      this.detailsprognosegrundlage2.setAllowBlank(true);
      this.arbeitleistung.setAllowBlank(false);
      this.arbeitleistungmenge.setAllowBlank(false);
      this.arbeitleistungeinheit.setAllowBlank(false);
      this.veranschlagtejahresmenge.setAllowBlank(true);
      this.normiertesProfil.field.setDisabled(true);
      this.normiertesProfil.field.setVisible(false);
      this.normiertesProfilVerfahren.field.setDisabled(true);
      this.normiertesProfilVerfahren.field.setVisible(false);
      this.normiertesProfilCode.field.setDisabled(true);
      this.normiertesProfilCode.field.setVisible(false);
      this.profilschar.field.setDisabled(true);
      this.profilschar.field.setVisible(false);
      this.profilscharVerfahren.field.setDisabled(true);
      this.profilscharVerfahren.field.setVisible(false);
      this.profilscharCode.field.setDisabled(true);
      this.profilscharCode.field.setVisible(false);
      this.klimazone.field.setDisabled(true);
      this.klimazone.field.setVisible(false);
      this.dienstanbieter.field.setDisabled(true);
      this.dienstanbieter.field.setVisible(false);
      this.klimazoneid.field.setDisabled(true);
      this.klimazoneid.field.setVisible(false);
      this.referenzprofilCode.field.setDisabled(false);
      this.referenzprofilCode.field.setVisible(true);
    }
  }, this);
  this.components.push(this.detailsprognosegrundlage2 = new WIM.QualifierChoice({values:WIM.QQQ.SD.detailsprognosegrundlage2, name:'detailsprognosegrundlage2', fieldLabel:'Details Prognosegrundlage 2', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:true, hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.detailsprognosegrundlage2_process}));
  this.components.push(this.arbeitleistung = new WIM.QualifierChoice({values:WIM.QQQ.SD.arbeitleistung, name:'arbeitleistung', fieldLabel:'Arbeit/Leistung', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:true, hidden:false, noProcessValue:this.noProcessValue, processValue:record.data.arbeitleistung_process}));
  this.components.push(this.arbeitleistungmenge = new WIM.TextField({allowBlank:true, hidden:false, name:'arbeitleistungmenge', fieldLabel:'Arbeit/Leistung Menge', diff:this.diff, noProcessValue:this.noProcessValue, regex:WIM.nichtnegativeZahlRegex, regexText:'Wert muss eine positive Zahl sein', processValue:record.data.arbeitleistungmenge_process}));
  this.components.push(this.arbeitleistungeinheit = new WIM.QualifierChoice({values:WIM.QQQ.SD.arbeitleistungeinheit, name:'arbeitleistungeinheit', fieldLabel:'Arbeit/Leistung Einheit', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:true, hidden:false, noProcessValue:this.noProcessValue, processValue:record.data.arbeitleistung_process}));
  this.components.push(this.veranschlagtejahresmenge = new WIM.TextField({allowBlank:true, hidden:false, name:'veranschlagtejahresmenge', fieldLabel:'Veranschlagte Jahresmenge', diff:this.diff, noProcessValue:this.noProcessValue, regex:WIM.nichtnegativeZahlRegex, regexText:'Wert muss eine positive Zahl sein', processValue:record.data.veranschlagtejahresmenge_process}));
  this.components.push(this.aufteilungsmenge = new WIM.TextField({allowBlank:true, hidden:true, name:'aufteilungsmenge', fieldLabel:'Prozentualer Anteil (%)', diff:this.diff, noProcessValue:this.noProcessValue, regex:WIM.nichtnegativeZahlRegex, regexText:'Wert muss eine positive Zahl sein', processValue:record.data.aufteilungsmenge_process}));
  this.components.push(this.lieferrichtung = new WIM.QualifierChoice({values:WIM.QQQ.SD.lieferrichtung, name:'lieferrichtung', fieldLabel:'Lieferrichtung', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:false, hidden:false, noProcessValue:this.noProcessValue, processValue:record.data.lieferrichtung_process}));
  this.lieferrichtung.on('change', function(field) {
    var value = field.giveValue();
    if (value == 'Z06') {
      this.arterzeugendemarktlokation.field.setDisabled(false);
      this.arterzeugendemarktlokation.field.setVisible(true);
      this.arterzeugendemarktlokation.setAllowBlank(false);
    } else if (value == 'Z07') {
      this.arterzeugendemarktlokation.field.setDisabled(true);
      this.arterzeugendemarktlokation.field.setVisible(false);
      this.arterzeugendemarktlokation.setAllowBlank(true);
    }
  }, this);
  this.components.push(this.messtechnischeeinordnung = new WIM.QualifierChoice({values:WIM.QQQ.SD.messtechnischeeinordnung, name:'messtechnischeeinordnung', fieldLabel:'Messtechnische Einordnung', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:false, hidden:false, noProcessValue:this.noProcessValue, processValue:record.data.messtechnischeeinordnung_process}));
  this.components.push(this.arterzeugendemarktlokation = new WIM.QualifierChoice({values:WIM.QQQ.SD.arterzeugendemarktlokation, name:'arterzeugendemarktlokation', fieldLabel:'Art erzeugende Malo', diff:this.diff, overrideWidth:300 + labelWidth, allowBlank:false, hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.arterzeugendemarktlokation_process}));
  this.components.push(this.spannungsebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebeneentnahme, name:'spannungsebeneentnahme', fieldLabel:'Spannungsebene MaLo', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.spannungsebeneentnahme_process}));
  this.components.push(this.spannungsebenemessung = new WIM.QualifierChoice({values:WIM.QQQ.SD.spannungsebenemessung, name:'spannungsebenemessung', fieldLabel:'Spannungsebene MeLo', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.spannungsebenemessung_process}));
  this.components.push(this.druckebeneentnahme = new WIM.QualifierChoice({values:WIM.QQQ.SD.druckebeneentnahme, name:'druckebeneentnahme', fieldLabel:'Druckebene MaLo', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.druckebeneentnahme_process}));
  this.components.push(this.gasqualitaet = new WIM.QualifierChoice({values:WIM.QQQ.SD.gasqualitaet, name:'gasqualitaet', fieldLabel:'Gasqualität', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.gasqualitaet_process}));
  this.components.push(this.betriebszustand = new WIM.QualifierChoice({values:WIM.QQQ.SD.betriebszustand, name:'betriebszustand', fieldLabel:'Betriebszustand', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.betriebszustand_process}));
  this.components.push(this.turnusablesung = new WIM.TextField({maxLength:8, allowBlank:true, name:'turnusablesung', fieldLabel:'Geplante Turnusablesung MSB', emptyText:'MMDD oder MMWWMMWW', diff:this.diff, noProcessValue:this.noProcessValue, regex:WIM.turnusRegex, regexText:WIM.turnusRegexError, validator:function(v) {
    if (v.length > 0) {
      if (v.length == 4) {
        if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) == 0) {
          return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) > 31) {
          return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
        }
      } else if (v.length >= 9) {
        if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) == 0) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) > 12) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) == 0) {
          return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) > 4 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) > 4) {
          return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
        }
      }
    }
    return true;
  }, processValue:record.data.turnusablesung_process}));
  this.components.push(this.turnusintervall = new WIM.QualifierChoice({values:WIM.QQQ.SD.turnusintervall, name:'turnusintervall', fieldLabel:'Turnusintervall MSB', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.turnusintervall_process}));
  this.components.push(this.abrechnungsintervalllf = new WIM.QualifierChoice({values:WIM.QQQ.SD.turnusintervall, name:'abrechnungsintervalllf', fieldLabel:'Abrechnungsintervall LF', allowBlank:false, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.abrechnungsintervalllf_process}));
  this.components.push(this.turnusablesungnb = new WIM.TextField({maxLength:8, allowBlank:true, name:'turnusablesungnb', fieldLabel:'Geplante Turnusablesung NB', emptyText:'MMDD oder MMWWMMWW', diff:this.diff, noProcessValue:this.noProcessValue, regex:WIM.turnusRegex, regexText:WIM.turnusRegexError, validator:function(v) {
    if (v.length > 0) {
      if (v.length == 4) {
        if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) == 0) {
          return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 4), 10) > 31) {
          return 'Bitte geben Sie einen Tag von 01 bis 31 ein!';
        }
      } else if (v.length >= 9) {
        if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) == 0) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 0, 2), 10) > 12 || parseInt(Ext.util.Format.substr(v, 5, 2), 10) > 12) {
          return 'Bitte geben Sie einen Monat von 01 bis 12 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) == 0 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) == 0) {
          return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
        } else if (parseInt(Ext.util.Format.substr(v, 2, 2), 10) > 4 || parseInt(Ext.util.Format.substr(v, 7, 2), 10) > 4) {
          return 'Bitte geben Sie eine Woche von 01 bis 04 ein!';
        }
      }
    }
    return true;
  }, processValue:record.data.turnusablesungnb_process}));
  this.components.push(this.turnusintervallnb = new WIM.QualifierChoice({values:WIM.QQQ.SD.turnusintervall, name:'turnusintervallnb', fieldLabel:'Turnusintervall NB', allowBlank:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.turnusintervallnb_process}));
  this.components.push(this.zaehlernummern = new WIM.TextField({allowBlank:true, name:'zaehlernummern', fieldLabel:'Zählernummern', hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.zaehlernummern_process}));
  this.components.push(this.normiertesProfil = new WIM.QualifierChoice({values:WIM.QQQ.SD.normiertesProfil, name:'normiertesProfil', fieldLabel:'Normiertes Profil', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.normiertesProfil_process}));
  this.components.push(this.normiertesProfilVerfahren = new WIM.QualifierChoice({values:WIM.QQQ.SD.normiertesProfilVerfahren, name:'normiertesProfilVerfahren', fieldLabel:'Profilverfahren', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.normiertesProfilVerfahren_process}));
  this.components.push(this.normiertesProfilCode = new WIM.TextField({allowBlank:true, name:'normiertesProfilCode', fieldLabel:'Profilcode', hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.normiertesProfilCode_process}));
  this.components.push(this.profilschar = new WIM.QualifierChoice({values:WIM.QQQ.SD.profilschar, name:'profilschar', fieldLabel:'Profilschar', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.profilschar_process}));
  this.components.push(this.profilscharVerfahren = new WIM.QualifierChoice({values:WIM.QQQ.SD.profilscharVerfahren, name:'profilscharVerfahren', fieldLabel:'Profilscharverfahren', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.profilscharVerfahren_process}));
  this.components.push(this.profilscharCode = new WIM.TextField({allowBlank:true, name:'profilscharCode', fieldLabel:'Profilscharcode', hidden:true, noProcessValue:this.noProcessValue, processValue:record.data.profilscharCode_process}));
  this.components.push(this.klimazone = new WIM.QualifierChoice({values:WIM.QQQ.SD.klimazone, name:'klimazone', fieldLabel:'Klimazone/Messstelle', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.klimazone_process}));
  this.components.push(this.dienstanbieter = new WIM.QualifierChoice({values:WIM.QQQ.SD.dienstanbieter, name:'dienstanbieter', fieldLabel:'Dienstanbieter', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.dienstanbieter_process}));
  this.components.push(this.klimazoneid = new WIM.TextField({allowBlank:true, hidden:true, name:'klimazoneid', fieldLabel:'ID Klimazone/Messstelle', noProcessValue:this.noProcessValue, processValue:record.data.klimazoneid_process}));
  this.components.push(this.referenzprofilCode = new WIM.QualifierChoice({values:WIM.QQQ.SD.referenzprofilCode, name:'referenzprofilCode', fieldLabel:'Code des Referenzprofils', allowBlank:true, hidden:true, overrideWidth:300 + labelWidth, diff:this.diff, noProcessValue:this.noProcessValue, processValue:record.data.referenzprofilCode_process}));
  this.createCommitCancelButtons();
  Ext.each(this.components, function(c) {
    this.form.add(c.fieldsToArray());
  }, this);
  this.form.on('validitychange', function(form, valid) {
    this.commitButton.setDisabled(!valid);
  }, this);
  this.createFormWindow(title, 550, 950);
}, saveRecord:function(r) {
  r.beginEdit();
  r.set('meldepunkt', this.meldepunkt.giveValue());
  r.set('zaehlpunkt', this.zaehlpunkt.giveValue());
  r.set('meldepunkttyp', this.meldepunkttyp.giveValue());
  r.set('prognosegrundlage', this.prognosegrundlage.giveValue() == undefined ? '' : this.prognosegrundlage.giveValue());
  r.set('spannungsebeneentnahme', this.spannungsebeneentnahme.giveValue() == undefined ? '' : this.spannungsebeneentnahme.giveValue());
  r.set('spannungsebenemessung', this.spannungsebenemessung.giveValue() == undefined ? '' : this.spannungsebenemessung.giveValue());
  r.set('druckebeneentnahme', this.druckebeneentnahme.giveValue() == undefined ? '' : this.druckebeneentnahme.giveValue());
  r.set('gasqualitaet', this.gasqualitaet.giveValue() == undefined ? '' : this.gasqualitaet.giveValue());
  r.set('turnusablesung', this.turnusablesung.giveValue() == undefined ? '' : this.turnusablesung.giveValue());
  r.set('turnusintervall', this.turnusintervall.giveValue() == undefined ? '' : this.turnusintervall.giveValue());
  r.set('turnusablesungnb', this.turnusablesungnb.giveValue() == undefined ? '' : this.turnusablesungnb.giveValue());
  r.set('turnusintervallnb', this.turnusintervallnb.giveValue() == undefined ? '' : this.turnusintervallnb.giveValue());
  r.set('abrechnungsintervalllf', this.abrechnungsintervalllf.giveValue() == undefined ? '' : this.abrechnungsintervalllf.giveValue());
  r.set('zaehlernummern', this.zaehlernummern.giveValue() == undefined ? '' : this.zaehlernummern.giveValue());
  r.set('referenzmalomelo', this.meldepunkttyp.giveValue() == 'malo' ? this.referenzMeldepunktMultiMelo.giveValue() : this.referenzMeldepunktMultiMalo.giveValue());
  r.set('detailsprognosegrundlage', this.detailsprognosegrundlage.giveValue() == undefined ? '' : this.detailsprognosegrundlage.giveValue());
  r.set('detailsprognosegrundlage2', this.detailsprognosegrundlage2.giveValue() == undefined ? '' : this.detailsprognosegrundlage2.giveValue());
  r.set('arbeitleistung', this.arbeitleistung.giveValue() == undefined ? '' : this.arbeitleistung.giveValue());
  r.set('arbeitleistungmenge', this.arbeitleistungmenge.giveValue() == undefined ? '' : this.arbeitleistungmenge.giveValue());
  r.set('arbeitleistungeinheit', this.arbeitleistungeinheit.giveValue() == undefined ? '' : this.arbeitleistungeinheit.giveValue());
  r.set('veranschlagtejahresmenge', this.veranschlagtejahresmenge.giveValue() == undefined ? '' : this.veranschlagtejahresmenge.giveValue());
  r.set('lieferrichtung', this.lieferrichtung.giveValue() == undefined ? '' : this.lieferrichtung.giveValue());
  r.set('messtechnischeeinordnung', this.messtechnischeeinordnung.giveValue() == undefined ? '' : this.messtechnischeeinordnung.giveValue());
  r.set('arterzeugendemarktlokation', this.arterzeugendemarktlokation.giveValue() == undefined ? '' : this.arterzeugendemarktlokation.giveValue());
  r.set('betriebszustand', this.betriebszustand.giveValue() == undefined ? '' : this.betriebszustand.giveValue());
  r.set('normiertesProfil', this.normiertesProfil.giveValue() == undefined ? '' : this.normiertesProfil.giveValue());
  r.set('normiertesProfilVerfahren', this.normiertesProfilVerfahren.giveValue() == undefined ? '' : this.normiertesProfilVerfahren.giveValue());
  r.set('normiertesProfilCode', this.normiertesProfilCode.giveValue() == undefined ? '' : this.normiertesProfilCode.giveValue());
  r.set('profilschar', this.profilschar.giveValue() == undefined ? '' : this.profilschar.giveValue());
  r.set('profilscharVerfahren', this.profilscharVerfahren.giveValue() == undefined ? '' : this.profilscharVerfahren.giveValue());
  r.set('profilscharCode', this.profilscharCode.giveValue() == undefined ? '' : this.profilscharCode.giveValue());
  r.set('klimazone', this.klimazone.giveValue() == undefined ? '' : this.klimazone.giveValue());
  r.set('dienstanbieter', this.dienstanbieter.giveValue() == undefined ? '' : this.dienstanbieter.giveValue());
  r.set('klimazoneid', this.klimazoneid.giveValue() == undefined ? '' : this.klimazoneid.giveValue());
  r.set('aufteilungsmenge', this.aufteilungsmenge.giveValue() == undefined ? '' : this.aufteilungsmenge.giveValue());
  r.set('referenzprofilCode', this.referenzprofilCode.giveValue() == undefined ? '' : this.referenzprofilCode.giveValue());
  r.endEdit();
}, edit:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'edit';
  this.makeWindow('Bearbeiten');
  this.window.show();
  this.meldepunkttyp.loadSD(record.data.meldepunkttyp_sd);
  this.prognosegrundlage.loadSD(record.data.prognosegrundlage_sd);
  this.spannungsebeneentnahme.loadSD(record.data.spannungsebeneentnahme_sd);
  this.spannungsebenemessung.loadSD(record.data.spannungsebenemessung_sd);
  this.druckebeneentnahme.loadSD(record.data.druckebeneentnahme_sd);
  this.gasqualitaet.loadSD(record.data.gasqualitaet_sd);
  this.turnusablesung.loadSD(record.data.turnusablesung_sd);
  this.turnusintervall.loadSD(record.data.turnusintervall_sd);
  this.turnusablesungnb.loadSD(record.data.turnusablesungnb_sd);
  this.turnusintervallnb.loadSD(record.data.turnusintervallnb_sd);
  this.abrechnungsintervalllf.loadSD(record.data.abrechnungsintervalllf_sd);
  this.zaehlernummern.loadSD(record.data.zaehlernummern_sd);
  this.detailsprognosegrundlage.loadSD(record.data.detailsprognosegrundlage_sd);
  this.detailsprognosegrundlage2.loadSD(record.data.detailsprognosegrundlage2_sd);
  this.arbeitleistung.loadSD(record.data.arbeitleistung_sd);
  this.arbeitleistungmenge.loadSD(record.data.arbeitleistungmenge_sd);
  this.arbeitleistungeinheit.loadSD(record.data.arbeitleistungeinheit_sd);
  this.veranschlagtejahresmenge.loadSD(record.data.veranschlagtejahresmenge_sd);
  this.aufteilungsmenge.loadSD(record.data.aufteilungsmenge_sd);
  this.lieferrichtung.loadSD(record.data.lieferrichtung_sd);
  this.messtechnischeeinordnung.loadSD(record.data.messtechnischeeinordnung_sd);
  this.arterzeugendemarktlokation.loadSD(record.data.arterzeugendemarktlokation_sd);
  this.normiertesProfil.loadSD(record.data.normiertesProfil_sd);
  this.normiertesProfilVerfahren.loadSD(record.data.normiertesProfilVerfahren_sd);
  this.normiertesProfilCode.loadSD(record.data.normiertesProfilCode_sd);
  this.profilschar.loadSD(record.data.profilschar_sd);
  this.profilscharVerfahren.loadSD(record.data.profilscharVerfahren_sd);
  this.profilscharCode.loadSD(record.data.profilscharCode_sd);
  this.klimazone.loadSD(record.data.klimazone_sd);
  this.dienstanbieter.loadSD(record.data.dienstanbieter_sd);
  this.klimazoneid.loadSD(record.data.klimazoneid_sd);
  this.referenzprofilCode.loadSD(record.data.referenzprofilCode_sd);
  this.meldepunkt.load(record.data.meldepunkt);
  this.zaehlpunkt.load(record.data.zaehlpunkt);
  this.meldepunkttyp.load(record.data.meldepunkttyp);
  this.prognosegrundlage.load(record.data.prognosegrundlage);
  this.spannungsebeneentnahme.load(record.data.spannungsebeneentnahme);
  this.spannungsebenemessung.load(record.data.spannungsebenemessung);
  this.druckebeneentnahme.load(record.data.druckebeneentnahme);
  this.gasqualitaet.load(record.data.gasqualitaet);
  this.turnusablesung.load(record.data.turnusablesung);
  this.turnusintervall.load(record.data.turnusintervall);
  this.turnusablesungnb.load(record.data.turnusablesungnb);
  this.turnusintervallnb.load(record.data.turnusintervallnb);
  this.abrechnungsintervalllf.load(record.data.abrechnungsintervalllf);
  this.zaehlernummern.load(record.data.zaehlernummern);
  this.detailsprognosegrundlage.load(record.data.detailsprognosegrundlage);
  this.detailsprognosegrundlage2.load(record.data.detailsprognosegrundlage2);
  this.arbeitleistung.load(record.data.arbeitleistung);
  this.arbeitleistungmenge.load(record.data.arbeitleistungmenge);
  this.arbeitleistungeinheit.load(record.data.arbeitleistungeinheit);
  this.veranschlagtejahresmenge.load(record.data.veranschlagtejahresmenge);
  this.aufteilungsmenge.load(record.data.aufteilungsmenge);
  this.lieferrichtung.load(record.data.lieferrichtung);
  this.messtechnischeeinordnung.load(record.data.messtechnischeeinordnung);
  this.arterzeugendemarktlokation.load(record.data.arterzeugendemarktlokation);
  this.betriebszustand.load(record.data.betriebszustand);
  this.normiertesProfil.load(record.data.normiertesProfil);
  this.normiertesProfilVerfahren.load(record.data.normiertesProfilVerfahren);
  this.normiertesProfilCode.load(record.data.normiertesProfilCode);
  this.profilschar.load(record.data.profilschar);
  this.profilscharVerfahren.load(record.data.profilscharVerfahren);
  this.profilscharCode.load(record.data.profilscharCode);
  this.klimazone.load(record.data.klimazone);
  this.dienstanbieter.load(record.data.dienstanbieter);
  this.klimazoneid.load(record.data.klimazoneid);
  this.referenzprofilCode.load(record.data.referenzprofilCode);
}, create:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'create';
  this.makeWindow('Hinzufügen');
  this.window.show();
}});
Ext.define('mpm.packages.wim.MesswerteForm', {extend:'mpm.packages.wim.FormPopup', requires:['mpm.packages.wim.StubCore'], constructor:function(config) {
  this.callParent(arguments);
  this.withUhrzeit = config.withUhrzeit;
}, makeWindow:function(title) {
  var items = [];
  this.obis = new Ext.form.field.Text({name:'obis', allowBlank:false, fieldLabel:'OBIS-Kennzahl', maxLength:35, regex:WIM.obisRegex, regexText:WIM.obisRegexError, listeners:{scope:this, change:function(source) {
    if (this.withUhrzeit) {
      var obis = source.getValue();
      var obisregexzuordnung = /1-65:1.8.[0-9]$/;
      if (obisregexzuordnung.test(obis) || obis == '1-65:1.8.63') {
        this.uhrzeit.allowBlank = false;
        this.uhrzeit.validate();
      } else {
        this.uhrzeit.allowBlank = true;
        this.uhrzeit.validate();
      }
    }
  }, beforerender:function(source) {
    var obis = source.getValue();
    if (obis != undefined && this.withUhrzeit) {
      var obisregexzuordnung = /1-65:1.8.[0-9]$/;
      if (obisregexzuordnung.test(obis) || obis == '1-65:1.8.63') {
        this.uhrzeit.allowBlank = false;
        this.uhrzeit.validate();
      } else {
        this.uhrzeit.allowBlank = true;
        this.uhrzeit.validate();
      }
    }
  }}});
  this.datum = new Ext.form.DateField({altFormats:'c', allowBlank:false, name:'datum', width:120, maxValue:WIM.endOfToday()});
  this.uhrzeit = new Ext.form.TimeField({altFormats:'c', allowBlank:true, disabled:false, hidden:!this.withUhrzeit, format:'H:i', width:80});
  this.bis = new Ext.form.Checkbox({labelWidth:1, boxLabel:'bis'});
  this.datumbis = new Ext.form.DateField({altFormats:'c', allowBlank:false, disabled:true, name:'datumbis', width:120, maxValue:WIM.endOfToday()});
  this.uhrzeitbis = new Ext.form.TimeField({altFormats:'c', allowBlank:true, disabled:true, hidden:!this.withUhrzeit, format:'H:i', width:80});
  this.bis.on('change', function() {
    var zeitpunkt = !this.bis.getValue();
    this.datumbis.setDisabled(zeitpunkt);
    this.datumbis.validate();
    this.uhrzeitbis.setDisabled(zeitpunkt);
    this.uhrzeitbis.validate();
  }, this);
  this.wertstatus = this.newSimpleComboBox({allowBlank:false, name:'wertstatus', fieldLabel:'Wertstatus', matchFieldWidth:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.MW.wertstatus)});
  this.wert = new WIM.ZahlField({maskRe:WIM.nichtnegativeZahlMaskRegex, regex:WIM.nichtnegativeZahlRegex, allowBlank:false, name:'wert', maxLength:35, fieldLabel:'Wert'});
  var checkArray = [];
  Ext.each(WIM.qualifiersToStoreArray(WIM.QQQ.MW.messwertstatus), function(r) {
    checkArray.push({QUALIFIER:r[0], BEZEICHNUNG:r[2], BESCHREIBUNG:r[3]});
  }, this);
  var checkStore = new Ext.data.Store({model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'QUALIFIER', fields:[{name:'QUALIFIER'}, {name:'BEZEICHNUNG'}, {name:'BESCHREIBUNG'}]}), sorters:[{property:'QUALIFIER', direction:'ASC'}], data:checkArray});
  this.statuswerte = new Ext.grid.GridPanel({selModel:{type:'checkboxmodel'}, border:true, width:461, height:120, store:checkStore, columns:[{dataIndex:'QUALIFIER', header:'Qualifier', sortable:false, hideable:false, width:80, renderer:function(v, meta) {
    return Ext.String.htmlEncode(v);
  }}, {dataIndex:'BEZEICHNUNG', header:'Bezeichnung', sortable:false, hideable:false, width:300, renderer:function(v, meta, r) {
    var result = Ext.String.htmlEncode(v);
    var w = r.data.BESCHREIBUNG;
    meta.attr = '';
    if (w != v && !Ext.isEmpty(w)) {
      meta.attr += "ext:qtip\x3d'" + WIM.tooltipText(w) + "'";
    }
    return result;
  }}]});
  items = [this.obis, this.wert, new Ext.form.FieldContainer({layout:'hbox', fieldLabel:'Zeitpunkt/-raum', items:[this.datum, this.uhrzeit, new Ext.Container({width:10}), this.bis, new Ext.Container({width:10}), this.datumbis, this.uhrzeitbis]}), this.wertstatus, new Ext.Container({height:10}), Ext.create('Ext.form.FieldContainer', {fieldLabel:'Statuswerte (max. 4)', items:[this.statuswerte]})];
  this.createCommitCancelButtons();
  this.form = new Ext.form.Panel({flex:1, bodyPadding:'10', items:items, fieldDefaults:{labelWidth:170}});
  this.statuswerte.on('selectionchange', function() {
    this.commitButton.setDisabled(this.statuswerte.getSelectionModel().getCount() > 4 || !this.form.isValid());
  }, this);
  this.form.on('validitychange', function(form, valid) {
    this.commitButton.setDisabled(!valid || this.statuswerte.getSelectionModel().getCount() > 4);
  }, this);
  this.createFormWindow(this.mode == 'create' ? 'Hinzufügen' : 'Bearbeiten', 700, 365);
}, loadRecord:function(r) {
  this.obis.setValue(r.data.obis);
  this.wert.setValue(r.data.wert);
  this.wertstatus.setValue(r.data.wertstatus);
  var selected = [];
  Ext.each(r.data.statuswerte, function(v) {
    var r = this.statuswerte.store.getById(v);
    if (r) {
      selected.push(r);
    }
  }, this);
  this.statuswerte.getSelectionModel().select(selected);
  if (!Ext.isEmpty(r.data.datumvon) && !Ext.isEmpty(r.data.datumbis)) {
    this.datum.setValue(r.data.datumvon);
    this.uhrzeit.setValue(this.timeOf(r.data.datumvon));
    this.bis.setValue(true);
    this.datumbis.setValue(r.data.datumbis);
    this.uhrzeitbis.setValue(this.timeOf(r.data.datumbis));
  } else {
    if (r.data.datum.search(':') > -1) {
      this.datum.setValue(r.data.datum);
      this.uhrzeit.setValue(this.timeOf(r.data.datum));
    } else {
      this.datum.setValue(r.data.datum);
      this.uhrzeit.setValue('');
    }
    this.bis.setValue(false);
    this.datumbis.setValue('');
    this.uhrzeitbis.setValue('');
  }
}, timeOf:function(dateString) {
  var result = '';
  if (!Ext.isEmpty(dateString) && dateString.length > 10) {
    var date = Ext.Date.parse(dateString, 'c');
    if (date) {
      result = Ext.Date.format(date, 'H:i');
    }
  }
  return result;
}, dayValue:function(v) {
  return Ext.isEmpty(v) ? '' : Ext.Date.format(v, 'Y-m-d');
}, dayOrDateTimeValue:function(date, time) {
  if (Ext.isEmpty(date) || Ext.isEmpty(time)) {
    return this.dayValue(date);
  }
  var d = Ext.Date.clone(date);
  d.setHours(time.getHours());
  d.setMinutes(time.getMinutes());
  d.setSeconds(time.getSeconds());
  return Ext.Date.format(d, 'c');
}, saveRecord:function(r) {
  r.beginEdit();
  r.set('obis', this.obis.getValue());
  r.set('wert', this.wert.getValue());
  r.set('wertstatus', this.wertstatus.getValue());
  var ss = [];
  Ext.each(this.statuswerte.getSelectionModel().getSelection(), function(r) {
    ss.push(r.data.QUALIFIER);
  }, this);
  r.set('statuswerte', ss);
  if (this.bis.getValue()) {
    r.set('datum', '');
    r.set('datumvon', this.dayOrDateTimeValue(this.datum.getValue(), this.uhrzeit.getValue()));
    r.set('datumbis', this.dayOrDateTimeValue(this.datumbis.getValue(), this.uhrzeitbis.getValue()));
  } else {
    r.set('datum', this.dayOrDateTimeValue(this.datum.getValue(), this.uhrzeit.getValue()));
    r.set('datumvon', '');
    r.set('datumbis', '');
  }
  r.endEdit();
  r.commit();
}, edit:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'edit';
  this.makeWindow('Bearbeiten');
  this.loadRecord(record);
  this.window.show();
}, create:function(store, record) {
  this.store = store;
  this.record = record;
  this.mode = 'create';
  this.makeWindow('Hinzufügen');
  this.window.show();
}});
Ext.define('mpm.packages.wim.OBISForm', {extend:'mpm.packages.wim.FormPopup', requires:['mpm.packages.wim.StubCore'], constructor:function(config) {
  this.callParent(arguments);
  this.meldepunkteContext = config.meldepunkteContext;
  this.zaehlernummern = config.zaehlernummern;
  this.noZaehlwerk = !!config.noZaehlwerk;
  this.noZaehlernummern = !!config.noZaehlernummern;
  this.allowBlankZaehlernummer = this.noZaehlernummern || this.zaehlernummern.length === 0;
}, updateSchwachlastfaehig:function() {
  var v = Ext.valueFrom(this.obis.getValue(), '');
  var schwachlast;
  if (v == '1-1:1.8.0' || v == '1-1:1.8.1' || v == '1-1:2.8.0' || v == '1-65:1.8.0' || v == '1-65:1.8.1' || v == '1-65:2.8.0' || v == '1-1:1.9.0' || v == '1-1:1.9.1' || v == '1-1:2.9.0') {
    schwachlast = 'Z59';
  } else if (v == '1-1:1.8.2' || v == '1-65:1.8.2' || v == '1-1:1.9.2') {
    schwachlast = 'Z60';
  } else if (v == '1-1:1.29.0' || v == '1-1:3.29.0' || v == '1-1:2.29.0' || v == '1-1:1.6.0' || v == '1-1:2.6.0' || v == '1-1:1.29.0' || v == '1-1:3.29.0' || v == '1-1:2.29.0') {
    schwachlast = '';
  }
  if (schwachlast !== undefined) {
    this.schwachlastfaehig.setValue(schwachlast);
  }
  this.schwachlastfaehig.allowBlank = v.indexOf('1-') === -1 || v.indexOf('1.8.') === -1 || v.indexOf('2.8.') === -1;
  this.schwachlastfaehig.validate();
}, updateType:function() {
  var v = this.obistype.getValue();
  if (v == 'melo') {
    this.obis.setVisible(true);
    this.obis.bindStore(WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmelo, {noKey:true}));
    this.marktlokation.setDisabled(true);
    this.marktlokation.setVisible(false);
    this.messlokation.setDisabled(false);
    this.messlokation.setVisible(true);
    this.geraet.setDisabled(true);
    this.geraet.setVisible(false);
    this.schwachlastfaehig.setVisible(true);
    this.verbrauchsart.setVisible(false);
    this.unterbrechbarkeit.setVisible(false);
    this.waermenutzung.setVisible(false);
    this.vorkommastellen.setVisible(false);
    this.nachkommastellen.setVisible(false);
    this.marktrollerelevantLF.setVisible(false);
    this.marktrollerelevantLFZweck.setVisible(false);
    this.marktrollerelevantNB.setVisible(false);
    this.marktrollerelevantNBZweck.setVisible(false);
    this.marktrollerelevantUENB.setVisible(false);
    this.marktrollerelevantUENBZweck.setVisible(false);
  } else if (v == 'malo') {
    this.obis.setVisible(true);
    this.obis.bindStore(WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmalo, {noKey:true}));
    this.marktlokation.setDisabled(false);
    this.marktlokation.setVisible(true);
    this.messlokation.setDisabled(true);
    this.messlokation.setVisible(false);
    this.geraet.setDisabled(true);
    this.geraet.setVisible(false);
    this.schwachlastfaehig.setVisible(true);
    this.verbrauchsart.setVisible(true);
    this.unterbrechbarkeit.setVisible(true);
    this.waermenutzung.setVisible(true);
    this.vorkommastellen.setVisible(false);
    this.nachkommastellen.setVisible(false);
    this.marktrollerelevantLF.setVisible(true);
    this.marktrollerelevantLFZweck.setVisible(true);
    this.marktrollerelevantNB.setVisible(true);
    this.marktrollerelevantNBZweck.setVisible(true);
    this.marktrollerelevantUENB.setVisible(true);
    this.marktrollerelevantUENBZweck.setVisible(true);
  } else if (v == 'geraet') {
    this.obis.setVisible(true);
    this.obis.bindStore(WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmelo, {noKey:true}));
    this.marktlokation.setDisabled(true);
    this.marktlokation.setVisible(false);
    this.messlokation.setDisabled(true);
    this.messlokation.setVisible(false);
    this.geraet.setDisabled(false);
    this.geraet.setVisible(true);
    this.schwachlastfaehig.setVisible(true);
    this.verbrauchsart.setVisible(false);
    this.unterbrechbarkeit.setVisible(false);
    this.waermenutzung.setVisible(false);
    this.vorkommastellen.setVisible(true);
    this.nachkommastellen.setVisible(true);
    this.marktrollerelevantLF.setVisible(false);
    this.marktrollerelevantLFZweck.setVisible(false);
    this.marktrollerelevantNB.setVisible(false);
    this.marktrollerelevantNBZweck.setVisible(false);
    this.marktrollerelevantUENB.setVisible(false);
    this.marktrollerelevantUENBZweck.setVisible(false);
  } else if (v == 'tranche') {
    this.obis.setVisible(true);
    this.obis.bindStore(WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmalo, {noKey:true}));
    this.marktlokation.setDisabled(false);
    this.marktlokation.setVisible(true);
    this.messlokation.setDisabled(true);
    this.messlokation.setVisible(false);
    this.geraet.setDisabled(true);
    this.geraet.setVisible(false);
    this.schwachlastfaehig.setVisible(false);
    this.verbrauchsart.setVisible(false);
    this.unterbrechbarkeit.setVisible(false);
    this.waermenutzung.setVisible(false);
    this.vorkommastellen.setVisible(false);
    this.nachkommastellen.setVisible(false);
    this.marktrollerelevantLF.setVisible(true);
    this.marktrollerelevantLFZweck.setVisible(true);
    this.marktrollerelevantNB.setVisible(true);
    this.marktrollerelevantNBZweck.setVisible(true);
    this.marktrollerelevantUENB.setVisible(true);
    this.marktrollerelevantUENBZweck.setVisible(true);
  } else {
    this.obis.setVisible(false);
    this.obis.bindStore(WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmelo, {noKey:true}));
    this.marktlokation.setDisabled(true);
    this.marktlokation.setVisible(false);
    this.messlokation.setDisabled(true);
    this.messlokation.setVisible(false);
    this.geraet.setDisabled(true);
    this.geraet.setVisible(false);
    this.verbrauchsart.setVisible(false);
    this.unterbrechbarkeit.setVisible(false);
    this.waermenutzung.setVisible(false);
    this.vorkommastellen.setVisible(false);
    this.nachkommastellen.setVisible(false);
    this.marktrollerelevantLF.setVisible(false);
    this.marktrollerelevantLFZweck.setVisible(false);
    this.marktrollerelevantNB.setVisible(false);
    this.marktrollerelevantNBZweck.setVisible(false);
    this.marktrollerelevantUENB.setVisible(false);
    this.marktrollerelevantUENBZweck.setVisible(false);
  }
}, makeWindow:function(title) {
  var labelWidth = 170;
  var items = [];
  this.obis = this.newSimpleComboBox({name:'obis', regex:WIM.obisRegex, regexText:WIM.obisRegexError, fieldLabel:'OBIS-Kennzahl', allowBlank:false, hidden:true, width:300 + labelWidth, matchFieldWidth:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisidlistmelo, {noKey:true})});
  this.obis.on('change', this.updateSchwachlastfaehig, this);
  this.obistype = this.newSimpleComboBox({name:'obistype', fieldLabel:'OBIS für', allowBlank:false, width:300 + labelWidth, matchFieldWidth:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.obistype, {textFirst:true})});
  this.obistype.on('change', this.updateType, this);
  var meldepunkte = this.meldepunkteContext.toStringArray(11);
  var zaehlpunkte = this.meldepunkteContext.toStringArray(33);
  var meldepunktNotrequired = !this.meldepunkteContext.hasStore();
  var geraetenummern = [];
  this.sourceStoreGeraete.each(function(record) {
    if (record.data.art == 'zaehleinrichtung' || record.data.art == 'mengenumwerter') {
      Ext.each(record.data.geraetenummern, function(nummer) {
        geraetenummern.push(nummer);
      });
    }
  });
  this.marktlokation = this.newSimpleComboBox({name:'marktlokation', fieldLabel:'Marktlokation', hidden:true, allowBlank:meldepunktNotrequired, width:300 + labelWidth, store:meldepunkte});
  this.messlokation = this.newSimpleComboBox({name:'messlokation', fieldLabel:'Messlokation', hidden:true, allowBlank:meldepunktNotrequired, width:300 + labelWidth, store:zaehlpunkte});
  this.geraet = this.newSimpleComboBox({name:'geraet', fieldLabel:'zugeh. Gerät', hidden:true, allowBlank:false, width:300 + labelWidth, store:geraetenummern});
  this.zaehlwerk = new Ext.form.field.Text({regex:WIM.Latin1Regex, regexText:WIM.Latin1RegexError, hidden:this.noZaehlwerk, name:'zaehlwerk', width:300 + labelWidth, fieldLabel:'Zählwerk'});
  this.schwachlastfaehig = this.newSimpleComboBox({name:'schwachlastfaehig', fieldLabel:'schwachlastfähig', allowBlank:true, width:300 + labelWidth, matchFieldWidth:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.GER.schwachlastfaehig, {textFirst:true})});
  this.marktrollerelevantLF = this.newSimpleCheckBox({name:'marktrollerelevantLF', fieldLabel:'relevant für LF', allowBlank:true, width:300 + labelWidth});
  this.marktrollerelevantLFZweck = new WIM.VerwendungszweckList({fieldLabel:'Verwendungszwecke für LF', maxLength:70, minCount:0, maxCount:4});
  this.marktrollerelevantNB = this.newSimpleCheckBox({name:'marktrollerelevantNB', fieldLabel:'relevant für NB', allowBlank:true, width:300});
  this.marktrollerelevantNBZweck = new WIM.VerwendungszweckList({fieldLabel:'Verwendungszwecke für NB', maxLength:70, minCount:0, maxCount:4});
  this.marktrollerelevantUENB = this.newSimpleCheckBox({name:'marktrollerelevantUENB', fieldLabel:'relevant für ÜNB', allowBlank:true, width:300});
  this.marktrollerelevantUENBZweck = new WIM.VerwendungszweckList({fieldLabel:'Verwendungszwecke für ÜNB', maxLength:70, minCount:0, maxCount:4});
  this.verbrauchsart = this.newSimpleComboBox({name:'verbrauchsart', fieldLabel:'Verbrauchsart', allowBlank:true, width:300 + labelWidth, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.verbrauchsart, {textFirst:true})});
  this.unterbrechbarkeit = this.newSimpleComboBox({name:'unterbrechbarkeit', fieldLabel:'Unterbrechbarkeit', allowBlank:true, width:300 + labelWidth, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.unterbrechbarkeit, {textFirst:true})});
  this.waermenutzung = this.newSimpleComboBox({name:'waermenutzung', fieldLabel:'Wärmenutzung', allowBlank:true, width:300 + labelWidth, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.waermenutzung, {textFirst:true})});
  this.vorkommastellen = new Ext.form.field.Number({allowNegative:false, allowExponential:false, allowDecimals:false, allowBlank:true, maxLength:4, width:300 + labelWidth, fieldLabel:'Vorkommastellen'});
  this.nachkommastellen = new Ext.form.field.Number({allowNegative:false, allowExponential:false, allowDecimals:false, allowBlank:true, maxLength:1, width:300 + labelWidth, fieldLabel:'Nachkommastellen'});
  this.zaehlernummer = this.newSimpleComboBox({fieldLabel:'zug. Zählernummer', hidden:this.noZaehlernummern, allowBlank:this.allowBlankZaehlernummer, store:this.zaehlernummern, width:300 + labelWidth});
  items = [this.obistype, this.obis, this.marktlokation, this.messlokation, this.geraet, this.marktrollerelevantLF, this.marktrollerelevantLFZweck.root, this.marktrollerelevantNB, this.marktrollerelevantNBZweck.root, this.marktrollerelevantUENB, this.marktrollerelevantUENBZweck.root, this.zaehlwerk, this.schwachlastfaehig, this.verbrauchsart, this.unterbrechbarkeit, this.waermenutzung, this.vorkommastellen, this.nachkommastellen, this.zaehlernummer];
  this.createCommitCancelButtons();
  this.form = new Ext.form.Panel({flex:1, scrollable:true, items:items, bodyPadding:10, fieldDefaults:{labelWidth:labelWidth}});
  this.form.on('validitychange', function(form, valid) {
    this.commitButton.setDisabled(!valid);
  }, this);
  this.createFormWindow(this.mode == 'create' ? 'Hinzufügen' : 'Bearbeiten', 600, 600);
}, loadRecord:function(r) {
  this.obis.setValue(r.data.obis);
  this.obistype.setValue(r.data.obistype);
  this.marktlokation.setValue(r.data.marktlokation);
  this.messlokation.setValue(r.data.messlokation);
  this.geraet.setValue(r.data.geraet);
  this.marktrollerelevantLF.setValue(r.data.marktrollerelevantLF);
  this.marktrollerelevantLFZweck.loadValue(r.data.marktrollerelevantLFZweck);
  this.marktrollerelevantNB.setValue(r.data.marktrollerelevantNB);
  this.marktrollerelevantNBZweck.loadValue(r.data.marktrollerelevantNBZweck);
  this.marktrollerelevantUENB.setValue(r.data.marktrollerelevantUENB);
  this.marktrollerelevantUENBZweck.loadValue(r.data.marktrollerelevantUENBZweck);
  this.zaehlwerk.setValue(r.data.zaehlwerk);
  this.schwachlastfaehig.setValue(r.data.schwachlastfaehig);
  this.verbrauchsart.setValue(r.data.verbrauchsart);
  this.unterbrechbarkeit.setValue(r.data.unterbrechbarkeit);
  this.waermenutzung.setValue(r.data.waermenutzung);
  this.vorkommastellen.setValue(r.data.vorkommastellen);
  this.nachkommastellen.setValue(r.data.nachkommastellen);
  this.zaehlernummer.setValue(r.data.refzaehleinrichtung);
}, saveRecord:function(r) {
  r.beginEdit();
  r.set('obis', this.obis.getValue());
  r.set('obistype', this.obistype.getValue());
  r.set('marktlokation', this.marktlokation.getValue());
  r.set('messlokation', this.messlokation.getValue());
  r.set('geraet', this.geraet.getValue());
  r.set('marktrollerelevantLF', this.marktrollerelevantLF.getValue());
  r.set('marktrollerelevantLFZweck', this.marktrollerelevantLFZweck.value());
  r.set('marktrollerelevantNB', this.marktrollerelevantNB.getValue());
  r.set('marktrollerelevantNBZweck', this.marktrollerelevantNBZweck.value());
  r.set('marktrollerelevantUENB', this.marktrollerelevantUENB.getValue());
  r.set('marktrollerelevantUENBZweck', this.marktrollerelevantUENBZweck.value());
  r.set('zaehlwerk', this.zaehlwerk.getValue());
  r.set('schwachlastfaehig', this.schwachlastfaehig.getValue());
  r.set('verbrauchsart', this.verbrauchsart.getValue());
  r.set('unterbrechbarkeit', this.unterbrechbarkeit.getValue());
  r.set('waermenutzung', this.waermenutzung.getValue());
  r.set('vorkommastellen', this.vorkommastellen.getValue());
  r.set('nachkommastellen', this.nachkommastellen.getValue());
  r.set('refzaehleinrichtung', this.zaehlernummer.getValue());
  r.endEdit();
}, edit:function(store, record, sourceStoreMeldepunkte, sourceStoreGeraete) {
  this.store = store;
  this.sourceStoreMeldepunkte = sourceStoreMeldepunkte;
  this.sourceStoreGeraete = sourceStoreGeraete;
  this.record = record;
  this.mode = 'edit';
  this.makeWindow('Bearbeiten');
  this.loadRecord(record);
  this.window.show();
}, create:function(store, record, sourceStoreMeldepunkte, sourceStoreGeraete) {
  this.store = store;
  this.sourceStoreMeldepunkte = sourceStoreMeldepunkte;
  this.sourceStoreGeraete = sourceStoreGeraete;
  this.record = record;
  this.mode = 'create';
  this.makeWindow('Hinzufügen');
  this.window.show();
}});
Ext.define('mpm.packages.wim.StubAblesekarteView', {requires:['mpm.packages.wim.StubCore', 'mpm.packages.wim.FormPopup']});
(function() {
  WIM.AblesekarteForm = Ext.extend(mpm.packages.wim.FormPopup, {makeWindow:function(title) {
    var allwidth = 500 + 170;
    var zaehlpunkte = this.meldepunkteContext ? this.meldepunkteContext.toStringArray(33) : [];
    this.messlokation = this.newSimpleComboBox({name:'messlokation', fieldLabel:'Messlokation', allowBlank:!this.meldepunktContext, row:true, growMin:allwidth, width:allwidth, store:zaehlpunkte});
    this.typ = this.newSimpleComboBox({name:'typ', fieldLabel:'Typ', allowBlank:false, width:allwidth, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.kundentyp, {textFirst:true})});
    this.name = new Ext.form.field.Text({name:'name', allowBlank:false, maxLength:70, grow:true, growMin:allwidth, width:allwidth, fieldLabel:'Name'});
    this.vorname = new Ext.form.field.Text({name:'vorname', maxLength:70, grow:true, growMin:allwidth, width:allwidth, fieldLabel:'Vorname'});
    this.titel = new Ext.form.field.Text({name:'titel', maxLength:70, grow:true, growMin:allwidth, width:allwidth, fieldLabel:'Titel'});
    this.zusatz = new Ext.form.TextArea({name:'zusatz', maxLength:140, width:allwidth, fieldLabel:'Zusätzliche Namensangaben'});
    this.strasse = new Ext.form.field.Text({name:'strasse', maxLength:70, grow:true, growMin:allwidth, width:allwidth, allowBlank:false, fieldLabel:'Straße/Postfach'});
    this.hausnummer = new Ext.form.field.Text({name:'hausnummer', maxLength:35, grow:true, width:allwidth, growMin:allwidth, fieldLabel:'Hausnummer/Postfachnr.'});
    this.ortsteil = new Ext.form.field.Text({name:'ortsteil', maxLength:35, grow:true, growMin:allwidth, width:allwidth, fieldLabel:'Ortsteil'});
    this.ort = new Ext.form.field.Text({name:'ort', maxLength:35, grow:true, growMin:allwidth, width:allwidth, allowBlank:false, fieldLabel:'Ort'});
    this.plz = new Ext.form.field.Text({name:'plz', maxLength:35, grow:true, growMin:allwidth, width:allwidth, allowBlank:false, fieldLabel:'Postleitzahl'});
    this.land = this.newSimpleComboBox({name:'land', fieldLabel:'Land', grow:true, growMin:allwidth, width:allwidth, allowBlank:false, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.land, {noKey:true})});
    this.createCommitCancelButtons();
    this.form = new Ext.form.Panel({flex:1, scrollable:true, bodyPadding:'10', fieldDefaults:{labelWidth:170}, items:[this.messlokation, this.typ, this.name, this.vorname, this.titel, this.zusatz, this.strasse, this.hausnummer, this.plz, this.ort, this.ortsteil, this.land]});
    this.form.on('validitychange', function(form, valid) {
      this.commitButton.setDisabled(!valid);
    }, this);
    this.createFormWindow(this.mode == 'create' ? 'Hinzufügen' : 'Bearbeiten', 750, 550);
  }, loadRecord:function(r) {
    this.messlokation.setValue(r.data.messlokation);
    this.name.setValue(r.data.name);
    this.vorname.setValue(r.data.vorname);
    this.titel.setValue(r.data.titel);
    this.typ.setValue(r.data.typ);
    this.zusatz.setValue(r.data.zusatz);
    this.strasse.setValue(r.data.strasse);
    this.hausnummer.setValue(r.data.hausnummer);
    this.ortsteil.setValue(r.data.ortsteil);
    this.ort.setValue(r.data.ort);
    this.plz.setValue(r.data.plz);
    this.land.setValue(r.data.land);
  }, saveRecord:function(r) {
    r.beginEdit();
    r.set('messlokation', this.messlokation.getValue());
    r.set('name', this.name.getValue());
    r.set('vorname', this.vorname.getValue());
    r.set('titel', this.titel.getValue());
    r.set('typ', this.typ.getValue());
    r.set('zusatz', this.zusatz.getValue());
    r.set('strasse', this.strasse.getValue());
    r.set('hausnummer', this.hausnummer.getValue());
    r.set('ortsteil', this.ortsteil.getValue());
    r.set('ort', this.ort.getValue());
    r.set('plz', this.plz.getValue());
    r.set('land', this.land.getValue());
    r.endEdit();
  }, edit:function(store, record) {
    this.store = store;
    this.record = record;
    this.mode = 'edit';
    this.makeWindow('Bearbeiten');
    this.loadRecord(record);
    this.window.show();
  }, create:function(store, record) {
    this.store = store;
    this.record = record;
    this.mode = 'create';
    this.makeWindow('Hinzufügen');
    this.window.show();
  }});
  WIM.AblesekarteView = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.meldepunkteContext = config.meldepunkteContext;
    this.AblesekarteGrid = new WIM.BasicGrid({title:'Ablesekarten', columns:WIM.AblesekarteView.AblesekarteColumns, readOnly:config.readOnly, forceRow:config.forceRow, editContext:{create:function(grid) {
      (new WIM.AblesekarteForm({meldepunkteContext:this.meldepunkteContext})).create(grid.store, new grid.store.model({}));
    }.bind(this), edit:function(grid, record) {
      (new WIM.AblesekarteForm({meldepunkteContext:this.meldepunkteContext})).edit(grid.store, record);
    }.bind(this), remove:function(grid, record) {
      grid.store.remove(record);
    }}});
    this.AblesekarteGrid.on('change', function() {
      this.fireEvent('change', this);
    }, this);
    this.root = this.AblesekarteGrid.root;
  }, canAccept:function() {
    return this.AblesekarteGrid.canAccept();
  }, submitType:function() {
    return 'tuple';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.begin('ablesekarten', 'relation');
    Ext.each(this.AblesekarteGrid.getValue(), function(v) {
      x.begin('item', 'tuple');
      x.atom('messlokation', v.messlokation);
      x.atom('typ', v.typ);
      x.atom('name', v.name);
      x.atom('vorname', v.vorname);
      x.atom('titel', v.titel);
      x.atom('zusatz', v.zusatz);
      x.atom('strasse', v.strasse);
      x.atom('hausnummer', v.hausnummer);
      x.atom('plz', v.plz);
      x.atom('ort', v.ort);
      x.atom('ortsteil', v.ortsteil);
      x.atom('land', v.land);
      x.end('item');
    }, this);
    x.end('ablesekarten');
    return x.result();
  }, loadInitial:function(data, zpChanged) {
    if (!this.loaded || zpChanged) {
      this.doLoad(data);
    }
  }, load:function(data) {
    this.doLoad(data);
  }, loadSD:function(data, zpChanged) {
    this.doLoad(data);
  }, doLoad:function(data) {
    if (!data) {
      return;
    }
    this.loaded = true;
    var ablesekartenxml = [];
    Ext.each(data.ablesekarten, function(z) {
      ablesekartenxml.push({messlokation:z.messlokation, typ:z.typ, name:z.name, vorname:z.vorname, titel:z.titel, zusatz:z.zusatz, strasse:z.strasse, hausnummer:z.hausnummer, plz:z.plz, ort:z.ort, ortsteil:z.ortsteil, land:z.land});
    }, this);
    if (!this.AblesekarteGrid.hasValue()) {
      this.AblesekarteGrid.load(ablesekartenxml);
    }
  }, noBackend:function() {
    this.loaded = true;
  }});
  WIM.AblesekarteView.AblesekarteColumns = [{name:'messlokation', header:'Messlokation', width:300}, {name:'typ', header:'Typ', width:60}, {name:'name', header:'Name', width:150}, {name:'vorname', header:'Vorname', width:120}, {name:'titel', header:'Titel', width:75}, {name:'zusatz', header:'Zusatz', width:100}, {name:'strasse', header:'Straße/Postfach', width:150}, {name:'hausnummer', header:'Hausnummer/Postfachnr', width:100}, {name:'plz', header:'PLZ', width:75}, {name:'ort', header:'Ort', width:120}, 
  {name:'ortsteil', header:'Ortsteil', width:120}, {name:'land', header:'Land', width:75}];
})();
Ext.define('mpm.packages.wim.StubAdresseView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.horizontalFieldSet = function(items) {
    var newItems = items;
    return new Ext.form.FieldContainer({items:newItems, padding:'0', layout:{type:'hbox', align:'stretch'}});
  };
  WIM.Adresse = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    var labelWidth = 130;
    this.kind = config.kind;
    this.diff = config.diff;
    this.readOnly = config.readOnly;
    this.noProcessValue = config.noProcessValue;
    this.forceAdresse = !!config.forceAdresse;
    var items = [];
    var doChange = function() {
      this.fireEvent('change', this);
    };
    if (this.kind == 'ZP') {
      this.ortsteil = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, noProcessValue:this.noProcessValue, maxLength:35, width:200 + labelWidth, fieldLabel:'Ortsteil'});
      this.ortsteil.on('change', this.updateOrtsteil, this);
      this.ortsteil.on('change', doChange, this);
      this.ortsteil.addFields(items);
    }
    this.strasse = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:true, noProcessValue:this.noProcessValue, fieldLabel:'Straße/Postfach', width:260 + labelWidth, maxLength:70});
    this.strasse.on('change', doChange, this);
    this.hausnummer = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, noProcessValue:this.noProcessValue, fieldLabel:'Haus-/Postfach-Nr.', width:130 + labelWidth, maxLength:35});
    this.hausnummer.on('change', doChange, this);
    this.hausnummer.on('change', this.updateStrasse, this);
    this.plz = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, fieldLabel:'PLZ', width:130 + labelWidth, maxLength:17});
    this.plz.on('change', doChange, this);
    this.ort = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, fieldLabel:'Ort', width:150 + labelWidth, maxLength:35});
    this.ort.on('change', doChange, this);
    this.land = new WIM.QualifierChoice({values:WIM.QQQ.SD.land, name:'land', fieldLabel:'Land', readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, overrideWidth:70 + labelWidth, qualifierOptions:{noKey:true}});
    this.land.on('change', doChange, this);
    var subItems = [];
    this.strasse.addFields(subItems);
    this.hausnummer.addFields(subItems);
    subItems.push(new Ext.form.Hidden({}));
    items.push(WIM.horizontalFieldSet(subItems, 130));
    subItems = [];
    this.plz.addFields(subItems);
    this.ort.addFields(subItems);
    this.land.addFields(subItems);
    items.push(WIM.horizontalFieldSet(subItems, 130));
    if (this.kind == 'ZP') {
      this.zusatz = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, noProcessValue:this.noProcessValue, maxLength:175, width:660 + labelWidth, fieldLabel:'Zusatzinformation z. Identifizierung'});
      this.zusatz.on('change', doChange, this);
      subItems = [];
      this.zusatz.addFields(subItems);
      items.push(WIM.horizontalFieldSet(subItems, 200, 800));
    }
    this.root = new Ext.form.Panel({fieldDefaults:{labelWidth:labelWidth, labelAlign:'right'}, title:config.title, bodyPadding:'5', items:items, tbar:config.tools || undefined});
  }, setForceAdresse:function(_) {
    if (_ != this.forceAdresse) {
      this.forceAdresse = _;
      this.plz.setAllowBlank(!_);
      this.ort.setAllowBlank(!_);
      this.land.setAllowBlank(!_);
      this.updateStrasse();
    }
  }, canAccept:function() {
    return this.strasse.canAccept() && this.plz.canAccept() && this.ort.canAccept() && this.land.canAccept();
  }, updateOrtsteil:function() {
    if (this.ortsteil) {
      this.ortsteil.setAllowBlank(this.ortsteil.isReadOnly());
    }
  }, updateStrasse:function() {
    this.strasse.setAllowBlank(this.strasse.isReadOnly() || !this.forceAdresse && Ext.isEmpty(this.hausnummer.submitValue()));
    this.fireEvent('change', this);
  }, setReadOnly:function(_) {
    if (this.ortsteil) {
      this.ortsteil.setReadOnly(_);
    }
    if (this.zusatz) {
      this.zusatz.setReadOnly(_);
    }
    this.strasse.setReadOnly(_);
    this.hausnummer.setReadOnly(_);
    this.plz.setReadOnly(_);
    this.ort.setReadOnly(_);
    this.land.setReadOnly(_);
    if (!_) {
      this.updateStrasse();
      this.updateOrtsteil();
    }
  }, noBackend:function() {
    if (this.ortsteil) {
      this.ortsteil.noBackend();
    }
    if (this.zusatz) {
      this.zusatz.noBackend();
    }
    this.strasse.noBackend();
    this.hausnummer.noBackend();
    this.plz.noBackend();
    this.ort.noBackend();
    this.land.noBackend();
  }, loadSD:function(adresse, zpChanged) {
    if (!adresse) {
      adresse = {};
    }
    if (this.ortsteil) {
      this.ortsteil.loadSD(adresse.ortsteil, zpChanged);
    }
    if (this.zusatz) {
      this.zusatz.loadSD(adresse.zusatz, zpChanged);
    }
    this.strasse.loadSD(adresse.strasse, zpChanged);
    this.hausnummer.loadSD(adresse.hausnummer, zpChanged);
    this.plz.loadSD(adresse.plz, zpChanged);
    this.ort.loadSD(adresse.ort, zpChanged);
    this.land.loadSD(adresse.land, zpChanged);
    this.updateStrasse();
  }, loadProcess:function(adresse) {
    if (this.ortsteil) {
      this.ortsteil.loadProcess(adresse.ortsteil);
    }
    if (this.zusatz) {
      this.zusatz.loadProcess(adresse.zusatz);
    }
    this.strasse.loadProcess(adresse.strasse);
    this.hausnummer.loadProcess(adresse.hausnummer);
    this.plz.loadProcess(adresse.plz);
    this.ort.loadProcess(adresse.ort);
    this.land.loadProcess(adresse.land);
    this.updateStrasse();
  }, load:function(adresse) {
    if (!adresse) {
      adresse = {};
    }
    if (this.ortsteil) {
      this.ortsteil.load(adresse.ortsteil);
    }
    if (this.zusatz) {
      this.zusatz.load(adresse.zusatz);
    }
    this.strasse.load(adresse.strasse);
    this.hausnummer.load(adresse.hausnummer);
    this.plz.load(adresse.plz);
    this.ort.load(adresse.ort);
    this.land.load(adresse.land);
    this.updateStrasse();
  }, submitType:function() {
    return 'tuple';
  }, emptyValue:function() {
    var result = {};
    if (this.kind === 'ZP') {
      result.ortsteil = '';
      result.zusatz = '';
    }
    result.strasse = '';
    result.hausnummer = '';
    result.plz = '';
    result.ort = '';
    result.land = '';
    return result;
  }, copyValue:function() {
    var result = {};
    if (this.kind === 'ZP') {
      result.ortsteil = this.ortsteil.copyValue();
      result.zusatz = this.zusatz.copyValue();
    }
    result.strasse = this.strasse.copyValue();
    result.hausnummer = this.hausnummer.copyValue();
    result.plz = this.plz.copyValue();
    result.ort = this.ort.copyValue();
    result.land = this.land.copyValue();
    return result;
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    if (this.kind === 'ZP') {
      x.encodedAtom('ortsteil', this.ortsteil.submitValue());
      x.encodedAtom('zusatz', this.zusatz.submitValue());
    }
    x.encodedAtom('strasse', this.strasse.submitValue());
    x.encodedAtom('hausnummer', this.hausnummer.submitValue());
    x.encodedAtom('plz', this.plz.submitValue());
    x.encodedAtom('ort', this.ort.submitValue());
    x.encodedAtom('land', this.land.submitValue());
    return x.result();
  }, addFields:function(into) {
    into.push(this.root);
  }});
  WIM.AdresseMitKunde = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    var labelWidth = 130;
    this.kind = config.kind;
    this.diff = config.diff;
    this.readOnly = config.readOnly;
    this.noProcessValue = config.noProcessValue;
    this.forceAdresse = !!config.forceAdresse;
    this.canAlwaysReject = config.canAlwaysReject;
    this.title = Ext.valueFrom(config.title, 'Kunde des Messstellenbetreibers');
    var items = [];
    this.typField = new WIM.QualifierChoice({values:WIM.QQQ.SD.kundentyp, fieldLabel:'Typ', readOnly:this.readOnly, diff:config.diff, allowBlank:!!config.allowBlankKunde, noProcessValue:this.noProcessValue, width:100 + labelWidth, overrideWidth:100 + labelWidth});
    this.nameField = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, allowBlank:!!config.allowBlankKunde, noProcessValue:this.noProcessValue, fieldLabel:'Name', width:150 + labelWidth, maxLength:70});
    this.vorname1 = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Vorname', noProcessValue:this.noProcessValue, width:100 + labelWidth, maxLength:35});
    this.titel = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Titel', noProcessValue:this.noProcessValue, width:70 + labelWidth, maxLength:35});
    this.zusatz = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Zusatz', noProcessValue:this.noProcessValue, width:100 + labelWidth, maxLength:140});
    var kunde = [];
    this.typField.addFields(kunde);
    this.nameField.addFields(kunde);
    this.vorname1.addFields(kunde);
    this.titel.addFields(kunde);
    this.zusatz.addFields(kunde);
    items.push(WIM.horizontalFieldSet(kunde, 130));
    var doChange = function() {
      this.fireEvent('change', this);
    };
    this.typField.on('change', doChange, this);
    this.nameField.on('change', doChange, this);
    this.vorname1.on('change', doChange, this);
    this.zusatz.on('change', doChange, this);
    this.titel.on('change', doChange, this);
    this.typField.on('change', function() {
      var noFields = this.typField.submitValue() == 'Z02';
      this.vorname1.setDisabled(noFields);
      this.titel.setDisabled(noFields);
    }, this);
    if (this.kind == 'ZP') {
      this.ortsteil = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, noProcessValue:this.noProcessValue, maxLength:35, width:200 + labelWidth, fieldLabel:'Ortsteil'});
      this.ortsteil.on('change', this.updateOrtsteil, this);
      this.ortsteil.on('change', doChange, this);
      this.ortsteil.addFields(items);
    }
    this.strasse = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:true, noProcessValue:this.noProcessValue, fieldLabel:'Straße/Postfach', width:260 + labelWidth, maxLength:70});
    this.strasse.on('change', doChange, this);
    this.hausnummer = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, noProcessValue:this.noProcessValue, fieldLabel:'Haus-/Postfach-Nr.', width:130 + labelWidth, maxLength:35});
    this.hausnummer.on('change', doChange, this);
    this.hausnummer.on('change', this.updateStrasse, this);
    this.plz = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, fieldLabel:'PLZ', width:130 + labelWidth, maxLength:17});
    this.plz.on('change', doChange, this);
    this.ort = new WIM.TextField({readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, fieldLabel:'Ort', width:130 + labelWidth, maxLength:35});
    this.ort.on('change', doChange, this);
    this.land = new WIM.QualifierChoice({values:WIM.QQQ.SD.land, name:'land', fieldLabel:'Land', readOnly:this.readOnly, diff:this.diff, allowBlank:!this.forceAdresse, noProcessValue:this.noProcessValue, overrideWidth:70 + labelWidth, qualifierOptions:{noKey:true}});
    this.land.on('change', doChange, this);
    var subItems = [];
    this.strasse.addFields(subItems);
    this.hausnummer.addFields(subItems);
    subItems.push(new Ext.form.Hidden({}));
    items.push(WIM.horizontalFieldSet(subItems, 130));
    subItems = [];
    this.plz.addFields(subItems);
    this.ort.addFields(subItems);
    this.land.addFields(subItems);
    items.push(WIM.horizontalFieldSet(subItems, 130));
    this.root = new Ext.form.Panel({fieldDefaults:{labelAlign:'right', labelWidth:labelWidth}, title:config.title, bodyPadding:'5', items:items, tbar:config.tools || undefined});
  }, setForceAdresse:function(_) {
    if (_ != this.forceAdresse) {
      this.forceAdresse = _;
      this.plz.setAllowBlank(!_);
      this.ort.setAllowBlank(!_);
      this.land.setAllowBlank(!_);
      this.updateStrasse();
    }
  }, canAccept:function() {
    return this.strasse.canAccept() && this.plz.canAccept() && this.ort.canAccept() && this.land.canAccept() && this.typField.canAccept() && this.nameField.canAccept();
  }, canReject:function() {
    return this.canAlwaysReject || this.typField.canAccept() && this.nameField.canAccept();
  }, updateOrtsteil:function() {
    if (this.ortsteil) {
      this.ortsteil.setAllowBlank(this.ortsteil.isReadOnly());
    }
  }, updateStrasse:function() {
    this.strasse.setAllowBlank(this.strasse.isReadOnly() || !this.forceAdresse && Ext.isEmpty(this.hausnummer.submitValue()));
    this.fireEvent('change', this);
  }, setReadOnly:function(_) {
    if (this.ortsteil) {
      this.ortsteil.setReadOnly(_);
    }
    this.strasse.setReadOnly(_);
    this.hausnummer.setReadOnly(_);
    this.plz.setReadOnly(_);
    this.ort.setReadOnly(_);
    this.land.setReadOnly(_);
    this.typField.setReadOnly(_);
    this.nameField.setReadOnly(_);
    this.vorname1.setReadOnly(_);
    this.zusatz.setReadOnly(_);
    this.titel.setReadOnly();
    if (!_) {
      this.updateStrasse();
      this.updateOrtsteil();
    }
  }, noBackend:function() {
    if (this.ortsteil) {
      this.ortsteil.noBackend();
    }
    this.strasse.noBackend();
    this.hausnummer.noBackend();
    this.plz.noBackend();
    this.ort.noBackend();
    this.land.noBackend();
    this.typField.noBackend();
    this.nameField.noBackend();
    this.vorname1.noBackend();
    this.zusatz.noBackend();
    this.titel.noBackend();
  }, loadSD:function(adresse, zpChanged) {
    if (!adresse) {
      adresse = {};
    }
    if (this.ortsteil) {
      this.ortsteil.loadSD(adresse.ortsteil, zpChanged);
    }
    this.strasse.loadSD(adresse.strasse, zpChanged);
    this.hausnummer.loadSD(adresse.hausnummer, zpChanged);
    this.plz.loadSD(adresse.plz, zpChanged);
    this.ort.loadSD(adresse.ort, zpChanged);
    this.land.loadSD(adresse.land, zpChanged);
    this.typField.loadSD(adresse.typ, zpChanged);
    this.nameField.loadSD(adresse.name, zpChanged);
    this.vorname1.loadSD(adresse.vorname1, zpChanged);
    this.zusatz.loadSD(adresse.zusatz, zpChanged);
    this.titel.loadSD(adresse.titel, zpChanged);
    this.updateStrasse();
  }, loadProcess:function(adresse) {
    if (this.ortsteil) {
      this.ortsteil.loadProcess(adresse.ortsteil);
    }
    this.strasse.loadProcess(adresse.strasse);
    this.hausnummer.loadProcess(adresse.hausnummer);
    this.plz.loadProcess(adresse.plz);
    this.ort.loadProcess(adresse.ort);
    this.land.loadProcess(adresse.land);
    if (adresse.typ != '') {
      this.typField.loadProcess(adresse.typ);
    }
    this.nameField.loadProcess(adresse.name);
    this.vorname1.loadProcess(adresse.vorname1);
    this.zusatz.loadProcess(adresse.zusatz);
    this.titel.loadProcess(adresse.titel);
    this.updateStrasse();
  }, load:function(adresse) {
    if (!adresse) {
      adresse = {};
    }
    if (this.ortsteil) {
      this.ortsteil.load(adresse.ortsteil);
    }
    this.strasse.load(adresse.strasse);
    this.hausnummer.load(adresse.hausnummer);
    this.plz.load(adresse.plz);
    this.ort.load(adresse.ort);
    this.land.load(adresse.land);
    if (adresse.typ != '') {
      this.typField.load(adresse.typ);
    }
    this.typField.load(adresse.typ);
    this.nameField.load(adresse.name);
    this.vorname1.load(adresse.vorname1);
    this.zusatz.load(adresse.zusatz);
    this.titel.load(adresse.titel);
    this.updateStrasse();
  }, submitType:function() {
    return 'tuple';
  }, emptyValue:function() {
    var result = {};
    if (this.kind === 'ZP') {
      result.ortsteil = '';
    }
    result.strasse = '';
    result.hausnummer = '';
    result.plz = '';
    result.ort = '';
    result.land = '';
    return result;
  }, copyValue:function() {
    var result = {};
    if (this.kind === 'ZP') {
      result.ortsteil = this.ortsteil.copyValue();
    }
    result.strasse = this.strasse.copyValue();
    result.hausnummer = this.hausnummer.copyValue();
    result.plz = this.plz.copyValue();
    result.ort = this.ort.copyValue();
    result.land = this.land.copyValue();
    return result;
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.encodedAtom('typ', this.typField.submitValue());
    x.encodedAtom('name', this.nameField.submitValue());
    var noFields = this.typField.submitValue() == 'Z02';
    if (noFields) {
      x.atom('vorname1', '');
      x.atom('titel', '');
      x.atom('zusatz', '');
    } else {
      x.encodedAtom('vorname1', this.vorname1.submitValue());
      x.encodedAtom('titel', this.titel.submitValue());
      x.encodedAtom('zusatz', this.zusatz.submitValue());
    }
    if (this.kind === 'ZP') {
      x.encodedAtom('ortsteil', this.ortsteil.submitValue());
    }
    x.encodedAtom('strasse', this.strasse.submitValue());
    x.encodedAtom('hausnummer', this.hausnummer.submitValue());
    x.encodedAtom('plz', this.plz.submitValue());
    x.encodedAtom('ort', this.ort.submitValue());
    x.encodedAtom('land', this.land.submitValue());
    return x.result();
  }, addFields:function(into) {
    into.push(this.root);
  }});
  WIM.Kunde = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    var labelWidth = 100;
    this.canAlwaysReject = config.canAlwaysReject;
    this.readOnly = config.readOnly;
    this.noProcessValue = config.noProcessValue;
    this.title = config.title;
    this.typField = new WIM.QualifierChoice({values:WIM.QQQ.SD.kundentyp, fieldLabel:'Typ', readOnly:this.readOnly, diff:config.diff, allowBlank:!!config.allowBlankKunde, noProcessValue:this.noProcessValue, width:100 + labelWidth, overrideWidth:100 + labelWidth});
    this.nameField = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, allowBlank:!!config.allowBlankKunde, noProcessValue:this.noProcessValue, fieldLabel:'Name', width:150 + labelWidth, maxLength:70});
    this.vorname1 = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Vorname', noProcessValue:this.noProcessValue, width:100 + labelWidth, maxLength:35});
    this.titel = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Titel', noProcessValue:this.noProcessValue, width:70 + labelWidth, maxLength:35});
    this.zusatz = new WIM.TextField({diff:config.diff, readOnly:this.readOnly, fieldLabel:'Zusatz', noProcessValue:this.noProcessValue, width:100 + labelWidth, maxLength:140});
    var kunde = [];
    this.typField.addFields(kunde);
    this.nameField.addFields(kunde);
    this.vorname1.addFields(kunde);
    this.titel.addFields(kunde);
    this.zusatz.addFields(kunde);
    var doChange = function() {
      this.fireEvent('change', this);
    };
    this.typField.on('change', doChange, this);
    this.nameField.on('change', doChange, this);
    this.vorname1.on('change', doChange, this);
    this.zusatz.on('change', doChange, this);
    this.titel.on('change', doChange, this);
    this.typField.on('change', function() {
      var noFields = this.typField.submitValue() == 'Z02';
      this.vorname1.setDisabled(noFields);
      this.titel.setDisabled(noFields);
    }, this);
    this.root = new Ext.form.Panel({fieldDefaults:{labelAlign:'right', labelWidth:labelWidth}, bodyPadding:'5', padding:'0', title:this.title, items:[WIM.horizontalFieldSet(kunde, 100, 235)]});
  }, loadSD:function(kunde, zpChanged) {
    if (!kunde) {
      kunde = {};
    }
    this.typField.loadSD(kunde.typ, zpChanged);
    this.nameField.loadSD(kunde.name, zpChanged);
    this.vorname1.loadSD(kunde.vorname1, zpChanged);
    this.zusatz.loadSD(kunde.zusatz, zpChanged);
    this.titel.loadSD(kunde.titel, zpChanged);
  }, noBackend:function() {
    this.typField.noBackend();
    this.nameField.noBackend();
    this.vorname1.noBackend();
    this.zusatz.noBackend();
    this.titel.noBackend();
  }, loadProcess:function(kunde) {
    this.typField.loadProcess(kunde.typ);
    this.nameField.loadProcess(kunde.name);
    this.vorname1.loadProcess(kunde.vorname1);
    this.zusatz.loadProcess(kunde.zusatz);
    this.titel.loadProcess(kunde.titel);
  }, load:function(kunde) {
    if (!kunde) {
      kunde = {};
    }
    this.typField.load(kunde.typ);
    this.nameField.load(kunde.name);
    this.vorname1.load(kunde.vorname1);
    this.zusatz.load(kunde.zusatz);
    this.titel.load(kunde.titel);
  }, addFields:function(into) {
    into.push(this.root);
  }, canAccept:function() {
    return this.typField.canAccept() && this.nameField.canAccept();
  }, canReject:function() {
    return this.canAlwaysReject || this.typField.canAccept() && this.nameField.canAccept();
  }, submitType:function() {
    return 'tuple';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.encodedAtom('typ', this.typField.submitValue());
    x.encodedAtom('name', this.nameField.submitValue());
    var noFields = this.typField.submitValue() == 'Z02';
    if (noFields) {
      x.atom('vorname1', '');
      x.atom('titel', '');
      x.atom('zusatz', '');
    } else {
      x.encodedAtom('vorname1', this.vorname1.submitValue());
      x.encodedAtom('titel', this.titel.submitValue());
      x.encodedAtom('zusatz', this.zusatz.submitValue());
    }
    return x.result();
  }, setReadOnly:function(_) {
    this.typField.setReadOnly(_);
    this.nameField.setReadOnly(_);
    this.vorname1.setReadOnly(_);
    this.zusatz.setReadOnly(_);
    this.titel.setReadOnly(_);
  }});
  WIM.AdressenView = Ext.extend(Object, {constructor:function(config) {
    this.task = config.task;
    this.diff = config.diff;
    this.readOnly = config.readOnly;
    this.noProcessValue = config.noProcessValue;
    this.forceAdresse = !!config.forceAdresse;
    this.noMessstelle = !!config.noMessstelle;
    this.forceAdresseMSB = !!config.forceAdresseMSB;
    this.forceAdresseLF = !!config.forceAdresseLF;
    this.noAdresse = !!config.noAdresse;
    this.forceMessstelle = !!config.forceMessstelle;
    this.noKundenadresse = !!config.noKundenadresse;
    this.noKundenadresself = !!config.noKundenadresself;
    this.noKundeLF = !!config.noKundeLF;
    this.kundenname = Ext.valueFrom(config.kundenname, 'Kunde des Messstellenbetreibers');
    this.kundennamelf = Ext.valueFrom(config.kundennamelf, 'Kunde des Lieferanten');
    var ad = [];
    this.kunde = new WIM.Kunde({name:'kunde', diff:this.diff, title:this.kundenname, readOnly:this.readOnly, canAlwaysReject:config.canAlwaysReject, allowBlankKunde:config.allowBlankKunde, noProcessValue:this.noProcessValue});
    this.kunde.addFields(ad);
    if (!this.noKundenadresse) {
      this.kundenAdresse = new WIM.AdresseMitKunde({kind:'KU', name:'kundenadresse', title:'Korrespondenzanschrift des Kunden des Messstellenbetreibers', diff:this.diff, forceAdresse:this.forceAdresseMSB, readOnly:this.readOnly, canAlwaysReject:config.canAlwaysReject, allowBlankKunde:config.allowBlankKunde, noProcessValue:this.noProcessValue});
      this.kundenAdresse.addFields(ad);
    }
    if (!this.noKundeLF) {
      this.kundelf = new WIM.Kunde({name:'kundelf', diff:this.diff, title:this.kundennamelf, readOnly:this.readOnly, canAlwaysReject:config.canAlwaysReject, allowBlankKunde:config.allowBlankKundelf, noProcessValue:this.noProcessValue});
      this.kundelf.addFields(ad);
    }
    if (!this.noKundenadresself) {
      this.kundenAdresself = new WIM.AdresseMitKunde({kind:'KULF', name:'kundenadresself', title:'Korrespondenzanschrift des Kunden des Lieferanten', diff:this.diff, forceAdresse:this.forceAdresseLF, readOnly:this.readOnly, canAlwaysReject:config.canAlwaysReject, allowBlankKunde:config.allowBlankKundelf, noProcessValue:this.noProcessValue});
      this.kundenAdresself.addFields(ad);
    }
    if (!this.noAdresse) {
      this.zpAdresse = new WIM.Adresse({kind:'ZP', name:'adresse', title:'Marktlokationsanschrift', diff:this.diff, forceAdresse:this.forceAdresse, readOnly:this.readOnly, noProcessValue:this.noProcessValue});
      this.zpAdresse.addFields(ad);
    }
    if (!this.noMessstelle) {
      this.messstellenAdresse = new WIM.Adresse({kind:'ZP', name:'messstellenadresse', title:'Messlokationsadresse', diff:this.diff, forceAdresse:this.forceMessstelle, readOnly:this.readOnly, noProcessValue:this.noProcessValue});
      this.messstellenAdresse.addFields(ad);
    }
    this.root = new Ext.Panel({scrollable:true, layout:'form', title:'Adressen', items:ad});
    if (this.task) {
      this.task.addComponent(this.kunde);
      if (!this.noKundeLF) {
        this.task.addComponent(this.kundelf);
      }
      if (!this.noKundenadresse) {
        this.task.addComponent(this.kundenAdresse);
      }
      if (!this.noKundenadresself) {
        this.task.addComponent(this.kundenAdresself);
      }
      if (!this.noAdresse) {
        this.task.addComponent(this.zpAdresse);
      }
      if (!this.noMessstelle) {
        this.task.addComponent(this.messstellenAdresse);
      }
    }
  }, setForceAdresse:function(_) {
    this.zpAdresse.setForceAdresse(_);
  }, loadSD:function(data, zpChanged) {
    this.kunde.loadSD(data.kunde, zpChanged);
    if (!this.noKundenadresse) {
      this.kundenAdresse.loadSD(data.kundenadresse, zpChanged);
    }
    if (!this.noAdresse) {
      this.zpAdresse.loadSD(data.adresse, zpChanged);
    }
    if (!this.noMessstelle) {
      this.messstellenAdresse.loadSD(data.messstellenadresse, zpChanged);
    }
  }, noBackend:function() {
    this.kunde.noBackend();
    if (!this.noKundeLF) {
      this.kunde.noBackend();
    }
    if (!this.noKundenadresse) {
      this.kundenAdresse.noBackend();
    }
    if (!this.noKundenadresself) {
      this.kundenAdresself.noBackend();
    }
    if (!this.noAdresse) {
      this.zpAdresse.noBackend();
    }
    if (!this.noMessstelle) {
      this.messstellenAdresse.noBackend();
    }
  }, setReadOnly:function(_) {
    this.kunde.setReadOnly(_);
    if (!this.noKundeLF) {
      this.kunde.setReadOnly(_);
    }
    if (!this.noKundenadresse) {
      this.kundenAdresse.setReadOnly(_);
    }
    if (!this.noKundenadresself) {
      this.kundenAdresself.setReadOnly(_);
    }
    if (!this.noAdresse) {
      this.zpAdresse.setReadOnly(_);
    }
    if (!this.noMessstelle) {
      this.messstellenAdresse.setReadOnly(_);
    }
  }, load:function(root) {
    if (!this.noProcessValue) {
      this.kunde.loadProcess(root.data.LOG.KUNDE);
      if (!this.noKundeLF) {
        this.kundelf.loadProcess(root.data.LOG.KUNDELF);
      }
      if (!this.noKundenadresse) {
        this.kundenAdresse.loadProcess(root.data.LOG.KUNDENADRESSE);
      }
      if (!this.noKundenadresself) {
        this.kundenAdresself.loadProcess(root.data.LOG.KUNDENADRESSELF);
      }
      if (!this.noAdresse) {
        this.zpAdresse.loadProcess(root.data.LOG.ADRESSE);
      }
      if (!this.noMessstelle) {
        this.messstellenAdresse.loadProcess(root.data.LOG.MESSSTELLENADRESSE);
      }
    }
  }, allowBlankKunde:function(_) {
    this.kunde.typField.setAllowBlank(_);
    this.kunde.nameField.setAllowBlank(_);
    this.kunde.vorname1.setAllowBlank(_);
  }, allowBlankKundelf:function(_) {
    this.kundelf.typField.setAllowBlank(_);
    this.kundelf.nameField.setAllowBlank(_);
    this.kundelf.vorname1.setAllowBlank(_);
  }, allowBlankAdresse:function(_) {
    if (this.zpAdresse) {
      this.zpAdresse.setForceAdresse(!_);
      this.zpAdresse.plz.setAllowBlank(_);
      this.zpAdresse.ort.setAllowBlank(_);
      this.zpAdresse.strasse.setAllowBlank(_);
      this.zpAdresse.land.setAllowBlank(_);
    }
  }, allowBlankMessstelle:function(_) {
    this.messstellenAdresse.setForceAdresse(!_);
    this.messstellenAdresse.plz.setAllowBlank(_);
    this.messstellenAdresse.ort.setAllowBlank(_);
    this.messstellenAdresse.strasse.setAllowBlank(_);
    this.messstellenAdresse.land.setAllowBlank(_);
  }});
})();
Ext.define('mpm.packages.wim.StubAngebotView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.Artikelnummer = {zaehleinrichtung:'9990001000649', wandler:'9990001000657', mengenumwerter:'9990001000657M', kommunikationseinrichtung:'9990001000665', technischesteuereinrichtung:'9990001000673', befestigungsart:'9990001000699', smartmetergateway:'9990001000772', steuerbox:'9990001000780'};
  Ext.ns('WIM.AngebotView');
  WIM.AngebotView.preisRenderer = function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    var w = String(v).replace('.', ',');
    return Ext.String.htmlEncode(w);
  };
  WIM.AngebotView = Ext.extend(Object, {constructor:function(config) {
    this.grid = new WIM.BasicGrid({title:'Angebot', columns:WIM.AngebotView.angebotColumns});
    this.root = this.grid.root;
  }, load:function(root) {
    this.grid.load(WIM.AngebotView.positionenUpgraded(root.data.LOG.POSITIONENXML));
  }});
  WIM.BestellungView = Ext.extend(Object, {constructor:function(config) {
    this.grid = new WIM.BasicGrid({title:'Bestellung', columns:WIM.AngebotView.bestellungColumns});
    this.root = this.grid.root;
  }, load:function(root) {
    this.grid.load(WIM.AngebotView.positionenUpgraded(root.data.LOG.BESTELLTEPOSITIONENXML));
  }});
  WIM.AngebotView.positionenUpgraded = function(positionen) {
    return Ext.Array.map(positionen || [], function(o) {
      var p = Ext.clone(o);
      if ('seriennummer' in p) {
        p.seriennummern = Ext.isEmpty(p.seriennummer) ? [] : [p.seriennummer];
        delete p.seriennummer;
      }
      if ('zaehlernummer' in p) {
        p.geraetenummern = Ext.isEmpty(p.zaehlernummer) ? [] : [p.zaehlernummer];
        delete p.zaehlernummer;
      }
      return p;
    }, this);
  };
  WIM.AngebotView.bestellungColumns = [{name:'zeile', header:'Zeile'}, {name:'anzahl', header:'Anzahl'}, {name:'artikelnummer', header:'Artikelnummer'}, {name:'betrag', header:'Betrag', renderer:WIM.AngebotView.preisRenderer}, {name:'preis', header:'Preis', renderer:WIM.AngebotView.preisRenderer}, {name:'geraetenummern', header:'Gerätenummern', renderer:WIM.arrayRenderer(), width:140}, {name:'ref-zeile', header:'Zeilenreferenz'}];
  WIM.AngebotView.angebotColumns = [{name:'zeile', header:'Zeile', width:100}, {name:'anzahl', header:'Anzahl', width:100}, {name:'artikelnummer', header:'Artikelnummer'}, {name:'baujahr', header:'Bau-/Verkehrsjahr', renderer:function(v, meta, r) {
    var result;
    if (!Ext.isEmpty(r.data.baujahr)) {
      result = 'Baujahr ' + r.data.baujahr;
    } else if (!Ext.isEmpty(r.data.verkehrsjahr)) {
      result = 'Verkehrsjahr ' + r.data.verkehrsjahr;
    } else {
      result = Ext.valueFrom(v, '');
    }
    return Ext.String.htmlEncode(result);
  }, defaultValue:''}, {name:'verkehrsjahr', header:'Verkehrsjahr', internal:true, defaultValue:''}, {name:'eichjahr', header:'Eichgültigkeit (Jahr)', defaultValue:'', renderer:function(v, meta, r) {
    return Ext.String.htmlEncode(Ext.valueFrom(r.data.eichjahr, ''));
  }}, {name:'seriennummern', header:'Seriennummern', renderer:WIM.arrayRenderer()}, {name:'betrag', header:'Betrag', defaultValue:'', renderer:WIM.AngebotView.preisRenderer}, {name:'preis', header:'Preis', defaultValue:'', renderer:WIM.AngebotView.preisRenderer}, {name:'leistung', header:'Leistung', width:100, defaultValue:''}, {name:'geraetenummern', header:'Gerätenummern', renderer:WIM.arrayRenderer()}, {name:'zaehleinrichtung', header:'Zähleinrichtung', width:140, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    var result = '';
    if (!Ext.isEmpty(v.messlokation)) {
      result += ' ' + v.messlokation;
    }
    if (!Ext.isEmpty(v.typ)) {
      result += ' ' + v.typ;
    }
    if (!Ext.isEmpty(v.groesse)) {
      result += ' ' + v.groesse;
    }
    if (!Ext.isEmpty(v.tarif)) {
      result += ' ' + v.tarif;
    }
    if (!Ext.isEmpty(v.befestigungsart)) {
      result += ' ' + v.befestigungsart;
    }
    if (!Ext.isEmpty(v.richtung)) {
      result += ' ' + v.richtung;
    }
    if (!Ext.isEmpty(v.fernschaltung)) {
      result += ' ' + v.fernschaltung;
    }
    return Ext.String.htmlEncode(result.substring(1));
  }}, {name:'wandler', header:'Wandler', renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ + ' ' + v.konstante);
  }}, {name:'mengenumwerter', header:'Mengenumwerter', renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'kommunikationseinrichtung', header:'Kommunikationseinrichtung', width:150, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'technischesteuereinrichtung', header:'Technische Steuereinrichtung', width:160, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'smartmetergateway', header:'Smartmetergateway', width:160, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    } else if (!Ext.isEmpty(v.msb)) {
      return 'MSB: ' + v.msb;
    } else {
      return '';
    }
  }}, {name:'steuerbox', header:'Steuerbox', width:160, renderer:function(v) {
    return '';
  }}, {name:'befestigungsart', header:'Befestigungsart/-einrichtung', width:120, defaultValue:''}, {name:'messwerterfassung', header:'Messwerterfassung', defaultValue:'', width:120}, {name:'eigentuemer', header:'Eigentümer', defaultValue:'', width:120}];
})();
Ext.define('mpm.packages.wim.StubGeraeteView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.MultiField = Ext.extend(Object, {constructor:function(config) {
    this.callParent(arguments);
    this.items = [];
    if (config.updateEnabled) {
      this.updateEnabled = config.updateEnabled;
    }
    this.disabled = !!config.disabled;
    this.mainField = config.mainField;
    this.mainField.on('change', this.updateEnabled, this);
    this.items.push(this.mainField);
    Ext.each(config.otherFields, function(c) {
      this.items.push(c);
    }, this);
    this.setDisabled(this.disabled);
  }, setDisabled:function(_) {
    this.disabled = _;
    this.updateEnabled();
  }, updateEnabled:function() {
    Ext.each(this.items, function(n) {
      n.setDisabled(this.disabled);
    }, this);
  }, getValue:function() {
    var result = {};
    Ext.each(this.items, function(n) {
      result[n.name] = this.disabled || n.disabled ? '' : n.getValue();
    }, this);
    return result;
  }, setValue:function(_) {
    if (_) {
      Ext.each(this.items, function(n) {
        n.setValue(_[n.name]);
      }, this);
    }
    this.updateEnabled();
  }});
  WIM.GeraetedatenView = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.isVersion1 = false;
    this.isNeuanlage = false;
    this.canOnlyZaehlernummer = config.canOnlyZaehlernummer;
    this.readOnly = config.readOnly;
    this.noKennzahlen = config.noKennzahlen;
    this.taskconfig = config;
    this.noZaehlwerk = !!config.noZaehlwerk;
    this.meldepunkteContext = config.meldepunkteContext || new WIM.MeldepunkteContext({});
    var columns = this.noZaehlwerk ? WIM.GeraetedatenView.kennzahlenColumnsHidden : WIM.GeraetedatenView.kennzahlenColumns;
    this.noZaehlernummern = !!config.noZaehlernummern;
    if (!this.noKennzahlen) {
      this.kennzahlenGrid = new WIM.BasicGrid({title:'OBIS-Kennzahlen', flex:0.8, columns:columns, readOnly:config.readOnly, forceRow:true, editContext:{create:function(grid) {
        (new mpm.packages.wim.OBISForm({meldepunkteContext:this.meldepunkteContext, zaehlernummern:this.zaehlernummern(), noZaehlwerk:this.noZaehlwerk, noZaehlernummern:this.noZaehlernummern})).create(grid.store, new grid.store.model({}), this.meldepunkteContext, this.geraeteGrid.store);
      }.bind(this), edit:function(grid, record) {
        (new mpm.packages.wim.OBISForm({meldepunkteContext:this.meldepunkteContext, zaehlernummern:this.zaehlernummern(), noZaehlwerk:this.noZaehlwerk, noZaehlernummern:this.noZaehlernummern})).edit(grid.store, record, this.meldepunkteContext, this.geraeteGrid.store);
      }.bind(this), remove:function(grid, record) {
        grid.store.remove(record);
      }}, isRecordValid:function(r) {
        if (true) {
          return true;
        } else {
          if (r.data.refzaehleinrichtung === '' && this.noZaehlernummern == false) {
            return this.zaehlernummern().length === 0;
          } else if (this.noZaehlernummern) {
            return true;
          } else {
            return this.zaehlernummern().indexOf(r.data.refzaehleinrichtung) >= 0;
          }
        }
      }.bind(this)});
    }
    this.geraeteGrid = new WIM.BasicGrid({title:'Geräte', flex:1, columns:WIM.GeraetedatenView.geraeteColumns, readOnly:config.readOnly, reorderGroup:'art', forceRow:!!config.forceRow, editContext:{create:function(grid) {
      var p = new mpm.packages.wim.GeraeteForm({meldepunkteContext:this.meldepunkteContext, zaehlernummern:this.zaehlernummern(), smartmetergatewaynummern:this.smartmetergatewaynummern(), canOnlyZaehlernummer:this.canOnlyZaehlernummer, taskdata:this.taskconfig.taskdata || null});
      p.on('commit', function() {
        if (p.record.data.art == 'zaehleinrichtung') {
          if (this.kennzahlenGrid) {
            this.kennzahlenGrid.refreshValid();
          }
          this.geraeteGrid.refreshValid();
        }
      }, this);
      var data = {};
      p.create(grid.store, new grid.store.model());
    }.bind(this), edit:function(grid, record) {
      var p = new mpm.packages.wim.GeraeteForm({meldepunkteContext:this.meldepunkteContext, zaehlernummern:this.zaehlernummern(), smartmetergatewaynummern:this.smartmetergatewaynummern(), canOnlyZaehlernummer:this.canOnlyZaehlernummer, taskdata:this.taskconfig.taskdata || null});
      p.on('commit', function() {
        if (record.data.art == 'zaehleinrichtung') {
          if (this.kennzahlenGrid) {
            this.kennzahlenGrid.refreshValid();
          }
          this.geraeteGrid.refreshValid();
        }
      }, this);
      p.edit(record);
    }.bind(this), remove:function(grid, record) {
      grid.store.remove(record);
      if (record.data.art == 'zaehleinrichtung') {
        if (this.kennzahlenGrid) {
          this.kennzahlenGrid.refreshValid();
        }
        this.geraeteGrid.refreshValid();
      }
    }.bind(this)}, isRecordValid:function(r) {
      if (r.data.art == 'zaehleinrichtung') {
        return true;
      }
      if (r.data.art == 'smartmetergateway') {
        return true;
      }
      var zaehlernummern = this.zaehlernummern();
      if (r.data.refzaehleinrichtungen.length === 0) {
        return zaehlernummern.length === 0;
      }
      return Ext.Array.every(r.data.refzaehleinrichtungen, function(z) {
        return zaehlernummern.indexOf(z) >= 0;
      }, this);
    }.bind(this)});
    this.geraeteGrid.on('change', function() {
      this.fireEvent('change', this);
    }, this);
    this.root = new Ext.Panel({layout:{type:'vbox', align:'stretch'}, flex:1, title:config.title || 'Gerätedaten', items:this.noKennzahlen ? [this.geraeteGrid.root] : [this.geraeteGrid.root, this.kennzahlenGrid.root]});
  }, canAccept:function() {
    return this.geraeteGrid.canAccept() && (!this.kennzahlenGrid || this.kennzahlenGrid.canAccept());
  }, setNeuanlage:function(_) {
    if (this.isNeuanlage != _) {
      this.isNeuanlage = _;
      this.geraeteGrid.refreshValid();
      if (this.kennzahlenGrid) {
        this.kennzahlenGrid.setForceRow(!_);
        this.kennzahlenGrid.refreshValid();
      }
    }
  }, zaehlernummern:function() {
    var result = [];
    Ext.each(this.geraeteGrid.getValue(), function(v) {
      if (v.art == 'zaehleinrichtung') {
        result = result.concat(v.geraetenummern);
      }
    }, this);
    return result;
  }, smartmetergatewaynummern:function() {
    var result = [];
    Ext.each(this.geraeteGrid.getValue(), function(v) {
      if (v.art == 'smartmetergateway') {
        result = result.concat(v.geraetenummern);
      }
    }, this);
    return result;
  }, submitType:function() {
    return 'tuple';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.begin('kennzahlen', 'relation');
    if (!this.noKennzahlen) {
      Ext.each(this.kennzahlenGrid.getValue(), function(v) {
        x.begin('position', 'tuple');
        x.atom('obis', v.obis);
        x.atom('obistype', v.obistype);
        x.atom('geraet', v.geraet);
        x.atom('marktlokation', v.marktlokation);
        x.atom('messlokation', v.messlokation);
        x.atom('marktrollerelevantLF', v.marktrollerelevantLF);
        x.atomArray('marktrollerelevantLFZweck', v.marktrollerelevantLFZweck);
        x.atom('marktrollerelevantNB', v.marktrollerelevantNB);
        x.atomArray('marktrollerelevantNBZweck', v.marktrollerelevantNBZweck);
        x.atom('marktrollerelevantUENB', v.marktrollerelevantUENB);
        x.atomArray('marktrollerelevantUENBZweck', v.marktrollerelevantUENBZweck);
        x.atom('vorkommastellen', v.vorkommastellen);
        x.atom('nachkommastellen', v.nachkommastellen);
        x.atom('schwachlastfaehig', v.schwachlastfaehig);
        x.atom('unterbrechbarkeit', v.unterbrechbarkeit);
        x.atom('verbrauchsart', v.verbrauchsart);
        x.atom('waermenutzung', v.waermenutzung);
        x.atom('zaehlwerk', v.zaehlwerk);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtung', v.refzaehleinrichtung);
        x.end('position');
      }, this);
    }
    x.end('kennzahlen');
    var vv = this.geraeteGrid.getValue();
    x.begin('zaehleinrichtungen', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'zaehleinrichtung') {
        x.begin('item', 'tuple');
        x.atom('messlokation', v.eigenschaften.messlokation);
        x.atom('typ', v.eigenschaften.typ);
        x.atom('groesse', v.eigenschaften.groesse);
        x.atom('tarif', v.eigenschaften.tarif);
        x.atom('richtung', v.eigenschaften.richtung);
        x.atom('befestigungsart', v.eigenschaften.befestigungsart);
        x.atom('messwerterfassung', v.eigenschaften.messwerterfassung);
        x.atom('fernschaltung', v.eigenschaften.fernschaltung);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungenSmartmeter', v.refzaehleinrichtungenSmartmeter);
        x.end('item');
      }
    }, this);
    x.end('zaehleinrichtungen');
    x.begin('wandler', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'wandler') {
        x.begin('item', 'tuple');
        x.atom('typ', v.eigenschaften.typ);
        x.atom('konstante', v.eigenschaften.konstante);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungen', v.refzaehleinrichtungen);
        x.end('item');
      }
    }, this);
    x.end('wandler');
    x.begin('mengenumwerter', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'mengenumwerter') {
        x.begin('item', 'tuple');
        x.atom('typ', v.eigenschaften.typ);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungen', v.refzaehleinrichtungen);
        x.end('item');
      }
    }, this);
    x.end('mengenumwerter');
    x.begin('kommunikationseinrichtungen', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'kommunikationseinrichtung') {
        x.begin('item', 'tuple');
        x.atom('typ', v.eigenschaften.typ);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungen', v.refzaehleinrichtungen);
        x.end('item');
      }
    }, this);
    x.end('kommunikationseinrichtungen');
    x.begin('technischesteuereinrichtungen', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'technischesteuereinrichtung') {
        x.begin('item', 'tuple');
        x.atom('typ', v.eigenschaften.typ);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungen', v.refzaehleinrichtungen);
        x.end('item');
      }
    }, this);
    x.end('technischesteuereinrichtungen');
    x.begin('smartmetergateways', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'smartmetergateway') {
        x.begin('item', 'tuple');
        x.atomArray('geraetenummern', v.geraetenummern);
        x.end('item');
      }
    }, this);
    x.end('smartmetergateways');
    x.begin('steuerboxen', 'relation');
    Ext.each(vv, function(v) {
      if (v.art == 'steuerbox') {
        x.begin('item', 'tuple');
        x.atom('marktlokation', v.eigenschaften.marktlokation);
        x.atomArray('geraetenummern', v.geraetenummern);
        x.atomArray('refzaehleinrichtungen', v.refzaehleinrichtungen);
        x.atomArray('refzaehleinrichtungenSmartmeter', v.refzaehleinrichtungenSmartmeter);
        x.end('item');
      }
    }, this);
    x.end('steuerboxen');
    return x.result();
  }, loadInitial:function(data, zpChanged) {
    if (!this.loaded || zpChanged) {
      this.doLoad(data);
    }
  }, load:function(data) {
    this.doLoad(data);
  }, addObis:function(array) {
    var store = this.kennzahlenGrid.store;
    var newRows = [];
    Ext.each(array, function(a) {
      var existing = store.findBy(function(r) {
        return r.data.obis == a.obis && (Ext.isEmpty(a.messlokation) ? r.data.marktlokation == a.marktlokation : r.data.messlokation == a.messlokation);
      });
      if (existing === -1) {
        newRows.push(a);
      }
    }, this);
    this.kennzahlenGrid.appendRows(newRows);
  }, convertedToV2:function(data) {
    var kennzahlen = [];
    var zaehleinrichtungen = [];
    var wandler = [];
    var mengenumwerter = [];
    var kommunikationseinrichtungen = [];
    var technischesteuereinrichtungen = [];
    var smartmetergateways = [];
    var steuerboxen = [];
    var value = function(v) {
      return Ext.isEmpty(v) ? '' : v;
    };
    Ext.each(data, function(l) {
      Ext.each(l.messwerte, function(m) {
        kennzahlen.push({obis:value(m.obis), obistype:value(m.obistype), marktlokation:value(m.marktlokation), messlokation:value(m.messlokation), geraet:value(m.geraet), zaehlwerk:value(m.zaehlwerk), schwachlastfaehig:value(m.schwachlastfaehig), verbrauchsart:value(m.verbrauchsart), unterbrechbarkeit:value(m.unterbrechbarkeit), waermenutzung:value(m.waermenutzung), vorkommastellen:'', nachkommastellen:'', refzaehleinrichtung:''});
      }, this);
      if (l.zaehleinrichtung) {
        zaehleinrichtungen.push({messlokation:value(l.zaehleinrichtung.messlokation), typ:value(l.zaehleinrichtung.typ), groesse:value(l.zaehleinrichtung.groesse), tarif:value(l.zaehleinrichtung.tarif), richtung:value(l.zaehleinrichtung.richtung), messwerterfassung:value(l.messwerterfassung), fernschaltung:value(l.fernschaltung), befestigungsart:value(l.befestigungsart), geraetenummern:[]});
      }
      if (l.wandler) {
        wandler.push({typ:value(l.wandler.typ), konstante:value(l.wandler.konstante), geraetenummern:[], refzaehleinrichtungen:[]});
      }
      if (l.mengenumwerter) {
        mengenumwerter.push({typ:value(l.mengenumwerter.typ), geraetenummern:[], refzaehleinrichtungen:[]});
      }
      if (l.kommunikationseinrichtung) {
        kommunikationseinrichtungen.push({typ:value(l.kommunikationseinrichtung.typ), geraetenummern:[], refzaehleinrichtungen:[]});
      }
      if (l.technischesteuereinrichtung) {
        technischesteuereinrichtungen.push({typ:value(l.technischesteuereinrichtung.typ), geraetenummern:[], refzaehleinrichtungen:[]});
      }
      if (l.smartmetergateway) {
        smartmetergateways.push({marktlokation:l.smartmetergateway.marktlokation, geraetenummern:[], refzaehleinrichtungen:[]});
      }
      if (l.steuerbox) {
        steuerboxen.push({marktlokation:l.smartmetergateway.marktlokation, geraetenummern:[], refzaehleinrichtungen:[]});
      }
    }, this);
    return {kennzahlen:kennzahlen, zaehleinrichtungen:zaehleinrichtungen, wandler:wandler, mengenumwerter:mengenumwerter, kommunikationseinrichtungen:kommunikationseinrichtungen, technischesteuereinrichtungen:technischesteuereinrichtungen, smartmetergateways:smartmetergateways, steuerboxen:steuerboxen};
  }, doLoad:function(data) {
    if (!data) {
      return;
    }
    if (Ext.isArray(data)) {
      if (this.readOnly) {
        if (!this.isVersion1) {
          this.isVersion1 = true;
          if (!this.noKennzahlen) {
            this.root.remove(this.kennzahlenGrid.root);
          }
          this.root.remove(this.geraeteGrid.root);
          var v1 = new WIM.BasicGrid({title:'Geräte/Kennzahlen (altes Format)', columns:WIM.GeraetedatenView.oldFormatColumns, readOnly:true});
          this.root.add(v1.root);
          v1.load(data);
          return;
        }
      } else {
        data = this.convertedToV2(data);
      }
    }
    if (Ext.isObject(data)) {
      if (this.isVersion1) {
        Ext.Msg.alert('Warnung', 'Wegen Problemen mit der Rückwärtskompatibilität können die Gerätedaten nicht angezeigt werden.');
        return;
      }
    }
    this.loaded = true;
    if (!this.noKennzahlen) {
      this.kennzahlenGrid.load(data.kennzahlen);
    }
    var geraete = [];
    Ext.each(data.zaehleinrichtungen, function(z) {
      geraete.push({art:'zaehleinrichtung', eigenschaften:{messlokation:z.messlokation, typ:z.typ, groesse:z.groesse, richtung:z.richtung, tarif:z.tarif, messwerterfassung:z.messwerterfassung, fernschaltung:z.fernschaltung, befestigungsart:z.befestigungsart}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:[], refzaehleinrichtungenSmartmeter:z.refzaehleinrichtungenSmartmeter});
    }, this);
    Ext.each(data.wandler, function(z) {
      geraete.push({art:'wandler', eigenschaften:{typ:z.typ, konstante:z.konstante}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen});
    }, this);
    Ext.each(data.mengenumwerter, function(z) {
      geraete.push({art:'mengenumwerter', eigenschaften:{typ:z.typ}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen});
    }, this);
    Ext.each(data.kommunikationseinrichtungen, function(z) {
      geraete.push({art:'kommunikationseinrichtung', eigenschaften:{typ:z.typ}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen});
    }, this);
    Ext.each(data.technischesteuereinrichtungen, function(z) {
      geraete.push({art:'technischesteuereinrichtung', eigenschaften:{typ:z.typ}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen});
    }, this);
    Ext.each(data.smartmetergateways, function(z) {
      geraete.push({art:'smartmetergateway', eigenschaften:{marktlokation:z.marktlokation}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen});
    }, this);
    Ext.each(data.steuerboxen, function(z) {
      geraete.push({art:'steuerbox', eigenschaften:{marktlokation:z.marktlokation}, geraetenummern:z.geraetenummern, refzaehleinrichtungen:z.refzaehleinrichtungen, refzaehleinrichtungenSmartmeter:z.refzaehleinrichtungenSmartmeter});
    }, this);
    this.geraeteGrid.load(geraete);
    if (this.kennzahlenGrid) {
      this.kennzahlenGrid.refreshValid();
    }
  }, noBackend:function() {
    this.loaded = true;
  }});
  WIM.GeraetedatenView.kennzahlenColumns = [{name:'obis', header:'OBIS-Kennzahl', width:100}, {name:'marktlokation', header:'Marktlokation', width:220}, {name:'messlokation', header:'Messlokation', width:220}, {name:'geraet', header:'zugeh. Gerät', width:220}, {name:'marktrollerelevantLF', header:'Relevant für LF', width:100}, {name:'marktrollerelevantNB', header:'Relevant für NB', width:120}, {name:'marktrollerelevantUENB', header:'Relevant für ÜNB', width:120}, {name:'zaehlwerk', header:'Lokale Kennzeichnung zu Kontrollzwecken', 
  width:220}, {name:'schwachlastfaehig', header:'schwachlastfähig', width:100}, {name:'verbrauchsart', header:'Verbrauchsart', width:100}, {name:'unterbrechbarkeit', header:'Unterbrechbarkeit', width:100}, {name:'waermenutzung', header:'Wärmenutzung', width:100}, {name:'vorkommastellen', header:'Vorkommastellen', width:100}, {name:'nachkommastellen', header:'Nachkommastellen', width:100}, {name:'refzaehleinrichtung', header:'zug. Zählernummer', width:150}];
  WIM.GeraetedatenView.kennzahlenColumnsHidden = [{name:'obis', header:'OBIS-Kennzahl', width:100}, {name:'marktlokation', header:'Marktlokation', width:220}, {name:'messlokation', header:'Messlokation', width:220}, {name:'geraet', header:'zugeh. Gerät', width:220}, {name:'marktrollerelevantLF', header:'Relevant für Lieferant', width:120}, {name:'marktrollerelevantNB', header:'Relevant für NB', width:120}, {name:'marktrollerelevantUENB', header:'Relevant für ÜNB', width:120}, {name:'zaehlwerk', header:'Lokale Kennzeichnung zu Kontrollzwecken', 
  hidden:true, width:220}, {name:'schwachlastfaehig', header:'schwachlastfähig', width:100}, {name:'verbrauchsart', header:'Verbrauchsart', width:100}, {name:'unterbrechbarkeit', header:'Unterbrechbarkeit', width:100}, {name:'waermenutzung', header:'Wärmenutzung', width:100}, {name:'vorkommastellen', header:'Vorkommastellen', width:100}, {name:'nachkommastellen', header:'Nachkommastellen', width:100}, {name:'refzaehleinrichtung', header:'zug. Zählernummer', hidden:true, width:150}];
  WIM.GeraetedatenView.geraeteColumns = [{name:'geraetenummern', header:'Zähler-/Gerätenummern', width:200, renderer:WIM.arrayRenderer()}, {name:'art', header:'Art', width:200, renderer:function(v) {
    if (v == 'zaehleinrichtung') {
      return 'Zähleinrichtung';
    }
    if (v == 'wandler') {
      return 'Wandler';
    }
    if (v == 'mengenumwerter') {
      return 'Mengenumwerter';
    }
    if (v == 'kommunikationseinrichtung') {
      return 'Kommunikationseinrichtung';
    }
    if (v == 'technischesteuereinrichtung') {
      return 'Techn. Steuereinrichtung';
    }
    if (v == 'smartmetergateway') {
      return 'Smartmeter Gateway';
    }
    if (v == 'steuerbox') {
      return 'Steuerbox';
    }
    return Ext.isEmpty(v) ? '' : Ext.String.htmlEncode(v);
  }}, {name:'eigenschaften', header:'Eigenschaften', width:250, renderer:function(v, meta, r) {
    var result = '';
    if (r.data.art == 'smartmetergateway') {
      if (!Ext.isEmpty(v.marktlokation)) {
        result += '\x3cbr/\x3eMarktlokation: ' + Ext.String.htmlEncode(v.marktlokation);
      }
    } else {
      if (!Ext.isEmpty(v.typ)) {
        result += 'Typ: ' + Ext.String.htmlEncode(v.typ);
      }
      if (r.data.art == 'zaehleinrichtung') {
        if (!Ext.isEmpty(v.messlokation)) {
          result += '\x3cbr/\x3eMesslokation: ' + Ext.String.htmlEncode(v.messlokation);
        }
        if (!Ext.isEmpty(v.groesse)) {
          result += '\x3cbr/\x3eGröße: ' + Ext.String.htmlEncode(v.groesse);
        }
        if (!Ext.isEmpty(v.tarif)) {
          result += '\x3cbr/\x3eTarif: ' + Ext.String.htmlEncode(v.tarif);
        }
        if (!Ext.isEmpty(v.richtung)) {
          result += '\x3cbr/\x3eRichtung: ' + Ext.String.htmlEncode(v.richtung);
        }
        if (!Ext.isEmpty(v.messwerterfassung)) {
          result += '\x3cbr/\x3eMesswerterfassung: ' + Ext.String.htmlEncode(v.messwerterfassung);
        }
        if (!Ext.isEmpty(v.fernschaltung)) {
          result += '\x3cbr/\x3eFernschaltung: ' + Ext.String.htmlEncode(v.fernschaltung);
        }
        if (!Ext.isEmpty(v.befestigungsart)) {
          result += '\x3cbr/\x3eBefestigungsart: ' + Ext.String.htmlEncode(v.befestigungsart);
        }
      } else if (r.data.art == 'wandler') {
        if (!Ext.isEmpty(v.konstante)) {
          result += '\x3cbr/\x3eKonstante: ' + Ext.String.htmlEncode(v.konstante);
        }
      } else if (r.data.art == 'steuerbox') {
        if (!Ext.isEmpty(v.marktlokation)) {
          result += '\x3cbr/\x3eMarktlokation: ' + Ext.String.htmlEncode(v.marktlokation);
        }
      }
    }
    if (result === '') {
      result = 'nicht erfasst';
    }
    return result;
  }}, {name:'refzaehleinrichtungen', header:'zug. Zählernummer', width:170, renderer:WIM.arrayRenderer()}, {name:'refzaehleinrichtungenSmartmeter', header:'Nr. des Smartmeter-Gateway', width:200, renderer:WIM.arrayRenderer()}];
  WIM.GeraetedatenView.oldFormatColumns = [{name:'messwerte', header:'OBIS-Kennzahlen', renderer:function(v) {
    var s = '';
    if (Ext.isEmpty(v)) {
      return '';
    }
    Ext.each(v, function(w, index) {
      if (index !== 0) {
        s += '\x3cbr/\x3e';
      }
      s += Ext.String.htmlEncode(w.obis + ' ' + w.zaehlwerk + ' ' + w.schwachlastfaehig);
    }, this);
    return s;
  }}, {name:'zaehleinrichtung', header:'Zähleinrichtung', width:150, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.messlokation + ' ' + v.typ + ' ' + v.groesse + ' ' + v.tarif + ' ' + v.befestigungsart + ' ' + v.richtung + ' ' + v.fernschaltung);
  }}, {name:'wandler', header:'Wandler', width:150, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ + ' ' + String(v.konstante).replace('.', ','));
  }}, {name:'mengenumwerter', header:'Mengenumwerter', width:150, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'kommunikationseinrichtung', header:'Kommunikationseinrichtung', width:150, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'technischesteuereinrichtung', header:'Technische Steuereinrichtung', width:160, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.typ);
  }}, {name:'smartmetergateway', header:'Smartmeter Gateway', width:160, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.marktlokation);
  }}, {name:'steuerbox', header:'Steuerbox', width:160, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v.marktlokation);
  }}, {name:'befestigungsart', header:'Befestigungsart', defaultValue:'', render:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v);
  }}, {width:120, name:'messwerterfassung', header:'Messwerterfassung', defaultValue:'', render:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    return Ext.String.htmlEncode(v);
  }}];
  WIM.VerwendungszweckList = Ext.extend(WIM.ComponentList, {newField:function() {
    return new Ext.form.ComboBox({width:300, allowBlank:false, matchFieldWidth:false, triggerAction:'all', forceSelection:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.obisverwendungszweck, {textFirst:true})});
  }, setVisible:function(_) {
    this.root.setVisible(_);
  }});
})();
Ext.define('mpm.packages.wim.StubInterchange', {requires:['mpm.packages.wim.StubCore']});
Ext.onReady(function() {
  WIM.RCTools = {};
  WIM.RCTools.addIcon = function(node) {
    if (!node.marked) {
      node.getUI().textNode.insert('\x3cimg id\x3d"' + node.id + '_error_mark' + '" style\x3d"width: 16px; height: 16px;" class\x3d"icon_exclamation node_error_mark" unselectable\x3d"on" src\x3d"' + Ext.BLANK_IMAGE_URL + '"\x3e');
      node.marked = true;
    }
  };
  WIM.RCTools.getNode = function(tree, xpath) {
    var xpathArray = xpath.split('/');
    var node = tree.getRootNode();
    for (var i = 1; i < xpathArray.length; i++) {
      if (xpathArray[i].indexOf('[') >= 0) {
        var element = xpathArray[i].slice(0, xpathArray[i].indexOf('['));
        var index = xpathArray[i].slice(xpathArray[i].indexOf('[') + 1, xpathArray[i].indexOf(']'));
        if (node.attributes.text != element) {
          var n = WIM.RCTools.getChildNode(node, element, index);
          if (n) {
            node = n;
          } else {
            break;
          }
        }
      }
    }
    return node;
  };
  WIM.RCTools.getChildNode = function(node, name, index) {
    var counter = 0;
    var child = index >= 0 ? null : [];
    node.childNodes.each(function(item) {
      var result = true;
      if (item.attributes.text.search(name) === 0) {
        counter++;
        if (counter == index) {
          child = item;
          result = false;
        } else if (index == -1) {
          child.push(item);
        }
      }
      return result;
    });
    return child;
  };
  WIM.RCTools.getNodeByText = function(rootnode, searchText) {
    var child = null;
    rootnode.cascade(function(item) {
      var result = true;
      if (item.attributes.text.search(searchText) > -1) {
        child = item;
        result = false;
      }
      return result;
    });
    return child;
  };
  WIM.RCTools.deepSearchAttributeByName = function(object, attName, attVal, firstOnly) {
    var returnObject = firstOnly ? null : [];
    if (Ext.isArray(object)) {
      for (var i = 0; i < object.length; i++) {
        tempObject = WIM.RCTools.deepSearchAttributeByName(object[i], attName, attVal, firstOnly);
        if (tempObject) {
          if (firstOnly) {
            returnObject = tempObject;
            break;
          } else {
            returnObject = returnObject.concat(tempObject);
          }
        }
      }
    } else {
      for (var a in object) {
        var isString = typeof object[a] == 'string';
        if (a == attName && attVal && isString && object[a].search(attVal) > -1) {
          if (firstOnly) {
            returnObject = object;
            break;
          } else {
            returnObject.push(object);
          }
        } else {
          if (typeof object[a] == 'object') {
            var tempObject = WIM.RCTools.deepSearchAttributeByName(object[a], attName, attVal, firstOnly);
            if (tempObject) {
              if (firstOnly) {
                returnObject = tempObject;
                break;
              } else {
                returnObject = returnObject.concat(tempObject);
              }
            }
          }
        }
      }
    }
    return returnObject;
  };
  WIM.MailView = Ext.extend(Object, {constructor:function(config) {
    var data = config.data;
    var fields = [WIM.newScrollableDisplayField({value:data.From, width:450, fieldLabel:'From'}), WIM.newScrollableDisplayField({value:data.To, width:450, fieldLabel:'To'})];
    if (!Ext.isEmpty(data.ReplyTo) && data.ReplyTo != data.From) {
      fields.push(WIM.newScrollableDisplayField({value:data.ReplyTo, width:450, fieldLabel:'Reply-To'}));
    }
    fields.push(WIM.newScrollableDisplayField({value:data.Subject, width:450, fieldLabel:'Subject'}));
    fields.push(WIM.newScrollableDisplayField({value:data.MessageID, width:450, fieldLabel:'Message-ID'}));
    var head = new Ext.FormPanel({fieldDefaults:{labelWidth:140}, bodyPadding:10, items:fields});
    this.items = [head];
    this.items.push(head);
    var text = Ext.util.Base64.decode(data.BodyText || '');
    text = "\x3cdiv style\x3d'white-space: nowrap'\x3e" + Ext.String.htmlEncode(text).replace(/\n/g, '\x3cbr/\x3e') + '\x3c/div\x3e';
    this.items.push(new Ext.Panel({flex:1, scrollable:true, items:[new Ext.form.field.Display({padding:5, value:text, htmlEncode:false})]}));
  }});
  WIM.EDIView = Ext.extend(Object, {constructor:function(config) {
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.referenz = config.referenz;
    this.title = config.title;
    this.htmlView = new WIM.HTMLView({wimContext:this.wimContext, process:this.process, referenz:this.referenz});
    this.downloadEDI = new Ext.Button({text:'Nachricht herunterladen', scope:this, handler:function() {
      var url = this.wimContext.referenzURL();
      url += url.indexOf('?') >= 0 ? '\x26' : '?';
      url += 'directory\x3d' + this.entry.REFERENZ + '\x26' + Ext.urlEncode({mimeType:this.entry.MIMETYPE});
      window.open(url, '_blank');
    }});
    this.originalView = new Ext.form.field.Display({});
    this.originalViewPanel = new Ext.Panel({margin:'10', hidden:true, scrollable:true, layout:'vbox', items:[this.originalView]});
    this.originalTree = new Ext.tree.TreePanel({animate:false, hidden:false, border:false, root:{text:'Interchange', expanded:true, children:[]}});
    this.originalTreeContainer = new Ext.Panel({border:false, region:'center', scrollable:true, items:[this.originalTree]});
    this.errorPanel = new Ext.Panel({region:'east', split:true, collapsible:true, collapseMode:'mini', collapsed:true, title:'Fehlerliste', layout:'border', width:250, items:[{xtype:'panel', region:'center', layout:'border', itemId:'topPanel', layout:'fit', items:[{html:'keine Fehlerliste vorhanden'}]}, {xtype:'panel', region:'south', split:true, height:75, layout:'border', itemId:'bottomPanel', layout:'fit', items:[{html:' '}]}]});
    this.originalTreePanel = new Ext.Panel({layout:'border', items:[this.originalTreeContainer, this.errorPanel]});
    this.showHtml = new Ext.Button({text:'HTML', enableToggle:true, allowDepress:false, toggleGroup:'EDIView-' + this.referenz, pressed:true});
    this.showEDI = new Ext.Button({text:'Text', enableToggle:true, allowDepress:false, toggleGroup:'EDIView-' + this.referenz, pressed:false});
    this.showTree = new Ext.Button({text:'Baum', enableToggle:true, allowDepress:false, toggleGroup:'EDIView-' + this.referenz, pressed:false});
    this.collapse = new Ext.Button({iconCls:WIM.iconCls('fa-arrow-up'), scope:this, handler:function() {
      this.originalTree.collapseAll();
      this.showTree.toggle(true);
    }});
    this.expand = new Ext.Button({iconCls:WIM.iconCls('fa-arrow-down'), scope:this, handler:function() {
      this.originalTree.expandAll();
      this.showTree.toggle(true);
    }});
    var updateToggle = function() {
      if (this.showTree.pressed) {
        this.root.getLayout().setActiveItem(this.originalTreePanel);
      } else if (this.showHtml.pressed) {
        this.root.getLayout().setActiveItem(this.htmlView.root);
      } else {
        this.root.getLayout().setActiveItem(this.originalViewPanel);
      }
    };
    this.showTree.on('toggle', updateToggle, this);
    this.showEDI.on('toggle', updateToggle, this);
    this.showHtml.on('toggle', updateToggle, this);
    this.root = new Ext.Panel({title:this.title, layout:'card', tbar:new Ext.Toolbar({itemId:'top', items:[this.showHtml, ' ', this.showEDI, ' ', this.showTree, '-', this.collapse, this.expand, '-', this.downloadEDI, '-\x3e']}), items:[this.htmlView.root, this.originalViewPanel, this.originalTreePanel], listeners:{scope:this, afterrender:function() {
      var errors = this.errorPanel;
      if (errors) {
        errors.setWidth(this.root.getWidth() * 0.33);
      }
    }, activate:function() {
      this.loadEDI();
    }}});
  }, setMaskComponent:function(_) {
    this.maskComponent = _;
    this.htmlView.maskComponent = _;
  }, loadEDI:function(force) {
    if (!this.entry) {
      return;
    }
    if (!this.hasLoadedEDI) {
      this.hasLoadedEDI = true;
      var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, referenz:this.entry.CHILDID, makeCommand:function() {
        return this.makeDefaultCommand() + '\x3creferenz\x3e' + this.referenz + '\x3c/referenz\x3e' + (force ? '\x3cignoreMaximumLength\x3etrue\x3c/ignoreMaximumLength\x3e' : '');
      }, requestSuccess:function(result) {
        this.loadedEDI(result.data.data);
      }, requestFailure:function() {
        WIM.handleFailure.apply(this, arguments);
        this.setError('Fehler beim Abruf');
      }});
      processRequest.start(this.maskComponent || this.root);
    }
  }, loadedEDI:function(_) {
    var fullEntry;
    Ext.each(_.CHILDLOG, function(c) {
      if (c.CHILDID == this.entry.CHILDID) {
        fullEntry = c;
        return false;
      }
      return true;
    }, this);
    if (fullEntry) {
      var original = Ext.util.Base64.decode(fullEntry.REFFILE.DATA);
      var needsForceButton = false;
      if (!Ext.isEmpty(fullEntry.EDITREE.DATA)) {
        var interchange = fullEntry.EDITREE.DATA;
        if (Ext.isArray(interchange)) {
          this.originalTree.setRootNode({text:'Interchange', children:interchange});
          if (this.originalTree.rendered) {
            this.originalTree.expandAll();
          } else {
            this.originalTree.on('afterrender', function() {
              this.originalTree.expandAll();
            }, this);
          }
          this.expand.setDisabled(false);
          this.collapse.setDisabled(false);
        } else {
          needsForceButton = true;
          this.originalTree.setRootNode({text:interchange.ERROR, leaf:true});
          this.expand.setDisabled(true);
          this.collapse.setDisabled(true);
        }
      } else {
        this.originalTree.setRootNode({text:'nicht vorhanden', expanded:true, children:[]});
        this.showEDI.toggle(true);
        this.expand.setDisabled(true);
        this.collapse.setDisabled(true);
      }
      if (needsForceButton) {
        if (!this.treeForceButton) {
          this.originalTreeContainer.add(this.treeForceButton = new Ext.Button({margin:'10', text:'Trotzdem abrufen', scope:this, handler:function() {
            this.hasLoadedEDI = false;
            this.loadEDI(true);
          }}));
        }
      } else {
        if (this.treeForceButton) {
          this.treeForceButton.ownerCt.remove(this.treeForceButton);
          delete this.treeForceButton;
        }
      }
      if (original.substring(0, 1) == '\x3c') {
        original = Ext.util.Format.htmlEncode(original);
      } else {
        original = atob(fullEntry.REFFILE.DATA);
        original = "\x3cdiv style\x3d'white-space: nowrap'\x3e" + Ext.util.Format.htmlEncode(original).replace(/(&#39;|')/g, '\x3cbr/\x3e') + '\x3c/div\x3e';
      }
      original = original.replace(/\n/g, '\x3cbr/\x3e');
      this.originalView.setValue(original);
      if (!Ext.isEmpty(fullEntry.ERRORS.DATA) && !this.process.errorsHandled) {
        this.process.errorsHandled = true;
        if (this.process.contrlErrorAction) {
          this.process.contrlErrorAction.hide();
        }
        if (this.process.aperakErrorAction) {
          this.process.aperakErrorAction.hide();
        }
        var errorList = new Ext.grid.GridPanel({tree:this.originalTree, errorPanel:this.errorPanel, displayField:'label', valueField:'pseudoId', store:new Ext.data.Store({autoDestroy:true, idIndex:0, data:fullEntry.ERRORS, root:'DATA', model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'pseudoId', fields:['pseudoId', {name:'additionalErrorValue'}, {name:'msg'}, {name:'qualifier'}, {name:'xpath'}, {name:'label'}]})}), columns:[{header:'Fehler', dataIndex:'label', width:120, sortable:true}], 
        viewConfig:{forceFit:true}, listeners:{rowclick:function(thisList, index) {
          var targetNode;
          var record = thisList.store.getAt(index);
          if (record.get('xpath') && record.get('xpath').length > 0) {
            targetNode = WIM.RCTools.getNode(thisList.tree, record.get('xpath'));
            if (targetNode) {
              thisList.tree.expandPath(targetNode.getPath());
              targetNode.select();
              WIM.RCTools.addIcon(targetNode);
            }
          }
          if (record.get('additionalErrorValue') && record.get('additionalErrorValue').length > 0) {
            targetNode = WIM.RCTools.getNodeByText(thisList.tree.getRootNode(), record.get('additionalErrorValue'));
            if (targetNode) {
              thisList.tree.expandPath(targetNode.getPath());
              targetNode.select();
              WIM.RCTools.addIcon(targetNode);
            }
          }
          thisList.errorPanel.down('#bottomPanel').removeAll();
          thisList.errorPanel.down('#bottomPanel').add(new Ext.form.Label({text:record.get('msg')}));
        }}});
        this.errorPanel.down('#topPanel').removeAll();
        this.errorPanel.down('#topPanel').add(errorList);
        var errorCount = errorList.store.getCount();
        var errorBtn = new Ext.Button({iconCls:WIM.iconCls('fa-exclamation-circle'), text:(fullEntry.ERRORS.ERRORTYPE == 'CONTRL' ? errorCount : 0) + ' CONTRL Fehler - ' + (fullEntry.ERRORS.ERRORTYPE == 'APERAK' ? errorCount : 0) + ' APERAK Fehler', errorPanel:this.errorPanel, originalTreePanel:this.originalTreePanel, rootPanel:this.root, ref:'../errorBtn', scope:this, handler:function(thisBtn) {
          if (thisBtn.refOwner.ownerCt.setActiveTab) {
            thisBtn.refOwner.ownerCt.setActiveTab(thisBtn.refOwner);
          }
          this.showTree.toggle(true);
          Ext.Function.defer(function() {
            thisBtn.errorPanel.expand(true);
          }, 10, this);
          Ext.Function.defer(function() {
            var t = thisBtn.errorPanel.getEl();
            t.fadeOut();
            t.fadeIn();
            t.frame();
          }, 1000, this);
        }});
        this.root.getDockedComponent('top').add(errorBtn);
        this.root.errorBtn = errorBtn;
        errorBtn.refOwner = this.root;
        this.root.ownerCt.baseBtn = errorBtn;
        this.root.ownerCt.items.each(function(panel) {
          var t = panel.getDockedComponent ? panel.getDockedComponent('top') : undefined;
          var baseBtn = panel.ownerCt.baseBtn;
          if (!panel.errorBtn && t) {
            t.add('-\x3e', Ext.apply(baseBtn.initialConfig, {id:Ext.id(), refBtn:baseBtn, handler:function(b1) {
              b1.refBtn.handler(b1.refBtn);
            }}));
          }
        });
      } else {
        if (!this.process.errorsHandled) {
          var contrlErrorIndicator = WIM.RCTools.deepSearchAttributeByName(interchange, 'text', 'D_0083', true);
          var contrlError = contrlErrorIndicator ? contrlErrorIndicator.text.search('4') > -1 : false;
          var aperakErrorPreIndicator = WIM.RCTools.deepSearchAttributeByName(interchange, 'text', 'D_0065', true);
          var aperakErrorPre = aperakErrorPreIndicator ? aperakErrorPreIndicator.text.search('APERAK') > -1 : false;
          var aperakError = false;
          if (aperakErrorPre) {
            var aperakErrorIndicatorArray = WIM.RCTools.deepSearchAttributeByName(interchange, 'text', 'G_SG4', false);
            aperakError = aperakErrorIndicatorArray.length > 0;
          }
          if (contrlError) {
            if (!this.process.contrlErrorAction) {
              this.process.contrlErrorAction = new Ext.Action({baseText:' CONTRL Fehler', text:' CONTRL Fehler', iconCls:WIM.iconCls('fa-exclamation-circle'), scope:this, handler:function() {
                if (this.root.ownerCt.setActiveTab) {
                  this.root.ownerCt.setActiveTab(this.root);
                }
                this.root.getLayout().setActiveItem(this.originalTreePanel);
                this.showTree.toggle(true);
              }});
            }
          }
          if (aperakError) {
            if (!this.process.aperakErrorAction) {
              this.process.aperakErrorAction = new Ext.Action({baseText:' APERAK Fehler', text:' APERAK Fehler', iconCls:'icon_exclamation', scope:this, handler:function() {
                if (this.root.ownerCt.setActiveTab) {
                  this.root.ownerCt.setActiveTab(this.root);
                }
                this.root.getLayout().setActiveItem(this.originalTreePanel);
                this.showTree.toggle(true);
              }});
            }
          }
          if (this.root.ownerCt.setActiveTab) {
            this.root.ownerCt.items.each(function(item) {
              var t = item.getDockedComponent ? item.getDockedComponent('top') : undefined;
              if (t) {
                if (this.process.aperakErrorAction && !t.aperakErrorAction) {
                  t.add(this.process.aperakErrorAction);
                  t.aperakErrorAction = this.process.aperakErrorAction;
                }
                if (this.process.contrlErrorAction && !t.contrlErrorAction) {
                  t.add(this.process.contrlErrorAction);
                  t.contrlErrorAction = this.process.contrlErrorAction;
                }
              }
            }, this);
          }
        }
      }
    } else {
      this.originalView.setValue("\x3cspan style\x3d'color:#999'\x3eKeine Originalnachricht gespeichert.\x3c/span\x3e");
      this.downloadEDI.setDisabled(true);
    }
  }, reset:function() {
    delete this.entry;
    delete this.process.errorsHandled;
    if (this.root.errorBtn) {
      if (this.root.errorBtn.ownerCt) {
        this.root.errorBtn.ownerCt.remove(this.root.errorBtn);
      }
      delete this.root.errorBtn;
    }
    this.hasLoadedEDI = false;
    this.originalView.setValue('');
    this.downloadEDI.setDisabled(true);
    this.originalTree.setRootNode({text:'Interchange', expanded:true, children:[]});
    if (this.treeForceButton) {
      this.treeForceButton.ownerCt.remove(this.treeForceButton);
      delete this.treeForceButton;
    }
    this.expand.setDisabled(true);
    this.collapse.setDisabled(true);
    this.htmlView.reset();
  }, load:function(_) {
    var entry;
    Ext.each(_.CHILDLOG, function(c) {
      if (Ext.String.endsWith(c.REFERENZ, this.referenz)) {
        entry = c;
      }
    }, this);
    if (entry) {
      this.root.setDisabled(false);
      this.entry = entry;
      this.downloadEDI.setDisabled(false);
      this.loadEDI();
    } else {
      this.root.setDisabled(true);
      this.originalView.setValue("\x3cspan style\x3d'color:#999'\x3eNicht vorhanden.\x3c/span\x3e");
      this.downloadEDI.setDisabled(true);
    }
    this.htmlView.load(_);
  }, setError:function(_) {
    this.originalView.setValue(_);
    this.downloadEDI.setDisabled(true);
  }});
  WIM.HTMLView = Ext.extend(Object, {constructor:function(config) {
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.referenz = config.referenz;
    this.htmlField = new Ext.form.field.Display({});
    this.root = new Ext.Panel({title:config.title, scrollable:true, padding:'10', items:[this.htmlField]});
    this.root.on('activate', function(a) {
      this.loadEDI();
    }, this);
    this.maskComponent = this.root;
  }, loadEDI:function(force) {
    if (!this.entry) {
      return;
    }
    if (!this.hasLoadedEDI) {
      this.hasLoadedEDI = true;
      var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, referenz:this.entry.CHILDID, makeCommand:function() {
        return this.makeDefaultCommand() + '\x3creferenz\x3e' + this.referenz + '\x3c/referenz\x3e\x3casHTML\x3etrue\x3c/asHTML\x3e' + (force ? '\x3cignoreMaximumLength\x3etrue\x3c/ignoreMaximumLength\x3e' : '');
      }, requestSuccess:function(result) {
        this.loadedEDI(result.data);
      }, requestFailure:function() {
        WIM.handleFailure.apply(this, arguments);
        this.setError('Fehler beim Abruf.');
      }});
      processRequest.start(this.maskComponent || this.root);
    }
  }, loadedEDI:function(_) {
    this.htmlField.setValue(_.data);
    if (_.toolarge == 'true') {
      if (!this.forceButton) {
        this.root.add(this.forceButton = new Ext.Button({margin:'10', text:'Trotzdem abrufen', scope:this, handler:function() {
          this.hasLoadedEDI = false;
          this.loadEDI(true);
        }}));
      }
    } else if (this.forceButton) {
      this.root.remove(this.forceButton);
      delete this.forceButton;
    }
  }, reset:function() {
    delete this.entry;
    this.hasLoadedEDI = false;
    this.htmlField.setValue('');
    if (this.forceButton) {
      this.root.remove(this.forceButton);
      delete this.forceButton;
    }
  }, load:function(_) {
    var entry;
    Ext.each(_.CHILDLOG, function(c) {
      if (Ext.String.endsWith(c.REFERENZ, this.referenz) && c.EDITREE && c.EDITREE.SUPPRESSED == 'true') {
        entry = c;
      }
    }, this);
    if (entry) {
      this.entry = entry;
      if (this.root.isVisible()) {
        this.loadEDI();
      }
    } else {
      this.htmlField.setValue("\x3cspan style\x3d'color:#999'\x3eNicht vorhanden.\x3c/span\x3e");
    }
  }, setError:function(_) {
    this.htmlField.setValue(_);
  }});
  WIM.InterchangeMessagePanel = Ext.extend(WIM.AbstractMessagePanel, {constructor:function(config) {
    this.callParent(arguments);
    this.head = new Ext.form.Panel({title:'Prozessdaten', tools:[{type:'refresh', qtip:'Neu laden', scope:this, handler:this.reload}], layout:{type:'hbox', align:'stretch'}, items:[{width:280, xtype:'fieldcontainer', layout:'form', labelWidth:200, items:[Ext.create('Ext.form.field.Display', {name:'STATUS', fieldLabel:'Status', htmlEncode:false}), WIM.newScrollableDisplayField({name:'PROCESSID', fieldLabel:'Prozess-ID', value:this.process.processID, width:130}), WIM.newScrollableDisplayField({name:'ROUTINGID', 
    fieldLabel:'Routing-ID', width:130}), WIM.newScrollableDisplayField({name:'FORMAT', fieldLabel:'Format', width:130}), WIM.newScrollableDisplayField({name:'TYPE', fieldLabel:'Typ', width:130}), WIM.newScrollableDisplayField({name:'VERSION', fieldLabel:'Version', width:130}), WIM.newScrollableDisplayField({name:'FACHPROCESSID', fieldLabel:'Fachprozess(e)', width:130})]}, {width:15, xtype:'container'}, {width:410, xtype:'fieldcontainer', layout:'form', labelWidth:150, items:[WIM.newScrollableDisplayField({name:'PROCESS', 
    fieldLabel:'Prozess', width:260}), WIM.newScrollableDisplayField({name:'DIRECTION', fieldLabel:'Richtung', width:260}), WIM.newScrollableDisplayField({name:'MESSAGE', fieldLabel:'Nachricht', width:260}), WIM.newScrollableDisplayField({name:'MESSAGEID', fieldLabel:'Nachricht (ID)', width:260}), WIM.newScrollableDisplayField({name:'APERAKID', fieldLabel:' APERAK (ID)', width:260}), WIM.newScrollableDisplayField({name:'TIMESTAMP', fieldLabel:'Zeitstempel', width:260}), WIM.newScrollableDisplayField({name:'LASTUPDATE', 
    fieldLabel:'Aktualisierung', width:260})]}, {width:15, xtype:'container'}, {width:410, xtype:'fieldcontainer', layout:'form', labelWidth:150, items:[WIM.newScrollableDisplayField({name:'MP_PARTNERNAME', fieldLabel:'Partner-Name', width:260}), WIM.newScrollableDisplayField({name:'MP_PARTNERID', fieldLabel:'Partner-ID', width:260}), this.newMarktpartnerField({name:'MP_MPID', fieldLabel:'Partner-MPID', width:260}), WIM.newScrollableDisplayField({name:'OWN_PARTNERNAME', fieldLabel:'Mandant-Name', 
    width:260}), WIM.newScrollableDisplayField({name:'OWN_PARTNERID', fieldLabel:'Mandant-ID', width:260}), this.newMarktpartnerField({name:'OWN_MPID', fieldLabel:'Mandant-MPID', width:260})]}]});
    this.history = new Ext.grid.GridPanel({title:'Verarbeitungshistorie', viewConfig:{emptyText:'Keine Einträge.', deferEmptyText:false}, border:false, enableHdMenu:false, store:new Ext.data.Store({model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'CHILDID', fields:[{name:'STATUS'}, {name:'CHILDID'}, {name:'MESSAGEID'}, {name:'TIMESTAMP', convert:WIM.dbDateDisplayValue}, {name:'TEXT'}]})}), columns:[{header:'Lfd. Nr.', dataIndex:'CHILDID', width:80, renderer:WIM.renderer()}, {header:'Status', 
    dataIndex:'STATUS', width:140, scope:this, renderer:this.wimContext.statusIconIMGRenderer({withText:true})}, {header:'Nachricht (ID)', dataIndex:'MESSAGEID', width:160, renderer:WIM.renderer()}, {header:'Zeitstempel', dataIndex:'TIMESTAMP', renderer:WIM.renderer(), width:180}, {renderer:function(value, meta) {
      meta.attr += "style\x3d'white-space: normal'";
      return Ext.util.Format.nl2br(Ext.String.htmlEncode(value));
    }, cellWrap:true, header:'Text', dataIndex:'TEXT', width:530}]});
    this.mailView = new Ext.Panel({title:'Mailansicht', layout:{type:'vbox', align:'stretch'}, scrollable:true, border:false});
    this.interchangeView = new WIM.EDIView({process:this.process, wimContext:config.wimContext, title:'Originalnachricht', referenz:'interchange.edi'});
    this.contrlView = new WIM.EDIView({process:this.process, wimContext:config.wimContext, title:'CONTRL', referenz:'CONTRL.edi'});
    this.aperakView = new WIM.EDIView({process:this.process, wimContext:config.wimContext, title:'APERAK', referenz:'APERAK.edi'});
    this.tabs = new Ext.TabPanel({flex:1, plain:true, items:[this.interchangeView.root, this.history]});
    this.items = [this.head, this.tabs];
  }, newMarktpartnerField:function(config) {
    var space = 5;
    return new Ext.form.FieldContainer({fieldLabel:config.fieldLabel, layout:{type:'hbox', align:'stretch'}, flex:1, width:140 + config.width, items:[new Ext.form.field.Text({flex:1, name:config.name, readOnly:true}), new Ext.Container({width:space}), new Ext.form.field.Text({width:63, name:config.name + 'CODE', readOnly:true})]});
  }, reload:function() {
    this.interchangeView.reset();
    this.contrlView.reset();
    this.aperakView.reset();
    this.mailView.removeAll();
    this.requestData(this.maskComponent);
  }, load:function(root) {
    var d = Ext.apply({}, root.data.LOG);
    var convertFields = {STATUS:this.wimContext.statusIconIMGRenderer(), TIMESTAMP:WIM.dbDateDisplayValue, LASTUPDATE:WIM.dbDateDisplayValue};
    Ext.Object.each(convertFields, function(k, v) {
      d[k] = v.call(this, d[k]);
    }, this);
    this.head.getForm().loadRecord(Ext.create('Ext.data.Model', d));
    var data = root.data;
    var cc = Ext.clone(data.CHILDLOG);
    cc.sort(function(a, b) {
      var m = Ext.Number.from(a.CHILDID), n = Ext.Number.from(b.CHILDID);
      return m < n ? -1 : m === n ? 0 : 1;
    });
    this.history.store.add(cc);
    this.interchangeView.setMaskComponent(this.maskComponent);
    this.contrlView.setMaskComponent(this.maskComponent);
    this.aperakView.setMaskComponent(this.maskComponent);
    this.interchangeView.load(data);
    if (data.LOG.TYPE != 'CONTRL') {
      if (!this.contrlView.root.ownerCt) {
        this.tabs.insert(this.tabs.items.getCount() - 1, this.contrlView.root);
      }
      this.contrlView.load(data);
      if (data.LOG.TYPE != 'APERAK') {
        if (!this.aperakView.root.ownerCt) {
          this.tabs.insert(this.tabs.items.getCount() - 1, this.aperakView.root);
        }
        this.aperakView.load(data);
      } else {
        this.tabs.remove(this.aperakView.root);
      }
    } else {
      this.tabs.remove(this.contrlView.root);
    }
    var json = data.LOG.ENVELOPEXML;
    if (Ext.isObject(json)) {
      if (json.Protocol == 'Mail') {
        var mail = new WIM.MailView({data:json});
        this.mailView.add(mail.items);
        if (!this.mailView.ownerCt) {
          this.tabs.insert(0, this.mailView);
        }
      } else {
        this.tabs.remove(this.mailView);
      }
    }
  }, requestFailed:function() {
    this.callParent(arguments);
    if (this.interchangeView) {
      var error = "\x3cspan style\x3d'color:#f44'\x3eFehler beim Abruf.\x3c/span\x3e";
      this.interchangeView.setError(error);
      this.contrlView.setError(error);
      this.aperakView.setError(error);
      this.tabs.remove(this.mailView);
    }
  }});
});
Ext.define('mpm.packages.wim.StubTasks', {requires:['mpm.packages.wim.StubCore']});
Ext.onReady(function() {
  WIM.newTask = function(config) {
    var taskWindow = Ext.ComponentQuery.query('window#autoload-win')[0];
    var wimContext = Ext.create('mpm.packages.wim.WIMContext', {baseURL:BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(taskWindow.moduleId, 'proxy_id'))});
    var template;
    Ext.Array.each(WIM.Tasks, function(t) {
      if (t.task == config.kind) {
        template = t;
        return false;
      }
      return true;
    }, this);
    if (!template) {
      Ext.Msg.alert('Fehler', "Task unbekannt: '" + config.kind + "'");
      return undefined;
    } else {
      var klass = WIM[config.kind + '_Task'];
      if (!klass) {
        Ext.Msg.alert('Interner Fehler', "Task nicht gefunden: '" + config.kind + "'");
      }
      config.taskTemplate = template;
      config.wimContext = wimContext;
      return new klass(config);
    }
  };
  WIM.AbstractTask = Ext.extend(Object, {formularLabelWidth:140, constructor:function(config) {
    this.callParent(arguments);
    this.wimContext = config.wimContext;
    var own_mpid = Ext.valueFrom(Ext.valueFrom(config.own_mpid, Ext.valueFrom(config.values.OWN_MPID, config.values.own_mpid)), '');
    var own_mpidcode = Ext.valueFrom(Ext.valueFrom(config.own_mpidcode, Ext.valueFrom(config.values.OWN_MPIDCODE, config.values.own_mpidcode)), '');
    this.process = new WIM.Process({prefix:config.prefix, processID:config.processID, url:this.wimContext.serverURL(), own_mpid:own_mpid, own_mpidcode:own_mpidcode});
    this.description = config.description;
    this.kind = config.kind;
    this.values = config.values;
    this.namespace = config.namespace;
    var taskTemplate = config.taskTemplate;
    this.taskMessageContainer = new Ext.Panel({border:false, bodyPadding:'5 10 5 10', items:[new Ext.form.field.Display({htmlEncode:false, value:(new Ext.Template(taskTemplate.text)).apply([config.message])})]});
    this.tabs = new Ext.TabPanel({layoutOnTabChange:true, plain:true, flex:1, items:[], listeners:{scope:this, tabchange:this.updateButtons}});
    this.commitButtons = [];
    this.commitItems = [];
    this.commitItems.push(new Ext.Container({width:20}));
    Ext.Array.each(config.buttonTemplate, function(b) {
      var button = new Ext.Button({text:b[0], scale:'medium', minWidth:120, scope:this, handler:function() {
        if (b[1]) {
          this.submit(b[1]);
        } else if (b[1] === undefined) {
          this.cancel();
        }
      }});
      if (b[1] === undefined) {
        this.cancelButton = button;
      } else if (b[1] === 'Accept' || b[1] === 'Send') {
        this.acceptButton = button;
      } else if (b[1] === 'Save') {
        this.saveButton = button;
      } else if (b[1] === 'Reject') {
        this.rejectButton = button;
      }
      this.commitButtons.push(button);
      this.commitItems.push(button);
      this.commitItems.push(new Ext.Container({width:20}));
    }, this);
    this.buttons = new Ext.Panel({layout:{type:'hbox', pack:'center', padding:'10px'}, items:this.commitItems});
    this.components = [];
    this.submitValues = new Ext.form.Hidden({name:'values'});
  }, insertMessage:function(value) {
    this.form.insert(1, Ext.create('Ext.form.field.Display', {value:value, htmlEncode:true}));
    this.form.insert(2, {xtype:'container', height:20});
  }, makeItems:function() {
    var result = [this.taskMessageContainer];
    if (this.head) {
      result.push(this.head);
    }
    if (this.submitValues) {
      result.push(this.submitValues);
    }
    if (this.tabs && this.tabs.items.getCount() > 0) {
      result.push(this.tabs);
    }
    if (this.buttons) {
      result.push(this.buttons);
    }
    return result;
  }, addTab:function(_) {
    this.tabs.add(_);
  }, show:function() {
    if (!this.root) {
      this.root = new Ext.Panel({flex:1, layout:{type:'vbox', align:'stretch'}, items:this.makeItems()});
    }
    if (!this.root.rendered) {
      this.root.render('main');
      var w = Ext.ComponentQuery.query('window#autoload-win')[0];
      var offset = 0;
      if (w) {
        var new_w = w.body.getSize(true);
        new_w.height = w.body.getSize(true).height - offset;
        new_w.width = w.body.getSize(true).width - offset;
        this.setSize(new_w);
        w.on('resize', function() {
          var new_w = w.body.getSize(true);
          new_w.height = w.body.getSize(true).height - offset;
          new_w.width = w.body.getSize(true).width - offset;
          this.setSize(new_w);
        }, this);
        w.on('close', function() {
          this.destroy();
        }, this);
      } else {
        this.setSize(1200, 700);
      }
    }
    this.updateButtons();
  }, maskRootWithTimeout:function() {
    if (this.root.rendered) {
      this.root.setLoading(true);
    }
    Ext.Function.defer(function() {
      if (this.root && this.root.rendered) {
        this.root.setLoading(false);
      }
    }, 30000, this);
  }, cancel:function() {
    this.maskRootWithTimeout();
    var w = Ext.ComponentQuery.query('window#autoload-win')[0];
    this.destroyAndClose(w);
  }, destroy:function() {
    if (!this.root.destroyed) {
      this.root.destroy();
    }
  }, destroyAndClose:function(w) {
    this.destroy();
    w.close();
  }, submit:function(choice) {
    this.setSubmitValues(choice);
    this.maskRootWithTimeout();
    var w = Ext.ComponentQuery.query('window#autoload-win')[0];
    var form = w.getEl().down('form').dom;
    var data = new FormData(form);
    data.append('submitter', choice);
    data.append('submitId', choice);
    data.append('hiddenSubmitIS', choice);
    interaction.Support.submitViaExtJs('POST', form.action, data).then(function() {
      this.destroyAndClose(w);
    }, function() {
      Ext.Msg.alert('Fehler', 'Fehler bei der Aktion.');
    }, undefined, this);
  }, newFormPanel:function(config) {
    return new Ext.form.Panel(Ext.apply({}, config, {flex:1, scrollable:true, bodyPadding:10, fieldDefaults:{labelWidth:140}}));
  }, loadRecord:function(noZaehlpunkt) {
    Ext.Array.each(this.components, function(c) {
      if (noZaehlpunkt && c.name == 'zaehlpunkt') {
        return;
      }
      if (c.isMulti()) {
        c.load(this.values);
      } else if (c.name != 'terminkorrigiertedit' || c.name != 'terminedit' || c.name != 'fristkorrigiertedit') {
        c.load(this.values[c.name]);
      }
    }, this);
    this.updateButtons();
  }, loadRecordZaehlpunkt:function() {
    Ext.Array.each(this.components, function(c) {
      if (c.name != 'zaehlpunkt') {
        return;
      }
      if (c.isMulti()) {
        c.load(this.values);
      } else {
        c.load(this.values[c.name]);
      }
    }, this);
    this.updateButtons();
  }, setSize:function(_) {
    this.root.setSize(_);
  }, setSubmitValues:function(choice) {
    var s = '\x3cvalues\x3e';
    Ext.Array.each(this.components, function(c) {
      if (!c.hasSubmitValue()) {
        return;
      }
      if (c.isMulti()) {
        s += c.submitValue();
      } else {
        var t = c.submitType();
        if (t == 'atom') {
          t = '';
        } else {
          t = ' type\x3d"' + Ext.String.htmlEncode(t) + '"';
        }
        s += '\x3c' + c.name + t + '\x3e' + c.submitValue() + '\x3c/' + c.name + '\x3e';
      }
    }, this);
    s += '\x3c/values\x3e';
    this.submitValues.setValue(s);
  }, addComponent:function(_) {
    this.components.push(_);
    _.on('change', this.updateButtons, this);
  }, addComponentFields:function(into) {
    Ext.Array.each(this.components, function(c) {
      c.addFields(into);
    }, this);
  }, addFormularTab:function(formItems) {
    this.form = this.newFormPanel({labelWidth:this.formularLabelWidth, title:'Formular', items:formItems});
    this.tabs.insert(0, this.form);
  }, updateButtons:function() {
    if (this.hasError) {
      Ext.Array.each(this.commitButtons, function(b) {
        if (b !== this.cancelButton) {
          b.setDisabled(true);
        }
      }, this);
      return;
    }
    if (this.acceptButton) {
      var canAccept = true;
      Ext.Array.each(this.stornoComponents || this.components, function(c) {
        if (!c.canAccept()) {
          canAccept = false;
        }
      }, this);
      this.acceptButton.setDisabled(!canAccept);
    }
    if (this.saveButton) {
      var canSave = true;
      Ext.Array.each(this.stornoComponents || this.components, function(c) {
        if (!c.canSave()) {
          canSave = false;
        }
      }, this);
      this.saveButton.setDisabled(!canSave);
    }
    if (this.rejectButton) {
      var canReject = true;
      Ext.Array.each(this.stornoComponents || this.components, function(c) {
        if (!c.canReject()) {
          canReject = false;
        }
      }, this);
      this.rejectButton.setDisabled(!canReject);
    }
  }});
  WIM.PreAbstractProcessTask = Ext.extend(WIM.AbstractTask, {constructor:function(config) {
    if (!config.buttonTemplate) {
      if (this.buttonTemplate) {
        config.buttonTemplate = this.buttonTemplate;
      } else if (this.quittierenOnly) {
        config.buttonTemplate = [['Quittieren', 'Accept'], ['Schließen', undefined]];
      } else if (this.acceptOnly) {
        config.buttonTemplate = [['Annehmen', 'Accept'], ['Speichern', 'Save'], ['Schließen', undefined]];
      } else {
        config.buttonTemplate = [['Annehmen', 'Accept'], ['Ablehnen', 'Reject'], ['Speichern', 'Save'], ['Schließen', undefined]];
      }
    }
    WIM.PreAbstractProcessTask.superclass.constructor.call(this, config);
  }, show:function() {
    this.callParent(arguments);
    var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, requestSuccess:function(data) {
      data = data.data;
      if (!data.meta || !data.data.LOG || !data.data.LOG.PROCESSID) {
        Ext.Msg.alert('Fehler', 'Keine Daten zum Prozess (' + Ext.util.Format.htmlEncode(this.process.processID) + ') gefunden.');
        this.requestFailed();
      } else {
        this.loadedProcess(data);
      }
    }, requestFailure:function() {
      WIM.handleFailure.apply(this, arguments);
      this.requestFailed();
    }});
    processRequest.start(this.root);
  }, loadedProcess:function(root) {
  }, requestFailed:function() {
    this.hasError = true;
    this.updateButtons();
  }});
  WIM.AbstractProcessTask = Ext.extend(WIM.PreAbstractProcessTask, {processHeadHiddenFields:[], isGERAustausch:false, constructor:function(config) {
    this.callParent(arguments);
    this.processHeadView = new WIM.ProcessView({isGERAustausch:this.isGERAustausch, hiddenFields:this.processHeadHiddenFields, wimContext:this.wimContext, process:this.process, title:'Prozessdaten (Prozess ' + this.process.processID + ')'});
    this.head = this.processHeadView.root;
  }, loadedProcess:function(root) {
    this.callParent(arguments);
    WIM.QQQ.defineDynamicValues(root);
    this.processHeadView.load(root);
  }});
  WIM.AdhocTask = Ext.extend(WIM.AbstractTask, {defaultWidth:570, ansprechpartnerRequired:true, senderConfig:{}, constructor:function(config) {
    config.buttonTemplate = [['Versenden', 'Send'], ['Speichern', 'Save'], ['Schließen', undefined], ['Löschen', 'Delete']];
    WIM.AdhocTask.superclass.constructor.call(this, config);
    this.descriptionField = new Ext.form.field.Display({htmlEncode:true, value:this.description, padding:'0 0 20 0'});
    this.sender = new WIM.MarktpartnerComponent(Ext.apply({}, {url:this.wimContext.serverURL(), diff:false, selbst:true, name:'own', fieldLabel:'Absender', MSB:true, width:this.defaultWidth}, this.senderConfig));
    this.hasNoBackend = config.noBackend == 'true';
    if (this.hasNoBackend) {
      this.zaehlpunkt = new WIM.TextField({maxLength:35, task:this, allowBlank:false, diff:false, name:'zaehlpunkt', fieldLabel:'Messlokation', width:this.defaultWidth});
      this.zaehlpunkt.showSuppressedError = Ext.emptyFn;
    } else {
      if (config.kind == 'WIMM_MSB_BEGINN_AUS' || config.kind == 'WIMM_MSB_KUENDIGUNG_AUS' || config.kind == 'WIMM_MDL_KUENDIGUNG_AUS' || config.kind == 'GER_WECHSEL_AUS') {
        this.zaehlpunkt = new WIM.ZaehlpunktComponent({zaehlpunktMode:'initial', task:this, process:this.process, name:'zaehlpunkt', fieldLabel:'Messlokation', width:this.defaultWidth});
      } else if (config.kind == 'WIMM_ENERGIEMENGEN_AUS' || config.kind == 'WIM_NB_FORMEL_AUS') {
        this.zaehlpunkt = new WIM.ZaehlpunktComponent({zaehlpunktMode:'malo', task:this, process:this.process, name:'zaehlpunkt', fieldLabel:'Marktlokation', width:this.defaultWidth});
      } else {
        this.zaehlpunkt = new WIM.ZaehlpunktComponent({task:this, process:this.process, name:'zaehlpunkt', fieldLabel:'Messlokation', width:this.defaultWidth});
      }
    }
    this.ansprechpartner = new WIM.AnsprechpartnerChoice({url:this.wimContext.serverURL(), sender:this.sender, name:'ansprechpartnerintern', fieldLabel:'Ansprechpartner', allowBlank:!this.ansprechpartnerRequired, width:this.defaultWidth});
    this.zaehlpunkt.on('load', this.loadedZaehlpunkt, this);
    this.zaehlpunkt.on('noBackend', this.noBackend, this);
    this.initialize(config);
    this.loadRecord(true);
  }, newFormItems:function() {
    return [this.descriptionField];
  }, show:function() {
    this.callParent(arguments);
    WIM.activateFirstPossibleTab(this.tabs);
    this.loadRecordZaehlpunkt();
    var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, requestSuccess:function(data) {
      data = data.data;
      if (!data) {
        Ext.Msg.alert('Fehler', 'Fehler bei der Kommunikation mit dem Server.');
        this.requestFailed();
      } else {
        this.loadedPseudoProcess(data);
      }
    }, requestFailure:function() {
      WIM.handleFailure.apply(this, arguments);
      this.requestFailed();
    }});
    if (this.messagePanel) {
      this.messagePanel.maskComponent = this.root;
    }
    processRequest.start(this.root);
    if (this.hasNoBackend) {
      this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
    }
  }, loadedPseudoProcess:function(root) {
    this.config = root.config;
    this.messwerteAbrufenEnabled = root.config.messwerteAbrufenEnabled == 'true';
    this.messwerteSchreibenEnabled = root.config.messwerteSchreibenEnabled == 'true';
    this.stammdatenSchreibenEnabled = root.config.stammdatenSchreibenEnabled == 'true';
    WIM.QQQ.defineDynamicValues(root);
  }, requestFailed:function() {
  }, loadedZaehlpunkt:function(zpChanged) {
  }, noBackend:function() {
  }, initialize:function(config) {
  }});
  WIM.ProcessTask = Ext.extend(WIM.AbstractProcessTask, {defaultWidth:570, ansprechpartnerRequired:true, loadErrorSuppressed:false, constructor:function(config) {
    this.callParent(arguments);
    this.zaehlpunkt = new WIM.ZaehlpunktComponent({loadErrorSuppressed:this.loadErrorSuppressed, process:this.process, task:this});
    this.ansprechpartner = new WIM.AnsprechpartnerChoice({url:this.wimContext.serverURL(), name:'ansprechpartnerintern', fieldLabel:'Ansprechpartner', allowBlank:!this.ansprechpartnerRequired, width:this.defaultWidth});
    this.descriptionField = new Ext.form.field.Display({htmlEncode:true, value:this.description, padding:'0 0 20 0'});
    this.zaehlpunkt.on('load', this.loadedZaehlpunkt, this);
    this.initialize(config);
    this.historyView = new WIM.HistoryView({wimContext:this.wimContext, process:this.process});
    this.addTab(this.historyView.root);
  }, initialize:function(config) {
  }, loadedProcess:function(root) {
    this.callParent(arguments);
    this.config = root.config;
    this.backendEnabled = root.config.backendEnabled == 'true';
    this.messwerteAbrufenEnabled = root.config.messwerteAbrufenEnabled == 'true';
    this.messwerteSchreibenEnabled = root.config.messwerteSchreibenEnabled == 'true';
    this.stammdatenSchreibenEnabled = root.config.stammdatenSchreibenEnabled == 'true';
    var processZaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    if (Ext.isEmpty(processZaehlpunkt)) {
      var taskZaehlpunkt = this.values.zaehlpunkt;
      if (Ext.isEmpty(taskZaehlpunkt)) {
        if (this.kind !== 'FRIST_ABLAUF') {
          this.noZaehlpunkt(root);
        }
      } else {
        this.processHeadView.setZaehlpunkt(taskZaehlpunkt);
        this.zaehlpunktSubmit = new WIM.FixedComponent({name:'zaehlpunkt', value:taskZaehlpunkt});
        this.addComponent(this.zaehlpunktSubmit);
        processZaehlpunkt = taskZaehlpunkt;
      }
    }
    if (!Ext.isEmpty(processZaehlpunkt)) {
      if (this.backendEnabled) {
        this.zaehlpunkt.load(processZaehlpunkt);
      } else {
        this.zaehlpunkt.noBackend();
      }
    }
    this.zaehlpunktInitialValue = root.data.LOG.ZAEHLPUNKTINITIAL;
    this.loadedData(root);
    this.loadRecord();
    this.postLoadedData(root);
    if (!this.backendEnabled) {
      this.noBackend();
    }
  }, newFormItems:function() {
    return [this.descriptionField];
  }, noZaehlpunkt:function(root) {
    Ext.Msg.alert('Fehler', 'Kein Zählpunkt enthalten.');
  }, setProcessZaehlpunkt:function(_) {
    this.processHeadView.setZaehlpunkt(_);
    if (this.backendEnabled) {
      this.zaehlpunkt.load(_);
    }
  }, loadedData:function(root) {
    this.historyView.load(root);
    if (this.ansprechpartner) {
      this.ansprechpartner.loadSender(root);
      this.ansprechpartner.loadProcess(root);
    }
    WIM.activateFirstPossibleTab(this.tabs);
  }, postLoadedData:function(root) {
  }, loadedZaehlpunkt:function(zpChanged) {
  }, noBackend:function() {
  }, checkCurrentMSB:function() {
    if (this.zaehlpunkt.data.msb && this.zaehlpunkt.data.msb.mpid !== this.process.own_mpid) {
      this.form.insert(1, Ext.create('Ext.form.field.Display', {value:'\x3cspan style\x3d"color:red"\x3eZur Zeit nicht als MSB zugeordnet.\x3c/span\x3e Derzeitiger MSB: ' + Ext.String.htmlEncode(this.zaehlpunkt.data.msb.mpid) + ' (' + Ext.String.htmlEncode(this.zaehlpunkt.data.msb.partnername) + ')'}));
    }
  }, installBackendFehler:function(root, fieldName) {
    if (!fieldName) {
      fieldName = 'BACKEND_FEHLER';
    }
    if (!Ext.isEmpty(root.data.LOG[fieldName])) {
      var backendItems = [];
      backendItems.push(new Ext.form.field.TextArea({fieldLabel:'Fehlermeldung', readOnly:true, width:600, height:200, value:root.data.LOG[fieldName]}));
      var ignoreBackendFehler = new WIM.Checkbox({boxLabel:'Fehler beim erneuten Versuch ignorieren', name:'ignoreBackendFehler'});
      this.addComponent(ignoreBackendFehler);
      ignoreBackendFehler.addFields(backendItems);
      this.tabs.insert(0, this.newFormPanel({title:'\x3cspan style\x3d"color:red;"\x3eFehler\x3c/span\x3e', items:backendItems}));
      this.tabs.setActiveTab(0);
    }
  }});
  WIM.MSBMDLTask = Ext.extend(WIM.ProcessTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN'], noFormularTab:false, constructor:function(config) {
    this.callParent(arguments);
    this.processView = new WIM.WechselView({hiddenFields:this.wechselHiddenFields});
    this.tabs.insert(this.noFormularTab ? 0 : 1, this.processView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.callParent(arguments);
    if (!this.noUpdateAntwortstatus && this.antwortstatus) {
      this.antwortstatus.updateLabels();
    }
  }, noZaehlpunkt:function(root) {
    var k = root.data.LOG.KATEGORIE;
    if (k === 'E01' || k === 'E35') {
      this.installZaehlpunktIdentifikation();
    } else {
      this.callParent(arguments);
    }
  }, newDatumkorrigiert:function(antwortstatus, hint) {
    var result = new WIM.DateComponent({name:'datumkorrigiert', fieldLabel:'Terminkorrektur', disabled:true, hint:hint, minDate:WIM.startOfToday()});
    if (antwortstatus) {
      antwortstatus.on('change', function(c) {
        var wantsDate = antwortstatus.isChecked('Z01');
        result.setDisabled(!wantsDate);
      }, this);
    }
    return result;
  }, newTerminkorrigiert:function() {
    var result = new WIM.DateComponent({name:'terminkorrigiertedit', fieldLabel:'Termin (korrigiert)', disabled:false, allowBlank:true});
    return result;
  }, newTermin:function() {
    var result = new WIM.DateComponent({name:'terminedit', fieldLabel:'Termin', disabled:false, allowBlank:true});
    return result;
  }, newFristkorrigiert:function() {
    var result = new WIM.DateComponent({name:'fristkorrigiertedit', fieldLabel:'Neue Frist', disabled:false, allowBlank:false, minDate:WIM.startOfToday()});
    return result;
  }, installZaehlpunktIdentifikation:function() {
    if (!this.antwortstatus) {
      this.antwortstatus = Ext.create('WIM.Antwortstatus', {});
    }
    this.antwortstatus.setDisabled(true);
    if (this.backendEnabled) {
      this.zaehlpunktInput = new WIM.ZaehlpunktComponent({task:this, process:this.process, name:'zaehlpunkt', fieldLabel:'Eingabe Zählpunkt', width:this.defaultWidth, canSave:function() {
        return !this.antwortstatus.isDisabled();
      }.bind(this)});
    } else {
      this.zaehlpunktInput = new WIM.TextField({maxLength:35, allowBlank:false, diff:false, name:'zaehlpunkt', fieldLabel:'Eingabe Zählpunkt', width:this.defaultWidth, canSave:function() {
        return !this.antwortstatus.isDisabled();
      }.bind(this)});
    }
    this.zaehlpunktInput.on('change', function() {
      commitButton.setDisabled(Ext.isEmpty(this.zaehlpunktInput.submitValue()));
    }, this);
    this.addComponent(this.zaehlpunktInput);
    var inputItems = [];
    inputItems.push(new Ext.form.field.Display({style:'color:red', value:'Sie müssen zunächst die Zählpunktidentifikation durchführen.'}));
    inputItems.push({xtype:'container', height:10});
    this.zaehlpunktInput.addFields(inputItems);
    var commitButton = new Ext.Button({text:'Festlegen', scope:this, handler:function() {
      this.setProcessZaehlpunkt(this.zaehlpunktInput.submitValue());
      this.antwortstatus.setDisabled(false);
      this.zaehlpunktInput.setReadOnly(true);
      commitButton.setDisabled(true);
    }});
    inputItems.push(commitButton);
    this.tabs.insert(0, this.newFormPanel({scrollable:true, title:'Zählpunktidentifikation', items:inputItems}));
    this.tabs.setActiveTab(0);
  }, installStornierung:function() {
    this.antwortstatusstornierung = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, name:'antwortstatusstornierung', items:[{key:'E15', accept:true}, {key:'E14'}, {key:'E17'}, {key:'Z07'}, {key:'Z08'}, {key:'Z13'}, {key:'Z14'}]});
    this.bemerkungantwortstorno = new WIM.TextArea({width:400, height:150, name:'bemerkungantwortstorno', fieldLabel:'Bemerkung'});
    this.antwortstatusstornierung.on('change', function() {
      this.bemerkungantwortstorno.setAllowBlank(!this.antwortstatusstornierung.isChecked('E14'));
    }, this);
    this.antwortstatus.setDisabled(true);
    this.addComponent(this.antwortstatusstornierung);
    this.addComponent(this.bemerkungantwortstorno);
    this.stornoComponents = [this.antwortstatusstornierung, this.bemerkungantwortstorno];
    var stornoItems = [];
    stornoItems.push(new Ext.form.field.Display({style:'color:red', value:'Sie müssen zunächst die Stornierung annehmen oder ablehnen. Danach wird der Prozess (bei Ablehnung) weitergeführt.'}));
    stornoItems.push({xtype:'container', height:10});
    this.antwortstatusstornierung.addFields(stornoItems);
    this.bemerkungantwortstorno.addFields(stornoItems);
    this.tabs.insert(0, this.newFormPanel({scrollable:true, title:'Stornierung', items:stornoItems}));
    this.tabs.setActiveTab(0);
  }});
  WIM.FRIST_ABLAUF_Task = Ext.extend(WIM.MSBMDLTask, {buttonTemplate:[['Frist verlängern', 'Accept'], ['Frist belassen', 'Reject'], ['Schließen', undefined]], wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'DATUMKORRIGIERT', 'BEMERKUNGANTWORT', 'WECHSELSTATUS', 'WECHSELSTATUSANLASS', 'VORGANGLF'], initialize:function(config) {
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.fristkorrigiert = this.newFristkorrigiert();
    this.addComponent(this.fristkorrigiert);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({rooted:true, task:this, displayOnly:true, displaySDOnly:true, MSB:{grundzustaendigkeit:true, noProcessValue:true}, LF:{noProcessValue:true}});
    this.marktpartnerZPView.addComponentsToTask();
    this.addTab(this.marktpartnerZPView.root);
    this.fristkorrigiert.load(this.values.deadline_format);
  }, loadedData:function(root) {
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
    this.callParent(arguments);
    this.fristkorrigiert.load(this.values.deadline_format);
    this.marktpartnerZPView.load(root);
  }, noBackend:function() {
    this.marktpartnerZPView.noBackend();
  }});
  WIM.MSBMDLClearingTask = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['VORGANGLF'], quittierenOnly:true, noFormularTab:true, initialize:function() {
    var panelConfig = this.kind == 'MSB_ANMELDUNG_CLEARING' ? WIM.MSBBeginn : this.kind == 'MSB_ABMELDUNG_CLEARING' ? WIM.MSBEnde : this.kind == 'MDL_ANMELDUNG_CLEARING' ? WIM.MDLBeginn : this.kind == 'MDL_ABMELDUNG_CLEARING' ? WIM.MDLEnde : undefined;
    this.marktpartnerZPView = new WIM.MarktpartnerZPView(panelConfig.marktpartnerConfig);
    this.addTab(this.marktpartnerZPView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
    var backendItems = [];
    backendItems.push(new Ext.form.field.TextArea({fieldLabel:'Warnungen', readOnly:true, width:600, height:200, value:root.data.LOG.BACKEND_WARNUNG}));
    this.tabs.insert(0, this.newFormPanel({title:'Warnungen', items:backendItems}));
    this.tabs.setActiveTab(0);
  }});
  WIM.MSB_ANMELDUNG_CLEARING_Task = WIM.MSBMDLClearingTask;
  WIM.MSB_ABMELDUNG_CLEARING_Task = WIM.MSBMDLClearingTask;
  WIM.StornoTask = Ext.extend(WIM.AdhocTask, {stornoprefixes:undefined, initialize:function(config) {
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkung', fieldLabel:'Bemerkung'});
    var formItems = this.newFormItems();
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.bemerkung);
    this.processList = new WIM.ProcessListView({wimContext:this.wimContext, name:'stornoprocessid', prefixName:'stornoprefix', process:this.process, prefixes:this.stornoprefixes});
    this.addComponent(new WIM.SpaceComponent({height:20}));
    this.addComponent(this.processList);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.processList.requestLoad(this.root);
  }});
  WIM.GER_WECHSEL_STORNIERUNG_AUS_Task = Ext.extend(WIM.StornoTask, {stornoprefixes:['WIM_GER_WECHSEL_']});
  WIM.STORNIERUNG_ZU_SPAET_Task = Ext.extend(WIM.MSBMDLTask, {initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E14'}, {key:'E17'}, {key:'Z07'}, {key:'Z08'}, {key:'Z13'}, {key:'Z14'}]});
    this.bemerkungantwortstorno = new WIM.TextArea({width:400, height:150, name:'bemerkungantwortstorno', fieldLabel:'Bemerkung'});
    this.antwortstatus.on('change', function() {
      this.bemerkungantwortstorno.setAllowBlank(!this.antwortstatus.isChecked('E14'));
    }, this);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.bemerkungantwortstorno);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.MSBMDLQuittierTask = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, wechselHiddenFields:[], initialize:function(config) {
    this.processView = new WIM.WechselView({hiddenFields:this.wechselHiddenFields});
    this.tabs.insert(0, this.processView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.callParent(arguments);
  }});
  WIM.MSB_WEITERVERPFLICHTUNG_ANGENOMMEN_Task = WIM.MSBMDLQuittierTask;
  WIM.MSB_WEITERVERPFLICHTUNG_ABGELEHNT_Task = WIM.MSBMDLQuittierTask;
  WIM.GER_WECHSEL_ANTWORT_IN_Task = WIM.MSBMDLQuittierTask;
  WIM.GER_WECHSEL_APERAK_IN_Task = WIM.MSBMDLQuittierTask;
  WIM.GER_WECHSEL_STORNIERUNG_ANGENOMMEN_Task = WIM.MSBMDLQuittierTask;
  WIM.GER_WECHSEL_STORNIERUNG_ABGELEHNT_Task = WIM.MSBMDLQuittierTask;
  WIM.MSB_KUENDIGUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'DATUMKORRIGIERT', 'BEMERKUNGANTWORT', 'ANTWORTSTATUS'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E15', accept:true, exclusive:true}, {key:'Z01', accept:true}, {key:'Z44', accept:true}, {key:'E11'}, {key:'Z12'}, {key:'Z29'}, {key:'Z34'}]});
    this.datumkorrigiert = this.newDatumkorrigiert(undefined, '00:00 (Strom) bzw. 06:00 (Gas)');
    this.antwortstatus.on('change', function(c) {
      var wantsDate = this.antwortstatus.isChecked('Z01') || this.antwortstatus.isChecked('Z12');
      this.datumkorrigiert.setDisabled(!wantsDate);
    }, this);
    this.kuendigungsfristCode = new WIM.TextField({minLength:4, maxLength:4, name:'kuendigungsfrist_code', fieldLabel:'Code Kündigungsfrist', allowBlank:false, hidden:true});
    this.kuendigungsfristCode.on('change', function(field, newvalue) {
      var value = field.giveValue();
      this.kuendigungsfristBezug.setAllowBlank(value.length > 3 && Ext.util.Format.substr(value, 3, 1) == 'T');
    }, this);
    this.kuendigungsfristCode.canReject = this.kuendigungsfristCode.canAccept;
    this.kuendigungsfristBezug = new WIM.TextField({minLength:4, maxLength:8, name:'kuendigungsfrist_bezug', fieldLabel:'Bezug Kündigungstermin', allowBlank:true, hidden:true});
    this.kuendigungsfristHinweis = new Ext.form.field.Display({hidden:true, value:'Eine Beschreibung und einige Beispiele zur Kodierung der Kündigungsfrist kann der gültigen UTILMD-Spezifikation beim BDEW entnommen werden.'});
    this.antwortstatus.on('change', function() {
      var isFrist = this.antwortstatus.isChecked('Z12');
      this.kuendigungsfristCode.setHidden(!isFrist);
      this.kuendigungsfristBezug.setHidden(!isFrist);
      this.kuendigungsfristHinweis.setVisible(isFrist);
    }, this);
    this.antwortstatus.on('change', function(c) {
      if (this.antwortstatus.isChecked('Z29') || this.antwortstatus.isChecked('Z34') || this.antwortstatus.isChecked('Z11') || this.antwortstatus.isChecked('E11')) {
        this.adressenView.allowBlankKunde(true);
        this.adressenView.allowBlankAdresse(true);
      }
    }, this);
    this.antwortstatus.on('change', function(c) {
      if (this.antwortstatus.isChecked('E15') || this.antwortstatus.isChecked('Z44') || this.antwortstatus.isChecked('Z01')) {
        this.adressenView.allowBlankKunde(false);
        this.adressenView.allowBlankAdresse(false);
      }
    }, this);
    this.addComponent(this.datumkorrigiert);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.kuendigungsfristCode);
    this.addComponent(this.kuendigungsfristBezug);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    formItems.push(this.kuendigungsfristHinweis);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:false, noAdresse:true, forceMessstelle:true, allowBlankKunde:false, noKundenadresse:true, noKundeLF:true, noKundenadresself:true});
    this.addTab(this.adressenView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    if (root.data.LOG.DATUM == '') {
      this.antwortstatus.removeValues(['Z12']);
      if (root.data.LOG.DATUMNAECHSTMOEGLICH == 'nein') {
        this.antwortstatus.removeValues(['Z01']);
      }
    } else {
      if (root.data.LOG.DATUMNAECHSTMOEGLICH == 'nein') {
        this.antwortstatus.removeValues(['Z01']);
        this.datumkorrigiert.setLabel('nächstmöglicher Termin:');
      } else {
        this.antwortstatus.removeValues(['Z12']);
      }
    }
    this.adressenView.load(root);
    this.stammdatenView.load(root);
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.checkCurrentMSB();
  }, noBackend:function() {
    this.adressenView.noBackend();
    this.stammdatenView.noBackend();
  }});
  WIM.MSB_ABMELDUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'DATUMKORRIGIERT', 'BEMERKUNGANTWORT', 'WECHSELSTATUS', 'WECHSELSTATUSANLASS', 'VORGANGLF'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E15', accept:true, exclusive:true}, {key:'E17'}, {key:'Z01', accept:true, exclusive:true}, {key:'Z09'}]});
    this.datumkorrigiert = this.newDatumkorrigiert(this.antwortstatus);
    this.addComponent(this.datumkorrigiert);
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({rooted:true, task:this, displayOnly:true, displaySDOnly:true, MSB:{grundzustaendigkeit:true, noProcessValue:true}, LF:{noProcessValue:true}});
    this.marktpartnerZPView.addComponentsToTask();
    this.addTab(this.marktpartnerZPView.root);
  }, loadedData:function(root) {
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
    if (root.data.LOG.DATUM === '') {
      this.antwortstatus.setValueDisabled('E15', true);
    }
    if (root.data.LOG.TRANSAKTIONSGRUND != 'ZG9' && root.data.LOG.TRANSAKTIONSGRUND != 'ZH1' && root.data.LOG.TRANSAKTIONSGRUND != 'ZH2') {
      this.antwortstatus.setValueDisabled('E17', true);
    }
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
  }, noBackend:function() {
    this.marktpartnerZPView.noBackend();
  }});
  WIM.MSB_ABMELDUNG_ENTSCHEIDUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['VORGANGLF'], acceptOnly:true, initialize:function(config) {
    this.datumweiter = new WIM.DateComponent({allowBlank:false, name:'datumweiter', fieldLabel:'Termin Weiterverpflichtung', disabled:true, minDate:WIM.startOfTomorrow()});
    this.entscheidung = new WIM.RadioGroup({name:'entscheidung', fieldLabel:'Entscheidung', defaultValue:'', items:[{value:'weiter', boxLabel:'Weiterverpflichtung MSBA'}, {value:'gv', boxLabel:'Übergang in Grundzuständigkeit'}, {value:'neuer', boxLabel:'Neue MSB-Anmeldung erfolgreich'}]});
    this.entscheidung.on('change', function() {
      this.datumweiter.setDisabled(!this.entscheidung.isChecked('weiter'));
    }, this);
    var formItems = this.newFormItems();
    this.addComponent(this.entscheidung);
    this.addComponent(this.datumweiter);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedData:function(root) {
    this.callParent(arguments);
    if (!Ext.isEmpty(root.data.LOG.VORGANGWEITER) && Ext.isEmpty(root.data.LOG.ANTWORTSTATUSWEITER)) {
      this.entscheidung.setValueDisabled('weiter', true);
    }
  }});
  WIM.MSB_ABMELDUNG_ZUORDNUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'VORGANGLF'], initialize:function(config) {
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({task:this, MSB0:{name:'msbgv', fieldLabel:'MSB(GZ)', role:undefined, selbst:true}, MSBDisplayOnly:true, MSB:{name:'mp', fieldLabel:'MSBA'}, LF:{noProcessValue:true}});
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.datumzuordnung = new WIM.DateComponent({name:'datumzuordnung', fieldLabel:'Zuordnungstermin', ignoreEmptyValue:true});
    this.addComponent(this.datumzuordnung);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.marktpartnerZPView.addComponentsToTask();
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedData:function(root) {
    var datum = root.data.LOG.DATUMKORRIGIERT !== '' ? root.data.LOG.DATUMKORRIGIERT : root.data.LOG.DATUM;
    var d = Ext.Date.parse(datum, 'c');
    if (d) {
      d = Ext.Date.format(Ext.Date.add(d, Ext.Date.DAY, 1), 'c');
    }
    this.datumzuordnung.load(d);
    this.marktpartnerZPView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root);
  }});
  WIM.MSB_ANMELDUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'DATUMKORRIGIERT', 'BEMERKUNGANTWORT', 'VORGANGLF'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E15', accept:true, exclusive:true}, {key:'Z01', accept:true, disabled:true}, {key:'Z44', accept:true}, {key:'E11'}, {key:'E17'}, {key:'Z09'}, {key:'Z29'}, {key:'ZB6'}]});
    this.datumkorrigiert = this.newDatumkorrigiert(this.antwortstatus);
    this.addComponent(this.datumkorrigiert);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.datumkorrigiert.addFields(formItems);
    this.antwortstatus.addFields(formItems);
    this.ansprechpartner.addFields(formItems);
    this.bemerkung.addFields(formItems);
    this.addFormularTab(formItems);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten', z82z30Required:true});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
    this.meldepunkteView.on('wizardchange', this.wizardchangeGeraetedaten, this);
    this.meldepunkteContext = new WIM.MeldepunkteContext({store:this.meldepunkteView.store, fields:[this.zaehlpunkt]});
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', meldepunkteContext:this.meldepunkteContext, taskdata:this, noZaehlwerk:true, noZaehlernummern:true});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:false, noAdresse:true, forceMessstelle:true, allowBlankKunde:false, allowBlankKundelf:true, noKundenadresse:false, noKundenadresself:false, forceAdresseMSB:true, forceAdresseLF:false});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:false});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({name:'marktpartnerxml', forceRow:false, meldepunkteContext:this.meldepunkteContext, readOnly:false, MSB0DisplayOnly:true, MSB0:{name:'mp', fieldLabel:'MSBN', noSDValue:true}, MSB:{name:'msba', fieldLabel:'MSBA', noProcessValue:true, grundzustaendigkeit:true}, LF:{allowBlank:true, noProcessValue:true}});
    this.addComponent(this.marktpartnerGridView);
    this.addTab(this.marktpartnerGridView.root);
    this.antwortstatus.on('change', function(root) {
      if (this.antwortstatus.isChecked('E11') || this.antwortstatus.isChecked('E17') || this.antwortstatus.isChecked('Z07') || this.antwortstatus.isChecked('Z09') || this.antwortstatus.isChecked('Z11') || this.antwortstatus.isChecked('Z29') || this.antwortstatus.isChecked('ZB6') || this.antwortstatus.isChecked('ZB7')) {
        this.adressenView.kunde.nameField.setAllowBlank(true);
        this.adressenView.kunde.typField.setAllowBlank(true);
      }
      if (this.antwortstatus.isChecked('E15') || this.antwortstatus.isChecked('Z01') || this.antwortstatus.isChecked('Z44')) {
        this.adressenView.kunde.nameField.setAllowBlank(false);
        this.adressenView.kunde.typField.setAllowBlank(false);
      }
    }, this);
  }, loadedProcess:function(root) {
    this.callParent(arguments);
    this.obiswizardItems = root.config.obiswizard || [];
    if (Ext.isEmpty(this.obiswizardItems)) {
      delete this.obiswizardItems;
    } else {
      if (console) {
        console.log('OBISWizard: ' + this.obiswizardItems.length + ' Einträge');
      }
    }
  }, wizardchangeGeraetedaten:function(source, mode, store, record, oldRecord) {
    if (!this.obiswizardItems) {
      return;
    }
    if (!(mode === 'create' || mode === 'update')) {
      return;
    }
    var type = record.data.meldepunkttyp;
    if (type === 'malo' || type === 'tranche') {
      var marktlokation = record.data.meldepunkt;
      var maloRecord;
      var lieferrichtung, prognosedetails;
      if (type === 'tranche') {
        maloRecord = store.findExact('meldepunkt', record.data.referenzmalomelo);
        if (maloRecord === -1) {
          return;
        }
        maloRecord = store.getAt(maloRecord);
      } else {
        maloRecord = record;
      }
      lieferrichtung = maloRecord.data.lieferrichtung;
      prognosedetails = maloRecord.data.prognosegrundlage === 'ZC0' ? 'E01' : maloRecord.data.detailsprognosegrundlage;
      if (console) {
        console.log('OBISWizard: Einsatz für ' + type + ' / ' + lieferrichtung + ' / ' + prognosedetails);
      }
      var obisItems = [];
      Ext.Array.each(this.obiswizardItems, function(w) {
        if (w.type === type && w.lieferrichtung === lieferrichtung && w.prognosedetails === prognosedetails) {
          var o = Ext.apply({obis:'', geraet:'', messlokation:'', marktrollerelevantLF:false, marktrollerelevantLFZweck:[], marktrollerelevantNB:false, marktrollerelevantNBZweck:[], marktrollerelevantUENB:false, marktrollerelevantUENBZweck:[], vorkommastellen:'', nachkommastellen:'', schwachlastfaehig:'', unterbrechbarkeit:'', verbrauchsart:'', waermenutzung:'', zaehlwerk:'', geraetenummern:[], refzaehleinrichtung:[]}, w);
          delete o.type;
          delete o.lieferrichtung;
          delete o.prognosedetails;
          Ext.apply(o, {obistype:type, marktlokation:marktlokation});
          obisItems.push(o);
        }
      }, this);
      this.geraetedatenView.addObis(obisItems);
    }
  }, loadedData:function(root) {
    this.callParent(arguments);
    var neuanlage = root.data.LOG.TRANSAKTIONSGRUND == 'E02';
    this.antwortstatus.setValueDisabled('Z01', !neuanlage);
    this.geraetedatenView.setNeuanlage(neuanlage);
    this.meldepunkteView.load(root);
    this.marktpartnerGridView.loadprocess(root.data.LOG);
    this.adressenView.load(root);
    this.ablesekarteView.load(root.data.LOG.ABLESEKARTENXML);
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.marktpartnerGridView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e$5) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
    try {
      this.marktpartnerGridView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e$6) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Marktpartnerdaten.');
    }
  }, noBackend:function() {
    this.adressenView.noBackend();
    this.geraetedatenView.noBackend();
  }});
  WIM.MSB_ANMELDUNG_GESCHEITERT_Task = Ext.extend(WIM.MSBMDLTask, {buttonTemplate:[['Quittieren', 'Accept'], ['Schließen', undefined], ['Klärung', 'Reject']], wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'VORGANGLF'], noFormularTab:true, initialize:function(config) {
    this.marktpartnerGridView = new WIM.MarktpartnerGridView(WIM.MSBBeginn.marktpartnerConfig);
    this.addTab(this.marktpartnerGridView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerGridView.loadprocess(root.data.LOG);
  }});
  WIM.MSB_ANMELDUNG_FRIST_Task = Ext.extend(WIM.MSB_ANMELDUNG_GESCHEITERT_Task, {initialize:function(config) {
    this.callParent(arguments);
    this.wechselstatusanlass = new WIM.FixedComponent({name:'wechselstatusanlass', value:'E17'});
    this.addComponent(this.wechselstatusanlass);
  }});
  WIM.MSB_ANMELDUNG_ZUORDNUNG_Task = Ext.extend(WIM.MSBMDLTask, {buttonTemplate:[['Annehmen', 'Accept'], ['Speichern', 'Save'], ['Schließen', undefined], ['Klärung', 'Reject']], wechselHiddenFields:['MSB_ANMELDUNG_ZUORDNUNG_Task', 'ANSPRECHPARTNERINTERN', 'VORGANGLF'], acceptOnly:false, initialize:function(config) {
    var formItems = this.newFormItems();
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({task:this, MSB0DisplayOnly:true, MSB0:{name:'mp', fieldLabel:'MSBN', noSDValue:true}, MSB:{name:'msba', fieldLabel:'MSBA', grundzustaendigkeit:true}});
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.termin = this.newTermin();
    this.addComponent(this.termin);
    this.terminkorrigiert = this.newTerminkorrigiert();
    if (this.values.DATUMKORRIGIERT) {
      this.terminkorrigiert.load(this.values.DATUMKORRIGIERT);
    }
    this.addComponent(this.terminkorrigiert);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.marktpartnerZPView.addComponentsToTask();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.installBackendFehler(root);
    if (this.terminkorrigiert && this.terminkorrigiert.field.value != '') {
      if (this.processView.root.items.get(9) != undefined) {
        this.processView.root.items.get(9).value = this.terminkorrigiert.field.value;
        this.terminkorrigiert.load('');
      }
    }
    var neuanlage = root.data.LOG.TRANSAKTIONSGRUND == 'E02';
    if (neuanlage) {
      this.marktpartnerZPView.setAllowBlankForMSBMDL(true);
      this.marktpartnerZPView.setAllowBlankForLF(true);
    }
    this.marktpartnerZPView.load(root);
    if (neuanlage) {
      this.termin.load(root.data.LOG.DATUM);
      if (root.data.LOG.DATUMKORRIGIERT != '') {
        this.termin.setDisabled(true);
        this.terminkorrigiert.load(root.data.LOG.DATUMKORRIGIERT);
      }
    } else {
      this.termin.isHidden(true);
      this.termin.setDisabled(true);
      this.terminkorrigiert.isHidden(true);
      this.terminkorrigiert.setDisabled(true);
    }
  }});
  WIM.GER_WECHSEL_EIN_Task = Ext.extend(WIM.MSBMDLTask, {ansprechpartnerRequired:true, wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'BEMERKUNGANTWORT', 'ANTWORTSTATUS'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'ZB4', accept:true, exclusive:true}, {key:'ZB5', accept:true, exclusive:true}, {key:'E17', exclusive:true}, {key:'Z07', exclusive:true}]});
    this.addComponent(this.antwortstatus);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionen', readOnly:true, canOnlyZaehlernummer:true, taskdata:this, noKennzahlen:true});
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.eigentuemer = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:false, noSDValue:true, name:'eigentuemer', fieldLabel:'Eigentümer', width:this.defaultWidth, MSB:true});
    this.antwortstatus.on('change', this.updateEigentuemer, this);
    var formItems = this.newFormItems();
    this.antwortstatus.addFields(formItems);
    this.addComponent(this.ansprechpartner);
    this.ansprechpartner.addFields(formItems);
    this.addComponent(this.eigentuemer);
    this.eigentuemer.addFields(formItems);
    this.addComponent(this.bemerkung);
    this.bemerkung.addFields(formItems);
    this.addComponent(this.geraetedatenView);
    this.addFormularTab(formItems);
    this.addTab(this.geraetedatenView.root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.checkCurrentMSB();
  }, loadedData:function(root) {
    if (root.data.LOG.GERAETEXML.zaehleinrichtungen.length > 0) {
      this.geraetedatenView.load(root.data.LOG.GERAETEXML);
    }
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
    this.updateEigentuemer();
    this.callParent(arguments);
  }, updateEigentuemer:function() {
    this.eigentuemer.setDisabled(!this.antwortstatus.isChecked('Z07'));
  }});
  WIM.GER_WECHSEL_AUS_Task = Ext.extend(WIM.AdhocTask, {senderConfig:{submitGrundzustaendigkeit:true, MSB:true}, ansprechpartnerRequired:true, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {name:'mp'});
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'Z58'}, {value:'Z59'}], defaultValue:'Z58'});
    this.datum = new WIM.DateTimeComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:new Date()});
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkung', fieldLabel:'Bemerkung'});
    this.anmeldungid = new WIM.TunnelComponent({name:'anmeldungid'});
    var formItems = this.newFormItems();
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.transaktionsgrund);
    this.addComponent(this.datum);
    this.addComponent(this.bemerkung);
    this.addComponent(this.anmeldungid);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this, canOnlyZaehlernummer:true, forceRow:true, noKennzahlen:true});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.geraetedatenView.noBackend();
  }});
  WIM.GER_UEBERNAHME_AUS_OUT_Task = Ext.extend(WIM.AdhocTask, {ansprechpartnerRequired:true, senderConfig:{submitGrundzustaendigkeit:true}, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {fieldLabel:'Empfänger (MSB)', name:'mp'});
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:WIM.startOfToday()});
    this.anmeldungid = new WIM.TunnelComponent({name:'anmeldungid'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(this.anmeldungid);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.GER_UEBERNAHME_AUS_ANGEBOT_IN_Task = Ext.extend(WIM.ProcessTask, {ansprechpartnerRequired:true, initialize:function(config) {
    var c = Ext.Array.filter(WIM.AngebotView.angebotColumns, function(c) {
      return c.name !== 'betrag';
    });
    c.splice(1, 0, {name:'anzahlbestellung', header:'\x3cb\x3eAnzahl Bestellung\x3c/b\x3e', editor:new Ext.form.field.Number({allowNegative:false, allowExponential:false, allowDecimals:false, maxLength:35}), renderer:function(v, meta, r) {
      if (r.data.leistung == 'Z09') {
        v = 'nicht angeboten';
      } else {
        v = Ext.valueFrom(v, '');
        var a = Ext.Number.parseInt(v);
        var invalid = false;
        if (a === null) {
          invalid = true;
        } else if (a > Ext.Number.parseInt(r.data.anzahl)) {
          invalid = true;
        }
        if (invalid) {
          meta.tdCls = WIM.configuration.invalidCellClass;
        }
      }
      return Ext.String.htmlEncode(v);
    }, defaultValue:'', width:130});
    this.positionenAngebotBestellung = new WIM.BasicGrid({name:'geraete', width:700, title:'Angebot', height:400, fieldLabel:'Positionen', columns:c, isCellEditable:function(grid, col, row) {
      var r = grid.store.getAt(row);
      if (r.get('leistung') == 'Z09') {
        return false;
      }
      return Ext.grid.ColumnModel.prototype.isCellEditable.call(this, col, row);
    }, canAccept:function() {
      var result = true;
      var hasItem = false;
      this.store.each(function(r) {
        if (r.get('leistung') == 'Z09') {
          return true;
        }
        var a = Ext.Number.parseInt(r.data.anzahlbestellung);
        if (a === null) {
          result = false;
          return false;
        }
        if (a > 0) {
          hasItem = true;
        }
        if (a > Ext.Number.parseInt(r.data.anzahl)) {
          result = false;
          return false;
        }
        return true;
      }, this);
      return result && hasItem;
    }, submitValue:function() {
      var x = new WIM.XMLOutput();
      this.grid.store.each(function(a, index) {
        x.begin('position', 'tuple');
        Ext.each(a.getFields(), function(f) {
          var name = f.name;
          if (name != 'zaehleinrichtung' && name != 'wandler' && name != 'mengenumwerter' && name != 'kommunikationseinrichtung' && name != 'technischesteuereinrichtung') {
            x.atom(name, a.data[name]);
          }
        }, this);
        if (a.data.zaehleinrichtung) {
          x.begin('zaehleinrichtung', 'tuple');
          x.atom('typ', a.data.zaehleinrichtung.typ);
          x.atom('groesse', a.data.zaehleinrichtung.groesse);
          x.atom('tarif', a.data.zaehleinrichtung.tarif);
          x.atom('richtung', a.data.zaehleinrichtung.richtung);
          x.end('zaehleinrichtung');
        }
        if (a.data.wandler) {
          x.begin('wandler', 'tuple');
          x.atom('typ', a.data.wandler.typ);
          x.atom('konstante', a.data.wandler.konstante);
          x.end('wandler');
        }
        if (a.data.mengenumwerter) {
          x.begin('mengenumwerter', 'tuple');
          x.atom('typ', a.data.mengenumwerter.typ);
          x.end('mengenumwerter');
        }
        if (a.data.kommunikationseinrichtung) {
          x.begin('kommunikationseinrichtung', 'tuple');
          x.atom('typ', a.data.kommunikationseinrichtung.typ);
          x.end('kommunikationseinrichtung');
        }
        if (a.data.technischesteuereinrichtung) {
          x.begin('technischesteuereinrichtung', 'tuple');
          x.atom('typ', a.data.technischesteuereinrichtung.typ);
          x.end('technischesteuereinrichtung');
        }
        x.end('position');
      }, this);
      return x.result();
    }});
    var formItems = this.newFormItems();
    this.betrag = new WIM.TextField({maxLength:35, name:'betragbestellung', fieldLabel:'Betrag Bestellung', allowBlank:false, noRegex:true, fieldClass:WIM.PreisFieldOptional});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.betrag);
    this.addComponentFields(formItems);
    this.addComponent(this.positionenAngebotBestellung);
    this.processView = new WIM.GeraeteuebernahmeView({hiddenFields:['BETRAGBESTELLUNG', 'ANTWORTBESTELLUNG', 'VORGANGORDERS']});
    this.addFormularTab(formItems);
    this.positionenAngebotBestellung.on('change', this.calculateBetrag, this);
    this.form.on('activate', this.calculateBetrag, this);
    this.addTab(this.processView.root);
    this.addTab(this.positionenAngebotBestellung.root);
  }, calculateBetrag:function() {
    var betrag = 0;
    this.positionenAngebotBestellung.grid.store.each(function(r) {
      if (!Ext.isEmpty(r.data.anzahlbestellung)) {
        betrag += parseFloat(r.data.preis) * r.data.anzahlbestellung;
      }
    }, this);
    this.betrag.load(isNaN(betrag) ? '' : betrag.toFixed(2));
  }, loadedData:function(root) {
    this.processView.load(root);
    this.positionenAngebotBestellung.loadInitial(WIM.AngebotView.positionenUpgraded(root.data.LOG.POSITIONENXML));
    this.callParent(arguments);
  }});
  WIM.GER_UEBERNAHME_AUS_ANGEBOT_ABGELEHNT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, noFormularTab:true, initialize:function(config) {
    this.processView = new WIM.GeraeteuebernahmeView({hiddenFields:['LEISTUNG', 'WAEHRUNG', 'BETRAG', 'BETRAGBESTELLUNG', 'ANTWORTBESTELLUNG', 'VORGANGORDERS']});
    this.addTab(this.processView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.callParent(arguments);
  }});
  WIM.GER_UEBERNAHME_AUS_ANGEBOT_APERAK_IN_Task = WIM.GER_UEBERNAHME_AUS_ANGEBOT_ABGELEHNT_IN_Task;
  WIM.GER_UEBERNAHME_AUS_BESTELLUNG_ANGENOMMEN_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, noFormularTab:true, initialize:function(config) {
    this.processView = new WIM.GeraeteuebernahmeView({hiddenFields:['LEISTUNG', 'WAEHRUNG', 'BETRAG', 'BETRAGBESTELLUNG', 'ANTWORTBESTELLUNG', 'VORGANGORDERS']});
    this.addTab(this.processView.root);
    this.bestellungView = new WIM.BestellungView({});
    this.addTab(this.bestellungView.root);
    this.angebotView = new WIM.AngebotView({});
    this.addTab(this.angebotView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.bestellungView.load(root);
    this.angebotView.load(root);
    this.callParent(arguments);
  }});
  WIM.GER_UEBERNAHME_AUS_BESTELLUNG_ABGELEHNT_IN_Task = WIM.GER_UEBERNAHME_AUS_BESTELLUNG_ANGENOMMEN_IN_Task;
  WIM.SecondUebernahmeComponent = Ext.extend(WIM.Component, {constructor:function(config) {
    this.callParent(arguments);
    this.task = config.task;
    this.hasSecond = false;
    this.addAngebotText = 'zweites Angebot erstellen';
    this.removeAngebotText = 'zweites Angebot entfernen';
    this.beides = new Ext.Button({text:'beides (zwei Angebote)', scope:this, handler:function() {
      this.hasSecond = !this.hasSecond;
      if (Ext.isEmpty(this.task.leistung.submitValue())) {
        this.task.leistung.load('Z07');
      }
      this.task.leistung.setDisabled(this.hasSecond);
      this.adjustFields();
      this.task.form.getForm().isValid();
    }});
  }, isMulti:WIM.trueFunction, canAccept:function() {
    return !this.hasSecond || this.betrag2 && this.secondPositionen && this.betrag2.canAccept() && this.secondPositionen.canAccept();
  }, load:function(r) {
    this.task.leistung.load(r.leistung);
    this.hasSecond = !!r.second;
    this.adjustFields();
    if (this.hasSecond) {
      this.betrag2.load(r.second.betrag);
      this.secondPositionen.load(r.second.positionen);
    }
  }, adjustFields:function() {
    var leistung = this.task.leistung.submitValue();
    var text1, text2;
    if (leistung === 'Z07') {
      text1 = 'Kauf';
      text2 = 'Nutzung';
    } else {
      text1 = 'Nutzung';
      text2 = 'Kauf';
    }
    this.task.positionenAngebot.setTitle(this.hasSecond ? 'Angebot ' + text1 : 'Angebot');
    if (this.hasSecond) {
      this.beides.setText(this.removeAngebotText);
      this.task.betrag.setLabel('Betrag ' + text1 + ':');
      this.betrag2 = this.task.newBetrag({fieldLabel:'Betrag ' + text2});
      this.betrag2.on('change', function() {
        this.fireEvent('change', this);
      }, this);
      this.task.form.add(this.betrag2.field);
      this.secondPositionen = this.task.newPositionen({title:'Angebot ' + text2});
      this.secondPositionen.on('change', function() {
        this.calculateBetrag();
        this.fireEvent('change', this);
      }, this);
      this.task.tabs.insert(this.task.tabs.items.indexOf(this.task.positionenAngebot.root) + 1, this.secondPositionen.root);
    } else {
      this.beides.setText(this.addAngebotText);
      this.task.betrag.setLabel('Betrag:');
      if (this.betrag2) {
        this.task.form.remove(this.betrag2.field);
        delete this.betrag2;
      }
      if (this.secondPositionen) {
        this.secondPositionen.root.ownerCt.remove(this.secondPositionen.root);
        delete this.secondPositionen;
      }
    }
  }, calculateBetrag:function() {
    if (this.secondPositionen) {
      this.betrag2.load(this.task.betragSum(this.secondPositionen));
    }
  }, addFields:function(into) {
    into.push(this.beides);
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    var l = this.task.leistung.submitValue();
    x.atom('leistung', l);
    if (this.hasSecond) {
      x.begin('second', 'tuple');
      x.subXML(this.task.ansprechpartner.submitValue());
      x.atom('leistung', l == 'Z07' ? 'Z08' : 'Z07');
      x.encodedAtom('waehrung', this.task.waehrung.submitValue());
      x.begin('positionen', 'relation');
      x.subXML(this.secondPositionen.submitValue());
      x.end('positionen');
      x.encodedAtom('betrag', this.betrag2.submitValue());
      x.end('second');
    }
    return x.result();
  }});
  WIM.GER_UEBERNAHME_EIN_IN_Task = Ext.extend(WIM.ProcessTask, {ansprechpartnerRequired:true, acceptOnly:true, initialize:function(config) {
    this.leistung = new WIM.QualifierChoice({noSubmit:true, fieldLabel:'Leistung', values:WIM.QQQ.GER.leistungbestellung, allowBlank:false});
    this.waehrung = new WIM.BasicChoice({name:'waehrung', fieldLabel:'Währung', initialValue:'EUR', allowBlank:false, store:['EUR']});
    this.positionenAngebot = this.newPositionen({title:'Angebot'});
    this.betrag = this.newBetrag({});
    this.secondComponent = new WIM.SecondUebernahmeComponent({task:this});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.leistung);
    this.addComponent(this.secondComponent);
    this.addComponent(this.waehrung);
    this.addComponent(this.betrag);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addComponent(this.positionenAngebot);
    this.addFormularTab(formItems);
    this.processView = new WIM.GeraeteuebernahmeView({hiddenFields:['LEISTUNG', 'WAEHRUNG', 'BETRAG', 'BETRAGBESTELLUNG', 'ANTWORTBESTELLUNG', 'VORGANGQUOTES', 'VORGANGORDERS']});
    this.addTab(this.processView.root);
    this.addTab(this.positionenAngebot.root);
    this.positionenAngebot.on('change', this.calculateBetrag, this);
    this.form.on('activate', this.calculateBetrag, this);
  }, newBetrag:function(config) {
    return new WIM.TextField({maxLength:35, name:'betrag', fieldLabel:config.fieldLabel || 'Betrag', allowBlank:false, noRegex:true, fieldClass:WIM.PreisFieldOptional});
  }, isRecordValid:function(r) {
    if (r.data.leistung === 'Z09') {
      return true;
    }
    if (Ext.isEmpty(r.data.baujahr) && Ext.isEmpty(r.data.verkehrsjahr) || Ext.isEmpty(r.data.preis) || Ext.isEmpty(r.data.betrag) || Ext.isEmpty(r.data.anzahl)) {
      return false;
    }
    return true;
  }, newPositionen:function(config) {
    var columns = [].concat(WIM.AngebotView.angebotColumns);
    columns.splice(0, 1);
    var isRecordValid = this.isRecordValid.bind(this);
    return new WIM.BasicGrid({name:'positionen', title:config.title || 'Angebot', columns:columns, createZeile:true, width:800, height:300, editContext:{create:function(grid, record) {
      var p = new mpm.packages.wim.AngebotForm({});
      p.create(grid.store, new grid.store.model({anzahl:1}));
    }, edit:function(grid, record) {
      var p = new mpm.packages.wim.AngebotForm({});
      p.edit(record);
    }, remove:function(grid, record) {
      grid.store.remove(record);
    }}, forceRow:true, isRecordValid:isRecordValid, submitValue:function() {
      var x = new WIM.XMLOutput();
      this.grid.store.each(function(a, index) {
        x.begin('position', 'tuple');
        x.atom('zeile', index + 1);
        Ext.each(a.getFields(), function(f) {
          var name = f.name;
          if (name != 'zaehleinrichtung' && name != 'wandler' && name != 'mengenumwerter' && name != 'kommunikationseinrichtung' && name != 'technischesteuereinrichtung' && name != 'seriennummern' && name != 'geraetenummern') {
            x.atom(name, a.data[name]);
          }
        }, this);
        x.begin('seriennummern', 'array');
        Ext.each(a.data.seriennummern, function(s) {
          if (!Ext.isEmpty(s)) {
            x.atom('item', s);
          }
        }, this);
        x.end('seriennummern');
        x.begin('geraetenummern', 'array');
        Ext.each(a.data.geraetenummern, function(s) {
          if (!Ext.isEmpty(s)) {
            x.atom('item', s);
          }
        }, this);
        x.end('geraetenummern');
        if (a.data.zaehleinrichtung) {
          x.begin('zaehleinrichtung', 'tuple');
          x.atom('typ', a.data.zaehleinrichtung.typ);
          x.atom('groesse', a.data.zaehleinrichtung.groesse);
          x.atom('tarif', a.data.zaehleinrichtung.tarif);
          x.atom('richtung', a.data.zaehleinrichtung.richtung);
          x.atom('befestigungsart', a.data.zaehleinrichtung.befestigungsart);
          x.atom('fernschaltung', a.data.zaehleinrichtung.fernschaltung);
          x.end('zaehleinrichtung');
        }
        if (a.data.wandler) {
          x.begin('wandler', 'tuple');
          x.atom('typ', a.data.wandler.typ);
          x.atom('konstante', a.data.wandler.konstante);
          x.end('wandler');
        }
        if (a.data.mengenumwerter) {
          x.begin('mengenumwerter', 'tuple');
          x.atom('typ', a.data.mengenumwerter.typ);
          x.end('mengenumwerter');
        }
        if (a.data.kommunikationseinrichtung) {
          x.begin('kommunikationseinrichtung', 'tuple');
          x.atom('typ', a.data.kommunikationseinrichtung.typ);
          x.end('kommunikationseinrichtung');
        }
        if (a.data.technischesteuereinrichtung) {
          x.begin('technischesteuereinrichtung', 'tuple');
          x.atom('typ', a.data.technischesteuereinrichtung.typ);
          x.end('technischesteuereinrichtung');
        }
        x.end('position');
      }, this);
      return x.result();
    }});
  }, betragSum:function(component) {
    var betrag = 0;
    component.grid.store.each(function(r) {
      if (r.data.leistung !== 'Z09') {
        betrag += parseFloat(r.data.preis) * r.data.anzahl;
      }
    }, this);
    return isNaN(betrag) ? '' : betrag.toFixed(2);
  }, calculateBetrag:function() {
    this.betrag.load(this.betragSum(this.positionenAngebot));
  }, loadedData:function(root) {
    this.processView.load(root);
    this.callParent(arguments);
    this.calculateBetrag();
  }, loadedZaehlpunkt:function(zpChanged) {
    if (this.positionenAngebot.store.data.length == 0) {
      var angebot = [];
      this.positionenAngebot.loaded = false;
      var defaults = {artikelnummer:'', anzahl:'1', baujahr:'', verkehrsjahr:'', eichjahr:'', seriennummern:[], befestigungsart:'', messwerterfassung:'', betrag:'', preis:'', leistung:'', geraetenummern:[], zaehleinrichtung:null, wandler:null, kommunikationseinrichtung:null, technischesteuereinrichtung:null};
      try {
        Ext.each(this.zaehlpunkt.data.positionen.zaehleinrichtungen, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.zaehleinrichtung, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, zaehleinrichtung:{typ:g.typ, groesse:g.groesse, tarif:g.tarif, richtung:g.richtung, befestigungsart:g.befestigungsart, fernschaltung:g.fernschaltung}, messwerterfassung:g.messwerterfassung, geraetenummern:g.geraetenummern}, defaults));
        }, this);
        Ext.each(this.zaehlpunkt.data.positionen.wandler, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.wandler, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, wandler:{typ:g.typ, konstante:g.konstante}, geraetenummern:g.geraetenummern}, defaults));
        }, this);
        Ext.each(this.zaehlpunkt.data.positionen.kommunikationseinrichtungen, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.kommunikationseinrichtung, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, kommunikationseinrichtung:{typ:g.typ}, geraetenummern:g.geraetenummern}, defaults));
        }, this);
        Ext.each(this.zaehlpunkt.data.positionen.technischesteuereinrichtungen, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.technischesteuereinrichtung, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, technischesteuereinrichtung:{typ:g.typ}, geraetenummern:g.geraetenummern}, defaults));
        }, this);
        Ext.each(this.zaehlpunkt.data.positionen.smartmetergateways, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.smartmetergateway, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, smartmetergateway:{msb:g.msb}, geraetenummern:g.geraetenummern}, defaults));
        }, this);
        Ext.each(this.zaehlpunkt.data.positionen.steuerboxen, function(g) {
          angebot.push(Ext.apply({}, {artikelnummer:WIM.Artikelnummer.steuerbox, baujahr:g.baujahr, verkehrsjahr:g.verkehrsjahr, eichjahr:g.eichjahr, steuerbox:{}, geraetenummern:g.geraetenummern}, defaults));
        }, this);
      } catch (e) {
        Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
      }
      this.positionenAngebot.loadInitial(angebot);
    }
    this.checkCurrentMSB();
  }});
  WIM.GER_UEBERNAHME_EIN_BESTELLUNG_IN_Task = Ext.extend(WIM.ProcessTask, {ansprechpartnerRequired:true, initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({fieldLabel:'Antwortstatus', name:'antwortbestellung', textFunction:WIM.QQQ.GER.antwortbestellungQText, items:[{key:'Z13', accept:true}, {key:'5'}, {key:'Z32'}]});
    this.addComponent(this.antwortstatus);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.ansprechpartner);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.processView = new WIM.GeraeteuebernahmeView({hiddenFields:['ANTWORTBESTELLUNG']});
    this.addTab(this.processView.root);
    this.bestellungView = new WIM.BestellungView({});
    this.addTab(this.bestellungView.root);
    this.angebotView = new WIM.AngebotView({});
    this.addTab(this.angebotView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.bestellungView.load(root);
    this.angebotView.load(root);
    this.callParent(arguments);
  }});
  WIM.GER_UEBERNAHME_EIN_EINBAU_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.datumskorrektur = new WIM.DateComponent({fieldLabel:'Terminkorrektur', name:'datumeinbau', allowBlank:true});
    this.addComponent(this.datumskorrektur);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.processView = new WIM.GeraeteuebernahmeView({});
    this.addTab(this.processView.root);
    this.bestellungView = new WIM.BestellungView({});
    this.addTab(this.bestellungView.root);
    this.angebotView = new WIM.AngebotView({});
    this.addTab(this.angebotView.root);
  }, loadedData:function(root) {
    this.processView.load(root);
    this.bestellungView.load(root);
    this.angebotView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root);
    if (Ext.isEmpty(this.datumskorrektur.submitValue())) {
      this.datumskorrektur.load(root.data.LOG.DATUM);
    }
  }});
  WIM.STM_MELDUNG_Task = Ext.extend(WIM.AdhocTask, {ansprechpartnerRequired:true, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {name:'mp', fieldLabel:'Empfänger (MSB)'});
    this.freitext = new WIM.TextArea({width:400, height:150, name:'freitext', fieldLabel:'Freitext'});
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', maxDate:WIM.endOfToday()});
    this.status = new WIM.RadioGroup({name:'status', fieldLabel:'Status', textFunction:WIM.QQQ.STM.statusQText, items:[{value:'Z11'}, {value:'Z12'}], defaultValue:'Z12'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.receiver);
    this.addComponent(this.datum);
    this.addComponent(this.status);
    this.addComponent(this.freitext);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.STM_MELDUNG_ANTWORT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.meldungsView = new WIM.StoerungsMeldungsView({});
    this.addTab(this.meldungsView.root);
  }, loadedData:function(root) {
    this.meldungsView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_MELDUNG_ANTWORT_NEGATIV_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.meldungsView = new WIM.StoerungsMeldungsView({});
    this.addTab(this.meldungsView.root);
  }, loadedData:function(root) {
    this.meldungsView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_MELDUNG_APERAK_IN_Task = WIM.STM_MELDUNG_ANTWORT_NEGATIV_IN_Task;
  WIM.STM_MELDUNG_PRUEFBERICHT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.meldungsView = new WIM.StoerungsMeldungsView({});
    this.addTab(this.meldungsView.root);
    this.berichtView = new WIM.StoerungsBerichtView({});
    this.addTab(this.berichtView.root);
  }, loadedData:function(root) {
    this.meldungsView.load(root);
    this.berichtView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_MELDUNG_IN_Task = Ext.extend(WIM.ProcessTask, {formularLabelWidth:170, initialize:function(config) {
    this.NB = WIM.newNBComponent(this);
    this.freitext = new WIM.TextArea({width:400, height:150, name:'freitext', fieldLabel:'Freitext'});
    this.datumgeplant = new WIM.DateComponent({name:'datumgeplant', fieldLabel:'Datum (Behebung geplant)', minDate:WIM.startOfToday()});
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.STM.antwortstatusQText, items:[{key:'E15', accept:true}, {key:'Z29', exclusive:true}, {key:'ZB8', exclusive:true}]});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datumgeplant);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.freitext);
    this.addComponent(this.NB);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.meldungsView = new WIM.StoerungsMeldungsView({hiddenFields:['ANSPRECHPARTNERINTERN'], answerHidden:true});
    this.addTab(this.meldungsView.root);
  }, loadedData:function(root) {
    this.meldungsView.load(root);
    this.NB.setAllowBlank(root.data.LOG.OWN_GZ === 'JA');
    this.callParent(arguments);
  }});
  WIM.STM_MELDUNG_PRUEFUNG_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    var formItems = this.newFormItems();
    this.berichtstatus = new WIM.RadioGroup({name:'berichtstatus', fieldLabel:'Status', items:[{value:'ZB8', boxLabel:'Keine Störung'}, {value:'Z09', boxLabel:'Störung behoben ohne Gerätewechsel'}, {value:'Z78', boxLabel:'Störung behoben mit Gerätewechsel'}, {value:'Z10', boxLabel:'Störung nicht behebbar'}]});
    this.stoerungsanlass = new WIM.RadioGroup({name:'berichtstoerungsanlass', fieldLabel:'Störungsanlass', textFunction:WIM.QQQ.STM.statusanlassQText, items:[{value:'Z75'}, {value:'Z78'}, {value:'Z81'}]});
    this.berichtstatus.on('change', function() {
      this.stoerungsanlass.setDisabled(this.berichtstatus.isChecked('ZB8'));
      this.berichtfreitext.setAllowBlank(!this.berichtstatus.isChecked('Z10'));
    }, this);
    this.berichtdatum = new WIM.DateComponent({name:'berichtdatum', fieldLabel:'Termin', maxDate:WIM.endOfToday()});
    this.berichtfreitext = new WIM.TextArea({name:'berichtfreitext', fieldLabel:'Freitext'});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.berichtstatus);
    this.addComponent(this.stoerungsanlass);
    this.addComponent(this.berichtdatum);
    this.addComponent(this.berichtfreitext);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.meldungsView = new WIM.StoerungsMeldungsView({hiddenFields:['ANSPRECHPARTNERINTERN']});
    this.addTab(this.meldungsView.root);
  }, loadedData:function(root) {
    this.meldungsView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_INFORMATION_OUT_Task = Ext.extend(WIM.AdhocTask, {senderConfig:{submitGrundzustaendigkeit:true}, ansprechpartnerRequired:true, initialize:function(config) {
    this.NB = WIM.newNBComponent(this, {name:'mp'});
    this.sender.on('change', function() {
      this.NB.setAllowBlank(this.sender.isGZ());
    }, this);
    this.freitext = new WIM.TextArea({width:400, height:150, name:'freitext', fieldLabel:'Freitext'});
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Datum (festgestellt)', maxDate:WIM.endOfToday()});
    this.datumgeplant = new WIM.DateComponent({name:'datumgeplant', fieldLabel:'Datum (Behebung geplant)', minDate:WIM.startOfToday()});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.NB);
    this.addComponent(this.datum);
    this.addComponent(this.datumgeplant);
    this.addComponent(this.freitext);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.STM_INFORMATION_PRUEFUNG_OUT_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    var formItems = this.newFormItems();
    this.berichtstatus = new WIM.RadioGroup({name:'berichtstatus', fieldLabel:'Status', items:[{value:'ZB8', boxLabel:'Keine Störung'}, {value:'Z09', boxLabel:'Störung behoben ohne Gerätewechsel'}, {value:'Z78', boxLabel:'Störung behoben mit Gerätewechsel'}, {value:'Z10', boxLabel:'Störung nicht behebbar'}]});
    this.stoerungsanlass = new WIM.RadioGroup({name:'berichtstoerungsanlass', fieldLabel:'Störungsanlass', textFunction:WIM.QQQ.STM.statusanlassQText, items:[{value:'Z75'}, {value:'Z78'}, {value:'Z81'}]});
    this.berichtstatus.on('change', function() {
      this.stoerungsanlass.setDisabled(this.berichtstatus.isChecked('ZB8'));
      this.berichtfreitext.setAllowBlank(!this.berichtstatus.isChecked('Z10'));
    }, this);
    this.berichtdatum = new WIM.DateComponent({name:'berichtdatum', fieldLabel:'Datum', maxDate:WIM.endOfToday()});
    this.berichtfreitext = new WIM.TextArea({name:'berichtfreitext', fieldLabel:'Freitext'});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.berichtstatus);
    this.addComponent(this.stoerungsanlass);
    this.addComponent(this.berichtdatum);
    this.addComponent(this.berichtfreitext);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.informationsView = new WIM.StoerungsInformationsView({hiddenFields:['ANSPRECHPARTNERINTERN', 'ANSPRECHPARTNEREXTERN']});
    this.addTab(this.informationsView.root);
  }, loadedData:function(root) {
    this.informationsView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_INFORMATION_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.informationsView = new WIM.StoerungsInformationsView({hiddenFields:['ANSPRECHPARTNERINTERN']});
    this.addTab(this.informationsView.root);
  }, loadedData:function(root) {
    this.informationsView.load(root);
    this.callParent(arguments);
  }});
  WIM.STM_INFORMATION_PRUEFBERICHT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.informationsView = new WIM.StoerungsInformationsView({hiddenFields:['ANSPRECHPARTNERINTERN']});
    this.addTab(this.informationsView.root);
    this.berichtView = new WIM.StoerungsBerichtView({});
    this.addTab(this.berichtView.root);
  }, loadedData:function(root) {
    this.informationsView.load(root);
    this.berichtView.load(root);
    this.callParent(arguments);
  }});
  WIM.GED_SDANFRAGE_IN_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'BEMERKUNGANTWORT'], initialize:function(config) {
    this.noUpdateAntwortstatus = true;
    this.antwortstatus = new WIM.Antwortstatus({fieldLabel:'Aktion/Ablehnungsgrund', textFunction:WIM.QQQ.GED.antwortstammdatenQText, items:[{key:'', accept:true}, {key:'Z15'}]});
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.antwortstatus.on('change', function() {
      this.bemerkung.setDisabled(this.antwortstatus.isChecked('Z15'));
    }, this);
    this.role = new WIM.BasicChoice({name:'role', fieldLabel:'eigene Rolle', allowBlank:false, store:['NB', 'MSB']});
    this.addComponent(this.role);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.meldepunkteContext = new WIM.MeldepunkteContext({fields:[this.zaehlpunkt]});
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({name:'marktpartnerxml', meldepunkteContext:this.meldepunkteContext, forceRow:false, readOnly:false, MSB0DisplayOnly:true, MSB:{name:'msb', fieldLabel:'MSB', noProcessValue:true, grundzustaendigkeit:true}});
    this.addComponent(this.marktpartnerGridView);
    this.addFormularTab(formItems);
    this.addTab(this.marktpartnerGridView.root);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten'});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:false, noAdresse:true, forceMessstelle:true, canAlwaysReject:true, allowBlankKunde:true});
    this.addTab(this.adressenView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
  }, noZaehlpunkt:function(root) {
    this.installZaehlpunktIdentifikation();
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerGridView.loadprocess(root.data.LOG);
    this.adressenView.load(root);
    this.meldepunkteView.load(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.marktpartnerGridView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e$7) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
  }, noBackend:function() {
    this.adressenView.noBackend();
    this.geraetedatenView.noBackend();
  }});
  WIM.GED_SDANTWORT_ABLEHNUNG_Task = Ext.extend(WIM.MSBMDLQuittierTask, {loadErrorSuppressed:true, loadedZaehlpunkt:function(zpChanged) {
    this.zaehlpunkt.showSuppressedError(this.zaehlpunktInitialValue);
  }});
  WIM.GED_SDANTWORT_APERAK_Task = Ext.extend(WIM.MSBMDLQuittierTask, {noZaehlpunkt:function() {
  }});
  WIM.GED_SDANFRAGE_ANTWORT_Task = Ext.extend(WIM.MSBMDLQuittierTask, {loadErrorSuppressed:true, formularLabelWidth:1, initialize:function(config) {
    this.callParent(arguments);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten'});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
    this.meldepunkteContext = new WIM.MeldepunkteContext({store:this.meldepunkteView.store, fields:[this.zaehlpunkt]});
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({rooted:true, meldepunkteContext:this.meldepunkteContext, MSB:{name:'msb', fieldLabel:'MSB', grundzustaendigkeit:true}, LF:{name:'lf', fieldLabel:'LF'}});
    this.addComponent(this.marktpartnerGridView);
    this.addTab(this.marktpartnerGridView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, diff:true});
    this.addTab(this.adressenView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true});
    this.addTab(this.geraetedatenView.root);
    this.addComponent(this.geraetedatenView);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.adressenView.load(root);
    this.marktpartnerGridView.loadprocessDetail(root);
    this.meldepunkteView.load(root);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
    if (this.stammdatenSchreibenEnabled) {
      this.backendText = new Ext.form.field.Display({value:'Ggfs. ist die Übernahme im Backend manuell zu prüfen oder zu korrigieren.'});
      var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Daten ins Backend schreiben', name:'setZaehlpunktBackend'});
      this.addComponent(setZaehlpunktBackend);
      this.addFormularTab([setZaehlpunktBackend.field, new Ext.Container({height:10}), this.backendText]);
      this.tabs.setActiveTab(0);
      this.installBackendFehler(root);
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.zaehlpunkt.showSuppressedError(this.zaehlpunktInitialValue);
    if (this.stammdatenSchreibenEnabled) {
      if (Ext.isEmpty(this.zaehlpunktInitialValue) && this.zaehlpunkt.data.zaehlpunkt == undefined) {
        this.backendText.setValue('Der Zählpunkt existiert im Backend nicht und wird bei Bestätigung angelegt.');
        this.addComponent(new WIM.FixedComponent({name:'createZaehlpunktBackend', value:'true'}));
      }
      if ((this.zaehlpunkt.data.mdl_status == 'MDL' || this.zaehlpunkt.data.mdl_status == 'MDLN') && (this.zaehlpunkt.data.msb_status == 'MSB' || this.zaehlpunkt.data.msb_status == 'MSBN' || this.zaehlpunkt.data.nb_status == 'ja')) {
        var text = new Ext.form.field.Display({value:'Anscheinend wird der Zählpunkt nicht nur als MDL betrieben. Daher würde durch Schreiben der Gerätedaten ins Backend eventuell Daten überschrieben. Bitte prüfen Sie die Gerätedaten und bestätigen Sie die Übernahme manuell.'});
        var check = new WIM.Checkbox({boxLabel:'Gerätedaten ins Backend schreiben', name:'changePositionenBackend'});
        this.addComponent(check);
        this.form.add(new Ext.Container({height:10}));
        this.form.add(text);
        this.form.add(new Ext.Container({height:10}));
        this.form.add(check.field);
      }
    }
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
  }});
  WIM.GED_SDANFRAGE_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.zaehlpunkt.on('change', this.updateAdresseRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Zählpunkt unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateAdresseRequired();
    }, this);
    this.receiver = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:false, noProcessValue:true, name:'mp', fieldLabel:'Empfänger'});
    this.zaehlernummern = new WIM.EditableList({name:'zaehlernummern', fieldLabel:'Zählernummern', columnName:'Zählernummer', diff:true, forceRow:false, height:120, noProcessValue:true});
    this.hinweis = new WIM.TextArea({width:400, height:150, name:'hinweis', fieldLabel:'Hinweis', diff:true, noProcessValue:true});
    this.lieferrichtung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'lieferrichtung', fieldLabel:'Lieferrichtung', noProcessValue:true, values:WIM.QQQ.SD.lieferrichtung});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.zaehlernummern);
    this.addComponent(this.lieferrichtung);
    this.addComponent(this.hinweis);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:false, noProcessValue:true});
    this.addTab(this.adressenView.root);
  }, updateAdresseRequired:function() {
    this.adressenView.setForceAdresse(Ext.isEmpty(this.zaehlpunkt.submitValue()));
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
      this.hinweis.loadSD(this.zaehlpunkt.data.hinweis, zpChanged);
      this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.zaehlernummern.noBackend();
    this.hinweis.noBackend();
    this.adressenView.noBackend();
  }});
  WIM.GED_MDANFRAGE_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receiver = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:false, noProcessValue:true, name:'mp', fieldLabel:'Empfänger'});
    this.datum = new WIM.DateTimeComponent({fieldLabel:'Zeitpunkt/Termin (von)', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.datumbis = new WIM.DateTimeComponent({fieldLabel:'Termin (bis)', name:'datumbis', allowBlank:true, maxDate:WIM.endOfToday()});
    this.leistung = new WIM.QualifierChoice({noSubmit:true, fieldLabel:'Leistung', values:WIM.QQQ.GED.anfragemesswerte, allowBlank:false});
    this.leistung.on('change', function() {
      if (this.leistung.submitValue() == 'Z11') {
        this.datum.setTimeDisabled(false);
        this.datumbis.setTimeDisabled(false);
      } else {
        this.datum.setTimeDisabled(true);
        this.datumbis.setTimeDisabled(true);
      }
    }, this);
    this.lieferrichtung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'lieferrichtung', fieldLabel:'Lieferrichtung', noProcessValue:true, values:WIM.QQQ.SD.lieferrichtung});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.leistung);
    this.addComponent(this.datum);
    this.addComponent(this.datumbis);
    this.addComponent(this.lieferrichtung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GED_MDANFORDERUNG_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {name:'mp', fieldLabel:'Empfänger (MSB)'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false});
    this.ablesegrund = new WIM.RadioGroup({name:'ablesegrund', fieldLabel:'Ablesegrund', textFunction:WIM.QQQ.GED.ablesegrundQText, items:[{value:'ABZ'}, {value:'CMP'}, {value:'COB'}, {value:'COS'}, {value:'COT'}, {value:'PMR'}, {value:'ABM'}], defaultValue:'COT'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(this.ablesegrund);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GER_AUSTAUSCH_MSBA_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], isGERAustausch:true, initialize:function(config) {
    this.sender = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:true, noSDValue:true, ignoreEmptyProcessValue:true, selbst:true, name:'own', fieldLabel:'Absender', width:this.defaultWidth, NB:true});
    this.receiver = WIM.newMSBComponent(this, {fieldLabel:'Empfänger (MSB)'});
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['VORGANGMDL']});
    this.addTab(this.wechselView.root);
    this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:true, noProcessValue:true, forceRow:true});
    this.abrufenEnde = {process:this.process, typ:'EMV'};
    this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
    var endeItems = [];
    this.addComponent(this.messwerteEnde);
    this.addComponent(this.zaehlernummernEnde);
    this.zaehlernummernEnde.addFields(endeItems);
    this.messwerteEnde.addFields(endeItems);
    this.addTab(this.newFormPanel({labelWidth:140, title:'Endablesewerte', items:endeItems}));
    this.remoteWechselView = new WIM.RemoteWechselView({wimContext:this.wimContext, wechselConfig:{title:'Gerätewechselanfrage', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_WECHSEL_', fromField:'AUSTAUSCHID'}, process:this});
    this.addTab(this.remoteWechselView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufenEnde.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufenEnde.datum = root.data.LOG.DATUM;
    if (this.config.suppressMDL == 'true') {
      this.insertMessage('Die Benachrichtung des MDL in der Konfiguration deaktiviert. Damit löst dieser Prozess keine Nachrichten aus.');
    }
    this.sender.loadProcess(root.data.LOG);
    this.wechselView.load(root);
    this.remoteWechselView.load(root.data.LOG.PROCESSID, this.root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummernEnde.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GER_AUSTAUSCH_MSBN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], isGERAustausch:true, initialize:function(config) {
    this.sender = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:true, noSDValue:true, ignoreEmptyProcessValue:true, selbst:true, name:'own', fieldLabel:'Absender', width:this.defaultWidth, NB:true});
    this.receiver = WIM.newMSBComponent(this, {fieldLabel:'Empfänger (MSB)'});
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['SPANNUNGSEBENEMESSUNG', 'VORGANG', 'VORGANGMDL']});
    this.addTab(this.wechselView.root);
    if (config.mitEndwerten) {
      this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:true, noProcessValue:true, forceRow:true});
      this.abrufenEnde = {process:this.process, typ:'EMV'};
      this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
      var endeItems = [];
      this.addComponent(this.messwerteEnde);
      this.addComponent(this.zaehlernummernEnde);
      this.zaehlernummernEnde.addFields(endeItems);
      this.messwerteEnde.addFields(endeItems);
      this.addTab(this.newFormPanel({labelWidth:140, title:'Endablesewerte', items:endeItems}));
    }
    this.abrufenAnfang = {process:this.process, typ:'SMV'};
    this.messwerteAnfang = new WIM.MesswerteView({name:'anfang_messwertexml', fieldLabel:'Zählerstände (Anfang)', height:150, abrufen:this.abrufenAnfang, forceRow:true});
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this, width:900, height:150});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
    var anfangItems = [];
    this.addComponent(this.messwerteAnfang);
    this.messwerteAnfang.addFields(anfangItems);
    this.addTab(this.newFormPanel({title:'Anfangsablesewerte', items:anfangItems, labelWidth:170}));
    this.remoteWechselView = new WIM.RemoteWechselView({wimContext:this.wimContext, wechselConfig:{title:'Gerätewechselanfrage', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_WECHSEL_', fromField:'AUSTAUSCHID'}, process:this});
    this.addTab(this.remoteWechselView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    if (this.config.suppressMDL == 'true') {
      this.insertMessage('Die Benachrichtung des MDL in der Konfiguration deaktiviert. Damit löst dieser Prozess keine Nachrichten aus.');
    }
    this.messwerteAnfang.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufenAnfang.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufenAnfang.datum = root.data.LOG.DATUM;
    if (this.messwerteEnde) {
      this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
      this.abrufenEnde.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
      this.abrufenEnde.datum = root.data.LOG.DATUM;
    }
    this.sender.loadProcess(root.data.LOG);
    this.wechselView.load(root);
    this.remoteWechselView.load(root.data.LOG.PROCESSID, this.root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen);
      this.messwerteAnfang.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GER_AUSTAUSCH_MSBN_MIT_ENDE_Task = Ext.extend(WIM.GER_AUSTAUSCH_MSBN_Task, {constructor:function(config) {
    config.mitEndwerten = true;
    this.callParent(arguments);
  }});
  WIM.GER_AUSTAUSCH_MSB_Task = Ext.extend(WIM.AdhocTask, {senderConfig:{submitGrundzustaendigkeit:true, MSBGZ:true}, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {fieldLabel:'Empfänger (MSB)'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:false, forceRow:true});
    this.abrufenEnde = {process:this.process, abrufen:function() {
      return {typ:'EMV', datum:this.datum.submitValue(), zaehlpunkt:this.zaehlpunkt.submitValue()};
    }.bind(this)};
    this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
    var endeItems = [];
    this.addComponent(this.messwerteEnde);
    this.addComponent(this.zaehlernummernEnde);
    this.zaehlernummernEnde.addFields(endeItems);
    this.messwerteEnde.addFields(endeItems);
    this.addTab(this.newFormPanel({title:'Endablesewerte', items:endeItems, labelWidth:170}));
    this.abrufenAnfang = {process:this.process, abrufen:function() {
      return {typ:'SMV', datum:this.datum.submitValue(), zaehlpunkt:this.zaehlpunkt.submitValue()};
    }.bind(this)};
    this.messwerteAnfang = new WIM.MesswerteView({name:'anfang_messwertexml', fieldLabel:'Zählerstände (Anfang)', height:150, abrufen:this.abrufenAnfang, forceRow:true});
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
    var anfangItems = [];
    this.addComponent(this.messwerteAnfang);
    this.messwerteAnfang.addFields(anfangItems);
    this.addTab(this.newFormPanel({title:'Anfangsablesewerte', items:anfangItems, labelWidth:170}));
  }, loadedPseudoProcess:function(root) {
    this.callParent(arguments);
    this.messwerteAnfang.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    if (this.config.suppressMDL == 'true') {
      this.insertMessage('Die Benachrichtung des MDL in der Konfiguration deaktiviert. Damit löst dieser Prozess keine Nachrichten aus.');
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
      this.messwerteAnfang.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GED_MSAENDERUNG_Task = Ext.extend(WIM.AdhocTask, {ansprechpartnerRequired:true, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {name:'mp', fieldLabel:'Empfänger (MSB)'});
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Änderungstermin', allowBlank:false, minDate:WIM.startOfToday()});
    this.obis = new WIM.EditableList({maxLength:35, name:'obis', columnName:'OBIS-Kennzahl', fieldLabel:'OBIS-Kennzahlen'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(this.obis);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.derzeitige = new WIM.EditableList({maxLength:35, fieldLabel:'OBIS-Kennzahlen', readOnly:true, diff:false, fieldName:'VALUE', columnName:'OBIS-Kennzahl'});
    var derzeitigeItems = [];
    this.derzeitige.addFields(derzeitigeItems);
    this.derzeitigeTab = this.newFormPanel({title:'Zählpunktinformationen', items:derzeitigeItems});
    this.addTab(this.derzeitigeTab);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.derzeitige.loadSD(this.zaehlpunkt.data.summary.obis, zpChanged);
      this.obis.loadSD(this.zaehlpunkt.data.summary.obis, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.derzeitigeTab.disable();
  }});
  WIM.GED_MW_ANTWORT_ABGELEHNT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, noFormularTab:true, initialize:function(config) {
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
  }});
  WIM.GED_MW_ANTWORT_APERAK_IN_Task = WIM.GED_MW_ANTWORT_ABGELEHNT_IN_Task;
  WIM.GED_MWANFORDERUNG_ANTWORT_ABGELEHNT_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, noFormularTab:true, initialize:function(config) {
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
  }});
  WIM.GED_MWANFORDERUNG_ANTWORT_APERAK_IN_Task = WIM.GED_MWANFORDERUNG_ANTWORT_ABGELEHNT_IN_Task;
  WIM.GED_MW_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.messwerteView = new WIM.MesswerteView({name:'messwertekorrigiertxml', fieldLabel:'Messwerte', height:150, forceRow:true});
    this.sendBack = new WIM.Checkbox({name:'sendBack', boxLabel:'Geprüfte/korrigierte Werte zurückschicken', initialValue:'true'});
    this.sendBack.hasSubmitValue = WIM.trueFunction;
    this.ansprechpartner.setDisabled(!this.sendBack.isChecked());
    this.sendBack.on('change', function() {
      this.ansprechpartner.setDisabled(!this.sendBack.isChecked());
    }, this);
    var formItems = this.newFormItems();
    this.addComponent(this.sendBack);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.messwerteView);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['FEHLERSTATUSANLASS', 'ANSPRECHPARTNERINTERN']});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    if (root.data.LOG.STATUS == 'Storniert') {
      Ext.Msg.alert('Storno', 'Messwerte wurden storniert.');
    }
    this.messwerteProcessView.load(root);
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.callParent(arguments);
    if (this.config.suppressMDL == 'true') {
      this.sendBack.initialValue = false;
      this.sendBack.setDisabled(true);
      this.insertMessage('Die Benachrichtung des MDL in der Konfiguration deaktiviert. Damit löst dieser Prozess keine Nachrichten aus.');
    }
    this.installBackendFehler(root);
  }});
  WIM.GED_MW_TURNUS_GESCHEITERT_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.messwerteView = new WIM.MesswerteView({name:'messwertekorrigiertxml', fieldLabel:'Messwerte', height:150, forceRow:true});
    this.sendBack = new WIM.FixedComponent({name:'sendBack', value:'true'});
    var formItems = this.newFormItems();
    this.zaehlernummern = new WIM.EditableList({noProcessValue:true, forceRow:true, columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:'Zählernummern', diff:true, height:100});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.zaehlernummern);
    this.addComponent(this.messwerteView);
    this.addComponent(this.sendBack);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['ZAEHLERNUMMERN', 'ANSPRECHPARTNERINTERN']});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.messwerteProcessView.load(root);
    if (this.config.suppressMDL == 'true') {
      this.sendBack.setFixedValue('false');
      this.ansprechpartner.setDisabled(true);
      this.insertMessage('Die Benachrichtung des MDL in der Konfiguration deaktiviert. Damit löst dieser Prozess keine Nachrichten aus.');
    }
    this.installBackendFehler(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GED_MWANFORDERUNG_ANTWORT_GESCHEITERT_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.writeBackend = new WIM.Checkbox({name:'writeBackend', boxLabel:'Werte ins Backend schreiben'});
    this.sendBack = new WIM.Checkbox({name:'sendBack', boxLabel:'Geprüfte/korrigierte Werte zurückschicken', initialValue:'true'});
    this.ansprechpartner.setDisabled(!this.sendBack.isChecked());
    this.sendBack.on('change', function() {
      this.ansprechpartner.setDisabled(!this.sendBack.isChecked());
    }, this);
    this.zaehlernummern = new WIM.EditableList({noProcessValue:true, forceRow:true, columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:'Zählernummern', diff:true, height:100});
    var task = this;
    this.messwerteView = new WIM.MesswerteView({name:'messwertekorrigiertxml', fieldLabel:'Messwerte', height:150, forceRow:true, canAccept:function() {
      return WIM.MesswerteView.prototype.canAccept.call(this) || !task.sendBack.isChecked() && !task.writeBackend.isChecked();
    }});
    var formItems = this.newFormItems();
    this.addComponent(this.writeBackend);
    this.addComponent(this.sendBack);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.zaehlernummern);
    this.addComponent(this.messwerteView);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.writeBackend.setDisabled(!this.messwerteSchreibenEnabled);
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.installBackendFehler(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GED_MW_ANTWORT_GESCHEITERT_IN_Task = WIM.GED_MWANFORDERUNG_ANTWORT_GESCHEITERT_IN_Task;
  WIM.GED_MW_ANTWORT_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.writeBackend = new WIM.Checkbox({name:'writeBackend', boxLabel:'Werte ins Backend schreiben'});
    var task = this;
    this.messwerteView = new WIM.MesswerteView({name:'messwertekorrigiertxml', fieldLabel:'Messwerte', height:150, forceRow:true, canAccept:function() {
      return WIM.MesswerteView.prototype.canAccept.call(this) || !task.writeBackend.isChecked();
    }});
    var formItems = this.newFormItems();
    this.addComponent(this.writeBackend);
    this.addComponent(this.messwerteView);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.writeBackend.setDisabled(!this.messwerteSchreibenEnabled);
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.installBackendFehler(root);
  }});
  WIM.GED_MWANFORDERUNG_ANTWORT_IN_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, initialize:function(config) {
    this.writeBackend = new WIM.Checkbox({name:'writeBackend', boxLabel:'Werte ins Backend schreiben'});
    this.sendBack = new WIM.Checkbox({name:'sendBack', boxLabel:'Geprüfte/korrigierte Werte zurückschicken'});
    this.ansprechpartner.setDisabled(true);
    this.sendBack.on('change', function() {
      this.ansprechpartner.setDisabled(!this.sendBack.isChecked());
    }, this);
    var task = this;
    this.messwerteView = new WIM.MesswerteView({name:'messwertekorrigiertxml', fieldLabel:'Messwerte', height:150, forceRow:true, canAccept:function() {
      return WIM.MesswerteView.prototype.canAccept.call(this) || !task.sendBack.isChecked() && !task.writeBackend.isChecked();
    }});
    var formItems = this.newFormItems();
    this.addComponent(this.writeBackend);
    this.addComponent(this.sendBack);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.messwerteView);
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.writeBackend.setDisabled(!this.messwerteSchreibenEnabled);
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.installBackendFehler(root);
  }});
  WIM.GED_MWANFRAGE_IN_Task = Ext.extend(WIM.ProcessTask, {initialize:function(config) {
    this.zaehlernummern = new WIM.EditableList({name:'zaehlernummern', fieldLabel:'Zählernummern', columnName:'Zählernummer', diff:true, forceRow:true, height:120});
    this.abrufen = {process:this.process, typ:'MRV'};
    var leistung = Ext.valuesFrom(this.values.LEISTUNG, '');
    this.messwerteView = new WIM.MesswerteView({name:'messwertexml', title:'Messwerte', height:150, abrufen:this.abrufen, forceRow:true, leistung:leistung});
    this.ablesegrund = new WIM.QualifierChoice({diff:true, allowBlank:false, ignoreEmptyProcessValue:true, name:'ablesegrund', fieldLabel:'Ablesegrund', noSDValue:true, values:WIM.QQQ.GED.ablesegrund});
    this.ablesetyp = new WIM.QualifierChoice({diff:true, allowBlank:false, ignoreEmptyProcessValue:true, name:'ablesetyp', fieldLabel:'Ablesetyp', noSDValue:true, values:WIM.QQQ.GED.ablesetyp});
    if (leistung == 'Z11' || leistung == 'Z12') {
      this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.GED.antwortmesswerteQText, fieldLabel:'Aktion/Ablehnungsgrund', items:[{key:'', accept:true, exclusive:true}, {key:'A01', exclusive:true}, {key:'A02', exclusive:true}, {key:'A03', exclusive:true}, {key:'A04', exclusive:true}, {key:'Z15', exclusive:true}, {key:'Z21', exclusive:true}]});
    } else {
      this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.GED.antwortmesswerteQText, fieldLabel:'Aktion/Ablehnungsgrund', items:[{key:'', accept:true, exclusive:true}, {key:'Z23', exclusive:true}, {key:'Z24', exclusive:true}, {key:'Z25', exclusive:true}, {key:'Z26', exclusive:true}, {key:'Z27', exclusive:true}, {key:'Z28', exclusive:true}, {key:'Z29', exclusive:true}, {key:'Z30', exclusive:true}, {key:'Z31', exclusive:true}, {key:'ZD7', exclusive:true}, {key:'ZD8', exclusive:true}]});
    }
    var formItems = this.newFormItems();
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.ablesegrund);
    this.addComponent(this.ablesetyp);
    this.addComponent(this.zaehlernummern);
    this.addComponent(this.antwortstatus);
    this.addComponentFields(formItems);
    this.addComponent(this.messwerteView);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['ANSPRECHPARTNERINTERN', 'ZAEHLERNUMMERN', 'ABLESETYP', 'FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
    this.addTab(this.messwerteView.root);
  }, loadedData:function(root) {
    this.messwerteView.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufen.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufen.datum = root.data.LOG.DATUM;
    this.messwerteProcessView.load(root);
    this.zaehlernummern.loadProcess(root.data.LOG.ZAEHLERNUMMERN);
    this.ablesegrund.loadProcess(root.data.LOG.ABLESEGRUND);
    this.callParent(arguments);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.GED_REKLAMATION_IN_Task = Ext.extend(WIM.ProcessTask, {ansprechpartnerRequired:true, initialize:function(config) {
    var leistung = Ext.valueFrom(this.values.LEISTUNG, '');
    this.messwerteView = new WIM.ReklamationMesswerteView({name:'messwertexml', title:'Reklamierte Werte', height:150, abrufen:true, forceRow:false, readOnly:true, leistung:leistung});
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.GED.antwortreklamationQText, fieldLabel:'Aktion/Ablehnungsgrund', items:[{key:'', accept:true, exclusive:true}, {key:'Z54', exclusive:true}, {key:'Z55', exclusive:true}]});
    this.ansprechpartner.setDisabled(true);
    this.antwortstatus.on('change', function() {
      this.ansprechpartner.setDisabled(!this.antwortstatus.canReject());
    }, this);
    var formItems = this.newFormItems();
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.antwortstatus);
    this.addComponentFields(formItems);
    this.addComponent(this.messwerteView);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['ANSPRECHPARTNERINTERN', 'ZAEHLERNUMMERN', 'ABLESETYP', 'FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
    this.addTab(this.messwerteView.root);
  }, loadedData:function(root) {
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
  }});
  WIM.GER_ENDABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], isGERAustausch:true, initialize:function(config) {
    this.datumskorrektur = new WIM.DateComponent({fieldLabel:'Terminkorrektur', name:'datumausbau', allowBlank:true});
    this.addComponent(this.datumskorrektur);
    this.zaehlernummern = new WIM.EditableList({name:'zaehlernummern', fieldLabel:'Zählernummern', readOnly:true, diff:false, height:70});
    this.addComponent(this.zaehlernummern);
    this.messwerteView = new WIM.MesswerteView({name:'messwertexml', fieldLabel:'Messwerte', height:150, forceRow:true});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.messwerteView);
    var formItems = this.newFormItems();
    this.datumskorrektur.addFields(formItems);
    this.ansprechpartner.addFields(formItems);
    this.zaehlernummern.addFields(formItems);
    formItems.push(this.messwerteView.root);
    this.addFormularTab(formItems);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['VORGANGMDL']});
    this.addTab(this.wechselView.root);
  }, loadedData:function(root) {
    this.datumskorrektur.load(root.data.LOG.DATUM);
    this.zaehlernummern.load(root.data.LOG.ENDE_ZAEHLERNUMMERNXML);
    this.wechselView.load(root);
    this.messwerteView.loadInitial(root.data.LOG.ENDE_MESSWERTEXML);
    this.callParent(arguments);
    this.installBackendFehler(root, 'ENDE_BACKEND_FEHLER');
  }});
  WIM.GER_ANFANGSABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], isGERAustausch:true, initialize:function(config) {
    this.datumskorrektur = new WIM.DateComponent({fieldLabel:'Terminkorrektur', name:'datumeinbau', allowBlank:true});
    this.addComponent(this.datumskorrektur);
    this.addComponent(this.ansprechpartner);
    this.zaehlernummern = new WIM.EditableList({name:'zaehlernummern', fieldLabel:'Zählernummern', readOnly:true, diff:false, height:70});
    this.addComponent(this.zaehlernummern);
    this.messwerteView = new WIM.MesswerteView({name:'messwertexml', fieldLabel:'Messwerte', height:150, forceRow:true});
    this.addComponent(this.messwerteView);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this});
    this.addComponent(this.geraetedatenView);
    var formItems = this.newFormItems();
    this.datumskorrektur.addFields(formItems);
    this.ansprechpartner.addFields(formItems);
    this.zaehlernummern.addFields(formItems);
    formItems.push(this.messwerteView.root);
    this.addFormularTab(formItems);
    this.addTab(this.geraetedatenView.root);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['VORGANGMDL']});
    this.addTab(this.wechselView.root);
  }, loadedData:function(root) {
    this.zaehlernummern.load(root.data.LOG.ANFANG_ZAEHLERNUMMERNXML);
    this.messwerteView.loadInitial(root.data.LOG.ANFANG_MESSWERTEXML);
    this.wechselView.load(root);
    this.geraetedatenView.loadInitial(root.data.LOG.POSITIONENXML);
    this.callParent(arguments);
    this.installBackendFehler(root, 'ANFANG_BACKEND_FEHLER');
  }, loadedZaehlpunkt:function(zpChanged) {
  }});
  WIM.GED_MW_STORNO_IN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.addFormularTab([]);
  }});
  WIM.GED_SDAENDERUNG_AUS_OUT_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receivers = new WIM.ZaehlpunktMarktpartnerList({task:this, fieldLabel:'Empfänger', name:'receivers'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false});
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkung', fieldLabel:'Bemerkung'});
    this.role = new WIM.BasicChoice({name:'role', fieldLabel:'eigene Rolle', allowBlank:false, store:['NB', 'MSB']});
    this.role.on('change', function() {
      this.stammdatenView.setRestrictedByRole(this.role.submitValue());
    }, this);
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.role);
    this.addComponent(this.sender);
    this.addComponent(this.receivers);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, defaultKategorie:'E03'});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:false, noProcessValue:true});
    this.addTab(this.adressenView.root);
    var emptyLog = {data:{LOG:{}, CHILDLOG:[]}};
    this.stammdatenView.load(emptyLog);
    this.adressenView.load(emptyLog);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }});
  WIM.GED_SDAENDERUNG_ANTWORT_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, initialize:function(config) {
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true});
    this.addTab(this.adressenView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.stammdatenView.load(root);
    this.adressenView.load(root);
  }});
  WIM.GED_SDAENDERUNG_ABLEHNUNG_Task = WIM.GED_SDAENDERUNG_ANTWORT_Task;
  WIM.GED_SDAENDERUNG_APERAK_Task = WIM.GED_SDAENDERUNG_ABLEHNUNG_Task;
  WIM.GED_SDAENDERUNG_IN_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'BEMERKUNGANTWORT'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E15', accept:true, exclusive:true}, {key:'E11'}, {key:'E14'}, {key:'E17'}, {key:'Z07'}, {key:'Z09'}, {key:'Z11'}]});
    this.antwortstatus.on('change', function() {
      this.bemerkung.setAllowBlank(!this.antwortstatus.isChecked('E14'));
    }, this);
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten'});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, forceAdresse:false, forceMessstelle:false, allowBlankKunde:true, diff:true, task:this});
    this.addTab(this.adressenView.root);
    this.meldepunkteContext = new WIM.MeldepunkteContext({store:this.meldepunkteView.store, fields:[this.zaehlpunkt]});
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({name:'marktpartnerxml', forceRow:false, readOnly:false, meldepunkteContext:this.meldepunkteContext, MSB0DisplayOnly:true, MSB:{name:'msb', fieldLabel:'MSB', grundzustaendigkeit:true}, LF:{allowBlank:true}});
    this.addComponent(this.marktpartnerGridView);
    this.addTab(this.marktpartnerGridView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.meldepunkteView.load(root);
    this.adressenView.load(root);
    this.marktpartnerGridView.loadprocess(root.data.LOG);
    if (this.stammdatenSchreibenEnabled) {
      this.adressenView.setReadOnly(false);
      var text = new Ext.form.field.Display({value:'Bitte führen Sie dazu im Reiter "Adressen" einen Stammdatenabgleich durch. Im weiteren werden leere Felder nicht übertragen. Ggfs. ist die Übernahme im Backend manuell zu prüfen oder zu korrigieren.'});
      var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Änderungen ins Backend schreiben', name:'setZaehlpunktBackend'});
      this.addComponent(setZaehlpunktBackend);
      this.form.add(new Ext.Container({height:20}));
      this.form.add(setZaehlpunktBackend.field);
      this.form.add(new Ext.Container({height:10}));
      this.form.add(text);
      this.installBackendFehler(root);
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.marktpartnerGridView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
  }});
  WIM.GED_SDAENDERUNG_SUPPLIER_INFO_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'BEMERKUNGANTWORT'], quittierenOnly:true, initialize:function(config) {
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({rooted:true, task:this, displayOnly:true, displaySDOnly:false, MSB:{grundzustaendigkeit:true, noProcessValue:true}, LF:{noProcessValue:false, noSDValue:true}});
    this.marktpartnerZPView.addComponentsToTask();
    this.addTab(this.marktpartnerZPView.root);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten'});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
  }});
  WIM.GEDMSAenderungTask = Ext.extend(WIM.ProcessTask, {processHiddenFields:[], initialize:function(config) {
    this.aenderungView = new WIM.MSAenderungView({hiddenFields:this.processHiddenFields});
    this.addTab(this.aenderungView.root);
  }, loadedData:function(root) {
    this.aenderungView.load(root);
    this.callParent(arguments);
  }});
  WIM.GED_MSAENDERUNG_ABLEHNUNG_Task = Ext.extend(WIM.GEDMSAenderungTask, {processHiddenFields:['DATUMVOLLZOGEN', 'UMBAUSTATUS', 'UMBAUSTATUSANLASS'], quittierenOnly:true});
  WIM.GED_MSAENDERUNG_APERAK_Task = Ext.extend(WIM.GEDMSAenderungTask, {processHiddenFields:['ANTWORTSTATUS', 'DATUMKORRIGIERT', 'DATUMVOLLZOGEN', 'UMBAUSTATUS', 'UMBAUSTATUSANLASS'], quittierenOnly:true});
  WIM.GED_MSAENDERUNG_ANNAHME_Task = Ext.extend(WIM.GEDMSAenderungTask, {processHiddenFields:['DATUMVOLLZOGEN', 'UMBAUSTATUS', 'UMBAUSTATUSANLASS'], quittierenOnly:true});
  WIM.GED_MSAENDERUNG_GESCHEITERT_Task = Ext.extend(WIM.GEDMSAenderungTask, {quittierenOnly:true});
  WIM.GED_MSAENDERUNG_VOLLZOGEN_Task = Ext.extend(WIM.GEDMSAenderungTask, {quittierenOnly:true});
  WIM.GED_MSAE_AUFTRAG_IN_Task = Ext.extend(WIM.GEDMSAenderungTask, {ansprechpartnerRequired:true, processHiddenFields:['ANSPRECHPARTNERINTERN', 'DATUMKORRIGIERT', 'ANTWORTSTATUS', 'DATUMVOLLZOGEN', 'UMBAUSTATUS', 'UMBAUSTATUSANLASS'], initialize:function(config) {
    this.callParent(arguments);
    this.datumkorrigiert = new WIM.DateComponent({disabled:true, fieldLabel:'Terminkorrektur', name:'datumkorrigiert', minDate:WIM.startOfToday()});
    this.antwortstatus = new WIM.Antwortstatus({fieldLabel:'Antwortstatus', name:'antwortstatus', textFunction:WIM.QQQ.GED.antwortumbauQText, items:[{key:'Z13', accept:true, exclusive:true}, {key:'Z14', accept:true, exclusive:true}, {key:'Z15', exclusive:true}, {key:'Z17', exclusive:true}, {key:'Z18', exclusive:true}]});
    this.antwortstatus.on('change', function() {
      this.datumkorrigiert.setDisabled(!this.antwortstatus.isChecked('Z14'));
    }, this);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datumkorrigiert);
    this.addComponent(this.antwortstatus);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.GED_MSAE_AUFTRAG_UMBAU_Task = Ext.extend(WIM.GEDMSAenderungTask, {ansprechpartnerRequired:true, processHiddenFields:['DATUMVOLLZOGEN', 'UMBAUSTATUS', 'UMBAUSTATUSANLASS'], acceptOnly:true, initialize:function(config) {
    this.callParent(arguments);
    this.datumvollzogen = new WIM.DateComponent({disabled:true, fieldLabel:'Termin (vollzogen)', name:'datumvollzogen', maxDate:WIM.endOfToday()});
    this.umbaustatus = new WIM.RadioGroup({fieldLabel:'Umbaustatus', name:'umbaustatus', textFunction:WIM.QQQ.GED.umbaustatusQText, items:[{value:'Z13'}, {value:'Z14'}]});
    this.umbaustatus.on('change', function() {
      this.umbaustatusanlass.setDisabled(!this.umbaustatus.isChecked('Z13'));
      this.datumvollzogen.setDisabled(!this.umbaustatus.isChecked('Z14'));
    }, this);
    this.umbaustatusanlass = new WIM.RadioGroup({disabled:true, defaultValue:'', fieldLabel:'Umbaustatusanlass', name:'umbaustatusanlass', textFunction:WIM.QQQ.GED.umbaustatusanlassQText, items:[{value:'Z74'}, {value:'Z75'}]});
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datumvollzogen);
    this.addComponent(this.umbaustatus);
    this.addComponent(this.umbaustatusanlass);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.WIMM_STORNO_Task = Ext.extend(WIM.StornoTask, {stornoprefixes:['WIM_MSB_ANMELDUNGEN_', 'WIM_MSB_ABMELDUNGEN_', 'WIM_MSB_KUENDIGUNGEN_']});
  WIM.WIMM_STORNO_ANGENOMMEN_Task = WIM.MSBMDLQuittierTask;
  WIM.WIMM_STORNO_ABGELEHNT_Task = WIM.MSBMDLQuittierTask;
  WIM.WIM_STORNO_ANGENOMMEN_Task = WIM.MSBMDLQuittierTask;
  WIM.WIM_STORNO_ABGELEHNT_Task = WIM.MSBMDLQuittierTask;
  WIM.WIMMMSBMDLAdhocTask = Ext.extend(WIM.AdhocTask, {isMDL:false, newLeistung:function() {
    return new WIM.RadioGroup({name:'leistung', fieldLabel:'Leistung', defaultValue:'', textFunction:WIM.QQQ.SD.leistungQText, items:[{value:'Z01'}, {value:'Z03'}]});
  }, newBemerkung:function() {
    return new WIM.TextArea({allowBlank:true, name:'bemerkung', fieldLabel:'Bemerkung'});
  }});
  WIM.WIMM_MSB_KUENDIGUNG_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {initialize:function(config) {
    this.zaehlpunkt.on('change', this.updateZaehlernummerRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Zählpunkt unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateZaehlernummerRequired();
    }, this);
    this.isMDL = this.kind == 'WIMM_MDL_KUENDIGUNG_AUS';
    this.receiver = this.isMDL ? WIM.newMDLComponent(this, {name:'mp', fieldLabel:'MDLA'}) : WIM.newMSBComponent(this, {name:'mp', fieldLabel:'MSBA'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, hint:'00:00 (Strom) bzw. 06:00 (Gas)', minDate:Ext.Date.clearTime(new Date())});
    this.naechstmoeglich = new WIM.Checkbox({name:'datumnaechstmoeglich', fieldLabel:'zum nächstmöglichen Termin'});
    this.addComponent(this.datum);
    this.addComponent(this.naechstmoeglich);
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E03'}, {value:'ZR9'}], defaultValue:'E03'});
    this.addComponent(this.transaktionsgrund);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, defaultKategorie:'E35'});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, noProcessValue:true, forceAdresse:false, noAdresse:true, forceMessstelle:false, noMessstelle:false, noKundenadresse:true, noKundenadresself:true, noKundeLF:true, forceAdresseMSB:false, forceAdresseLF:false});
    this.addTab(this.adressenView.root);
    this.stammdatenView.load({data:{LOG:{HINWEIS:'', ZAEHLERNUMMERN:[]}}});
    this.stammdatenView.setForceZaehlernummer(false);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }, updateZaehlernummerRequired:function() {
    this.stammdatenView.setForceZaehlernummer(Ext.isEmpty(this.zaehlpunkt.submitValue()));
  }});
  WIM.WIMM_MSB_KUENDIGUNG_AUS_ANGENOMMEN_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, loadErrorSuppressed:true, initialize:function(config) {
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true, diff:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, diff:true});
    this.addTab(this.adressenView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.stammdatenView.load(root);
    this.adressenView.load(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.zaehlpunkt.showSuppressedError(this.zaehlpunktInitialValue);
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
  }});
  WIM.WIMM_MSB_KUENDIGUNG_AUS_ABGELEHNT_Task = WIM.WIMM_MSB_KUENDIGUNG_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MSB_KUENDIGUNG_AUS_APERAK_Task = Ext.extend(WIM.WIMM_MSB_KUENDIGUNG_AUS_ABGELEHNT_Task, {noZaehlpunkt:function() {
  }});
  WIM.WIMM_MSB_ENDE_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {initialize:function(config) {
    this.isMDL = this.kind == 'WIMM_MDL_ENDE_AUS';
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    if (this.isMDL) {
      this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'ZB1'}, {value:'ZG9'}, {value:'ZH1'}, {value:'ZH2'}], defaultValue:'ZB1'});
    } else {
      this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E01'}, {value:'E03'}, {value:'Z33'}, {value:'ZG9'}, {value:'ZH1'}, {value:'ZH2'}], defaultValue:'E03'});
    }
    this.addComponent(this.transaktionsgrund);
    this.datumbeginn = new WIM.DateComponent({name:'datumBeginn', fieldLabel:'Termin Vertragsbeginn', allowBlank:true});
    this.addComponent(this.datumbeginn);
    this.datumende = new WIM.DateComponent({name:'datum', fieldLabel:'Termin Vertragsende', allowBlank:true, minDate:Ext.Date.clearTime(new Date())});
    this.addComponent(this.datumende);
    this.transaktionsgrund.on('change', function() {
      var isBeginn = false;
      if (this.transaktionsgrund.isChecked('ZG9')) {
        isBeginn = true;
        this.datumende.setHidden(true);
      } else if (this.transaktionsgrund.isChecked('ZH1')) {
        isBeginn = true;
        this.datumende.setHidden(true);
      } else if (this.transaktionsgrund.isChecked('ZH2')) {
        isBeginn = true;
        this.datumende.setHidden(true);
      } else {
        this.datumende.setHidden(false);
      }
      this.datumbeginn.setAllowBlank(!isBeginn);
    }, this);
    this.addComponent(this.newBemerkung());
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.WIMM_MSB_ENDE_AUS_ANGENOMMEN_Task = WIM.MSBMDLQuittierTask;
  WIM.WIMM_MSB_ENDE_AUS_ABGELEHNT_Task = WIM.WIMM_MSB_ENDE_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MSB_ENDE_AUS_APERAK_Task = WIM.WIMM_MSB_ENDE_AUS_ABGELEHNT_Task;
  WIM.WIMM_MSB_ENDE_AUS_GZ_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, acceptOnly:true, initialize:function(config) {
    this.marktpartnerZPView = new WIM.MarktpartnerZPView(WIM.MSBEnde.marktpartnerConfigAusgang);
    this.addTab(this.marktpartnerZPView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MSB_ENDE_AUS_WEITERVERPFLICHTUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], initialize:function(config) {
    this.addComponent(this.ansprechpartner);
    this.datumkorrigiert = this.newDatumkorrigiert();
    this.addComponent(this.datumkorrigiert);
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.MSB.antwortweiterQText, fieldLabel:'Antwortstatus', name:'antwortstatusweiter', items:[{key:'Z13', exclusive:true, accept:true}, {key:'Z14', exclusive:true, accept:true}, {key:'Z22', exclusive:true}]});
    this.antwortstatus.on('change', function(c) {
      var wantsDate = this.antwortstatus.isChecked('Z14');
      this.datumkorrigiert.setDisabled(!wantsDate);
    }, this);
    this.addComponent(this.antwortstatus);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.WIMM_MSB_BEGINN_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {formularLabelWidth:160, senderConfig:{submitGrundzustaendigkeit:false, MSBNoGZ:true}, initialize:function(config) {
    this.isMDL = this.kind == 'WIM_GZ_MDL_BEGINN_AUS' || this.kind == 'WIMM_MDL_BEGINN_AUS';
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.zaehlpunkt);
    this.zaehlpunkt.on('change', this.updateZaehlernummerRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Zählpunkt unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateZaehlernummerRequired();
    }, this);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.leistung = this.newLeistung();
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', columnCount:2, textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E01'}, {value:'E02'}, {value:'E03'}, {value:'ZJ4'}], defaultValue:'E03'});
    this.transaktionsgrund.on('change', this.updateZaehlernummerRequired, this);
    this.addComponent(this.transaktionsgrund);
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:Ext.Date.clearTime(new Date())});
    this.addComponent(this.datum);
    this.beauftragungbeendigung = new WIM.Antwortstatus({textFunction:WIM.QQQ.MSB.beauftragungbeendigungQText, canAccept:WIM.trueFunction, canReject:WIM.trueFunction, fieldLabel:'Beauftragung/Beendigung', name:'beauftragungbeendigung', items:this.isMDL ? [{key:'Z05'}, {key:'Z06'}] : [{key:'Z04'}, {key:'Z06'}]});
    this.addComponent(this.beauftragungbeendigung);
    this.addComponent(this.newBemerkung());
    this.addComponent(new WIM.SpaceComponent({}));
    var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Alle Änderungen ins Backend schreiben', name:'setZaehlpunktBackend', initialValue:'true'});
    this.addComponent(setZaehlpunktBackend);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, initialTask:true, defaultKategorie:'E01', editableZaehlernummern:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, noProcessValue:true, forceAdresse:false, noAdresse:true, noMessstelle:false, noKundenadresse:false, noKundenadresself:true, noKundeLF:true, kundenname:'Kunde / Vertragspartner des Messstellenbetreibers (MSBN)'});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:true});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    var initialLog = {HINWEIS:'', ZAEHLERNUMMERN:[]};
    if (!this.isMDL) {
      initialLog.LEISTUNG = 'Z01';
      initialLog.SPANNUNGSEBENEENTNAHME = '';
      initialLog.DRUCKEBENEENTNAHME = '';
      initialLog.SPANNUNGSEBENEMESSUNG = '';
    }
    this.stammdatenView.load({data:{LOG:initialLog}});
    this.stammdatenView.setForceZaehlernummer(false);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }, updateZaehlernummerRequired:function() {
    this.stammdatenView.setForceZaehlernummer(Ext.isEmpty(this.zaehlpunkt.submitValue()) && this.transaktionsgrund.submitValue() != 'E02');
  }});
  WIM.WIM_GZ_MSB_BEGINN_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {formularLabelWidth:160, senderConfig:{submitGrundzustaendigkeit:false, MSBGZ:true}, initialize:function(config) {
    this.isMDL = this.kind == 'WIM_GZ_MDL_BEGINN_AUS' || this.kind == 'WIMM_MDL_BEGINN_AUS';
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.zaehlpunkt);
    this.zaehlpunkt.on('change', this.updateZaehlernummerRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Messlokation unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateZaehlernummerRequired();
    }, this);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', columnCount:2, textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E01'}, {value:'E02'}, {value:'E03'}, {value:'ZJ4'}], defaultValue:'E03'});
    this.transaktionsgrund.on('change', this.updateZaehlernummerRequired, this);
    this.addComponent(this.transaktionsgrund);
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:Ext.Date.clearTime(new Date())});
    this.addComponent(this.datum);
    this.beauftragungbeendigung = new WIM.Antwortstatus({textFunction:WIM.QQQ.MSB.beauftragungbeendigungQText, canAccept:WIM.trueFunction, canReject:WIM.trueFunction, fieldLabel:'Beauftragung/Beendigung', name:'beauftragungbeendigung', items:this.isMDL ? [{key:'Z05'}, {key:'Z06'}] : [{key:'Z04'}, {key:'Z06'}]});
    this.addComponent(this.beauftragungbeendigung);
    this.addComponent(this.newBemerkung());
    this.addComponent(new WIM.SpaceComponent({}));
    var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Alle Änderungen ins Backend schreiben', name:'setZaehlpunktBackend', initialValue:'true'});
    this.addComponent(setZaehlpunktBackend);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, initialTask:true, defaultKategorie:'E01', editableZaehlernummern:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, noProcessValue:true, forceAdresse:false, noAdresse:true, noMessstelle:false, noKundenadresse:false, noKundenadresself:true, forceAdresseMSB:true, forceAdresseLF:false, noKundeLF:true, kundenname:'Kunde / Vertragspartner des Messstellenbetreibers (MSBN)'});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:true});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    var initialLog = {HINWEIS:'', ZAEHLERNUMMERN:[]};
    if (!this.isMDL) {
      initialLog.LEISTUNG = 'Z01';
      initialLog.SPANNUNGSEBENEENTNAHME = '';
      initialLog.DRUCKEBENEENTNAHME = '';
      initialLog.SPANNUNGSEBENEMESSUNG = '';
    }
    this.stammdatenView.load({data:{LOG:initialLog}});
    this.stammdatenView.setForceZaehlernummer(false);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }, updateZaehlernummerRequired:function() {
    this.stammdatenView.setForceZaehlernummer(Ext.isEmpty(this.zaehlpunkt.submitValue()) && this.transaktionsgrund.submitValue() != 'E01');
  }});
  WIM.WIM_NB_FORMEL_AUS_Task = Ext.extend(WIM.AdhocTask, {ansprechpartnerRequired:true, initialize:function(config) {
    this.receiver = WIM.newMSBComponent(this, {name:'mp', fieldLabel:'Empfänger (MSB)'});
    this.auftraggeber = new WIM.MarktpartnerComponent({diff:false, noProcessValue:true, url:this.wimContext.serverURL(), name:'ag', fieldLabel:'Auftraggeber', allowBlank:true});
    this.datum = new WIM.DateTimeComponent({name:'datum', fieldLabel:'Gültig ab', allowBlank:false});
    this.lieferrichtung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'lieferrichtung', fieldLabel:'Lieferrichtung', noProcessValue:true, values:WIM.QQQ.SD.lieferrichtung});
    this.formelstatus = new WIM.RadioGroup({name:'formelstatus', fieldLabel:'Status der Berechnungsformel', textFunction:WIM.QQQ.GED.statusformelQText, items:[{value:'Z34'}, {value:'Z33'}], defaultValue:'Z34'});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.lieferrichtung);
    this.addComponent(this.datum);
    this.addComponent(this.formelstatus);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.WIMM_MSB_BEGINN_AUS_ABGELEHNT_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, initialize:function(config) {
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true, diff:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, diff:true});
    this.addTab(this.adressenView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.stammdatenView.load(root);
    this.adressenView.load(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
  }});
  WIM.WIMM_MSB_BEGINN_AUS_APERAK_Task = Ext.extend(WIM.WIMM_MSB_BEGINN_AUS_ABGELEHNT_Task, {noZaehlpunkt:function() {
  }});
  WIM.WIMM_MSB_BEGINN_AUS_ANGENOMMEN_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], loadErrorSuppressed:true, noFormularTab:true, acceptOnly:true, initialize:function(config) {
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({name:'meldepunktedaten'});
    this.addComponent(this.meldepunkteView);
    this.addTab(this.meldepunkteView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, diff:true});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', readOnly:true});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true, taskdata:this, noZaehlwerk:true, noZaehlernummern:true});
    this.addTab(this.geraetedatenView.root);
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({rooted:true, displayOnly:true, MSB0:{name:'mp', fieldLabel:'MSBN'}, MSB:{name:'msba', fieldLabel:'MSBA', grundzustaendigkeit:true}, LF:{name:'lf', fieldLabel:'LF'}});
    this.addComponent(this.marktpartnerGridView);
    this.addTab(this.marktpartnerGridView.root);
  }, loadedData:function(root) {
    this.adressenView.load(root);
    this.ablesekarteView.load(root.data.LOG.ABLESEKARTENXML);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
    this.marktpartnerGridView.loadprocessDetail(root);
    this.meldepunkteView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root);
    if (root.data.LOG.STATUS == 'OK_OK_Fehler_OK') {
      Ext.Msg.alert('Fristüberschreitung', 'Der Prozess ist wegen Fristüberschreitung abgebrochen worden. Die weiteren Prozessschritte entfallen daher.');
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.zaehlpunkt.showSuppressedError(this.zaehlpunktInitialValue);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.meldepunkteView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.meldepunkteView.loadInitial(this.zaehlpunkt.data, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Meldepunktdaten.');
    }
  }});
  WIM.WIMM_MSB_BEGINN_AUS_WECHSELSTATUS_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], acceptOnly:true, initialize:function(config) {
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.wechselstatus = new WIM.RadioGroup({name:'wechselstatus', fieldLabel:'Wechselstatus', defaultValue:'', textFunction:WIM.QQQ.MSB.wechselstatusQText, items:[{value:'Z13'}, {value:'Z14'}]});
    this.wechselstatus.on('change', function() {
      this.datumkorrigiert.setDisabled(this.wechselstatus.submitValue() == 'Z13');
    }, this);
    this.addComponent(this.wechselstatus);
    this.datumkorrigiert = new WIM.DateComponent({name:'datumkorrigiert', fieldLabel:'Wechseltermin'});
    this.addComponent(this.datumkorrigiert);
    this.addComponent(new WIM.SpaceComponent({}));
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, postLoadedData:function(root) {
    this.callParent(arguments);
    if (root.data.LOG.STATUS == 'OK_OK_Fehler_OK') {
      Ext.Msg.alert('Fristüberschreitung', 'Der Prozess ist wegen Fristüberschreitung abgebrochen worden. Die Übermittlung des Wechselstatus entfällt daher.');
    }
    if (this.values.datumkorrigiert === undefined) {
      var d = root.data.LOG.DATUMKORRIGIERT;
      if (Ext.isEmpty(d)) {
        d = root.data.LOG.DATUM;
      }
      this.datumkorrigiert.load(d);
    }
    this.remoteWechselView = new WIM.RemoteWechselView({wimContext:this.wimContext, tabPanel:this.tabs, wechselConfig:{title:'Gerätewechselanfrage', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_WECHSEL_', fromField:'ANMELDUNGID'}, process:this});
    this.remoteWechselView.load(root.data.LOG.PROCESSID, this.root);
    this.remoteWechselView.on('loaded', function(source, data) {
      if (data) {
        var status = data.data.LOG.STATUS;
        this.form.add(new Ext.form.field.Display({fieldLabel:'Gerätewechselanfrage', value:this.wimContext.statusIconIMG(status) + ' ' + (status == 'OK_OK_OK' ? 'vollzogen' : 'nicht vollzogen')}));
      } else {
        var displayField;
        this.form.add(new Ext.form.FieldContainer({fieldLabel:'Gerätewechselanfrage', layout:{type:'hbox'}, items:[displayField = new Ext.form.field.Display({value:'nicht gestartet'}), new Ext.Container({width:20}), new Ext.Button({text:'Aufgabe erzeugen', scope:this, handler:function() {
          this.createTask('wechsel', displayField);
        }})]}));
      }
    }, this);
    this.remoteUebernahmeView = new WIM.RemoteUebernahmeView({tabPanel:this.tabs, wimContext:this.wimContext, uebernahmeConfig:{title:'Geräteübernahme', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_UEBERNAHME_', fromField:'ANMELDUNGID'}, process:this});
    this.remoteUebernahmeView.load(root.data.LOG.PROCESSID, this.root);
    this.remoteUebernahmeView.on('loaded', function(source, data) {
      if (data) {
        var status = data.data.LOG.STATUS;
        this.form.add(new Ext.form.field.Display({fieldLabel:'Geräteübernahme', value:this.wimContext.statusIconIMG(status) + ' ' + (status == 'Bestellung_OK' ? 'vollzogen' : 'nicht vollzogen')}));
      } else {
        var displayField;
        this.form.add(new Ext.form.FieldContainer({fieldLabel:'Geräteübernahme', layout:{type:'hbox'}, items:[displayField = new Ext.form.field.Display({value:'nicht gestartet'}), new Ext.Container({width:20}), new Ext.Button({text:'Aufgabe erzeugen', scope:this, handler:function() {
          this.createTask('uebernahme', displayField);
        }})]}));
      }
    }, this);
  }, createTask:function(typ, displayField) {
    var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, scope:this, makeCommand:function() {
      return '\x3ccreateTask\x3e\x3ctyp\x3e' + Ext.String.htmlEncode(typ) + '\x3c/typ\x3e\x3cprocessid\x3e' + Ext.String.htmlEncode(this.process.processID) + '\x3c/processid\x3e\x3c/createTask\x3e';
    }.bind(this), requestSuccess:function(data) {
      displayField.setValue('Aufgabe erzeugt');
      Ext.Msg.alert('Information', 'Die Aufgabe wurde erzeugt. Zum Bearbeiten schließen Sie zunächst die aktuelle Aufgabe.');
    }, requestFailure:function() {
      WIM.handleFailure.apply(this, arguments);
    }});
    processRequest.start(this.root);
  }});
  WIM.WIM_GZ_MSB_BEGINN_AUS_WECHSELSTATUS_Task = WIM.WIMM_MSB_BEGINN_AUS_WECHSELSTATUS_Task;
  WIM.WIMM_MSB_BEGINN_AUS_ZUORDNUNG_BasicTask = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, acceptOnly:true, loadedData:function(root) {
    this.callParent(arguments);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MSB_BEGINN_AUS_GESCHEITERT_BasicTask = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, loadedData:function(root) {
    this.callParent(arguments);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MSB_BEGINN_AUS_ZUORDNUNG_Task = WIM.WIMM_MSB_BEGINN_AUS_ZUORDNUNG_BasicTask;
  WIM.WIMM_MSB_BEGINN_AUS_FRISTUEBERSCHREITUNG_Task = WIM.WIMM_MSB_BEGINN_AUS_GESCHEITERT_BasicTask;
  WIM.WIMM_MSB_BEGINN_AUS_GESCHEITERT_Task = WIM.WIMM_MSB_BEGINN_AUS_GESCHEITERT_BasicTask;
  WIM.WIMM_GER_MSB_ENDABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {acceptOnly:true, processHeadHiddenFields:['MP', 'VORGANG'], initialize:function(config) {
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:true, noProcessValue:true, forceRow:true});
    this.abrufenEnde = {process:this.process, typ:'EMV'};
    this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
    this.addComponent(this.messwerteEnde);
    this.addComponent(this.zaehlernummernEnde);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['MP', 'VORGANG', 'VORGANGMDL', 'SPANNUNGSEBENEMESSUNG', 'ANSPRECHPARTNERINTERN', 'ANSPRECHPARTNEREXTERN']});
    this.addTab(this.wechselView.root);
    this.remoteWechselView = new WIM.RemoteWechselView({wimContext:this.wimContext, wechselConfig:{title:'Gerätewechselanfrage', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_WECHSEL_', fromField:'AUSTAUSCHID'}, process:this});
    this.addTab(this.remoteWechselView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufenEnde.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufenEnde.datum = root.data.LOG.DATUM;
    this.wechselView.load(root);
    this.remoteWechselView.load(root.data.LOG.PROCESSID, this.root);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummernEnde.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.zaehlernummernEnde.noBackend();
  }});
  WIM.WIMM_GER_MSB_ANFANGSABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {formularLabelWidth:180, acceptOnly:true, processHeadHiddenFields:['VORGANG', 'MP'], initialize:function(config) {
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.spannungsebenemessung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'spannungsebenemessung', fieldLabel:'Spannungsebene Messung', noProcessValue:true, values:WIM.QQQ.SD.spannungsebenemessung});
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.spannungsebenemessung);
    this.addComponent(new WIM.SpaceComponent({}));
    var changeGeraeteBackend = new WIM.Checkbox({boxLabel:'Alle Änderungen ins Backend schreiben', name:'changeGeraeteBackend', initialValue:'true'});
    this.addComponent(changeGeraeteBackend);
    var formItems = this.newFormItems();
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['MP', 'VORGANG', 'VORGANGMDL', 'SPANNUNGSEBENEMESSUNG', 'ANSPRECHPARTNERINTERN', 'ANSPRECHPARTNEREXTERN']});
    this.addTab(this.wechselView.root);
    if (config.mitEndwerten) {
      this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:true, noProcessValue:true, forceRow:true});
      this.abrufenEnde = {process:this.process, typ:'EMV'};
      this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
      var endeItems = [];
      this.addComponent(this.messwerteEnde);
      this.addComponent(this.zaehlernummernEnde);
      this.zaehlernummernEnde.addFields(endeItems);
      this.messwerteEnde.addFields(endeItems);
      this.addTab(this.newFormPanel({labelWidth:140, title:'Endablesewerte', items:endeItems}));
    }
    this.abrufenAnfang = {process:this.process, typ:'SMV'};
    this.messwerteAnfang = new WIM.MesswerteView({name:'anfang_messwertexml', fieldLabel:'Zählerstände (Anfang)', height:150, abrufen:this.abrufenAnfang, forceRow:true});
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this, width:900, height:150});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
    var anfangItems = [];
    this.addComponent(this.messwerteAnfang);
    this.messwerteAnfang.addFields(anfangItems);
    this.addTab(this.newFormPanel({title:'Anfangsablesewerte', items:anfangItems, labelWidth:170}));
    this.remoteWechselView = new WIM.RemoteWechselView({wimContext:this.wimContext, wechselConfig:{title:'Gerätewechselanfrage', hiddenFields:['NAME']}, remoteConfig:{prefix:'WIM_GER_WECHSEL_', fromField:'AUSTAUSCHID'}, process:this});
    this.addTab(this.remoteWechselView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.messwerteAnfang.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufenAnfang.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufenAnfang.datum = root.data.LOG.DATUM;
    if (this.messwerteEnde) {
      this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
      this.abrufenEnde.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
      this.abrufenEnde.datum = root.data.LOG.DATUM;
    }
    this.wechselView.load(root);
    this.remoteWechselView.load(root.data.LOG.PROCESSID, this.root);
    this.installBackendFehler(root, 'ANFANG_BACKEND_FEHLER');
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.spannungsebenemessung.loadSD(this.zaehlpunkt.data.spannungsebenemessung);
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen);
      this.messwerteAnfang.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.spannungsebenemessung.noBackend();
  }});
  WIM.WIMM_GER_MSB_ANFANGSABLESEWERTE_MIT_ENDE_Task = Ext.extend(WIM.WIMM_GER_MSB_ANFANGSABLESEWERTE_Task, {constructor:function(config) {
    config.mitEndwerten = true;
    this.callParent(arguments);
  }});
  WIM.WIMM_GER_MSB_ADHOC_Task = Ext.extend(WIM.AdhocTask, {formularLabelWidth:180, initialize:function(config) {
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.spannungsebenemessung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'spannungsebenemessung', fieldLabel:'Spannungsebene Messung', noProcessValue:true, values:WIM.QQQ.SD.spannungsebenemessung});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.spannungsebenemessung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.zaehlernummernEnde = new WIM.EditableList({columnName:'Zählernummer', name:'ende_zaehlernummernxml', fieldLabel:'Zählernummern (Ende)', diff:false, forceRow:true});
    this.abrufenEnde = {process:this.process, abrufen:function() {
      return {typ:'EMV', datum:this.datum.submitValue(), zaehlpunkt:this.zaehlpunkt.submitValue()};
    }.bind(this)};
    this.messwerteEnde = new WIM.MesswerteView({name:'ende_messwertexml', fieldLabel:'Zählerstände (Ende)', height:150, abrufen:this.abrufenEnde, forceRow:true});
    this.keineWerteEnde = new WIM.Checkbox({name:'keineWerteEnde', fieldLabel:'Endablesewerte nicht übermitteln'});
    this.keineWerteEnde.on('change', function() {
      if (this.keineWerteEnde.isChecked()) {
        this.messwerteEnde.setForceRow(false);
        this.zaehlernummernEnde.setForceRow(false);
      } else {
        this.messwerteEnde.setForceRow(true);
        this.zaehlernummernEnde.setForceRow(true);
      }
    }, this);
    var endeItems = [];
    this.addComponent(this.messwerteEnde);
    this.addComponent(this.zaehlernummernEnde);
    this.addComponent(this.keineWerteEnde);
    this.keineWerteEnde.addFields(endeItems);
    this.zaehlernummernEnde.addFields(endeItems);
    this.messwerteEnde.addFields(endeItems);
    this.addTab(this.newFormPanel({title:'Endablesewerte', items:endeItems, labelWidth:170}));
    this.abrufenAnfang = {process:this.process, abrufen:function() {
      return {typ:'SMV', datum:this.datum.submitValue(), zaehlpunkt:this.zaehlpunkt.submitValue()};
    }.bind(this)};
    this.messwerteAnfang = new WIM.MesswerteView({name:'anfang_messwertexml', fieldLabel:'Zählerstände (Anfang)', height:150, abrufen:this.abrufenAnfang, forceRow:true});
    this.keineWerteAnfang = new WIM.Checkbox({name:'keineWerteAnfang', fieldLabel:'Anfangsablesewerte nicht übermitteln'});
    this.keineWerteAnfang.on('change', function() {
      this.messwerteAnfang.setForceRow(!this.keineWerteAnfang.isChecked());
    }, this);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml'});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
    var anfangItems = [];
    this.addComponent(this.messwerteAnfang);
    this.addComponent(this.keineWerteAnfang);
    this.keineWerteAnfang.addFields(anfangItems);
    this.messwerteAnfang.addFields(anfangItems);
    this.addTab(this.newFormPanel({title:'Anfangsablesewerte', items:anfangItems, labelWidth:170}));
  }, loadedPseudoProcess:function(root) {
    this.callParent(arguments);
    this.messwerteAnfang.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.messwerteEnde.setAbrufenEnabled(this.messwerteAbrufenEnabled);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.spannungsebenemessung.loadSD(this.zaehlpunkt.data.spannungsebenemessung);
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
      this.messwerteAnfang.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.spannungsebenemessung.noBackend();
  }});
  WIM.WIMM_MWANFORDERUNG_EIN_Task = Ext.extend(WIM.ProcessTask, {initialize:function(config) {
    this.zaehlernummern = new WIM.EditableList({name:'zaehlernummern', fieldLabel:'Zählernummern', columnName:'Zählernummer', diff:true, forceRow:true, height:120});
    this.abrufen = {process:this.process, typ:'MRV'};
    this.messwerteView = new WIM.MesswerteView({name:'messwertexml', title:'Messwerte', height:150, abrufen:this.abrufen, forceRow:true});
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.GED.antwortmesswerteQText, fieldLabel:'Aktion/Ablehnungsgrund', items:[{key:'', accept:true, exclusive:true}, {key:'Z19', exclusive:true}, {key:'Z23', exclusive:true}, {key:'Z24', exclusive:true}, {key:'Z25', exclusive:true}, {key:'Z26', exclusive:true}, {key:'Z27', exclusive:true}, {key:'Z28', exclusive:true}, {key:'Z29', exclusive:true}, {key:'Z30', exclusive:true}, {key:'Z31', exclusive:true}, {key:'ZD7', exclusive:true}, {key:'ZD8', 
    exclusive:true}]});
    var formItems = this.newFormItems();
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.zaehlernummern);
    this.addComponent(this.antwortstatus);
    this.addComponentFields(formItems);
    this.addComponent(this.messwerteView);
    this.addFormularTab(formItems);
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['ANSPRECHPARTNERINTERN', 'ZAEHLERNUMMERN', 'ABLESETYP', 'FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
    this.addTab(this.messwerteView.root);
  }, loadedData:function(root) {
    this.messwerteView.setAbrufenEnabled(this.messwerteAbrufenEnabled);
    this.abrufen.zaehlpunkt = root.data.LOG.ZAEHLPUNKT;
    this.abrufen.datum = root.data.LOG.DATUM;
    this.messwerteProcessView.load(root);
    this.zaehlernummern.loadProcess(root.data.LOG.ZAEHLERNUMMERN);
    this.callParent(arguments);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.WIMM_LGANFORDERUNG_EIN_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, noFormularTab:true, initialize:function(config) {
    this.messwerteProcessView = new WIM.MesswerteProcessView({hiddenFields:['ANSPRECHPARTNERINTERN', 'ZAEHLERNUMMERN', 'ABLESETYP', 'FEHLERSTATUSANLASS']});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.messwerteProcessView.load(root);
    this.callParent(arguments);
  }});
  WIM.WIMM_MESSWERTE_AUS_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receiver = new WIM.MarktpartnerComponent({url:this.wimContext.serverURL(), diff:false, noProcessValue:true, name:'mp', fieldLabel:'Empfänger'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.ablesegrund = new WIM.QualifierChoice({diff:true, allowBlank:false, ignoreEmptyProcessValue:true, name:'ablesegrund', fieldLabel:'Ablesegrund', noSDValue:true, values:WIM.QQQ.GED.ablesegrund});
    this.ablesetyp = new WIM.QualifierChoice({diff:true, allowBlank:false, ignoreEmptyProcessValue:true, name:'ablesetyp', fieldLabel:'Ablesetyp', noSDValue:true, values:WIM.QQQ.GED.ablesetyp});
    this.zaehlernummern = new WIM.EditableList({columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:'Zählernummern)', diff:true, forceRow:true, noProcessValue:true});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(this.ablesegrund);
    this.addComponent(this.ablesetyp);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.zaehlernummern);
    this.abrufenConfig = {process:this.process, abrufen:function() {
      return {typ:'MRV', datum:this.datum.submitValue(), zaehlpunkt:this.zaehlpunkt.submitValue()};
    }.bind(this)};
    this.messwerte = new WIM.MesswerteView({name:'messwertexml', fieldLabel:'Zählerstände', height:150, abrufen:this.abrufenConfig, forceRow:true});
    this.addComponent(this.messwerte);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedPseudoProcess:function(root) {
    this.callParent(arguments);
    this.messwerte.setAbrufenEnabled(this.messwerteAbrufenEnabled);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.zaehlernummern.loadSD(this.zaehlpunkt.data.summary.zaehlernummern, zpChanged);
      this.messwerte.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.WIMM_ENERGIEMENGEN_AUS_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receiver = WIM.newNBLFComponent(this, {name:'mp'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.messwerte = new WIM.MesswerteView({name:'messwertexml', fieldLabel:'Energiemengen', height:150, forceRow:true});
    this.addComponent(this.messwerte);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedZaehlpunkt:function(zpChanged) {
    try {
      this.messwerte.loadInitialVorbelegung(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }});
  WIM.WIMM_MESSWERTE_GESCHEITERT_AUS_Task = Ext.extend(WIM.AdhocTask, {initialize:function(config) {
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.datum = new WIM.DateComponent({fieldLabel:'Termin', name:'datum', allowBlank:false, maxDate:WIM.endOfToday()});
    this.addComponent(this.zaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(this.datum);
    this.addComponent(new WIM.SpaceComponent({}));
    this.scheiterungsgrund = new WIM.Antwortstatus({fieldLabel:'Scheiterungsgrund', name:'fehlerstatusanlass', textFunction:WIM.QQQ.MW.messwertstatusQText, items:[{key:'Z74', accept:true, exclusive:true}, {key:'Z75', accept:true, exclusive:true}, {key:'Z76', accept:true, exclusive:true}, {key:'Z77', accept:true, exclusive:true}, {key:'Z78', accept:true, exclusive:true}, {key:'Z79', accept:true, exclusive:true}, {key:'Z80', accept:true, exclusive:true}, {key:'Z81', accept:true, exclusive:true}, {key:'Z82', 
    accept:true, exclusive:true}, {key:'ZD7', accept:true, exclusive:true}, {key:'ZD8', accept:true, exclusive:true}]});
    this.addComponent(this.scheiterungsgrund);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }});
  WIM.WIMM_MESSWERTE_AUS_KORR_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, initialize:function(config) {
    this.messwerteView = new WIM.MesswerteDatenView({});
    this.addTab(this.messwerteView.root);
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.addTab(this.messwerteProcessView.root);
  }, loadedData:function(root) {
    this.messwerteProcessView.load(root);
    this.messwerteView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root, 'BACKEND_FEHLER');
  }});
  WIM.WIMM_MWANFORDERUNG_EIN_KORR_Task = WIM.WIMM_MESSWERTE_AUS_KORR_Task;
  WIM.WIMM_MSB_WECHSEL_BasicTask = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, loadedData:function(root) {
    this.callParent(arguments);
    if (Ext.String.endsWith(this.kind, 'VOLLZOGEN')) {
      this.installBackendFehler(root);
    }
  }});
  WIM.WIMM_MSB_WECHSEL_MSBA_GEPLANT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MSB_WECHSEL_MSBA_GESCHEITERT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MSB_WECHSEL_MSBA_VOLLZOGEN_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIM_GZ_MSB_WECHSEL_MSB_VOLLZOGEN_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIM_GZ_MSB_WECHSEL_MSB_GESCHEITERT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
});
Ext.define('mpm.packages.wim.StubInterchangeTasks', {requires:['mpm.packages.wim.StubTasks']});
Ext.onReady(function() {
  WIM.Tasks.push({task:'NOPROCESSAPERAK', text:'\x3cp\x3eDie eingegangene Nachricht für einen Folgeprozess konnte keinem Fachprozess zugeordnet werden. Bitte prüfen Sie die Nachricht. Die Nachricht kann ebenfalls per APERAK abgelehnt werden (Referenziertes Geschäftsvorfall-Tupel nicht vorhanden) \x3c/p\x3e'}, {task:'NOPROCESS', text:'\x3cp\x3eDie eingegangene Nachricht für einen Folgeprozess konnte keinem Fachprozess zugeordnet werden. Bitte prüfen Sie die Nachricht.\x3c/p\x3e'}, {task:'APERAK', 
  text:'\x3cp\x3eFür die eingegangene Nachricht hat die EDI-Prüfung eine APERAK erzeugt. Bitte entscheiden Sie, ob die APERAK versandt und damit die Verarbeitung abgebrochen oder ob die Nachricht trotzdem verarbeitet werden soll.\x3c/p\x3e' + '\x3cp\x3eJe nach Art der erkannnten Fehler kann es bei der Verarbeitung zu Fehlern im weiteren Prozessverlauf kommen.\x3c/p\x3e'}, {task:'EMV_VALIDATION', text:'\x3cp\x3eDer vorliegende Vorgang bzw. die daraus erstelle EDIFACT Nachricht enthält semantische oder syntaktische Fehler.\x3c/p\x3e' + 
  '\x3cp\x3eBitte prüfen Sie die Nachricht entsprechend. \x3c/p\x3e'}, {task:'APERAK_ERR', text:'\x3cp\x3eFür die eingangene Nachricht konnten ein oder mehrere Zählpunkte nicht identifiziert werden oder sonstige Verarbeitungsfehler sind aufgetreten. Entscheiden Sie anhand der Fehlerliste, ob dennoch alle Vorgänge verarbeitet werden sollen oder ob die APERAK versandt und nur evtl. verbliebene Vorgänge verarbeitet werden sollen.\x3c/p\x3e'}, {task:'APERAK_IN', text:'\x3cp\x3eEs wurde eine APERAK empfangen.\x3c/p\x3e'}, 
  {task:'APERAK_ERR_IN', text:'\x3cp\x3eEs wurde eine APERAK (Verarbeitungsfehler) empfangen.\x3c/p\x3e'}, {task:'CONTRL_NEGATIV_IN', text:'\x3cp\x3eEs wurde eine negative CONTRL empfangen.\x3c/p\x3e'}, {task:'APERAK_ZP', text:'\x3cp\x3eDer vorliegende Vorgang enthält keine Zählpunktbezeichung. Bitte versuchen Sie, den Zählpunkt anhand der mitgeschickten Informationen eindeutig zu identifizieren.\x3c/p\x3e' + '\x3cp\x3eAnschließend geben Sie bitte entweder die Zählpunktbezeichnung ein oder geben Sie, wenn trotz gründlicher Prüfung und ggfs. Rückfrage beim Absender eine eindeutige Identifikation des Zählpunktes nicht möglich war, den Grund für die Ablehnung mittels APERAK ein. \x3c/p\x3e'});
  WIM.AbstractInterchangeTask = Ext.extend(WIM.PreAbstractProcessTask, {constructor:function(config) {
    this.callParent(arguments);
    this.messagePanel = new WIM.InterchangeMessagePanel({wimContext:this.wimContext, process:this.process});
    this.head = this.messagePanel.head;
    this.tabs.destroy();
    this.tabs = this.messagePanel.tabs;
  }, show:function() {
    this.callParent(arguments);
    this.messagePanel.maskComponent = this.root;
  }, loadedProcess:function(root) {
    this.callParent(arguments);
    this.messagePanel.load(root);
  }, requestFailed:function() {
    this.callParent(arguments);
    this.messagePanel.requestFailed();
  }});
  WIM.APERAK_Task = Ext.extend(WIM.AbstractInterchangeTask, {buttonTemplate:[['Trotzdem verarbeiten', 'Take'], ['APERAK versenden', 'APERAK'], ['Schließen', undefined]]});
  WIM.NOPROCESS_Task = Ext.extend(WIM.AbstractInterchangeTask, {buttonTemplate:[['Quittieren', 'Take'], ['Schließen', undefined]]});
  WIM.NOPROCESSAPERAK_Task = WIM.APERAK_Task;
  WIM.EMV_VALIDATION_Task = Ext.extend(WIM.AbstractInterchangeTask, {buttonTemplate:[['Quittieren', 'Take'], ['Erneut prüfen', 'Retry'], ['Schließen', undefined]]});
  WIM.APERAK_ERR_Task = Ext.extend(WIM.AbstractInterchangeTask, {buttonTemplate:[['Alles verarbeiten', 'TakeAll'], ['APERAK versenden', 'APERAK'], ['Schließen', undefined]]});
  WIM.APERAK_IN_Task = Ext.extend(WIM.AbstractInterchangeTask, {quittierenOnly:true});
  WIM.APERAK_ERR_IN_Task = WIM.APERAK_IN_Task;
  WIM.CONTRL_NEGATIV_IN_Task = WIM.APERAK_IN_Task;
  WIM.APERAK_ZP_Task = Ext.extend(WIM.AbstractInterchangeTask, {buttonTemplate:[['Zählpunkt übernehmen', 'Take'], ['APERAK versenden', 'APERAK'], ['Schließen', undefined]], loadedProcess:function(root) {
    this.callParent(arguments);
    this.backendEnabled = root.config.backendEnabled == 'true';
    this.installZaehlpunktIdentifikation();
  }, installZaehlpunktIdentifikation:function() {
    var defaultWidth = 500;
    if (this.backendEnabled) {
      this.zaehlpunktInput = new WIM.ZaehlpunktComponent({wimContext:this.wimContext, process:this.process, zaehlpunktMode:'noload', name:'zaehlpunkt', fieldLabel:'Zählpunktbezeichnung', width:defaultWidth});
    } else {
      this.zaehlpunktInput = new WIM.TextField({maxLength:33, minLength:33, allowBlank:false, diff:false, name:'zaehlpunkt', fieldLabel:'Zählpunktbezeichnung', width:defaultWidth});
    }
    this.addComponent(this.zaehlpunktInput);
    this.antwortstatus = new WIM.Antwortstatus({fieldLabel:'APERAK-Status', name:'aperakstatus', textFunction:WIM.QQQ.APERAK.antwortstatusQText, items:[{key:'Z14', accept:true, exclusive:true}, {key:'Z15', accept:true, exclusive:true}, {key:'Z16', accept:true, exclusive:true}]});
    this.addComponent(this.antwortstatus);
    var continueButton = this.commitButtons[0];
    var aperakButton = this.commitButtons[1];
    continueButton.setDisabled(true);
    aperakButton.setDisabled(true);
    this.antwortstatus.on('change', function() {
      if (this.antwortstatus.isAnyChecked()) {
        this.zaehlpunktInput.setAllowBlank(true);
        this.zaehlpunktInput.load('');
        continueButton.setDisabled(true);
        aperakButton.setDisabled(false);
      } else {
        this.zaehlpunktInput.setAllowBlank(false);
        aperakButton.setDisabled(true);
      }
    }, this);
    this.zaehlpunktInput.on('change', function() {
      if (!Ext.isEmpty(this.zaehlpunktInput.submitValue())) {
        this.antwortstatus.clearAll();
        continueButton.setDisabled(false);
        aperakButton.setDisabled(true);
      } else {
        continueButton.setDisabled(true);
      }
    }, this);
    var inputItems = [];
    this.zaehlpunktInput.addFields(inputItems);
    this.antwortstatus.addFields(inputItems);
    this.tabs.insert(0, this.newFormPanel({scrollable:'true', title:'Zählpunktidentifikation', items:inputItems}));
    this.tabs.setActiveTab(0);
  }});
});
Ext.define('mpm.packages.wim.StubMDLTasks', {requires:['mpm.packages.wim.StubTasks']});
Ext.onReady(function() {
  WIM.MDL_KUENDIGUNG_Task = WIM.MSB_KUENDIGUNG_Task;
  WIM.MDL_ABMELDUNG_Task = WIM.MSB_ABMELDUNG_Task;
  WIM.MDL_ANMELDUNG_CLEARING_Task = WIM.MSBMDLClearingTask;
  WIM.MDL_ABMELDUNG_CLEARING_Task = WIM.MSBMDLClearingTask;
  WIM.WIMM_MDL_KUENDIGUNG_AUS_Task = WIM.WIMM_MSB_KUENDIGUNG_AUS_Task;
  WIM.WIMM_MDL_KUENDIGUNG_AUS_ANGENOMMEN_Task = WIM.WIMM_MSB_KUENDIGUNG_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MDL_KUENDIGUNG_AUS_ABGELEHNT_Task = WIM.WIMM_MSB_KUENDIGUNG_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MDL_KUENDIGUNG_AUS_APERAK_Task = WIM.WIMM_MSB_KUENDIGUNG_AUS_APERAK_Task;
  WIM.WIMM_MDL_BEGINN_AUS_ZUORDNUNG_Task = WIM.WIMM_MSB_BEGINN_AUS_ZUORDNUNG_BasicTask;
  WIM.WIM_GZ_MDL_BEGINN_AUS_ZUORDNUNG_Task = WIM.WIMM_MSB_BEGINN_AUS_ZUORDNUNG_BasicTask;
  WIM.WIMM_GER_MDL_ENDABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], noFormularTab:true, initialize:function(config) {
    this.messwerteView = new WIM.MesswerteMiniView({title:'Endablesewerte', prefix:'ENDE_'});
    this.wechselView = new WIM.GeraeteAustauschView({});
    this.addTab(this.messwerteView.root);
    this.addTab(this.wechselView.root);
  }, loadedData:function(root) {
    this.wechselView.load(root);
    this.messwerteView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root, 'ENDE_BACKEND_FEHLER');
  }});
  WIM.WIMM_GER_MDL_ANFANGSABLESEWERTE_Task = Ext.extend(WIM.ProcessTask, {quittierenOnly:true, processHeadHiddenFields:['VORGANG', 'RICHTUNG'], initialize:function(config) {
    this.messwerteView = new WIM.MesswerteMiniView({title:'Anfangsablesewerte', prefix:'ANFANG_'});
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true});
    this.addComponent(this.ansprechpartner);
    var formItems = this.newFormItems();
    this.ansprechpartner.addFields(formItems);
    this.addFormularTab(formItems);
    this.addTab(this.geraetedatenView.root);
    this.addTab(this.messwerteView.root);
    this.wechselView = new WIM.GeraeteAustauschView({hiddenFields:['ANSPRECHPARTNERINTERN']});
    this.addTab(this.wechselView.root);
  }, loadedData:function(root) {
    this.wechselView.load(root);
    this.messwerteView.load(root);
    this.geraetedatenView.loadInitial(root.data.LOG.POSITIONENXML);
    this.callParent(arguments);
    this.installBackendFehler(root, 'ANFANG_BACKEND_FEHLER');
  }, loadedZaehlpunkt:function() {
    if (this.zaehlpunkt.data.msb_status == 'MSB' || this.zaehlpunkt.data.msb_status == 'MSBN' || this.zaehlpunkt.data.nb_status == 'ja') {
      var text = new Ext.form.field.Display({value:'Anscheinend wird der Zählpunkt nicht nur als MDL betrieben. Daher würde durch Schreiben der Gerätedaten ins Backend eventuell Daten überschrieben. Bitte bestätigen Sie manuell.'});
      var check = new WIM.Checkbox({boxLabel:'Gerätedaten ins Backend schreiben', name:'changePositionenBackend'});
      this.addComponent(check);
      this.form.add(new Ext.Container({height:20}));
      this.form.add(text);
      this.form.add(new Ext.Container({height:10}));
      this.form.add(check.field);
    }
  }});
  WIM.MDL_ANMELDUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'ANTWORTSTATUS', 'DATUMKORRIGIERT', 'BEMERKUNGANTWORT', 'VORGANGLF'], initialize:function(config) {
    this.antwortstatus = new WIM.Antwortstatus({textFunction:WIM.QQQ.UTILMD.antwortstatusQText, items:[{key:'E15', accept:true, exclusive:true}, {key:'Z01', accept:true, disabled:true}, {key:'Z44', accept:true}, {key:'E17'}, {key:'Z07'}, {key:'Z09'}, {key:'ZB6'}]});
    this.datumkorrigiert = this.newDatumkorrigiert(this.antwortstatus);
    this.addComponent(this.datumkorrigiert);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({rooted:true, task:this, MSB:{noProcessValue:true, emptyText:'Bitte ausfüllen, wenn vorhanden', grundzustaendigkeit:true}, LF:{noProcessValue:true, allowBlank:true, emptyText:'Bitte ausfüllen, wenn vorhanden'}});
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true});
    this.addComponent(this.antwortstatus);
    this.addComponent(this.ansprechpartner);
    this.bemerkung = new WIM.TextArea({allowBlank:true, name:'bemerkungantwort', fieldLabel:'Bemerkung'});
    this.addComponent(this.bemerkung);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.marktpartnerZPView.addComponentsToTask();
    this.addTab(this.marktpartnerZPView.root);
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, forceAdresse:true, allowBlankKunde:true, noKundenadresse:true});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:true});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({name:'positionenxml', taskdata:this});
    this.addComponent(this.geraetedatenView);
    this.addTab(this.geraetedatenView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    var neuanlage = root.data.LOG.TRANSAKTIONSGRUND == 'E02';
    this.antwortstatus.setValueDisabled('Z01', !neuanlage);
    if (neuanlage) {
      this.marktpartnerZPView.setAllowBlankForAll(true);
    }
    this.geraetedatenView.setNeuanlage(neuanlage);
    this.marktpartnerZPView.load(root);
    this.stammdatenView.load(root);
    this.adressenView.load(root);
    this.ablesekarteView.load(root.data.LOG.ABLESEKARTENXML);
    if (root.data.LOG.STORNIERT === 'ja') {
      this.installStornierung();
    }
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
    try {
      this.geraetedatenView.loadInitial(this.zaehlpunkt.data.positionen, zpChanged);
    } catch (e) {
      Ext.Msg.alert('Fehler', 'Fehler beim Abruf der Zählpunktdaten.');
    }
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
    this.geraetedatenView.noBackend();
  }});
  WIM.MDL_ANMELDUNG_ZUORDNUNG_Task = Ext.extend(WIM.MSBMDLTask, {acceptOnly:true, wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'VORGANGLF'], initialize:function(config) {
    var formItems = this.newFormItems();
    this.lieferrichtung = new WIM.QualifierChoice({diff:true, allowBlank:false, name:'lieferrichtung', fieldLabel:'Lieferrichtung', noProcessValue:true, values:WIM.QQQ.SD.lieferrichtung});
    this.addComponent(this.lieferrichtung);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({task:this, MSB:{grundzustaendigkeit:true}});
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.marktpartnerZPView.addComponentsToTask();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.installBackendFehler(root);
    var neuanlage = root.data.LOG.TRANSAKTIONSGRUND == 'E02';
    if (neuanlage) {
      this.marktpartnerZPView.setAllowBlankForMDL(true);
    }
    this.marktpartnerZPView.load(root);
  }});
  WIM.MDL_ABMELDUNG_ZUORDNUNG_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:['ANSPRECHPARTNERINTERN', 'VORGANGLF'], initialize:function(config) {
    this.marktpartnerZPView = new WIM.MarktpartnerZPView({task:this, MSB:{noProcessValue:true}, LF:{noProcessValue:true}});
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({height:15}));
    this.marktpartnerZPView.addComponentsToTask(this);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MDL_BEGINN_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {formularLabelWidth:160, senderConfig:{submitGrundzustaendigkeit:false, MDLNoGZ:true}, initialize:function(config) {
    if (this.kind == 'WIM_GZ_MDL_BEGINN_AUS') {
      this.isMDL = this.kind == 'WIM_GZ_MDL_BEGINN_AUS';
    } else {
      this.isMDL = this.kind == 'WIMM_MDL_BEGINN_AUS';
    }
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.zaehlpunkt);
    this.zaehlpunkt.on('change', this.updateZaehlernummerRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Zählpunkt unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateZaehlernummerRequired();
    }, this);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.leistung = this.newLeistung();
    this.addComponent(this.leistung);
    if (this.isMDL) {
      this.msb = WIM.newMSBComponent(this, {fieldLabel:'MSB', name:'msb', allowBlank:true});
      this.addComponent(this.msb);
    } else {
      this.mdl = WIM.newMDLComponent(this, {fieldLabel:'MDL', name:'mdla', allowBlank:true});
      this.addComponent(this.mdl);
      this.mdln = WIM.newMDLComponent(this, {fieldLabel:'MDLN', name:'mdln', role:undefined, selbst:true, hidden:true});
      this.addComponent(this.mdln);
      this.leistung.on('change', function() {
        var isDoppelt = this.leistung.submitValue() == 'Z03';
        this.mdl.setHidden(isDoppelt);
        this.mdln.setHidden(!isDoppelt);
      }, this);
    }
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E01'}, {value:'E02'}, {value:'E03'}], defaultValue:'E03'});
    this.transaktionsgrund.on('change', this.updateZaehlernummerRequired, this);
    this.addComponent(this.transaktionsgrund);
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:Ext.Date.clearTime(new Date())});
    this.addComponent(this.datum);
    if (!this.isMDL) {
      var updateBeauftragungbeendigung = function() {
        this.beauftragungbeendigung.setValueDisabled('Z05', this.leistung.submitValue() == 'Z01', true);
      };
      this.leistung.on('change', updateBeauftragungbeendigung, this);
    }
    this.beauftragungbeendigung = new WIM.Antwortstatus({textFunction:WIM.QQQ.MSB.beauftragungbeendigungQText, canAccept:WIM.trueFunction, canReject:WIM.trueFunction, fieldLabel:'Beauftragung/Beendigung', name:'beauftragungbeendigung', items:this.isMDL ? [{key:'Z05'}, {key:'Z06'}] : [{key:'Z04'}, {key:'Z05'}, {key:'Z06'}]});
    this.addComponent(this.beauftragungbeendigung);
    this.addComponent(this.newBemerkung());
    this.addComponent(new WIM.SpaceComponent({}));
    var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Alle Änderungen ins Backend schreiben', name:'setZaehlpunktBackend', initialValue:'true'});
    this.addComponent(setZaehlpunktBackend);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, defaultKategorie:'E01', editableZaehlernummern:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, noProcessValue:true, forceAdresse:false, noMessstelle:true, noKundenadresse:true, kundenname:'Kunde / Vertragspartner des Messdienstleisters (MDLN)'});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:true});
    this.addTab(this.ablesekarteView.root);
    this.addComponent(this.ablesekarteView);
    var initialLog = {HINWEIS:'', ZAEHLERNUMMERN:[]};
    if (!this.isMDL) {
      initialLog.LEISTUNG = 'Z01';
      initialLog.SPANNUNGSEBENEENTNAHME = '';
      initialLog.DRUCKEBENEENTNAHME = '';
      initialLog.SPANNUNGSEBENEMESSUNG = '';
    }
    this.stammdatenView.load({data:{LOG:initialLog}});
    this.stammdatenView.setForceZaehlernummer(false);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }, updateZaehlernummerRequired:function() {
    this.stammdatenView.setForceZaehlernummer(Ext.isEmpty(this.zaehlpunkt.submitValue()) && this.transaktionsgrund.submitValue() != 'E02');
  }});
  WIM.WIMM_MDL_ENDE_AUS_Task = WIM.WIMM_MSB_ENDE_AUS_Task;
  WIM.WIMM_MDL_ENDE_AUS_ANGENOMMEN_Task = WIM.WIMM_MSB_ENDE_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MDL_ENDE_AUS_ABGELEHNT_Task = WIM.WIMM_MSB_ENDE_AUS_ANGENOMMEN_Task;
  WIM.WIMM_MDL_ENDE_AUS_APERAK_Task = WIM.WIMM_MSB_ENDE_AUS_ABGELEHNT_Task;
  WIM.WIMM_MDL_ENDE_AUS_GZ_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, acceptOnly:true, initialize:function(config) {
    this.marktpartnerZPView = new WIM.MarktpartnerZPView(WIM.MDLEnde.marktpartnerConfigAusgang);
    this.addTab(this.marktpartnerZPView.root);
  }, loadedData:function(root) {
    this.callParent(arguments);
    this.marktpartnerZPView.load(root);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MDL_WECHSEL_MDL_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, quittierenOnly:true, loadedData:function(root) {
    this.callParent(arguments);
    this.installBackendFehler(root);
  }});
  WIM.WIMM_MDL_WECHSEL_MSB_Task = WIM.WIMM_MDL_WECHSEL_MDL_Task;
  WIM.WIMM_MSB_WECHSEL_MDL_VOLLZOGEN_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MSB_WECHSEL_MDLA_GEPLANT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MSB_WECHSEL_MDLA_GESCHEITERT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MSB_WECHSEL_MDLA_VOLLZOGEN_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIM_GZ_MSB_WECHSEL_MDL_VOLLZOGEN_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIM_GZ_MSB_WECHSEL_MDL_GESCHEITERT_Task = WIM.WIMM_MSB_WECHSEL_BasicTask;
  WIM.WIMM_MDL_BEGINN_AUS_ABGELEHNT_Task = WIM.WIMM_MSB_BEGINN_AUS_ABGELEHNT_Task;
  WIM.WIMM_MDL_BEGINN_AUS_APERAK_Task = WIM.WIMM_MSB_BEGINN_AUS_APERAK_Task;
  WIM.WIMM_MDL_BEGINN_AUS_ANGENOMMEN_Task = Ext.extend(WIM.MSBMDLTask, {wechselHiddenFields:[], noFormularTab:true, formularLabelWidth:1, acceptOnly:true, initialize:function(config) {
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true, diff:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true, diff:true});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', readOnly:true});
    this.addComponent(this.ablesekarteView);
    this.addTab(this.ablesekarteView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true});
    this.addTab(this.geraetedatenView.root);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView(WIM.MDLBeginn.marktpartnerConfigAusgang);
    this.addTab(this.marktpartnerZPView.root);
  }, loadedData:function(root) {
    this.stammdatenView.load(root);
    this.adressenView.load(root);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
    this.ablesekarteView.load(root.data.LOG.ABLESEKARTENXML);
    this.marktpartnerZPView.load(root);
    this.callParent(arguments);
    this.installBackendFehler(root);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
    if (this.zaehlpunkt.data.msb_status == 'MSB' || this.zaehlpunkt.data.msb_status == 'MSBN' || this.zaehlpunkt.data.nb_status == 'ja') {
      var text = new Ext.form.field.Display({value:'Anscheinend wird der Zählpunkt nicht nur als MDL betrieben. Daher würde durch Schreiben der Gerätedaten ins Backend eventuell Daten überschrieben. Bitte bestätigen Sie manuell.'});
      var check = new WIM.Checkbox({boxLabel:'Gerätedaten ins Backend schreiben', name:'changePositionenBackend'});
      this.addComponent(check);
      this.addFormularTab([text, new Ext.Container({height:10}), check.field]);
      this.tabs.setActiveTab(0);
    }
  }});
  WIM.WIM_GZ_MDL_BEGINN_AUS_Task = Ext.extend(WIM.WIMMMSBMDLAdhocTask, {formularLabelWidth:160, senderConfig:{submitGrundzustaendigkeit:false, MDLGZ:true}, initialize:function(config) {
    this.isMDL = this.kind == 'WIM_GZ_MDL_BEGINN_AUS' || this.kind == 'WIMM_MDL_BEGINN_AUS';
    this.receiver = WIM.newNBComponent(this, {name:'mp'});
    this.addComponent(this.zaehlpunkt);
    this.zaehlpunkt.on('change', this.updateZaehlernummerRequired, this);
    this.unknownZaehlpunkt = new WIM.Checkbox({name:'unknownZaehlpunkt', fieldLabel:'Zählpunkt unbekannt'});
    this.unknownZaehlpunkt.on('change', function() {
      if (this.unknownZaehlpunkt.isChecked()) {
        this.zaehlpunkt.load('');
        this.zaehlpunkt.fireEvent('noBackend', this.zaehlpunkt);
        this.zaehlpunkt.setDisabled(true);
      } else {
        this.zaehlpunkt.setDisabled(false);
      }
      this.updateZaehlernummerRequired();
    }, this);
    this.addComponent(this.unknownZaehlpunkt);
    this.addComponent(new WIM.SpaceComponent({}));
    this.addComponent(this.sender);
    this.addComponent(this.receiver);
    this.addComponent(this.ansprechpartner);
    this.addComponent(new WIM.SpaceComponent({}));
    this.leistung = this.newLeistung();
    this.addComponent(this.leistung);
    if (this.isMDL) {
      this.msb = WIM.newMSBComponent(this, {fieldLabel:'MSB', name:'msb', allowBlank:true});
      this.addComponent(this.msb);
    } else {
      this.mdl = WIM.newMDLComponent(this, {fieldLabel:'MDL', name:'mdla', allowBlank:true});
      this.addComponent(this.mdl);
      this.mdln = WIM.newMDLComponent(this, {fieldLabel:'MDLN', name:'mdln', role:undefined, selbst:true, hidden:true});
      this.addComponent(this.mdln);
      this.leistung.on('change', function() {
        var isDoppelt = this.leistung.submitValue() == 'Z03';
        this.mdl.setHidden(isDoppelt);
        this.mdln.setHidden(!isDoppelt);
      }, this);
    }
    this.transaktionsgrund = new WIM.RadioGroup({name:'transaktionsgrund', fieldLabel:'Transaktionsgrund', textFunction:WIM.QQQ.UTILMD.transaktionsgrundQText, items:[{value:'E01'}, {value:'E02'}, {value:'E03'}], defaultValue:'E03'});
    this.transaktionsgrund.on('change', this.updateZaehlernummerRequired, this);
    this.addComponent(this.transaktionsgrund);
    this.datum = new WIM.DateComponent({name:'datum', fieldLabel:'Termin', allowBlank:false, minDate:Ext.Date.clearTime(new Date())});
    this.addComponent(this.datum);
    if (!this.isMDL) {
      var updateBeauftragungbeendigung = function() {
        this.beauftragungbeendigung.setValueDisabled('Z05', this.leistung.submitValue() == 'Z01', true);
      };
      this.leistung.on('change', updateBeauftragungbeendigung, this);
    }
    this.beauftragungbeendigung = new WIM.Antwortstatus({textFunction:WIM.QQQ.MSB.beauftragungbeendigungQText, canAccept:WIM.trueFunction, canReject:WIM.trueFunction, fieldLabel:'Beauftragung/Beendigung', name:'beauftragungbeendigung', items:this.isMDL ? [{key:'Z05'}, {key:'Z06'}] : [{key:'Z04'}, {key:'Z05'}, {key:'Z06'}]});
    this.addComponent(this.beauftragungbeendigung);
    this.addComponent(this.newBemerkung());
    this.addComponent(new WIM.SpaceComponent({}));
    var setZaehlpunktBackend = new WIM.Checkbox({boxLabel:'Alle Änderungen ins Backend schreiben', name:'setZaehlpunktBackend', initialValue:'true'});
    this.addComponent(setZaehlpunktBackend);
    var formItems = this.newFormItems();
    this.addComponentFields(formItems);
    this.addFormularTab(formItems);
    this.stammdatenView = new WIM.StammdatenZPView({task:this, diff:true, noProcessValue:true, defaultKategorie:'E01', editableZaehlernummern:true});
    this.addTab(this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({task:this, diff:true, noProcessValue:true, forceAdresse:false, noMessstelle:true, noKundenadresse:true, kundenname:'Kunde / Vertragspartner des Messdienstleisters (MDLN)'});
    this.addTab(this.adressenView.root);
    this.ablesekarteView = new WIM.AblesekarteView({name:'ablesekartenxml', forceRow:true});
    this.addTab(this.ablesekarteView.root);
    this.addComponent(this.ablesekarteView);
    var initialLog = {HINWEIS:'', ZAEHLERNUMMERN:[]};
    if (!this.isMDL) {
      initialLog.LEISTUNG = 'Z01';
      initialLog.SPANNUNGSEBENEENTNAHME = '';
      initialLog.DRUCKEBENEENTNAHME = '';
      initialLog.SPANNUNGSEBENEMESSUNG = '';
    }
    this.stammdatenView.load({data:{LOG:initialLog}});
    this.stammdatenView.setForceZaehlernummer(false);
  }, loadedZaehlpunkt:function(zpChanged) {
    this.stammdatenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.adressenView.loadSD(this.zaehlpunkt.data, zpChanged);
    this.ablesekarteView.loadSD(this.zaehlpunkt.data, zpChanged);
  }, noBackend:function() {
    this.stammdatenView.noBackend();
    this.adressenView.noBackend();
  }, updateZaehlernummerRequired:function() {
    this.stammdatenView.setForceZaehlernummer(Ext.isEmpty(this.zaehlpunkt.submitValue()) && this.transaktionsgrund.submitValue() != 'E01');
  }});
});
Ext.define('mpm.packages.wim.StubMarktpartnerView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.MSBBeginn = {marktpartnerConfig:{rooted:true, displayOnly:true, MSB0:{name:'mp', fieldLabel:'MSBN'}, MSB:{name:'msba', fieldLabel:'MSBA', grundzustaendigkeit:true}}, marktpartnerConfigGrid:{rooted:true, forceRow:false, readOnly:true, MSB0:{name:'mp', fieldLabel:'MSBN'}, MSB:{name:'msba', fieldLabel:'MSBA', grundzustaendigkeit:true}, LF:{name:'lf', fieldLabel:'LF'}}, marktpartnerConfigAusgang:{name:'marktpartnerxml', displayOnly:true, MSB0:{name:'own', fieldLabel:'MSBN'}, MSB:{name:'msba', fieldLabel:'MSBA', 
  grundzustaendigkeit:true}}, marktpartnerConfigAusgangGrid:{name:'marktpartnerxml', forceRow:false, readOnly:true, MSB0:{name:'own', fieldLabel:'MSBN'}, MSB:{name:'msba', fieldLabel:'MSBA', grundzustaendigkeit:true}, LF:{name:'lf', fieldLabel:'LF'}}};
  WIM.MDLBeginn = {marktpartnerConfig:{rooted:true, displayOnly:true, MDL0:{name:'mp', fieldLabel:'MDLN'}, MDL:{name:'mdla', fieldLabel:'MDLA'}, MSB:{name:'msb', fieldLabel:'MSB', grundzustaendigkeit:true}}, marktpartnerConfigGrid:WIM.MSBBeginn.marktpartnerConfigGrid, marktpartnerConfigAusgangGrid:WIM.MSBBeginn.marktpartnerConfigAusgangGrid, marktpartnerConfigAusgang:{rooted:true, displayOnly:true, MDL0:{name:'own', fieldLabel:'MDLN'}, MDL:{name:'mdla', fieldLabel:'MDLA'}, MSB:{name:'msb', fieldLabel:'MSB', 
  grundzustaendigkeit:true}}};
  WIM.MSBEnde = {marktpartnerConfig:{rooted:true, displayOnly:true, MSB0:{name:'msbgv', fieldLabel:'MSB(GZ)'}, MSB:{name:'mp', fieldLabel:'MSBA'}}, marktpartnerConfigAusgang:{rooted:true, displayOnly:true, noLF:true, MSB0:{name:'msbgv', fieldLabel:'MSB(GZ)'}, MSB:{name:'own', fieldLabel:'MSBA'}}};
  WIM.MDLEnde = {marktpartnerConfig:{rooted:true, displayOnly:true, MDL0:{name:'mdlgv', fieldLabel:'MDL(GZ)'}, MDL:{name:'mp', fieldLabel:'MDLA'}}, marktpartnerConfigAusgang:{rooted:true, displayOnly:true, noMSB:true, noLF:true, MDL0:{name:'mdlgv', fieldLabel:'MDL(GZ)'}, MDL:{name:'own', fieldLabel:'MDLA'}}};
  WIM.MarktpartnerForm = Ext.extend(mpm.packages.wim.FormPopup, {makeWindow:function(title) {
    var items = [];
    var allWidth = 500;
    var labelWidth = 170;
    var qualifiers = this.config.MSB && this.config.MSB0 && this.config.MSB.fieldLabel == 'MSBA' && this.config.MSB0.fieldLabel == 'MSBN' ? WIM.QQQ.SD.marktpartnertypBeginn : WIM.QQQ.SD.marktpartnertyp;
    this.typ = this.newSimpleComboBox({name:'typ', fieldLabel:'Typ', allowBlank:false, width:allWidth + labelWidth, store:WIM.qualifiersToStoreArray(qualifiers, {textFirst:true}), listeners:{scope:this, select:function() {
      if (this.typ.getValue() === 'LF') {
        this.grundzustaendigkeit.allowBlank = true;
        this.grundzustaendigkeit.setDisabled(true);
        this.grundzustaendigkeit.validate();
      } else {
        this.grundzustaendigkeit.allowBlank = true;
        this.grundzustaendigkeit.setDisabled(true);
        this.grundzustaendigkeit.validate();
      }
    }, beforerender:function() {
      if (this.typ.getValue() === 'LF') {
        this.grundzustaendigkeit.allowBlank = true;
        this.grundzustaendigkeit.setDisabled(true);
        this.grundzustaendigkeit.validate();
      } else {
        this.grundzustaendigkeit.allowBlank = true;
        this.grundzustaendigkeit.setDisabled(true);
        this.grundzustaendigkeit.validate();
      }
    }}});
    this.mpid = new Ext.form.field.Text({name:'mpid', allowBlank:false, maxLength:70, grow:true, growMin:allWidth + labelWidth, width:allWidth + labelWidth, fieldLabel:'Marktpartner-ID'});
    this.mpidcode = this.newSimpleComboBox({name:'mpidcode', fieldLabel:'Marktpartner-ID Code', grow:true, growMin:allWidth + labelWidth, width:allWidth + labelWidth, allowBlank:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.mpidcode, {noKey:false})});
    this.name = new Ext.form.field.Text({name:'name', maxLength:70, allowBlank:true, grow:true, growMin:allWidth + labelWidth, editable:false, width:allWidth + labelWidth, fieldLabel:'Marktpartner-Name'});
    var meldepunkte = this.meldepunkteContext.toStringArray();
    var meldepunktNotrequired = !this.meldepunkteContext.hasStore;
    var meldepunktestore = new Ext.data.ArrayStore({fields:['meldepunkt'], data:meldepunkte});
    this.meldepunkt = this.newSimpleComboBox({name:'meldepunkt', fieldLabel:'Meldepunkt', allowBlank:false, width:allWidth + labelWidth, store:meldepunkte});
    this.grundzustaendigkeit = this.newSimpleComboBox({name:'grundzustaendigkeit', fieldLabel:'Grundzuständigkeit', grow:true, growMin:allWidth + labelWidth, width:allWidth + labelWidth, allowBlank:true, hidden:true, store:WIM.qualifiersToStoreArray(WIM.QQQ.SD.grundzustaendigkeit, {noKey:false})});
    items = [this.typ, this.mpid, this.mpidcode, this.meldepunkt, this.grundzustaendigkeit];
    this.createCommitCancelButtons();
    this.form = new Ext.form.Panel({flex:1, bodyPadding:'10', items:items, scrollable:true, fieldDefaults:{labelWidth:labelWidth}});
    this.form.on('validitychange', function(form, valid) {
      this.commitButton.setDisabled(!valid);
    }, this);
    this.createFormWindow(this.mode == 'create' ? 'Marktpartner hinzufügen' : 'Marktpartner bearbeiten', 750, 300);
  }, loadRecord:function(r) {
    this.typ.setValue(r.data.typ);
    this.mpid.setValue(r.data.mpid);
    this.mpidcode.setValue(r.data.mpidcode);
    this.name.setValue(r.data.name);
    this.meldepunkt.setValue(r.data.meldepunkt);
    this.grundzustaendigkeit.setValue(r.data.grundzustaendigkeit);
  }, saveRecord:function(r) {
    r.beginEdit();
    r.set('typ', this.typ.getValue());
    r.set('mpid', this.mpid.getValue());
    r.set('mpidcode', this.mpidcode.getValue());
    r.set('name', this.name.getValue());
    r.set('meldepunkt', this.meldepunkt.getValue());
    r.set('grundzustaendigkeit', this.grundzustaendigkeit.getValue());
    r.endEdit();
  }, edit:function(store, record, config, sourceStoreMeldepunkte) {
    this.config = config;
    this.store = store;
    this.sourceStoreMeldepunkte = sourceStoreMeldepunkte;
    this.record = record;
    this.mode = 'edit';
    this.makeWindow('Bearbeiten');
    this.loadRecord(record);
    this.window.show();
  }, create:function(store, record, config, sourceStoreMeldepunkte) {
    this.config = config;
    this.store = store;
    this.sourceStoreMeldepunkte = sourceStoreMeldepunkte;
    this.record = record;
    this.mode = 'create';
    this.makeWindow('Hinzufügen', config);
    this.window.show();
  }});
  WIM.MarktpartnerGridView = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.meldepunkteContext = config.meldepunkteContext || new WIM.MeldepunkteContext({});
    this.readOnly = config.readOnly;
    this.config = config;
    this.grid = new WIM.BasicGrid({title:'Marktpartner', columns:WIM.MarktpartnerGridView.MarktpartnerColumns, readOnly:config.readOnly, forceRow:config.forceRow, editContext:{create:function(grid) {
      (new WIM.MarktpartnerForm({meldepunkteContext:config.meldepunkteContext})).create(grid.store, new grid.store.model({}), this.config);
    }.bind(this), edit:function(grid, record) {
      (new WIM.MarktpartnerForm({meldepunkteContext:config.meldepunkteContext})).edit(grid.store, record, this.config);
    }.bind(this), remove:function(grid, record) {
      grid.store.remove(record);
    }}});
    this.grid.on('change', function() {
      this.fireEvent('change', this);
    }, this);
    this.root = this.grid.root;
  }, canAccept:function() {
    return this.grid.canAccept();
  }, submitType:function() {
    return 'tuple';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.begin('marktpartner', 'relation');
    Ext.each(this.grid.getValue(), function(v) {
      x.begin('item', 'tuple');
      x.atom('typ', v.typ);
      x.atom('mpid', v.mpid);
      x.atom('mpidcode', v.mpidcode);
      x.atom('name', v.name);
      x.atom('meldepunkt', v.meldepunkt);
      x.atom('grundzustaendigkeit', v.grundzustaendigkeit);
      x.end('item');
    }, this);
    x.end('marktpartner');
    return x.result();
  }, loadInitial:function(data, zpChanged) {
    if (!this.loaded || zpChanged) {
      this.doLoadInitial(data);
    }
  }, load:function(data) {
    this.doLoad(data);
  }, loadprocess:function(data) {
    if (!this.loaded) {
      this.doLoadprocess(data);
    }
  }, loadprocessDetail:function(data) {
    if (!this.loaded) {
      this.doLoadprocessDetail(data);
    }
  }, loadSD:function(data, zpChanged) {
    if (!this.loaded) {
      this.doLoad(data);
    }
  }, doLoadprocess:function(data) {
    if (!data) {
      return;
    }
    var meldepunkt = Ext.valueFrom(data.MELDEPUNKT, data.ZAEHLPUNKT);
    var marktpartnerxml = [];
    if (this.config.MSB0 && !this.config.MSB0.noProcessValue) {
      if (!Ext.isEmpty(data[(this.config.MSB0.name + '_mpid').toUpperCase()])) {
        marktpartnerxml.push({typ:this.config.MSB0.fieldLabel, name:Ext.valueFrom(data[(this.config.MSB0.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data[(this.config.MSB0.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data[(this.config.MSB0.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data[(this.config.MSB0.name + '_gz').toUpperCase()], '') || 'NEIN'});
      }
    }
    if (this.config.MSB && !this.config.MSB.noProcessValue) {
      if (!Ext.isEmpty(data[(this.config.MSB.name + '_mpid').toUpperCase()])) {
        marktpartnerxml.push({typ:this.config.MSB.fieldLabel, name:Ext.valueFrom(data[(this.config.MSB.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data[(this.config.MSB.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data[(this.config.MSB.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data[(this.config.MSB.name + '_gz').toUpperCase()], '') || 'NEIN'});
      }
    }
    if (this.config.NB && !this.config.NB.noProcessValue) {
      if (!Ext.isEmpty(data[(this.config.NB.name + '_mpid').toUpperCase()])) {
        marktpartnerxml.push({typ:this.config.NB.fieldLabel, name:Ext.valueFrom(data[(this.config.NB.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data[(this.config.NB.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data[(this.config.NB.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data[(this.config.NB.name + '_gz').toUpperCase()], '')});
      }
    }
    if (this.config.LF && !this.config.LF.noProcessValue) {
      if (!Ext.isEmpty(data[(this.config.LF.name + '_mpid').toUpperCase()])) {
        marktpartnerxml.push({typ:this.config.LF.fieldLabel, name:Ext.valueFrom(data[(this.config.LF.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data[(this.config.LF.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data[(this.config.LF.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data[(this.config.LF.name + '_gz').toUpperCase()], '')});
      }
    }
    if (this.config.OWN && !this.config.OWN.noProcessValue) {
      if (!Ext.isEmpty(data[(this.config.OWN.name + '_mpid').toUpperCase()])) {
        marktpartnerxml.push({typ:this.config.OWN.fieldLabel, name:Ext.valueFrom(data[(this.config.OWN.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data[(this.config.OWN.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data[(this.config.OWN.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data[(this.config.OWN.name + '_gz').toUpperCase()], '')});
      }
    }
    if (!this.grid.hasValue()) {
      this.grid.load(marktpartnerxml);
    }
  }, doLoad:function(data) {
    if (!data) {
      return;
    }
    var meldepunkt = Ext.valueFrom(data.meldepunkt, data.zaehlpunkt);
    var marktpartnerxml = [];
    if (Ext.isArray(data.marktpartner)) {
      Ext.each(data.marktpartner, function(z) {
        marktpartnerxml.push(z);
      }, this);
      this.loaded = true;
    } else {
      if (this.grid.hasValue()) {
        this.grid.store.each(function(z) {
          marktpartnerxml.push(z.data);
        }, this);
      }
      if (this.config.MSB && !this.config.MSB.noSDValue) {
        Ext.each(data.msb, function(z) {
          marktpartnerxml.push({typ:this.config.MSB.fieldLabel, mpid:z.mpid, mpidcode:z.mpidcode, name:z.partnername, meldepunkt:meldepunkt, grundzustaendigkeit:z.gz});
        }, this);
      }
      if (this.config.MSB0 && !this.config.MSB0.noSDValue) {
        Ext.each(data.msb, function(z) {
          if (z.mpid != '') {
            marktpartnerxml.push({typ:this.config.MSB0.fieldLabel, mpid:z.mpid, mpidcode:z.mpidcode, name:z.partnername, meldepunkt:meldepunkt, grundzustaendigkeit:z.gz});
          }
        }, this);
      }
      if (this.config.NB && !this.config.NB.noSDValue) {
        Ext.each(data.nb, function(z) {
          if (z.mpid != '') {
            marktpartnerxml.push({typ:this.config.NB.fieldLabel, mpid:z.mpid, mpidcode:z.mpidcode, name:z.partnername, meldepunkt:meldepunkt, grundzustaendigkeit:z.gz});
          }
        }, this);
      }
      if (this.config.LF && !this.config.LF.noSDValue) {
        Ext.each(data.lf, function(z) {
          if (z.mpid != '') {
            marktpartnerxml.push({typ:this.config.LF.fieldLabel || 'LF', mpid:z.mpid, mpidcode:z.mpidcode, name:z.partnername, meldepunkt:meldepunkt, grundzustaendigkeit:''});
          }
        }, this);
        Ext.each(data.references, function(z) {
          if (z.lf != undefined && z.lf.mpid != '') {
            marktpartnerxml.push({typ:this.config.LF.fieldLabel || 'LF', mpid:z.lf.mpid, mpidcode:z.lf.mpidcode, name:z.lf.partnername, meldepunkt:z.meldepunkt, grundzustaendigkeit:''});
          }
        }, this);
      }
    }
    this.grid.load(marktpartnerxml);
  }, doLoadInitial:function(data) {
    if (data) {
      this.loaded = true;
    }
  }, doLoadprocessDetail:function(data) {
    if (!data) {
      return;
    }
    this.loaded = true;
    var meldepunkt = Ext.valueFrom(data.data.LOG.MELDEPUNKT, data.data.LOG.ZAEHLPUNKT);
    var marktpartnerxml = [];
    if (!Ext.isEmpty(data.data.LOG.POSITIONENXML)) {
      if (Ext.isArray(data.data.LOG.POSITIONENXML.marktpartner)) {
        Ext.each(data.data.LOG.POSITIONENXML.marktpartner, function(z) {
          marktpartnerxml.push(z);
        }, this);
      } else {
        if (this.config.MSB0 && !this.config.MSB0.noProcessValue) {
          if (!Ext.isEmpty(data.data.LOG[(this.config.MSB0.name + '_mpid').toUpperCase()])) {
            marktpartnerxml.push({typ:this.config.MSB0.fieldLabel, name:Ext.valueFrom(data.data.LOG[(this.config.MSB0.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data.data.LOG[(this.config.MSB0.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data.data.LOG[(this.config.MSB0.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data.data.LOG[(this.config.MSB0.name + '_gz').toUpperCase()], '') || 'NEIN'});
          }
        }
        if (this.config.MSB && !this.config.MSB.noProcessValue) {
          if (!Ext.isEmpty(data.data.LOG[(this.config.MSB.name + '_mpid').toUpperCase()])) {
            marktpartnerxml.push({typ:this.config.MSB.fieldLabel, name:Ext.valueFrom(data.data.LOG[(this.config.MSB.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data.data.LOG[(this.config.MSB.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data.data.LOG[(this.config.MSB.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data.data.LOG[(this.config.MSB.name + '_gz').toUpperCase()], '') || 'NEIN'});
          }
        }
        if (this.config.NB && !this.config.NB.noProcessValue) {
          if (!Ext.isEmpty(data.data.LOG[(this.config.NB.name + '_mpid').toUpperCase()])) {
            marktpartnerxml.push({typ:this.config.NB.fieldLabel, name:Ext.valueFrom(data.data.LOG[(this.config.NB.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data.data.LOG[(this.config.NB.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data.data.LOG[(this.config.NB.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data.data.LOG[(this.config.NB.name + '_gz').toUpperCase()], '')});
          }
        }
        if (this.config.LF && !this.config.LF.noProcessValue) {
          if (!Ext.isEmpty(data.data.LOG[(this.config.LF.name + '_mpid').toUpperCase()])) {
            marktpartnerxml.push({typ:this.config.LF.fieldLabel, name:Ext.valueFrom(data.data.LOG[(this.config.LF.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data.data.LOG[(this.config.LF.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data.data.LOG[(this.config.LF.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data.data.LOG[(this.config.LF.name + '_gz').toUpperCase()], '')});
          }
        }
        if (this.config.OWN && !this.config.OWN.noProcessValue) {
          if (!Ext.isEmpty(data.data.LOG[(this.config.OWN.name + '_mpid').toUpperCase()])) {
            marktpartnerxml.push({typ:this.config.OWN.fieldLabel, name:Ext.valueFrom(data.data.LOG[(this.config.OWN.name + '_partnername').toUpperCase()], ''), mpid:Ext.valueFrom(data.data.LOG[(this.config.OWN.name + '_mpid').toUpperCase()], ''), mpidcode:Ext.valueFrom(data.data.LOG[(this.config.OWN.name + '_mpidcode').toUpperCase()], ''), meldepunkt:meldepunkt, grundzustaendigkeit:Ext.valueFrom(data.data.LOG[(this.config.OWN.name + '_gz').toUpperCase()], '')});
          }
        }
      }
    }
    if (!this.grid.hasValue()) {
      this.grid.load(marktpartnerxml);
    }
  }, noBackend:function() {
    this.loaded = true;
  }});
  WIM.MarktpartnerGridView.MarktpartnerColumns = [{name:'typ', header:'Typ', width:100}, {name:'mpid', header:'Marktpartner-ID', width:180}, {name:'mpidcode', header:'Marktpartner-ID-Code', width:180}, {name:'name', header:'Marktpartner-Name', width:180}, {name:'meldepunkt', header:'Meldepunkt', width:300}, {name:'grundzustaendigkeit', header:'Grundzuständigkeit', width:180}];
})();
Ext.define('mpm.packages.wim.StubMeldepunkteView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  mpm.packages.wim.MeldepunkteView = Ext.extend(WIM.NamedComponent, {constructor:function(config) {
    this.callParent(arguments);
    this.tasksaved = false;
    this.readOnly = config.readOnly;
    this.z82z30Required = !!config.z82z30Required;
    this.meldepunkteGrid = new WIM.BasicGrid({title:'Meldepunkte', id:'meldepunkteGrid', columns:mpm.packages.wim.MeldepunkteView.meldepunkteColumns, columnhide:true, readOnly:this.readOnly, forceRow:true, editContext:{create:function(grid) {
      var record = new grid.store.model({});
      var f = new mpm.packages.wim.MeldepunkteForm({});
      f.on('commit', function() {
        this.fireEvent('wizardchange', this, 'create', grid.store, record);
      }, this);
      f.create(grid.store, record);
    }.bind(this), edit:function(grid, record) {
      var oldRecord = record.copy();
      var f = new mpm.packages.wim.MeldepunkteForm({});
      f.on('commit', function() {
        this.fireEvent('wizardchange', this, 'update', grid.store, record, oldRecord);
      }, this);
      f.edit(grid.store, record);
    }.bind(this), remove:function(grid, record) {
      grid.store.remove(record);
      this.fireEvent('wizardchange', this, 'destroy', grid.store, record);
    }.bind(this)}, isRecordValid:function(r) {
      return !Ext.isEmpty(r.data.meldepunkttyp);
    }.bind(this)});
    this.root = this.meldepunkteGrid.root;
    this.store = this.root.store;
  }, canAccept:function() {
    if (this.z82z30Required) {
      var z82 = false;
      var z30 = false;
      this.meldepunkteGrid.store.each(function(z) {
        if (z.data.meldepunkttyp == 'pbmelo') {
          z82 = true;
        }
        if (z.data.meldepunkttyp == 'malo') {
          z30 = true;
        }
      }, this);
      return z82 && z30;
    } else {
      return this.meldepunkteGrid.canAccept();
    }
  }, submitType:function() {
    return 'tuple';
  }, submitValue:function() {
    var x = new WIM.XMLOutput();
    x.begin('meldepunkte', 'relation');
    Ext.each(this.meldepunkteGrid.getValue(), function(v) {
      x.begin('position', 'tuple');
      x.atom('meldepunkttyp', v.meldepunkttyp);
      x.atom('meldepunkt', v.meldepunkt);
      x.atom('zaehlpunkt', v.zaehlpunkt);
      x.atom('referenzmalomelo', v.referenzmalomelo == undefined ? '' : v.referenzmalomelo);
      x.atom('betriebszustand', v.betriebszustand == undefined ? '' : v.betriebszustand);
      x.atom('abrechnungsintervalllf', v.abrechnungsintervalllf == undefined ? '' : v.abrechnungsintervalllf);
      x.atom('lieferrichtung', v.lieferrichtung == undefined ? '' : v.lieferrichtung);
      x.atom('messtechnischeeinordnung', v.messtechnischeeinordnung == undefined ? '' : v.messtechnischeeinordnung);
      x.atom('prognosegrundlage', v.prognosegrundlage == undefined ? '' : v.prognosegrundlage);
      x.atom('detailsprognosegrundlage', v.detailsprognosegrundlage == undefined ? '' : v.detailsprognosegrundlage);
      x.atom('detailsprognosegrundlage2', v.detailsprognosegrundlage2 == undefined ? '' : v.detailsprognosegrundlage2);
      x.atom('veranschlagtejahresmenge', v.veranschlagtejahresmenge == undefined ? '' : v.veranschlagtejahresmenge);
      x.atom('arterzeugendemarktlokation', v.arterzeugendemarktlokation == undefined ? '' : v.arterzeugendemarktlokation);
      x.atom('normiertesProfil', v.normiertesProfil == undefined ? '' : v.normiertesProfil);
      x.atom('normiertesProfilVerfahren', v.normiertesProfilVerfahren == undefined ? '' : v.normiertesProfilVerfahren);
      x.atom('normiertesProfilCode', v.normiertesProfilCode == undefined ? '' : v.normiertesProfilCode);
      x.atom('profilschar', v.profilschar == undefined ? '' : v.profilschar);
      x.atom('profilscharVerfahren', v.profilscharVerfahren == undefined ? '' : v.profilscharVerfahren);
      x.atom('profilscharCode', v.profilscharCode == undefined ? '' : v.profilscharCode);
      x.atom('klimazone', v.klimazone == undefined ? '' : v.klimazone);
      x.atom('dienstanbieter', v.dienstanbieter == undefined ? '' : v.dienstanbieter);
      x.atom('klimazoneid', v.klimazoneid == undefined ? '' : v.klimazoneid);
      x.atom('referenzprofilCode', v.referenzprofilCode == undefined ? '' : v.referenzprofilCode);
      x.atom('arbeitleistung', v.arbeitleistung == undefined ? '' : v.arbeitleistung);
      x.atom('arbeitleistungmenge', v.arbeitleistungmenge == undefined ? '' : v.arbeitleistungmenge);
      x.atom('arbeitleistungeinheit', v.arbeitleistungeinheit == undefined ? '' : v.arbeitleistungeinheit);
      x.atom('aufteilungsmenge', v.aufteilungsmenge == undefined ? '' : v.aufteilungsmenge);
      x.atom('druckebeneentnahme', v.druckebeneentnahme == undefined ? '' : v.druckebeneentnahme);
      x.atom('gasqualitaet', v.gasqualitaet == undefined ? '' : v.gasqualitaet);
      x.atom('spannungsebeneentnahme', v.spannungsebeneentnahme == undefined ? '' : v.spannungsebeneentnahme);
      x.atom('spannungsebenemessung', v.spannungsebenemessung == undefined ? '' : v.spannungsebenemessung);
      x.atom('turnusablesung', v.turnusablesung == undefined ? '' : v.turnusablesung);
      x.atom('turnusablesungnb', v.turnusablesungnb == undefined ? '' : v.turnusablesungnb);
      x.atom('turnusintervall', v.turnusintervall == undefined ? '' : v.turnusintervall);
      x.atom('turnusintervallnb', v.turnusintervallnb == undefined ? '' : v.turnusintervallnb);
      x.end('position');
    }, this);
    x.end('meldepunkte');
    return x.result();
  }, loadInitial:function(data, zpChanged) {
    if (!this.loaded || zpChanged) {
      this.doLoad(data);
    }
  }, load:function(data) {
    this.doLoad(data);
  }, loadSD:function(data) {
    this.doLoad(data);
  }, doLoad:function(data) {
    if (!data) {
      return;
    }
    this.loaded = true;
    var meldepunkte = [];
    this.meldepunkteGrid.store.each(function(z) {
      meldepunkte.push(z.data);
    }, this);
    var meldepunkttyp = 'pbmelo';
    var znummern = null;
    var value = function(v) {
      return Ext.valueFrom(v, '');
    };
    if (!Ext.isEmpty(data.meldepunkte)) {
      this.tasksaved = true;
      this.meldepunkteGrid.store.each(function(z) {
        meldepunkte.remove(z);
      }, this);
      Ext.each(data.meldepunkte, function(l) {
        meldepunkte.push(l);
      }, this);
    } else if (!this.tasksaved) {
      if (!Ext.isEmpty(data.data)) {
        if (!Ext.isEmpty(data.data.LOG.MELDEPUNKTEXML)) {
          Ext.each(data.data.LOG.MELDEPUNKTEXML.meldepunkte, function(l) {
            meldepunkte.push(l);
          }, this);
        } else {
          if (data.data.LOG.ZAEHLERNUMMERN) {
            znummern = data.data.LOG.ZAEHLERNUMMERN;
          }
          var malo_id = '';
          var melo_id = '';
          if (data.data.LOG.MELDEPUNKT.length == 11 || data.data.LOG.ZAEHLPUNKT.length == 11) {
            meldepunkttyp = 'malo';
            malo_id = data.data.LOG.MELDEPUNKT.length == 11 ? data.data.LOG.MELDEPUNKT : data.data.LOG.ZAEHLPUNKT;
          } else {
            melo_id = data.data.LOG.ZAEHLPUNKT;
          }
          meldepunkte.push({meldepunkt:value(malo_id), zaehlpunkt:value(melo_id), meldepunkttyp:value(meldepunkttyp), meldepunkttyp_process:value(meldepunkttyp), meldepunkttyp_sd:'', prognosegrundlage:value(data.data.LOG.PROGNOSEGRUNDLAGE), prognosegrundlage_process:value(data.data.LOG.PROGNOSEGRUNDLAGE), prognosegrundlage_sd:'', spannungsebeneentnahme:value(data.data.LOG.SPANNUNGSEBENEENTNAHME), spannungsebeneentnahme_process:value(data.data.LOG.SPANNUNGSEBENEENTNAHME), spannungsebeneentnahme_sd:'', 
          spannungsebenemessung:value(data.data.LOG.SPANNUNGSEBENEMESSUNG), spannungsebenemessung_process:value(data.data.LOG.SPANNUNGSEBENEMESSUNG), spannungsebenemessung_sd:'', druckebeneentnahme:value(data.data.LOG.DRUCKEBENEENTNAHME), druckebeneentnahme_process:value(data.data.LOG.DRUCKEBENEENTNAHME), druckebeneentnahme_sd:'', gasqualitaet:value(data.data.LOG.GASQUALITAET), gasqualitaet_process:value(data.data.LOG.GASQUALITAET), gasqualitaet_sd:'', turnusablesung:value(data.data.LOG.TURNUSABLESUNG), 
          turnusablesung_process:value(data.data.LOG.TURNUSABLESUNG), turnusablesung_sd:'', turnusintervall:value(data.data.LOG.TURNUSINTERVALL), turnusintervall_process:value(data.data.LOG.TURNUSINTERVALL), turnusintervall_sd:'', turnusablesungnb:value(data.data.LOG.TURNUSABLESUNGNB), turnusablesungnb_process:value(data.data.LOG.TURNUSABLESUNGNB), turnusablesungnb_sd:'', turnusintervallnb:value(data.data.LOG.TURNUSINTERVALLNB), turnusintervallnb_process:value(data.data.LOG.TURNUSINTERVALLNB), turnusintervallnb_sd:'', 
          abrechnungsintervalllf:value(data.data.LOG.ABRECHNUNGSINTERVALLLF), abrechnungsintervalllf_process:value(data.data.LOG.ABRECHNUNGSINTERVALLLF), abrechnungsintervalllf_sd:'', referenzmalomelo:'', referenzmalomelo_process:'', referenzmalomelo_sd:'', zaehlernummern:value(znummern), zaehlernummern_process:value(znummern), zaehlernummern_sd:''});
        }
      } else {
        if (meldepunkte.length > 0) {
          var same = false;
          Ext.each(meldepunkte, function(l) {
            var melo_id = l.zaehlpunkt;
            var malo_id = l.meldepunkt;
            if (melo_id == data.meldepunkt || melo_id == data.zaehlpunkt || (malo_id == data.meldepunkt || malo_id == data.zaehlpunkt)) {
              same = true;
              meldepunkte.remove(l);
              meldepunkte.push({meldepunkt:value(l.meldepunkt), zaehlpunkt:value(l.zaehlpunkt), meldepunkttyp:value(l.meldepunkttyp), meldepunkttyp_process:value(l.meldepunkttyp), meldepunkttyp_sd:value(data.meldepunkttyp), prognosegrundlage:value(l.prognosegrundlage), prognosegrundlage_process:value(l.prognosegrundlage), prognosegrundlage_sd:value(data.prognosegrundlage), spannungsebeneentnahme:value(l.spannungsebeneentnahme), spannungsebeneentnahme_process:value(l.spannungsebeneentnahme), spannungsebeneentnahme_sd:value(data.spannungsebeneentnahme), 
              spannungsebenemessung:value(data.spannungsebenemessung), spannungsebenemessung_process:value(l.spannungsebenemessung), spannungsebenemessung_sd:value(data.spannungsebenemessung), druckebeneentnahme:value(l.druckebeneentnahme), druckebeneentnahme_process:value(l.druckebeneentnahme), druckebeneentnahme_sd:value(data.druckebeneentnahme), gasqualitaet:value(l.gasqualitaet), gasqualitaet_process:value(l.gasqualitaet), gasqualitaet_sd:value(data.gasqualitaet), turnusablesung:value(l.turnusablesung), 
              turnusablesung_process:value(l.turnusablesung), turnusablesung_sd:value(data.turnusablesung), turnusintervall:value(l.turnusintervall), turnusintervall_process:value(l.turnusintervall), turnusintervall_sd:value(data.turnusintervall), turnusablesungnb:value(l.turnusablesungnb), turnusablesungnb_process:value(l.turnusablesungnb), turnusablesungnb_sd:value(data.turnusablesungnb), turnusintervallnb:value(l.turnusintervallnb), turnusintervallnb_process:value(l.turnusintervallnb), turnusintervallnb_sd:value(data.turnusintervallnb), 
              abrechnungsintervalllf:value(l.abrechnungsintervalllf), abrechnungsintervalllf_process:value(l.abrechnungsintervalllf), abrechnungsintervalllf_sd:value(data.abrechnungsintervalllf), referenzmalomelo:value(l.referenzmalomelo), referenzmalomelo_process:value(l.referenzmalomelo), referenzmalomelo_sd:value(data.referenzmalomelo), zaehlernummern:value(l.zaehlernummern), zaehlernummern_process:value(l.zaehlernummern), zaehlernummern_sd:value(data.zaehlernummern)});
            }
          }, this);
          if (!same) {
            meldepunkte.push({meldepunkt:value(data.meldepunkt), zaehlpunkt:value(data.zaehlpunkt), meldepunkttyp:value(data.meldepunkttyp), meldepunkttyp_process:'', meldepunkttyp_sd:value(data.meldepunkttyp), prognosegrundlage:value(data.prognosegrundlage), prognosegrundlage_process:'', prognosegrundlage_sd:value(data.prognosegrundlage), spannungsebeneentnahme:value(data.spannungsebeneentnahme), spannungsebeneentnahme_process:'', spannungsebeneentnahme_sd:value(data.spannungsebeneentnahme), spannungsebenemessung:value(data.spannungsebenemessung), 
            spannungsebenemessung_process:'', spannungsebenemessung_sd:value(data.spannungsebenemessung), druckebeneentnahme:value(data.druckebeneentnahme), druckebeneentnahme_process:'', druckebeneentnahme_sd:value(data.druckebeneentnahme), gasqualitaet:value(data.gasqualitaet), gasqualitaet_process:'', gasqualitaet_sd:value(data.gasqualitaet), turnusablesung:value(data.turnusablesung), turnusablesung_process:'', turnusablesung_sd:value(data.turnusablesung), turnusintervall:value(data.turnusintervall), 
            turnusintervall_process:'', turnusintervall_sd:value(data.turnusintervall), turnusablesungnb:value(data.turnusablesungnb), turnusablesungnb_process:'', turnusablesungnb_sd:value(data.turnusablesungnb), turnusintervallnb:value(data.turnusintervallnb), turnusintervallnb_process:'', turnusintervallnb_sd:value(data.turnusintervallnb), abrechnungsintervalllf:value(data.abrechnungsintervalllf), abrechnungsintervalllf_process:'', abrechnungsintervalllf_sd:value(data.abrechnungsintervalllf), 
            referenzmalomelo:value(data.referenzmalomelo), referenzmalomelo_process:'', referenzmalomelo_sd:value(data.referenzmalomelo), zaehlernummern:value(data.zaehlernummern), zaehlernummern_process:'', zaehlernummern_sd:value(data.zaehlernummern)});
          }
        } else {
          meldepunkte.push({meldepunkt:value(data.meldepunkt), zaehlpunkt:value(data.zaehlpunkt), meldepunkttyp:value(data.meldepunkttyp), prognosegrundlage:value(data.prognosegrundlage), spannungsebeneentnahme:value(data.spannungsebeneentnahme), spannungsebenemessung:value(data.spannungsebenemessung), druckebeneentnahme:value(data.druckebeneentnahme), gasqualitaet:value(data.gasqualitaet), turnusablesung:value(data.turnusablesung), turnusintervall:value(data.turnusintervall), turnusablesungnb:value(data.turnusablesungnb), 
          turnusintervallnb:value(data.turnusintervallnb), abrechnungsintervalllf:value(data.abrechnungsintervalllf), referenzmalomelo:value(data.referenzmeldepunkte), zaehlernummern:value(data.zaehlernummern), meldepunkttyp_process:'', meldepunkttyp_sd:value(data.meldepunkttyp), prognosegrundlage_process:'', prognosegrundlage_sd:value(data.prognosegrundlage), spannungsebeneentnahme_process:'', spannungsebeneentnahme_sd:value(data.spannungsebeneentnahme), spannungsebenemessung_process:'', spannungsebenemessung_sd:value(data.spannungsebenemessung), 
          druckebeneentnahme_process:'', druckebeneentnahme_sd:value(data.druckebeneentnahme), gasqualitaet_process:'', gasqualitaet_sd:value(data.gasqualitaet), turnusablesung_process:'', turnusablesung_sd:value(data.turnusablesung), turnusintervall_process:'', turnusintervall_sd:value(data.turnusintervall), turnusablesungnb_process:'', turnusablesungnb_sd:value(data.turnusablesungnb), turnusintervallnb_process:'', turnusintervallnb_sd:value(data.turnusintervallnb), abrechnungsintervalllf_process:'', 
          abrechnungsintervalllf_sd:value(data.abrechnungsintervalllf), referenzmalomelo_process:'', referenzmalomelo_sd:value(data.referenzmalomelo), zaehlernummern_process:'', zaehlernummern_sd:value(data.zaehlernummern)});
        }
        if (!Ext.isEmpty(data.references)) {
          Ext.each(data.references, function(l) {
            var referenzen = l.meldepunkttyp == 'malo' ? l.referenzmeldepunkte : '';
            if (meldepunkte.length > 0) {
              meldepunkte.push({meldepunkt:value(l.meldepunkt), zaehlpunkt:value(l.zaehlpunkt), meldepunkttyp:value(l.meldepunkttyp), prognosegrundlage:value(l.prognosegrundlage), spannungsebeneentnahme:value(l.spannungsebeneentnahme), spannungsebenemessung:value(l.spannungsebenemessung), druckebeneentnahme:value(l.druckebeneentnahme), gasqualitaet:value(l.gasqualitaet), turnusablesung:value(l.turnusablesung), turnusintervall:value(l.turnusintervall), turnusablesungnb:value(l.turnusablesungnb), turnusintervallnb:value(l.turnusintervallnb), 
              abrechnungsintervalllf:value(l.abrechnungsintervalllf), referenzmalomelo:value(l.referenzmeldepunkte), zaehlernummern:'', meldepunkttyp_sd:value(l.meldepunkttyp), prognosegrundlage_sd:value(l.prognosegrundlage), spannungsebeneentnahme_sd:value(l.spannungsebeneentnahme), spannungsebenemessung_sd:value(l.spannungsebenemessung), druckebeneentnahme_sd:value(l.druckebeneentnahme), gasqualitaet_sd:value(l.gasqualitaet), turnusablesung_sd:value(l.turnusablesung), turnusintervall_sd:value(l.turnusintervall), 
              turnusablesungnb_sd:value(l.turnusablesungnb), turnusintervallnb_sd:value(l.turnusintervallnb), abrechnungsintervalllf_sd:value(l.abrechnungsintervalllf), referenzmalomelo_sd:value(l.referenzmeldepunkte), zaehlernummern_sd:'', meldepunkttyp_process:'', prognosegrundlage_process:'', spannungsebeneentnahme_process:'', spannungsebenemessung_process:'', druckebeneentnahme_process:'', gasqualitaet_process:'', turnusablesung_process:'', turnusintervall_process:'', turnusablesungnb_process:'', 
              turnusintervallnb_process:'', abrechnungsintervalllf_process:'', referenzmalomelo_process:'', zaehlernummern_process:''});
            } else {
              meldepunkte.push({meldepunkt:value(l.meldepunkt), zaehlpunkt:value(l.zaehlpunkt), meldepunkttyp:value(l.meldepunkttyp), prognosegrundlage:value(l.prognosegrundlage), spannungsebeneentnahme:value(l.spannungsebeneentnahme), spannungsebenemessung:value(l.spannungsebenemessung), druckebeneentnahme:value(l.druckebeneentnahme), gasqualitaet:value(l.gasqualitaet), turnusablesung:value(l.turnusablesung), turnusintervall:value(l.turnusintervall), turnusablesungnb:value(l.turnusablesungnb), turnusintervallnb:value(l.turnusintervallnb), 
              abrechnungsintervalllf:value(l.abrechnungsintervalllf), referenzmalomelo:value(l.referenzmeldepunkte), zaehlernummern:'', meldepunkttyp_sd:value(l.meldepunkttyp), prognosegrundlage_sd:value(l.prognosegrundlage), spannungsebeneentnahme_sd:value(l.spannungsebeneentnahme), spannungsebenemessung_sd:value(l.spannungsebenemessung), druckebeneentnahme_sd:value(l.druckebeneentnahme), gasqualitaet_sd:value(l.gasqualitaet), turnusablesung_sd:value(l.turnusablesung), turnusintervall_sd:value(l.turnusintervall), 
              turnusablesungnb_sd:value(l.turnusablesungnb), turnusintervallnb_sd:value(l.turnusintervallnb), abrechnungsintervalllf_sd:value(l.abrechnungsintervalllf), referenzmalomelo_sd:value(l.referenzmeldepunkte), zaehlernummern_sd:'', meldepunkttyp_process:'', prognosegrundlage_process:'', spannungsebeneentnahme_process:'', spannungsebenemessung_process:'', druckebeneentnahme_process:'', gasqualitaet_process:'', turnusablesung_process:'', turnusintervall_process:'', turnusablesungnb_process:'', 
              turnusintervallnb_process:'', abrechnungsintervalllf_process:'', referenzmalomelo_process:'', zaehlernummern_process:''});
            }
          }, this);
        }
      }
    }
    this.meldepunkteGrid.load(meldepunkte);
    this.meldepunkteGrid.load(data.meldepunkte);
    this.meldepunkteGrid.refreshValid();
  }, noBackend:function() {
    this.loaded = true;
  }, statics:{meldepunkteColumns:[{name:'meldepunkt', header:'Marktlokations-ID', width:150}, {name:'zaehlpunkt', header:'Messlokations-ID', width:300}, {name:'meldepunkttyp', header:'Meldepunkttyp', width:120, renderer:function(v, meta, r) {
    var type = Ext.valueFrom(r.data.meldepunkttyp, r.data.meldepunkttyp_process);
    if (type == 'melo') {
      return 'Messlokation';
    } else if (type == 'malo') {
      return 'Marktlokation';
    } else if (type == 'pbmelo') {
      return 'prozessual behandelte Messlokation';
    } else if (type == 'tranche') {
      return 'Tranche';
    } else {
      return '';
    }
  }}, {name:'referenzmalomelo', header:'Referenz MaLo/MeLo', width:250, renderer:function(v, meta, r) {
    v = Ext.valueFrom(v, '');
    return Ext.String.htmlEncode(v.length == 33 ? '' : v);
  }}, {name:'prognosegrundlage', header:'Prognosegrundlage', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.prognosegrundlage, r.data.prognosegrundlage_process);
  }}, {name:'prognosegrundlage_sd', header:'Prognosegrundlage SD', hidden:true, width:150}, {name:'prognosegrundlage_process', header:'Prognosegrundlage Process', hidden:true, width:150}, {name:'spannungsebeneentnahme', header:'Spannungsebene\x3cbr\x3eMarktlokation', width:150, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.spannungsebeneentnahme, r.data.spannungsebeneentnahme_process);
  }}, {name:'spannungsebeneentnahme_sd', header:'Spannungsebene Marktlokation SD', hidden:true, width:150}, {name:'spannungsebeneentnahme_process', header:'Spannungsebene Marktlokation Process', hidden:true, width:150}, {name:'spannungsebenemessung', header:'Spannungsebene\x3cbr\x3eMesslokation', width:150, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.spannungsebenemessung, r.data.spannungsebenemessung_process);
  }}, {name:'spannungsebenemessung_sd', header:'Spannungsebene Messlokation SD', hidden:true, width:150}, {name:'spannungsebenemessung_process', header:'Spannungsebene Messlokation Process', hidden:true, width:150}, {name:'druckebeneentnahme', header:'Druckebene\x3cbr\x3eMarktlokation', width:150, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.druckebeneentnahme, r.data.druckebeneentnahme_process);
  }}, {name:'druckebeneentnahme_sd', header:'Druckebene Marktlokation SD', hidden:true, width:150}, {name:'druckebeneentnahme_process', header:'Druckebene Marktlokation Process', hidden:true, width:150}, {name:'gasqualitaet', header:'Gasqualität', width:80, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.gasqualitaet, r.data.gasqualitaet_process);
  }}, {name:'gasqualitaet_sd', header:'Gasqualität SD', hidden:true, width:150}, {name:'gasqualitaet_process', header:'Gasqualität Process', hidden:true, width:150}, {name:'aufteilungsmenge', header:'Aufteilungsmenge', width:80, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.aufteilungsmenge, r.data.aufteilungsmenge_process);
  }}, {name:'aufteilungsmenge_sd', header:'Aufteilungsmenge SD', hidden:true, width:150}, {name:'aufteilungsmenge_process', header:'Aufteilungsmenge Process', hidden:true, width:150}, {name:'turnusablesung', header:'Turnusablesung\x3cbr\x3eMSB', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.turnusablesung, r.data.turnusablesung_process);
  }}, {name:'turnusablesung_sd', header:'Turnusablesung MSB SD', hidden:true, width:150}, {name:'turnusablesung_process', header:'Turnusablesung MSB Process', hidden:true, width:150}, {name:'turnusintervall', header:'Turnusintervall\x3cbr\x3eMSB', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.turnusintervall, r.data.turnusintervall_process);
  }}, {name:'turnusintervall_sd', header:'Turnusintervall MSB SD', hidden:true, width:150}, {name:'turnusintervall_process', header:'Turnusintervall MSB Process', hidden:true, width:150}, {name:'turnusablesungnb', header:'Turnusablesung\x3cbr\x3eNB', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.turnusablesungnb, r.data.turnusablesungnb_process);
  }}, {name:'turnusablesungnb_sd', header:'Turnusablesung NB SD', hidden:true, width:150}, {name:'turnusablesungnb_process', header:'Turnusablesung NB Process', hidden:true, width:150}, {name:'turnusintervallnb', header:'Turnusintervall\x3cbr\x3eNB', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.turnusintervallnb, r.data.turnusintervallnb_process);
  }}, {name:'turnusintervallnb_sd', header:'Turnusintervall NB SD', hidden:true, width:150}, {name:'turnusintervallnb_process', header:'Turnusintervall NB Process', hidden:true, width:150}, {name:'abrechnungsintervalllf', header:'Abrechnungsintervall\x3cbr\x3eLF', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.abrechnungsintervalllf, r.data.abrechnungsintervalllf_process);
  }}, {name:'abrechnungsintervalllf_sd', header:'Abrechnungsintervall LF SD', hidden:true, width:150}, {name:'abrechnungsintervalllf_process', header:'Abrechnungsintervall LF Process', hidden:true, width:150}, {name:'zaehlernummern', header:'Zählernummern', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.zaehlernummern, r.data.zaehlernummern_process);
  }}, {name:'zaehlernummern_sd', header:'Zählernummern SD', hidden:true, width:150}, {name:'zaehlernummern_process', header:'Zählernummern Process', hidden:true, width:150}, {name:'hinweis', header:'Hinweis', width:120, renderer:function(v, meta, r) {
    return Ext.valueFrom(r.data.hinweis, r.data.hinweis_process);
  }}, {name:'hinweis_sd', header:'Hinweis SD', hidden:true, width:150}, {name:'hinweis_process', header:'Hinweis Process', hidden:true, width:150}]}});
})();
Ext.define('mpm.packages.wim.StubMessagePanels', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.MKOView = Ext.extend(Object, {constructor:function(config) {
    this.callParent(arguments);
    this.wimContext = config.wimContext;
    this.process = config.process;
    this.loaded = false;
    var fields = ['PROCESSID', 'PROCESS', 'TYPE', 'DIRECTION', 'MP_PARTNERNAME', 'MESSAGEID', {name:'TIMESTAMP', convert:WIM.dbDateDisplayValue}];
    var columns = [{header:'Prozess', dataIndex:'PROCESS', width:180, renderer:WIM.renderer()}, {header:'Typ', dataIndex:'TYPE', width:140, renderer:WIM.renderer()}, {header:'Partnername', dataIndex:'MP_PARTNERNAME', width:200, renderer:WIM.renderer()}, {header:'Richtung', dataIndex:'DIRECTION', width:120, renderer:WIM.renderer()}, {header:'Nachricht (ID)', dataIndex:'MESSAGEID', width:240, renderer:WIM.renderer()}, {header:'Zeitstempel', dataIndex:'TIMESTAMP', renderer:WIM.renderer(), width:160}, 
    {header:'EDI', dataIndex:'', align:'center', scope:this, renderer:function(v, meta, r) {
      var url = this.wimContext.downloadURL();
      url += url.indexOf('?') >= 0 ? '\x26' : '?';
      return '\x3cspan onclick\x3d"window.open(\'' + Ext.String.htmlEncode(url) + 'edi\x3d' + Ext.String.htmlEncode(r.data.PROCESSID) + "', '_blank')\"\x3e" + WIM.iconClsHtml('fa-save') + '\x3c/span\x3e';
    }}];
    this.root = new Ext.grid.GridPanel({title:'Marktkommunikation', viewConfig:{emptyText:'Keine Einträge.', deferEmptyText:false}, border:false, enableHdMenu:false, store:new Ext.data.Store({model:Ext.define(null, {extend:'Ext.data.Model', idProperty:'PROCESSID', fields:fields})}), columns:columns});
    this.root.on('activate', function() {
      if (!this.loaded) {
        this.request = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.process, makeCommand:function() {
          return '\x3cMKO\x3e\x3cfachProcessID\x3e' + Ext.String.htmlEncode(this.process.processID) + '\x3c/fachProcessID\x3e\x3c/MKO\x3e';
        }, scope:this, requestSuccess:function(result) {
          this.loaded = true;
          this.loadMKO(result.data);
        }, requestFailure:function() {
          this.loaded = true;
          WIM.handleFailure.apply(this, arguments);
        }});
        this.request.start(this.root);
      }
    }, this);
  }, loadMKO:function(d) {
    this.root.store.add(d.LOG);
  }});
  WIM.BackendLogView = Ext.extend(Object, {constructor:function(config) {
    this.field = Ext.create('Ext.form.field.Display', {padding:5, htmlEncode:false});
    this.root = new Ext.Panel({flex:1, scrollable:true, title:'Backend-Log', items:[this.field]});
  }, load:function(root) {
    this.field.setValue(root.data.LOG.BACKEND_LOG);
    this.root.setTitle(Ext.isEmpty(root.data.LOG.BACKEND_LOG) ? 'Backend-Log (leer)' : 'Backend-Log');
  }});
  WIM.MessagePanel = Ext.extend(WIM.AbstractMessagePanel, {hiddenFields:[], isGERAustausch:false, constructor:function(config) {
    this.callParent(arguments);
    this.processView = new WIM.ProcessView({process:this.process, wimContext:config.wimContext, hiddenFields:this.hiddenFields, isGERAustausch:this.isGERAustausch});
    this.head = this.processView.root;
    this.tabs = new Ext.TabPanel({flex:1, plain:true});
    this.items = [this.head, this.tabs];
    var mkoView = new WIM.MKOView({wimContext:config.wimContext, process:this.process});
    this.historyView = new WIM.HistoryView({process:this.process, wimContext:this.wimContext, mkoView:mkoView});
    this.tabs.add(this.historyView.root);
    this.tabs.add(mkoView.root);
  }, loadMeta:function(root) {
    this.callParent(arguments);
    WIM.QQQ.defineDynamicValues(root);
  }, load:function(root) {
    this.callParent(arguments);
    if (this.backendLogView) {
      this.backendLogView.load(root);
    }
  }, addBackendLogView:function() {
    this.backendLogView = new WIM.BackendLogView({});
    this.tabs.add(this.backendLogView.root);
  }});
  WIM.MSBBeginnMessagePanel = Ext.extend(WIM.MessagePanel, {configuration:WIM.MSBBeginn, loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true});
    this.tabs.insert(1, this.adressenView.root);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({readOnly:true});
    this.tabs.insert(2, this.meldepunkteView.root);
    this.marktpartnerGridView = new WIM.MarktpartnerGridView(root.data.LOG.RICHTUNG == 'Ausgang' ? this.configuration.marktpartnerConfigAusgangGrid : this.configuration.marktpartnerConfigGrid);
    this.tabs.insert(3, this.marktpartnerGridView.root);
    this.ablesekarteView = new WIM.AblesekarteView({readOnly:true});
    this.tabs.insert(4, this.ablesekarteView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true, noZaehlwerk:true, noZaehlernummern:true});
    this.tabs.insert(5, this.geraetedatenView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.meldepunkteView.load(root);
    this.marktpartnerGridView.loadprocessDetail(root);
    this.adressenView.load(root);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
    this.ablesekarteView.load(root.data.LOG.ABLESEKARTENXML);
  }});
  WIM.MDLBeginnMessagePanel = Ext.extend(WIM.MSBBeginnMessagePanel, {configuration:WIM.MDLBeginn});
  WIM.MSBEndeMessagePanel = Ext.extend(WIM.MessagePanel, {configuration:WIM.MSBEnde, loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.marktpartnerZPView = new WIM.MarktpartnerZPView(root.data.LOG.RICHTUNG == 'Ausgang' ? this.configuration.marktpartnerConfigAusgang : this.configuration.marktpartnerConfig);
    this.tabs.insert(1, this.marktpartnerZPView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.marktpartnerZPView.load(root);
  }});
  WIM.MDLEndeMessagePanel = Ext.extend(WIM.MSBEndeMessagePanel, {configuration:WIM.MDLEnde});
  WIM.MSBKuendigungMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true});
    this.tabs.insert(1, this.stammdatenView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true});
    this.tabs.insert(2, this.adressenView.root);
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.stammdatenView.load(root);
    this.adressenView.load(root);
  }});
  WIM.MDLKuendigungMessagePanel = Ext.extend(WIM.MSBKuendigungMessagePanel, {});
  WIM.MSBWechselMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
  }});
  WIM.MDLWechselMessagePanel = Ext.extend(WIM.MSBWechselMessagePanel, {});
  WIM.GERAustauschMessagePanel = Ext.extend(WIM.MessagePanel, {isGERAustausch:true, hiddenFields:['VORGANG', 'RICHTUNG'], loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.GeraeteAustauschView({});
    this.tabs.insert(0, this.wechselView.root);
    this.endeWerte = new WIM.MesswerteMiniView({title:'Endablesewerte', prefix:'ENDE_'});
    this.tabs.insert(1, this.endeWerte.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true});
    this.tabs.insert(2, this.geraetedatenView.root);
    this.anfangWerte = new WIM.MesswerteMiniView({title:'Anfangsablesewerte', prefix:'ANFANG_'});
    this.tabs.insert(3, this.anfangWerte.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.endeWerte.load(root);
    this.anfangWerte.load(root);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
  }});
  WIM.GERWechselMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.stammdatenView = new WIM.StammdatenZPView({readOnly:true});
    this.tabs.insert(1, this.stammdatenView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true, noKennzahlen:true});
    this.tabs.insert(2, this.geraetedatenView.root);
  }, load:function(root) {
    this.callParent(arguments);
    this.stammdatenView.load(root);
    this.wechselView.load(root);
    var positionenxml = root.data.LOG.POSITIONENXML;
    if (positionenxml === null) {
      positionenxml = root.data.LOG.GERAETEXML;
    }
    this.geraetedatenView.load(positionenxml);
  }});
  WIM.GEDMesswerteMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.tabs.insert(0, this.messwerteProcessView.root);
    this.messwerteView = new WIM.MesswerteDatenView({});
    this.tabs.insert(1, this.messwerteView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.messwerteView.load(root);
    this.messwerteProcessView.load(root);
  }});
  WIM.GEDLastgangMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.messwerteProcessView = new WIM.MesswerteProcessView({});
    this.tabs.insert(0, this.messwerteProcessView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.messwerteProcessView.load(root);
  }});
  WIM.GERUebernahmeMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.uebernahmeView = new WIM.GeraeteuebernahmeView({});
    this.tabs.insert(0, this.uebernahmeView.root);
    this.angebotView = new WIM.AngebotView({});
    this.tabs.insert(1, this.angebotView.root);
    this.bestellungView = new WIM.BestellungView({});
    this.tabs.insert(2, this.bestellungView.root);
    if (root.config.backendEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.uebernahmeView.load(root);
    this.angebotView.load(root);
    this.bestellungView.load(root);
  }});
  WIM.STMMeldungMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.meldungsView = new WIM.StoerungsMeldungsView({});
    this.tabs.insert(0, this.meldungsView.root);
    this.berichtView = new WIM.StoerungsBerichtView({});
    this.tabs.insert(1, this.berichtView.root);
  }, load:function(root) {
    this.callParent(arguments);
    this.meldungsView.load(root);
    this.berichtView.load(root);
  }});
  WIM.STMInformationMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.informationsView = new WIM.StoerungsInformationsView({});
    this.tabs.insert(0, this.informationsView.root);
    this.berichtView = new WIM.StoerungsBerichtView({});
    this.tabs.insert(1, this.berichtView.root);
  }, load:function(root) {
    this.callParent(arguments);
    this.informationsView.load(root);
    this.berichtView.load(root);
  }});
  WIM.GEDMSAenderungMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.aenderungView = new WIM.MSAenderungView({});
    this.tabs.insert(0, this.aenderungView.root);
  }, load:function(root) {
    this.callParent(arguments);
    this.aenderungView.load(root);
  }});
  WIM.GEDSDAnfrageMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({readOnly:true});
    this.tabs.insert(1, this.meldepunkteView.root);
    this.marktpartnerGridView = new WIM.MarktpartnerGridView({rooted:true, displayOnly:true, MSB:{name:'msb', fieldLabel:'MSB', grundzustaendigkeit:true}, LF:{name:'lf', fieldLabel:'LF'}});
    this.tabs.insert(2, this.marktpartnerGridView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true});
    this.tabs.insert(3, this.adressenView.root);
    this.geraetedatenView = new WIM.GeraetedatenView({readOnly:true});
    this.tabs.insert(4, this.geraetedatenView.root);
    if (root.config.stammdatenSchreibenEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.meldepunkteView.load(root);
    this.marktpartnerGridView.loadprocessDetail(root);
    this.adressenView.load(root);
    this.geraetedatenView.load(root.data.LOG.POSITIONENXML);
  }});
  WIM.GEDSDAenderungMessagePanel = Ext.extend(WIM.MessagePanel, {loadMeta:function(root) {
    this.callParent(arguments);
    this.wechselView = new WIM.WechselView({});
    this.tabs.insert(0, this.wechselView.root);
    this.meldepunkteView = new mpm.packages.wim.MeldepunkteView({readOnly:true});
    this.tabs.insert(1, this.meldepunkteView.root);
    this.adressenView = new WIM.AdressenView({readOnly:true});
    this.tabs.insert(2, this.adressenView.root);
    if (root.config.stammdatenSchreibenEnabled == 'true') {
      this.addBackendLogView();
    }
  }, load:function(root) {
    this.callParent(arguments);
    this.wechselView.load(root);
    this.meldepunkteView.load(root);
    this.adressenView.load(root);
  }});
})();
Ext.define('mpm.packages.wim.StubMesswerteView', {requires:['mpm.packages.wim.StubCore', 'mpm.packages.wim.MesswerteForm']});
(function() {
  WIM.MesswerteDatenView = Ext.extend(WIM.ProcessTabView, {title:'Messwertinformationen', load:function(root) {
    this.messwerteView = new WIM.MesswerteView({readOnly:true, fieldLabel:'Messwerte', name:'messwertexml'});
    this.messwertekorrigiertView = new WIM.MesswerteView({readOnly:true, fieldLabel:'Messwerte (korrigiert)', name:'messwertekorrigiertxml'});
    this.root.add(this.messwerteView.fieldsToArray());
    this.root.add(this.messwertekorrigiertView.fieldsToArray());
    this.messwerteView.load(root.data.LOG.MESSWERTEXML);
    this.messwertekorrigiertView.load(root.data.LOG.MESSWERTEKORRIGIERTXML);
  }});
  WIM.MesswerteProcessView = Ext.extend(WIM.ProcessTabView, {load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    this.addProcessPartner(root, width);
    if (root.data.LOG.KATEGORIE !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Kategorie', width:width, value:WIM.QQQ.GED.kategorieQText(root.data.LOG.KATEGORIE)}));
    }
    if (root.data.LOG.DATUM !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:root.data.LOG.DATUM_ENDE !== undefined ? 'Termin (Beginn)' : 'Termin', width:width, value:WIM.dateOrSpanDisplayValue(root.data.LOG.DATUM)}));
    }
    if (root.data.LOG.DATUM_ENDE !== undefined) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Termin (Ende)', width:width, value:WIM.dateOrSpanDisplayValue(root.data.LOG.DATUM_ENDE)}));
    }
    if (root.data.LOG.LEISTUNG !== undefined && !Ext.isEmpty(root.data.LOG.LEISTUNG)) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Leistung', width:width, value:WIM.QQQ.GED.leistungmesswerteQText(root.data.LOG.LEISTUNG)}));
    }
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablesegrund', width:width, value:WIM.QQQ.GED.ablesegrundQText(root.data.LOG.ABLESEGRUND)}));
    if (!this.hiddenFields.contains('ABLESETYP')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablesetyp', width:width, value:WIM.QQQ.GED.ablesetypQText(root.data.LOG.ABLESETYP)}));
    }
    if (!this.hiddenFields.contains('ERMITTLUNG') && !Ext.isEmpty(root.data.LOG.ERMITTLUNG)) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ermittlung (obsolet)', width:width, value:WIM.QQQ.GED.ermittlungQText(root.data.LOG.ERMITTLUNG)}));
    }
    if (!this.hiddenFields.contains('FEHLERSTATUSANLASS')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Fehlerstatusanlass', width:width, value:WIM.QQQ.MW.messwertstatusQText(root.data.LOG.FEHLERSTATUSANLASS)}));
    }
    if (!this.hiddenFields.contains('ZAEHLERNUMMERN')) {
      this.root.add((new WIM.EditableList({columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:'Zählernummern', readOnly:true, processValue:root.data.LOG.ZAEHLERNUMMERN})).root);
    }
    if (!Ext.isEmpty(root.data.LOG.ANTWORTSTATUS)) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablehnungsgrund', width:width, value:WIM.QQQ.GED.antwortmesswerteQText(root.data.LOG.ANTWORTSTATUS)}));
    }
    if (root.data.LOG.OBISXML && root.data.LOG.OBISXML.length > 0) {
      var data = [];
      Ext.each(root.data.LOG.OBISXML, function(v) {
        data.push(Ext.isString(v) ? v : v.obis);
      }, this);
      this.root.add((new WIM.EditableList({maxLength:35, fieldLabel:'Anfrage OBIS-Kennzahlen (obsolet)', width:width, readOnly:true, processValue:data})).root);
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.MesswerteMiniView = Ext.extend(WIM.ProcessTabView, {constructor:function(config) {
    this.prefix = config.prefix || '';
    this.title = config.title || 'Messwerte';
    this.callParent(arguments);
  }, load:function(root) {
    var width = 400 + this.labelWidth;
    var merkmale = root.data.LOG[this.prefix + 'MERKMALEXML'];
    if (!merkmale) {
      merkmale = {ablesegrund:'', ablesetyp:'', ermittlung:''};
    }
    this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablesegrund', width:width, value:WIM.QQQ.GED.ablesegrundQText(merkmale.ablesegrund)}));
    if (!this.hiddenFields.contains('ABLESETYP')) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ablesetyp', width:width, value:WIM.QQQ.GED.ablesetypQText(merkmale.ablesetyp)}));
    }
    if (!this.hiddenFields.contains('ERMITTLUNG') && !Ext.isEmpty(merkmale.ermittlung)) {
      this.root.add(WIM.newScrollableDisplayField({fieldLabel:'Ermittlung (obsolet)', width:width, value:WIM.QQQ.GED.ermittlungQText(merkmale.ermittlung)}));
    }
    if (!this.hiddenFields.contains('ZAEHLERNUMMERN')) {
      this.root.add((new WIM.EditableList({columnName:'Zählernummer', name:'zaehlernummern', fieldLabel:'Zählernummern', readOnly:true, processValue:root.data.LOG[this.prefix + 'ZAEHLERNUMMERNXML']})).root);
    }
    this.messwerteView = new WIM.MesswerteView({readOnly:true, fieldLabel:'Messwerte'});
    this.root.add(this.messwerteView.fieldsToArray());
    this.messwerteView.load(root.data.LOG[this.prefix + 'MESSWERTEXML']);
  }});
  WIM.MesswerteView = Ext.extend(WIM.BasicGrid, {constructor:function(config) {
    config = Ext.apply({}, config, {width:950, height:150, withFieldContainer:true});
    config.columns = WIM.MesswerteView.columns;
    var withUhrzeit = config.leistung !== 'Z12';
    config.editContext = {create:function(grid) {
      (new mpm.packages.wim.MesswerteForm({withUhrzeit:withUhrzeit})).create(grid.store, new grid.store.model({}));
    }, edit:function(grid, record) {
      (new mpm.packages.wim.MesswerteForm({withUhrzeit:withUhrzeit})).edit(grid.store, record);
    }, remove:function(grid, record) {
      grid.store.remove(record);
    }};
    if (config.abrufen) {
      this.abrufen = config.abrufen;
      this.abrufenButton = new Ext.Button({text:'Messwerte abrufen', scope:this, handler:this.messwerteAbrufen, disabled:true});
      config.tbarItems = [this.abrufenButton];
    }
    WIM.MesswerteView.superclass.constructor.call(this, config);
  }, isRecordValid:function(r) {
    return !Ext.isEmpty(r.data.obis) && !Ext.isEmpty(r.data.wert) && !Ext.isEmpty(r.data.wertstatus) && (!Ext.isEmpty(r.data.datum) || !Ext.isEmpty(r.data.datumvon) && !Ext.isEmpty(r.data.datumbis));
  }, messwerteAbrufen:function() {
    var processRequest = new WIM.ProcessRequest({url:this.wimContext.serverURL(), process:this.abrufen.process, scope:this, makeCommand:function() {
      var d = this.abrufen;
      if (d.abrufen) {
        d = d.abrufen();
      }
      return '\x3cmesswerte\x3e\x3ctyp\x3e' + Ext.String.htmlEncode(d.typ) + '\x3c/typ\x3e\x3cdatum\x3e' + Ext.String.htmlEncode(d.datum) + '\x3c/datum\x3e\x3czaehlpunkt\x3e' + Ext.String.htmlEncode(d.zaehlpunkt) + '\x3c/zaehlpunkt\x3e\x3cmandant\x3e\x3cown_mpid\x3e' + d.process.own_mpid + '\x3c/own_mpid\x3e\x3cown_mpidcode\x3e' + d.process.own_mpidcode + '\x3c/own_mpidcode\x3e\x3c/mandant\x3e\x3c/messwerte\x3e';
    }.bind(this), requestSuccess:function(data) {
      data = data.data;
      if (!data) {
        Ext.Msg.alert('Fehler', 'Fehler beim Messwertabruf.');
      } else {
        if (data.length === 0) {
          Ext.Msg.alert('Fehler', 'Es konnten keine Messwerte abgerufen werden.');
        } else {
          this.load(data);
        }
      }
    }, requestFailure:function() {
      Ext.Msg.alert('Fehler', 'Fehler beim Messwertabruf.');
    }});
    processRequest.start(this.root);
  }, setAbrufenEnabled:function(_) {
    if (this.abrufenButton) {
      this.abrufenButton.setDisabled(!_);
    }
  }, submitValue:function() {
    var s = new WIM.XMLOutput();
    this.grid.store.each(function(a) {
      s.begin('position', 'tuple');
      Ext.each(this.columns, function(c) {
        if (c.name == 'statuswerte') {
          s.begin(c.name, 'array');
          var vv = a.data[c.name];
          vv = Ext.isEmpty(vv) ? [] : vv;
          Ext.each(vv, function(v) {
            s.atom('v', v);
          }, this);
          s.end(c.name);
        } else if (!Ext.String.startsWith(c.name, 'datum')) {
          var v = a.data[c.name];
          v = Ext.isEmpty(v) ? '' : v;
          s.atom(c.name, v);
        }
      }, this);
      if (!Ext.isEmpty(a.data.datumvon) && !Ext.isEmpty(a.data.datumbis)) {
        s.atom('datumvon', a.data.datumvon);
        s.atom('datumbis', a.data.datumbis);
      } else {
        s.atom('datum', Ext.isEmpty(a.data.datum) ? '' : a.data.datum);
      }
      s.end('position');
    }, this);
    return s.result();
  }, loadInitialVorbelegung:function(positionen, zpChanged) {
    if (!Ext.isEmpty(positionen)) {
      var data = [];
      Ext.each(positionen.kennzahlen, function(k) {
        data.push({obis:k.obis, datum:'', wert:'', wertstatus:'220', statuswerte:[]});
      }, this);
      this.loadInitial(data, zpChanged);
    }
  }});
  WIM.MesswerteView.columns = [{name:'obis', header:'OBIS', width:150}, {name:'datum', width:195, header:'Zeitpunkt/-raum', renderer:function(v, meta, r) {
    if (!Ext.isEmpty(r.data.datumvon)) {
      return WIM.dateDisplayValue(r.data.datumvon) + ' - ' + WIM.dateDisplayValue(r.data.datumbis);
    } else {
      return WIM.dateDisplayValue(v);
    }
  }}, {name:'datumvon', internal:true}, {name:'datumbis', internal:true}, {name:'wertstatus', header:'Wertstatus'}, {name:'wert', header:'Wert', renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    }
    var w = String(v).replace('.', ',');
    return Ext.String.htmlEncode(w);
  }}, {name:'statuswerte', header:'Statuswerte', width:140, renderer:WIM.arrayRenderer(', ')}];
  WIM.ReklamationMesswerteView = Ext.extend(WIM.BasicGrid, {constructor:function(config) {
    config = Ext.apply({}, config, {width:900});
    config.columns = WIM.ReklamationMesswerteView.columns;
    WIM.ReklamationMesswerteView.superclass.constructor.call(this, config);
  }, loadInitialVorbelegung:function(positionen, zpChanged) {
    if (!Ext.isEmpty(positionen)) {
      var data = [];
      Ext.each(positionen.kennzahlen, function(k) {
        data.push({obis:k.obis, datum:'', wertstatus:'', hinweis:''});
      }, this);
      this.loadInitial(data, zpChanged);
    }
  }});
  WIM.ReklamationMesswerteView.columns = [{name:'obis', header:'OBIS', width:140}, {name:'datum', width:195, header:'Zeitpunkt/-raum', renderer:function(v, meta, r) {
    if (!Ext.isEmpty(r.data.datumvon)) {
      return WIM.dateDisplayValue(r.data.datumvon) + ' - ' + WIM.dateDisplayValue(r.data.datumbis);
    } else {
      return WIM.dateDisplayValue(v);
    }
  }}, {name:'datumvon', internal:true}, {name:'datumbis', internal:true}, {name:'wertstatus', header:'Reklamation', width:300, renderer:function(v) {
    if (Ext.isEmpty(v)) {
      return '';
    } else if (v == 'Z04') {
      return 'Z04 - Werte zu hoch im angegebenen Zeitintervall';
    } else if (v == 'Z05') {
      return 'Z05 - Werte zu niedrig im angegebenen Zeitintervall';
    } else if (v == 'Z06') {
      return 'Z06 - Werte fehlen im angegebenen Zeitintervall';
    }
  }}, {name:'hinweis', header:'Hinweis', width:700}];
})();
Ext.define('mpm.packages.wim.StubQualifier', {requires:['mpm.packages.wim.StubCore']});
(function() {
  Ext.ns('WIM.QQQ');
  WIM.qualifierQText = function(_, options) {
    var text = _.text;
    if (_.obsolete === true) {
      text += ' (obsolet)';
    }
    if (Ext.isEmpty(_.key)) {
      return text;
    }
    if (options) {
      if (options.textFirst) {
        return text + ' (' + _.key + ')';
      }
      if (options.noKey) {
        return text;
      }
    }
    return _.key + ' - ' + text;
  };
  WIM.qualifierProperty = function(qq, v, p) {
    var result;
    Ext.each(qq, function(q) {
      if (q.key === v) {
        result = q[p];
        return false;
      }
      return true;
    }, this);
    return result;
  };
  WIM.qualifiersToStoreArray = function(qq, options) {
    var result = [];
    if (!options) {
      options = {};
    }
    Ext.each(qq, function(q) {
      if (Ext.isEmpty(q.key) && options.skipEmpty) {
        return;
      }
      if (options.obsoleteFiltered && q.obsolete) {
        return;
      }
      result.push([q.key, WIM.qualifierQText(q, options), q.text, q.description]);
    }, this);
    return result;
  };
  Ext.define('WIM.QualifierModel', {extend:'Ext.data.Model', idProperty:'key', fields:['key', 'text', {name:'keytext', convert:function(v, r) {
    return WIM.qualifierQText(r.data);
  }}, {name:'keytextnokey', convert:function(v, r) {
    return WIM.qualifierQText(r.data, {noKey:true});
  }}]});
  WIM.QQQ.defineDynamicValues = function(root) {
    mergeValues('UTILMD', 'antwortstatus', root.antwortstatus);
    mergeValues('UTILMD', 'transaktionsgrund', root.transaktionsgruende);
    if (root.messwertstatus) {
      mergeValues('MW', 'messwertstatus', root.messwertstatus);
    }
  };
  var mergeValues = function(a, b, ww) {
    if (!WIM.QQQ[a] || !WIM.QQQ[a][b]) {
      defineValues(a, b, ww);
      return;
    }
    var vv = WIM.QQQ[a][b];
    var updated = {};
    var handled = {};
    Ext.each(ww, function(w) {
      updated[w.key] = w;
    }, this);
    Ext.each(vv, function(v, index) {
      handled[v.key] = true;
      if (updated[v.key]) {
        vv[index] = updated[v.key];
      }
    }, this);
    Ext.each(ww, function(w) {
      if (!handled[w.key]) {
        vv.push(w);
      }
    }, this);
  };
  var defineValues = function(a, b, vv) {
    if (!WIM.QQQ[a]) {
      WIM.QQQ[a] = {};
    }
    WIM.QQQ[a][b] = vv;
    WIM.QQQ[a][b + 'Text'] = function(_) {
      var result;
      Ext.each(vv, function(v) {
        if (v.key === _) {
          result = v.text;
          return false;
        }
        return true;
      }, this);
      return result == undefined ? _ : result;
    };
    WIM.QQQ[a][b + 'QText'] = function(_) {
      var result;
      Ext.each(vv, function(v) {
        if (v.key === _) {
          result = WIM.qualifierQText(v);
          return false;
        }
        return true;
      }, this);
      return result == undefined ? _ : result;
    };
    WIM.QQQ[a][b + 'QTexts'] = function(_) {
      if (Ext.isEmpty(_)) {
        return _;
      }
      var qq = String(_).split(/ /);
      var result = '';
      Ext.each(qq, function(q, index) {
        if (index !== 0) {
          result += '; ';
        }
        result += WIM.QQQ[a][b + 'QText'](q);
      }, this);
      return result;
    };
  };
  defineValues('SD', 'mpidcode', [{key:'14', text:'GS1 Germany'}, {key:'500', text:'BDEW'}, {key:'502', text:'DVGW'}]);
  defineValues('SD', 'marktpartnertypBeginn', [{key:'LF', text:'Lieferant'}, {key:'MSBN', text:'Neuer Messstellenbetreiber'}, {key:'MSBA', text:'Bisheriger Messstellenbetreiber'}, {key:'UENB', text:'Übertragungsnetzbetreiber'}]);
  defineValues('SD', 'marktpartnertyp', [{key:'LF', text:'Lieferant'}, {key:'NB', text:'Netzbetreiber'}, {key:'MSB', text:'Messstellenbetreiber'}]);
  defineValues('SD', 'grundzustaendigkeit', [{key:'JA', text:'grundzuständig'}, {key:'NEIN', text:'nicht grundzuständig'}]);
  defineValues('SD', 'kundentyp', [{key:'Z01', text:'Person'}, {key:'Z02', text:'Firma'}]);
  defineValues('SD', 'land', [{key:'DE', text:'DE'}, {key:'AT', text:'AT'}, {key:'CH', text:'CH'}]);
  defineValues('SD', 'lieferrichtung', [{key:'Z06', text:'Erzeugung'}, {key:'Z07', text:'Verbrauch'}]);
  defineValues('SD', 'betriebszustand', [{key:'ZC1', text:'Messlokation gesperrt und darf nicht entsperrt werden'}, {key:'ZC2', text:'Messlokation gesperrt und darf entsperrt werden'}, {key:'ZC3', text:'Messlokation im Regelbetrieb'}]);
  defineValues('SD', 'meldepunkttyp', [{key:'malo', text:'ID der Marktlokation'}, {key:'melo', text:'ID der Messlokation'}, {key:'pbmelo', text:'ID der prozessual behandelten Messlokation'}, {key:'tranche', text:'ID der Tranche'}]);
  defineValues('SD', 'obistype', [{key:'malo', text:'Marktlokation'}, {key:'melo', text:'Messlokation'}, {key:'geraet', text:'Zähleinrichtung/Mengenumwerter'}, {key:'tranche', text:'Tranche'}]);
  defineValues('SD', 'obisidlistmelo', [{key:'1-1:1.8.0', text:'1-1:1.8.0'}, {key:'1-1:1.8.1', text:'1-1:1.8.1'}, {key:'1-1:1.8.2', text:'1-1:1.8.2'}, {key:'1-1:2.8.0', text:'1-1:2.8.0'}, {key:'1-65:1.8.0', text:'1-65:1.8.0'}, {key:'1-65:1.8.1', text:'1-65:1.8.1'}, {key:'1-65:1.8.2', text:'1-65:1.8.2'}, {key:'1-65:2.8.0', text:'1-65:2.8.0'}, {key:'1-1:1.29.0', text:'1-1:1.29.0'}, {key:'1-1:3.29.0', text:'1-1:3.29.0'}, {key:'1-1:2.29.0', text:'1-1:2.29.0'}, {key:'7-20:3.0.0', text:'7-20:3.0.0'}]);
  defineValues('SD', 'obisidlistmalo', [{key:'1-1:1.9.0', text:'1-1:1.9.0'}, {key:'1-1:1.9.1', text:'1-1:1.9.1'}, {key:'1-1:1.9.2', text:'1-1:1.9.2'}, {key:'1-1:2.9.0', text:'1-1:2.9.0'}, {key:'1-1:1.6.0', text:'1-1:1.6.0'}, {key:'1-1:2.6.0', text:'1-1:2.6.0'}, {key:'1-1:1.29.0', text:'1-1:1.29.0'}, {key:'1-1:2.29.0', text:'1-1:2.29.0'}, {key:'1-1:3.29.0', text:'1-1:3.29.0'}]);
  defineValues('SD', 'normiertesProfil', [{key:'Z02', text:'Standardlastprofil'}, {key:'Z04', text:'Standardeinspeiseprofil'}]);
  defineValues('SD', 'normiertesProfilVerfahren', [{key:'E01', text:'synthetisches Verfahren'}, {key:'Z10', text:'analytisches Verfahren'}]);
  defineValues('SD', 'profilschar', [{key:'Z03', text:'tagesparameterabhängiges Lastprofil'}, {key:'Z05', text:'tagesparameterabhängiges Einspeiseprofil'}]);
  defineValues('SD', 'profilscharVerfahren', [{key:'E01', text:'synthetisches Verfahren'}, {key:'Z10', text:'analytisches Verfahren'}]);
  defineValues('SD', 'klimazone', [{key:'Z99', text:'Messstelle des Tagesparameters'}, {key:'ZA0', text:'Klimazone des Tagesparameters'}]);
  defineValues('SD', 'dienstanbieter', [{key:'ZT1', text:'DWD'}, {key:'ZT3', text:'MeteoGroup'}, {key:'ZT4', text:'UBIMET GmbH (ehemals EWC Weather Consult GmbH)'}, {key:'ZT5', text:'Meteodat GmbH'}, {key:'ZT6', text:'EWD Energiewirtschaftlicher Wetterdienst GmbH'}, {key:'ZT7', text:'Meteomatics GmbH'}]);
  defineValues('SD', 'referenzprofilCode', [{key:'SOT', text:'ESO bzw. SOT'}]);
  defineValues('MW', 'wertstatus', [{key:'220', text:'Abgelesener Wert'}, {key:'67', text:'Ersatzwert'}, {key:'201', text:'Vorschlagswert'}, {key:'20', text:'Nicht verwendbarer Wert'}]);
  defineValues('MW', 'messwertstatus', [{key:'ZA2', text:'zu stornierender Wert', description:'Dieser Wert darf nicht verwendet werden und ist zu löschen. Zur Stornierung von Werten, deren Erfassungsdatum vor dem 01.10.2011 liegt.'}, {key:'Z83', text:'Kundenselbstablesung', description:'Messwert durch den Kunden am Zähler abgelesen'}, {key:'Z84', text:'Leerstand', description:''}, {key:'Z85', text:'Realer Zählerüberlauf geprüft', description:''}, {key:'Z86', text:'Plausibel wg. Kontrollablesung', 
  description:''}, {key:'Z87', text:'Plausibel wg. Kundenhinweis', description:''}, {key:'ZC3', text:'Austausch des Ersatzwertes', description:'Austausch eines zuvor übertragenen Ersatzwertes durch einen Ablesewert'}, {key:'Z88', text:'Vergleichsmessung (geeicht)', description:'Strom: Meswert aus geeichter Vergleichsmessung. Gas: Messwert eines weiteren geeichten Messgerätes in der gleichen Messstrecke.'}, {key:'Z89', text:'Vergleichsmessung (nicht geeicht)', description:'Strom: Messwert aus verfügbaren nicht geeichten Geräten (z.B. Analogmessung). Gas: Messwert eines nicht geeichten Messgerätes in der gleichen Messstrecke (auch Störmengenzählwerk).'}, 
  {key:'Z90', text:'Messwertnachbildung aus geeichten Werten', description:'Strom: Messwert gebildet unter Verwendung anderer verfügbarer geeichter Messwerte. Gas: Messwert eines geeichten Messgerätes an einem geeigneten, dem Messort möglichst nahen Ort, ggf. unter Berücksichtigung der Zeitverschiebung.'}, {key:'Z91', text:'Messwertnachbildung aus nicht geeichten Werten', description:'Strom: Messwert gebildet unter Verwendung anderer verfügbarer nicht geeichter Messwerte. Gas: Messwert eines nicht geeichten Messgerätes an einem geeigneten, dem Messort möglichst nahen Ort, ggf. unter Berücksichtigung der Zeitverschiebung.'}, 
  {key:'Z92', text:'Interpolation', description:'Strom / Gas: Berechnung eines neuen Wertes durch Interpolation'}, {key:'ZJ2', text:'Statistische Methode', description:''}, {key:'Z93', text:'Haltewert', description:'Nur Gas: Weiterverwendung des zuletzt gültig gemessenen Wertes'}, {key:'Z94', text:'Bilanzierung Netzabschnitt', description:'Gas: Berechnung eines neuen Wertes durch Bilanzierung über einen geschlossenen Netzabschnitt'}, {key:'Z95', text:'Historische Messwerte', description:'Strom / Gas: historische Messwerte aus einem geeigneten Zeitabschnitt'}, 
  {key:'Z96', text:'Ersatzprofilbestimmung', description:'Nur Strom: Bestimmung eines Ersatz-Lastverlauf unter Heranziehung von verfügbaren Eckwerten (Energie, Leistung) und ggf. geeigneten Lastprofilen'}, {key:'Z97', text:'Korrektur von Synchronisationsfehler', description:'Strom / Gas: Nachbildung der Messperiodenwerte z.B. durch  Lastschiebeverfahren'}, {key:'Z74', text:'kein Zugang', description:'Zugang zur Messeinrichtung nicht möglich (Vor-Ort-Ablesung)'}, {key:'Z75', text:'Kommunikationsstörung', 
  description:'Fernauslesung konnte nicht fristgerecht durchgeführt werden '}, {key:'Z76', text:'Netzausfall', description:'Netzausfall \x3d Ausfall eines Netzgebietes/fehlende Primärspannung'}, {key:'Z77', text:'Spannungsausfall', description:'Messspannungsausfall oder fehlende Hilfsspannung'}, {key:'Z78', text:'Gerätewechsel', description:'Messwerte unvollständig wegen Gerätewechsels'}, {key:'Z79', text:'Kalibrierung', description:'Während Wartungs-, Revisions- oder Instandsetzungsarbeiten an geeichten Messgeräten stehen keine Messwerte zur Verfügung'}, 
  {key:'Z80', text:'Gerät arbeitet außerhalb der Betriebsbedingungen', description:'Das Gerät arbeitet außerhalb der zugelassenen Betriebsbedingungen und liefert keine Messwerte'}, {key:'Z81', text:'Messeinrichtung gestört/defekt', description:'Messwerte sind nicht verwendbar / verfügbar, da bei der Messeinrichtung ein Defekt festgestellt wurde'}, {key:'Z82', text:'Unsicherheit Messung', description:'Möglicher Gerätedefekt/Messeinrichtung in Überprüfung (z.B. Befundprüfung)'}, {key:'ZD7', text:'In der Messstelle ist kein Gerät vorhanden', 
  description:'In der Messstelle ist kein Gerät vorhanden'}, {key:'ZD8', text:'Messstelle/Lokation real nicht auffindbar', description:'Messstelle/Lokation real nicht auffindbar'}, {key:'Z98', text:'Berücksichtigung Störmengenzählwerk', description:'Normvolumen aus Störmengenzähler des MU'}, {key:'Z99', text:'Mengenumwertung unvollständig', description:'Zur Ermittlung des Normvolumens relevante Faktoren sind nicht verfügbar'}, {key:'ZA0', text:'Uhrzeit gestellt / Synchronisation', description:'Uhrzeit war außerhalb der zulässigen Grenzwerte'}, 
  {key:'ZA1', text:'Messwert unplausibel', description:'Energie, Leistung, Volumen, etc. unplausibel'}, {key:'ZC2', text:'Tarifschaltgerät defekt', description:'Tarifschaltgerät defekt'}, {key:'ZC4', text:'Impulswertigkeit nicht ausreichend', description:'Der Wert basiert auf einer unzureichenden Anzahl von Impulsen gemäß der Eichordnung.'}, {key:'ZA3', text:'Falscher Wandlerfaktor', description:''}, {key:'ZA4', text:'Fehlerhafte Ablesung', description:'Incl. Messstellenverwechslung, Zahlendreher, ...'}, 
  {key:'ZA5', text:'Änderung der Berechnung', description:'z.B. Änderung der Berechnungsvorschrift, nachträglich berücksichtigte Zweit- bzw. Untermessung'}, {key:'ZA6', text:'Messstellenumbau', description:''}, {key:'ZA7', text:'Datenbearbeitungsfehler', description:''}, {key:'ZA8', text:'Brennwertkorrektur', description:''}, {key:'ZA9', text:'Z-Zahl-Korrektur', description:''}, {key:'ZB0', text:'Störung / Defekt Messeinrichtung', description:'Technischer Fehler in der Messeinrichtung'}, {key:'ZB9', 
  text:'Änderung Tarifschaltzeiten', description:''}]);
  defineValues('GER', 'antwortbestellung', [{key:'Z13', text:'Zustimmung ohne Korrekturen'}, {key:'5', text:'Ablehnung (Preis/Rechenregel falsch)'}, {key:'Z32', text:'Ablehnung (Bestellumfang überschreitet Angebotsumfang)'}]);
  defineValues('GED', 'antwortstammdaten', [{key:'', text:'Annahme (Stammdaten versenden)'}, {key:'Z15', text:'Ablehnung (Keine Berechtigung)'}]);
  defineValues('GED', 'antwortmesswerte', [{key:'', text:'Annahme (Messwerte versenden)'}, {key:'A01', text:'Ablehnung (Falscher Prozess - „Reklamation von Werten beim MSB“ ist zu verwenden.)', obsolete:false}, {key:'A02', text:'Ablehnung (keine Berechtigung)', obsolete:false}, {key:'A03', text:'Ablehnung (Es wurden Werte angefragt, die es auf dem Meldepunkt nicht geben kann.)', obsolete:false}, {key:'A04', text:'Ablehnung (Die angefragten Werte sind nicht vorhanden.)', obsolete:false}, {key:'Z15', 
  text:'Ablehnung (keine Berechtigung)', obsolete:false}, {key:'Z16', text:'Ablehnung (nicht zuständig)', obsolete:true}, {key:'Z19', text:'Ablehnung (unzulässiger Sollablesezeitpunkt)'}, {key:'Z21', text:'Ablehnung (Daten nicht vorhanden)'}, {key:'Z23', text:'Scheiterung (kein Zugang)'}, {key:'Z24', text:'Scheiterung (Kommunikationsstörung)'}, {key:'Z25', text:'Scheiterung (Netzausfall)'}, {key:'Z26', text:'Scheiterung (Spannungsausfall)'}, {key:'Z27', text:'Scheiterung (Gerätewechsel)'}, {key:'Z28', 
  text:'Scheiterung (Kalibrierung)'}, {key:'Z29', text:'Scheiterung (Gerät arbeitet außerhalb der Betriebsbedingungen)'}, {key:'Z30', text:'Scheiterung (Messeinrichtung gestört/defekt)'}, {key:'Z31', text:'Scheiterung (Unsicherheit Messung)'}, {key:'ZD7', text:'Scheiterung (In der Messstelle ist kein Gerät vorhanden)'}, {key:'ZD8', text:'Scheiterung (Messstelle/Lokation real nicht auffindbar)'}]);
  defineValues('GED', 'antwortreklamation', [{key:'', text:'Bestätigung (Nachricht quittieren)'}, {key:'Z54', text:'Ablehnung (keine Messwertänderung durchgeführt)'}, {key:'Z55', text:'Ablehnung (Prüfung zur Klärung des Sachverhalts veranlasst)'}]);
  defineValues('UTILMD', 'transaktionsgrund', [{key:'E01', text:'Ein-/Auszug (Umzug)'}, {key:'E02', text:'Einzug/Neuanlage'}, {key:'E03', text:'Wechsel'}, {key:'E04', text:'Vorübergehender Anschluss'}, {key:'E05', text:'Stornierung'}, {key:'E06', text:'Ersatzbelieferung'}, {key:'Z03', text:'Ersatz- oder Grundversorgung'}, {key:'Z26', text:'Lieferantenkonkurrenz'}, {key:'Z33', text:'Auszug/Stillegung'}, {key:'Z36', text:'EoG aus Ein-/Auszug (Umzug)'}, {key:'Z37', text:'EoG aus Einzug/Neuanlage'}, 
  {key:'Z38', text:'EoG aus Lieferantenwechsel'}, {key:'Z39', text:'EoG aus vorübergehendem Ausschluss'}, {key:'Z40', text:'Geschäftsdatenanfrage'}, {key:'Z41', text:'Ende der ESV ohne Folgelieferung'}, {key:'Z42', text:'Ein/Auszug (\x3e 6 Wochen)'}, {key:'Z46', text:'Änderungsmitteilung nichtbilanzierungsrel. Daten'}, {key:'Z47', text:'Änderungsmitteilung von bilanzierungsrel. Daten'}, {key:'Z69', text:'Wiederinbetriebnahme'}, {key:'ZB1', text:'Ende der Messdienstleistung'}, {key:'ZB2', text:'Vollständiger Gerätewechsel (früher)'}, 
  {key:'ZB3', text:'Teilweiser Gerätewechsel (früher)'}, {key:'Z58', text:'Vollständiger Gerätewechsel'}, {key:'Z59', text:'Teilweiser Gerätewechsel'}, {key:'ZG9', text:'Aufhebung einer zukünftigen Zuordnung wegen Auszug des Kunden'}, {key:'ZH0', text:'Aufhebung einer zukünftigen Zuordnung wegen Anmeldung eines anderen Lieferanten zu einem früheren Termin'}, {key:'ZH1', text:'Aufhebung einer zukünftigen Zuordnung wegen Stilllegung'}, {key:'ZH2', text:'Aufhebung einer zukünftigen Zuordnung wegen aufgehobenem Vertragsverhältnis'}, 
  {key:'ZJ4', text:'Übernahme aufgrund nicht erfolgtem iMS- Einbau'}, {key:'ZR9', text:'Kündigung aufgrund Vertrag mit Anschlussnehmer'}]);
  defineValues('UTILMD', 'antwortstatus', [{key:'E11', text:'Ablehnung (Messproblem)'}, {key:'E14', text:'Ablehnung (sonstiges)'}, {key:'E15', text:'Zustimmung ohne Korrekturen'}, {key:'E17', text:'Ablehnung (Fristüberschreitung)'}, {key:'Z01', text:'Zustimmung mit Terminänderung'}, {key:'Z07', text:'Ablehnung (keine Berechtigung)'}, {key:'Z08', text:'Ablehnung (Transaktion hat schon stattgefunden)'}, {key:'Z09', text:'Ablehnung (Transaktionsgrund unplausibel)'}, {key:'Z10', text:'Ablehnung (Abmeldung fehlt)'}, 
  {key:'Z11', text:'Ablehnung (Termin fehlt)'}, {key:'Z12', text:'Ablehnung (Vertragsbindung)'}, {key:'Z13', text:'Ablehnung (Meldung nicht identifizierbar)'}, {key:'Z14', text:'Ablehnung (Doppelmeldung)'}, {key:'Z29', text:'Ablehnung (kein Vertragsverhältnis)'}, {key:'Z34', text:'Ablehnung (Mehrfachkündigung)'}, {key:'Z43', text:'Zustimmung mit Korrektur von bilanzierungsrel. Daten'}, {key:'Z44', text:'Zustimmung mit Korrektur von nicht bilanzierungsrel. Daten'}, {key:'ZB6', text:'Erforderliche Versicherung fehlt'}, 
  {key:'ZB7', text:'Angemeldeter Leistungsumfang ist nicht stimmig'}, {key:'ZB4', text:'Eigenausbau wird erfolgen'}, {key:'ZB5', text:'Kein Eigenausbau des MSBA'}]);
  defineValues('APERAK', 'antwortstatus', [{key:'Z14', text:'Markt- bzw. Messlokation bzw. Tranche im IT-System nicht gefunden'}, {key:'Z15', text:'Markt- bzw. Messlokation bzw. Tranche im IT-System nicht eindeutig'}, {key:'Z16', text:'Markt- bzw. Messlokation bzw. Tranche nicht mehr im Netzgebiet'}]);
  defineValues('MSB', 'antwortweiter', [{key:'Z13', text:'Zustimmung ohne Korrekturen'}, {key:'Z14', text:'Zustimmung mit Terminänderung'}, {key:'Z21', text:'Daten nicht vorhanden; auch fälschlich: Ablehnung (max. Zeitraum überschritten)'}, {key:'Z22', text:'Ablehnung (max. Zeitraum überschritten)'}]);
  defineValues('MSB', 'beauftragungbeendigung', [{key:'Z04', text:'Vertrag zwischen AN und MSB'}, {key:'Z05', text:'Vertrag zwischen AN und MDL'}, {key:'Z06', text:'Vertragsbeendigung liegt vor'}]);
  defineValues('GED', 'antwortumbau', [{key:'Z13', text:'Zustimmung ohne Korrekturen'}, {key:'Z14', text:'Zustimmung mit Terminänderung'}, {key:'Z15', text:'Ablehnung (keine Berechtigung)'}, {key:'Z16', text:'Ablehnung (nicht zuständig)', obsolete:true}, {key:'Z17', text:'Ablehnung (Umbau technisch nicht möglich)'}, {key:'Z18', text:'Ablehnung (Umbau vertraglich nicht möglich)'}]);
  defineValues('GED', 'leistungmesswerte', [{key:'Z10', text:'Abrechnungsbrennwert und Zustandszahl'}, {key:'Z11', text:'Lastgangdaten'}, {key:'Z12', text:'Zählerstande'}, {key:'Z13', text:'Werteermittlung'}, {key:'Z35', text:'Energiemenge Einzelwert'}]);
  defineValues('GED', 'anfragemesswerte', [{key:'Z11', text:'Lastgänge'}, {key:'Z12', text:'Zählerstande'}]);
  defineValues('GED', 'ablesegrund', [{key:'COM', text:'Gerätewechsel'}, {key:'IOM', text:'Geräteeinbau'}, {key:'ROM', text:'Geräteausbau'}, {key:'COS', text:'Vertragswechsel'}, {key:'COB', text:'Bilanzierungsgebietswechsel'}, {key:'CMP', text:'Geräteparameteränderung'}, {key:'PMR', text:'Turnusablesung'}, {key:'COT', text:'Zwischenablesung'}, {key:'ABZ', text:'Zählerstand für Abgrenzung'}, {key:'ABM', text:'Abgrenzungsmengen'}]);
  defineValues('GED', 'ablesetyp', [{key:'SMV', text:'Anfangszählerstand'}, {key:'EMV', text:'Endzählerstand'}, {key:'MRV', text:'Zählerstand'}]);
  defineValues('GED', 'statusformel', [{key:'Z33', text:'Berechnungsformel angefügt'}, {key:'Z34', text:'Berechnungsformel muss beim Absender angefragt werden'}]);
  defineValues('GED', 'ermittlung', [{key:'VNB', text:'Netzbetreiber'}, {key:'LIE', text:'Lieferant'}, {key:'MSB', text:'Messstellenbetreiber'}, {key:'MDL', text:'Messdienstleister'}]);
  defineValues('GED', 'kategorie', [{key:'E01', text:'Anmeldung'}, {key:'E02', text:'Abmeldung'}, {key:'E03', text:'Änderungsmeldung'}, {key:'E35', text:'Kündigung'}, {key:'Z10', text:'Geräteübernahme'}, {key:'Z11', text:'Weiterverpflichtung MSBA'}, {key:'Z12', text:'Messstellenänderung'}, {key:'Z13', text:'Gerätewechselabsicht'}, {key:'Z14', text:'Stammdaten am Zählpunkt'}, {key:'7', text:'Prozessdatenbericht'}]);
  defineValues('SD', 'leistung', [{key:'Z01', text:'MSB'}, {key:'Z02', text:'MDL'}, {key:'Z03', text:'MSB+MDL'}]);
  defineValues('SD', 'ausleseverfahren', [{key:'Z04', text:'analog'}, {key:'Z05', text:'elektronisch'}]);
  defineValues('SD', 'prognosegrundlage', [{key:'ZC0', text:'Prognose auf Basis von Werten'}, {key:'ZA6', text:'Prognose auf Basis von Profilen'}]);
  defineValues('SD', 'detailsprognosegrundlage', [{key:'E02', text:'SLP/SEP'}, {key:'E14', text:'TLP/TEP'}, {key:'Z36', text:'TEP mit Referenzmessung'}]);
  defineValues('SD', 'detailsprognosegrundlage2', [{key:'E02', text:'SLP/SEP'}, {key:'E14', text:'TLP/TEP'}]);
  defineValues('SD', 'arbeitleistung', [{key:'265', text:'Veranschlagte Jahresmenge Gesamt/ Jahresverbrauchsprognose für spezifische Arbeit für tagesparameterabhängige Marktlokation'}, {key:'Z08', text:'Angepasste elektrische Arbeit nach Anhang D der VDN-Richtlinie Lastprofile für unterbrechbare Verbrauchseinrichtungen'}]);
  defineValues('SD', 'arbeitleistungeinheit', [{key:'Z16', text:'kWh/K (Kilowatt-Stunde/Kelvin)'}, {key:'KWH', text:'Kilowattstunde'}]);
  defineValues('SD', 'ausleseverfahrenauftrag', [{key:'', text:'unverändert'}, {key:'Z04', text:'analog'}, {key:'Z05', text:'elektronisch'}]);
  defineValues('MSB', 'wechselstatus', [{key:'209', text:'geplant'}, {key:'Z13', text:'gescheitert'}, {key:'Z14', text:'erfolgreich'}]);
  defineValues('MSB', 'wechselstatusanlass', [{key:'E17', text:'Fristüberschreitung'}, {key:'Z66', text:'MSB-Scheitermeldung liegt vor'}, {key:'ZI1', text:'Wechsel auf iMS'}, {key:'ZI2', text:'Beibehaltung der bisherigen Messtechnik'}]);
  defineValues('GED', 'umbaustatus', [{key:'Z13', text:'gescheitert'}, {key:'Z14', text:'erfolgreich'}]);
  defineValues('GED', 'umbaustatusanlass', [{key:'Z74', text:'kein Zugang'}, {key:'Z75', text:'Kommunikationsstörung'}]);
  defineValues('SD', 'druckebeneentnahme', [{key:'Y01', text:'Hochdruck'}, {key:'Y02', text:'Mitteldruck'}, {key:'Y03', text:'Niederdruck'}]);
  defineValues('SD', 'gasqualitaet', [{key:'Y04', text:'H-Gas'}, {key:'Y05', text:'L-Gas'}]);
  defineValues('SD', 'spannungsebeneentnahme', [{key:'E03', text:'Höchstspannung'}, {key:'E04', text:'Hochspannung'}, {key:'E05', text:'Mittelspannung'}, {key:'E06', text:'Niederspannung'}]);
  defineValues('SD', 'messtechnischeeinordnung', [{key:'Z52', text:'IMS'}, {key:'Z53', text:'kME/mME'}]);
  defineValues('SD', 'arterzeugendemarktlokation', [{key:'Z33', text:'EEG-Marktlokation ohne DV-Pflicht'}, {key:'Z34', text:'KWKG-Marktlokation ohne DV-Pflicht'}, {key:'Z35', text:'sonstige Marktlokation'}, {key:'Z37', text:'EEG-Marktlokation mit DV-Pflicht'}, {key:'Z46', text:'KWKG-Marktlokation mit DV-Pflicht'}]);
  defineValues('SD', 'spannungsebenemessung', [{key:'E03', text:'Höchstspannung'}, {key:'E04', text:'Hochspannung'}, {key:'E05', text:'Mittelspannung'}, {key:'E06', text:'Niederspannung'}]);
  defineValues('SD', 'messwertuebermittlungsfallmesslokation', [{key:'Z67', text:'Konfiguration für MÜ-A und MÜ-B'}, {key:'Z41', text:'Konfiguration für MÜ-C'}, {key:'Z42', text:'Konfiguration für MÜ-D'}, {key:'Z43', text:'Konfiguration für MÜ-E'}, {key:'Z60', text:'Konfiguration für MÜ-F'}]);
  defineValues('SD', 'obisverwendungszweck', [{key:'Z84', text:'Netznutzungsabrechnung'}, {key:'Z85', text:'Bilanzkreisabrechnung'}, {key:'Z86', text:'Mehrmindermengenabrechnung'}, {key:'Z92', text:'Übermittlung an das HKNR'}, {key:'Z47', text:'Endkundenabrechnung'}, {key:'ZB5', text:'Zur Ermittlung der Ausgeglichenheit von BK'}]);
  defineValues('SD', 'turnusintervall', [{key:'1', text:'monatlich'}, {key:'3', text:'alle 3 Monate'}, {key:'6', text:'alle 6 Monate'}, {key:'12', text:'jährlich'}]);
  defineValues('SD', 'verbrauchsart', [{key:'Z64', text:'Kraft/Licht'}, {key:'Z65', text:'Wärme'}, {key:'Z66', text:'Kraft/Licht/Wärme'}, {key:'Z87', text:'E-Mobilitätsladesäule'}, {key:'ZA8', text:'Straßenbeleuchtung'}, {key:'ZB3', text:'Steuerung Wärmeausgabe'}]);
  defineValues('SD', 'unterbrechbarkeit', [{key:'Z62', text:'unterbrechbare Verbrauchseinrichtung'}, {key:'Z63', text:'nicht-unterbrechbare Verbrauchseinrichtung'}]);
  defineValues('SD', 'waermenutzung', [{key:'Z56', text:'Speicherheizung'}, {key:'Z57', text:'Wärmepumpe'}, {key:'Z61', text:'Direktheizung'}]);
  defineValues('GER', 'leistungbestellung', [{key:'Z07', text:'Kauf'}, {key:'Z08', text:'Nutzungsüberlassung'}]);
  defineValues('GER', 'leistungbestellposition', [{key:'', text:'kann angeboten werden'}, {key:'Z09', text:'kann nicht angeboten werden'}]);
  defineValues('STM', 'antwortstatus', [{key:'E15', text:'Zustimmung ohne Korrekturen'}, {key:'Z29', text:'Ablehnung (kein Vertragsverhältnis - Messstelle nicht von MSB betrieben)'}, {key:'ZB8', text:'Ablehnung (keine Störung feststellbar)'}]);
  defineValues('STM', 'status', [{key:'Z09', text:'störungsfrei'}, {key:'Z10', text:'gestört'}, {key:'Z11', text:'Störung festgestellt'}, {key:'Z12', text:'Störung vermutet'}]);
  defineValues('STM', 'statusanlass', [{key:'Z75', text:'Kommunikationsstörung'}, {key:'Z78', text:'Gerätewechsel'}, {key:'Z81', text:'Messeinrichtung gestört/defekt'}, {key:'ZB8', text:'keine Störung feststellbar'}, {key:'ZC1', text:'Störungsbehebung nicht möglich'}]);
  defineValues('GER', 'zaehlertyp', [{key:'AHZ', text:'analoger Haushaltszähler (Drehstrom)'}, {key:'WSZ', text:'analoger Wechselstromzähler'}, {key:'LAZ', text:'Lastgangzähler'}, {key:'EHZ', text:'elektronischer Haushaltzähler'}, {key:'MAZ', text:'Maximumzähler'}, {key:'DKZ', text:'Drehkolbengaszähler', gas:true}, {key:'BGZ', text:'Balgengaszähler', gas:true}, {key:'TRZ', text:'Turbinenradgaszähler', gas:true}, {key:'UGZ', text:'Ultraschallgaszähler', gas:true}, {key:'WGZ', text:'Wirbelgaszähler', 
  gas:true}, {key:'MRG', text:'Messdatenregistriergerät', gas:true}, {key:'IVA', text:'Individuelle Abstimmung (Sonderausstattung)'}, {key:'MME', text:'moderne Messeinrichtung nach MsbG'}]);
  defineValues('GER', 'schwachlastfaehig', [{key:'Z59', text:'Nicht-Schwachlast'}, {key:'Z60', text:'Schwachlastfähig'}, {key:'', text:'kein Wert'}]);
  defineValues('GER', 'zaehlergroesse', [{key:'G10', text:'Gaszähler G10'}, {key:'G100', text:'Gaszähler G100'}, {key:'G1000', text:'Gaszähler G1000'}, {key:'G10000', text:'Gaszähler G10000'}, {key:'G12500', text:'Gaszähler G12500'}, {key:'G16', text:'Gaszähler G16'}, {key:'G160', text:'Gaszähler G160'}, {key:'G1600', text:'Gaszähler G1600'}, {key:'G16000', text:'Gaszähler G16000'}, {key:'G2.5', text:'Gaszähler G2.5'}, {key:'G25', text:'Gaszähler G25'}, {key:'G250', text:'Gaszähler G250'}, {key:'G2500', 
  text:'Gaszähler G2500'}, {key:'G350', text:'Gaszähler G350'}, {key:'G4', text:'Gaszähler G4'}, {key:'G40', text:'Gaszähler G40'}, {key:'G400', text:'Gaszähler G400'}, {key:'G4000', text:'Gaszähler G4000'}, {key:'G6', text:'Gaszähler G6'}, {key:'G65', text:'Gaszähler G65'}, {key:'G650', text:'Gaszähler G650'}, {key:'G6500', text:'Gaszähler G6500'}, {key:'Z01', text:'EDL40'}, {key:'Z02', text:'EDL21'}, {key:'Z03', text:'sonstiger EHZ'}, {key:'Z04', text:'Standard'}, {key:'Z05', text:'MeDa-Zähler'}]);
  defineValues('GER', 'zaehlertarif', [{key:'ETZ', text:'Eintarif'}, {key:'ZTZ', text:'Zweitarif'}, {key:'NTZ', text:'Mehrtarif'}]);
  defineValues('GER', 'zaehlerrichtung', [{key:'ERZ', text:'Einrichtungszähler'}, {key:'ZRZ', text:'Zweirichtungszähler'}]);
  defineValues('GER', 'wandlertyp', [{key:'MSW', text:'Messwandler', obsolete:true}, {key:'MIW', text:'Messwandlersatz Strom', konstante:true}, {key:'MPW', text:'Kombimesswandlersatz (Strom und Spannung)', konstante:true}, {key:'MBW', text:'Blockstromwandler', konstante:true}, {key:'MUW', text:'Messwandlersatz Spannung', konstante:false}]);
  defineValues('GER', 'mengenumwertertyp', [{key:'DMU', text:'Dichtemengenumwerter'}, {key:'TMU', text:'Temperaturmengenumwerter'}, {key:'ZMU', text:'Zustandsmengenumwerter'}]);
  defineValues('GER', 'techtyp', [{key:'RSU', text:'Rundsteuerempfänger'}, {key:'TSU', text:'Tarifschaltuhr'}]);
  defineValues('GER', 'kommtyp', [{key:'GSM', text:'GSM/GPRS/UMTS/LTE-Kom.-Einr.'}, {key:'ETH', text:'Ethernet-Kom.-Einricht. LAN/WLAN'}, {key:'PLC', text:'PLC-Kom.-Einrichtung'}, {key:'PST', text:'Festnetz-Kom.-Einricht. TAE'}, {key:'DSL', text:'DSL-Kom.Einr.'}, {key:'LTE', text:'LTE-Kom.Einr.'}]);
  defineValues('GER', 'messwerterfassung', [{key:'AMR', text:'fernauslesbar'}, {key:'MMR', text:'manuell auslesbar'}]);
  defineValues('GER', 'befestigungsart', [{key:'BKE', text:'Stecktechnik'}, {key:'DPA', text:'Dreipunktaufhängung'}, {key:'HUT', text:'Hutschiene'}, {key:'Z31', text:'Einstutzen-Zähler'}, {key:'Z32', text:'Zweistutzen-Zähler'}]);
  defineValues('GER', 'fernschaltung', [{key:'Z06', text:'vorhanden'}, {key:'Z07', text:'nicht vorhanden'}]);
})();
Ext.define('mpm.packages.wim.StubStoerungsView', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.StoerungsMeldungsView = Ext.extend(WIM.ProcessTabView, {title:'Meldung', load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    if (root.data.LOG.RICHTUNG === 'Eingang') {
      this.addPartner(root, {fieldLabel:'Mandant', prefix:'OWN'}, width);
      this.addPartner(root, {fieldLabel:'Partner (Melder)', prefix:'MP'}, width);
      this.addPartner(root, {fieldLabel:'Partner (NB)', prefix:'NB'}, width);
      this.addSmallSpace();
    } else {
      this.addProcessPartner(root, width);
    }
    this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'gemeldeter Status', value:WIM.QQQ.STM.statusQText(root.data.LOG.GEMELDETERSTATUS)}));
    this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'gemeldetes Datum', value:WIM.dateDisplayValue(root.data.LOG.GEMELDETESDATUM)}));
    this.root.add(new Ext.form.field.TextArea({width:width, readOnly:true, fieldLabel:'gemeldeter Freitext', value:root.data.LOG.GEMELDETERFREITEXT}));
    if (!this.answerHidden) {
      this.addSmallSpace();
      this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Antwortstatus', value:WIM.QQQ.STM.antwortstatusQText(root.data.LOG.ANTWORTSTATUS)}));
      this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Gerätestatus', value:WIM.QQQ.STM.statusQText(root.data.LOG.GERAETESTATUS)}));
      this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Datum (Behebung geplant)', value:WIM.dateDisplayValue(root.data.LOG.DATUMGEPLANT)}));
      this.root.add(new Ext.form.field.TextArea({width:width, readOnly:true, fieldLabel:'Freitext Antwort', value:root.data.LOG.FREITEXTANTWORT}));
      this.addSmallSpace();
      this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Vorgang (Antwort)', value:root.data.LOG.VORGANGANTWORT}));
      if (root.data.LOG.RICHTUNG == 'Eingang') {
        this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Vorgang (NB)', value:root.data.LOG.VORGANGNB}));
      }
    }
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.StoerungsInformationsView = Ext.extend(WIM.ProcessTabView, {load:function(root) {
    var width = 400 + this.labelWidth;
    this.addProcessName(root, width);
    if (root.data.LOG.RICHTUNG === 'Ausgang') {
      this.addPartner(root, {fieldLabel:'Mandant', prefix:'OWN'}, width);
      this.addPartner(root, {fieldLabel:'Partner (NB)', prefix:'MP'}, width);
      this.addSmallSpace();
    } else {
      this.addProcessPartner(root, width);
    }
    this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Datum (festgestellt)', value:WIM.dateDisplayValue(root.data.LOG.DATUM)}));
    this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Gerätestatus', value:WIM.QQQ.STM.statusQText(root.data.LOG.GERAETESTATUS)}));
    this.root.add(new Ext.form.field.TextArea({width:width, readOnly:true, fieldLabel:'Freitext', value:root.data.LOG.FREITEXT}));
    this.root.add(WIM.newScrollableDisplayField({width:width, readOnly:true, fieldLabel:'Datum (Behebung geplant)', value:WIM.dateDisplayValue(root.data.LOG.DATUMGEPLANT)}));
    this.addSmallSpace();
    this.addAnsprechpartner(root, width);
  }});
  WIM.StoerungsBerichtView = Ext.extend(WIM.ProcessTabView, {title:'Störbericht', load:function(root) {
    var width = 400 + this.labelWidth;
    this.root.add(WIM.newScrollableDisplayField({width:width, fieldLabel:'Störungsanlass', value:WIM.QQQ.STM.statusanlassQText(root.data.LOG.BERICHTSTOERUNGSANLASS)}));
    this.root.add(WIM.newScrollableDisplayField({width:width, fieldLabel:'Status', value:WIM.QQQ.STM.statusQText(root.data.LOG.BERICHTSTATUS)}));
    this.root.add(WIM.newScrollableDisplayField({width:width, fieldLabel:'Statusanlass', value:WIM.QQQ.STM.statusanlassQText(root.data.LOG.BERICHTSTATUSANLASS)}));
    this.root.add(WIM.newScrollableDisplayField({width:width, fieldLabel:'Datum', value:WIM.dateDisplayValue(root.data.LOG.BERICHTDATUM)}));
    this.root.add(new Ext.form.field.TextArea({readOnly:true, width:width, fieldLabel:'Freitext', value:root.data.LOG.BERICHTFREITEXT}));
  }});
})();
Ext.define('mpm.packages.wim.StubTaskTexts', {requires:['mpm.packages.wim.StubCore']});
(function() {
  WIM.Tasks = [{task:'MSB_KUENDIGUNG', text:'\x3cp\x3eEs wurde eine MSB-Kündigung empfangen. Bitte prüfen Sie die Daten und versenden dann eine Bestätigung oder Ablehnung (max. 3 Ablehnungsgründe).\x3c/p\x3e\x3cp\x3eFür den NB in seiner Rolle als MSBA findet naturgemäß keine Prüfung auf Mindestvertragslaufzeiten bzw. Kündigungsfristen statt.\x3c/p\x3e'}, {task:'MDL_KUENDIGUNG', text:'\x3cp\x3eEs wurde eine MDL-Kündigung empfangen. Bitte prüfen Sie die Daten und versenden dann eine Bestätigung oder Ablehnung (max. 3 Ablehnungsgründe).\x3c/p\x3e\x3cp\x3eFür den NB in seiner Rolle als MDLA findet naturgemäß keine Prüfung auf Mindestvertragslaufzeiten bzw. Kündigungsfristen statt.\x3c/p\x3e'}, 
  {task:'MSB_ANMELDUNG', text:'\x3cp\x3eEs wurde eine MSB-Anmeldung empfangen. Bitte prüfen Sie die Daten und versenden dann eine Bestätigung oder Ablehnung.\x3c/p\x3e\x3cp\x3eBei Annahme wird auch der MSBA über den bevorstehenden Wechsel informiert. Nach dem Empfang der Bestätigung führt der MSBN in Kommunikation mit MSBA die Prozesse Gerätewechsel und/oder Geräteübernahme durch und übermittelt schließlich den Wechselstatus.\x3c/p\x3e\x3cp\x3eBei Ablehnung sind max. 3 Ablehnungsgründe zu wählen.\x3c/p\x3e'}, 
  {task:'MSB_ANMELDUNG_FRIST', text:'\x3cp\x3eDie Frist für Durchführung von Gerätewechsel/-übernahme im Rahmen der Anmeldung MSB ist abgelaufen, ohne dass der Wechselstatus vom MSB übermittelt wurde. Der Wechselprozess wird abgebrochen, und der MSBA bleibt zugeordnet. MSBN und MSBA werden über das Scheitern informiert.\x3c/p\x3e'}, {task:'MSB_ANMELDUNG_GESCHEITERT', text:'\x3cp\x3eDer MSB-Wechsel ist nach Mitteilung des MSBN gescheitert. Der MSBA bleibt zugeordnet.\x3c/p\x3e' + '\x3cp\x3eBei Quittieren wird auch der MSBA informiert.\x3c/p\x3e'}, 
  {task:'MSB_ANMELDUNG_ZUORDNUNG', text:'\x3cp\x3eDer MSB-Wechsel wurde vollzogen. Bitte führen Sie die Neuzuordnung durch.\x3c/p\x3e' + '\x3cp\x3eBei Quittieren wird auch der MSBA informiert.\x3c/p\x3e'}, {task:'MSB_ANMELDUNG_CLEARING', text:'\x3cp\x3eDie Zuordnung von MSB im Backend hat Warnungen erzeugt und ist vermutlich nicht vollständig durchgeführt worden. Bitte prüfen Sie den Zustand und quittieren dann zum Fortsetzen des Prozesses (Versenden der Zuordnungsnachrichten).\x3c/p\x3e'}, {task:'MDL_ANMELDUNG', 
  text:'\x3cp\x3eEs wurde eine MDL-Anmeldung empfangen. Bitte prüfen Sie die Daten und versenden dann eine Bestätigung oder Ablehnung. Bei Annahme folgt direkt im Anschluss die Zuordnung.\x3c/p\x3e\x3cp\x3eBei Ablehnung sind max. 3 Ablehnungsgründe zu wählen.\x3c/p\x3e'}, {task:'MDL_ANMELDUNG_ZUORDNUNG', text:'\x3cp\x3eNach der durchgeführten Annahme der MDL-Anmeldung ist direkt die Neuzuordnung durchzuführen. Es werden MDLA, MSB und LF über den MDL-Wechsel informiert.\x3c/p\x3e'}, {task:'MDL_ANMELDUNG_CLEARING', 
  text:'\x3cp\x3eDie Zuordnung von MDL im Backend hat Warnungen erzeugt und ist vermutlich nicht vollständig durchgeführt worden. Bitte prüfen Sie den Zustand und quittieren dann zum Fortsetzen des Prozesses (Versenden der Zuordnungsnachrichten).\x3c/p\x3e'}, {task:'MSB_ABMELDUNG', text:'\x3cp\x3eBitte prüfen Sie die MSB-Abmeldung und wählen Sie evtl. Ablehnungsgründe:\x3c/p\x3e\x3cul\x3e' + '\x3cli\x3eWenn es sich nach Ihren Kenntnisstand um einen elektronisch ausgelesenen Zähler handelt und nur MSB abgemeldet wird, ist abzulehnen mit "Transaktionsgrund unplausibel", da hier der MSB nicht separat wechseln kann.\x3c/li\x3e' + 
  '\x3cli\x3eWenn kein Abmeldetermin übermittelt wurde, müssen Sie den nächstmöglichen Termin eintragen.\x3c/li\x3e' + '\x3cli\x3eBei Annahme können Sie den Abmeldetermin korrigieren (mind. 20 Tage nach Abmeldungseingang).\x3c/li\x3e\x3c/ul\x3e' + '\x3c/ul\x3e\x3cp\x3eBei Annahme oder Ablehnung wird der Absender benachrichtigt.\x3c/p\x3e\x3cp\x3eBei Annahme wird auch eine neue Aufgabe erstellt, um den eventuellen Übergang als grundzuständiger MSB vorzubereiten. Diese Übergang ist hinfällig, wenn sich bis zum Termin ein neuer MSB gefunden hat. Das ist dann später zu prüfen.\x3c/p\x3e'}, 
  {task:'MSB_ABMELDUNG_ENTSCHEIDUNG', text:'\x3cp\x3eNachdem die MSB-Abmeldung akzeptiert wurde, ist, sofern sich kein neuer MSB anmeldet, der Übergang in Grundzuständigkeit durchzuführen. Zur Überbrückung einer Zuordnungslücke kann der MSBA auch kurzzeitig vom NB weiterverpflichtet werden. Wählen Sie, wie der Prozess weiter verlaufen soll.\x3c/p\x3e' + '\x3cp\x3eBeim Übergang in Grundzuständigkeit ist der dann notwendige Prozess Geräteübernahme/Gerätewechsel separat durchzuführen.\x3c/p\x3e'}, {task:'MSB_WEITERVERPFLICHTUNG_ANGENOMMEN', 
  text:'\x3cp\x3eDie Weiterverpflichtung des MSBA wurde akzeptiert. Damit verschiebt sich der Termin, zu dem der Übergang in Grundzuständigkeit durchzuführen ist, sofern sich kein neuer MSB findet.\x3c/p\x3e'}, {task:'MSB_WEITERVERPFLICHTUNG_ABGELEHNT', text:'\x3cp\x3eDie Weiterverpflichtung des MSBA wurde abgelehnt. Damit bleibt der Termin bestehen, zu dem der Übergang in Grundzuständigkeit durchzuführen ist, sofern sich kein neuer MSB findet.\x3c/p\x3e'}, {task:'MSB_ABMELDUNG_ZUORDNUNG', text:'\x3cp\x3eNach der Abmeldung des MSBA ist nun der Übergang in die Grundzuständigkeit durchzuführen.\x3c/p\x3e' + 
  '\x3cp\x3eAls Zuordnungsbeginn ist der Tag festzulegen, an dem die Weiterverpflichtung beginnt bzw. der Tag, der auf den erfolgreichen Abschluss von Gerätewechsel/-übernhame folgt.\x3c/p\x3e' + '\x3cp\x3eDurch Bestätigung wird die Zuordnung durchgeführt und Informationsnachrichten an MSBA und LF versandt.\x3c/p\x3e\x3cp\x3eEine Ablehnung ist an dieser hier nur durchführen, wenn der Übergang in die Grundzuständigkeit aus irgendeinem Grund doch nicht durchführen ist  (z.B. Anmeldung neuer MSB).\x3c/p\x3e'}, 
  {task:'MSB_ABMELDUNG_CLEARING', text:'\x3cp\x3eDie Zuordnung von grundzuständigem MSB im Backend hat Warnungen erzeugt und ist vermutlich nicht vollständig durchgeführt worden. Bitte prüfen Sie den Zustand und quittieren dann zum Fortsetzen des Prozesses (Versenden der Zuordnungsnachrichten).\x3c/p\x3e'}, {task:'MDL_ABMELDUNG', text:'\x3cp\x3eBitte prüfen Sie die MDL-Abmeldung und wählen Sie evtl. Ablehnungsgründe:\x3c/p\x3e' + '\x3cp\x3eBei Annahme oder Ablehnung wird der Absender benachrichtigt.\x3c/p\x3e\x3cp\x3eBei Annahme wird auch eine neue Aufgabe erstellt, um ab dem Abmeldetermin die eigene Zuordnung als grundzuständiger MDL vorzunehmen. Diese Zuordnung ist hinfällig, wenn sich bis zum Termin ein neuer MDL gefunden hat. Das ist dann später zu prüfen.\x3c/p\x3e'}, 
  {task:'MDL_ABMELDUNG_ZUORDNUNG', text:'\x3cp\x3eWenn sich kein neuer MDL gefunden hat, geht die Messstelle am folgenden Tag in die Grundzuständigkeit über.\x3c/p\x3e' + '\x3cp\x3eFalls das der Fall ist, bestätigen Sie. Damit werden Nachrichten an MDLA, MSB und LF versandt.\x3c/p\x3e'}, {task:'MDL_ABMELDUNG_CLEARING', text:'\x3cp\x3eDie Zuordnung von grundzuständigem MDL im Backend hat Warnungen erzeugt und ist vermutlich nicht vollständig durchgeführt worden. Bitte prüfen Sie den Zustand und quittieren dann zum Fortsetzen des Prozesses (Versenden der Zuordnungsnachrichten).\x3c/p\x3e'}, 
  {task:'GER_AUSTAUSCH_MSB', text:'\x3cp\x3eMit dieser Task kann ein Gerätewechsel als grundzuständiger MSB durchgeführt werden. \x3c/p\x3e\x3cp\x3eAls Absender ist die Rolle "NB" zu wählen.\x3c/p\x3e'}, {task:'GER_AUSTAUSCH_MSBN', text:'\x3cp\x3eEs ist ein Gerätewechsel als grundzuständiger MSBN durchzuführen. Hier sind die neuen Geräte und Anfangszählerstände zu erfassen. (Die Endzählerstände werden vom MSBA ermittelt.)\x3c/p\x3e\x3cp\x3eAls Absender ist dabei die Rolle "NB" zu wählen.\x3c/p\x3e'}, 
  {task:'GER_AUSTAUSCH_MSBN_MIT_ENDE', text:'\x3cp\x3eEs ist ein Gerätewechsel als grundzuständiger MSBN durchzuführen. Hier sind die Endzählerstände, die neuen Geräte und Anfangszählerstände zu erfassen.\x3c/p\x3e\x3cp\x3eAls Absender ist dabei die Rolle "NB" zu wählen.\x3c/p\x3e'}, {task:'GER_AUSTAUSCH_MSBA', text:'\x3cp\x3eEs ist ein Gerätewechsel als grundzuständiger MSBA durchzuführen. Hier sind die Endzählerstände zu erfassen.\x3c/p\x3e\x3cp\x3eAls Absender ist dabei die Rolle "NB" zu wählen.\x3c/p\x3e'}, 
  {task:'GER_ENDABLESEWERTE', text:'\x3cp\x3eEs wurde Endablesewerte empfangen.\x3cp\x3e\x3cp\x3eDie Werte können ggfs. ins Backend übertragen werden.\x3c/p\x3e'}, {task:'GER_ANFANGSABLESEWERTE', text:'\x3cp\x3eEs wurden Anfangsablesewerte empfangen.\x3c/p\x3e\x3cp\x3eDie Werte können ggfs. ins Backend übertragen werden.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_AUS_OUT', text:'\x3cp\x3eMit dieser Task kann eine Anfrage für eine Geräteübernahme versandt und damit der Prozess "Geräteübernahme" im Rahmen einer Anmeldung MSB bzw. eines Übergangs in Grundzuständigkeit MSB ausgelöst werden.\x3c/p\x3e'}, 
  {task:'GER_UEBERNAHME_AUS_ANGEBOT_IN', text:'\x3cp\x3eFür eine versandte Geräteübernahme ist das Angebot eingegangen. Prüfen Sie das Angebot und bestellen Sie eventuell.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_AUS_ANGEBOT_ABGELEHNT_IN', text:'\x3cp\x3eFür eine versandte Geräteübernahme ist das Angebot eingegangen: Es können keine Artikel übernommen werden.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_AUS_ANGEBOT_APERAK_IN', text:'\x3cp\x3eFür eine versandte Geräteübernahme ist eine APERAK eingegangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, 
  {task:'GER_UEBERNAHME_AUS_BESTELLUNG_ANGENOMMEN_IN', text:'\x3cp\x3eDie Bestellung der Geräte bei der Geräteübernahme wurde angenommen.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_AUS_BESTELLUNG_ABGELEHNT_IN', text:'\x3cp\x3eDie Bestellung der Geräte bei der Geräteübernahme wurde abgelehnt. Bitte prüfen Sie die Daten der Bestellung, insbesondere die Preise.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_EIN_IN', text:'\x3cp\x3eEine Anfrage zur Geräteübernahme ist eingegangen. Bitte erstellen Sie ein Angebot. Es ist nicht möglich, die Anfrage abzulehnen. Falls keine Geräte angeboten werden können, ist Leistung "Kauf" zu wählen und für alle Geräte "kann nicht angeboten werden".\x3c/p\x3e'}, 
  {task:'GER_UEBERNAHME_EIN_BESTELLUNG_IN', text:'\x3cp\x3eEine Bestellung zur Geräteübernahme eingegangen. Bitte prüfen Sie auf inhaltliche Richtigkeit. Die Bestätigung oder Ablehnung wird dem MSBN übermittelt.\x3c/p\x3e'}, {task:'GER_UEBERNAHME_EIN_EINBAU', text:"\x3cp\x3eZum Abschluss des Geräteübernahmeprozesses wird der Status der Geräte ins Backend umgeschrieben ('Geräteinfosatz' statt 'Gerät').\x3c/p\x3e"}, {task:'GER_WECHSEL_EIN', text:'\x3cp\x3eEs wurde eine Gerätewechselanfrage empfangen. Bei Akzeptieren wird der Absender benachrichtigt und der Prozess fortgesetzt.\x3c/p\x3e'}, 
  {task:'GER_WECHSEL_AUS', text:'\x3cp\x3eMit dieser Task kann eine Gerätewechselanfrage im Rahmen einer Anmeldung MSB bzw. eines Übergangs in Grundzuständigkeit MSB versandt werden.\x3c/p\x3e'}, {task:'GER_WECHSEL_ANTWORT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine versandte Gerätewechselanfrage empfangen.\x3c/p\x3e'}, {task:'GER_WECHSEL_APERAK_IN', text:'\x3cp\x3eFür eine versandte Gerätewechselanfrage wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, 
  {task:'GER_WECHSEL_STORNIERUNG_AUS', text:'\x3cp\x3eMit dieser Task kann eine selbst ausgelöste Gerätewechselanfrage (im Rahmen einer Anmeldung MSB bzw. beim Übergang in die Grundzuständigkeit MSB) storniert werden.\x3c/p\x3e' + '\x3cp\x3eWählen Sie die Gerätewechselanfrage, die storniert werden soll. Es können nur Anfragen storniert werden, auf die noch nicht geantwortet wurde.\x3c/p\x3e'}, {task:'GER_WECHSEL_STORNIERUNG_ANGENOMMEN', text:'\x3cp\x3eDie Stornierung der Gerätewechselanfrage wurde angenommen. Der Prozess ist damit storniert.\x3c/p\x3e'}, 
  {task:'GER_WECHSEL_STORNIERUNG_ABGELEHNT', text:'\x3cp\x3eDie Stornierung der Gerätewechselanfrage wurde abgelehnt.\x3c/p\x3e'}, {task:'STM_MELDUNG_IN', text:'\x3cp\x3eEs ist eine Störungsmeldung eingegangen. Bitte prüfen Sie, ob der NB für die Messtelle als MSB verantwortlich und dann, ob die Messstelle tatsächlich gestört ist. Bei Ablehnung wird der Absender informiert, bei Zustimmung auch optional NB. Anschließend ist die Störung zu beheben und der Störbericht an die gleichen Marktpartner zu senden.\x3c/p\x3e'}, 
  {task:'STM_MELDUNG_PRUEFUNG_IN', text:'\x3cp\x3eVersenden Sie den Störbericht nach Prüfung und Behebung der Störung. Es werden die gleichen Marktpartner informiert wie bei der vorangangenen Prüfung der Meldung: Melder und optional NB.\x3c/p\x3e'}, {task:'STM_INFORMATION_OUT', text:'\x3cp\x3eMit dieser Task kann der Prozess "Störungsinformation" ausgelöst werden. Der Prozess ist vom MSB bei eigener Feststellung einer Störung an einer Messstelle zu verwenden.\x3c/p\x3e\x3cp\x3eEs wird ggfs. der NB über die Störung informiert. Anschließend ist die Störung zu beheben und schließlich der Störbericht an die gleichen Marktpartner zu senden.\x3c/p\x3e'}, 
  {task:'STM_INFORMATION_PRUEFUNG_OUT', text:'\x3cp\x3eVersenden Sie den Störbericht an NB (optional) nach Prüfung und Behebung der Störung. Es werden die gleichen Marktpartner informiert wie beim vorangangenen Versand der Störungsinformation: optional der NB.\x3c/p\x3e'}, {task:'STM_MELDUNG', text:'\x3cp\x3eMit dieser Task kann der Prozess "Störungsmeldung" ausgelöst werden. Der Prozess ist bei Vermutung oder Feststellung einer Störung an einer Messstelle zu verwenden. Es wird eine Störungsmeldung an den Empfänger (MSB) versandt. Der MSB prüft die Störung und bestätigt die Meldung oder lehnt sie ab.\x3c/p\x3e\x3cp\x3eAls NB ist dieser Prozess ist nicht durchzuführen, wenn der NB selbst grundzuständiger MSB ist.\x3c/p\x3e'}, 
  {task:'STM_MELDUNG_APERAK_IN', text:'\x3cp\x3eFür eine versandte Störungsmeldung ist eine APERAK eingegangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'STM_MELDUNG_ANTWORT_IN', text:'\x3cp\x3eAuf eine versandte Störungsmeldung ist die Antwort eingegangen. Die Behebung der Störung soll zum genannten Termin erfolgen. Nach Behebung der Störung übermittelt der MSB den Störbericht.\x3c/p\x3e'}, {task:'STM_MELDUNG_ANTWORT_NEGATIV_IN', text:'\x3cp\x3eAuf eine versandte Störungsmeldung ist eine negative Antwort eingegangen: Die Messstelle ist nicht gestört oder die Meldung wurde aus anderen Gründen abgelehnt.\x3c/p\x3e'}, 
  {task:'STM_INFORMATION_IN', text:'\x3cp\x3eEs ist eine Störungsinformation eingegangen. Der MSB teilt damit mit, dass an der Messstelle eine Störung vorliegt. Die Behebung soll zum genannten Termin erfolgen. Nach Behebung der Störung übermittelt der MSB den Störbericht.\x3c/p\x3e\x3cp\x3eVon Seiten des NB besteht kein direkter Handlungsbedarf.\x3c/p\x3e'}, {task:'STM_MELDUNG_PRUEFBERICHT_IN', text:'\x3cp\x3eEs ist der Störbericht zu einer versandten Störungsmeldung eingegangen. Mit dem Störbericht ist der Prozess abgeschlossen.\x3c/p\x3e'}, 
  {task:'STM_INFORMATION_PRUEFBERICHT_IN', text:'\x3cp\x3eEs ist der Störbericht zu einer empfangenen Störungsinformation eingegangen. Mit dem Störbericht ist der Prozess abgeschlossen.\x3c/p\x3e'}, {task:'GED_SDANFRAGE', text:'\x3cp\x3eMit dieser Task kann eine Stammdatenanfrage versandt werden. Der Prozess kann zum Abgleich der Stammdaten am Zählpunkt verwandt werden.\x3c/p\x3e'}, {task:'GED_SDANTWORT_ABLEHNUNG', text:'\x3cp\x3eEine versandte Stammdatenanfrage wurde abgelehnt.\x3c/p\x3e'}, {task:'GED_SDANTWORT_APERAK', 
  text:'\x3cp\x3eFür eine versandte Stammdatenanfrage wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'GED_SDANFRAGE_ANTWORT', text:'\x3cp\x3eDie Antwort auf eine versandte Stammdatenanfrage wurde empfangen.\x3c/p\x3e\x3cp\x3eJe nach Rolle des Partners können manche Felder nicht übermittelt worden sein.\x3cp\x3eEin Abgleich der Geräte mit den Stammdaten ist manuell durchzuführen. Auch hier können nicht alle Geräteeigenschaften übermittelt worden sein.\x3c/p\x3e\x3cp\x3eRelevante Unterschiede sind ggfs. manuell im Backend anzupassen.\x3c/p\x3e'}, 
  {task:'GED_SDANFRAGE_IN', text:'\x3cp\x3eEs wurde eine Stammdatenanfrage empfangen. Prüfen Sie die Anfrage und übermitteln die Stammdaten oder lehnen mit zutreffendem Ablehnungsgrund ab.\x3c/p\x3e'}, {task:'GED_SDAENDERUNG_AUS_OUT', text:"\x3cp\x3eMit dieser Task kann eine Änderungsmeldung versandt werden. Die Änderung kann an ein oder mehrere Marktpartner des betroffenen Zählpunkts versandt werden.\x3c/p\x3e\x3cp\x3eOptionale nicht-geänderte Felder können auch leer gelassen werden. Für zu löschende Feldinhalte kann auch explizit '###' übermittelt werden.\x3c/p\x3e"}, 
  {task:'GED_SDAENDERUNG_APERAK', text:'\x3cp\x3eFür eine versandte Änderungsmeldung wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'GED_SDAENDERUNG_ABLEHNUNG', text:'\x3cp\x3eEs wurde eine Antwort auf eine versandte Änderungsmeldung empfangen: Die Änderungsmeldung wurde abgelehnt.\x3c/p\x3e'}, {task:'GED_SDAENDERUNG_ANTWORT', text:'\x3cp\x3eEs wurde eine Antwort auf eine versandte Änderungsmeldung empfangen: Die Meldung wurde akzeptiert.\x3c/p\x3e'}, 
  {task:'GED_SDAENDERUNG_IN', text:"\x3cp\x3eEs wurden eine Stammdatenänderung empfangen.\x3cp\x3e\x3c/p\x3eNicht geänderte Felder sind möglicherweise nicht übermittelt worden. Ein Feldinhalt '###' bedeutet, dass ein vorher vorhandener Feldinhalt zu löschen ist.\x3cp\x3e\x3c/p\x3eVor der Annahme sind die Änderungen manuell ins Backend zu übertragen.\x3c/p\x3e\x3cp\x3eBei Ablehnung sind max. 3 Ablehnungsgründe zu wählen.\x3c/p\x3e"}, {task:'GED_SDAENDERUNG_SUPPLIER_INFO', text:'\x3cp\x3eEs wurden eine Stammdatenänderung Lieferantenwechsel empfangen.\x3cp\x3e\x3c/p\x3eDer Lieferant und/oder die Marktlokation konnten in den Stammdaten nicht ermittelt werden\x3c/p\x3e'}, 
  {task:'GED_MDANFRAGE', text:'\x3cp\x3eMit dieser Task kann eine Messdatenanfrage an den Empfänger ausgelöst werden.\x3c/p\x3e'}, {task:'GED_MDANFORDERUNG', text:'\x3cp\x3eMit dieser Task kann eine Anforderung von Messwerten an den MSB ausgelöst werden.\x3c/p\x3e'}, {task:'GED_MWANFRAGE_IN', text:'\x3cp\x3eEs wurde eine Messwertanfrage empfangen. Prüfen Sie die Anfrage und übermitteln die Messwerte.\x3c/p\x3e' + '\x3cp\x3eA01-A04 sind ausschließlich in der Sparte Strom in der Kommunikation zu MSB, NB und LF zu verwenden.\x3c/p\x3e' + 
  '\x3cp\x3eFür den ÜNB und den Gasmarkt sind die anderen Antwortstatuscodes vorgesehene.\x3c/p\x3e'}, {task:'GED_MW_ANTWORT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Messwerte eingegangen. Sie können ggfs. die Messwerte ins Backend übertragen.\x3c/p\x3e'}, {task:'GED_MW_ANTWORT_APERAK_IN', text:'\x3cp\x3eFür die versandte Messwertanfrage wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'GED_MW_ANTWORT_ABGELEHNT_IN', 
  text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Die Anfrage wurde abgelehnt.\x3c/p\x3e'}, {task:'GED_MW_ANTWORT_GESCHEITERT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Die Ablesung ist gescheitert. Sie können ggfs. Ersatzwerte bilden und ins Backend übertragen oder an den Marktpartner senden.\x3c/p\x3e'}, {task:'GED_MWANFORDERUNG_ANTWORT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Messwerte eingegangen. Sie können ggfs. die Messwerte korrigieren, ins Backend übertragen oder zurück an den Marktpartner senden.\x3c/p\x3e'}, 
  {task:'GED_MWANFORDERUNG_ANTWORT_APERAK_IN', text:'\x3cp\x3eFür die versandte Messwertanfrage wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'GED_MWANFORDERUNG_ANTWORT_ABGELEHNT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Die Anfrage wurde abgelehnt.\x3c/p\x3e'}, {task:'GED_MWANFORDERUNG_ANTWORT_GESCHEITERT_IN', text:'\x3cp\x3eEs wurde eine Antwort auf eine Messdatenanfrage empfangen: Die Ablesung ist gescheitert. Sie können ggfs. Ersatzwerte bilden und ins Backend übertragen oder an den Marktpartner senden.\x3c/p\x3e'}, 
  {task:'GED_BERECHNUNGSFORMEL_IN', text:'\x3cp\x3eEs wurde eine Berechnungsformel empfangen.\x3c/p\x3e'}, {task:'GED_MW_IN', text:'\x3cp\x3eEs wurden Messwerte (Zählerstände) empfangen - Turnusablesung oder andere Ablesung. Die Messwerte können korrigiert werden und werden ggfs. in das Backend übertragen.\x3c/p\x3e'}, {task:'GED_MW_STORNO_IN', text:'\x3cp\x3eEs wurden eine Stornierung für Zählerstände empfangen.\x3c/p\x3e'}, {task:'GED_MW_TURNUS_GESCHEITERT_IN', text:'\x3cp\x3eEs wurden eine Mitteilung über eine gescheiterte Turnusablesung empfangen. Bitte bilden Sie Ersatzwerte. Die Werte werden ggfs. in das Backend übertragen und zurück an den MDL gesendet.\x3c/p\x3e'}, 
  {task:'GED_MSAENDERUNG', text:'\x3cp\x3eMit dieser Task kann eine Beauftragung zur Messstellenänderung an den Empfänger (MSB) ausgelöst werden.\x3c/p\x3e' + '\x3cp\x3eEs sind immer alle OBIS-Kennzahlen anzugegeben, für die in Zukunft Messungen erfolgen sollen, auch die bereits verwandten. Ein Wechsel auf elektronische Ablesung ist nur möglich, wenn MDL und Anschlussnutzer ihr Rechtsverhältnis miteinander beendet haben.\x3c/p\x3e'}, {task:'GED_MSAENDERUNG_ANNAHME', text:'\x3cp\x3eFür den versandten Auftrag zur Messstellenänderung wurde eine Bestätigung empfangen. Der MSB führt zum bestätigten Zeitpunkt die Änderung der Messstelle durch und übermittelt dann den Umbaustatus.\x3c/p\x3e'}, 
  {task:'GED_MSAENDERUNG_ABLEHNUNG', text:'\x3cp\x3eFür den versandten Auftrag zur Messstellenänderung wurde eine Ablehnung empfangen.\x3c/p\x3e'}, {task:'GED_MSAENDERUNG_APERAK', text:'\x3cp\x3eFür den versandten Auftrag zur Messstellenänderung wurde eine APERAK empfangen (Zählpunkt unbekannt oder anderer Verarbeitungsfehler).\x3c/p\x3e'}, {task:'GED_MSAENDERUNG_GESCHEITERT', text:'\x3cp\x3eFür den versandten Auftrag zur Messtellenänderung wurde der Umbaustatus vom MSB mitgeteilt: Die Messstellenänderung ist gescheitert.\x3c/p\x3e'}, 
  {task:'GED_MSAENDERUNG_VOLLZOGEN', text:'\x3cp\x3eFür den versandten Auftrag zur Messtellenänderung wurde der Umbaustatus vom MSB mitgeteilt: Die Messtellenänderung ist vollzogen.\x3c/p\x3e'}, {task:'GED_MSAE_AUFTRAG_IN', text:'\x3cp\x3eEin Auftrag zum Messtellenumbau ist eingegangen. Die Anfrage ist inhaltlich zu prüfen und evtl. abzulehnen, insbesondere:\x3c/p\x3e\x3cul\x3e' + '\x3cli\x3eEin Umbau auf elektronische Ablesung darf nur erfolgen, wenn Anschlussnutzer und MDL ihr Rechtsverhältnis miteinander beendet haben.\x3c/li\x3e' + 
  '\x3cli\x3eDer Auftraggeber gibt immer alle OBIS-Kennzahlen an, für die Messungen erfolgen sollen.\x3c/li\x3e' + '\x3cli\x3ePrüfen Sie, ob der gewünschte Änderungstermin aus technischen oder betriebsbedingten Gründen eingehalten werden kann.\x3c/li\x3e\x3c/ul\x3e'}, {task:'GED_MSAE_AUFTRAG_UMBAU', text:'\x3cp\x3eNach der vollzogenen oder gescheiterten Durchführung der Messstellenänderung muss der Umbaustatus an den Auftraggeber übermittelt werden. Diese Mitteilung ist unabhängig von einem eventuellen Gerätewechsel durchzuführen, der für die gewünschten Änderungen nötig ist.\x3c/p\x3e'}, 
  {task:'STORNIERUNG_ZU_SPAET', text:'\x3cp\x3eEs wurde eine Stornierung für eine Anfrage empfangen, die schon beantwortet wurde. Es ist immer mit geeignetem Antwortstatus (max. 3) abzulehnen.\x3c/p\x3e'}, {task:'FRIST_ABLAUF', text:'\x3cp\x3eDie Frist einer Nachricht läuft in einem Werktag ab. Bitte prüfen Sie, ob die Frist verlängert werden soll. Alternativ haben Sie die Möglichkeit, die definierte Aktion für den Fristablauf direkt zu Starten. Die Task wird nach 24 Stunden automatisch gelöscht und die definierte Aktion für den Fristablauf durchgeführt.\x3c/p\x3e'}, 
  {task:'GER_EINFUEHRUNGSSZENARIO', text:'\x3cp\x3eEs wurde eine Nachricht zum Einführungsszenario 01.04.2013 empfangen. Bitte übertragen Sie die geänderten Daten manuell ins Backend.\x3c/p\x3e'}, {task:'WIMM_MSB_KUENDIGUNG_AUS', text:'\x3cp\x3eMit dieser Aufgabe kann die Kündigung des Messstellenbetriebs beim MSBA im Auftrag und in Vertretung des AN ausgelöst werden.\x3c/p\x3e'}, {task:'WIMM_MDL_KUENDIGUNG_AUS', text:'\x3cp\x3eMit dieser Aufgabe kann die Kündigung der Messdienstleistung beim MDLA im Auftrag und in Vertretung des AN ausgelöst werden.\x3c/p\x3e\x3cp\x3eDer Prozess ist nicht anzuwenden, wenn auch der Messstellenbetrieb gekündigt werden soll.\x3c/p\x3e'}, 
  {task:'WIMM_MSB_KUENDIGUNG_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Kündigung des Messstellenbetriebs wurde bestätigt.\x3c/p\x3e'}, {task:'WIMM_MSB_KUENDIGUNG_AUS_ABGELEHNT', text:'\x3cp\x3eDie Kündigung des Messstellenbetriebs wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MSB_KUENDIGUNG_AUS_APERAK', text:'\x3cp\x3eDie Kündigung des Messstellenbetriebs wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_KUENDIGUNG_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Kündigung des Messdienstleistung wurde bestätigt.\x3c/p\x3e'}, 
  {task:'WIMM_MDL_KUENDIGUNG_AUS_ABGELEHNT', text:'\x3cp\x3eDie Kündigung des Messdienstleistung wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_KUENDIGUNG_AUS_APERAK', text:'\x3cp\x3eDie Kündigung des Messdienstleistung wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MSB_ENDE_AUS', text:'\x3cp\x3eMit dieser Aufgabe kann der Messstellenbetrieb beim NB abgemeldet werden.\x3c/p\x3e'}, {task:'WIMM_MDL_ENDE_AUS', text:'\x3cp\x3eMit dieser Aufgabe kann die Messdienstleistung beim NB abgemeldet werden.\x3c/p\x3e\x3cp\x3eDer Prozess ist nicht anzuwenden, wenn auch der Messstellenbetrieb abgemeldet werden soll.\x3c/p\x3e'}, 
  {task:'WIMM_MSB_ENDE_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Abmeldung des Messstellenbetriebs wurde bestätigt.\x3c/p\x3e'}, {task:'WIMM_MSB_ENDE_AUS_ABGELEHNT', text:'\x3cp\x3eDie Abmeldung des Messstellenbetriebs wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MSB_ENDE_AUS_APERAK', text:'\x3cp\x3eDie Abmeldung des Messstellenbetriebs wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_ENDE_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Abmeldung der Messdienstleistung wurde bestätigt.\x3c/p\x3e'}, {task:'WIMM_MDL_ENDE_AUS_ABGELEHNT', 
  text:'\x3cp\x3eDie Abmeldung der Messdienstleistung wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_ENDE_AUS_APERAK', text:'\x3cp\x3eDie Abmeldung der Messdienstleistung wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_ENDE_AUS_GZ', text:'\x3cp\x3eNach der Abmeldung der Messdienstleistung ist nun ein Übergang in Grundzuständigkeit durchgeführt. Die Zuordnung des NB als grundzuständiger MDL muss übernommen werden.\x3c/p\x3e'}, {task:'WIMM_MSB_ENDE_AUS_GZ', text:'\x3cp\x3eNach der Abmeldung des Messstellenbetriebs ist nun ein Übergang in Grundzuständigkeit durchgeführt. Die Zuordnung des NB als grundzuständiger MSB muss übernommen werden.\x3c/p\x3e'}, 
  {task:'WIMM_MSB_ENDE_AUS_WEITERVERPFLICHTUNG', text:'\x3cp\x3eEs ist eine Anfrage zur Weiterverpflichtung nach Abmeldung des Messstellenbetriebs eingegangen.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS', text:'\x3cp\x3eMit dieser Aufgabe wird eine MSB-Anmeldung ausgelöst.\x3c/p\x3e'}, {task:'WIMM_MDL_BEGINN_AUS', text:'\x3cp\x3eMit dieser Aufgabe wird eine MDL-Anmeldung ausgelöst. Der MSB ist nur anzugeben, wenn der Absender bereits MSB ist.\x3c/p\x3e'}, {task:'WIM_GZ_MSB_BEGINN_AUS', text:'\x3cp\x3eMit dieser Aufgabe wird eine MSB-Anmeldung (für Übernahme in Grundzuständigkeit) ausgelöst.\x3c/p\x3e'}, 
  {task:'WIM_NB_FORMEL_AUS', text:'\x3cp\x3eMit dieser Aufgabe kann die Berechnungsformel zur Berechnung der Werte der Marktlokation für die angegebenen Verwendungszwecke unter Angabe der notwendigen Messlokationen versendet werden.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_ABGELEHNT', text:'\x3cp\x3eDie verschickte Anmeldung wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_BEGINN_AUS_ABGELEHNT', text:'\x3cp\x3eDie verschickte Anmeldung wurde abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_APERAK', 
  text:'\x3cp\x3eDie verschickte Anmeldung wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MDL_BEGINN_AUS_APERAK', text:'\x3cp\x3eDie verschickte Anmeldung wurde mit APERAK abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Anmeldung wurden angenommen. Die Stammdaten am Zählpunkt können jetzt ins Backend übernommen werden.\x3c/p\x3e'}, {task:'WIMM_MDL_BEGINN_AUS_ANGENOMMEN', text:'\x3cp\x3eDie Anmeldung wurde angenommen. Die Stammdaten am Zählpunkt können jetzt ins Backend übernommen werden. Anschließend wird direkt die Neuzuordnung durchgeführt.\x3c/p\x3e'}, 
  {task:'WIMM_MDL_BEGINN_AUS_ZUORDNUNG', text:'\x3cp\x3eDie Anmeldung ist vollzogen. Die Neuzuordnung des MDL muss noch übernommen werden.\x3c/p\x3e'}, {task:'WIM_GZ_MDL_BEGINN_AUS_ZUORDNUNG', text:'\x3cp\x3eÜbernahme Grundzuständigkeit: Die Anmeldung ist vollzogen. Die Neuzuordnung des MDL muss noch übernommen werden.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_WECHSELSTATUS', text:'\x3cp\x3eIm Rahmen einer Anmeldung muss zunächst Gerätewechsel und/oder Geräteübernahme durchgeführt werden. Wenn sich dann MSBN und MSBA über die Geräte verständigt haben, muss der Wechselstatus dem Netzbetreiber mitgeteilt werden.\x3c/p\x3e'}, 
  {task:'WIM_GZ_MSB_BEGINN_AUS_WECHSELSTATUS', text:'\x3cp\x3eÜbernahme Grundzuständigkeit: Im Rahmen einer Anmeldung muss zunächst Gerätewechsel und/oder Geräteübernahme durchgeführt werden. Wenn sich dann MSBN und MSBA über die Geräte verständigt haben, muss der Wechselstatus dem Netzbetreiber mitgeteilt werden.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_ZUORDNUNG', text:'\x3cp\x3eDie Anmeldung ist vollzogen. Die Neuzuordnung muss noch übernommen werden.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_GESCHEITERT', 
  text:'\x3cp\x3eDie Anmeldung ist gescheitert.\x3c/p\x3e'}, {task:'WIMM_MSB_BEGINN_AUS_FRISTUEBERSCHREITUNG', text:'\x3cp\x3eDie Anmeldung ist aufgrund von Fristüberschreitung gescheitert.\x3c/p\x3e'}, {task:'GED_REKLAMATION_IN', text:'\x3cp\x3eEs wurde eine Reklamation für versendete Werte empfangen. Die Reklamation kann quittiert oder abgelehnt werden.\x3c/p\x3e'}, {task:'WIMM_MDL_WECHSEL_MDL', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen MDL-Wechsel empfangen. Damit endet die eigene MDL-Zuordnung.\x3c/p\x3e'}, 
  {task:'WIMM_MDL_WECHSEL_MSB', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen MDL-Wechsel empfangen. Die eigene MSB-Zuordnung bleibt bestehen.\x3c/p\x3e'}, {task:'WIMM_MSB_WECHSEL_MDL_VOLLZOGEN', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen vollzogenen MSB-Wechsel empfangen. Die eigene MDL-Zuordnung bleibt bestehen.\x3c/p\x3e'}, {task:'WIM_GZ_MSB_WECHSEL_MDL_VOLLZOGEN', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen vollzogenen MSB-Wechsel empfangen. Die eigene MDL-Zuordnung bleibt bestehen.\x3c/p\x3e'}, 
  {task:'WIMM_MSB_WECHSEL_MDLA_GEPLANT', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen geplanten MSB-Wechsel (inkl. MDL) empfangen. Bei Vollzug des Wechsels würde die eigene MDL-Zuordnung beendet.\x3c/p\x3e'}, {task:'WIMM_MSB_WECHSEL_MDLA_GESCHEITERT', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen gescheiterten MSB-Wechsel (inkl. MDL) empfangen. Damit bleibt die eigene MDL-Zuordnung bestehen. Zur Beendigung des MDL-Zuordnung wäre der Prozess Abmeldung MDL auszulösen.\x3c/p\x3e'}, 
  {task:'WIM_GZ_MSB_WECHSEL_MDL_GESCHEITERT', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen gescheiterten MSB-Wechsel (inkl. MDL) empfangen. Damit bleibt die eigene MDL-Zuordnung bestehen. Zur Beendigung des MDL-Zuordnung wäre der Prozess Abmeldung MDL auszulösen.\x3c/p\x3e'}, {task:'WIMM_MSB_WECHSEL_MDLA_VOLLZOGEN', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen vollzogenen MSB-Wechsel (inkl. MDL) empfangen. Damit wird die eigene MDL-Zuordnung beendet.\x3c/p\x3e'}, 
  {task:'WIMM_MSB_WECHSEL_MSBA_GEPLANT', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen geplanten MSB-Wechsel empfangen. Bei Vollzug des Wechsels würde die eigene MSB-Zuordnung beendet.\x3c/p\x3e'}, {task:'WIMM_MSB_WECHSEL_MSBA_GESCHEITERT', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen gescheiterten MSB-Wechsel empfangen. Damit bleibt die eigene MSB-Zuordnung bestehen. Zur Beendigung des MSB-Zuordnung wäre der Prozess Abmeldung MSB auszulösen.\x3c/p\x3e'}, {task:'WIM_GZ_MSB_WECHSEL_MSB_GESCHEITERT', 
  text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen gescheiterten MSB-Wechsel empfangen. Damit bleibt die eigene MSB-Zuordnung bestehen. Zur Beendigung des MSB-Zuordnung wäre der Prozess Abmeldung MSB auszulösen.\x3c/p\x3e'}, {task:'WIMM_MSB_WECHSEL_MSBA_VOLLZOGEN', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen vollzogenen MSB-Wechsel empfangen. Damit wird die eigene MSB-Zuordnung beendet.\x3c/p\x3e'}, {task:'WIM_GZ_MSB_WECHSEL_MSB_VOLLZOGEN', text:'\x3cp\x3eEs wurde eine Informationsmitteilung über einen vollzogenen MSB-Wechsel empfangen. Damit wird die eigene MSB-Zuordnung beendet.\x3c/p\x3e'}, 
  {task:'WIMM_GER_MDL_ANFANGSABLESEWERTE', text:'\x3cp\x3eIm Rahmen eines Gerätewechsels wurden neue Gerätedaten und Anfangsablesewerte vom Netzbetreiber empfangen.\x3c/p\x3e'}, {task:'WIMM_GER_MDL_ENDABLESEWERTE', text:'\x3cp\x3eIm Rahmen eines Gerätewechsels wurden Endablesewerte vom Netzbetreiber empfangen.\x3c/p\x3e'}, {task:'WIMM_GER_MSB_ADHOC', text:'\x3cp\x3eMit dieser Aufgabe kann ein Gerätewechsel als MSB im laufenden Betrieb durchgeführt werden. Der Netzbetreiber wird über die geänderten Gerätestammdaten und die Ausbau- und Einbauzählerstände informiert.\x3c/p\x3e'}, 
  {task:'WIMM_GER_MSB_ENDABLESEWERTE', text:'\x3cp\x3eIm Rahmen eines Gerätewechsels müssen die Endablesewerte erfasst und dem Netzbetreiber mitgeteilt werden.\x3c/p\x3e'}, {task:'WIMM_GER_MSB_ANFANGSABLESEWERTE', text:'\x3cp\x3eIm Rahmen eines Gerätewechsels müssen die neuen Geräte und die Anfangsablesewerte erfasst und dem Netzbetreiber mitgeteilt werden.\x3c/p\x3e'}, {task:'WIMM_GER_MSB_ANFANGSABLESEWERTE_MIT_ENDE', text:'\x3cp\x3eIm Rahmen eines Gerätewechsels müssen die neuen Geräte und die Anfangsablesewerte sowie zusätzlich die Endablesewerte der ausgebauten Zähleinrichtungen erfasst und dem Netzbetreiber mitgeteilt werden.\x3c/p\x3e'}, 
  {task:'WIMM_STORNO', text:'\x3cp\x3eAnmeldung, Abmeldung oder Kündigung MSB oder MDL stornieren.\x3c/p\x3e'}, {task:'WIMM_STORNO_ANGENOMMEN', text:'\x3cp\x3eStornierung angenommen.\x3c/p\x3e'}, {task:'WIMM_STORNO_ABGELEHNT', text:'\x3cp\x3eStornierung abgelehnt.\x3c/p\x3e'}, {task:'WIM_STORNO_ANGENOMMEN', text:'\x3cp\x3eStornierung angenommen.\x3c/p\x3e'}, {task:'WIM_STORNO_ABGELEHNT', text:'\x3cp\x3eStornierung abgelehnt.\x3c/p\x3e'}, {task:'WIMM_MWANFORDERUNG_EIN', text:'\x3cp\x3eEs wurde eine Messwertanforderung empfangen. Erfassen Sie zum angefragten Termin die Messwerte und übermitteln sie.\x3c/p\x3e'}, 
  {task:'WIMM_EMANFORDERUNG_EIN', text:'\x3cp\x3eEs wurde eine Energiemengenanforderung empfangen. Erfassen Sie zum angefragten Termin die Energimenge und übermitteln sie.\x3c/p\x3e'}, {task:'GED_EMANFRAGE_IN', text:'\x3cp\x3eEs wurde eine Energiemengenanfrage empfangen. Erfassen Sie zum angefragten Zeitraum die Energimenge und übermitteln sie.\x3c/p\x3e'}, {task:'WIMM_LGANFORDERUNG_EIN', text:'\x3cp\x3eEs wurde eine Lastganganforderung empfangen. Bitte quittieren Sie den Empfang.\x3c/p\x3e'}, {task:'WIMM_MESSWERTE_AUS', 
  text:'\x3cp\x3eMit dieser Task werden erfasste Messwerte aus einer Turnusablesung oder sonstigen Ablesung an Marktpartner versandt.\x3c/p\x3e'}, {task:'WIMM_ENERGIEMENGEN_AUS', text:'\x3cp\x3eMit dieser Task werden erfasste Energiemengen an den NB/LF versandt.\x3c/p\x3e'}, {task:'WIMM_MESSWERTE_GESCHEITERT_AUS', text:'\x3cp\x3eMit dieser Task wird eine Mitteilung über eine gescheiterte Turnusablesung an den NB versandt.\x3c/p\x3e'}, {task:'WIMM_MESSWERTE_AUS_KORR', text:'\x3cp\x3eEs wurden aufbereitete/korrigierte Messwerte empfangen. Die Messwerte können ggfs. ins Backend übernommen werden.\x3c/p\x3e'}, 
  {task:'WIMM_MWANFORDERUNG_EIN_KORR', text:'\x3cp\x3eZu einer Messwertanforderung wurden aufbereitete/korrigierte Messwerte empfangen. Die Messwerte können ggfs. ins Backend übernommen werden.\x3c/p\x3e'}];
})();
Ext.define('mpm.packages.wim.WIMContext', {constructor:function(config) {
  this.callParent(arguments);
  this.baseURL = config.baseURL;
}, statusIconIMG:function(status) {
  return mpm.packages.wim.WIMStatusColumn.statusIconHtml(status);
}, statusIconIMGRenderer:function(config) {
  var withText = config && config.withText;
  return function(status) {
    return mpm.packages.wim.WIMStatusColumn.statusIconHtml(status, withText);
  };
}, serverURL:function(connector) {
  if (Ext.isEmpty(connector)) {
    connector = 'WIM_Log_AJAX_Listener';
  }
  return this.baseURL + '/ibis/servlet/IBISHTTPUploadServlet/' + connector;
}, downloadURL:function() {
  return this.serverURL('WIM_Log_Download_Listener');
}, referenzURL:function() {
  return this.serverURL('PM_Load_ReferenzWIM');
}});
Ext.define('mpm.packages.wim.WIMStatusColumn', {statics:{statusMap:{'contrl_positiv_offen':'#85909c', 'contrl_positiv_ok':'#7b9b9b', 'contrl_positiv_fehler':'#7b9b9b_#c63441', 'contrl_negativ_offen':'#c63441_#85909c', 'contrl_negativ_ok':'#c63441', 'contrl_negativ_fehler':'#c63441_#c63441', 'contrl_keine':'', 'aperak_offen':'#85909c', 'aperak_unterdrueckt':'#6b2fb5', 'aperak_ok':'#e18b50', 'aperak_error':'#c63441', 'aperak_keine':'', 'information':'#96bebe', 'warnung':'#e18b50', 'warning':{iconCls:'fa-circle', 
color:'#e18b50', statusLabel:'Warnung'}, 'error':{iconCls:'fa-circle', color:'#c63441', statusLabel:'Fehler'}, 'versendet':'#7b9b9b', 'abgebrochen':{iconCls:'fa-exclamation-circle', color:'#c63441'}, 'storniert':{iconCls:'fa-exclamation-circle', color:'#c63441'}, 'aktiv':{color:'#e18b50', iconCls:'fa-arrow-circle-right'}, 'fristueberschreitung':{color:'#c63441', iconCls:'fa-clock', statusLabel:'Fristüberschreitung'}, 'offen':{color:'#cccccc', iconCls:'fa-circle'}, 'fehlgeschlagen':{color:'#c63441', 
iconCls:'fa-circle'}, 'hinfaellig':{color:'#cccccc', iconCls:'fa-times-circle', statusLabel:'Hinfällig'}, 'abgelehnt':{color:'#c63441', iconCls:'fa-times-circle'}, 'erledigt':{color:'##7b9b9b', iconCls:'fa-circle'}, 'ignoriert':{color:'#dd2222', iconCls:'fa-exclamation-circle'}, 'abgeschlossen':'#7b9b9b', 'angebotablehnung':'#7b9b9b_#7b9b9b_#c63441', 'angebotablehnungohneanfrage':'silver_#7b9b9b_#c63441', 'angebotanfrage':'#7b9b9b', 'angebotanfrageablehnung':'#7b9b9b_#c63441', 'angebotbeendigungablehnung':'#c63441_#c63441', 
'angebotbeendigunganfrage':'#c63441', 'angebotbeendigungzustimmung':'#c63441_#7b9b9b', 'angebotbestellung':'#7b9b9b_#7b9b9b', 'angebotbestellungohneanfrage':'silver_#7b9b9b', 'angeboten':'#7b9b9b', 'ausgeloest':'#7b9b9b_#7b9b9b', 'bestellt':'#7b9b9b_#7b9b9b', 'bestellt_abgelehnt':'#7b9b9b_#7b9b9b_#c63441', 'bestellt_angenommen':'#7b9b9b_#7b9b9b_#7b9b9b', 'bestellung':'#7b9b9b_#7b9b9b_#7b9b9b', 'bestellung_fehler':'#7b9b9b_#7b9b9b_#7b9b9b_#c63441', 'bestellung_ok':'#7b9b9b_#7b9b9b_#7b9b9b_#7b9b9b', 
'bestellungangebot':'#7b9b9b_#7b9b9b_#7b9b9b', 'bestellungangebotohneanfrage':'silver_#7b9b9b_#7b9b9b', 'fehler':'#c63441', 'fehler_ok':'#c63441_#7b9b9b', 'grundzustaendigkeit':'#7b9b9b_#7b9b9b_#7b9b9b', 'in_bearbeitung':'#85909c', 'keine_bestellung':'#7b9b9b_#7b9b9b_#c63441', 'keine_grundzustaendigkeit':'#7b9b9b_#7b9b9b_#c63441', 'nicht_abgeschlossen':'#85909c', 'nicht_angeboten':'#c63441', 'nicht_bestellt':'#7b9b9b_#c63441', 'offen_offen_offen_offen':'silver_silver_silver_silver', 'offen_offen_ok_offen':'silver_silver_#7b9b9b_silver', 
'offen_offen_ok_ok':'silver_silver_#7b9b9b_#7b9b9b', 'ok':'#7b9b9b', 'ok_fehler':'#7b9b9b_#c63441', 'ok_offen_offen_offen':'#7b9b9b_silver_silver_silver', 'ok_offen_ok_offen':'#7b9b9b_silver_#7b9b9b_silver', 'ok_offen_ok_ok':'#7b9b9b_silver_#7b9b9b_#7b9b9b', 'ok_ok':'#7b9b9b_#7b9b9b', 'ok_ok_fehler':'#7b9b9b_#7b9b9b_#c63441', 'ok_ok_fehler_ok':'#7b9b9b_#7b9b9b_#c63441_#7b9b9b', 'ok_ok_offen_offen':'#7b9b9b_#7b9b9b_silver_silver', 'ok_ok_ok':'#7b9b9b_#7b9b9b_#7b9b9b', 'ok_ok_ok_offen':'#7b9b9b_#7b9b9b_#7b9b9b_silver', 
'ok_ok_ok_ok':'#7b9b9b_#7b9b9b_#7b9b9b_#7b9b9b', 'geplant':'#85909c'}, cache:{'':''}, statusIconHtml:function(v, withText) {
  var self = mpm.packages.wim.WIMStatusColumn;
  var r = self.cache[v + '@@@' + withText];
  if (r !== undefined) {
    return r;
  }
  var result;
  var status = self.statusMap[v.toLowerCase()];
  var statusLabel;
  if (status !== undefined) {
    result = '';
    if (Ext.isObject(status)) {
      result = mpm.Support.getSpanForIconCls('fa ' + status.iconCls + ' fa-fw fa-ln', status.color);
      statusLabel = Ext.valueFrom(status.statusLabel, v);
    } else {
      Ext.each(status.split('_'), function(c) {
        result += mpm.Support.getSpanForIconCls('fa fa-circle fa-fw fa-ln', c);
        statusLabel = v;
      }, this);
    }
    if (withText) {
      result += '\x26nbsp;' + Ext.String.htmlEncode(statusLabel);
    }
  } else {
    result = Ext.String.htmlEncode(v);
  }
  self.cache[v + '@@@' + withText] = result;
  return result;
}}, extend:'Ext.grid.column.Column', alias:'widget.wimStatusColumn', renderer:function(v) {
  return mpm.packages.wim.WIMStatusColumn.statusIconHtml(v);
}});
Ext.define('mpm.util.BpcSupport', {singleton:true, getVersionFromPackage:function(packageName) {
  packageName = packageName === void 0 ? 'BpcCommon' : packageName;
  var $jscomp$destructuring$var59 = Ext.manifest;
  var packages = $jscomp$destructuring$var59.packages;
  packages = packages || {};
  var common = packages[packageName] || {};
  var $jscomp$destructuring$var60 = common;
  var version = $jscomp$destructuring$var60.version;
  return version || '';
}, isBpcVersion:function(targetVersion) {
  targetVersion = targetVersion === void 0 ? 4 : targetVersion;
  try {
    var version = this.getVersionFromPackage();
    var parts = version.split('.');
    return parseInt(parts[0]) === targetVersion;
  } catch (e) {
    return false;
  }
}, versionStartsWith:function(versionPrefix) {
  versionPrefix = versionPrefix === void 0 ? '4.1' : versionPrefix;
  return this.getVersionFromPackage().startsWith(versionPrefix);
}});
Ext.define('mpm.util.Colors', {singleton:true, getCssVariableValue:function(varName) {
  var styles = getComputedStyle(document.body);
  varName = '--' + varName;
  return styles.getPropertyValue(varName);
}});
Ext.define('mpm.util.Components', {singleton:true, getSpacer:function(width) {
  width = width === void 0 ? 5 : width;
  return {xtype:'tbspacer', width:width};
}, asyncMessageBox:function(titleKey, messageKey) {
  titleKey = titleKey === void 0 ? '' : titleKey;
  messageKey = messageKey === void 0 ? '' : messageKey;
  var title = collaboration.Support.TR(titleKey);
  var message = collaboration.Support.TR(messageKey);
  return new Promise(function(resolve) {
    Ext.Msg.show({title:title, message:message, buttons:Ext.Msg.YESNOCANCEL, icon:Ext.Msg.QUESTION, fn:function(btn) {
      if (btn === 'yes') {
        resolve(true);
      } else if (btn === 'no') {
        resolve(false);
      } else {
        resolve(undefined);
      }
    }});
  });
}, getHr:function(margin) {
  margin = margin === void 0 ? '10 0 10 0' : margin;
  return {xtype:'box', margin:margin, autoEl:{tag:'hr'}};
}});
Ext.define('mpm.util.Icons', {singleton:true, icons:{settings:'fa-cogs', admin:'fa-tools', database:'fa-database', remove:'fa-remove', retweet:'fa-retweet', comment:'fa-comment', barchart:'fa-chart-bar', user:'fa-user', clock:'fa-clock', bookmark:'fa-bookmark', angleRight:'fa-angle-right', angleDoubleLeft:'fa-angle-double-left', angleDoubleRight:'fa-angle-double-right', bars:'fa-bars', fire:'fa-fire', cog:'fa-cog', image:'fa-image', clone:'fa-clone', refresh:'fa-sync', plus:'fa-plus', edit:'fa-edit', 
submit:'fa-submit', check:'fa-check', externalLink:'fa-external-link', mailReply:'fa-mail-reply', info:'fa-info', paperclip:'fa-paperclip', users:'fa-users', filter:'fa-filter', bug:'fa-bug', trash:'fa-trash', circle:'fa-circle', times:'fa-times', chevronCircleRight:'fa-chevron-circle-right', chain:'fa-link', arrowDown:'fa-arrow-down', envelope:'fa-envelope', history:'fa-history', picture:'fa-picture', upload:'fa-upload', save:'fa-save', comments:'fa-comments', download:'fa-download', bell:'fa-bell', 
calendar:'fa-calendar', search:'fa-search', reply:'fa-reply', tags:'fa-tags', flash:'fa-flash', toggleOn:'fa-toggle-on', undo:'fa-undo', eye:'fa-eye', minusSquare:'fa-minus-square', checkSquare:'fa-minus-square', messageIcon:'fa-envelope', newMessageIcon:'fa-plus', newCollabArtefactIcon:'fa-plus', collabOverviewIcon:'fa-list-ul', messageOverviewIcon:'fa-list-ul', colorIcon:'fa-paint-roller', userIcon:'fa-user fa-fw', groupIcon:'fa-users fa-fw', roleIcon:'fa-users fa-fw', webhookIcon:'fa-bullhorn', 
messagesIcon:'fa-envelope', tasksIcon:'fa-check-circle iconNotification3', commentsIcon:'fa-comments', activitiesIcon:'fa-clock'}});
Ext.define('mpm.util.Store', {singleton:true, standardType:'Ext.data.Store', newLocalStore:function(data) {
  data = data === void 0 ? [] : data;
  return Ext.create(this.standardType, {data:data});
}});
Ext.define('mpm.util.Window', {singleton:true, openWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig, show) {
  width = width === void 0 ? 800 : width;
  cmpAlias = cmpAlias === void 0 ? 'panel' : cmpAlias;
  cmpConfig = cmpConfig === void 0 ? {} : cmpConfig;
  show = show === void 0 ? true : show;
  var windowConfig = {title:title, width:width, padding:'0 0 0 0', style:{backgroundColor:'#eceaea'}, layout:'fit', iconCls:iconCls || mpm.Support.icon('fa-info')};
  if (height !== null) {
    windowConfig.height = height || 600;
  }
  var w = Ext.create('Ext.window.Window', windowConfig);
  cmpConfig.windowReference = w;
  var cmp = Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig));
  w.add(cmp);
  if (show) {
    w.show();
  }
  return w;
}});
Ext.define('mpm.view.Main', {extend:'Ext.container.Container', layout:'fit', initComponent:function() {
  var $jscomp$this = this;
  var instancesStore = BpcCommon.Api.getModuleInstances('monitor');
  var models = instancesStore.getData().getRange() || [];
  var plugins = BpcCommon.Api.getSetting('monitor', 'plugin_configuration') || [];
  var storeData = models.map(function(m) {
    var moduleId = m.get('moduleId');
    var plugs = plugins.filter(function(p) {
      return p.targetInstance.indexOf(String(moduleId)) !== -1;
    });
    return {_storeId:m.getId(), _superModuleId:m.get('superModuleId'), moduleId:moduleId, instanceName:m.get('instanceName'), data_index:BpcCommon.Api.getSetting(moduleId, 'data_index'), data_historyIndex:BpcCommon.Api.getSetting(moduleId, 'data_historyIndex'), pluginCount:plugs.length, pluginNames:plugs.map(function(p) {
      return p.plugin;
    }).join(', ')};
  }).filter(function(i) {
    return ['auditlog', 'performance', 'replicationjobs'].indexOf(String(i.moduleId)) === -1;
  });
  var replicationInstances = BpcCommon.Api.getModuleInstances('replication');
  var replicationModels = replicationInstances.getData().getRange() || [];
  replicationModels = replicationModels.map(function(m) {
    m.instanceSettings = m._settings.data.items;
    return m;
  });
  storeData = storeData.map(function(item) {
    if (item.data_index) {
      replicationModels.filter(function(i) {
        var match = false;
        i.instanceSettings.map(function(settingModel) {
          if (match === false) {
            match = settingModel.getId() === 'targetIndex' && settingModel.get('value') === item.data_index;
          }
        });
        return match;
      }).map(function(r) {
        item.data_index_replicationId = r.get('moduleId');
        item.data_index_table = r.instanceSettings.filter(function(s) {
          return s.getId() === 'sourceTable';
        })[0].get('value');
        item.data_index_replicationName = r.get('instanceName');
      });
    }
    if (item.data_historyIndex) {
      replicationModels.filter(function(i) {
        var match = false;
        i.instanceSettings.map(function(settingModel) {
          if (match === false) {
            match = settingModel.getId() === 'targetIndex' && settingModel.get('value') === item.data_historyIndex;
          }
        });
        return match;
      }).map(function(r) {
        item.data_historyIndex_replicationId = r.get('moduleId');
        item.data_historyIndex_table = r.instanceSettings.filter(function(s) {
          return s.getId() === 'sourceTable';
        })[0].get('value');
        item.data_historyIndex_replicationName = r.get('instanceName');
      });
    }
    return item;
  });
  this.items = [{xtype:'panel', header:false, layout:{type:'hbox', align:'stretch'}, tbar:[{xtype:'button', iconCls:mpm.Support.icon('fa-play'), text:'Task starten', ui:'primary', handler:function(b) {
    $jscomp$this.openDebugger();
  }}], defaults:{flex:1, xtype:'panel'}, items:[{xtype:'grid', flex:7, store:mpm.util.Store.newLocalStore(storeData), viewConfig:{enableTextSelection:true}, columns:[{dataIndex:'moduleId', width:120}, {dataIndex:'instanceName', flex:2}, {dataIndex:'pluginCount', width:40}, {dataIndex:'pluginNames', flex:2}, {dataIndex:'data_index', flex:1}, {dataIndex:'data_index_table', flex:1}, {dataIndex:'data_historyIndex', flex:1}, {dataIndex:'data_historyIndex_table', flex:1}].map(function(i) {
    i.text = i.dataIndex ? mpm.Support.TR('COL_' + i.dataIndex) : mpm.Support.TR('COL_ACTIONS');
    return i;
  })}]}];
  this.callParent(arguments);
}, openDebugger:function() {
  Ext.create({xtype:'window', title:'MPM Task Debugger', layout:{type:'hbox', align:'stretch'}, height:document.body.clientHeight * 0.8, width:document.body.clientWidth * 0.8, items:[{xtype:'panel', tbar:[{xtype:'displayfield', value:'FOOOO'}], header:false, layout:'fit', flex:2, items:[{xtype:'textarea', emptyText:'config - place globalObject as json here'}], bbar:[{xtype:'tbfill'}, {iconCls:mpm.Support.icon('fa-play'), text:'RUN', ui:'primary', handler:function(b) {
    var jsonStr = b.up('window').down('textarea').getValue();
    mpm.task.init(JSON.parse(jsonStr));
  }}]}]}).show();
}});
